/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/platform/workspaces/common/workspaces","vs/base/common/strings","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","fs","vs/base/common/process","vs/base/common/extpath","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","child_process","vs/platform/product/common/product","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/base/common/errorMessage","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","vs/code/electron-main/main"],J=function(V){for(var e=[],v=0,L=V.length;v<L;v++)e[v]=Q[V[v]];return e};define(Q[102],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(L,M){if(!L)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}e.ok=v}),define(Q[47],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(I){return(n,f,w)=>{let t=null,k=null;if(typeof w.value=="function"?(t="value",k=w.value):typeof w.get=="function"&&(t="get",k=w.get),!k)throw new Error("not supported");w[t]=I(k,f)}}e.createDecorator=v;function L(I,n,f){let w=null,t=null;if(typeof f.value=="function"?(w="value",t=f.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",t=f.get),!t)throw new Error("not supported");const k=`$memoize$${n}`;f[w]=function(...b){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,b)}),this[k]}}e.memoize=L;function M(I,n,f){return v((w,t)=>{const k=`$debounce$${t}`,b=`$debounce$result$${t}`;return function(...S){this[b]||(this[b]=f?f():void 0),clearTimeout(this[k]),n&&(this[b]=n(this[b],...S),S=[this[b]]),this[k]=setTimeout(()=>{w.apply(this,S),this[b]=f?f():void 0},I)}})}e.debounce=M;function D(I,n,f){return v((w,t)=>{const k=`$throttle$timer$${t}`,b=`$throttle$result$${t}`,S=`$throttle$lastRun$${t}`,d=`$throttle$pending$${t}`;return function(...m){if(this[b]||(this[b]=f?f():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),n&&(this[b]=n(this[b],...m)),this[d])return;const E=this[S]+I;E<=Date.now()?(this[S]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0):(this[d]=!0,this[k]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0},E-Date.now()))}})}e.throttle=D}),define(Q[17],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(l=>{l(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=v,e.errorHandler=new v;function L(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=L;function M(u){f(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=M;function D(u){f(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=D;function I(u){if(u instanceof Error){let{name:i,message:l}=u;const s=u.stacktrace||u.stack;return{$isError:!0,name:i,message:l,stack:s}}return u}e.transformErrorForSerialization=I;const n="Canceled";function f(u){return u instanceof Error&&u.name===n&&u.message===n}e.isPromiseCanceledError=f;class w extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=w;function t(){const u=new Error(n);return u.name=u.message,u}e.canceled=t;function k(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=k;function b(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=b;function S(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function d(u){const i=new Error(`${u} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function m(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=m;class E extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=E;class y extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=y;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function h(u){const i=u;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=h;function o(u,i=Object.create(null)){const l=new Error(u);return i.actions&&(l.actions=i.actions),l}e.createErrorWithActions=o}),define(Q[30],J([0,1,17]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(O,T=0){return O[O.length-(1+T)]}e.tail=L;function M(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=M;function D(O,T,_=(q,X)=>q===X){if(O===T)return!0;if(!O||!T||O.length!==T.length)return!1;for(let q=0,X=O.length;q<X;q++)if(!_(O[q],T[q]))return!1;return!0}e.equals=D;function I(O,T,_){let q=0,X=O.length-1;for(;q<=X;){const $=(q+X)/2|0,N=_(O[$],T);if(N<0)q=$+1;else if(N>0)X=$-1;else return $}return-(q+1)}e.binarySearch=I;function n(O,T){let _=0,q=O.length;if(q===0)return 0;for(;_<q;){const X=Math.floor((_+q)/2);T(O[X])?q=X:_=X+1}return _}e.findFirstInSorted=n;function f(O,T,_){if(O=O|0,O>=T.length)throw new TypeError("invalid index");let q=T[Math.floor(T.length*Math.random())],X=[],$=[],N=[];for(let Z of T){const ie=_(Z,q);ie<0?X.push(Z):ie>0?$.push(Z):N.push(Z)}return O<X.length?f(O,X,_):O<X.length+N.length?N[0]:f(O-(X.length+N.length),$,_)}e.quickSelect=f;function w(O,T){const _=[];let q;for(const X of O.slice(0).sort(T))!q||T(q[0],X)!==0?(q=[X],_.push(q)):q.push(X);return _}e.groupBy=w;function t(O,T,_){const q=[];function X(Z,ie,oe){if(ie===0&&oe.length===0)return;const le=q[q.length-1];le&&le.start+le.deleteCount===Z?(le.deleteCount+=ie,le.toInsert.push(...oe)):q.push({start:Z,deleteCount:ie,toInsert:oe})}let $=0,N=0;for(;;){if($===O.length){X($,0,T.slice(N));break}if(N===T.length){X($,O.length-$,[]);break}const Z=O[$],ie=T[N],oe=_(Z,ie);oe===0?($+=1,N+=1):oe<0?(X($,1,[]),$+=1):oe>0&&(X($,0,[ie]),N+=1)}return q}e.sortedDiff=t;function k(O,T,_){const q=t(O,T,_),X=[],$=[];for(const N of q)X.push(...O.slice(N.start,N.start+N.deleteCount)),$.push(...N.toInsert);return{removed:X,added:$}}e.delta=k;function b(O,T,_){if(_===0)return[];const q=O.slice(0,_).sort(T);return d(O,T,q,_,O.length),q}e.top=b;function S(O,T,_,q,X){return _===0?Promise.resolve([]):new Promise(($,N)=>{(async()=>{const Z=O.length,ie=O.slice(0,_).sort(T);for(let oe=_,le=Math.min(_+q,Z);oe<Z;oe=le,le=Math.min(le+q,Z)){if(oe>_&&await new Promise(ne=>setTimeout(ne)),X&&X.isCancellationRequested)throw(0,v.canceled)();d(O,T,ie,oe,le)}return ie})().then($,N)})}e.topAsync=S;function d(O,T,_,q,X){for(const $=_.length;q<X;q++){const N=O[q];if(T(N,_[$-1])<0){_.pop();const Z=n(_,ie=>T(N,ie)<0);_.splice(Z,0,N)}}}function m(O){return O.filter(T=>!!T)}e.coalesce=m;function E(O){let T=0;for(let _=0;_<O.length;_++)O[_]&&(O[T]=O[_],T+=1);O.length=T}e.coalesceInPlace=E;function y(O,T,_){O.splice(_,0,O.splice(T,1)[0])}e.move=y;function c(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=c;function h(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=h;function o(O,T=_=>_){const _=new Set;return O.filter(q=>{const X=T(q);return _.has(X)?!1:(_.add(X),!0)})}e.distinct=o;function u(O){const T=Object.create(null);return _=>{const q=O(_);return T[q]?!1:(T[q]=!0,!0)}}e.uniqueFilter=u;function i(O,T){const _=l(O,T);if(_!==-1)return O[_]}e.findLast=i;function l(O,T){for(let _=O.length-1;_>=0;_--){const q=O[_];if(T(q))return _}return-1}e.lastIndex=l;function s(O,T){return O.length>0?O[0]:T}e.firstOrDefault=s;function r(O,T,_=(q,X)=>q===X){let q=0;for(let X=0,$=Math.min(O.length,T.length);X<$&&_(O[X],T[X]);X++)q++;return q}e.commonPrefixLength=r;function a(O){return[].concat(...O)}e.flatten=a;function g(O,T){let _=typeof T=="number"?O:0;typeof T=="number"?_=O:(_=0,T=O);const q=[];if(_<=T)for(let X=_;X<T;X++)q.push(X);else for(let X=_;X>T;X--)q.push(X);return q}e.range=g;function p(O,T,_){return O.reduce((q,X)=>(q[T(X)]=_?_(X):X,q),Object.create(null))}e.index=p;function P(O,T){return O.push(T),()=>R(O,T)}e.insert=P;function R(O,T){const _=O.indexOf(T);if(_>-1)return O.splice(_,1),T}e.remove=R;function A(O,T,_){const q=O.slice(0,T),X=O.slice(T);return q.concat(_,X)}e.arrayInsert=A;function W(O,T){let _;if(typeof T=="number"){let q=T;_=()=>{const X=Math.sin(q++)*179426549;return X-Math.floor(X)}}else _=Math.random;for(let q=O.length-1;q>0;q-=1){const X=Math.floor(_()*(q+1)),$=O[q];O[q]=O[X],O[X]=$}}e.shuffle=W;function j(O,T){const _=O.indexOf(T);_>-1&&(O.splice(_,1),O.unshift(T))}e.pushToStart=j;function x(O,T){const _=O.indexOf(T);_>-1&&(O.splice(_,1),O.push(T))}e.pushToEnd=x;function re(O,T){return Array.isArray(O)?O.map(T):T(O)}e.mapArrayOrNot=re;function K(O){return Array.isArray(O)?O:[O]}e.asArray=K;function ee(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=ee;function F(O,T){for(const _ of O){const q=T(_);if(q!==void 0)return q}}e.mapFind=F;function H(O,T,_){const q=B(O,T),X=O.length,$=_.length;O.length=X+$;for(let N=X-1;N>=q;N--)O[N+$]=O[N];for(let N=0;N<$;N++)O[N+q]=_[N]}e.insertInto=H;function z(O,T,_,q){const X=B(O,T),$=O.splice(X,_);return H(O,X,q),$}e.splice=z;function B(O,T){return T<0?Math.max(T+O.length,0):Math.min(T,O.length)}function C(O,T){let _=Number.MAX_SAFE_INTEGER,q=0;return O.forEach((X,$)=>{const N=T(X);N<_&&(_=N,q=$)}),q}e.minIndex=C;function U(O,T){let _=Number.MIN_SAFE_INTEGER,q=0;return O.forEach((X,$)=>{const N=T(X);N>_&&(_=N,q=$)}),q}e.maxIndex=U;class Y{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let _=this.firstIdx;for(;_<this.items.length&&T(this.items[_]);)_++;const q=_===this.firstIdx?null:this.items.slice(this.firstIdx,_);return this.firstIdx=_,q}takeFromEndWhile(T){let _=this.lastIdx;for(;_>=0&&T(this.items[_]);)_--;const q=_===this.lastIdx?null:this.items.slice(_+1,this.lastIdx+1);return this.lastIdx=_,q}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=Y}),define(Q[42],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(L){const M=this;let D=!1,I;return function(){return D||(D=!0,I=L.apply(M,arguments)),I}}e.once=v}),define(Q[66],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(L){function M(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=M;const D=Object.freeze([]);function I(){return D}L.empty=I;function*n(u){yield u}L.single=n;function f(u){return u||D}L.from=f;function w(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=w;function t(u){return u[Symbol.iterator]().next().value}L.first=t;function k(u,i){for(const l of u)if(i(l))return!0;return!1}L.some=k;function b(u,i){for(const l of u)if(i(l))return l}L.find=b;function*S(u,i){for(const l of u)i(l)&&(yield l)}L.filter=S;function*d(u,i){let l=0;for(const s of u)yield i(s,l++)}L.map=d;function*m(...u){for(const i of u)for(const l of i)yield l}L.concat=m;function*E(u){for(const i of u)for(const l of i)yield l}L.concatNested=E;function y(u,i,l){let s=l;for(const r of u)s=i(s,r);return s}L.reduce=y;function*c(u,i,l=u.length){for(i<0&&(i+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);i<l;i++)yield u[i]}L.slice=c;function h(u,i=Number.POSITIVE_INFINITY){const l=[];if(i===0)return[l,u];const s=u[Symbol.iterator]();for(let r=0;r<i;r++){const a=s.next();if(a.done)return[l,L.empty()];l.push(a.value)}return[l,{[Symbol.iterator](){return s}}]}L.consume=h;function o(u,i,l=(s,r)=>s===r){const s=u[Symbol.iterator](),r=i[Symbol.iterator]();for(;;){const a=s.next(),g=r.next();if(a.done!==g.done)return!1;if(a.done)return!0;if(!l(a.value,g.value))return!1}}L.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(Q[39],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var M;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(M=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(i){i.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function I(i,l=!1){let s=0,r=i.length,a="",g=0,p=16,P=0;function R(ee){let F=0,H=0;for(;F<ee;){const z=i.charCodeAt(s);if(z>=48&&z<=57)H=H*16+z-48;else if(z>=65&&z<=70)H=H*16+z-65+10;else if(z>=97&&z<=102)H=H*16+z-97+10;else break;s++,F++}return F<ee&&(H=-1),H}function A(ee){s=ee,a="",g=0,p=16,P=0}function W(){const ee=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&w(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&w(i.charCodeAt(s)))for(s++;s<i.length&&w(i.charCodeAt(s));)s++;else return P=3,i.substring(ee,s);let F=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&w(i.charCodeAt(s))){for(s++;s<i.length&&w(i.charCodeAt(s));)s++;F=s}else P=3;return i.substring(ee,F)}function j(){let ee="",F=s;for(;;){if(s>=r){ee+=i.substring(F,s),P=2;break}const H=i.charCodeAt(s);if(H===34){ee+=i.substring(F,s),s++;break}if(H===92){if(ee+=i.substring(F,s),s++,s>=r){P=2;break}switch(i.charCodeAt(s++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const B=R(4);B>=0?ee+=String.fromCharCode(B):P=4;break;default:P=5}F=s;continue}if(H>=0&&H<=31)if(f(H)){ee+=i.substring(F,s),P=2;break}else P=6;s++}return ee}function x(){if(a="",P=0,g=s,s>=r)return g=r,p=17;let ee=i.charCodeAt(s);if(n(ee)){do s++,a+=String.fromCharCode(ee),ee=i.charCodeAt(s);while(n(ee));return p=15}if(f(ee))return s++,a+=String.fromCharCode(ee),ee===13&&i.charCodeAt(s)===10&&(s++,a+=`
`),p=14;switch(ee){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,a=j(),p=10;case 47:const F=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<r&&!f(i.charCodeAt(s));)s++;return a=i.substring(F,s),p=12}if(i.charCodeAt(s+1)===42){s+=2;const H=r-1;let z=!1;for(;s<H;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,P=1),a=i.substring(F,s),p=13}return a+=String.fromCharCode(ee),s++,p=16;case 45:if(a+=String.fromCharCode(ee),s++,s===r||!w(i.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=W(),p=11;default:for(;s<r&&re(ee);)s++,ee=i.charCodeAt(s);if(g!==s){switch(a=i.substring(g,s),a){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return a+=String.fromCharCode(ee),s++,p=16}}function re(ee){if(n(ee)||f(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let ee;do ee=x();while(ee>=12&&ee<=15);return ee}return{setPosition:A,getPosition:()=>s,scan:l?K:x,getToken:()=>p,getTokenValue:()=>a,getTokenOffset:()=>g,getTokenLength:()=>s-g,getTokenError:()=>P}}e.createScanner=I;function n(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function k(i,l){const s=[],r=new Object;let a;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function P(R,A,W,j){g.value=R,g.offset=A,g.length=W,g.type=j,g.colonOffset=void 0,a=g}try{h(i,{onObjectBegin:(R,A)=>{if(l<=R)throw r;a=void 0,p=l>R,s.push("")},onObjectProperty:(R,A,W)=>{if(l<A||(P(R,A,W,"property"),s[s.length-1]=R,l<=A+W))throw r},onObjectEnd:(R,A)=>{if(l<=R)throw r;a=void 0,s.pop()},onArrayBegin:(R,A)=>{if(l<=R)throw r;a=void 0,s.push(0)},onArrayEnd:(R,A)=>{if(l<=R)throw r;a=void 0,s.pop()},onLiteralValue:(R,A,W)=>{if(l<A||(P(R,A,W,u(R)),l<=A+W))throw r},onSeparator:(R,A,W)=>{if(l<=A)throw r;if(R===":"&&a&&a.type==="property")a.colonOffset=A,p=!1,a=void 0;else if(R===","){const j=s[s.length-1];typeof j=="number"?s[s.length-1]=j+1:(p=!0,s[s.length-1]=""),a=void 0}}})}catch(R){if(R!==r)throw R}return{path:s,previousNode:a,isAtPropertyKey:p,matches:R=>{let A=0;for(let W=0;A<R.length&&W<s.length;W++)if(R[A]===s[W]||R[A]==="*")A++;else if(R[A]!=="**")return!1;return A===R.length}}}e.getLocation=k;function b(i,l=[],s=D.DEFAULT){let r=null,a=[];const g=[];function p(R){Array.isArray(a)?a.push(R):r!==null&&(a[r]=R)}return h(i,{onObjectBegin:()=>{const R={};p(R),g.push(a),a=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{a=g.pop()},onArrayBegin:()=>{const R=[];p(R),g.push(a),a=R,r=null},onArrayEnd:()=>{a=g.pop()},onLiteralValue:p,onError:(R,A,W)=>{l.push({error:R,offset:A,length:W})}},s),a[0]}e.parse=b;function S(i,l=[],s=D.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function g(R){return r.children.push(R),R}h(i,{onObjectBegin:R=>{r=g({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,A,W)=>{r=g({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:A,length:W,parent:r})},onObjectEnd:(R,A)=>{r.length=R+A-r.offset,r=r.parent,a(R+A)},onArrayBegin:(R,A)=>{r=g({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,A)=>{r.length=R+A-r.offset,r=r.parent,a(R+A)},onLiteralValue:(R,A,W)=>{g({type:u(R),offset:A,length:W,parent:r,value:R}),a(A+W)},onSeparator:(R,A,W)=>{r.type==="property"&&(R===":"?r.colonOffset=A:R===","&&a(A))},onError:(R,A,W)=>{l.push({error:R,offset:A,length:W})}},s);const P=r.children[0];return P&&delete P.parent,P}e.parseTree=S;function d(i,l){if(!i)return;let s=i;for(let r of l)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const g of s.children)if(Array.isArray(g.children)&&g.children[0].value===r){s=g.children[1],a=!0;break}if(!a)return}else{const a=r;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.findNodeAtLocation=d;function m(i){if(!i.parent||!i.parent.children)return[];const l=m(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;l.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&l.push(s)}return l}e.getNodePath=m;function E(i){switch(i.type){case"array":return i.children.map(E);case"object":const l=Object.create(null);for(let s of i.children){const r=s.children[1];r&&(l[s.children[0].value]=E(r))}return l;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=E;function y(i,l,s=!1){return l>=i.offset&&l<i.offset+i.length||s&&l===i.offset+i.length}e.contains=y;function c(i,l,s=!1){if(y(i,l,s)){const r=i.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=l;a++){const g=c(r[a],l,s);if(g)return g}return i}}e.findNodeAtOffset=c;function h(i,l,s=D.DEFAULT){const r=I(i,!1);function a(_){return _?()=>_(r.getTokenOffset(),r.getTokenLength()):()=>!0}function g(_){return _?q=>_(q,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=a(l.onObjectBegin),P=g(l.onObjectProperty),R=a(l.onObjectEnd),A=a(l.onArrayBegin),W=a(l.onArrayEnd),j=g(l.onLiteralValue),x=g(l.onSeparator),re=a(l.onComment),K=g(l.onError),ee=s&&s.disallowComments,F=s&&s.allowTrailingComma;function H(){for(;;){const _=r.scan();switch(r.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:ee||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(_){case 12:case 13:ee?z(10):re();break;case 16:z(1);break;case 15:case 14:break;default:return _}}}function z(_,q=[],X=[]){if(K(_),q.length+X.length>0){let $=r.getToken();for(;$!==17;){if(q.indexOf($)!==-1){H();break}else if(X.indexOf($)!==-1)break;$=H()}}}function B(_){const q=r.getTokenValue();return _?j(q):P(q),H(),!0}function C(){switch(r.getToken()){case 11:let _=0;try{_=JSON.parse(r.getTokenValue()),typeof _!="number"&&(z(2),_=0)}catch(q){z(2)}j(_);break;case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return H(),!0}function U(){return r.getToken()!==10?(z(3,[],[2,5]),!1):(B(!1),r.getToken()===6?(x(":"),H(),T()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function Y(){p(),H();let _=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(_||z(4,[],[]),x(","),H(),r.getToken()===2&&F)break}else _&&z(6,[],[]);U()||z(4,[],[2,5]),_=!0}return R(),r.getToken()!==2?z(7,[2],[]):H(),!0}function O(){A(),H();let _=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(_||z(4,[],[]),x(","),H(),r.getToken()===4&&F)break}else _&&z(6,[],[]);T()||z(4,[],[4,5]),_=!0}return W(),r.getToken()!==4?z(8,[4],[]):H(),!0}function T(){switch(r.getToken()){case 3:return O();case 1:return Y();case 10:return B(!0);default:return C()}}return H(),r.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):T()?(r.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=h;function o(i,l){let s=I(i),r=[],a,g=0,p;do switch(p=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:g!==p&&r.push(i.substring(g,p)),l!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,l)),g=s.getPosition();break}while(a!==17);return r.join("")}e.stripComments=o;function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Q[103],J([0,1,39]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,w,t){let k,b,S,d,m;if(w){for(d=w.offset,m=d+w.length,S=d;S>0&&!n(f,S-1);)S--;let g=m;for(;g<f.length&&!n(f,g);)g++;b=f.substring(S,g),k=D(b,t)}else b=f,k=0,S=0,d=0,m=f.length;const E=I(t,f);let y=!1,c=0,h;t.insertSpaces?h=M(" ",t.tabSize||4):h="	";const o=(0,v.createScanner)(b,!1);let u=!1;function i(){return E+M(h,k+c)}function l(){let g=o.scan();for(y=!1;g===15||g===14;)y=y||g===14,g=o.scan();return u=g===16||o.getTokenError()!==0,g}const s=[];function r(g,p,P){!u&&p<m&&P>d&&f.substring(p,P)!==g&&s.push({offset:p,length:P-p,content:g})}let a=l();if(a!==17){const g=o.getTokenOffset()+S,p=M(h,k);r(p,S,g)}for(;a!==17;){let g=o.getTokenOffset()+o.getTokenLength()+S,p=l(),P="";for(;!y&&(p===12||p===13);){const A=o.getTokenOffset()+S;r(" ",g,A),g=o.getTokenOffset()+o.getTokenLength()+S,P=p===12?i():"",p=l()}if(p===2)a!==1&&(c--,P=i());else if(p===4)a!==3&&(c--,P=i());else{switch(a){case 3:case 1:c++,P=i();break;case 5:case 12:P=i();break;case 13:y?P=i():P=" ";break;case 6:P=" ";break;case 10:if(p===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?P=" ":p!==5&&p!==17&&(u=!0);break;case 16:u=!0;break}y&&(p===12||p===13)&&(P=i())}const R=o.getTokenOffset()+S;r(P,g,R),a=p}return s}e.format=L;function M(f,w){let t="";for(let k=0;k<w;k++)t+=f;return t}function D(f,w){let t=0,k=0;const b=w.tabSize||4;for(;t<f.length;){const S=f.charAt(t);if(S===" ")k++;else if(S==="	")k+=b;else break;t++}return Math.floor(k/b)}function I(f,w){for(let t=0;t<w.length;t++){const k=w.charAt(t);if(k==="\r")return t+1<w.length&&w.charAt(t+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=I;function n(f,w){return`\r
`.indexOf(f.charAt(w))!==-1}e.isEOL=n}),define(Q[78],J([0,1,39,103]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function M(w,t,k){return D(w,t,void 0,k)}e.removeProperty=M;function D(w,t,k,b,S){const d=t.slice(),m=[],E=(0,v.parseTree)(w,m);let y,c;for(;d.length>0&&(c=d.pop(),y=(0,v.findNodeAtLocation)(E,d),y===void 0&&k!==void 0);)typeof c=="string"?k={[c]:k}:k=[k];if(y)if(y.type==="object"&&typeof c=="string"&&Array.isArray(y.children)){const h=(0,v.findNodeAtLocation)(y,[c]);if(h!==void 0)if(k===void 0){if(!h.parent)throw new Error("Malformed AST");const o=y.children.indexOf(h.parent);let u,i=h.parent.offset+h.parent.length;if(o>0){const l=y.children[o-1];u=l.offset+l.length}else u=y.offset+1,y.children.length>1&&(i=y.children[1].offset);return I(w,{offset:u,length:i-u,content:""},b)}else return I(w,{offset:h.offset,length:h.length,content:JSON.stringify(k)},b);else{if(k===void 0)return[];const o=`${JSON.stringify(c)}: ${JSON.stringify(k)}`,u=S?S(y.children.map(l=>l.children[0].value)):y.children.length;let i;if(u>0){const l=y.children[u-1];i={offset:l.offset+l.length,length:0,content:","+o}}else y.children.length===0?i={offset:y.offset+1,length:0,content:o}:i={offset:y.offset+1,length:0,content:o+","};return I(w,i,b)}}else if(y.type==="array"&&typeof c=="number"&&Array.isArray(y.children))if(k!==void 0){const h=`${JSON.stringify(k)}`;let o;if(y.children.length===0||c===0)o={offset:y.offset+1,length:0,content:y.children.length===0?h:h+","};else{const u=c===-1||c>y.children.length?y.children.length:c,i=y.children[u-1];o={offset:i.offset+i.length,length:0,content:","+h}}return I(w,o,b)}else{const h=c,o=y.children[h];let u;if(y.children.length===1)u={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===h){const i=y.children[h-1],l=i.offset+i.length,s=y.offset+y.length;u={offset:l,length:s-2-l,content:""}}else u={offset:o.offset,length:y.children[h+1].offset-o.offset,content:""};return I(w,u,b)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${y.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return I(w,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(k)},b)}}e.setProperty=D;function I(w,t,k){let b=n(w,t),S=t.offset,d=t.offset+t.content.length;if(t.length===0||t.content.length===0){for(;S>0&&!(0,L.isEOL)(b,S-1);)S--;for(;d<b.length&&!(0,L.isEOL)(b,d);)d++}const m=(0,L.format)(b,{offset:S,length:d-S},k);for(let y=m.length-1;y>=0;y--){const c=m[y];b=n(b,c),S=Math.min(S,c.offset),d=Math.max(d,c.offset+c.length),d+=c.content.length-c.length}const E=w.length-(b.length-d)-S;return[{offset:S,length:E,content:b.substring(S,d)}]}e.withFormatting=I;function n(w,t){return w.substring(0,t.offset)+t.content+w.substring(t.offset+t.length)}e.applyEdit=n;function f(w,t){let k=t.slice(0).sort((S,d)=>{const m=S.offset-d.offset;return m===0?S.length-d.length:m}),b=w.length;for(let S=k.length-1;S>=0;S--){let d=k[S];if(d.offset+d.length<=b)w=n(w,d);else throw new Error("Overlapping edit");b=d.offset}return w}e.applyEdits=f}),define(Q[57],J([0,1,17]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,o){this._keyCodeToStr[h]=o,this._strToKeyCode[o.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const D=new M,I=new M,n=new M;(function(){function c(h,o,u=o,i=u){D.define(h,o),I.define(h,u),n.define(h,i)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var f;(function(c){function h(r){return D.keyCodeToStr(r)}c.toString=h;function o(r){return D.strToKeyCode(r)}c.fromString=o;function u(r){return I.keyCodeToStr(r)}c.toUserSettingsUS=u;function i(r){return n.keyCodeToStr(r)}c.toUserSettingsGeneral=i;function l(r){return I.strToKeyCode(r)||n.strToKeyCode(r)}c.fromUserSettings=l;function s(r){if(r>=93&&r<=108)return null;switch(r){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(r)}c.toElectronAccelerator=s})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(w||(w={}));var t;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(t=e.KeyMod||(e.KeyMod={}));function k(c,h){const o=(h&65535)<<16>>>0;return(c|o)>>>0}e.KeyChord=k;function b(c,h){if(c===0)return null;const o=(c&65535)>>>0,u=(c&4294901760)>>>16;return u!==0?new m([S(o,h),S(u,h)]):new m([S(o,h)])}e.createKeybinding=b;function S(c,h){const o=!!(c&2048),u=!!(c&256),i=h===2?u:o,l=!!(c&1024),s=!!(c&512),r=h===2?o:u,a=c&255;return new d(i,l,s,r,a)}e.createSimpleKeybinding=S;class d{constructor(h,o,u,i,l){this.ctrlKey=h,this.shiftKey=o,this.altKey=u,this.metaKey=i,this.keyCode=l}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",u=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`${h}${o}${u}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class m{constructor(h){if(h.length===0)throw(0,v.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let o=0,u=this.parts.length;o<u;o++)o!==0&&(h+=";"),h+=this.parts[o].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(h.parts[o]))return!1;return!0}}e.ChordKeybinding=m;class E{constructor(h,o,u,i,l,s){this.ctrlKey=h,this.shiftKey=o,this.altKey=u,this.metaKey=i,this.keyLabel=l,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=E;class y{}e.ResolvedKeybinding=y}),define(Q[2],J([0,1,42,66]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const M=!1;let D=null;function I(r){D=r}if(e.setDisposableTracker=I,M){const r="__is_disposable_tracked__";I(new class{trackDisposable(a){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(g)},3e3)}setParent(a,g){if(a&&a!==c.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==c.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function n(r){return D?.trackDisposable(r),r}function f(r){D?.markAsDisposed(r)}function w(r,a){D?.setParent(r,a)}function t(r,a){if(!!D)for(const g of r)D.setParent(g,a)}function k(r){return D?.markAsSingleton(r),r}e.markAsSingleton=k;class b extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=b;function S(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=S;function d(r){if(L.Iterable.is(r)){let a=[];for(const g of r)if(g)try{g.dispose()}catch(p){a.push(p)}if(a.length===1)throw a[0];if(a.length>1)throw new b(a);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function m(...r){const a=E(()=>d(r));return t(r,a),a}e.combinedDisposable=m;function E(r){const a=n({dispose:(0,v.once)(()=>{f(a),r()})});return a}e.toDisposable=E;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return w(a,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new y,n(this),w(this._store,this)}dispose(){f(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&w(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&w(a,null),a}}e.MutableDisposable=h;class o{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class u{constructor(){this.references=new Map}acquire(a,...g){let p=this.references.get(a);p||(p={counter:0,object:this.createReferencedObject(a,...g)},this.references.set(a,p));const{object:P}=p,R=(0,v.once)(()=>{--p.counter==0&&(this.destroyReferencedObject(a,p.object),this.references.delete(a))});return p.counter++,{object:P,dispose:R}}}e.ReferenceCollection=u;class i{constructor(a){this.referenceCollection=a}async acquire(a,...g){const p=this.referenceCollection.acquire(a,...g);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(P){throw p.dispose(),P}}}e.AsyncReferenceCollection=i;class l{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=l;function s(r){const a=new y;try{r(a)}finally{a.dispose()}}e.disposeOnReturn=s}),define(Q[104],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(D){this.element=D,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class L{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let D=this._first;for(;D!==v.Undefined;){const I=D.next;D.prev=v.Undefined,D.next=v.Undefined,D=I}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,I){const n=new v(D);if(this._first===v.Undefined)this._first=n,this._last=n;else if(I){const w=this._last;this._last=n,n.prev=w,w.next=n}else{const w=this._first;this._first=n,n.next=w,w.prev=n}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(n))}}shift(){if(this._first!==v.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==v.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==v.Undefined&&D.next!==v.Undefined){const I=D.prev;I.next=D.next,D.next.prev=I}else D.prev===v.Undefined&&D.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):D.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):D.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==v.Undefined;)yield D.element,D=D.next}}e.LinkedList=L}),function(){function V(M){const D=[];typeof M=="number"&&D.push("code/timeOrigin",M);function I(f){D.push(f,Date.now())}function n(){const f=[];for(let w=0;w<D.length;w+=2)f.push({name:D[w],startTime:D[w+1]});return f}return{mark:I,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const I of performance.getEntriesByType("mark"))D.push({name:I.name,startTime:Math.round(M+I.startTime)});return D}};if(typeof process=="object"){const M=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function v(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=v(L))}(),define(Q[3],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let L=!1,M=!1,D=!1,I=!1,n=!1,f=!1,w=!1,t,k=v,b,S;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const m=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=m&&d?.sandboxed,typeof navigator=="object"&&!m)S=navigator.userAgent,L=S.indexOf("Windows")>=0,M=S.indexOf("Macintosh")>=0,w=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=S.indexOf("Linux")>=0,f=!0,t=navigator.language,k=t;else if(typeof d=="object"){L=d.platform==="win32",M=d.platform==="darwin",D=d.platform==="linux",I=D&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,t=v,k=v;const s=d.env.VSCODE_NLS_CONFIG;if(s)try{const r=JSON.parse(s),a=r.availableLanguages["*"];t=r.locale,k=a||v,b=r._translationsConfigFile}catch(r){}n=!0}else console.error("Unable to resolve platform.");var E;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function y(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let c=0;M?c=1:L?c=3:D&&(c=2),e.isWindows=L,e.isMacintosh=M,e.isLinux=D,e.isLinuxSnap=I,e.isNative=n,e.isWeb=f,e.isIOS=w,e.platform=c,e.userAgent=S,e.language=k;var h;(function(s){function r(){return e.language}s.value=r;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=a;function g(){return e.language==="en"}s.isDefault=g})(h=e.Language||(e.Language={})),e.locale=t,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeSetImmediateId)for(let P=0,R=a.length;P<R;P++){const A=a[P];if(A.id===p.data.vscodeSetImmediateId){a.splice(P,1),A.callback();return}}});let g=0;return p=>{const P=++g;a.push({id:P,callback:p}),e.globals.postMessage({vscodeSetImmediateId:P},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const r=Promise.resolve();return a=>r.then(a)}();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=M||w?2:L?1:3;let u=!0,i=!1;function l(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,u=new Uint16Array(s.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=l}),define(Q[32],J([0,1,3]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const M=v.globals.vscode.process;L={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()},nextTick(D){return(0,v.setImmediate)(D)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(M){return process.nextTick(M)}}:L={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},nextTick(M){return(0,v.setImmediate)(M)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Q[8],J([0,1,32]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,M=97,D=90,I=122,n=46,f=47,w=92,t=58,k=63;class b extends Error{constructor(o,u,i){let l;typeof u=="string"&&u.indexOf("not ")===0?(l="must not be",u=u.replace(/^not /,"")):l="must be";const s=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${s} ${l} of type ${u}`;r+=`. Received type ${typeof i}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function S(h,o){if(typeof h!="string")throw new b(o,"string",h)}function d(h){return h===f||h===w}function m(h){return h===f}function E(h){return h>=L&&h<=D||h>=M&&h<=I}function y(h,o,u,i){let l="",s=0,r=-1,a=0,g=0;for(let p=0;p<=h.length;++p){if(p<h.length)g=h.charCodeAt(p);else{if(i(g))break;g=f}if(i(g)){if(!(r===p-1||a===1))if(a===2){if(l.length<2||s!==2||l.charCodeAt(l.length-1)!==n||l.charCodeAt(l.length-2)!==n){if(l.length>2){const P=l.lastIndexOf(u);P===-1?(l="",s=0):(l=l.slice(0,P),s=l.length-1-l.lastIndexOf(u)),r=p,a=0;continue}else if(l.length!==0){l="",s=0,r=p,a=0;continue}}o&&(l+=l.length>0?`${u}..`:"..",s=2)}else l.length>0?l+=`${u}${h.slice(r+1,p)}`:l=h.slice(r+1,p),s=p-r-1;r=p,a=0}else g===n&&a!==-1?++a:a=-1}return l}function c(h,o){if(o===null||typeof o!="object")throw new b("pathObject","Object",o);const u=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return u?u===o.root?`${u}${i}`:`${u}${h}${i}`:i}e.win32={resolve(...h){let o="",u="",i=!1;for(let l=h.length-1;l>=-1;l--){let s;if(l>=0){if(s=h[l],S(s,"path"),s.length===0)continue}else o.length===0?s=v.cwd():(s=v.env[`=${o}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===w)&&(s=`${o}\\`));const r=s.length;let a=0,g="",p=!1;const P=s.charCodeAt(0);if(r===1)d(P)&&(a=1,p=!0);else if(d(P))if(p=!0,d(s.charCodeAt(1))){let R=2,A=R;for(;R<r&&!d(s.charCodeAt(R));)R++;if(R<r&&R!==A){const W=s.slice(A,R);for(A=R;R<r&&d(s.charCodeAt(R));)R++;if(R<r&&R!==A){for(A=R;R<r&&!d(s.charCodeAt(R));)R++;(R===r||R!==A)&&(g=`\\\\${W}\\${s.slice(A,R)}`,a=R)}}}else a=1;else E(P)&&s.charCodeAt(1)===t&&(g=s.slice(0,2),a=2,r>2&&d(s.charCodeAt(2))&&(p=!0,a=3));if(g.length>0)if(o.length>0){if(g.toLowerCase()!==o.toLowerCase())continue}else o=g;if(i){if(o.length>0)break}else if(u=`${s.slice(a)}\\${u}`,i=p,p&&o.length>0)break}return u=y(u,!i,"\\",d),i?`${o}\\${u}`:`${o}${u}`||"."},normalize(h){S(h,"path");const o=h.length;if(o===0)return".";let u=0,i,l=!1;const s=h.charCodeAt(0);if(o===1)return m(s)?"\\":h;if(d(s))if(l=!0,d(h.charCodeAt(1))){let a=2,g=a;for(;a<o&&!d(h.charCodeAt(a));)a++;if(a<o&&a!==g){const p=h.slice(g,a);for(g=a;a<o&&d(h.charCodeAt(a));)a++;if(a<o&&a!==g){for(g=a;a<o&&!d(h.charCodeAt(a));)a++;if(a===o)return`\\\\${p}\\${h.slice(g)}\\`;a!==g&&(i=`\\\\${p}\\${h.slice(g,a)}`,u=a)}}}else u=1;else E(s)&&h.charCodeAt(1)===t&&(i=h.slice(0,2),u=2,o>2&&d(h.charCodeAt(2))&&(l=!0,u=3));let r=u<o?y(h.slice(u),!l,"\\",d):"";return r.length===0&&!l&&(r="."),r.length>0&&d(h.charCodeAt(o-1))&&(r+="\\"),i===void 0?l?`\\${r}`:r:l?`${i}\\${r}`:`${i}${r}`},isAbsolute(h){S(h,"path");const o=h.length;if(o===0)return!1;const u=h.charCodeAt(0);return d(u)||o>2&&E(u)&&h.charCodeAt(1)===t&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let o,u;for(let s=0;s<h.length;++s){const r=h[s];S(r,"path"),r.length>0&&(o===void 0?o=u=r:o+=`\\${r}`)}if(o===void 0)return".";let i=!0,l=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++l;const s=u.length;s>1&&d(u.charCodeAt(1))&&(++l,s>2&&(d(u.charCodeAt(2))?++l:i=!1))}if(i){for(;l<o.length&&d(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.win32.normalize(o)},relative(h,o){if(S(h,"from"),S(o,"to"),h===o)return"";const u=e.win32.resolve(h),i=e.win32.resolve(o);if(u===i||(h=u.toLowerCase(),o=i.toLowerCase(),h===o))return"";let l=0;for(;l<h.length&&h.charCodeAt(l)===w;)l++;let s=h.length;for(;s-1>l&&h.charCodeAt(s-1)===w;)s--;const r=s-l;let a=0;for(;a<o.length&&o.charCodeAt(a)===w;)a++;let g=o.length;for(;g-1>a&&o.charCodeAt(g-1)===w;)g--;const p=g-a,P=r<p?r:p;let R=-1,A=0;for(;A<P;A++){const j=h.charCodeAt(l+A);if(j!==o.charCodeAt(a+A))break;j===w&&(R=A)}if(A!==P){if(R===-1)return i}else{if(p>P){if(o.charCodeAt(a+A)===w)return i.slice(a+A+1);if(A===2)return i.slice(a+A)}r>P&&(h.charCodeAt(l+A)===w?R=A:A===2&&(R=3)),R===-1&&(R=0)}let W="";for(A=l+R+1;A<=s;++A)(A===s||h.charCodeAt(A)===w)&&(W+=W.length===0?"..":"\\..");return a+=R,W.length>0?`${W}${i.slice(a,g)}`:(i.charCodeAt(a)===w&&++a,i.slice(a,g))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const o=e.win32.resolve(h);if(o.length<=2)return h;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const u=o.charCodeAt(2);if(u!==k&&u!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(E(o.charCodeAt(0))&&o.charCodeAt(1)===t&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return h},dirname(h){S(h,"path");const o=h.length;if(o===0)return".";let u=-1,i=0;const l=h.charCodeAt(0);if(o===1)return d(l)?h:".";if(d(l)){if(u=i=1,d(h.charCodeAt(1))){let a=2,g=a;for(;a<o&&!d(h.charCodeAt(a));)a++;if(a<o&&a!==g){for(g=a;a<o&&d(h.charCodeAt(a));)a++;if(a<o&&a!==g){for(g=a;a<o&&!d(h.charCodeAt(a));)a++;if(a===o)return h;a!==g&&(u=i=a+1)}}}}else E(l)&&h.charCodeAt(1)===t&&(u=o>2&&d(h.charCodeAt(2))?3:2,i=u);let s=-1,r=!0;for(let a=o-1;a>=i;--a)if(d(h.charCodeAt(a))){if(!r){s=a;break}}else r=!1;if(s===-1){if(u===-1)return".";s=u}return h.slice(0,s)},basename(h,o){o!==void 0&&S(o,"ext"),S(h,"path");let u=0,i=-1,l=!0,s;if(h.length>=2&&E(h.charCodeAt(0))&&h.charCodeAt(1)===t&&(u=2),o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let r=o.length-1,a=-1;for(s=h.length-1;s>=u;--s){const g=h.charCodeAt(s);if(d(g)){if(!l){u=s+1;break}}else a===-1&&(l=!1,a=s+1),r>=0&&(g===o.charCodeAt(r)?--r==-1&&(i=s):(r=-1,i=a))}return u===i?i=a:i===-1&&(i=h.length),h.slice(u,i)}for(s=h.length-1;s>=u;--s)if(d(h.charCodeAt(s))){if(!l){u=s+1;break}}else i===-1&&(l=!1,i=s+1);return i===-1?"":h.slice(u,i)},extname(h){S(h,"path");let o=0,u=-1,i=0,l=-1,s=!0,r=0;h.length>=2&&h.charCodeAt(1)===t&&E(h.charCodeAt(0))&&(o=i=2);for(let a=h.length-1;a>=o;--a){const g=h.charCodeAt(a);if(d(g)){if(!s){i=a+1;break}continue}l===-1&&(s=!1,l=a+1),g===n?u===-1?u=a:r!==1&&(r=1):u!==-1&&(r=-1)}return u===-1||l===-1||r===0||r===1&&u===l-1&&u===i+1?"":h.slice(u,l)},format:c.bind(null,"\\"),parse(h){S(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const u=h.length;let i=0,l=h.charCodeAt(0);if(u===1)return d(l)?(o.root=o.dir=h,o):(o.base=o.name=h,o);if(d(l)){if(i=1,d(h.charCodeAt(1))){let R=2,A=R;for(;R<u&&!d(h.charCodeAt(R));)R++;if(R<u&&R!==A){for(A=R;R<u&&d(h.charCodeAt(R));)R++;if(R<u&&R!==A){for(A=R;R<u&&!d(h.charCodeAt(R));)R++;R===u?i=R:R!==A&&(i=R+1)}}}}else if(E(l)&&h.charCodeAt(1)===t){if(u<=2)return o.root=o.dir=h,o;if(i=2,d(h.charCodeAt(2))){if(u===3)return o.root=o.dir=h,o;i=3}}i>0&&(o.root=h.slice(0,i));let s=-1,r=i,a=-1,g=!0,p=h.length-1,P=0;for(;p>=i;--p){if(l=h.charCodeAt(p),d(l)){if(!g){r=p+1;break}continue}a===-1&&(g=!1,a=p+1),l===n?s===-1?s=p:P!==1&&(P=1):s!==-1&&(P=-1)}return a!==-1&&(s===-1||P===0||P===1&&s===a-1&&s===r+1?o.base=o.name=h.slice(r,a):(o.name=h.slice(r,s),o.base=h.slice(r,a),o.ext=h.slice(s,a))),r>0&&r!==i?o.dir=h.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let o="",u=!1;for(let i=h.length-1;i>=-1&&!u;i--){const l=i>=0?h[i]:v.cwd();S(l,"path"),l.length!==0&&(o=`${l}/${o}`,u=l.charCodeAt(0)===f)}return o=y(o,!u,"/",m),u?`/${o}`:o.length>0?o:"."},normalize(h){if(S(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f,u=h.charCodeAt(h.length-1)===f;return h=y(h,!o,"/",m),h.length===0?o?"/":u?"./":".":(u&&(h+="/"),o?`/${h}`:h)},isAbsolute(h){return S(h,"path"),h.length>0&&h.charCodeAt(0)===f},join(...h){if(h.length===0)return".";let o;for(let u=0;u<h.length;++u){const i=h[u];S(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(h,o){if(S(h,"from"),S(o,"to"),h===o||(h=e.posix.resolve(h),o=e.posix.resolve(o),h===o))return"";const u=1,i=h.length,l=i-u,s=1,r=o.length-s,a=l<r?l:r;let g=-1,p=0;for(;p<a;p++){const R=h.charCodeAt(u+p);if(R!==o.charCodeAt(s+p))break;R===f&&(g=p)}if(p===a)if(r>a){if(o.charCodeAt(s+p)===f)return o.slice(s+p+1);if(p===0)return o.slice(s+p)}else l>a&&(h.charCodeAt(u+p)===f?g=p:p===0&&(g=0));let P="";for(p=u+g+1;p<=i;++p)(p===i||h.charCodeAt(p)===f)&&(P+=P.length===0?"..":"/..");return`${P}${o.slice(s+g)}`},toNamespacedPath(h){return h},dirname(h){if(S(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f;let u=-1,i=!0;for(let l=h.length-1;l>=1;--l)if(h.charCodeAt(l)===f){if(!i){u=l;break}}else i=!1;return u===-1?o?"/":".":o&&u===1?"//":h.slice(0,u)},basename(h,o){o!==void 0&&S(o,"ext"),S(h,"path");let u=0,i=-1,l=!0,s;if(o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let r=o.length-1,a=-1;for(s=h.length-1;s>=0;--s){const g=h.charCodeAt(s);if(g===f){if(!l){u=s+1;break}}else a===-1&&(l=!1,a=s+1),r>=0&&(g===o.charCodeAt(r)?--r==-1&&(i=s):(r=-1,i=a))}return u===i?i=a:i===-1&&(i=h.length),h.slice(u,i)}for(s=h.length-1;s>=0;--s)if(h.charCodeAt(s)===f){if(!l){u=s+1;break}}else i===-1&&(l=!1,i=s+1);return i===-1?"":h.slice(u,i)},extname(h){S(h,"path");let o=-1,u=0,i=-1,l=!0,s=0;for(let r=h.length-1;r>=0;--r){const a=h.charCodeAt(r);if(a===f){if(!l){u=r+1;break}continue}i===-1&&(l=!1,i=r+1),a===n?o===-1?o=r:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||i===-1||s===0||s===1&&o===i-1&&o===u+1?"":h.slice(o,i)},format:c.bind(null,"/"),parse(h){S(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const u=h.charCodeAt(0)===f;let i;u?(o.root="/",i=1):i=0;let l=-1,s=0,r=-1,a=!0,g=h.length-1,p=0;for(;g>=i;--g){const P=h.charCodeAt(g);if(P===f){if(!a){s=g+1;break}continue}r===-1&&(a=!1,r=g+1),P===n?l===-1?l=g:p!==1&&(p=1):l!==-1&&(p=-1)}if(r!==-1){const P=s===0&&u?1:s;l===-1||p===0||p===1&&l===r-1&&l===s+1?o.base=o.name=h.slice(P,r):(o.name=h.slice(P,l),o.base=h.slice(P,r),o.ext=h.slice(l,r))}return s>0?o.dir=h.slice(0,s-1):u&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[79],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var L;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(D,...I){const n=I.reduce((t,k)=>(t[k]=!0,t),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(t=>!n[t]).forEach(t=>{for(let k=0;k<f.length;k++)if(t.search(f[k])!==-1){delete D[t];break}})}e.sanitizeProcessEnvironment=M}),define(Q[80],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const L=[],M=Object.create(null),D=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>D[n]||0,toEnum:n=>M[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class I{constructor(f,w,t,k,b){this.ctrlKey=f,this.shiftKey=w,this.altKey=t,this.metaKey=k,this.scanCode=b}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=I,function(){function n(f,w){L[f]=w,M[w]=f,D[w.toLowerCase()]=f}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function n(f,w){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[w]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Q[105],J([0,1,57,80]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class M{static _readModifiers(I){I=I.toLowerCase().trim();let n=!1,f=!1,w=!1,t=!1,k;do k=!1,/^ctrl(\+|\-)/.test(I)&&(n=!0,I=I.substr("ctrl-".length),k=!0),/^shift(\+|\-)/.test(I)&&(f=!0,I=I.substr("shift-".length),k=!0),/^alt(\+|\-)/.test(I)&&(w=!0,I=I.substr("alt-".length),k=!0),/^meta(\+|\-)/.test(I)&&(t=!0,I=I.substr("meta-".length),k=!0),/^win(\+|\-)/.test(I)&&(t=!0,I=I.substr("win-".length),k=!0),/^cmd(\+|\-)/.test(I)&&(t=!0,I=I.substr("cmd-".length),k=!0);while(k);let b;const S=I.indexOf(" ");return S>0?(b=I.substring(0,S),I=I.substring(S)):(b=I,I=""),{remains:I,ctrl:n,shift:f,alt:w,meta:t,key:b}}static parseSimpleKeybinding(I){const n=this._readModifiers(I),f=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}static parseKeybinding(I,n){if(!I)return null;const f=[];let w;do[w,I]=this.parseSimpleKeybinding(I),f.push(w);while(I.length>0);return new v.ChordKeybinding(f)}static parseSimpleUserBinding(I){const n=this._readModifiers(I),f=n.key.match(/^\[([^\]]+)\]$/);if(f){const t=f[1],k=L.ScanCodeUtils.lowerCaseToEnum(t);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,k),n.remains]}const w=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseUserBinding(I){if(!I)return[];const n=[];let f;for(;I.length>0;)[f,I]=this.parseSimpleUserBinding(I),n.push(f);return n}}e.KeybindingParser=M}),define(Q[106],J([0,1,3]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=v.globals.performance&&typeof v.globals.performance.now=="function";class M{constructor(I){this._highResolution=L&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new M(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=M}),define(Q[4],J([0,1,17,42,2,104,106]),function(V,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(o){o.None=()=>M.Disposable.None;function u(F){return(H,z=null,B)=>{let C=!1,U;return U=F(Y=>{if(!C)return U?U.dispose():C=!0,H.call(z,Y)},null,B),C&&U.dispose(),U}}o.once=u;function i(F,H){return p((z,B=null,C)=>F(U=>z.call(B,H(U)),null,C))}o.map=i;function l(F,H){return p((z,B=null,C)=>F(U=>{H(U),z.call(B,U)},null,C))}o.forEach=l;function s(F,H){return p((z,B=null,C)=>F(U=>H(U)&&z.call(B,U),null,C))}o.filter=s;function r(F){return F}o.signal=r;function a(...F){return(H,z=null,B)=>(0,M.combinedDisposable)(...F.map(C=>C(U=>H.call(z,U),null,B)))}o.any=a;function g(F,H,z){let B=z;return i(F,C=>(B=H(B,C),B))}o.reduce=g;function p(F){let H;const z=new b({onFirstListenerAdd(){H=F(z.fire,z)},onLastListenerRemove(){H.dispose()}});return z.event}function P(F,H,z=100,B=!1,C){let U,Y,O,T=0;const _=new b({leakWarningThreshold:C,onFirstListenerAdd(){U=F(q=>{T++,Y=H(Y,q),B&&!O&&(_.fire(Y),Y=void 0),clearTimeout(O),O=setTimeout(()=>{const X=Y;Y=void 0,O=void 0,(!B||T>1)&&_.fire(X),T=0},z)})},onLastListenerRemove(){U.dispose()}});return _.event}o.debounce=P;function R(F,H=(z,B)=>z===B){let z=!0,B;return s(F,C=>{const U=z||!H(C,B);return z=!1,B=C,U})}o.latch=R;function A(F,H){return[o.filter(F,H),o.filter(F,z=>!H(z))]}o.split=A;function W(F,H=!1,z=[]){let B=z.slice(),C=F(O=>{B?B.push(O):Y.fire(O)});const U=()=>{B&&B.forEach(O=>Y.fire(O)),B=null},Y=new b({onFirstListenerAdd(){C||(C=F(O=>Y.fire(O)))},onFirstListenerDidAdd(){B&&(H?setTimeout(U):U())},onLastListenerRemove(){C&&C.dispose(),C=null}});return Y.event}o.buffer=W;class j{constructor(H){this.event=H}map(H){return new j(i(this.event,H))}forEach(H){return new j(l(this.event,H))}filter(H){return new j(s(this.event,H))}reduce(H,z){return new j(g(this.event,H,z))}latch(){return new j(R(this.event))}debounce(H,z=100,B=!1,C){return new j(P(this.event,H,z,B,C))}on(H,z,B){return this.event(H,z,B)}once(H,z,B){return u(this.event)(H,z,B)}}function x(F){return new j(F)}o.chain=x;function re(F,H,z=B=>B){const B=(...O)=>Y.fire(z(...O)),C=()=>F.on(H,B),U=()=>F.removeListener(H,B),Y=new b({onFirstListenerAdd:C,onLastListenerRemove:U});return Y.event}o.fromNodeEventEmitter=re;function K(F,H,z=B=>B){const B=(...O)=>Y.fire(z(...O)),C=()=>F.addEventListener(H,B),U=()=>F.removeEventListener(H,B),Y=new b({onFirstListenerAdd:C,onLastListenerRemove:U});return Y.event}o.fromDOMEventEmitter=K;function ee(F){return new Promise(H=>u(F)(H))}o.toPromise=ee})(n=e.Event||(e.Event={}));class f{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${f._idPool++}`}start(u){this._stopWatch=new I.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let w=-1;function t(o){const u=w;return w=o,{dispose(){w=u}}}e.setGlobalLeakWarningThreshold=t;class k{constructor(u,i=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let i=w;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),i<=0||u<i)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(l)||0;if(this._stacks.set(l,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let r,a=0;for(const[g,p]of this._stacks)(!r||a<p)&&(r=g,a=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${a}):`),console.warn(r)}return()=>{const r=this._stacks.get(l)||0;this._stacks.set(l,r-1)}}}class b{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=w>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(u,i,l)=>{this._listeners||(this._listeners=new D.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(i?[u,i]:u);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,i);const a=this._leakageMon?.check(this._listeners.size),g=(0,M.toDisposable)(()=>{a&&a(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return l instanceof M.DisposableStore?l.add(g):Array.isArray(l)&&l.push(g),g}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,l]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,l):i[0].call(i[1],l)}catch(s){(0,v.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=b;class S extends b{async fireAsync(u,i,l){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,u]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),a=[],g={...r,waitUntil:p=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");l&&(p=l(p,typeof s=="function"?s:s[0])),a.push(p)}};try{typeof s=="function"?s.call(void 0,g):s[0].call(s[1],g)}catch(p){(0,v.onUnexpectedError)(p);continue}Object.freeze(a),await Promise.allSettled(a).then(p=>{for(const P of p)P.status==="rejected"&&(0,v.onUnexpectedError)(P.reason)})}}}}e.AsyncEmitter=S;class d extends b{constructor(u){super(u);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=d;class m extends d{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=m;class E extends b{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class y{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const i={event:u,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const l=()=>{this.hasListeners&&this.unhook(i);const s=this.events.indexOf(i);this.events.splice(s,1)};return(0,M.toDisposable)((0,L.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(i=>this.emitter.fire(i))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=y;class c{constructor(){this.buffers=[]}wrapEvent(u){return(i,l,s)=>u(r=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>i.call(l,r)):i.call(l,r)},void 0,s)}bufferEvents(u){const i=[];this.buffers.push(i);const l=u();return this.buffers.pop(),i.forEach(s=>s()),l}}e.EventBufferer=c;class h{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=M.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(Q[23],J([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,f){const w=setTimeout(n.bind(f),0);return{dispose(){clearTimeout(w)}}});var M;(function(n){function f(w){return w===n.None||w===n.Cancelled||w instanceof D?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}n.isCancellationToken=f,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(M=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=M.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=M.None}}e.CancellationTokenSource=I}),define(Q[107],J([0,1,4]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(k){const b=this._icons.get(k.id);b?k.description?b.description=k.description:console.error(`Duplicate registration of codicon ${k.id}`):(this._icons.set(k.id,k),this._onDidRegister.fire(k))}get(k){return this._icons.get(k)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const M=new L;e.iconRegistry=M;function D(t,k){return new n(t,k)}e.registerCodicon=D;function I(t){return t?t.replace(/\$\((.*?)\)/g,(k,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=I;class n{constructor(k,b,S){this.id=k,this.definition=b,this.description=S,M.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function f(t,k){const b=["codicon","codicon-"+t];return k&&b.push("codicon-modifier-"+k),b}e.getClassNamesArray=f;var w;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const k=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function b(m){if(m instanceof n)return["codicon","codicon-"+m.id];const E=k.exec(m.id);if(!E)return b(n.error);let[,y,c]=E;const h=["codicon","codicon-"+y];return c&&h.push("codicon-modifier-"+c.substr(1)),h}t.asClassNameArray=b;function S(m){return b(m).join(" ")}t.asClassName=S;function d(m){return"."+b(m).join(".")}t.asCSSSelector=d})(w=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"})}(n=e.Codicon||(e.Codicon={}))}),define(Q[67],J([0,1,17,2]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function M(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=M;function D(h){const o=h;return o?M(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=D;function I(h,o){return new n(h,o)}e.newWriteableStream=I;class n{constructor(o,u){this.reducer=o,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(u=>u(o))}emitError(o){this.listeners.error.length===0?(0,v.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(u=>u(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,u){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(o,u){if(this.state.destroyed)return;let i;switch(o){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const l=i.indexOf(u);l>=0&&i.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(h,o){const u=[];let i;for(;(i=h.read())!==null;)u.push(i);return o(u)}e.consumeReadable=f;function w(h,o,u){const i=[];let l;for(;(l=h.read())!==null&&i.length<u;)i.push(l);return l===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof l!="undefined"){const s=l;return l=void 0,s}return h.read()}}}e.peekReadable=w;function t(h,o){return new Promise((u,i)=>{const l=[];k(h,{onData:s=>{o&&l.push(s)},onError:s=>{o?i(s):u(void 0)},onEnd:()=>{u(o?o(l):void 0)}})})}e.consumeStream=t;function k(h,o){h.on("error",u=>o.onError(u)),h.on("end",()=>o.onEnd()),h.on("data",u=>o.onData(u))}e.listenStream=k;function b(h,o){return new Promise((u,i)=>{const l=new L.DisposableStore,s=[],r=p=>{if(s.push(p),s.length>o)return l.dispose(),h.pause(),u({stream:h,buffer:s,ended:!1})},a=p=>i(p),g=()=>u({stream:h,buffer:s,ended:!0});l.add((0,L.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),l.add((0,L.toDisposable)(()=>h.removeListener("end",g))),h.on("end",g),l.add((0,L.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}e.peekStream=b;function S(h,o){const u=I(o);return u.end(h),u}e.toStream=S;function d(){const h=I(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function m(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}e.toReadable=m;function E(h,o,u){const i=I(u);return k(h,{onData:l=>i.write(o.data(l)),onError:l=>i.error(o.error?o.error(l):l),onEnd:()=>i.end()}),i}e.transform=E;function y(h,o,u){let i=!1;return{read:()=>{const l=o.read();return i?l:(i=!0,l!==null?u([h,l]):h)}}}e.prefixedReadable=y;function c(h,o,u){let i=!1;const l=I(u);return k(o,{onData:s=>i?l.write(s):(i=!0,l.write(u([h,s]))),onError:s=>l.error(s),onEnd:()=>{i||(i=!0,l.write(h)),l.end()}}),l}e.prefixedStream=c}),define(Q[18],J([0,1,67]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let M,D;class I{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new I(Buffer.allocUnsafe(r)):new I(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new I(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&L?new I(Buffer.from(r)):(M||(M=new TextEncoder),new I(M.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let P=0,R=r.length;P<R;P++)a+=r[P].byteLength}const g=I.alloc(a);let p=0;for(let P=0,R=r.length;P<R;P++){const A=r[P];g.set(A,p),p+=A.byteLength}return g}toString(){return L?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(r,a){return new I(this.buffer.subarray(r,a))}set(r,a){r instanceof I?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return w(this.buffer,r)}writeUInt32BE(r,a){t(this.buffer,r,a)}readUInt32LE(r){return k(this.buffer,r)}writeUInt32LE(r,a){b(this.buffer,r,a)}readUInt8(r){return S(this.buffer,r)}writeUInt8(r,a){d(this.buffer,r,a)}}e.VSBuffer=I;function n(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0}e.readUInt16LE=n;function f(s,r,a){s[a+0]=r&255,r=r>>>8,s[a+1]=r&255}e.writeUInt16LE=f;function w(s,r){return s[r]*2**24+s[r+1]*2**16+s[r+2]*2**8+s[r+3]}e.readUInt32BE=w;function t(s,r,a){s[a+3]=r,r=r>>>8,s[a+2]=r,r=r>>>8,s[a+1]=r,r=r>>>8,s[a]=r}e.writeUInt32BE=t;function k(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0|s[r+2]<<16>>>0|s[r+3]<<24>>>0}e.readUInt32LE=k;function b(s,r,a){s[a+0]=r&255,r=r>>>8,s[a+1]=r&255,r=r>>>8,s[a+2]=r&255,r=r>>>8,s[a+3]=r&255}e.writeUInt32LE=b;function S(s,r){return s[r]}e.readUInt8=S;function d(s,r,a){s[a]=r}e.writeUInt8=d;function m(s){return v.consumeReadable(s,r=>I.concat(r))}e.readableToBuffer=m;function E(s){return v.toReadable(s)}e.bufferToReadable=E;function y(s){return v.consumeStream(s,r=>I.concat(r))}e.streamToBuffer=y;async function c(s){return s.ended?I.concat(s.buffer):I.concat([...s.buffer,await y(s.stream)])}e.bufferedStreamToBuffer=c;function h(s){return v.toStream(s,r=>I.concat(r))}e.bufferToStream=h;function o(s){return v.transform(s,{data:r=>typeof r=="string"?I.fromString(r):I.wrap(r)},r=>I.concat(r))}e.streamToBufferReadableStream=o;function u(s){return v.newWriteableStream(r=>I.concat(r),s)}e.newWriteableBufferStream=u;function i(s,r){return v.prefixedReadable(s,r,a=>I.concat(a))}e.prefixedBufferReadable=i;function l(s,r){return v.prefixedStream(s,r,a=>I.concat(a))}e.prefixedBufferStream=l}),define(Q[27],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function v(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=v;const L=/{(\d+)}/g;function M(G,...se){return se.length===0?G:G.replace(L,function(ce,we){const be=parseInt(we,10);return isNaN(be)||be<0||be>=se.length?ce:se[be]})}e.format=M;const D=/{([^}]+)}/g;function I(G,se){return G.replace(D,(ce,we)=>se[we]??ce)}e.format2=I;function n(G){return G.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=n;function f(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function w(G,se){let ce=0;const we=se.charCodeAt(0);for(let be=G.length-1;be>=0;be--)G.charCodeAt(be)===we&&ce++;return ce}e.count=w;function t(G,se,ce="\u2026"){return G.length<=se?G:`${G.substr(0,se)}${ce}`}e.truncate=t;function k(G,se=" "){const ce=b(G,se);return S(ce,se)}e.trim=k;function b(G,se){if(!G||!se)return G;const ce=se.length;if(ce===0||G.length===0)return G;let we=0;for(;G.indexOf(se,we)===we;)we=we+ce;return G.substring(we)}e.ltrim=b;function S(G,se){if(!G||!se)return G;const ce=se.length,we=G.length;if(ce===0||we===0)return G;let be=we,Le=-1;for(;Le=G.lastIndexOf(se,be-1),!(Le===-1||Le+ce!==be);){if(Le===0)return"";be=Le}return G.substring(0,be)}e.rtrim=S;function d(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function m(G){return G.replace(/\*/g,"")}e.stripWildcards=m;function E(G,se,ce={}){if(!G)throw new Error("Cannot create regex from empty string");se||(G=f(G)),ce.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let we="";return ce.global&&(we+="g"),ce.matchCase||(we+="i"),ce.multiline&&(we+="m"),ce.unicode&&(we+="u"),new RegExp(G,we)}e.createRegExp=E;function y(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function h(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=h;function o(G){return G.split(/\r\n|\r|\n/)}e.splitLines=o;function u(G){for(let se=0,ce=G.length;se<ce;se++){const we=G.charCodeAt(se);if(we!==32&&we!==9)return se}return-1}e.firstNonWhitespaceIndex=u;function i(G,se=0,ce=G.length){for(let we=se;we<ce;we++){const be=G.charCodeAt(we);if(be!==32&&be!==9)return G.substring(se,we)}return G.substring(se,ce)}e.getLeadingWhitespace=i;function l(G,se=G.length-1){for(let ce=se;ce>=0;ce--){const we=G.charCodeAt(ce);if(we!==32&&we!==9)return ce}return-1}e.lastNonWhitespaceIndex=l;function s(G,se){return G<se?-1:G>se?1:0}e.compare=s;function r(G,se,ce=0,we=G.length,be=0,Le=se.length){for(;ce<we&&be<Le;ce++,be++){let Ne=G.charCodeAt(ce),Be=se.charCodeAt(be);if(Ne<Be)return-1;if(Ne>Be)return 1}const Ue=we-ce,Fe=Le-be;return Ue<Fe?-1:Ue>Fe?1:0}e.compareSubstring=r;function a(G,se){return g(G,se,0,G.length,0,se.length)}e.compareIgnoreCase=a;function g(G,se,ce=0,we=G.length,be=0,Le=se.length){for(;ce<we&&be<Le;ce++,be++){let Ne=G.charCodeAt(ce),Be=se.charCodeAt(be);if(Ne===Be)continue;if(Ne>=128||Be>=128)return r(G.toLowerCase(),se.toLowerCase(),ce,we,be,Le);p(Ne)&&(Ne-=32),p(Be)&&(Be-=32);const ze=Ne-Be;if(ze!==0)return ze}const Ue=we-ce,Fe=Le-be;return Ue<Fe?-1:Ue>Fe?1:0}e.compareSubstringIgnoreCase=g;function p(G){return G>=97&&G<=122}e.isLowerAsciiLetter=p;function P(G){return G>=65&&G<=90}e.isUpperAsciiLetter=P;function R(G,se){return G.length===se.length&&g(G,se)===0}e.equalsIgnoreCase=R;function A(G,se){const ce=se.length;return se.length>G.length?!1:g(G,se,0,ce)===0}e.startsWithIgnoreCase=A;function W(G,se){let ce,we=Math.min(G.length,se.length);for(ce=0;ce<we;ce++)if(G.charCodeAt(ce)!==se.charCodeAt(ce))return ce;return we}e.commonPrefixLength=W;function j(G,se){let ce,we=Math.min(G.length,se.length);const be=G.length-1,Le=se.length-1;for(ce=0;ce<we;ce++)if(G.charCodeAt(be-ce)!==se.charCodeAt(Le-ce))return ce;return we}e.commonSuffixLength=j;function x(G){return 55296<=G&&G<=56319}e.isHighSurrogate=x;function re(G){return 56320<=G&&G<=57343}e.isLowSurrogate=re;function K(G,se){return(G-55296<<10)+(se-56320)+65536}e.computeCodePoint=K;function ee(G,se,ce){const we=G.charCodeAt(ce);if(x(we)&&ce+1<se){const be=G.charCodeAt(ce+1);if(re(be))return K(we,be)}return we}e.getNextCodePoint=ee;function F(G,se){const ce=G.charCodeAt(se-1);if(re(ce)&&se>1){const we=G.charCodeAt(se-2);if(x(we))return K(we,ce)}return ce}function H(G,se){const ce=Oe.getInstance(),we=se,be=G.length,Le=ee(G,be,se);se+=Le>=65536?2:1;let Ue=ce.getGraphemeBreakType(Le);for(;se<be;){const Fe=ee(G,be,se),Ne=ce.getGraphemeBreakType(Fe);if(Ae(Ue,Ne))break;se+=Fe>=65536?2:1,Ue=Ne}return se-we}e.nextCharLength=H;function z(G,se){const ce=Oe.getInstance(),we=se,be=F(G,se);se-=be>=65536?2:1;let Le=ce.getGraphemeBreakType(be);for(;se>0;){const Ue=F(G,se),Fe=ce.getGraphemeBreakType(Ue);if(Ae(Fe,Le))break;se-=Ue>=65536?2:1,Le=Fe}return we-se}e.prevCharLength=z;function B(G,se){const ce=Oe.getInstance(),we=G.length,be=se,Le=ee(G,we,se),Ue=ce.getGraphemeBreakType(Le);se+=Le>=65536?2:1;let Fe=Ue;for(;se<we;){const Be=ee(G,we,se),ze=ce.getGraphemeBreakType(Be);if(Ae(Fe,ze))break;se+=Be>=65536?2:1,Fe=ze}const Ne=se;for(se=be,Fe=Ue;se>0;){const Be=F(G,se),ze=ce.getGraphemeBreakType(Be);if(Ae(ze,Fe))break;se-=Be>=65536?2:1,Fe=ze}return[se,Ne]}function C(G,se){return se>0&&re(G.charCodeAt(se))?B(G,se-1):B(G,se)}e.getCharContainingOffset=C;const U=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(G){return U.test(G)}e.containsRTL=Y;const O=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function T(G){return O.test(G)}e.containsEmoji=T;const _=/^[\t\n\r\x20-\x7E]*$/;function q(G){return _.test(G)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=X;function $(G){for(let se=0,ce=G.length;se<ce;se++)if(N(G.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=$;function N(G){return G=+G,G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=N;function Z(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129003||G>=129280&&G<=129535||G>=129648&&G<=129750}e.isEmojiImprecise=Z;function ie(G,se){if(G.length<se)return G;const ce=/\b/g;let we=0;for(;ce.test(G)&&!(G.length-ce.lastIndex<se);)we=ce.lastIndex,ce.lastIndex+=1;return G.substring(we).replace(/^\s/,"")}e.lcut=ie;const oe=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,ne=/\x1b\[0?m/g;function ae(G){return G&&(G=G.replace(oe,""),G=G.replace(le,""),G=G.replace(ne,"")),G}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function de(G){return ue(G)?G.substr(1):G}e.stripUTF8BOM=de;function ve(G,se){if(!G||!se||G.length<se.length)return!1;const ce=se.length,we=G.toLowerCase();let be=0,Le=-1;for(;be<ce;){const Ue=we.indexOf(se[be],Le+1);if(Ue<0)return!1;Le=Ue,be++}return!0}e.fuzzyContains=ve;function Ie(G,se=!1){return G?(se&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Ie;function me(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=me;function ge(G,se=1){if(se===0)return"";let ce=-1;do ce=G.indexOf(`
`,ce+1),se--;while(se>0&&ce>=0);return ce===-1?G:(G[ce-1]==="\r"&&ce--,G.substr(0,ce))}e.getNLines=ge;function Ee(G){const se=90-65+1;return G=G%(2*se),G<se?String.fromCharCode(97+G):String.fromCharCode(65+G-se)}e.singleLetterHash=Ee;function ke(G){return Oe.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=ke;function Ae(G,se){return G===0?se!==5&&se!==7:G===2&&se===3?!1:G===4||G===2||G===3||se===4||se===2||se===3?!0:!(G===8&&(se===8||se===9||se===11||se===12)||(G===11||G===9)&&(se===9||se===10)||(G===12||G===10)&&se===10||se===5||se===13||se===7||G===1||G===13&&se===14||G===6&&se===6)}e.breakBetweenGraphemeBreakType=Ae;var We;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(We=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=Ye()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ce=this._data,we=ce.length/3;let be=1;for(;be<=we;)if(se<ce[3*be])be=2*be;else if(se>ce[3*be+1])be=2*be+1;else return ce[3*be+2];return 0}}Oe._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Xe(G,se){if(G===0)return 0;const ce=ct(G,se);if(ce!==void 0)return ce;const we=F(se,G);return G-=Ke(we),G}e.getLeftDeleteOffset=Xe;function ct(G,se){let ce=F(se,G);for(G-=Ke(ce);xe(ce)||ce===65039||ce===8419;){if(G===0)return;ce=F(se,G),G-=Ke(ce)}if(!!Z(ce)){if(G>=0){const we=F(se,G);we===8205&&(G-=Ke(we))}return G}}function Ke(G){return G>=65536?2:1}function xe(G){return 127995<=G&&G<=127999}var et;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={}))}),define(Q[81],J([0,1,27]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(y){return M(y,0)}e.hash=L;function M(y,c){switch(typeof y){case"object":return y===null?D(349,c):Array.isArray(y)?f(y,c):w(y,c);case"string":return n(y,c);case"boolean":return I(y,c);case"number":return D(y,c);case"undefined":return D(937,c);default:return D(617,c)}}e.doHash=M;function D(y,c){return(c<<5)-c+y|0}e.numberHash=D;function I(y,c){return D(y?433:863,c)}function n(y,c){c=D(149417,c);for(let h=0,o=y.length;h<o;h++)c=D(y.charCodeAt(h),c);return c}e.stringHash=n;function f(y,c){return c=D(104579,c),y.reduce((h,o)=>M(o,h),c)}function w(y,c){return c=D(181387,c),Object.keys(y).sort().reduce((h,o)=>(h=n(o,h),M(y[o],h)),c)}class t{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=M(c,this._value),this._value}}e.Hasher=t;var k;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function b(y,c,h=32){const o=h-c,u=~((1<<o)-1);return(y<<c|(u&y)>>>o)>>>0}function S(y,c=0,h=y.byteLength,o=0){for(let u=0;u<h;u++)y[c+u]=o}function d(y,c,h="0"){for(;y.length<c;)y=h+y;return y}function m(y,c=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((y>>>0).toString(16),c/4)}e.toHexString=m;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const h=c.length;if(h===0)return;const o=this._buff;let u=this._buffLen,i=this._leftoverHighSurrogate,l,s;for(i!==0?(l=i,s=-1,i=0):(l=c.charCodeAt(0),s=0);;){let r=l;if(v.isHighSurrogate(l))if(s+1<h){const a=c.charCodeAt(s+1);v.isLowSurrogate(a)?(s++,r=v.computeCodePoint(l,a)):r=65533}else{i=l;break}else v.isLowSurrogate(l)&&(r=65533);if(u=this._push(o,u,r),s++,s<h)l=c.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=i}_push(c,h,o){return o<128?c[h++]=o:o<2048?(c[h++]=192|(o&1984)>>>6,c[h++]=128|(o&63)>>>0):o<65536?(c[h++]=224|(o&61440)>>>12,c[h++]=128|(o&4032)>>>6,c[h++]=128|(o&63)>>>0):(c[h++]=240|(o&1835008)>>>18,c[h++]=128|(o&258048)>>>12,c[h++]=128|(o&4032)>>>6,c[h++]=128|(o&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=E._bigBlock32,h=this._buffDV;for(let p=0;p<64;p+=4)c.setUint32(p,h.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)c.setUint32(p,b(c.getUint32(p-12,!1)^c.getUint32(p-32,!1)^c.getUint32(p-56,!1)^c.getUint32(p-64,!1),1),!1);let o=this._h0,u=this._h1,i=this._h2,l=this._h3,s=this._h4,r,a,g;for(let p=0;p<80;p++)p<20?(r=u&i|~u&l,a=1518500249):p<40?(r=u^i^l,a=1859775393):p<60?(r=u&i|u&l|i&l,a=2400959708):(r=u^i^l,a=3395469782),g=b(o,5)+r+s+a+c.getUint32(p*4,!1)&4294967295,s=l,l=i,i=b(u,30),u=o,o=g;this._h0=this._h0+o&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[13],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(P){return Array.isArray(P)}e.isArray=v;function L(P){return typeof P=="string"}e.isString=L;function M(P){return Array.isArray(P)&&P.every(R=>L(R))}e.isStringArray=M;function D(P){return typeof P=="object"&&P!==null&&!Array.isArray(P)&&!(P instanceof RegExp)&&!(P instanceof Date)}e.isObject=D;function I(P){return typeof P=="number"&&!isNaN(P)}e.isNumber=I;function n(P){return!!P&&typeof P[Symbol.iterator]=="function"}e.isIterable=n;function f(P){return P===!0||P===!1}e.isBoolean=f;function w(P){return typeof P=="undefined"}e.isUndefined=w;function t(P){return!k(P)}e.isDefined=t;function k(P){return w(P)||P===null}e.isUndefinedOrNull=k;function b(P,R){if(!P)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=b;function S(P){if(k(P))throw new Error("Assertion Failed: argument is undefined or null");return P}e.assertIsDefined=S;function d(...P){const R=[];for(let A=0;A<P.length;A++){const W=P[A];if(k(W))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);R.push(W)}return R}e.assertAllDefined=d;const m=Object.prototype.hasOwnProperty;function E(P){if(!D(P))return!1;for(let R in P)if(m.call(P,R))return!1;return!0}e.isEmptyObject=E;function y(P){return typeof P=="function"}e.isFunction=y;function c(...P){return P.length>0&&P.every(y)}e.areFunctions=c;function h(P,R){const A=Math.min(P.length,R.length);for(let W=0;W<A;W++)o(P[W],R[W])}e.validateConstraints=h;function o(P,R){if(L(R)){if(typeof P!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(y(R)){try{if(P instanceof R)return}catch{}if(!k(P)&&P.constructor===R||R.length===1&&R.call(void 0,P)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function u(P){let R=[],A=Object.getPrototypeOf(P);for(;Object.prototype!==A;)R=R.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return R}e.getAllPropertyNames=u;function i(P){const R=[];for(const A of u(P))typeof P[A]=="function"&&R.push(A);return R}e.getAllMethodNames=i;function l(P,R){const A=j=>function(){const x=Array.prototype.slice.call(arguments,0);return R(j,x)};let W={};for(const j of P)W[j]=A(j);return W}e.createProxyObject=l;function s(P){return P===null?void 0:P}e.withNullAsUndefined=s;function r(P){return typeof P=="undefined"?null:P}e.withUndefinedAsNull=r;function a(P){return class{constructor(){return new Proxy({},{get(R,A){if(R[A])return R[A];throw new Error(`Not Implemented: ${P}->${String(A)}`)}})}}}e.NotImplementedProxy=a;function g(P,R="Unreachable"){throw new Error(R)}e.assertNever=g;function p(P){return!!P&&typeof P.then=="function"&&typeof P.catch=="function"}e.isPromise=p}),define(Q[33],J([0,1,8,3,27,13]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(s){return s===47||s===92}e.isPathSeparator=I;function n(s){return s.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=n;function f(s){return s.indexOf("/")===-1&&(s=n(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=f;function w(s,r=v.posix.sep){if(!s)return"";const a=s.length,g=s.charCodeAt(0);if(I(g)){if(I(s.charCodeAt(1))&&!I(s.charCodeAt(2))){let P=3;const R=P;for(;P<a&&!I(s.charCodeAt(P));P++);if(R!==P&&!I(s.charCodeAt(P+1))){for(P+=1;P<a;P++)if(I(s.charCodeAt(P)))return s.slice(0,P+1).replace(/[\\/]/g,r)}}return r}else if(y(g)&&s.charCodeAt(1)===58)return I(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<a;p++)if(I(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=w;function t(s){if(!L.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let a=2;const g=a;for(;a<s.length&&(r=s.charCodeAt(a),r!==92);a++);return!(g===a||(r=s.charCodeAt(a+1),isNaN(r)||r===92))}e.isUNC=t;const k=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,r=L.isWindows){const a=r?k:b;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||r&&S.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function m(s,r,a){const g=s===r;return!a||g?g:!s||!r?!1:(0,M.equalsIgnoreCase)(s,r)}e.isEqual=m;function E(s,r,a,g=v.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(a){if(!(0,M.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let P=r.length;return r.charAt(r.length-1)===g&&P--,s.charAt(P)===g}return r.charAt(r.length-1)!==g&&(r+=g),s.indexOf(r)===0}e.isEqualOrParent=E;function y(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=y;function c(s,r){return L.isWindows&&s.endsWith(":")&&(s+=v.sep),(0,v.isAbsolute)(s)||(s=(0,v.join)(r,s)),s=(0,v.normalize)(s),L.isWindows?(s=(0,M.rtrim)(s,v.sep),s.endsWith(":")&&(s+=v.sep)):(s=(0,M.rtrim)(s,v.sep),s||(s=v.sep)),s}e.sanitizeFilePath=c;function h(s){const r=(0,v.normalize)(s);return L.isWindows?s.length>3?!1:o(r)&&(s.length===2||r.charCodeAt(2)===92):r===v.posix.sep}e.isRootOrDriveLetter=h;function o(s){return L.isWindows?y(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function u(s){return o(s)?s[0]:void 0}e.getDriveLetter=u;function i(s,r,a){return r.length>s.length?-1:s===r?0:(a&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=i;function l(s){const r=s.split(":");let a,g,p;if(r.forEach(P=>{const R=Number(P);(0,D.isNumber)(R)?g===void 0?g=R:p===void 0&&(p=R):a=a?[a,P].join(":"):P}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:g!==void 0?g:void 0,column:p!==void 0?p:g!==void 0?1:void 0}}e.parseLineAndColumnAware=l}),define(Q[43],J([0,1,13]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const E=Array.isArray(m)?[]:{};return Object.keys(m).forEach(y=>{m[y]&&typeof m[y]=="object"?E[y]=L(m[y]):E[y]=m[y]}),E}e.deepClone=L;function M(m){if(!m||typeof m!="object")return m;const E=[m];for(;E.length>0;){const y=E.shift();Object.freeze(y);for(const c in y)if(D.call(y,c)){const h=y[c];typeof h=="object"&&!Object.isFrozen(h)&&E.push(h)}}return m}e.deepFreeze=M;const D=Object.prototype.hasOwnProperty;function I(m,E){return n(m,E,new Set)}e.cloneAndChange=I;function n(m,E,y){if((0,v.isUndefinedOrNull)(m))return m;const c=E(m);if(typeof c!="undefined")return c;if((0,v.isArray)(m)){const h=[];for(const o of m)h.push(n(o,E,y));return h}if((0,v.isObject)(m)){if(y.has(m))throw new Error("Cannot clone recursive data-structure");y.add(m);const h={};for(let o in m)D.call(m,o)&&(h[o]=n(m[o],E,y));return y.delete(m),h}return m}function f(m,E,y=!0){return(0,v.isObject)(m)?((0,v.isObject)(E)&&Object.keys(E).forEach(c=>{c in m?y&&((0,v.isObject)(m[c])&&(0,v.isObject)(E[c])?f(m[c],E[c],y):m[c]=E[c]):m[c]=E[c]}),m):E}e.mixin=f;function w(m,E){if(m===E)return!0;if(m==null||E===null||E===void 0||typeof m!=typeof E||typeof m!="object"||Array.isArray(m)!==Array.isArray(E))return!1;let y,c;if(Array.isArray(m)){if(m.length!==E.length)return!1;for(y=0;y<m.length;y++)if(!w(m[y],E[y]))return!1}else{const h=[];for(c in m)h.push(c);h.sort();const o=[];for(c in E)o.push(c);if(o.sort(),!w(h,o))return!1;for(y=0;y<h.length;y++)if(!w(m[h[y]],E[h[y]]))return!1}return!0}e.equals=w;function t(m){const E=new Set;return JSON.stringify(m,(y,c)=>{if((0,v.isObject)(c)||Array.isArray(c)){if(E.has(c))return"[Circular]";E.add(c)}return c})}e.safeStringify=t;function k(m,E,y){const c=E(m);return typeof c=="undefined"?y:c}e.getOrDefault=k;function b(m,E){const y=Object.create(null);return!m||!E||Object.keys(E).forEach(h=>{const o=m[h],u=E[h];w(o,u)||(y[h]=u)}),y}e.distinct=b;function S(m,E){const y=E.toLowerCase(),c=Object.keys(m).find(h=>h.toLowerCase()===y);return c?m[c]:m[E]}e.getCaseInsensitive=S;function d(m,E){const y=Object.create(null);for(const c of Object.keys(m))E(c,m[c])&&(y[c]=m[c]);return y}e.filter=d}),define(Q[7],J([0,1,8,3]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const M=/^\w[\w\d+.-]*$/,D=/^\//,I=/^\/\//;function n(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!M.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!D.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(s,r){return!s&&!r?"file":s}function w(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==k&&(r=k+r):r=k;break}return r}const t="",k="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(r,a,g,p,P,R=!1){typeof r=="object"?(this.scheme=r.scheme||t,this.authority=r.authority||t,this.path=r.path||t,this.query=r.query||t,this.fragment=r.fragment||t):(this.scheme=f(r,R),this.authority=a||t,this.path=w(this.scheme,g||t),this.query=p||t,this.fragment=P||t,n(this,R))}static isUri(r){return r instanceof S?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return h(this,!1)}with(r){if(!r)return this;let{scheme:a,authority:g,path:p,query:P,fragment:R}=r;return a===void 0?a=this.scheme:a===null&&(a=t),g===void 0?g=this.authority:g===null&&(g=t),p===void 0?p=this.path:p===null&&(p=t),P===void 0?P=this.query:P===null&&(P=t),R===void 0?R=this.fragment:R===null&&(R=t),a===this.scheme&&g===this.authority&&p===this.path&&P===this.query&&R===this.fragment?this:new m(a,g,p,P,R)}static parse(r,a=!1){const g=b.exec(r);return g?new m(g[2]||t,l(g[4]||t),l(g[5]||t),l(g[7]||t),l(g[9]||t),a):new m(t,t,t,t,t)}static file(r){let a=t;if(L.isWindows&&(r=r.replace(/\\/g,k)),r[0]===k&&r[1]===k){const g=r.indexOf(k,2);g===-1?(a=r.substring(2),r=k):(a=r.substring(2,g),r=r.substring(g)||k)}return new m("file",a,r,t,t)}static from(r){const a=new m(r.scheme,r.authority,r.path,r.query,r.fragment);return n(a,!0),a}static joinPath(r,...a){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return L.isWindows&&r.scheme==="file"?g=S.file(v.win32.join(h(r,!0),...a)).path:g=v.posix.join(r.path,...a),r.with({path:g})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof S)return r;{const a=new m(r);return a._formatted=r.external,a._fsPath=r._sep===d?r.fsPath:null,a}}else return r}}e.URI=S;const d=L.isWindows?1:void 0;class m extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=d),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(s,r){let a,g=-1;for(let p=0;p<s.length;p++){const P=s.charCodeAt(p);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||r&&P===47)g!==-1&&(a+=encodeURIComponent(s.substring(g,p)),g=-1),a!==void 0&&(a+=s.charAt(p));else{a===void 0&&(a=s.substr(0,p));const R=E[P];R!==void 0?(g!==-1&&(a+=encodeURIComponent(s.substring(g,p)),g=-1),a+=R):g===-1&&(g=p)}}return g!==-1&&(a+=encodeURIComponent(s.substring(g))),a!==void 0?a:s}function c(s){let r;for(let a=0;a<s.length;a++){const g=s.charCodeAt(a);g===35||g===63?(r===void 0&&(r=s.substr(0,a)),r+=E[g]):r!==void 0&&(r+=s[a])}return r!==void 0?r:s}function h(s,r){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=h;function o(s,r){const a=r?c:y;let g="",{scheme:p,authority:P,path:R,query:A,fragment:W}=s;if(p&&(g+=p,g+=":"),(P||p==="file")&&(g+=k,g+=k),P){let j=P.indexOf("@");if(j!==-1){const x=P.substr(0,j);P=P.substr(j+1),j=x.indexOf(":"),j===-1?g+=a(x,!1):(g+=a(x.substr(0,j),!1),g+=":",g+=a(x.substr(j+1),!1)),g+="@"}P=P.toLowerCase(),j=P.indexOf(":"),j===-1?g+=a(P,!1):(g+=a(P.substr(0,j),!1),g+=P.substr(j))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const j=R.charCodeAt(1);j>=65&&j<=90&&(R=`/${String.fromCharCode(j+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const j=R.charCodeAt(0);j>=65&&j<=90&&(R=`${String.fromCharCode(j+32)}:${R.substr(2)}`)}g+=a(R,!0)}return A&&(g+="?",g+=a(A,!1)),W&&(g+="#",g+=r?W:y(W,!1)),g}function u(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(s){return s.match(i)?s.replace(i,r=>u(r)):s}}),define(Q[108],J([0,1,7]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const t=w;return t&&typeof t.type=="string"&&typeof t.severity=="string"}e.isRemoteConsoleLog=L;function M(w){const t=[];let k;try{const b=JSON.parse(w.arguments),S=b[b.length-1];S&&S.__$stack&&(b.pop(),k=S.__$stack),t.push(...b)}catch(b){t.push("Unable to log remote console arguments",w.arguments)}return{args:t,stack:k}}e.parse=M;function D(w){if(typeof w!="string")return D(M(w).stack);const t=w;if(t){const k=I(t),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(b&&b.length===4)return{uri:v.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=D;function I(w){if(!w)return w;const t=w.indexOf(`
`);return t===-1?w:w.substring(0,t)}function n(w,t){const{args:k,stack:b}=M(w),S=typeof k[0]=="string"&&k.length===1;let d=I(b);d&&(d=`(${d.trim()})`);let m=[];if(typeof k[0]=="string"?d&&S?m=[`%c[${t}] %c${k[0]} %c${d}`,f("blue"),f(""),f("grey")]:m=[`%c[${t}] %c${k[0]}`,f("blue"),f(""),...k.slice(1)]:m=[`%c[${t}]%`,f("blue"),...k],d&&!S&&m.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,m)}e.log=n;function f(w){return`color: ${w}`}});var bt=this&&this.__classPrivateFieldSet||function(V,e,v,L,M){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!M)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!M:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?M.call(V,v):M?M.value=v:e.set(V,v),v},je=this&&this.__classPrivateFieldGet||function(V,e,v,L){if(v==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!L:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?L:v==="a"?L.call(V):L?L.value:e.get(V)};define(Q[40],J([0,1,30,27,7]),function(V,e,v,L,M){"use strict";var D,I,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(s,r,a){let g=s.get(r);return g===void 0&&(g=a,s.set(r,g)),g}e.getOrSet=f;function w(s){const r=[];return s.forEach((a,g)=>{r.push(`${g} => ${a}`)}),`Map(${s.size}) {${r.join(", ")}}`}e.mapToString=w;function t(s){const r=[];return s.forEach(a=>{r.push(a)}),`Set(${s.size}) {${r.join(", ")}}`}e.setToString=t;class k{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const a=r.charCodeAt(0),g=this._value.charCodeAt(this._pos);return a-g}value(){return this._value[this._pos]}}e.StringIterator=k;class b{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class S{constructor(r=!0,a=!0){this._splitOnBackslash=r,this._caseSensitive=a}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var d;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(d||(d={}));class m{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(y||(y={}));class c{constructor(r){this._iter=r}static forUris(r=()=>!1){return new c(new m(r))}static forPaths(){return new c(new S)}static forStrings(){return new c(new k)}static forConfigKeys(){return new c(new b)}clear(){this._root=void 0}fill(r,a){if(a){const g=a.slice(0);(0,v.shuffle)(g);for(let p of g)this.set(p,r)}else{const g=r.slice(0);(0,v.shuffle)(g);for(let p of g)this.set(p[0],p[1])}}set(r,a){const g=this._iter.reset(r);let p;this._root||(this._root=new E,this._root.segment=g.value());const P=[];for(p=this._root;;){const A=g.cmp(p.segment);if(A>0)p.left||(p.left=new E,p.left.segment=g.value()),P.push([-1,p]),p=p.left;else if(A<0)p.right||(p.right=new E,p.right.segment=g.value()),P.push([1,p]),p=p.right;else if(g.hasNext())g.next(),p.mid||(p.mid=new E,p.mid.segment=g.value()),P.push([0,p]),p=p.mid;else break}const R=p.value;p.value=a,p.key=r;for(let A=P.length-1;A>=0;A--){const W=P[A][1];W.updateHeight();const j=W.balanceFactor();if(j<-1||j>1){const x=P[A][0],re=P[A+1][0];if(x===1&&re===1)P[A][1]=W.rotateLeft();else if(x===-1&&re===-1)P[A][1]=W.rotateRight();else if(x===1&&re===-1)W.right=P[A+1][1]=P[A+1][1].rotateRight(),P[A][1]=W.rotateLeft();else if(x===-1&&re===1)W.left=P[A+1][1]=P[A+1][1].rotateLeft(),P[A][1]=W.rotateRight();else throw new Error;if(A>0)switch(P[A-1][0]){case-1:P[A-1][1].left=P[A][1];break;case 1:P[A-1][1].right=P[A][1];break;case 0:P[A-1][1].mid=P[A][1];break}else this._root=P[0][1]}}return R}get(r){return this._getNode(r)?.value}_getNode(r){const a=this._iter.reset(r);let g=this._root;for(;g;){const p=a.cmp(g.segment);if(p>0)g=g.left;else if(p<0)g=g.right;else if(a.hasNext())a.next(),g=g.mid;else break}return g}has(r){const a=this._getNode(r);return!(a?.value===void 0&&a?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,a){const g=this._iter.reset(r),p=[];let P=this._root;for(;P;){const R=g.cmp(P.segment);if(R>0)p.push([-1,P]),P=P.left;else if(R<0)p.push([1,P]),P=P.right;else if(g.hasNext())g.next(),p.push([0,P]),P=P.mid;else break}if(!!P){if(a?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const R=this._min(P.right),{key:A,value:W,segment:j}=R;this._delete(R.key,!1),P.key=A,P.value=W,P.segment=j}else{const R=P.left??P.right;if(p.length>0){const[A,W]=p[p.length-1];switch(A){case-1:W.left=R;break;case 0:W.mid=R;break;case 1:W.right=R;break}}else this._root=R}for(let R=p.length-1;R>=0;R--){const A=p[R][1];A.updateHeight();const W=A.balanceFactor();if(W>1?(A.right.balanceFactor()>=0||(A.right=p[R+1][1]=p[R+1][1].rotateRight()),p[R][1]=A.rotateLeft()):W<-1&&(A.left.balanceFactor()<=0||(A.left=p[R+1][1]=p[R+1][1].rotateLeft()),p[R][1]=A.rotateRight()),R>0)switch(p[R-1][0]){case-1:p[R-1][1].left=p[R][1];break;case 1:p[R-1][1].right=p[R][1];break;case 0:p[R-1][1].mid=p[R][1];break}else this._root=p[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const a=this._iter.reset(r);let g=this._root,p;for(;g;){const P=a.cmp(g.segment);if(P>0)g=g.left;else if(P<0)g=g.right;else if(a.hasNext())a.next(),p=g.value||p,g=g.mid;else break}return g&&g.value||p}findSuperstr(r){const a=this._iter.reset(r);let g=this._root;for(;g;){const p=a.cmp(g.segment);if(p>0)g=g.left;else if(p<0)g=g.right;else if(a.hasNext())a.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(r){for(const[a,g]of this)r(g,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=a=>{if(!a)return!0;const g=a.balanceFactor();return g<-1||g>1?!1:r(a.left)&&r(a.right)};return r(this._root)}}e.TernarySearchTree=c;class h{constructor(r,a){this[D]="ResourceMap",r instanceof h?(this.map=new Map(r.map),this.toKey=a??h.defaultToKey):(this.map=new Map,this.toKey=r??h.defaultToKey)}set(r,a){return this.map.set(this.toKey(r),a),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,a){typeof a!="undefined"&&(r=r.bind(a));for(let[g,p]of this.map)r(p,M.URI.parse(g),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield M.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[M.URI.parse(r[0]),r[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[M.URI.parse(r[0]),r[1]]}}e.ResourceMap=h,h.defaultToKey=s=>s.toString();var o;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class u{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,a=0){const g=this._map.get(r);if(!!g)return a!==0&&this.touch(g,a),g.value}set(r,a,g=0){let p=this._map.get(r);if(p)p.value=a,g!==0&&this.touch(p,g);else{switch(p={key:r,value:a,next:void 0,previous:void 0},g){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(r,p),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this._map.get(r);if(!!a)return this._map.delete(r),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,a){const g=this._state;let p=this._head;for(;p;){if(a?r.bind(a)(p.value,p.key,this):r(p.value,p.key,this),this._state!==g)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const r=this,a=this._state;let g=this._head;const p={[Symbol.iterator](){return p},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(g){const P={value:g.key,done:!1};return g=g.next,P}else return{value:void 0,done:!0}}};return p}values(){const r=this,a=this._state;let g=this._head;const p={[Symbol.iterator](){return p},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(g){const P={value:g.value,done:!1};return g=g.next,P}else return{value:void 0,done:!0}}};return p}entries(){const r=this,a=this._state;let g=this._head;const p={[Symbol.iterator](){return p},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(g){const P={value:[g.key,g.value],done:!1};return g=g.next,P}else return{value:void 0,done:!0}}};return p}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this._head,g=this.size;for(;a&&g>r;)this._map.delete(a.key),a=a.next,g--;this._head=a,this._size=g,a&&(a.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const a=r.next,g=r.previous;if(!a||!g)throw new Error("Invalid list");a.previous=g,g.next=a}r.next=void 0,r.previous=void 0,this._state++}touch(r,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this._head)return;const g=r.next,p=r.previous;r===this._tail?(p.next=void 0,this._tail=p):(g.previous=p,p.next=g),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(a===2){if(r===this._tail)return;const g=r.next,p=r.previous;r===this._head?(g.previous=void 0,this._head=g):(g.previous=p,p.next=g),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((a,g)=>{r.push([g,a])}),r}fromJSON(r){this.clear();for(const[a,g]of r)this.set(a,g)}}e.LinkedMap=u;class i extends u{constructor(r,a=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class l{constructor(r){n.set(this,void 0),bt(this,n,r,"f")}get size(){return je(this,n,"f").size}forEach(r,a){je(this,n,"f").forEach(r,a)}get(r){return je(this,n,"f").get(r)}has(r){return je(this,n,"f").has(r)}entries(){return je(this,n,"f").entries()}keys(){return je(this,n,"f").keys()}values(){return je(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return je(this,n,"f").entries()}}e.ReadonlyMapView=l}),define(Q[109],J([0,1,18,27,7]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function D(t){return JSON.stringify(t,f)}e.stringify=D;function I(t){let k=JSON.parse(t);return k=w(k),k}e.parse=I;var n;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function f(t,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,L.regExpFlags)(k)}:k}function w(t,k=0){if(!t||k>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return M.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof v.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let b=0;b<t.length;++b)t[b]=w(t[b],k+1);else for(const b in t)Object.hasOwnProperty.call(t,b)&&(t[b]=w(t[b],k+1))}return t}e.revive=w}),define(Q[10],J([0,1,3,7]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var M;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(M=e.Schemas||(e.Schemas={}));class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,w,t){this._hosts[f]=w,this._ports[f]=t}setConnectionToken(f,w){this._connectionTokens[f]=w}rewrite(f){if(this._delegate)return this._delegate(f);const w=f.authority;let t=this._hosts[w];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const k=this._ports[w],b=this._connectionTokens[w];let S=`path=${encodeURIComponent(f.path)}`;return typeof b=="string"&&(S+=`&tkn=${encodeURIComponent(b)}`),L.URI.from({scheme:v.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${t}:${k}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new D;class I{asBrowserUri(f,w){const t=this.toUri(f,w);return t.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===M.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${M.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?t.with({scheme:M.vscodeFileResource,authority:t.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(f,w){const t=this.toUri(f,w);return t.scheme===M.vscodeFileResource?t.with({scheme:M.file,authority:t.authority!==I.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(f,w){return L.URI.isUri(f)?f:L.URI.parse(w.toUrl(f))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I}),define(Q[68],J([0,1,40]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new v.LRUCache(1e4);function M(w){return f(w,"NFC",L)}e.normalizeNFC=M;const D=new v.LRUCache(1e4);function I(w){return f(w,"NFD",D)}e.normalizeNFD=I;const n=/[^\u0000-\u0080]/;function f(w,t,k){if(!w)return w;const b=k.get(w);if(b)return b;let S;return n.test(w)?S=w.normalize(t):S=w,k.set(w,S),S}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(t){return I(t).replace(w,"")}}()}),define(Q[15],J([0,1,33,10,8,3,27,7]),function(V,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(S){return(0,n.uriToFsPath)(S,!0)}e.originalFSPath=f;class w{constructor(d){this._ignorePathCasing=d}compare(d,m,E=!1){return d===m?0:(0,I.compare)(this.getComparisonKey(d,E),this.getComparisonKey(m,E))}isEqual(d,m,E=!1){return d===m?!0:!d||!m?!1:this.getComparisonKey(d,E)===this.getComparisonKey(m,E)}getComparisonKey(d,m=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,m,E=!1){if(d.scheme===m.scheme){if(d.scheme===L.Schemas.file)return v.isEqualOrParent(f(d),f(m),this._ignorePathCasing(d))&&d.query===m.query&&(E||d.fragment===m.fragment);if((0,e.isEqualAuthority)(d.authority,m.authority))return v.isEqualOrParent(d.path,m.path,this._ignorePathCasing(d),"/")&&d.query===m.query&&(E||d.fragment===m.fragment)}return!1}joinPath(d,...m){return n.URI.joinPath(d,...m)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return M.posix.basename(d.path)}extname(d){return M.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let m;return d.scheme===L.Schemas.file?m=n.URI.file(M.dirname(f(d))).path:(m=M.posix.dirname(d.path),d.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),m="/")),d.with({path:m})}normalizePath(d){if(!d.path.length)return d;let m;return d.scheme===L.Schemas.file?m=n.URI.file(M.normalize(f(d))).path:m=M.posix.normalize(d.path),d.with({path:m})}relativePath(d,m){if(d.scheme!==m.scheme||!(0,e.isEqualAuthority)(d.authority,m.authority))return;if(d.scheme===L.Schemas.file){const c=M.relative(f(d),f(m));return D.isWindows?v.toSlashes(c):c}let E=d.path||"/",y=m.path||"/";if(this._ignorePathCasing(d)){let c=0;for(const h=Math.min(E.length,y.length);c<h&&!(E.charCodeAt(c)!==y.charCodeAt(c)&&E.charAt(c).toLowerCase()!==y.charAt(c).toLowerCase());c++);E=y.substr(0,c)+E.substr(c)}return M.posix.relative(E,y)}resolvePath(d,m){if(d.scheme===L.Schemas.file){const E=n.URI.file(M.resolve(f(d),m));return d.with({authority:E.authority,path:E.path})}return m=v.toPosixPath(m),d.with({path:M.posix.resolve(d.path,m)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,m){return d===m||(0,I.equalsIgnoreCase)(d,m)}hasTrailingPathSeparator(d,m=M.sep){if(d.scheme===L.Schemas.file){const E=f(d);return E.length>v.getRoot(E).length&&E[E.length-1]===m}else{const E=d.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,m=M.sep){return(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,m=M.sep){let E=!1;if(d.scheme===L.Schemas.file){const y=f(d);E=y!==void 0&&y.length===v.getRoot(y).length&&y[y.length-1]===m}else{m="/";const y=d.path;E=y.length===1&&y.charCodeAt(y.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(S=>S.scheme===L.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new w(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(S,d){const m=[];for(let E=0;E<S.length;E++){const y=d(S[E]);S.some((c,h)=>h===E?!1:(0,e.isEqualOrParent)(y,d(c)))||m.push(S[E])}return m}e.distinctParents=t;var k;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function d(m){const E=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(h=>{const[o,u]=h.split(":");o&&u&&E.set(o,u)});const c=m.path.substring(0,m.path.indexOf(";"));return c&&E.set(S.META_DATA_MIME,c),E}S.parseMetaData=d})(k=e.DataUri||(e.DataUri={}));function b(S,d,m){if(d){let E=S.path;return E&&E[0]!==M.posix.sep&&(E=M.posix.sep+E),S.with({scheme:m,authority:d,path:E})}return S.with({scheme:m})}e.toLocalResource=b}),define(Q[9],J([0,1,23,17,4,2,15]),function(V,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n(z){return!!z&&typeof z.then=="function"}e.isThenable=n;function f(z){const B=new v.CancellationTokenSource,C=z(B.token),U=new Promise((Y,O)=>{const T=B.token.onCancellationRequested(()=>{T.dispose(),B.dispose(),O((0,L.canceled)())});Promise.resolve(C).then(_=>{T.dispose(),B.dispose(),Y(_)},_=>{T.dispose(),B.dispose(),O(_)})});return new class{cancel(){B.cancel()}then(Y,O){return U.then(Y,O)}catch(Y){return this.then(void 0,Y)}finally(Y){return U.finally(Y)}}}e.createCancelablePromise=f;function w(z,B,C){return Promise.race([z,new Promise(U=>B.onCancellationRequested(()=>U(C)))])}e.raceCancellation=w;async function t(z){let B=-1;const C=z.map((Y,O)=>Y.then(T=>(B=O,T))),U=await Promise.race(C);return z.forEach((Y,O)=>{O!==B&&Y.cancel()}),U}e.raceCancellablePromises=t;function k(z,B,C){let U;const Y=setTimeout(()=>{U?.(void 0),C?.()},B);return Promise.race([z.finally(()=>clearTimeout(Y)),new Promise(O=>U=O)])}e.raceTimeout=k;function b(z){return new Promise((B,C)=>{const U=z();n(U)?U.then(B,C):B(U)})}e.asPromise=b;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const C=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(C,C).then(U)})}return new Promise((C,U)=>{this.queuedPromise.then(C,U)})}return this.activePromise=B(),new Promise((C,U)=>{this.activePromise.then(Y=>{this.activePromise=null,C(Y)},Y=>{this.activePromise=null,U(Y)})})}}e.Throttler=S;class d{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=d;class m{constructor(){this.promiseMap=new Map}queue(B,C){const Y=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(C).finally(()=>{this.promiseMap.get(B)===Y&&this.promiseMap.delete(B)});return this.promiseMap.set(B,Y),Y}}e.SequencerByKey=m;class E{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,C=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,Y)=>{this.doResolve=U,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},C),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=E;class y{constructor(B){this.delayer=new E(B),this.throttler=new S}trigger(B,C){return this.delayer.trigger(()=>this.throttler.queue(B),C)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=y;class c{constructor(){this._isOpen=!1,this._promise=new Promise((B,C)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class h extends c{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function o(z,B){return B?new Promise((C,U)=>{const Y=setTimeout(()=>{O.dispose(),C()},z),O=B.onCancellationRequested(()=>{clearTimeout(Y),O.dispose(),U((0,L.canceled)())})}):f(C=>o(z,C))}e.timeout=o;function u(z,B=0){const C=setTimeout(z,B);return(0,D.toDisposable)(()=>clearTimeout(C))}e.disposableTimeout=u;function i(z){const B=[];let C=0;const U=z.length;function Y(){return C<U?z[C++]():null}function O(T){T!=null&&B.push(T);const _=Y();return _?_.then(O):Promise.resolve(B)}return Promise.resolve(null).then(O)}e.sequence=i;function l(z,B=U=>!!U,C=null){let U=0;const Y=z.length,O=()=>{if(U>=Y)return Promise.resolve(C);const T=z[U++];return Promise.resolve(T()).then(q=>B(q)?Promise.resolve(q):O())};return O()}e.first=l;function s(z,B=U=>!!U,C=null){if(z.length===0)return Promise.resolve(C);let U=z.length;const Y=()=>{U=-1;for(const O of z)O.cancel?.()};return new Promise((O,T)=>{for(const _ of z)_.then(q=>{--U>=0&&B(q)?(Y(),O(q)):U===0&&O(C)}).catch(q=>{--U>=0&&(Y(),T(q))})})}e.firstParallel=s;class r{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new M.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((C,U)=>{this.outstandingPromises.push({factory:B,c:C,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const C=B.factory();C.then(B.c,B.e),C.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class a extends r{constructor(){super(1)}}e.Queue=a;class g{constructor(){this.queues=new Map}queueFor(B,C=I.extUri){const U=C.getComparisonKey(B);let Y=this.queues.get(U);return Y||(Y=new a,M.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(U)}),this.queues.set(U,Y)),Y}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=g;class p{constructor(B,C){this._token=-1,typeof B=="function"&&typeof C=="number"&&this.setIfNotSet(B,C)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,C){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},C)}setIfNotSet(B,C){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},C))}}e.TimeoutTimer=p;class P{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,C){this.cancel(),this._token=setInterval(()=>{B()},C)}}e.IntervalTimer=P;class R{constructor(B,C){this.timeoutToken=-1,this.runner=B,this.timeout=C,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class A{constructor(B,C){C%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=C,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class W extends R{constructor(B,C){super(B,C);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class j extends D.Disposable{constructor(B,C,U,Y){super();this.maxWorkChunkSize=B,this.maxPendingWork=C,this.throttleDelay=U,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=j,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=z=>{const B=setTimeout(()=>{const U=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let C=!1;return{dispose(){C||(C=!0,clearTimeout(B))}}}:e.runWhenIdle=(z,B)=>{const C=requestIdleCallback(z,typeof B=="number"?{timeout:B}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(C))}}}}();class x{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(C){this._error=C}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function re(z,B,C){let U;for(let Y=0;Y<C;Y++)try{return await z()}catch(O){U=O,await o(B)}throw U}e.retry=re;class K{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,C,U){return this._pending={taskId:B,cancel:()=>U?.(),promise:C},C.then(()=>this.donePending(B),()=>this.donePending(B)),C}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let C,U;const Y=new Promise((O,T)=>{C=O,U=T});this._next={run:B,promise:Y,promiseResolve:C,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=K;class ee{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,C)=>{this.completeCallback=B,this.errorCallback=C})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(C=>{this.completeCallback(B),this.resolved=!0,C()})}error(B){return new Promise(C=>{this.errorCallback(B),this.rejected=!0,C()})}cancel(){new Promise(B=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=F;var H;(function(z){async function B(U){let Y;const O=await Promise.all(U.map(T=>T.then(_=>_,_=>{Y||(Y=_)})));if(typeof Y!="undefined")throw Y;return O}z.settled=B;function C(U){return new Promise(async(Y,O)=>{try{await U(Y,O)}catch(T){O(T)}})}z.withAsyncBody=C})(H=e.Promises||(e.Promises={}))}),define(Q[34],J([0,1,33,10,8,3,15,27,7]),function(V,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(r,a,g){if(typeof r=="string"&&(r=f.URI.file(r)),g){const P=g.getWorkspaceFolder(r);if(P){const R=g.getWorkspace().folders.length>1;let A;if((0,I.isEqual)(P.uri,r)?A="":A=(0,I.relativePath)(P.uri,r),R){const W=P.name?P.name:(0,I.basename)(P.uri);A=A?W+" \u2022 "+A:W}return A}}if(r.scheme!==L.Schemas.file&&r.scheme!==L.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(r.fsPath))return(0,M.normalize)(k(r.fsPath));let p=(0,M.normalize)(r.fsPath);return!D.isWindows&&a?.userHome&&(p=S(p,a.userHome.fsPath)),p}e.getPathLabel=w;function t(r){if(!r)return;typeof r=="string"&&(r=f.URI.file(r));const a=(0,I.basename)(r)||(r.scheme===L.Schemas.file?r.fsPath:r.path);return D.isWindows&&(0,v.isRootOrDriveLetter)(a)?k(a):a}e.getBaseLabel=t;function k(r){return(0,v.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=k;let b=Object.create(null);function S(r,a){if(D.isWindows||!r||!a)return r;let g=b.original===a?b.normalized:void 0;return g||(g=`${(0,n.rtrim)(a,M.posix.sep)}${M.posix.sep}`,b={original:a,normalized:g}),(D.isLinux?r.startsWith(g):(0,n.startsWithIgnoreCase)(r,g))&&(r=`~/${r.substr(g.length)}`),r}e.tildify=S;function d(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=d;const m="\u2026",E="\\\\",y="~";function c(r,a=M.sep){const g=new Array(r.length);let p=!1;for(let P=0;P<r.length;P++){let R=r[P];if(R===""){g[P]=`.${a}`;continue}if(!R){g[P]=R;continue}p=!0;let A="";R.indexOf(E)===0?(A=R.substr(0,R.indexOf(E)+E.length),R=R.substr(R.indexOf(E)+E.length)):R.indexOf(a)===0?(A=R.substr(0,R.indexOf(a)+a.length),R=R.substr(R.indexOf(a)+a.length)):R.indexOf(y)===0&&(A=R.substr(0,R.indexOf(y)+y.length),R=R.substr(R.indexOf(y)+y.length));const W=R.split(a);for(let j=1;p&&j<=W.length;j++)for(let x=W.length-j;p&&x>=0;x--){p=!1;let re=W.slice(x,x+j).join(a);for(let K=0;!p&&K<r.length;K++)if(K!==P&&r[K]&&r[K].indexOf(re)>-1){const ee=x+j===W.length,F=x>0&&r[K].indexOf(a)>-1?a+re:re,H=r[K].endsWith(F);p=!ee||H}if(!p){let K="";(W[0].endsWith(":")||A!=="")&&(x===1&&(x=0,j++,re=W[0]+a+re),x>0&&(K=W[0]+a),K=A+K),x>0&&(K=K+m+a),K=K+re,x+j<W.length&&(K=K+a+m),g[P]=K}}p&&(g[P]=R)}return g}e.shorten=c;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(r,a=Object.create(null)){const g=[];let p=!1,P="";for(const R of r)if(R==="$"||p&&R==="{")P&&g.push({value:P,type:h.TEXT}),P="",p=!0;else if(R==="}"&&p){const A=a[P];if(typeof A=="string")A.length&&g.push({value:A,type:h.VARIABLE});else if(A){const W=g[g.length-1];(!W||W.type!==h.SEPARATOR)&&g.push({value:A.label,type:h.SEPARATOR})}P="",p=!1}else P+=R;return P&&!p&&g.push({value:P,type:h.TEXT}),g.filter((R,A)=>{if(R.type===h.SEPARATOR){const W=g[A-1],j=g[A+1];return[W,j].every(x=>x&&(x.type===h.VARIABLE||x.type===h.TEXT)&&x.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function u(r,a){return D.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):r.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function i(r,a){return D.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):D.isWindows?r.replace(/&&|&/g,g=>g==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function l(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=l;function s(r){const a=r.indexOf("/")!==-1?M.posix:M.win32,g=a.basename(r),p=a.dirname(r);return g.length?{name:g,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(Q[28],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return v.test(f)}e.isUUID=L;const M=new Uint8Array(16),D=[];for(let f=0;f<256;f++)D.push(f.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};function n(){I(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,w="";return w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w+="-",w+=D[M[f++]],w+=D[M[f++]],w+="-",w+=D[M[f++]],w+=D[M[f++]],w+="-",w+=D[M[f++]],w+=D[M[f++]],w+="-",w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w}e.generateUuid=n}),define(Q[110],J([0,1,58,31,42]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function D(I,n){if(await new Promise((t,k)=>{const b=L.createReadStream(I),S=v.createHash("sha1");b.pipe(S);const d=(0,M.once)((m,E)=>{b.removeAllListeners(),S.removeAllListeners(),m?k(m):t(E)});b.once("error",d),b.once("end",d),S.once("error",d),S.once("data",m=>d(void 0,m.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=D}),define(Q[111],J([0,1,237]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(D="utf8"){this.stringDecoder=new v.StringDecoder(D),this.remaining=null}write(D){const I=[],n=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(n.length<1)return I;let f=0,w,t=f;for(;t<n.length;)if(w=n.charCodeAt(t),w===13||w===10){if(I.push(n.substring(f,t)),t++,t<n.length){const k=w;w=n.charCodeAt(t),(k===13&&w===10||k===10&&w===13)&&t++}f=t}else t++;return this.remaining=f<n.length?n.substr(f):null,I}end(){return this.remaining}}e.LineDecoder=L}),define(Q[112],J([0,1,25]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function M(n){const f=n.replace(/\-/g,":").toLowerCase();return!L.has(f)}function D(){return new Promise(async(n,f)=>{const w=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await I())}catch(t){f(t)}finally{clearTimeout(w)}})}e.getMac=D;function I(){return new Promise((n,f)=>{try{const w=(0,v.networkInterfaces)();for(let t in w){const k=w[t];if(k){for(const{mac:b}of k)if(M(b))return n(b)}}f("Unable to retrieve mac address (unexpected format)")}catch(w){f(w)}})}}),define(Q[69],J([0,1,25,17,40,28,112]),function(V,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(t){return this._virtualMachineOUIs||(this._virtualMachineOUIs=M.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(t)}value(){if(this._value===void 0){let t=0,k=0;const b=(0,v.networkInterfaces)();for(let S in b){const d=b[S];if(d)for(const{mac:m,internal:E}of d)E||(k+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(t+=1))}this._value=k>0?t/k:0}return this._value}};let n;async function f(){return n||(n=(async()=>await w()||D.generateUuid())()),n}e.getMachineId=f;async function w(){try{const t=await new Promise((b,S)=>{V(["crypto"],b,S)}),k=await(0,I.getMac)();return t.createHash("sha256").update(k,"utf8").digest("hex")}catch(t){L.onUnexpectedError(t);return}}}),define(Q[19],J([0,1,31,25,113,9,33,68,8,3,15,7,28]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function d(F,H=S.UNLINK){if((0,I.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return H===S.UNLINK?E(F):m(F)}async function m(F){try{const H=(0,f.join)((0,L.tmpdir)(),(0,b.generateUuid)());try{await e.Promises.rename(F,H)}catch(z){return E(F)}E(H).catch(z=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function E(F){return e.Promises.rmdir(F,{recursive:!0,maxRetries:3})}function y(F){if((0,I.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(F,{recursive:!0})}e.rimrafSync=y;async function c(F,H){return u(await(H?h(F):(0,M.promisify)(v.readdir)(F)))}async function h(F){try{return await(0,M.promisify)(v.readdir)(F,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const H=[],z=await c(F);for(const B of z){let C=!1,U=!1,Y=!1;try{const O=await e.Promises.lstat((0,f.join)(F,B));C=O.isFile(),U=O.isDirectory(),Y=O.isSymbolicLink()}catch(O){console.warn("[node.js fs] unexpected error from lstat after readdir: ",O)}H.push({name:B,isFile:()=>C,isDirectory:()=>U,isSymbolicLink:()=>Y})}return H}function o(F){return u(v.readdirSync(F))}e.readdirSync=o;function u(F){return F.map(H=>typeof H=="string"?w.isMacintosh?(0,n.normalizeNFC)(H):H:(H.name=w.isMacintosh?(0,n.normalizeNFC)(H.name):H.name,H))}async function i(F){const H=await c(F),z=[];for(const B of H)await s.existsDirectory((0,f.join)(F,B))&&z.push(B);return z}function l(F,H=1e3){return new Promise(z=>{let B=!1;const C=setInterval(()=>{B||(B=!0,v.access(F,U=>{B=!1,U&&(clearInterval(C),z(void 0))}))},H)})}e.whenDeleted=l;var s;(function(F){async function H(C){let U;try{if(U=await e.Promises.lstat(C),!U.isSymbolicLink())return{stat:U}}catch(Y){}try{return{stat:await e.Promises.stat(C),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(w.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(C)),symbolicLink:{dangling:!1}}}catch(O){if(O.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw O}throw Y}}F.stat=H;async function z(C){try{const{stat:U,symbolicLink:Y}=await F.stat(C);return U.isFile()&&Y?.dangling!==!0}catch(U){}return!1}F.existsFile=z;async function B(C){try{const{stat:U,symbolicLink:Y}=await F.stat(C);return U.isDirectory()&&Y?.dangling!==!0}catch(U){}return!1}F.existsDirectory=B})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new D.ResourceQueue;function a(F,H,z){return r.queueFor(k.URI.file(F),t.extUriBiasedIgnorePathCase).queue(()=>{const B=R(z);return new Promise((C,U)=>p(F,H,B,Y=>Y?U(Y):C()))})}let g=!0;function p(F,H,z,B){if(!g)return v.writeFile(F,H,{mode:z.mode,flag:z.flag},B);v.open(F,z.flag,z.mode,(C,U)=>{if(C)return B(C);v.writeFile(U,H,Y=>{if(Y)return v.close(U,()=>B(Y));v.fdatasync(U,O=>(O&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",O),g=!1),v.close(U,T=>B(T))))})})}function P(F,H,z){const B=R(z);if(!g)return v.writeFileSync(F,H,{mode:B.mode,flag:B.flag});const C=v.openSync(F,B.flag,B.mode);try{v.writeFileSync(C,H);try{v.fdatasyncSync(C)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),g=!1}}finally{v.closeSync(C)}}e.writeFileSync=P;function R(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function A(F,H){if(F===H)return;async function z(B){try{const C=await e.Promises.lstat(B);if(C.isDirectory()||C.isSymbolicLink())return;await e.Promises.utimes(B,C.atime,new Date)}catch(C){}}try{await e.Promises.rename(F,H),await z(H)}catch(B){if(F.toLowerCase()!==H.toLowerCase()&&B.code==="EXDEV"||F.endsWith("."))await W(F,H,{preserveSymlinks:!1}),await d(F,S.MOVE),await z(H);else throw B}}async function W(F,H,z){return x(F,H,{root:{source:F,target:H},options:z,handledSourcePaths:new Set})}const j=511;async function x(F,H,z){if(z.handledSourcePaths.has(F))return;z.handledSourcePaths.add(F);const{stat:B,symbolicLink:C}=await s.stat(F);if(C){if(z.options.preserveSymlinks)try{return await ee(F,H,z)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(C.dangling)return}return B.isDirectory()?re(F,H,B.mode&j,z):K(F,H,B.mode&j)}async function re(F,H,z,B){await e.Promises.mkdir(H,{recursive:!0,mode:z});const C=await c(F);for(const U of C)await x((0,f.join)(F,U),(0,f.join)(H,U),B)}async function K(F,H,z){await e.Promises.copyFile(F,H),await e.Promises.chmod(H,z)}async function ee(F,H,z){let B=await e.Promises.readlink(F);(0,I.isEqualOrParent)(B,z.root.source,!w.isLinux)&&(B=(0,f.join)(z.root.target,B.substr(z.root.source.length+1))),await e.Promises.symlink(B,H)}e.Promises=new class{get access(){return(0,M.promisify)(v.access)}get stat(){return(0,M.promisify)(v.stat)}get lstat(){return(0,M.promisify)(v.lstat)}get utimes(){return(0,M.promisify)(v.utimes)}get read(){return(0,M.promisify)(v.read)}get readFile(){return(0,M.promisify)(v.readFile)}get write(){return(0,M.promisify)(v.write)}get appendFile(){return(0,M.promisify)(v.appendFile)}get fdatasync(){return(0,M.promisify)(v.fdatasync)}get truncate(){return(0,M.promisify)(v.truncate)}get rename(){return(0,M.promisify)(v.rename)}get copyFile(){return(0,M.promisify)(v.copyFile)}get open(){return(0,M.promisify)(v.open)}get close(){return(0,M.promisify)(v.close)}get symlink(){return(0,M.promisify)(v.symlink)}get readlink(){return(0,M.promisify)(v.readlink)}get chmod(){return(0,M.promisify)(v.chmod)}get mkdir(){return(0,M.promisify)(v.mkdir)}get unlink(){return(0,M.promisify)(v.unlink)}get rmdir(){return(0,M.promisify)(v.rmdir)}get realpath(){return(0,M.promisify)(v.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return i}get writeFile(){return a}get rm(){return d}get move(){return A}get copy(){return W}}}),define(Q[82],J([0,1,31,8,27,19]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function I(t){const k=(0,L.dirname)(t);if(t===k)return t;const b=((0,L.basename)(t)||t).toLowerCase();try{const d=(0,D.readdirSync)(k).filter(m=>m.toLowerCase()===b);if(d.length===1){const m=I(k);if(m)return(0,L.join)(m,d[0])}else if(d.length>1){const m=d.indexOf(b);if(m>=0){const E=I(k);if(E)return(0,L.join)(E,d[m])}}}catch(S){}return null}e.realcaseSync=I;async function n(t){try{return await D.Promises.realpath(t)}catch(k){const b=w(t);return await D.Promises.access(b,v.constants.R_OK),b}}e.realpath=n;function f(t){try{return v.realpathSync(t)}catch(k){const b=w(t);return v.accessSync(b,v.constants.R_OK),b}}e.realpathSync=f;function w(t){return(0,M.rtrim)((0,L.normalize)(t),L.sep)}}),define(Q[114],J([0,1,59]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,f,w,t=1){let k=!1;return new Promise(b=>{const S=setTimeout(()=>{if(!k)return k=!0,b(0)},w);M(n,f,t,d=>{if(!k)return k=!0,clearTimeout(S),b(d)})})}e.findFreePort=L;function M(n,f,w,t){if(f===0)return t(0);const k=new v.Socket;k.once("connect",()=>(I(k),M(n+w,f-1,w,t))),k.once("data",()=>{}),k.once("error",b=>(I(k),b.code!=="ECONNREFUSED"?M(n+w,f-1,w,t):t(n))),k.connect(n,"127.0.0.1")}function D(n,f,w){let t=!1,k,b=1;const S=v.createServer({pauseOnConnect:!0});function d(m,E){t||(t=!0,S.removeAllListeners(),S.close(),k&&clearTimeout(k),E(m))}return new Promise(m=>{k=setTimeout(()=>{d(0,m)},w),S.on("listening",()=>{d(n,m)}),S.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&b<f?(n++,b++,S.listen(n,"127.0.0.1")):d(0,m)}),S.on("close",()=>{d(0,m)}),S.listen(n,"127.0.0.1")})}e.findFreePortFaster=D;function I(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(f){console.error(f)}}}),define(Q[115],J([0,1,25,8,19]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,I=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var f;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(f||(f={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let t;process.env.PROCESSOR_ARCHITEW6432?t=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?t=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?t=1:t=0;class k{constructor(u,i,l){this.exePath=u,this.displayName=i,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await M.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:o=!1}={}){return o?w===0?process.env["ProgramFiles(x86)"]||null:t===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:o=!1,findPreview:u=!1}={}){const i=b({useAlternateBitness:o});if(!i)return null;const l=L.join(i,"PowerShell");if(!await M.SymlinkSupport.existsDirectory(l))return null;let s=-1,r=null;for(const p of await M.Promises.readdir(l)){let P=-1;if(u){const A=p.indexOf("-");if(A<0)continue;const W=p.substring(0,A);if(!D.test(W)||p.substring(A+1)!=="preview")continue;P=parseInt(W,10)}else{if(!D.test(p))continue;P=parseInt(p,10)}if(P<=s)continue;const R=L.join(l,p,"pwsh.exe");!await M.SymlinkSupport.existsFile(R)||(r=R,s=P)}if(!r)return null;const a=i.includes("x86")?" (x86)":"",g=u?" Preview":"";return new k(r,`PowerShell${g}${a}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await M.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:i,pwshMsixName:l}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const s of await M.Promises.readdir(u))if(i.test(s)){const r=L.join(u,s,"pwsh.exe");return new k(r,l)}return null}function m(){const o=L.join(v.homedir(),".dotnet","tools","pwsh.exe");return new k(o,".NET Core PowerShell Global Tool")}function E(){const o=L.join(process.env.windir,w===1&&t!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(o,"Windows PowerShell",!0)}async function*y(){let o=await S();o&&(yield o),o=await S({useAlternateBitness:!0}),o&&(yield o),o=await d(),o&&(yield o),o=m(),o&&(yield o),o=await S({findPreview:!0}),o&&(yield o),o=await d({findPreview:!0}),o&&(yield o),o=await S({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=E(),o&&(yield o)}async function*c(){for await(const o of y())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=c;async function h(){for await(const o of c())return o;return null}e.getFirstAvailablePowerShellInstallation=h}),define(Q[83],J([0,1,44,10]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function M(I){return new Promise((n,f)=>{let w;const t=new Map;function k(S,d,m,E,y){const c=t.get(d);if(S===I||c){const h={name:b(m),cmd:m,pid:S,ppid:d,load:E,mem:y};t.set(S,h),S===I&&(w=h),c&&(c.children||(c.children=[]),c.children.push(h),c.children.length>1&&(c.children=c.children.sort((o,u)=>o.pid-u.pid)))}}function b(S){const d=/--disable-blink-features=Auxclick/,m=/\\watcher\\win32\\CodeHelper\.exe/,E=/--crashes-directory/,y=/\\pipe\\winpty-control/,c=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(m.exec(S))return"watcherService ";if(E.exec(S))return"electron-crash-reporter";if(y.exec(S))return"winpty-process";if(c.exec(S))return"console-window-host (Windows internal process)";let o=h.exec(S);if(o&&o.length===2)return o[1]==="renderer"?d.exec(S)?"shared-process":"window":o[1];const u=/[a-zA-Z-]+\.js/g;let i="";do o=u.exec(S),o&&(i+=o+" ");while(o);return i&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${i}`:S}if(process.platform==="win32"){const S=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,m)=>{V(["windows-process-tree"],d,m)}).then(d=>{d.getProcessList(I,m=>{d.getProcessCpuUsage(m,E=>{const y=new Map;E.forEach(c=>{const h=S(c.commandLine||"");y.set(c.pid,{name:b(h),cmd:h,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),w=y.get(I),w?(y.forEach(c=>{const h=y.get(c.ppid);h&&(h.children||(h.children=[]),h.children.push(c))}),y.forEach(c=>{c.children&&(c.children=c.children.sort((h,o)=>h.pid-o.pid))}),n(w)):f(new Error(`Root process ${I} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let S=function(){let d=[w];const m=[];for(;d.length;){const y=d.shift();y&&(m.push(y.pid),y.children&&(d=d.concat(y.children)))}let E=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);E+=" "+m.join(" "),(0,v.exec)(E,{},(y,c,h)=>{if(y||h)f(y||new Error(h.toString()));else{const o=c.toString().split(`
`);for(let u=0;u<m.length;u++){const i=t.get(m[u]);i.load=parseFloat(o[u])}if(!w){f(new Error(`Root process ${I} not found`));return}n(w)}})};(0,v.exec)("which ps",{},(d,m,E)=>{if(d||E)if(process.platform!=="linux")f(d||new Error(E.toString()));else{const y=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,v.exec)(y,{},(c,h,o)=>{c||o?f(c||new Error(o.toString())):(D(h,k),S())})}else{const y=m.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${y} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,o,u)=>{h||u&&!u.includes("screen size is bogus")?f(h||new Error(u.toString())):(D(o,k),process.platform==="linux"?S():w?n(w):f(new Error(`Root process ${I} not found`)))})}})}})}e.listProcesses=M;function D(I,n){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=I.toString().split(`
`);for(const t of w){const k=f.exec(t.trim());k&&k.length===6&&n(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(Q[116],J([0,1,31,23,33,2,68,8,3,19]),function(V,e,v,L,M,D,I,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function t(d,m,E){return b({path:d,isDirectory:!1},m,E)}e.watchFile=t;function k(d,m,E){return b({path:d,isDirectory:!0},m,E)}e.watchFolder=k,e.CHANGE_BUFFER_DELAY=100;function b(d,m,E){if(f.isMacintosh&&(0,M.isEqualOrParent)(d.path,"/Volumes/"))return E(`Refusing to watch ${d.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const y=(0,n.basename)(d.path),c=new Map;let h=!1,o=[(0,D.toDisposable)(()=>{c.forEach(u=>(0,D.dispose)(u)),c.clear()})];try{const u=(0,v.watch)(d.path);o.push((0,D.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const i=new Set;d.isDirectory&&w.Promises.readdir(d.path).then(l=>l.forEach(s=>i.add(s))),u.on("error",(l,s)=>{h||E(`Failed to watch ${d.path} for changes using fs.watch() (${l}, ${s})`)}),u.on("change",(l,s)=>{if(h)return;let r="";if(s&&(r=s.toString(),f.isMacintosh&&(r=(0,I.normalizeNFC)(r))),!r||l!=="change"&&l!=="rename")return;const a=d.isDirectory?(0,n.join)(d.path,r):d.path;if(d.isDirectory)if(l==="rename"){const g=c.get(a);g&&(0,D.dispose)(g);const p=setTimeout(async()=>{c.delete(a);const P=await w.Promises.exists(a);if(h)return;let R;P?i.has(r)?R="changed":(R="added",i.add(r)):(i.delete(r),R="deleted"),m(R,a)},e.CHANGE_BUFFER_DELAY);c.set(a,(0,D.toDisposable)(()=>clearTimeout(p)))}else{let g;i.has(r)?g="changed":(g="added",i.add(r)),m(g,a)}else if(l==="rename"||r!==y){const g=setTimeout(async()=>{const p=await w.Promises.exists(a);h||(p?(m("changed",a),o=[b(d,m,E)]):m("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,D.dispose)(o),o=[(0,D.toDisposable)(()=>clearTimeout(g))]}else m("changed",a)})}catch(u){w.Promises.exists(d.path).then(i=>{i&&!h&&E(`Failed to watch ${d.path} for changes using fs.watch() (${u.toString()})`)})}return(0,D.toDisposable)(()=>{h=!0,o=(0,D.dispose)(o)})}async function S(d,m,E,y=512){const c=await w.Promises.open(d,"r"),h=Buffer.allocUnsafe(y),o=new L.CancellationTokenSource(E);let u,i=!1;const l=t(d,async s=>{if(s==="changed"){if(i)return;i=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:r}=await w.Promises.read(c,h,0,y,null);if(!r||o.token.isCancellationRequested)break;m(h.slice(0,r))}}catch(r){u=new Error(r),o.dispose(!0)}finally{i=!1}}},s=>{u=new Error(s),o.dispose(!0)});return new Promise((s,r)=>{o.token.onCancellationRequested(async()=>{l.dispose(),await w.Promises.close(c),u?r(u):s()})})}e.watchFileContents=S}),define(Q[117],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[118],J([0,1,14,13,117]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){v.ipcMain.on(M.CONTEXT_MENU_CHANNEL,(n,f,w,t,k)=>{const b=I(n,t,w);b.popup({window:(0,L.withNullAsUndefined)(v.BrowserWindow.fromWebContents(n.sender)),x:k?k.x:void 0,y:k?k.y:void 0,positioningItem:k?k.positioningItem:void 0,callback:()=>{b&&n.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=D;function I(n,f,w){const t=new v.Menu;return w.forEach(k=>{let b;k.type==="separator"?b=new v.MenuItem({type:k.type}):Array.isArray(k.submenu)?b=new v.MenuItem({submenu:I(n,f,k.submenu),label:k.label}):b=new v.MenuItem({label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:k.enabled,visible:k.visible,click:(S,d,m)=>n.sender.send(f,k.id,m)}),t.append(b)}),t}});var he=this&&this.__decorate||function(V,e,v,L){var M=arguments.length,D=M<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,v):L,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(V,e,v,L);else for(var n=V.length-1;n>=0;n--)(I=V[n])&&(D=(M<3?I(D):M>3?I(e,v,D):I(e,v))||D);return M>3&&D&&Object.defineProperty(e,v,D),D};define(Q[35],J([0,1,30,9,18,23,47,17,4,2,109,27,13]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(C){C[C.Promise=100]="Promise",C[C.PromiseCancel=101]="PromiseCancel",C[C.EventListen=102]="EventListen",C[C.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function d(C){switch(C){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(C){C[C.Initialize=200]="Initialize",C[C.PromiseSuccess=201]="PromiseSuccess",C[C.PromiseError=202]="PromiseError",C[C.PromiseErrorObj=203]="PromiseErrorObj",C[C.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function E(C){switch(C){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(C){C[C.Uninitialized=0]="Uninitialized",C[C.Idle=1]="Idle"})(y||(y={}));class c{constructor(U){this.buffer=U,this.pos=0}read(U){const Y=this.buffer.slice(this.pos,this.pos+U);return this.pos+=Y.byteLength,Y}}class h{constructor(){this.buffers=[]}get buffer(){return M.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var o;(function(C){C[C.Undefined=0]="Undefined",C[C.String=1]="String",C[C.Buffer=2]="Buffer",C[C.VSBuffer=3]="VSBuffer",C[C.Array=4]="Array",C[C.Object=5]="Object"})(o||(o={}));function u(C){const U=M.VSBuffer.alloc(4);return U.writeUInt32BE(C,0),U}function i(C){return C.read(4).readUInt32BE(0)}function l(C){const U=M.VSBuffer.alloc(1);return U.writeUInt8(C,0),U}const s={Undefined:l(o.Undefined),String:l(o.String),Buffer:l(o.Buffer),VSBuffer:l(o.VSBuffer),Array:l(o.Array),Object:l(o.Object)},r=typeof Buffer!="undefined";function a(C,U){if(typeof U=="undefined")C.write(s.Undefined);else if(typeof U=="string"){const Y=M.VSBuffer.fromString(U);C.write(s.String),C.write(u(Y.byteLength)),C.write(Y)}else if(r&&Buffer.isBuffer(U)){const Y=M.VSBuffer.wrap(U);C.write(s.Buffer),C.write(u(Y.byteLength)),C.write(Y)}else if(U instanceof M.VSBuffer)C.write(s.VSBuffer),C.write(u(U.byteLength)),C.write(U);else if(Array.isArray(U)){C.write(s.Array),C.write(u(U.length));for(const Y of U)a(C,Y)}else{const Y=M.VSBuffer.fromString(JSON.stringify(U));C.write(s.Object),C.write(u(Y.byteLength)),C.write(Y)}}function g(C){switch(C.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return C.read(i(C)).toString();case o.Buffer:return C.read(i(C)).buffer;case o.VSBuffer:return C.read(i(C));case o.Array:{const Y=i(C),O=[];for(let T=0;T<Y;T++)O.push(g(C));return O}case o.Object:return JSON.parse(C.read(i(C)).toString())}}class p{constructor(U,Y,O=null,T=1e3){this.protocol=U,this.ctx=Y,this.logger=O,this.timeoutDelay=T,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(U,Y){this.channels.set(U,Y),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const Y=this.send([U.type]);this.logger&&this.logger.logOutgoing(Y,0,1,E(U.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(Y,U.id,1,E(U.type),U.data);return}}}send(U,Y=void 0){const O=new h;return a(O,U),a(O,Y),this.sendBuffer(O.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(Y){return 0}}onRawMessage(U){const Y=new c(U),O=g(Y),T=g(Y),_=O[0];switch(_){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,O[1],1,`${d(_)}: ${O[2]}.${O[3]}`,T),this.onPromise({type:_,id:O[1],channelName:O[2],name:O[3],arg:T});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,O[1],1,`${d(_)}: ${O[2]}.${O[3]}`,T),this.onEventListen({type:_,id:O[1],channelName:O[2],name:O[3],arg:T});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,O[1],1,`${d(_)}`),this.disposeActiveRequest({type:_,id:O[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,O[1],1,`${d(_)}`),this.disposeActiveRequest({type:_,id:O[1]})}}onPromise(U){const Y=this.channels.get(U.channelName);if(!Y){this.collectPendingRequest(U);return}const O=new D.CancellationTokenSource;let T;try{T=Y.call(this.ctx,U.name,U.arg,O.token)}catch(X){T=Promise.reject(X)}const _=U.id;T.then(X=>{this.sendResponse({id:_,data:X,type:201}),this.activeRequests.delete(U.id)},X=>{X instanceof Error?this.sendResponse({id:_,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:_,data:X,type:203}),this.activeRequests.delete(U.id)});const q=(0,w.toDisposable)(()=>O.cancel());this.activeRequests.set(U.id,q)}onEventListen(U){const Y=this.channels.get(U.channelName);if(!Y){this.collectPendingRequest(U);return}const O=U.id,_=Y.listen(this.ctx,U.name,U.arg)(q=>this.sendResponse({id:O,data:q,type:204}));this.activeRequests.set(U.id,_)}disposeActiveRequest(U){const Y=this.activeRequests.get(U.id);Y&&(Y.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let Y=this.pendingRequests.get(U.channelName);Y||(Y=[],this.pendingRequests.set(U.channelName,Y));const O=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:U,timeoutTimer:O})}flushPendingRequests(U){const Y=this.pendingRequests.get(U);if(Y){for(const O of Y)switch(clearTimeout(O.timeoutTimer),O.request.type){case 100:this.onPromise(O.request);break;case 102:this.onEventListen(O.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=p;var P;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(U,Y=null){this.protocol=U,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(O=>this.onBuffer(O)),this.logger=Y}getChannel(U){const Y=this;return{call(O,T,_){return Y.isDisposed?Promise.reject(n.canceled()):Y.requestPromise(U,O,T,_)},listen(O,T){return Y.isDisposed?Promise.reject(n.canceled()):Y.requestEvent(U,O,T)}}}requestPromise(U,Y,O,T=D.CancellationToken.None){const _=this.lastRequestId++,X={id:_,type:100,channelName:U,name:Y,arg:O};if(T.isCancellationRequested)return Promise.reject(n.canceled());let $;return new Promise((Z,ie)=>{if(T.isCancellationRequested)return ie(n.canceled());const oe=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(_),Z(de.data);break;case 202:this.handlers.delete(_);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,ie(ve);break;case 203:this.handlers.delete(_),ie(de.data);break}};this.handlers.set(_,ue),this.sendRequest(X)};let le=null;this.state===y.Idle?oe():(le=(0,L.createCancelablePromise)(ue=>this.whenInitialized()),le.then(()=>{le=null,oe()}));const ne=()=>{le?(le.cancel(),le=null):this.sendRequest({id:_,type:101}),ie(n.canceled())},ae=T.onCancellationRequested(ne);$=(0,w.combinedDisposable)((0,w.toDisposable)(ne),ae),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(U,Y,O){const T=this.lastRequestId++,q={id:T,type:102,channelName:U,name:Y,arg:O};let X=null;const $=new f.Emitter({onFirstListenerAdd:()=>{X=(0,L.createCancelablePromise)(Z=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add($),this.sendRequest(q)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete($),this.sendRequest({id:T,type:103}))}}),N=Z=>$.fire(Z.data);return this.handlers.set(T,N),$.event}sendRequest(U){switch(U.type){case 100:case 102:{const Y=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(Y,U.id,0,`${d(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const Y=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(Y,U.id,0,d(U.type));return}}}send(U,Y=void 0){const O=new h;return a(O,U),a(O,Y),this.sendBuffer(O.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(Y){return 0}}onBuffer(U){const Y=new c(U),O=g(Y),T=g(Y),_=O[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,E(_)),this.onResponse({type:O[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,O[1],0,E(_),T),this.onResponse({type:O[0],id:O[1],data:T})}}onResponse(U){if(U.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(U.id);Y&&Y(U)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}he([I.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class A{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:Y,onDidClientDisconnect:O})=>{f.Event.once(Y.onMessage)(_=>{const q=new c(_),X=g(q),$=new p(Y,X),N=new R(Y);this.channels.forEach((ie,oe)=>$.registerChannel(oe,ie));const Z={channelServer:$,channelClient:N,ctx:X};this._connections.add(Z),this._onDidAddConnection.fire(Z),O(()=>{$.dispose(),N.dispose(),this._connections.delete(Z),this._onDidRemoveConnection.fire(Z)})})})}get connections(){const U=[];return this._connections.forEach(Y=>U.push(Y)),U}getChannel(U,Y){const O=this;return{call(T,_,q){let X;if((0,b.isFunction)(Y)){let N=(0,v.getRandomElement)(O.connections.filter(Y));X=N?Promise.resolve(N):f.Event.toPromise(f.Event.filter(O.onDidAddConnection,Y))}else X=Y.routeCall(O,T,_);const $=X.then(N=>N.channelClient.getChannel(U));return j($).call(T,_,q)},listen(T,_){if((0,b.isFunction)(Y))return O.getMulticastEvent(U,Y,T,_);const q=Y.routeEvent(O,T,_).then(X=>X.channelClient.getChannel(U));return j(q).listen(T,_)}}}getMulticastEvent(U,Y,O,T){const _=this;let q=new w.DisposableStore;const X=new f.Emitter({onFirstListenerAdd:()=>{q=new w.DisposableStore;const $=new f.EventMultiplexer,N=new Map,Z=oe=>{const ne=oe.channelClient.getChannel(U).listen(O,T),ae=$.add(ne);N.set(oe,ae)},ie=oe=>{const le=N.get(oe);!le||(le.dispose(),N.delete(oe))};_.connections.filter(Y).forEach(Z),f.Event.filter(_.onDidAddConnection,Y)(Z,void 0,q),_.onDidRemoveConnection(ie,void 0,q),$.event(X.fire,X,q),q.add($)},onLastListenerRemove:()=>{q.dispose()}});return X.event}registerChannel(U,Y){this.channels.set(U,Y),this._connections.forEach(O=>{O.channelServer.registerChannel(U,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class W{constructor(U,Y,O=null){const T=new h;a(T,Y),U.send(T.buffer),this.channelClient=new R(U,O),this.channelServer=new p(U,Y,O)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,Y){this.channelServer.registerChannel(U,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function j(C){return{call(U,Y,O){return C.then(T=>T.call(U,Y,O))},listen(U,Y){const O=new f.Relay;return C.then(T=>O.input=T.listen(U,Y)),O.event}}}e.getDelayedChannel=j;function x(C){let U=!1;return{call(Y,O,T){return U?C.call(Y,O,T):(0,L.timeout)(0).then(()=>U=!0).then(()=>C.call(Y,O,T))},listen(Y,O){if(U)return C.listen(Y,O);const T=new f.Relay;return(0,L.timeout)(0).then(()=>U=!0).then(()=>T.input=C.listen(Y,O)),T.event}}}e.getNextTickChannel=x;class re{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const Y of U.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await f.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=re;var K;(function(C){function U(_,q){const X=_,$=q&&q.disableMarshalling,N=new Map;for(const Z in X)O(Z)&&N.set(Z,f.Event.buffer(X[Z],!0));return new class{listen(Z,ie,oe){const le=N.get(ie);if(le)return le;if(T(ie)){const ne=X[ie];if(typeof ne=="function")return ne.call(X,oe)}throw new Error(`Event not found: ${ie}`)}call(Z,ie,oe){const le=X[ie];if(typeof le=="function"){if(!$&&Array.isArray(oe))for(let ne=0;ne<oe.length;ne++)oe[ne]=(0,t.revive)(oe[ne]);return le.apply(X,oe)}throw new Error(`Method not found: ${ie}`)}}}C.fromService=U;function Y(_,q){const X=q&&q.disableMarshalling;return new Proxy({},{get($,N){if(typeof N=="string")return q?.properties?.has(N)?q.properties.get(N):T(N)?function(Z){return _.listen(N,Z)}:O(N)?_.listen(N):async function(...Z){let ie;q&&!(0,b.isUndefinedOrNull)(q.context)?ie=[q.context,...Z]:ie=Z;const oe=await _.call(N,ie);return X?oe:(0,t.revive)(oe)};throw new Error(`Property not found: ${String(N)}`)}})}C.toService=Y;function O(_){return _[0]==="o"&&_[1]==="n"&&k.isUpperAsciiLetter(_.charCodeAt(2))}function T(_){return/^onDynamic/.test(_)&&k.isUpperAsciiLetter(_.charCodeAt(9))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(C){if(Array.isArray(C))return C;if(C&&typeof C=="object"&&typeof C.toString=="function"){let U=C.toString();if(U!=="[object Object]")return U}return C}function H(C){return Array.isArray(C)?C.map(F):F(C)}function z(C,U,Y,O,T,_,q){q=H(q);const X=ee[T],$=X[O%X.length];let N=[`%c[${C}]%c[${String(U).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(O).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(_)?(N=N.concat(q),N.push(")")):N.push(q),console.log.apply(console,N)}e.logWithColors=z;class B{constructor(U,Y){this._outgoingPrefix=U,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,Y,O,T,_){this._totalOutgoing+=U,z(this._outgoingPrefix,this._totalOutgoing,U,Y,O,T,_)}logIncoming(U,Y,O,T,_){this._totalIncoming+=U,z(this._incomingPrefix,this._totalIncoming,U,Y,O,T,_)}}e.IPCLogger=B}),define(Q[119],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(M,D){this.sender=M,this.onMessage=D}send(M){try{this.sender.send("vscode:message",M.buffer)}catch(D){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Q[120],J([0,1,18,4,35]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",w=>v.VSBuffer.wrap(w.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=D;class I extends M.IPCClient{constructor(f,w){const t=new D(f);super(t,w);this.protocol=t}dispose(){this.protocol.disconnect()}}e.Client=I}),define(Q[84],J([0,1,18,4,2,3,32,35]),function(V,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function t(){return w||(w=v.VSBuffer.alloc(0)),w}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return t();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let g=v.VSBuffer.alloc(r),p=0,P=0;for(;r>0;){const R=this._chunks[P];if(R.byteLength>r){const A=R.slice(0,r);g.set(A,p),p+=r,a&&(this._chunks[P]=R.slice(r),this._totalLength-=r),r-=r}else g.set(R,p),p+=R.byteLength,a?(this._chunks.shift(),this._totalLength-=R.byteLength):P++,r-=R.byteLength}return g}}e.ChunkStream=k;var b;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(b||(b={}));var S;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(S=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,a,g,p){this.type=r,this.id=a,this.ack=g,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends M.Disposable{constructor(r){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const g=this._state.messageType,p=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(g,p,P,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class E{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=v.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._writeSoon(a,r.data)}_bufferAdd(r,a){const g=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,g}_bufferTake(){const r=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&D.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class y extends M.Disposable{constructor(r){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new E(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=y;class c extends n.IPCClient{constructor(r,a,g=null){super(r,a,g);this.protocol=r}static fromSocket(r,a){return new c(new y(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=c;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,I.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class o{constructor(r){this.data=r,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],a=0,g=this._first;for(;g;)r[a++]=g.data,g=g.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new o(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class i{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<i._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=i._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const r=Date.now(),a=(1+i._HISTORY_LENGTH)*1e3;let g=0;for(let p=0;p<i._HISTORY_LENGTH;p++)r-this.lastRuns[p]<=a&&g++;return 1-g/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class l{constructor(r,a=null,g=i.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=g,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,M.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,t());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const a=new d(4,0,0,t());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,M.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let a=0,g=r.length;a<g;a++)this._socketWriter.write(r[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new d(6,0,0,t())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const a=this._outgoingUnackMsg.toArray();for(let g=0,p=a.length;g<p;g++)this._socketWriter.write(a[g]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const g=new d(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(g),this._isReconnecting||(this._socketWriter.write(g),this._recvAckCheck())}sendControl(r){const a=new d(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,t());this._socketWriter.write(r)}}e.PersistentProtocol=l}),define(Q[121],J([0,1,14,18,4,2,35,119]),function(V,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(t,k){const b=M.Event.fromNodeEventEmitter(v.ipcMain,k,(d,m)=>({event:d,message:m})),S=M.Event.filter(b,({event:d})=>d.sender.id===t);return M.Event.map(S,({message:d})=>d&&L.VSBuffer.wrap(d))}class w extends I.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const k=M.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:b})=>b);return M.Event.map(k,b=>{const S=b.id,d=w.Clients.get(S);d&&d.dispose();const m=new M.Emitter;w.Clients.set(S,(0,D.toDisposable)(()=>m.fire()));const E=f(S,"vscode:message"),y=M.Event.any(M.Event.signal(f(S,"vscode:disconnect")),m.event);return{protocol:new n.Protocol(b,E),onDidClientDisconnect:y}})}}e.Server=w,w.Clients=new Map}),define(Q[85],J([0,1,14,4,28,120]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class I extends D.Client{constructor(w,t){super({addEventListener:(k,b)=>w.addListener(k,b),removeEventListener:(k,b)=>w.removeListener(k,b),postMessage:k=>w.postMessage(k),start:()=>w.start(),close:()=>w.close()},t)}}e.Client=I;async function n(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,M.generateUuid)();f.webContents.send("vscode:createMessageChannel",w);const t=L.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(b,S)=>({nonce:S,port:b.ports[0]})),{port:k}=await L.Event.toPromise(L.Event.once(L.Event.filter(t,b=>b.nonce===w)));return k}e.connect=n}),define(Q[86],J([0,1,9,4,2,13]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var I;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(I=e.StorageHint||(e.StorageHint={}));function n(k){const b=k;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=n;var f;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(f||(f={}));class w extends M.Disposable{constructor(b,S=Object.create(null)){super();this.database=b,this.options=S,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((S,d)=>this.accept(d,S)),b.deleted?.forEach(S=>this.accept(S,void 0))}accept(b,S){if(this.state===f.Closed)return;let d=!1;(0,D.isUndefinedOrNull)(S)?d=this.cache.delete(b):this.cache.get(b)!==S&&(this.cache.set(b,S),d=!0),d&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,S){const d=this.cache.get(b);return(0,D.isUndefinedOrNull)(d)?S:d}getBoolean(b,S){const d=this.get(b);return(0,D.isUndefinedOrNull)(d)?S:d==="true"}getNumber(b,S){const d=this.get(b);return(0,D.isUndefinedOrNull)(d)?S:parseInt(d,10)}async set(b,S){if(this.state===f.Closed)return;if((0,D.isUndefinedOrNull)(S))return this.delete(b);const d=String(S);if(this.cache.get(b)!==d)return this.cache.set(b,d),this.pendingInserts.set(b,d),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===f.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class t{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((S,d)=>this.items.set(d,S)),b.delete&&b.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=t}),define(Q[122],J([0,1,9,4,40,8,19]),function(V,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(t,k=Object.create(null)){this.path=t,this.options=k,this.name=(0,D.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const t=await this.whenConnected,k=new Map;return(await this.all(t,"SELECT * FROM ItemTable")).forEach(S=>k.set(S.key,S.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${k.size} rows`),k}async updateItems(t){const k=await this.whenConnected;return this.doUpdateItems(k,t)}doUpdateItems(t,k){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${k.insert?(0,M.mapToString)(k.insert):"0"}), delete(${k.delete?(0,M.setToString)(k.delete):"0"})`),this.transaction(t,()=>{const b=k.insert,S=k.delete;if(b&&b.size>0){const d=[];d.push([]);let m=0;b.forEach((E,y)=>{let c=d[m];c.length>n.MAX_HOST_PARAMETERS&&(m++,c=[],d.push(c)),c.push(y,E)}),d.forEach(E=>{this.prepare(t,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,y=>y.run(E),()=>{const y=[];let c=0;return b.forEach((h,o)=>{y.push(o),c+=h.length}),`Keys: ${y.join(", ")} Length: ${c}`})})}if(S&&S.size){const d=[];d.push([]);let m=0;S.forEach(E=>{let y=d[m];y.length>n.MAX_HOST_PARAMETERS&&(m++,y=[],d.push(y)),y.push(E)}),d.forEach(E=>{this.prepare(t,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,y=>y.run(E),()=>{const y=[];return S.forEach(c=>{y.push(c)}),`Keys: ${y.join(", ")}`})})}})}async close(t){this.logger.trace(`[storage ${this.name}] close()`);const k=await this.whenConnected;return this.doClose(k,t)}doClose(t,k){return new Promise((b,S)=>{t.db.close(d=>(d&&this.handleSQLiteError(t,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?b():!t.isErroneous&&!t.isInMemory?this.backup().then(b,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),b())):typeof k=="function"?I.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const E=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:k()}).then(()=>E(),y=>(E(),Promise.reject(y)))})).then(b,S):S(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const t=this.toBackupPath(this.path);return I.Promises.copy(this.path,t,{preserveSymlinks:!1})}toBackupPath(t){return`${t}.backup`}async checkIntegrity(t){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${t})`);const k=await this.whenConnected,b=await this.get(k,t?"PRAGMA integrity_check":"PRAGMA quick_check"),S=t?b.integrity_check:b.quick_check;return k.isErroneous?`${S} (last error: ${k.lastError})`:k.isInMemory?`${S} (in-memory!)`:S}async connect(t,k=!0){this.logger.trace(`[storage ${this.name}] open(${t}, retryOnBusy: ${k})`);try{return await this.doConnect(t)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&k)return await(0,v.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(t,!1);try{await I.Promises.unlink(t);try{await I.Promises.rename(this.toBackupPath(t),t)}catch(S){}return await this.doConnect(t)}catch(S){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${S}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(t,k){t.isErroneous=!0,t.lastError=k,this.logger.error(k)}doConnect(t){return new Promise((k,b)=>{new Promise((S,d)=>{V(["@vscode/sqlite3"],S,d)}).then(S=>{const d={db:new(this.logger.isTracing?S.verbose().Database:S.Database)(t,m=>m?d.db?d.db.close(()=>b(m)):b(m):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(d),E=>d.db.close(()=>b(E)))),isInMemory:t===n.IN_MEMORY_PATH};d.db.on("error",m=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&d.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},b)})}exec(t,k){return new Promise((b,S)=>{t.db.exec(k,d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] exec(): ${d}`),S(d)):b())})}get(t,k){return new Promise((b,S)=>{t.db.get(k,(d,m)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] get(): ${d}`),S(d)):b(m))})}all(t,k){return new Promise((b,S)=>{t.db.all(k,(d,m)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] all(): ${d}`),S(d)):b(m))})}transaction(t,k){return new Promise((b,S)=>{t.db.serialize(()=>{t.db.run("BEGIN TRANSACTION"),k(),t.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] transaction(): ${d}`),S(d)):b())})})}prepare(t,k,b,S){const d=t.db.prepare(k),m=E=>{this.handleSQLiteError(t,`[storage ${this.name}] prepare(): ${E} (${k}). Details: ${S()}`)};d.on("error",m),b(d),d.finalize(E=>{E&&m(E),d.removeListener("error",m)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class f{constructor(t){t&&typeof t.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=t.logTrace),t&&typeof t.logError=="function"&&(this.logError=t.logError)}get isTracing(){return!!this.logTrace}trace(t){this.logTrace&&this.logTrace(t)}error(t){this.logError&&this.logError(t)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[123],J([12,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(Q[124],J([0,1,123]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,M=L*60,D=M*24,I=D*7,n=D*30,f=D*365;function w(k,b){typeof k!="number"&&(k=k.getTime());const S=Math.round((new Date().getTime()-k)/1e3);if(S<-30)return(0,v.localize)(0,null,w(new Date().getTime()+S*1e3,!1));if(S<30)return(0,v.localize)(1,null);let d;return S<L?(d=S,b?d===1?(0,v.localize)(2,null,d):(0,v.localize)(3,null,d):d===1?(0,v.localize)(4,null,d):(0,v.localize)(5,null,d)):S<M?(d=Math.floor(S/L),b?d===1?(0,v.localize)(6,null,d):(0,v.localize)(7,null,d):d===1?(0,v.localize)(8,null,d):(0,v.localize)(9,null,d)):S<D?(d=Math.floor(S/M),b?d===1?(0,v.localize)(10,null,d):(0,v.localize)(11,null,d):d===1?(0,v.localize)(12,null,d):(0,v.localize)(13,null,d)):S<I?(d=Math.floor(S/D),b?d===1?(0,v.localize)(14,null,d):(0,v.localize)(15,null,d):d===1?(0,v.localize)(16,null,d):(0,v.localize)(17,null,d)):S<n?(d=Math.floor(S/I),b?d===1?(0,v.localize)(18,null,d):(0,v.localize)(19,null,d):d===1?(0,v.localize)(20,null,d):(0,v.localize)(21,null,d)):S<f?(d=Math.floor(S/n),b?d===1?(0,v.localize)(22,null,d):(0,v.localize)(23,null,d):d===1?(0,v.localize)(24,null,d):(0,v.localize)(25,null,d)):(d=Math.floor(S/f),b?d===1?(0,v.localize)(26,null,d):(0,v.localize)(27,null,d):d===1?(0,v.localize)(28,null,d):(0,v.localize)(29,null,d))}e.fromNow=w;function t(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(Q[125],J([12,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(Q[60],J([0,1,30,13,125]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function D(w,t){return t&&(w.stack||w.stacktrace)?M.localize(0,null,n(w),I(w.stack)||I(w.stacktrace)):n(w)}function I(w){return Array.isArray(w)?w.join(`
`):w}function n(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?M.localize(1,null,w.message):w.message||M.localize(2,null)}function f(w=null,t=!1){if(!w)return M.localize(3,null);if(Array.isArray(w)){const k=v.coalesce(w),b=f(k[0],t);return k.length>1?M.localize(4,null,b,k.length):b}if(L.isString(w))return w;if(w.detail){const k=w.detail;if(k.error)return D(k.error,t);if(k.exception)return D(k.exception,t)}return w.stack?D(w,t):w.message?w.message:M.localize(5,null)}e.toErrorMessage=f}),define(Q[126],J([12,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(Q[127],J([0,1,126]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(I,n,f=n){this.modifierLabels=[null],this.modifierLabels[2]=I,this.modifierLabels[1]=n,this.modifierLabels[3]=f}toLabel(I,n,f){if(n.length===0)return null;const w=[];for(let t=0,k=n.length;t<k;t++){const b=n[t],S=f(b);if(S===null)return null;w[t]=M(b,S,this.modifierLabels[I])}return w.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function M(D,I,n){if(I===null)return"";const f=[];return D.ctrlKey&&f.push(n.ctrlKey),D.shiftKey&&f.push(n.shiftKey),D.altKey&&f.push(n.altKey),D.metaKey&&f.push(n.metaKey),I!==""&&f.push(I),f.join(n.separator)}}),define(Q[128],J([12,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(Q[70],J([0,1,44,33,10,43,8,3,32,79,13,111,19,128]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return w.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return w.TerminateResponseCode}});function d(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(u,i){if(n.isWindows)try{const l={stdio:["pipe","pipe","ignore"]};i&&(l.cwd=i);const s=v.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],l);return new Promise(r=>{s.once("error",a=>{r({success:!1,error:a})}),s.once("exit",(a,g)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(l){return Promise.resolve({success:!1,error:l,code:l.status?d(l.status):1})}else if(n.isLinux||n.isMacintosh)try{const l=M.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(s=>{v.execFile(l,[u.pid.toString()],{encoding:"utf8",shell:!0},(r,a,g)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(l){return Promise.resolve({success:!1,error:l})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function E(u=f.env){return u.comspec||"cmd.exe"}e.getWindowsShell=E;class y{constructor(i,l,s,r){if(l!==void 0&&s!==void 0&&r!==void 0)this.cmd=i,this.args=l,this.shell=s,this.options=r;else{const a=i;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(f.env).forEach(g=>{a[g]=f.env[g]}),Object.keys(this.options.env).forEach(g=>{a[g]=this.options.env[g]}),this.options.env=a}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const l=i.lastIndexOf(I.sep);return l!==-1&&(i=i.substring(l+1)),y.WellKnowCommands[i]?i:"other"}start(i){return n.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(l=>{let s,r;const a=new Promise((g,p)=>{s=g,r=p});if(l){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=v.exec(g,this.options,(p,P,R)=>{this.childProcess=null;const A=p;A&&A.killed?r({killed:this.terminateRequested,stdout:P.toString(),stderr:R.toString()}):this.handleExec(s,i,p,P,R)})}else{let g=null;const p=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,s,i,r);const R={terminated:this.terminateRequested};t.isNumber(P)&&(R.cmdCode=P),s(R)};if(this.shell&&n.isWindows){const P=D.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let R=!1,A=!1;const W=[];let j=this.ensureQuotes(this.cmd);W.push(j.value),R=j.quoted,this.args&&this.args.forEach(re=>{j=this.ensureQuotes(re),W.push(j.value),A=A&&j.quoted});const x=["/s","/c"];R?A?x.push('"'+W.join(" ")+'"'):W.length>1?x.push('"'+W[0]+'" '+W.slice(1).join(" ")):x.push('"'+W[0]+'"'):x.push(W.join(" ")),g=v.spawn(E(),x,P)}else this.cmd&&(g=v.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(t.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",P=>{this.childProcess=null,r({terminated:this.terminateRequested,error:P})}),g.pid&&(this.childProcess.on("close",p),this.handleSpawn(g,s,i,r,!0)))}return a})}handleClose(i,l,s,r){}ensureQuotes(i){return y.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,m(i,this.options.cwd).then(l=>(l.success&&(this.childProcess=null),l))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!n.isWindows)return i(!1);const l=v.spawn(E(),["/s","/c"]);l.on("error",s=>i(!0)),l.on("exit",s=>i(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class c extends y{constructor(i,l,s,r){super(i,l,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,l,s,r,a){[r,a].forEach((g,p)=>{const P=new k.LineDecoder;P.write(g).forEach(W=>{l({line:W,source:p===0?0:1})});const A=P.end();A&&l({line:A,source:p===0?0:1})}),i({terminated:this.terminateRequested,error:s})}handleSpawn(i,l,s,r,a){const g=new k.LineDecoder,p=new k.LineDecoder;i.stdout.on("data",P=>{g.write(P).forEach(A=>s({line:A,source:0}))}),i.stderr.on("data",P=>{p.write(P).forEach(A=>s({line:A,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=p}handleClose(i,l,s,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&s({line:a,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&s({line:g,source:1})}}e.LineProcess=c;function h(u){let i=[],l=!1;const s=function(r){if(l){i.push(r);return}(!u.send(r,g=>{if(g&&console.error(g),l=!1,i.length>0){const p=i.slice(0);i=[],p.forEach(P=>s(P))}})||n.isWindows)&&(l=!0)};return{send:s}}e.createQueuedSender=h;var o;(function(u){async function i(l,s,r){if(I.isAbsolute(l))return l;if(s===void 0&&(s=f.cwd()),I.dirname(l)!=="."||(r===void 0&&t.isString(f.env.PATH)&&(r=f.env.PATH.split(I.delimiter)),r===void 0||r.length===0))return I.join(s,l);async function g(p){if(await b.Promises.exists(p)){let P;try{P=await b.Promises.stat(p)}catch(R){R.message.startsWith("EACCES")&&(P=await b.Promises.lstat(p))}return P?!P.isDirectory():!1}return!1}for(let p of r){let P;if(I.isAbsolute(p)?P=I.join(p,l):P=I.join(s,p,l),await g(P))return P;let R=P+".com";if(await g(R)||(R=P+".exe",await g(R)))return R}return I.join(s,l)}u.findExecutable=i})(o=e.win32||(e.win32={}))}),define(Q[129],J([0,1,25,3,115,70]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function I(S,d){return S===1?L.isWindows?k():D.getWindowsShell(d):w(S,d)}e.getSystemShell=I;function n(S,d){return S===1?L.isWindows?b(d):D.getWindowsShell(d):w(S,d)}e.getSystemShellSync=n;let f=null;function w(S,d){if(L.isLinux&&S===2||L.isMacintosh&&S===3)return"/bin/bash";if(!f){let m;if(L.isWindows)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=(0,v.userInfo)().shell}catch(E){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}f=m}return f}let t=null;async function k(){return t||(t=(await(0,M.getFirstAvailablePowerShellInstallation)()).exePath),t}function b(S){if(t)return t;const d=L.isWindows&&parseFloat((0,v.release)())>=10,m=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${S.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?E:D.getWindowsShell(S)}}),define(Q[71],J([0,1,44,9,18,23,108,17,4,2,43,3,70,35]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends S.ChannelServer{constructor(y){super({send:c=>{try{process.send&&process.send(c.buffer.toString("base64"))}catch(h){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",c=>M.VSBuffer.wrap(Buffer.from(c,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=d;class m{constructor(y,c){this.modulePath=y,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new L.Delayer(h),this.child=null,this._client=null}getChannel(y){const c=this;return{call(h,o,u){return c.requestPromise(y,h,o,u)},listen(h,o){return c.requestEvent(y,h,o)}}}requestPromise(y,c,h,o=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(y),i=(0,L.createCancelablePromise)(r=>u.call(c,h,r)),l=o.onCancellationRequested(()=>i.cancel()),s=(0,w.toDisposable)(()=>i.cancel());return this.activeRequests.add(s),i.finally(()=>{l.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(y,c,h){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let o;const u=new f.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(y).listen(c,h)(u.fire,u),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,t.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),k.isMacintosh&&c.env&&delete c.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,y,c);const h=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,I.isRemoteConsoleLog)(a)){(0,I.log)(a,`IPC Library: ${this.options.serverName}`);return}h.fire(M.VSBuffer.wrap(Buffer.from(a,"base64")))});const u=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,i=a=>this.child&&this.child.connected&&u.send(a.buffer.toString("base64")),l=h.event,s={send:i,onMessage:l};this._client=new S.ChannelClient(s);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,g)=>{process.removeListener("exit",r),this.activeRequests.forEach(p=>(0,w.dispose)(p)),this.activeRequests.clear(),a!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:g})})}return this._client}getCachedChannel(y){let c=this.channels.get(y);return c||(c=this.client.getChannel(y),this.channels.set(y,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(Q[130],J([12,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(Q[131],J([12,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[132],J([12,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[133],J([12,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(Q[134],J([12,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(Q[135],J([12,11]),function(V,e){return V.create("vs/platform/environment/node/shellEnv",e)}),define(Q[136],J([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[137],J([12,11]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[138],J([12,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[139],J([12,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(Q[140],J([12,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(Q[141],J([12,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(Q[142],J([12,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[143],J([12,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[144],J([12,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[145],J([12,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Q[146],J([12,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(Q[147],J([12,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[148],J([12,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[149],J([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(Q[150],J([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[151],J([12,11]),function(V,e){return V.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[152],J([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[153],J([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[154],J([0,1,4,2]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class M{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(n,f,w){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(n,f,w){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=M,M.ChannelName="extensionhostdebugservice";class D extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,f,w){this.channel.call("attach",[n,f,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,f){this.channel.call("terminate",[n,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,f){return this.channel.call("openExtensionDevelopmentHostWindow",[n,f])}}e.ExtensionHostDebugChannelClient=D}),define(Q[155],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(I){this.driver=I}listen(I,n){throw new Error(`No event found: ${n}`)}call(I,n,f){switch(n){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=v;class L{constructor(I){this.channel=I}click(I,n,f){return this.channel.call("click",[I,n,f])}doubleClick(I){return this.channel.call("doubleClick",I)}setValue(I,n){return this.channel.call("setValue",[I,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(I){return this.channel.call("isActiveElement",I)}getElements(I,n){return this.channel.call("getElements",[I,n])}getElementXY(I,n,f){return this.channel.call("getElementXY",[I,n,f])}typeInEditor(I,n){return this.channel.call("typeInEditor",[I,n])}getTerminalBuffer(I){return this.channel.call("getTerminalBuffer",I)}writeInTerminal(I,n){return this.channel.call("writeInTerminal",[I,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class M{constructor(I){this.channel=I}registerWindowDriver(I){return this.channel.call("registerWindowDriver",I)}reloadWindowDriver(I){return this.channel.call("reloadWindowDriver",I)}}e.WindowDriverRegistryChannelClient=M}),define(Q[156],J([0,1,124,47,10,8,32,15,7]),function(V,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(m,E,y){this._args=m,this.paths=E,this.productService=y}get appRoot(){return(0,D.dirname)(M.FileAccess.asFileUri("",V).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(f.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=I.env.VSCODE_PORTABLE;return m?f.URI.file((0,D.join)(m,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,D.resolve)(m):(0,D.normalize)((0,D.join)(M.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,D.resolve)(m):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,D.resolve)(m);const E=I.env.VSCODE_EXTENSIONS;if(E)return E;const y=I.env.VSCODE_PORTABLE;return y?(0,D.join)(y,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(E=>/^[^:/?#]+?:\/\//.test(E)?f.URI.parse(E):f.URI.file((0,D.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?f.URI.parse(m):f.URI.file((0,D.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return t(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],w.prototype,"appRoot",null),he([L.memoize],w.prototype,"userHome",null),he([L.memoize],w.prototype,"userDataPath",null),he([L.memoize],w.prototype,"appSettingsHome",null),he([L.memoize],w.prototype,"tmpDir",null),he([L.memoize],w.prototype,"userRoamingDataHome",null),he([L.memoize],w.prototype,"settingsResource",null),he([L.memoize],w.prototype,"userDataSyncHome",null),he([L.memoize],w.prototype,"userDataSyncLogResource",null),he([L.memoize],w.prototype,"sync",null),he([L.memoize],w.prototype,"machineSettingsResource",null),he([L.memoize],w.prototype,"globalStorageHome",null),he([L.memoize],w.prototype,"workspaceStorageHome",null),he([L.memoize],w.prototype,"keybindingsResource",null),he([L.memoize],w.prototype,"keyboardLayoutResource",null),he([L.memoize],w.prototype,"argvResource",null),he([L.memoize],w.prototype,"snippetsHome",null),he([L.memoize],w.prototype,"isExtensionDevelopment",null),he([L.memoize],w.prototype,"untitledWorkspacesHome",null),he([L.memoize],w.prototype,"installSourcePath",null),he([L.memoize],w.prototype,"builtinExtensionsPath",null),he([L.memoize],w.prototype,"extensionsPath",null),he([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],w.prototype,"extensionDevelopmentKind",null),he([L.memoize],w.prototype,"extensionTestsLocationURI",null),he([L.memoize],w.prototype,"debugExtensionHost",null),he([L.memoize],w.prototype,"serviceMachineIdResource",null),he([L.memoize],w.prototype,"telemetryLogResource",null),he([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function t(d,m){return S(d["inspect-extensions"],d["inspect-brk-extensions"],5870,m,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=t;function k(d,m){return S(d["inspect-search"],d["inspect-brk-search"],5876,m,d.extensionEnvironment)}e.parseSearchPort=k;function b(d,m){return S(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,m,d.extensionEnvironment)}e.parsePtyHostPort=b;function S(d,m,E,y,c,h){const u=Number(m||d)||(y?null:E),i=u?Boolean(!!m):!1;let l;if(h)try{l=JSON.parse(h)}catch{}return{port:u,break:i,debugId:c,env:l}}}),define(Q[87],J([0,1,238,3,133]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,M.localize)(0,null),e:(0,M.localize)(1,null),t:(0,M.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,M.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,M.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,M.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,M.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,M.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,M.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,M.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,M.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,M.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,M.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,M.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,M.localize)(14,null)},category:{type:"string",cat:"e",description:(0,M.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,M.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,M.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,M.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,M.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,M.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,M.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,M.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,M.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,M.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,M.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,M.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,M.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,M.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,M.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,m,E=I){const y={},c=[],h=[];for(let l in m){const s=m[l];s.alias&&(y[l]=s.alias),s.type==="string"||s.type==="string[]"?(c.push(l),s.deprecates&&c.push(s.deprecates)):s.type==="boolean"&&(h.push(l),s.deprecates&&h.push(s.deprecates))}const o=v(d,{string:c,boolean:h,alias:y}),u={},i=o;u._=o._.map(l=>String(l)).filter(l=>l.length>0),delete i._;for(let l in m){const s=m[l];s.alias&&delete i[s.alias];let r=i[l];s.deprecates&&i.hasOwnProperty(s.deprecates)&&(r||(r=i[s.deprecates]),delete i[s.deprecates]),typeof r!="undefined"&&(s.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):s.type==="string"&&Array.isArray(r)&&(r=r.pop(),E.onMultipleValues(l,r)),u[l]=r),delete i[l]}for(let l in i)E.onUnknownOption(l);return u}e.parseArgs=n;function f(d,m){let E="";return m.args&&(Array.isArray(m.args)?E=` <${m.args.join("> <")}>`:E=` <${m.args}>`),m.alias?`-${m.alias} --${d}${E}`:`--${d}${E}`}function w(d,m){let E=0,y=[];for(const u in d){const i=d[u],l=f(u,i);E=Math.max(E,l.length),y.push([l,i.description])}let c=E+2+1;if(m-c<25)return y.reduce((u,i)=>u.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let h=m-c-1,o=[];for(const u of y){let i=u[0],l=k(u[1],h),s=t(c-i.length-2);o.push("  "+i+s+l[0]);for(let r=1;r<l.length;r++)o.push(t(c)+l[r])}return o}e.formatOptions=w;function t(d){return" ".repeat(d)}function k(d,m){let E=[];for(;d.length;){let y=d.length<m?d.length:d.lastIndexOf(" ",m),c=d.slice(0,y).trim();d=d.slice(y),E.push(c)}return E}function b(d,m,E,y,c=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${E}`];o.push(""),o.push(`${(0,M.localize)(32,null)}: ${m} [${(0,M.localize)(33,null)}][${(0,M.localize)(34,null)}...]`),o.push(""),c&&(L.isWindows?o.push((0,M.localize)(35,null,m)):o.push((0,M.localize)(36,null,m)),o.push(""));const u={};for(const i in y){const l=y[i];if(l.description&&l.cat){let s=u[l.cat];s||(u[l.cat]=s={}),s[i]=l}}for(let i in u){const l=i;let s=u[l];s&&(o.push(D[l]),o.push(...w(s,h)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=b;function S(d,m){return`${d||(0,M.localize)(37,null)}
${m||(0,M.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=S}),define(Q[157],J([0,1,59,154,87]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class D extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,f,w){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1]):super.call(n,f,w)}async openExtensionDevelopmentHostWindow(n,f){const w=(0,M.parseArgs)(n,M.OPTIONS);w.debugRenderer=f;const t=w.extensionDevelopmentPath;if(!t)return{success:!1};const[k]=this.windowsMainService.openExtensionDevelopmentHostWindow(t,{context:5,cli:w});if(!f)return{success:!0};const b=k.win;if(!b)return{success:!0};const S=b.webContents.debugger;let d=S.isAttached()?Infinity:0;const m=(0,v.createServer)(E=>{d++==0&&S.attach();let y=!1;const c=u=>{y||E.write(JSON.stringify(u)+"\0")},h=(u,i,l,s)=>c({method:i,params:l,sessionId:s});b.on("close",()=>{S.removeListener("message",h),E.end(),y=!0}),S.addListener("message",h);let o=Buffer.alloc(0);E.on("data",u=>{o=Buffer.concat([o,u]);for(let i=o.indexOf(0);i!==-1;i=o.indexOf(0)){let l;try{const s=o.slice(0,i).toString("utf8");o=o.slice(i+1),l=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}S.sendCommand(l.method,l.params,l.sessionId).then(s=>c({id:l.id,sessionId:l.sessionId,result:s})).catch(s=>c({id:l.id,sessionId:l.sessionId,error:{code:0,message:s.message}}))}}),E.on("error",u=>{console.error("error on cdp pipe:",u)}),E.on("close",()=>{y=!0,--d==0&&S.detach()})});return await new Promise(E=>m.listen(0,E)),b.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=D}),function(){"use strict";function V(e,v,L,M){function D(n){const f=I(n),w=[f];return e.isAbsolute(f)||w.unshift(M),e.resolve(...w)}function I(n){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const t=n["user-data-dir"];if(t)return t;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(k,"AppData","Roaming")}break;case"darwin":w=e.join(v.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:D}}if(typeof define=="function")define(Q[158],J([0,239,25,10,15,32]),function(e,v,L,M,D,I){const n=D.dirname(M.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(D.joinPath(n,"package.json").fsPath);return V(v,L,f.name,I.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),L=require("os");module.exports=V(v,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[159],J([0,1,25,156,158]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends L.AbstractNativeEnvironmentService{constructor(n,f){super(n,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,M.getUserDataPath)(n)},f)}}e.NativeEnvironmentService=D}),define(Q[160],J([0,1,31,25,8]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function D(I){const n=(0,M.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(n,""),I&&console.log(`Marker file for --wait created: ${n}`),n}catch(f){I&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=D}),define(Q[161],J([0,1,137]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,M=/^-(\d{4})(\d{2})(\d{2})$/;function D(b){return b=b.trim(),b==="*"||L.test(b)}e.isValidVersionStr=D;function I(b){if(!D(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=b.match(L);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=I;function n(b){if(!b)return null;let S=b.majorBase,d=b.majorMustEqual,m=b.minorBase,E=b.minorMustEqual,y=b.patchBase,c=b.patchMustEqual;b.hasCaret&&(S===0||(E=!1),c=!1);let h=0;if(b.preRelease){const o=M.exec(b.preRelease);if(o){const[,u,i,l]=o;h=Date.UTC(Number(u),Number(i)-1,Number(l))}}return{majorBase:S,majorMustEqual:d,minorBase:m,minorMustEqual:E,patchBase:y,patchMustEqual:c,isMinimum:b.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function f(b,S,d){let m;typeof b=="string"?m=n(I(b)):m=b;let E;S instanceof Date?E=S.getTime():typeof S=="string"&&(E=new Date(S).getTime());let y;if(typeof d=="string"?y=n(I(d)):y=d,!m||!y)return!1;let c=m.majorBase,h=m.minorBase,o=m.patchBase,u=y.majorBase,i=y.minorBase,l=y.patchBase,s=y.notBefore,r=y.majorMustEqual,a=y.minorMustEqual,g=y.patchMustEqual;return y.isMinimum?c>u?!0:c<u?!1:h>i?!0:h<i||E&&E<s?!1:o>=l:(c===1&&u===0&&(!r||!a||!g)&&(u=1,i=0,l=0,r=!0,a=!1,g=!1),c<u?!1:c>u?!r:h<i?!1:h>i?!a:o<l?!1:o>l?!g:!(E&&E<s))}e.isValidVersion=f;function w(b,S,d,m){return d.isBuiltin||typeof d.main=="undefined"?!0:k(b,S,d.engines.vscode,m)}e.isValidExtensionVersion=w;function t(b,S,d){return b==="*"||k(S,d,b)}e.isEngineValid=t;function k(b,S,d,m=[]){let E=n(I(d));if(!E)return m.push(v.localize(0,null,d)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return m.push(v.localize(1,null,d)),!1}else if(!E.majorMustEqual)return m.push(v.localize(2,null,d)),!1;return f(b,S,E)?!0:(m.push(v.localize(3,null,b,d)),!1)}}),define(Q[162],J([0,1,2,10,35,71]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends v.Disposable{constructor(f,w,t,k){super();this.requests=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=k,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new D.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=M.ProxyChannel.toService((0,M.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.watch(this.requests)}setVerboseLogging(f){this.verboseLogging=f,this.isDisposed||this.service?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}watch(f){this.requests=f,this.service?.watch(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(Q[163],J([0,1,2,10,35,71]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends v.Disposable{constructor(f,w,t,k){super();this.requests=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=k,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new D.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (parcel)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=M.ProxyChannel.toService((0,M.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.watch(this.requests)}setVerboseLogging(f){this.verboseLogging=f,this.isDisposed||this.service?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${f}`})}watch(f){this.requests=f,this.service?.watch(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(Q[164],J([0,1,2,10,35,71]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends v.Disposable{constructor(f,w,t,k,b={}){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=k,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new D.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=M.ProxyChannel.toService((0,M.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.watch(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}watch(f){this.folders=f,this.service&&this.service.watch(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(Q[72],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(M,D=[],I=!1){this.ctor=M,this.staticArguments=D,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=v}),define(Q[165],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=v;class L{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let I of this._nodes.values())I.outgoing.size===0&&D.push(I);return D}insertEdge(D,I){const n=this.lookupOrInsertNode(D),f=this.lookupOrInsertNode(I);n.outgoing.set(this._hashFn(I),f),f.incoming.set(this._hashFn(D),n)}removeNode(D){const I=this._hashFn(D);this._nodes.delete(I);for(let n of this._nodes.values())n.outgoing.delete(I),n.incoming.delete(I)}lookupOrInsertNode(D){const I=this._hashFn(D);let n=this._nodes.get(I);return n||(n=new v(D),this._nodes.set(I,n)),n}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[I,n]of this._nodes)D.push(`${I}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,I]of this._nodes){const n=new Set([D]),f=this._findCycle(I,n);if(f)return f}}_findCycle(D,I){for(let[n,f]of D.outgoing){if(I.has(n))return[...I,n].join(" -> ");I.add(n);const w=this._findCycle(f,I);if(w)return w;I.delete(n)}}}e.Graph=L}),define(Q[5],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=f})(v=e._util||(e._util={})),e.IInstantiationService=M("instantiationService");function L(n,f,w,t){f[v.DI_TARGET]===f?f[v.DI_DEPENDENCIES].push({id:n,index:w,optional:t}):(f[v.DI_DEPENDENCIES]=[{id:n,index:w,optional:t}],f[v.DI_TARGET]=f)}function M(n){if(v.serviceIds.has(n))return v.serviceIds.get(n);const f=function(w,t,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,w,k,!1)};return f.toString=()=>n,v.serviceIds.set(n,f),f}e.createDecorator=M;function D(n){return n}e.refineServiceDecorator=D;function I(n){return function(f,w,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,f,t,!0)}}e.optional=I}),define(Q[73],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function L(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=L}),define(Q[88],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class L{constructor(D){this.machineId=D}encryption(){return new Promise((D,I)=>V(["vscode-encrypt"],D,I))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch(I){return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch(I){return D}}}e.EncryptionMainService=L}),define(Q[48],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[166],J([0,1,10,136,5]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var D;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));function I(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function n(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=n;function f(c,h){switch(c){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=f;function w(c,h){return h==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function t(c,h,o){return w(h,o)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===o?!0:k(o).includes(c)}e.isTargetPlatformCompatible=t;function k(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function b(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=b;var S;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var d;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var m;(function(c){c.Install="install",c.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var E;(function(c){c[c.None=0]="None",c[c.Install=1]="Install",c[c.Update=2]="Update"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class y extends Error{constructor(h,o){super(h);this.code=o,this.name=o}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,M.createDecorator)("IExtensionManagementCLIService")}),define(Q[167],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Q[89],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Q[168],J([0,1,44,10,8,3,79,19,70,138,89]),function(V,e,v,L,M,D,I,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=w.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends b{openTerminal(o,u){return this.spawnTerminal(v,o,f.getWindowsShell(),u)}spawnTerminal(o,u,i,l){const s=u.windowsExec||S.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const r=M.basename(s).toLowerCase();if(r==="cmder"||r==="cmder.exe")return o.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return s.indexOf(" ")>=0&&a.push('""'),a.push(s),(r==="wt"||r==="wt.exe")&&a.push("-d ."),new Promise((g,p)=>{const P=E(process),R=o.spawn(i,a,{cwd:l,env:P});R.on("error",p),R.on("exit",()=>g())})}runInTerminal(o,u,i,l,s){const r="windowsExec"in s&&s.windowsExec?s.windowsExec:S.getDefaultTerminalWindows();return new Promise((a,g)=>{const p=`"${u} - ${k}"`,P=`""${i.join('" "')}" & pause"`,R=["/c","start",p,"/wait",r,"/c",P],A=Object.assign({},E(process),l);Object.keys(A).filter(x=>A[x]===null).forEach(x=>delete A[x]);const W={cwd:u,env:A,windowsVerbatimArguments:!0};v.spawn(S.CMD,R,W).on("error",x=>{g(y(x))}),a(void 0)})}static getDefaultTerminalWindows(){if(!S._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return S._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=S,S.CMD="cmd.exe";class d extends b{openTerminal(o,u){return this.spawnTerminal(v,o,u)}runInTerminal(o,u,i,l,s){const r=s.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((a,g)=>{if(r===t.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const p=r===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`,V).fsPath,"-t",o||k,"-w",u];for(let j of i)R.push("-a"),R.push(j);if(l){const j=Object.assign({},E(process),l);for(let x in j){const re=j[x];re===null?(R.push("-u"),R.push(x)):(R.push("-e"),R.push(`${x}=${re}`))}}let A="";const W=v.spawn(d.OSASCRIPT,R);W.on("error",j=>{g(y(j))}),W.stderr.on("data",j=>{A+=j.toString()}),W.on("exit",j=>{if(j===0)a(void 0);else if(A){const x=A.split(`
`,1);g(new Error(x[0]))}else g(new Error(w.localize(1,null,p,j)))})}else g(new Error(w.localize(2,null,r)))})}spawnTerminal(o,u,i){const l=u.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((s,r)=>{const a=["-a",l];i&&a.push(i);const g=E(process),p=o.spawn("/usr/bin/open",a,{cwd:i,env:g});p.on("error",r),p.on("exit",()=>s())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class m extends b{openTerminal(o,u){return this.spawnTerminal(v,o,u)}runInTerminal(o,u,i,l,s){const r=s.linuxExec?Promise.resolve(s.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((a,g)=>{let p=[];r.then(P=>{P.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const R=`${c(i)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;p.push(`''${R}''`);const A=Object.assign({},E(process),l);Object.keys(A).filter(re=>A[re]===null).forEach(re=>delete A[re]);const W={cwd:u,env:A};let j="";const x=v.spawn(P,p,W);x.on("error",re=>{g(y(re))}),x.stderr.on("data",re=>{j+=re.toString()}),x.on("exit",re=>{if(re===0)a(void 0);else if(j){const K=j.split(`
`,1);g(new Error(K[0]))}else g(new Error(w.localize(4,null,P,re)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!D.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await n.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{o?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,u,i){const l=u.linuxExec?Promise.resolve(u.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((s,r)=>{l.then(a=>{const g=E(process),p=o.spawn(a,[],{cwd:i,env:g});p.on("error",r),p.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=w.localize(3,null);function E(h){const o={...h.env};return(0,I.sanitizeProcessEnvironment)(o),o}function y(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(w.localize(5,null,h.path)):h}function c(h){let o="";for(let u of h)u.indexOf(" ")>=0?o+='"'+u+'"':o+=u,o+=" ";return o}}),define(Q[20],J([0,1,40,8,27,13,7,140,5]),function(V,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function w(F){return F.create===!0}e.isFileOpenForWriteOptions=w;var t;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var k;(function(F){F[F.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var b;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=S;function d(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=d;function m(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function E(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=E;var y;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(H,z){super(H);this.code=z}}e.FileSystemProviderError=c;function h(F,H){const z=new c(F.toString(),H);return u(z,H),z}e.createFileSystemProviderError=h;function o(F){return F||h((0,n.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=o;function u(F,H){return F.name=H?`${H} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=u;function i(F){if(!F)return y.Unknown;if(F instanceof c)return F.code;const H=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!H)return y.Unknown;switch(H[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=i;function l(F){if(F instanceof P)return F.fileOperationResult;switch(i(F)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var s;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(H,z,B){this.resource=H,this.operation=z,this.target=B}isOperation(H){return this.operation===H}}e.FileOperationEvent=r;var a;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class g{constructor(H,z){this.added=void 0,this.updated=void 0,this.deleted=void 0;const B=new Map;for(const C of H){const U=B.get(C.type);U?U.push([C.resource,C]):B.set(C.type,[[C.resource,C]])}for(const[C,U]of B)switch(C){case 1:this.added=v.TernarySearchTree.forUris(()=>z),this.added.fill(U);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>z),this.updated.fill(U);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>z),this.deleted.fill(U);break}}contains(H,...z){return this.doContains(H,{includeChildren:!1},...z)}affects(H,...z){return this.doContains(H,{includeChildren:!0},...z)}doContains(H,z,...B){if(!H)return!1;const C=B.length>0;return!!((!C||B.includes(1))&&(this.added?.get(H)||z.includeChildren&&this.added?.findSuperstr(H))||(!C||B.includes(0))&&(this.updated?.get(H)||z.includeChildren&&this.updated?.findSuperstr(H))||(!C||B.includes(2))&&(this.deleted?.findSubstr(H)||z.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=g;function p(F,H,z){return!F||!H||F===H||H.length>F.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),z?(0,M.startsWithIgnoreCase)(F,H):F.indexOf(H)===0)}e.isParent=p;class P extends Error{constructor(H,z,B){super(H);this.fileOperationResult=z,this.options=B}}e.FileOperationError=P;class R extends P{constructor(H,z,B){super(H,2,B);this.stat=z}}e.NotModifiedSinceFileOperationError=R;var A;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var W;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(W=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function j(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=j;async function x(F,H){if(!H.hasProvider(I.URI.from({scheme:F.scheme})))return new Promise(z=>{const B=H.onDidChangeFileSystemProviderRegistrations(C=>{C.scheme===F.scheme&&C.added&&(B.dispose(),z())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(H){return(0,D.isNumber)(H)||(H=0),H<re.KB?(0,n.localize)(1,null,H.toFixed(0)):H<re.MB?(0,n.localize)(2,null,(H/re.KB).toFixed(2)):H<re.GB?(0,n.localize)(3,null,(H/re.MB).toFixed(2)):H<re.TB?(0,n.localize)(4,null,(H/re.GB).toFixed(2)):(0,n.localize)(5,null,(H/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var K;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function ee(F){return{maxFileSize:F===0?300*re.MB:16*re.GB,maxHeapSize:F===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=ee}),define(Q[54],J([0,1,240,134,87,20]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function I(b,S){const d={onUnknownOption:E=>{console.warn((0,L.localize)(0,null,E))},onMultipleValues:(E,y)=>{console.warn((0,L.localize)(1,null,E,y))}},m=(0,M.parseArgs)(b,M.OPTIONS,S?d:void 0);return m.goto&&m._.forEach(E=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,L.localize)(2,null))),m["max-memory"]&&v(parseInt(m["max-memory"])>=D.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${D.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function n(b){const S=b.findIndex(d=>!/^-/.test(d));if(S>-1)return[...b.slice(0,S),...b.slice(S+1)]}function f(b){let[,...S]=b;process.env.VSCODE_DEV&&(S=n(S)||[]);const d=!k(process.env);return I(S,d)}e.parseMainProcessArgv=f;function w(b){const[,,...S]=b;return I(S,!0)}e.parseCLIProcessArgv=w;function t(b,...S){const d=b.indexOf("--");return d===-1?b.push(...S):b.splice(d,0,...S),b}e.addArg=t;function k(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),define(Q[90],J([0,1,44,8,135,23,60,17,3,28,129,54,9]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const S=1e4;let d;async function m(y,c,h){return c["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(h)&&!c["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(h)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=b.Promises.withAsyncBody(async(o,u)=>{const i=new D.CancellationTokenSource,l=setTimeout(()=>{i.dispose(!0),u(new Error((0,M.localize)(0,null)))},S);try{o(await E(y,i.token))}catch(s){!(0,n.isPromiseCanceledError)(s)&&!i.token.isCancellationRequested?u(new Error((0,M.localize)(1,null,(0,I.toErrorMessage)(s)))):o({})}finally{clearTimeout(l),i.dispose()}})),d)}e.resolveShellEnv=m;async function E(y,c){const h=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",o);const u=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(u+"(.*)"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};y.trace("getUnixShellEnvironment#env",l);const s=await(0,t.getSystemShell)(f.OS,l);return y.trace("getUnixShellEnvironment#shell",s),new Promise((r,a)=>{if(c.isCancellationRequested)return a((0,n.canceled)());const g=(0,L.basename)(s);let p,P;/^pwsh(-preview)?$/.test(g)?(p=`& '${process.execPath}' -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,P=["-Login","-Command"]):(p=`'${process.execPath}' -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,P=["-ilc"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),p);const R=(0,v.spawn)(s,[...P,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});c.onCancellationRequested(()=>(R.kill(),a((0,n.canceled)()))),R.on("error",j=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,I.toErrorMessage)(j)),a(j)});const A=[];R.stdout.on("data",j=>A.push(j));const W=[];R.stderr.on("data",j=>W.push(j)),R.on("close",(j,x)=>{const re=Buffer.concat(A).toString("utf8");y.trace("getUnixShellEnvironment#raw",re);const K=Buffer.concat(W).toString("utf8");if(K.trim()&&y.trace("getUnixShellEnvironment#stderr",K),j||x)return a(new Error((0,M.localize)(2,null,j,x)));const ee=i.exec(re),F=ee?ee[1]:"{}";try{const H=JSON.parse(F);h?H.ELECTRON_RUN_AS_NODE=h:delete H.ELECTRON_RUN_AS_NODE,o?H.ELECTRON_NO_ATTACH_CONSOLE=o:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",H),r(H)}catch(H){y.error("getUnixShellEnvironment#errorCaught",(0,I.toErrorMessage)(H)),a(H)}})})}}),define(Q[91],J([0,1,3,7,20]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function D(f){return f.map(w=>({type:w.type,resource:L.URI.file(w.path)}))}e.toFileChanges=D;function I(f){const w=new n;for(const t of f)w.processEvent(t);return w.normalize()}e.normalizeFileChanges=I;class n{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(w){return v.isLinux?w.path:w.path.toLowerCase()}processEvent(w){const t=this.mapPathToChange.get(this.toKey(w));let k=!1;if(t){const b=t.type,S=w.type;t.path!==w.path&&w.type===2?k=!0:b===1&&S===2?(this.mapPathToChange.delete(this.toKey(w)),this.normalized.delete(t)):b===2&&S===1?t.type=0:b===1&&S===0||(t.type=S)}else k=!0;k&&(this.normalized.add(w),this.mapPathToChange.set(this.toKey(w),w))}normalize(){const w=[],t=[];return Array.from(this.normalized).filter(k=>k.type!==2?(w.push(k),!1):!0).sort((k,b)=>k.path.length-b.path.length).filter(k=>t.some(b=>(0,M.isParent)(k.path,b,!v.isLinux))?!1:(t.push(k.path),!0)).concat(w)}}}),define(Q[169],J([0,1,9,2,8,82,19,116,91]),function(V,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(k,b,S,d){super();this.path=k,this.onDidFilesChange=b,this.onLogMessage=S,this.verboseLogging=d,this.fileChangesDelayer=this._register(new v.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(k){this.verboseLogging=k}async startWatching(){try{const{stat:k,symbolicLink:b}=await I.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let S=this.path;if(b)try{S=await(0,D.realpath)(S)}catch(d){if(this.onError(d),b.dangling)return}k.isDirectory()?this._register((0,n.watchFolder)(S,(d,m)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,M.join)(this.path,(0,M.basename)(m))})},d=>this.onError(d))):this._register((0,n.watchFile)(S,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(k){k.code!=="ENOENT"&&this.onError(k)}}onFileChange(k){this.fileChangesBuffer.push(k),this.verboseLogging&&this.onVerbose(`${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,f.normalizeFileChanges)(b);if(this.verboseLogging)for(const d of S)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);S.length>0&&this.onDidFilesChange(S)})}onError(k){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${k}`})}onVerbose(k){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${k}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Q[74],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...M){this._entries=new Map;for(let[D,I]of M)this.set(D,I)}set(M,D){const I=this._entries.get(M);return this._entries.set(M,D),I}has(M){return this._entries.has(M)}get(M){return this._entries.get(M)}}e.ServiceCollection=v}),define(Q[170],J([0,1,9,17,72,165,5,74]),function(V,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class w extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class t{constructor(d=new n.ServiceCollection,m=!1,E){this._activeInstantiations=new Set,this._services=d,this._strict=m,this._parent=E,this._services.set(I.IInstantiationService,this)}createChild(d){return new t(d,this._strict,this)}invokeFunction(d,...m){let E=b.traceInvocation(d),y=!1;try{return d({get:(h,o)=>{if(y)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(h,E);if(!u&&o!==I.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return u}},...m)}finally{y=!0,E.stop()}}createInstance(d,...m){let E,y;return d instanceof M.SyncDescriptor?(E=b.traceCreation(d.ctor),y=this._createInstance(d.ctor,d.staticArguments.concat(m),E)):(E=b.traceCreation(d),y=this._createInstance(d,m,E)),E.stop(),y}_createInstance(d,m=[],E){let y=I._util.getServiceDependencies(d).sort((o,u)=>o.index-u.index),c=[];for(const o of y){let u=this._getOrCreateServiceInstance(o.id,E);if(!u&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);c.push(u)}let h=y.length>0?y[0].index:m.length;if(m.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${m.length} static arguments`);let o=h-m.length;o>0?m=m.concat(new Array(o)):m=m.slice(0,h)}return new d(...[...m,...c])}_setServiceInstance(d,m){if(this._services.get(d)instanceof M.SyncDescriptor)this._services.set(d,m);else if(this._parent)this._parent._setServiceInstance(d,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let m=this._services.get(d);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):m}_getOrCreateServiceInstance(d,m){let E=this._getServiceInstanceOrDescriptor(d);return E instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,E,m.branch(d,!0)):(m.branch(d,!1),E)}_safeCreateAndCacheServiceInstance(d,m,E){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,m,E)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,m,E){const y=new D.Graph(o=>o.id.toString());let c=0;const h=[{id:d,desc:m,_trace:E}];for(;h.length;){const o=h.pop();if(y.lookupOrInsertNode(o),c++>1e3)throw new w(y);for(let u of I._util.getServiceDependencies(o.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(u.id);if(!i&&!u.optional&&console.warn(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`),i instanceof M.SyncDescriptor){const l={id:u.id,desc:i,_trace:o._trace.branch(u.id,!0)};y.insertEdge(o,l),h.push(l)}}}for(;;){const o=y.roots();if(o.length===0){if(!y.isEmpty())throw new w(y);break}for(const{data:u}of o){if(this._getServiceInstanceOrDescriptor(u.id)instanceof M.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}y.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,m,E=[],y,c){if(this._services.get(d)instanceof M.SyncDescriptor)return this._createServiceInstance(m,E,y,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,m,E,y,c);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(d,m=[],E,y){if(E){const c=new v.IdleValue(()=>this._createInstance(d,m,y));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let u=c.value,i=u[o];return typeof i!="function"||(i=i.bind(u),h[o]=i),i},set(h,o,u){return c.value[o]=u,!0}})}else return this._createInstance(d,m,y)}}e.InstantiationService=t;var k;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(k||(k={}));class b{constructor(d,m){this.type=d,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return f?new b(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(d){return f?new b(0,d.name):b._None}branch(d,m){let E=new b(2,d.toString());return this._dep.push([d,m,E]),E}stop(){let d=Date.now()-this._start;b._totals+=d;let m=!1;function E(c,h){let o=[],u=new Array(c+1).join("	");for(const[i,l,s]of h._dep)if(l&&s){m=!0,o.push(`${u}CREATES -> ${i}`);let r=E(c+1,s);r&&o.push(r)}else o.push(`${u}uses -> ${i}`);return o.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(d>2||m)&&console.log(y.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(Q[171],J([0,1,17,127,57]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class D extends M.ResolvedKeybinding{constructor(n,f){super();if(f.length===0)throw(0,v.illegalArgument)("parts");this._os=n,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new M.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=D}),define(Q[172],J([0,1,57,171]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class M extends L.BaseResolvedKeybinding{constructor(I,n){super(n,I.parts)}_keyCodeToUILabel(I){if(this._os===2)switch(I){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(I)}_getLabel(I){return I.isDuplicateModifierCase()?"":this._keyCodeToUILabel(I.keyCode)}_getAriaLabel(I){return I.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(I.keyCode)}_getElectronAccelerator(I){return v.KeyCodeUtils.toElectronAccelerator(I.keyCode)}_getUserSettingsLabel(I){if(I.isDuplicateModifierCase())return"";const n=v.KeyCodeUtils.toUserSettingsUS(I.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(I){return M.getDispatchStr(I)}static getDispatchStr(I){if(I.isModifierKey())return null;let n="";return I.ctrlKey&&(n+="ctrl+"),I.shiftKey&&(n+="shift+"),I.altKey&&(n+="alt+"),I.metaKey&&(n+="meta+"),n+=v.KeyCodeUtils.toString(I.keyCode),n}_getSingleModifierDispatchPart(I){return I.keyCode===5&&!I.shiftKey&&!I.altKey&&!I.metaKey?"ctrl":I.keyCode===4&&!I.ctrlKey&&!I.altKey&&!I.metaKey?"shift":I.keyCode===6&&!I.ctrlKey&&!I.shiftKey&&!I.metaKey?"alt":I.keyCode===57&&!I.ctrlKey&&!I.shiftKey&&!I.altKey?"meta":null}}e.USLayoutResolvedKeybinding=M}),define(Q[173],J([0,1,9]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(M,D){if(M.length===0)return Promise.resolve(!1);const I=[];let n=!1;for(let f of M){if(f===!0)return Promise.resolve(!0);(0,v.isThenable)(f)&&I.push(f.then(w=>{w&&(n=!0)},w=>{D(w),n=!0}))}return v.Promises.settled(I).then(()=>n)}e.handleVetos=L}),define(Q[6],J([0,1,60,4,2,3,5]),function(V,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function n(){return new Date().toISOString()}var f;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class w extends M.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class t extends w{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...l){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...l]))}debug(i,...l){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...l]))}info(i,...l){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...l]))}warn(i,...l){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...l]))}error(i,...l){if(this.checkLogLevel(f.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(f.Error,this.format(s))}else this.log(f.Error,this.format([i,...l]))}critical(i,...l){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...l]))}flush(){}format(i){let l="";for(let s=0;s<i.length;s++){let r=i[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}l+=(s>0?" ":"")+r}return l}}e.AbstractMessageLogger=t;class k extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!D.isWindows}trace(i,...l){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...l):console.log(`[main ${n()}]`,i,...l))}debug(i,...l){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...l):console.log(`[main ${n()}]`,i,...l))}info(i,...l){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...l):console.log(`[main ${n()}]`,i,...l))}warn(i,...l){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,i,...l):console.warn(`[main ${n()}]`,i,...l))}error(i,...l){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,i,...l):console.error(`[main ${n()}]`,i,...l))}critical(i,...l){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,i,...l):console.error(`[main ${n()}]`,i,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class b extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...l){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...l)}debug(i,...l){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...l)}info(i,...l){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...l)}warn(i,...l){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...l)}error(i,...l){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...l)}critical(i,...l){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...l)}dispose(){}flush(){}}e.ConsoleLogger=b;class S extends w{constructor(i,l=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(l)}trace(i,...l){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...l])}debug(i,...l){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...l])}info(i,...l){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...l])}warn(i,...l){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...l])}error(i,...l){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...l])}critical(i,...l){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...l])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class d extends w{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const l of this.logServices)l.setLevel(i);super.setLevel(i)}trace(i,...l){for(const s of this.logServices)s.trace(i,...l)}debug(i,...l){for(const s of this.logServices)s.debug(i,...l)}info(i,...l){for(const s of this.logServices)s.info(i,...l)}warn(i,...l){for(const s of this.logServices)s.warn(i,...l)}error(i,...l){for(const s of this.logServices)s.error(i,...l)}critical(i,...l){for(const s of this.logServices)s.critical(i,...l)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class m extends M.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...l){this.logger.trace(i,...l)}debug(i,...l){this.logger.debug(i,...l)}info(i,...l){this.logger.info(i,...l)}warn(i,...l){this.logger.warn(i,...l)}error(i,...l){this.logger.error(i,...l)}critical(i,...l){this.logger.critical(i,...l)}flush(){this.logger.flush()}}e.LogService=m;class E extends M.Disposable{constructor(i,l){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(l(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,l){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,l?.always?f.Trace:this.logLevel,l),this.loggers.set(i.toString(),s),l?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class y{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...l){}debug(i,...l){}info(i,...l){}warn(i,...l){}error(i,...l){}critical(i,...l){}dispose(){}flush(){}}e.NullLogService=y;function c(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const i=h(u.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function h(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=h;function o(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o});var te=this&&this.__param||function(V,e){return function(v,L){e(v,L,V)}};define(Q[174],J([0,1,9,18,39,78,48,20,5,6]),function(V,e,v,L,M,D,I,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var t;(function(b){b.ERROR_INVALID_FILE="ERROR_INVALID_FILE",b.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(t=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let k=class{constructor(S,d,m){this.environmentService=S,this.fileService=d,this.logService=m,this.queue=new v.Queue}async updateSettings(S,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,S,d))}async doWrite(S,d,m){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,S.toString(),d);const{value:E,mtime:y,etag:c}=await this.fileService.readFile(S,{atomic:!0});let h=E.toString();const o=[];if((0,M.parse)(h,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const u=this.getEdits(d,h,m)[0];if(u){h=h.substring(0,u.offset)+u.content+h.substring(u.offset+u.length);try{await this.fileService.writeFile(S,L.VSBuffer.fromString(h),{etag:c,mtime:y})}catch(i){if(i.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:S,path:d},m,E){return d.length?(0,D.setProperty)(m,d,S,E):[{content:JSON.stringify(S,null,E.insertSpaces&&E.tabSize?" ".repeat(E.tabSize):"	"),length:m.length,offset:0}]}};k=he([te(0,I.IEnvironmentService),te(1,n.IFileService),te(2,w.ILogService)],k),e.UserConfigurationFileService=k}),define(Q[92],J([0,1,6]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(D,I){switch(I){case v.LogLevel.Trace:return D.trace;case v.LogLevel.Debug:return D.debug;case v.LogLevel.Info:return D.info;case v.LogLevel.Warning:return D.warn;case v.LogLevel.Error:return D.error;case v.LogLevel.Critical:return D.critical;default:throw new Error("Invalid log level")}}class M extends v.AbstractLogger{constructor(I=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(I),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(I){this._logger=I;for(const{level:n,args:f}of this.buffer)L(I,n).apply(I,f);this.buffer=[]}_log(I,...n){this._logger?L(this._logger,I).apply(this._logger,n):this.getLevel()<=I&&this.buffer.push({level:I,args:n})}trace(I,...n){this._log(v.LogLevel.Trace,I,...n)}debug(I,...n){this._log(v.LogLevel.Debug,I,...n)}info(I,...n){this._log(v.LogLevel.Info,I,...n)}warn(I,...n){this._log(v.LogLevel.Warning,I,...n)}error(I,...n){this._log(v.LogLevel.Error,I,...n)}critical(I,...n){this._log(v.LogLevel.Critical,I,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=M}),define(Q[175],J([0,1,9,18,15,20,5,92,6]),function(V,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*D.ByteSize.MB;let t=class extends f.AbstractLogger{constructor(S,d,m,E,y){super();this.name=S,this.resource=d,this.donotUseFormatters=E,this.fileService=y,this.backupIndex=1,this.setLevel(m),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const S=arguments[0];if(S instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=S.stack,this._log(f.LogLevel.Error,this.format(d))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(S,d){this._log(S,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(S){if(S.fileOperationResult!==3)throw S}}_log(S,d){this.queue.queue(async()=>{await this.initializePromise;let m=await this.loadContent();m.length>w&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(m)),m=""),this.donotUseFormatters?m+=d:m+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(S)}] ${d}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(m))})}getCurrentTimestamp(){const S=E=>E<10?`0${E}`:E,d=E=>E<10?`00${E}`:E<100?`0${E}`:E,m=new Date;return`${m.getFullYear()}-${S(m.getMonth()+1)}-${S(m.getDate())} ${S(m.getHours())}:${S(m.getMinutes())}:${S(m.getSeconds())}.${d(m.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(S){return""}}stringifyLogLevel(S){switch(S){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(S){let d="";for(let m=0;m<S.length;m++){let E=S[m];if(typeof E=="object")try{E=JSON.stringify(E)}catch(y){}d+=(m>0?" ":"")+E}return d}};t=he([te(4,D.IFileService)],t),e.FileLogger=t;let k=class extends f.AbstractLoggerService{constructor(S,d,m){super(S.getLevel(),S.onDidChangeLogLevel);this.instantiationService=d,this.fileService=m}doCreateLogger(S,d,m){const E=new n.BufferLogService(d);return(0,D.whenProviderRegistered)(S,this.fileService).then(()=>E.logger=this.instantiationService.createInstance(t,(0,M.basename)(S),S,E.getLevel(),!!m?.donotUseFormatters)),E}};k=he([te(0,f.ILogService),te(1,I.IInstantiationService),te(2,D.IFileService)],k),e.FileLoggerService=k}),define(Q[176],J([0,1,4,7,6]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class D{constructor(b){this.service=b,this.onDidChangeLogLevel=v.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(b,S,d){switch(S){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=D;class I{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){I.setLevel(this.channel,b)}static setLevel(b,S){return b.call("setLevel",S)}}e.LogLevelChannelClient=I;class n{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,S){throw new Error(`Event not found: ${S}`)}async call(b,S,d){switch(S){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${S}`)}createLogger(b,S){this.loggers.set(b.toString(),this.loggerService.createLogger(b,S))}consoleLog(b,S){let d=console.log;switch(b){case M.LogLevel.Error:d=console.error;break;case M.LogLevel.Warning:d=console.warn;break;case M.LogLevel.Info:d=console.info;break}d.call(console,...S)}log(b,S){const d=this.loggers.get(b.toString());if(!d)throw new Error("Create the logger before logging");for(const[m,E]of S)switch(m){case M.LogLevel.Trace:d.trace(E);break;case M.LogLevel.Debug:d.debug(E);break;case M.LogLevel.Info:d.info(E);break;case M.LogLevel.Warning:d.warn(E);break;case M.LogLevel.Error:d.error(E);break;case M.LogLevel.Critical:d.critical(E);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class f extends M.AbstractLoggerService{constructor(b,S,d){super(b,S);this.channel=d}createConsoleMainLogger(){return new M.AdapterLogger({log:(b,S)=>{this.channel.call("consoleLog",[b,S])}})}doCreateLogger(b,S,d){return new w(this.channel,b,S,d)}}e.LoggerChannelClient=f;class w extends M.AbstractMessageLogger{constructor(b,S,d,m){super(m?.always);this.channel=b,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[S,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,S){const d=[[b,S]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(b){this.channel.call("log",[this.file,b])}}class t extends M.LogService{constructor(b,S){super(S);this.parent=b,this._register(b.onDidChangeLogLevel(d=>S.setLevel(d)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=t}),define(Q[93],J([0,1,20,6]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function M(f,w,t,k){try{const b=await new Promise((S,d)=>{V(["spdlog"],S,d)});return b.setFlushOn(L.LogLevel.Trace),b.createAsyncRotatingLogger(f,w,t,k)}catch(b){console.error(b)}return null}function D(f,w,t,k){const b=V.__$__nodeRequire("spdlog");return b.setFlushOn(L.LogLevel.Trace),b.createRotatingLogger(f,w,t,k)}e.createRotatingLogger=D;function I(f,w,t){switch(w){case L.LogLevel.Trace:f.trace(t);break;case L.LogLevel.Debug:f.debug(t);break;case L.LogLevel.Info:f.info(t);break;case L.LogLevel.Warning:f.warn(t);break;case L.LogLevel.Error:f.error(t);break;case L.LogLevel.Critical:f.critical(t);break;default:throw new Error("Invalid log level")}}class n extends L.AbstractMessageLogger{constructor(w,t,k,b){super();this.name=w,this.filepath=t,this.rotating=k,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}_createSpdLogLogger(){const w=this.rotating?6:1,t=30/w*v.ByteSize.MB;return M(this.name,this.filepath,t,w).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:b,message:S}of this.buffer)I(this._logger,b,S);this.buffer=[]}})}log(w,t){this._logger?I(this._logger,w,t):this.getLevel()<=w&&this.buffer.push({level:w,message:t})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Q[177],J([0,1,10,15,28,20,175,6,93]),function(V,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(k,b){super(k.getLevel(),k.onDidChangeLogLevel);this.fileService=b}doCreateLogger(k,b,S){if(k.scheme===v.Schemas.file){const d=new f.SpdLogLogger(S?.name||(0,M.generateUuid)(),k.fsPath,!S?.donotRotate,b);return S?.donotUseFormatters&&d.clearFormatters(),d}else return new I.FileLogger(S?.name??(0,L.basename)(k),k,b,!!S?.donotUseFormatters,this.fileService)}};w=he([te(0,n.ILogService),te(1,D.IFileService)],w),e.LoggerService=w}),define(Q[178],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(I){return I.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function L(I){return I.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function M(I){return I.uri!==void 0}e.isMenubarMenuItemRecentAction=M;function D(I){return!v(I)&&!L(I)&&!M(I)}e.isMenubarMenuItemAction=D}),define(Q[45],J([0,1,10,3,32,15]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)I=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const n=(0,D.dirname)(v.FileAccess.asFileUri("",V));I=V.__$__nodeRequire((0,D.joinPath)(n,"product.json").fsPath);const f=V.__$__nodeRequire((0,D.joinPath)(n,"package.json").fsPath);M.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`}),Object.assign(I,{version:f.version})}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=I}),define(Q[94],J([0,1,18,17,141,20,45]),function(V,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(k,b,S,d,m,E){let y;try{await f(k,b,S,d,m,E)}catch(c){y=c}finally{y&&m.errorTransformer&&(y=m.errorTransformer(y)),typeof y!="undefined"&&S.error(y),S.end()}}e.readFileIntoStream=n;async function f(k,b,S,d,m,E){w(E);const y=await k.open(b,{create:!1});try{w(E);let c=0,h=0,o=m&&typeof m.length=="number"?m.length:void 0,u=v.VSBuffer.alloc(Math.min(m.bufferSize,typeof o=="number"?o:m.bufferSize)),i=m&&typeof m.position=="number"?m.position:0,l=0;do h=await k.read(y,i,u.buffer,l,u.byteLength-l),i+=h,l+=h,c+=h,typeof o=="number"&&(o-=h),l===u.byteLength&&(await S.write(d(u)),u=v.VSBuffer.alloc(Math.min(m.bufferSize,typeof o=="number"?o:m.bufferSize)),l=0);while(h>0&&(typeof o!="number"||o>0)&&w(E)&&t(c,m));if(l>0){let s=l;typeof o=="number"&&(s=Math.min(l,o)),S.write(d(u.slice(0,s)))}}catch(c){throw(0,D.ensureFileSystemProviderError)(c)}finally{await k.close(y)}}function w(k){if(k.isCancellationRequested)throw(0,L.canceled)();return!0}function t(k,b){if(b?.limits){if(typeof b.limits.memory=="number"&&k>b.limits.memory)throw(0,D.createFileSystemProviderError)((0,M.localize)(0,null,I.default.nameShort),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&k>b.limits.size)throw(0,D.createFileSystemProviderError)((0,M.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[179],J([0,1,30,9,18,23,4,66,2,40,10,75,15,67,139,20,94,6]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class Ve extends f.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new I.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new I.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new I.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new I.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new I.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new I.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new m.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new m.FileChangesEvent(u,!0)))),this.watchedResources=w.TernarySearchTree.forUris(u=>{const i=this.getProvider(u.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,u){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:u});const i=new f.DisposableStore;return i.add(u.onDidChangeFile(l=>this.onDidChangeFile(l,this.isPathCaseSensitive(u)))),i.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:o}))),typeof u.onDidErrorOccur=="function"&&i.add(u.onDidErrorOccur(l=>this._onError.fire(new Error(l)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:u}),this.provider.delete(o),(0,f.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){u.push(i)}}),!this.provider.has(o)&&await L.Promises.settled(u)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,u){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&u)}listCapabilities(){return n.Iterable.map(this.provider,([o,u])=>({scheme:o,capabilities:u.capabilities}))}async withProvider(o){if(!(0,b.isAbsolutePath)(o))throw new m.FileOperationError((0,d.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const u=this.provider.get(o.scheme);if(!u){const i=new Error;throw i.name="ENOPRO",i.message=(0,d.localize)(1,null,o.toString()),i}return u}async withReadProvider(o){const u=await this.withProvider(o);if((0,m.hasOpenReadWriteCloseCapability)(u)||(0,m.hasReadWriteCapability)(u)||(0,m.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const u=await this.withProvider(o);if((0,m.hasOpenReadWriteCloseCapability)(u)||(0,m.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,u){try{return await this.doResolveFile(o,u)}catch(i){throw(0,m.toFileSystemProviderErrorCode)(i)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,d.localize)(2,null,this.resourceForError(o)),1):(0,m.ensureFileSystemProviderError)(i)}}async doResolveFile(o,u){const i=await this.withProvider(o),l=this.isPathCaseSensitive(i),s=u?.resolveTo,r=u?.resolveSingleChildDescendants,a=u?.resolveMetadata,g=await i.stat(o);let p;return this.toFileStat(i,o,g,void 0,!!a,(P,R)=>(p||(p=w.TernarySearchTree.forUris(()=>!l),p.set(o,!0),s&&p.fill(!0,s)),p.get(P.resource)||p.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&r?R===1:!1))}async toFileStat(o,u,i,l,s,r){const{providerExtUri:a}=this.getExtUri(o),g={resource:u,name:a.basename(u),isFile:(i.type&m.FileType.File)!=0,isDirectory:(i.type&m.FileType.Directory)!=0,isSymbolicLink:(i.type&m.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&m.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,m.etag)({mtime:i.mtime,size:i.size})};if(g.isDirectory&&r(g,l)){try{const p=await o.readdir(u),P=await L.Promises.settled(p.map(async([R,A])=>{try{const W=a.joinPath(u,R),j=s?await o.stat(W):{type:A};return await this.toFileStat(o,W,j,p.length,s,r)}catch(W){return this.logService.trace(W),null}}));g.children=(0,v.coalesce)(P)}catch(p){this.logService.trace(p),g.children=[]}return g}return g}async resolveAll(o){return L.Promises.settled(o.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(o){const u=await this.withProvider(o);try{return!!await u.stat(o)}catch(i){return!1}}async canCreateFile(o,u){try{await this.doValidateCreateFile(o,u)}catch(i){return i}return!0}async doValidateCreateFile(o,u){if(!u?.overwrite&&await this.exists(o))throw new m.FileOperationError((0,d.localize)(3,null,this.resourceForError(o)),3,u)}async createFile(o,u=M.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const l=await this.writeFile(o,u);return this._onDidRunOperation.fire(new m.FileOperationEvent(o,0,l)),l}async writeFile(o,u,i){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(l);try{await this.validateWriteFile(l,o,i)||await this.mkdirp(l,s.dirname(o));let a;if((0,m.hasReadWriteCapability)(l)&&!(u instanceof M.VSBuffer))if((0,S.isReadableStream)(u)){const g=await(0,S.peekStream)(u,3);g.ended?a=M.VSBuffer.concat(g.buffer):a=g}else a=(0,S.peekReadable)(u,g=>M.VSBuffer.concat(g),3);else a=u;!(0,m.hasOpenReadWriteCloseCapability)(l)||(0,m.hasReadWriteCapability)(l)&&a instanceof M.VSBuffer?await this.doWriteUnbuffered(l,o,i,a):await this.doWriteBuffered(l,o,i,a instanceof M.VSBuffer?(0,M.bufferToReadable)(a):a)}catch(r){throw new m.FileOperationError((0,d.localize)(4,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),i)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,u,i){if(!!i?.unlock&&!(o.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(u)));let s;try{s=await o.stat(u)}catch(r){return}if((s.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,d.localize)(6,null,this.resourceForError(u)),0,i);if(this.throwIfFileIsReadonly(u,s),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==m.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&i.mtime<s.mtime&&i.etag!==(0,m.etag)({mtime:i.mtime,size:s.size}))throw new m.FileOperationError((0,d.localize)(7,null),3,i);return s}async readFile(o,u){const i=await this.withReadProvider(o);return u?.atomic?this.doReadFileAtomic(i,o,u):this.doReadFile(i,o,u)}async doReadFileAtomic(o,u,i){return new Promise((l,s)=>{this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,u,i);l(r)}catch(r){s(r)}})})}async doReadFile(o,u,i){const l=await this.doReadFileStream(o,u,{...i,preferUnbuffered:!0});return{...l,value:await(0,M.streamToBuffer)(l.value)}}async readFileStream(o,u){const i=await this.withReadProvider(o);return this.doReadFileStream(i,o,u)}async doReadFileStream(o,u,i){const l=new D.CancellationTokenSource,s=this.validateReadFile(u,i).then(a=>a,a=>{throw l.cancel(),a});let r;try{return typeof i?.etag=="string"&&i.etag!==m.ETAG_DISABLED&&await s,!((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasFileReadStreamCapability)(o))||(0,m.hasReadWriteCapability)(o)&&i?.preferUnbuffered?r=this.readFileUnbuffered(o,u,i):(0,m.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,u,l.token,i):r=this.readFileBuffered(o,u,l.token,i),{...await s,value:r}}catch(a){r&&await(0,S.consumeStream)(r);const g=(0,d.localize)(8,null,this.resourceForError(u),(0,m.ensureFileSystemProviderError)(a).toString());throw a instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(g,a.stat,i):new m.FileOperationError(g,(0,m.toFileOperationResult)(a),i)}}readFileStreamed(o,u,i,l=Object.create(null)){const s=o.readFileStream(u,l,i);return(0,S.transform)(s,{data:r=>r instanceof M.VSBuffer?r:M.VSBuffer.wrap(r),error:r=>new m.FileOperationError((0,d.localize)(9,null,this.resourceForError(u),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),l)},r=>M.VSBuffer.concat(r))}readFileBuffered(o,u,i,l=Object.create(null)){const s=(0,M.newWriteableBufferStream)();return(0,E.readFileIntoStream)(o,u,s,r=>r,{...l,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new m.FileOperationError((0,d.localize)(10,null,this.resourceForError(u),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),l)},i),s}readFileUnbuffered(o,u,i){const l=(0,S.newWriteableStream)(s=>M.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(u);typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.validateReadFileLimits(u,s.byteLength,i),l.end(M.VSBuffer.wrap(s))}catch(s){l.error(s),l.end()}})(),l}async validateReadFile(o,u){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new m.FileOperationError((0,d.localize)(11,null,this.resourceForError(o)),0,u);if(typeof u?.etag=="string"&&u.etag!==m.ETAG_DISABLED&&u.etag===i.etag)throw new m.NotModifiedSinceFileOperationError((0,d.localize)(12,null),i,u);return this.validateReadFileLimits(o,i.size,u),i}validateReadFileLimits(o,u,i){if(i?.limits){let l;if(typeof i.limits.memory=="number"&&u>i.limits.memory&&(l=9),typeof i.limits.size=="number"&&u>i.limits.size&&(l=7),typeof l=="number")throw new m.FileOperationError((0,d.localize)(13,null,this.resourceForError(o)),l)}}async canMove(o,u,i){return this.doCanMoveCopy(o,u,"move",i)}async canCopy(o,u,i){return this.doCanMoveCopy(o,u,"copy",i)}async doCanMoveCopy(o,u,i,l){if(o.toString()!==u.toString())try{const s=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(s,o,r,u,i,l)}catch(s){return s}return!0}async move(o,u,i){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(l,o,s,u,"move",!!i),a=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,u,i){const l=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(l,o,s,u,"copy",!!i),a=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,u,i,l,s,r){if(u.toString()===l.toString())return s;const{exists:a,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(o,u,i,l,s,r);if(a&&!g&&r&&await this.del(l,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(l)),s==="copy"){if(o===i&&(0,m.hasFileFolderCopyCapability)(o))await o.copy(u,l,{overwrite:r});else{const p=await this.resolve(u);p.isDirectory?await this.doCopyFolder(o,p,i,l):await this.doCopyFile(o,u,i,l)}return s}else return o===i?(await o.rename(u,l,{overwrite:r}),s):(await this.doMoveCopy(o,u,i,l,"copy",r),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(o,u,i,l){if((0,m.hasOpenReadWriteCloseCapability)(o)&&(0,m.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,u,i,l);if((0,m.hasOpenReadWriteCloseCapability)(o)&&(0,m.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,u,i,l);if((0,m.hasReadWriteCapability)(o)&&(0,m.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,u,i,l);if((0,m.hasReadWriteCapability)(o)&&(0,m.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,u,i,l)}async doCopyFolder(o,u,i,l){await i.mkdir(l),Array.isArray(u.children)&&await L.Promises.settled(u.children.map(async s=>{const r=this.getExtUri(i).providerExtUri.joinPath(l,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),i,r):this.doCopyFile(o,s.resource,i,r)}))}async doValidateMoveCopy(o,u,i,l,s,r){let a=!1;if(o===i){const{providerExtUri:p,isPathCaseSensitive:P}=this.getExtUri(o);if(P||(a=p.isEqual(u,l)),a&&s==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(u),this.resourceForError(l)));if(!a&&p.isEqualOrParent(l,u))throw new Error((0,d.localize)(15,null,this.resourceForError(u),this.resourceForError(l)))}const g=await this.exists(l);if(g&&!a){if(!r)throw new m.FileOperationError((0,d.localize)(16,null,this.resourceForError(u),this.resourceForError(l)),4);if(o===i){const{providerExtUri:p}=this.getExtUri(o);if(p.isEqualOrParent(u,l))throw new Error((0,d.localize)(17,null,this.resourceForError(u),this.resourceForError(l)))}}return{exists:g,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const u=this.isPathCaseSensitive(o);return{providerExtUri:u?b.extUri:b.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(u,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,0,i)),i}async mkdirp(o,u){const i=[],{providerExtUri:l}=this.getExtUri(o);for(;!l.isEqual(u,l.dirname(u));)try{if(((await o.stat(u)).type&m.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(u)));break}catch(s){if((0,m.toFileSystemProviderErrorCode)(s)!==m.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(l.basename(u)),u=l.dirname(u)}for(let s=i.length-1;s>=0;s--){u=l.joinPath(u,i[s]);try{await o.mkdir(u)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,u){try{await this.doValidateDelete(o,u)}catch(i){return i}return!0}async doValidateDelete(o,u){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!u?.useTrash&&!(i.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(o)));let s;try{s=await i.stat(o)}catch(a){}if(s)this.throwIfFileIsReadonly(o,s);else throw new m.FileOperationError((0,d.localize)(20,null,this.resourceForError(o)),1);if(!!!u?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(o)))}return i}async del(o,u){const i=await this.doValidateDelete(o,u),l=!!u?.useTrash,s=!!u?.recursive;await i.delete(o,{recursive:s,useTrash:l}),this._onDidRunOperation.fire(new m.FileOperationEvent(o,1))}onDidChangeFile(o,u){this._onDidChangeFilesRaw.fire({changes:o});let i,l;{for(const s of o)this.watchedResources.has(s.resource)?(i||(i=[]),i.push(s)):(l||(l=[]),l.push(s));i&&this._onDidFilesChange.fire(new m.FileChangesEvent(i,!u))}if(l){const s=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!s.work(l)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),s.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${s.pending}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,u={recursive:!1,excludes:[]}){const i=new f.DisposableStore;{let l=!1,s=()=>{l=!0};i.add((0,f.toDisposable)(()=>s())),this.doWatch(o,u).then(r=>{l?(0,f.dispose)(r):s=()=>(0,f.dispose)(r)},r=>this.logService.error(r))}return u.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),i.add((0,f.toDisposable)(()=>{const l=this.watchedResources.get(o);typeof l=="number"&&(l<=1?this.watchedResources.delete(o):this.watchedResources.set(o,l-1))}))),i}async doWatch(o,u){const i=await this.withProvider(o),l=this.toWatchKey(i,o,u),s=this.activeWatchers.get(l)||{count:0,disposable:i.watch(o,u)};return this.activeWatchers.has(l)||this.activeWatchers.set(l,s),s.count+=1,(0,f.toDisposable)(()=>{s.count--,s.count===0&&((0,f.dispose)(s.disposable),this.activeWatchers.delete(l))})}toWatchKey(o,u,i){const{providerExtUri:l}=this.getExtUri(o);return[l.getComparisonKey(u),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,f.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,u,i,l){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{const s=await o.open(u,{create:!0,unlock:i?.unlock??!1});try{(0,S.isReadableStream)(l)||(0,S.isReadableBufferedStream)(l)?await this.doWriteStreamBufferedQueued(o,s,l):await this.doWriteReadableBufferedQueued(o,s,l)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await o.close(s)}})}async doWriteStreamBufferedQueued(o,u,i){let l=0,s;if((0,S.isReadableBufferedStream)(i)){if(i.buffer.length>0){const r=M.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,u,r,r.byteLength,l,0),l+=r.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((r,a)=>{(0,S.listenStream)(s,{onData:async g=>{s.pause();try{await this.doWriteBuffer(o,u,g,g.byteLength,l,0)}catch(p){return a(p)}l+=g.byteLength,setTimeout(()=>s.resume())},onError:g=>a(g),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,u,i){let l=0,s;for(;(s=i.read())!==null;)await this.doWriteBuffer(o,u,s,s.byteLength,l,0),l+=s.byteLength}async doWriteBuffer(o,u,i,l,s,r){let a=0;for(;a<l;)a+=await o.write(u,s+a,i.buffer,r+a,l-a)}async doWriteUnbuffered(o,u,i,l){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,u,i,l))}async doWriteUnbufferedQueued(o,u,i,l){let s;l instanceof M.VSBuffer?s=l:(0,S.isReadableStream)(l)?s=await(0,M.streamToBuffer)(l):(0,S.isReadableBufferedStream)(l)?s=await(0,M.bufferedStreamToBuffer)(l):s=(0,M.readableToBuffer)(l),await o.writeFile(u,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(o,u,i,l){return this.writeQueue.queueFor(l,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,u,i,l))}async doPipeBufferedQueued(o,u,i,l){let s,r;try{s=await o.open(u,{create:!1}),r=await i.open(l,{create:!0,unlock:!1});const a=M.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,p=0,P=0;do P=await o.read(s,g,a.buffer,p,a.byteLength-p),await this.doWriteBuffer(i,r,a,P,g,p),g+=P,p+=P,p===a.byteLength&&(p=0);while(P>0)}catch(a){throw(0,m.ensureFileSystemProviderError)(a)}finally{await L.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof r=="number"?i.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,u,i,l){return this.writeQueue.queueFor(l,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,u,i,l))}async doPipeUnbufferedQueued(o,u,i,l){return i.writeFile(l,await o.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,u,i,l){return this.writeQueue.queueFor(l,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,u,i,l))}async doPipeUnbufferedToBufferedQueued(o,u,i,l){const s=await i.open(l,{create:!0,unlock:!1});try{const r=await o.readFile(u);await this.doWriteBuffer(i,s,M.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await i.close(s)}}async doPipeBufferedToUnbuffered(o,u,i,l){const s=await(0,M.streamToBuffer)(this.readFileBuffered(o,u,D.CancellationToken.None));await this.doWriteUnbuffered(i,l,void 0,s)}throwIfFileSystemIsReadonly(o,u){if(o.capabilities&2048)throw new m.FileOperationError((0,d.localize)(22,null,this.resourceForError(u)),6);return o}throwIfFileIsReadonly(o,u){if((u.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,d.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===t.Schemas.file?o.fsPath:o.toString(!0)}};c.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},c=he([te(0,y.ILogService)],c),e.FileService=c}),define(Q[180],J([0,1,30,9,18,4,33,2,8,3,15,67,19,142,20,94,169,162,163,164,91,6,45]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h,o,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class l extends n.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=D.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:g}=await b.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,g),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await b.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),g=[];return await Promise.all(a.map(async p=>{try{let P;p.isSymbolicLink()?P=(await this.stat((0,t.joinPath)(r,p.name))).type:P=this.toType(p),g.push([p.name,P])}catch(P){this.logService.trace(P)}})),g}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let g;return a?.dangling?g=d.FileType.Unknown:r.isFile()?g=d.FileType.File:r.isDirectory()?g=d.FileType.Directory:g=d.FileType.Unknown,a&&(g|=d.FileType.SymbolicLink),g}async readFile(r){try{const a=this.toFilePath(r);return await b.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,g){const p=(0,k.newWriteableStream)(P=>M.VSBuffer.concat(P.map(R=>M.VSBuffer.wrap(R))).buffer);return(0,m.readFileIntoStream)(this,r,p,P=>P.buffer,{...a,bufferSize:this.BUFFER_SIZE},g),p}async writeFile(r,a,g){let p;try{const P=this.toFilePath(r);if(!g.create||!g.overwrite){if(await b.Promises.exists(P)){if(!g.overwrite)throw(0,d.createFileSystemProviderError)((0,S.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!g.create)throw(0,d.createFileSystemProviderError)((0,S.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:g.unlock}),await this.write(p,0,a,0,a.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(r,P)}finally{typeof p=="number"&&await this.close(p)}}async open(r,a){try{const g=this.toFilePath(r);if((0,d.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:R}=await b.SymlinkSupport.stat(g);R.mode&128||await b.Promises.chmod(g,R.mode|128)}catch(R){this.logService.trace(R)}let p;if((0,d.isFileOpenForWriteOptions)(a)){if(w.isWindows)try{await b.Promises.truncate(g,0),p="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}p||(p="w")}else p="r";const P=await b.Promises.open(g,p);return this.mapHandleToPos.set(P,0),(0,d.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(P,r),P}catch(g){throw(0,d.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,g):this.toFileSystemProviderError(g)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await b.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await b.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,g,p,P){const R=this.normalizePos(r,a);let A=null;try{const W=await b.Promises.read(r,g,p,P,R);return typeof W=="number"?A=W:A=W.bytesRead,A}catch(W){throw this.toFileSystemProviderError(W)}finally{this.updatePos(r,R,A)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,g){const p=this.mapHandleToPos.get(r);typeof p=="number"&&(typeof a=="number"||(typeof g=="number"?this.mapHandleToPos.set(r,p+g):this.mapHandleToPos.delete(r)))}async write(r,a,g,p,P){return(0,L.retry)(()=>this.doWrite(r,a,g,p,P),100,3)}async doWrite(r,a,g,p,P){const R=this.normalizePos(r,a);let A=null;try{const W=await b.Promises.write(r,g,p,P,R);return typeof W=="number"?A=W:A=W.bytesWritten,A}catch(W){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),W)}finally{this.updatePos(r,R,A)}}async mkdir(r){try{await b.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const g=this.toFilePath(r);await this.doDelete(g,a)}catch(g){throw this.toFileSystemProviderError(g)}}async doDelete(r,a){a.recursive?await b.Promises.rm(r,b.RimRafMode.MOVE):await b.Promises.unlink(r)}async rename(r,a,g){const p=this.toFilePath(r),P=this.toFilePath(a);if(p!==P)try{await this.validateTargetDeleted(r,a,"move",g.overwrite),await b.Promises.move(p,P)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,S.localize)(2,null,(0,f.basename)(p),(0,f.basename)((0,f.dirname)(P)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(r,a,g){const p=this.toFilePath(r),P=this.toFilePath(a);if(p!==P)try{await this.validateTargetDeleted(r,a,"copy",g.overwrite),await b.Promises.copy(p,P,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,S.localize)(3,null,(0,f.basename)(p),(0,f.basename)((0,f.dirname)(P)),R.toString()))),this.toFileSystemProviderError(R)}}async validateTargetDeleted(r,a,g,p){const P=this.toFilePath(r),R=this.toFilePath(a);let A=!1;if(!!(this.capabilities&1024)||(A=(0,I.isEqual)(P,R,!0)),A&&g==="copy")throw(0,d.createFileSystemProviderError)((0,S.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!A&&await b.Promises.exists(R)){if(!p)throw(0,d.createFileSystemProviderError)((0,S.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a):this.watchNonRecursive(r)}watchRecursive(r,a){const g={path:this.toFilePath(r),excludes:a.excludes},p=(0,v.insert)(this.recursiveFoldersToWatch,g);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{p(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof y.FileWatcher||this.recursiveWatcher instanceof c.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;if(this.options?.watcher?.usePolling)r=h.FileWatcher,a=this.options?.watcher;else{let g=!1;this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?g=this.options.legacyWatcher==="on":i.default.quality==="stable"&&(g=this.recursiveFoldersToWatch.length===1),g?w.isLinux?r=h.FileWatcher:r=y.FileWatcher:r=c.FileWatcher}this.recursiveWatcher=new r(this.recursiveFoldersToWatch,g=>this._onDidChangeFile.fire((0,o.toFileChanges)(g)),g=>{g.type==="error"&&this._onDidWatchErrorOccur.fire(g.message),this.logService[g.type](g.message)},this.logService.getLevel()===u.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new E.FileWatcher(this.toFilePath(r),p=>this._onDidChangeFile.fire((0,o.toFileChanges)(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===u.LogLevel.Trace),g=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)});return(0,n.combinedDisposable)(a,g)}toFilePath(r){return(0,f.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof d.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=d.FileSystemProviderErrorCode.NoPermissions;break;default:a=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let g=this.toFileSystemProviderError(a);if(r&&g.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await b.SymlinkSupport.stat(this.toFilePath(r));p.mode&128||(g=(0,d.createFileSystemProviderError)(a,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return g}dispose(){super.dispose(),(0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,n.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=l}),define(Q[21],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Q[181],J([0,1,58,6,21]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let D=class{constructor(n,f){this.productService=n,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(f);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,t,k]=w;let b=this.trustedExtensionUrlPublicKeys.get(n);if(!b){if(b=this.productService.trustedExtensionUrlPublicKeys[n],!b||b.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...b])}const S=Buffer.from(decodeURIComponent(k),"base64");if(S.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const d=S.slice(0,6),m=S.readUIntBE(0,6),E=Date.now()-m;if(E<0||E>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const y=S.slice(6),c=v.createVerify("SHA256");c.write(d),c.write(Buffer.from(t)),c.end();for(let h=0;h<b.length;h++){let o=b[h];if(o!==null){if(typeof o=="string")try{o=v.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),b[h]=o}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,u),b[h]=null;continue}if(c.verify(o,y))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};D=he([te(0,M.IProductService),te(1,L.ILogService)],D),e.ExtensionUrlTrustService=D}),define(Q[55],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Q[182],J([0,1,14,2,40,10,3,15,7,28,48,6]),function(V,e,v,L,M,D,I,n,f,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let b=class extends L.Disposable{constructor(d,m){super();this.logService=m,this.validRoots=M.TernarySearchTree.forUris(()=>!I.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(d.appRoot)),this.addValidFileRoot(f.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=v.session;d.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(m,E)=>this.handleResourceRequest(m,E)),d.protocol.interceptFileProtocol(D.Schemas.file,(m,E)=>this.handleFileRequest(m,E)),this._register((0,L.toDisposable)(()=>{d.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?L.Disposable.None:(this.validRoots.set(d,!0),(0,L.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,m){const E=f.URI.parse(d.url);return this.logService.error(`Refused to load resource ${E.fsPath} from ${D.Schemas.file}: protocol (original URL: ${d.url})`),m({error:-3})}handleResourceRequest(d,m){const E=f.URI.parse(d.url),y=D.FileAccess.asFileUri(E);return this.validRoots.findSubstr(y)?m({path:y.fsPath}):this.validExtensions.has((0,n.extname)(y))?m({path:y.fsPath}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${y.fsPath} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),m({error:-3}))}createIPCObjectUrl(){let d;const m=f.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),E=m.toString(),y=async()=>d;return v.ipcMain.handle(E,y),this.logService.trace(`IPC Object URL: Registered new channel ${E}.`),{resource:m,update:c=>d=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${E}.`),v.ipcMain.removeHandler(E)}}}};b=he([te(0,t.INativeEnvironmentService),te(1,k.ILogService)],b),e.ProtocolMainService=b}),define(Q[37],J([0,1,102,13]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class M{constructor(){this.data=new Map}add(I,n){v.ok(L.isString(I)),v.ok(L.isObject(n)),v.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,n)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new M}),define(Q[183],J([0,1,4,37]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function M(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class D{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,w){this.schemasById[M(f)]=w,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new D;L.Registry.add(e.Extensions.JSONContribution,I)}),define(Q[49],J([0,1,30,4,13,131,183,37]),function(V,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(f=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=n.Registry.as(I.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,o=!0){this.registerConfigurations([h],o)}registerConfigurations(h,o=!0){const u=this.doRegisterConfigurations(h,o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(h){const o=this.doDeregisterConfigurations(h);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:h,remove:o}){const u=[];u.push(...this.doDeregisterConfigurations(o)),u.push(...this.doRegisterConfigurations(h,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,v.distinct)(u))}registerDefaultConfigurations(h){const o=[],u=[];for(const i of h)for(const l in i)if(o.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]={...this.defaultValues[l]||{},...i[l]};const s={type:"object",default:this.defaultValues[l],description:D.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};u.push(S(l)),this.configurationProperties[l]=s,this.defaultLanguageConfigurationOverridesNode.properties[l]=s}else{this.defaultValues[l]=i[l];const s=this.configurationProperties[l];s&&(this.updatePropertyDefaultValue(l,s),this.updateSchema(l,s))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(h){const o=[];for(const u of h)for(const i in u)if(o.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const l=this.configurationProperties[i];l&&(this.updatePropertyDefaultValue(i,l),this.updateSchema(i,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const o of h)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,o){const u=[];return h.forEach(i=>{u.push(...this.validateAndRegisterProperties(i,o,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),u}doDeregisterConfigurations(h){const o=[],u=i=>{if(i.properties)for(const l in i.properties)o.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,i.properties[l]);i.allOf&&i.allOf.forEach(l=>u(l))};for(const i of h){u(i);const l=this.configurationContributors.indexOf(i);l!==-1&&this.configurationContributors.splice(l,1)}return o}validateAndRegisterProperties(h,o=!0,u,i=3){i=M.isUndefinedOrNull(h.scope)?i:h.scope;let l=[],s=h.properties;if(s)for(let a in s){if(o&&E(a)){delete s[a];continue}const g=s[a];if(this.updatePropertyDefaultValue(a,g),e.OVERRIDE_PROPERTY_PATTERN.test(a)?g.scope=void 0:(g.scope=M.isUndefinedOrNull(g.scope)?i:g.scope,g.restricted=M.isUndefinedOrNull(g.restricted)?!!u?.restrictedConfigurations?.includes(a):g.restricted),s[a].hasOwnProperty("included")&&!s[a].included){this.excludedConfigurationProperties[a]=s[a],delete s[a];continue}else this.configurationProperties[a]=s[a];!s[a].deprecationMessage&&s[a].markdownDeprecationMessage&&(s[a].deprecationMessage=s[a].markdownDeprecationMessage),l.push(a)}let r=h.allOf;if(r)for(let a of r)l.push(...this.validateAndRegisterProperties(a,o,u,i));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const o=u=>{let i=u.properties;if(i)for(const s in i)this.updateSchema(s,i[s]);let l=u.allOf;l&&l.forEach(o)};o(h)}updateSchema(h,o){switch(e.allSettings.properties[h]=o,o.scope){case 1:e.applicationSettings.properties[h]=o;break;case 2:e.machineSettings.properties[h]=o;break;case 6:e.machineOverridableSettings.properties[h]=o;break;case 3:e.windowSettings.properties[h]=o;break;case 4:e.resourceSettings.properties[h]=o;break;case 5:e.resourceSettings.properties[h]=o,this.resourceLanguageSettingsSchema.properties[h]=o;break}}removeFromSchema(h,o){switch(delete e.allSettings.properties[h],o.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const o=`[${h}]`,u={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,o){let u=this.defaultValues[h];M.isUndefined(u)&&(u=o.default),M.isUndefined(u)&&(u=d(o.type)),o.default=u}}const b="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(b);function S(c){return c.substring(1,c.length-1)}e.overrideIdentifierFromKey=S;function d(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const m=new k;n.Registry.add(e.Extensions.Configuration,m);function E(c){return c.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(c)?D.localize(5,null,c):m.getConfigurationProperties()[c]!==void 0?D.localize(6,null,c):null:D.localize(4,null)}e.validateProperty=E;function y(){const c=[],h=m.getConfigurationProperties();for(const o of Object.keys(h))c.push([o,h[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=y}),define(Q[16],J([0,1,43,13,7,49,5,37]),function(V,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function f(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof M.URI)}e.isConfigurationOverrides=f;var w;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function k(l,s){const r=s?l?s.keys.filter(W=>l.keys.indexOf(W)===-1):[...s.keys]:[],a=l?s?l.keys.filter(W=>s.keys.indexOf(W)===-1):[...l.keys]:[],g=[];if(s&&l){for(const W of l.keys)if(s.keys.indexOf(W)!==-1){const j=y(l.contents,W),x=y(s.contents,W);v.equals(j,x)||g.push(W)}}const p=[],P=W=>{const j={};for(const x of W)for(const re of x.identifiers)j[u(re)]=x;return j},R=s?P(s.overrides):{},A=l?P(l.overrides):{};if(Object.keys(R).length)for(const W of r){const j=R[W];j&&p.push([(0,D.overrideIdentifierFromKey)(W),j.keys])}if(Object.keys(A).length)for(const W of a){const j=A[W];j&&p.push([(0,D.overrideIdentifierFromKey)(W),j.keys])}if(Object.keys(R).length&&Object.keys(A).length)for(const W of g){const j=A[W],x=R[W];if(j&&x){const re=k({contents:j.contents,keys:j.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});p.push([(0,D.overrideIdentifierFromKey)(W),[...re.added,...re.removed,...re.updated]])}}return{added:r,removed:a,updated:g,overrides:p}}e.compare=k;function b(l,s){const r=[];for(const a of Object.keys(l))if(D.OVERRIDE_PROPERTY_PATTERN.test(a)){const g={};for(const p in l[a])g[p]=l[a][p];r.push({identifiers:[(0,D.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(g),contents:S(g,s)})}return r}e.toOverrides=b;function S(l,s){const r=Object.create(null);for(let a in l)d(r,a,l[a],s);return r}e.toValuesTree=S;function d(l,s,r,a){const g=s.split("."),p=g.pop();let P=l;for(let R=0;R<g.length;R++){let A=g[R],W=P[A];switch(typeof W){case"undefined":W=P[A]=Object.create(null);break;case"object":break;default:a(`Ignoring ${s} as ${g.slice(0,R+1).join(".")} is ${JSON.stringify(W)}`);return}P=W}if(typeof P=="object"&&P!==null)try{P[p]=r}catch(R){a(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(P)}`)}else a(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=d;function m(l,s){const r=s.split(".");E(l,r)}e.removeFromValueTree=m;function E(l,s){const r=s.shift();if(s.length===0){delete l[r];return}if(Object.keys(l).indexOf(r)!==-1){const a=l[r];typeof a=="object"&&!Array.isArray(a)&&(E(a,s),Object.keys(a).length===0&&delete l[r])}}function y(l,s,r){function a(P,R){let A=P;for(const W of R){if(typeof A!="object"||A===null)return;A=A[W]}return A}const g=s.split("."),p=a(l,g);return typeof p=="undefined"?r:p}e.getConfigurationValue=y;function c(l,s,r){Object.keys(s).forEach(a=>{a!=="__proto__"&&(a in l?L.isObject(l[a])&&L.isObject(s[a])?c(l[a],s[a],r):r&&(l[a]=s[a]):l[a]=s[a])})}e.merge=c;function h(){const l=n.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(l)}e.getConfigurationKeys=h;function o(){const l=Object.create(null),s=n.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let r in s){let a=s[r].default;d(l,r,a,g=>console.error(`Conflict in default settings: ${g}`))}return l}e.getDefaultValues=o;function u(l){return`[${l}]`}e.keyFromOverrideIdentifier=u;function i(l,s,r){const a=l.inspect(s),g=l.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:a.defaultValue}e.getMigratedSettingValue=i}),define(Q[184],J([0,1,30,4,39,2,40,43,13,7,16,49,37]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(i={},l=[],s=[]){this._contents=i,this._keys=l,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,l){const s=this.getContentsForOverrideIdentifer(l);return s?i?(0,t.getConfigurationValue)(s,i):s:void 0}getKeysForOverrideIdentifier(i){for(const l of this.overrides)if(l.identifiers.indexOf(i)!==-1)return l.keys;return[]}override(i){let l=this.overrideConfigurations.get(i);return l||(l=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,l)),l}merge(...i){const l=n.deepClone(this.contents),s=n.deepClone(this.overrides),r=[...this.keys];for(const a of i){this.mergeContents(l,a.contents);for(const g of a.overrides){const[p]=s.filter(P=>v.equals(P.identifiers,g.identifiers));p?this.mergeContents(p.contents,g.contents):s.push(n.deepClone(g))}for(const g of a.keys)r.indexOf(g)===-1&&r.push(g)}return new S(l,r,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const l=this.getContentsForOverrideIdentifer(i);if(!l||typeof l!="object"||!Object.keys(l).length)return this;let s={};for(const r of v.distinct([...Object.keys(this.contents),...Object.keys(l)])){let a=this.contents[r],g=l[r];g&&(typeof a=="object"&&typeof g=="object"?(a=n.deepClone(a),this.mergeContents(a,g)):a=g),s[r]=a}return new S(s,this.keys,this.overrides)}mergeContents(i,l){for(const s of Object.keys(l)){if(s in i&&f.isObject(i[s])&&f.isObject(l[s])){this.mergeContents(i[s],l[s]);continue}i[s]=n.deepClone(l[s])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?n.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const l of this.overrides)if(l.identifiers.indexOf(i)!==-1)return l.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,l){this.addKey(i),(0,t.addToValueTree)(this.contents,i,l,s=>{throw new Error(s)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let l=this.keys.length;for(let s=0;s<l;s++)i.indexOf(this.keys[s])===0&&(l=s);this.keys.splice(l,1,i)}removeKey(i){let l=this.keys.indexOf(i);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=S;class d extends S{constructor(){const i=(0,t.getDefaultValues)(),l=(0,t.getConfigurationKeys)(),s=[];for(const r of Object.keys(i))k.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,k.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(i[r]),contents:(0,t.toValuesTree)(i[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(i,l,s)}}e.DefaultConfigurationModel=d;class m{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,l){if(!f.isUndefinedOrNull(i)){const s=this.doParseContent(i);this.parseRaw(s,l)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,l){this._raw=i;const{contents:s,keys:r,overrides:a,restricted:g}=this.doParseRaw(i,l);this._configurationModel=new S(s,r,a),this._restrictedConfigurations=g||[]}doParseContent(i){let l={},s=null,r=[],a=[],g=[];function p(R){Array.isArray(r)?r.push(R):s!==null&&(r[s]=R)}let P={onObjectBegin:()=>{let R={};p(R),a.push(r),r=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let R=[];p(R),a.push(r),r=R,s=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:p,onError:(R,A,W)=>{g.push({error:R,offset:A,length:W})}};if(i)try{M.visit(i,P),l=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return l}doParseRaw(i,l){const s=b.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,s,!0,l);i=r.raw;const a=(0,t.toValuesTree)(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),g=Object.keys(i),p=(0,t.toOverrides)(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:a,keys:g,overrides:p,restricted:r.restricted}}filter(i,l,s,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const a={},g=[];for(let p in i)if(k.OVERRIDE_PROPERTY_PATTERN.test(p)&&s){const P=this.filter(i[p],l,!1,r);a[p]=P.raw,g.push(...P.restricted)}else{const P=l[p],R=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&g.push(p),(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&(r.skipRestricted&&P?.restricted||(a[p]=i[p]))}return{raw:a,restricted:g}}}e.ConfigurationModelParser=m;class E extends D.Disposable{constructor(i,l,s,r){super();this.userSettingsResource=i,this.scopes=l,this.fileService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class y{constructor(i,l,s=new S,r=new S,a=new I.ResourceMap,g=new S,p=new I.ResourceMap,P=!0){this._defaultConfiguration=i,this._localUserConfiguration=l,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=g,this._memoryConfigurationByResource=p,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(i,l,s){return this.getConsolidateConfigurationModel(l,s).getValue(i)}updateValue(i,l,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new S,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,l===void 0?r.removeValue(i):r.setValue(i,l),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,l,s){const r=this.getConsolidateConfigurationModel(l,s),a=this.getFolderConfigurationModelForResource(l.resource,s),g=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,p=l.overrideIdentifier?this._defaultConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),P=l.overrideIdentifier?this.userConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),R=l.overrideIdentifier?this.localUserConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),A=l.overrideIdentifier?this.remoteUserConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),W=s?l.overrideIdentifier?this._workspaceConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,j=a?l.overrideIdentifier?a.freeze().override(l.overrideIdentifier).getValue(i):a.freeze().getValue(i):void 0,x=l.overrideIdentifier?g.override(l.overrideIdentifier).getValue(i):g.getValue(i),re=r.getValue(i),K=v.distinct(v.flatten(r.overrides.map(ee=>ee.identifiers))).filter(ee=>r.getOverrideValue(i,ee)!==void 0);return{defaultValue:p,userValue:P,userLocalValue:R,userRemoteValue:A,workspaceValue:W,workspaceFolderValue:j,memoryValue:x,value:re,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,workspace:W!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,workspaceFolder:j!==void 0?{value:a?.freeze().getValue(i),override:l.overrideIdentifier?a?.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:g.getValue(i),override:l.overrideIdentifier?g.getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(i){const l=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,l){this._folderConfigurations.set(i,l),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,l){const s=l.filter(r=>k.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,k.overrideIdentifierFromKey)(r),g=this._defaultConfiguration.getKeysForOverrideIdentifier(a),p=i.getKeysForOverrideIdentifier(a),P=[...p.filter(R=>g.indexOf(R)===-1),...g.filter(R=>p.indexOf(R)===-1),...g.filter(R=>!n.equals(this._defaultConfiguration.override(a).getValue(R),i.override(a).getValue(R)))];return[a,P]});return this.updateDefaultConfiguration(i),{keys:l,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:l,updated:s,removed:r,overrides:a}=(0,t.compare)(this.localUserConfiguration,i),g=[...l,...s,...r];return g.length&&this.updateLocalUserConfiguration(i),{keys:g,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:l,updated:s,removed:r,overrides:a}=(0,t.compare)(this.remoteUserConfiguration,i);let g=[...l,...s,...r];return g.length&&this.updateRemoteUserConfiguration(i),{keys:g,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:l,updated:s,removed:r,overrides:a}=(0,t.compare)(this.workspaceConfiguration,i);let g=[...l,...s,...r];return g.length&&this.updateWorkspaceConfiguration(i),{keys:g,overrides:a}}compareAndUpdateFolderConfiguration(i,l){const s=this.folderConfigurations.get(i),{added:r,updated:a,removed:g,overrides:p}=(0,t.compare)(s,l);let P=[...r,...a,...g];return(P.length||!s)&&this.updateFolderConfiguration(i,l),{keys:P,overrides:p}}compareAndDeleteFolderConfiguration(i){const l=this.folderConfigurations.get(i);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:r,removed:a,overrides:g}=(0,t.compare)(l,void 0);return{keys:[...s,...r,...a],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,l){let s=this.getConsolidatedConfigurationModelForResource(i,l);return i.overrideIdentifier?s.override(i.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:i},l){let s=this.getWorkspaceConsolidatedConfiguration();if(l&&i){const r=l.getFolder(i);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const a=this._memoryConfigurationByResource.get(i);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let l=this._foldersConsolidatedConfigurations.get(i);if(!l){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(l=s.merge(r),this._freeze&&(l=l.freeze()),this._foldersConsolidatedConfigurations.set(i,l)):l=s}return l}getFolderConfigurationModelForResource(i,l){if(l&&i){const s=l.getFolder(i);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,l)=>{const{contents:s,overrides:r,keys:a}=this._folderConfigurations.get(l);return i.push([l,{contents:s,overrides:r,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(l=>i.add(l)),this.userConfiguration.freeze().keys.forEach(l=>i.add(l)),this._workspaceConfiguration.freeze().keys.forEach(l=>i.add(l)),this._folderConfigurations.forEach(l=>l.freeze().keys.forEach(s=>i.add(s))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>l.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>l.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>l.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r))),[...l.values()]}static parse(i){const l=this.parseConfigurationModel(i.defaults),s=this.parseConfigurationModel(i.user),r=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((g,p)=>(g.set(w.URI.revive(p[0]),this.parseConfigurationModel(p[1])),g),new I.ResourceMap);return new y(l,s,new S,r,a,new S,new I.ResourceMap,!1)}static parseConfigurationModel(i){return new S(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=y;function c(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const i=new Set,l=new Map;for(const r of u)r.keys.forEach(a=>i.add(a)),r.overrides.forEach(([a,g])=>{const p=(0,I.getOrSet)(l,a,new Set);g.forEach(P=>p.add(P))});const s=[];return l.forEach((r,a)=>s.push([a,[...r.values()]])),{keys:[...i.values()],overrides:s}}e.mergeChanges=c;class h{constructor(i,l,s,r){this.change=i,this.previous=l,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;i.keys.forEach(p=>a.add(p)),i.overrides.forEach(([,p])=>p.forEach(P=>a.add(P))),this.affectedKeys=[...a.values()];const g=new S;this.affectedKeys.forEach(p=>g.setValue(p,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,l){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(l){const s=this.previousConfiguration?this.previousConfiguration.getValue(i,l,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,l,this.currentWorkspace);return!n.equals(s,r)}return!0}return!1}doesAffectedKeysTreeContains(i,l){let s=(0,t.toValuesTree)({[l]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(i=i[r],!i)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=h;class o extends h{constructor(i,l,s,r){super({keys:i.allKeys(),overrides:[]},void 0,i,l);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=o}),define(Q[185],J([0,1,9,4,2,15,16,184,49,37]),function(V,e,v,L,M,D,I,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class t extends M.Disposable{constructor(b,S){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,S)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,S){const d=typeof b=="string"?b:void 0,m=(0,I.isConfigurationOverrides)(b)?b:(0,I.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(d,m,void 0)}updateValue(b,S,d,m){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const S=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(d,S,1)}onDidDefaultConfigurationChange(b){const S=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,b);this.trigger(d,S,6)}trigger(b,S,d){const m=new n.ConfigurationChangeEvent(b,{data:S},this.configuration);m.source=d,m.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=t}),define(Q[186],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var L;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends Error{constructor(I,n=L.Unknown,f){super(I);this._message=I,this._code=n,this._detail=f,this.isHandled=n===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(I){return I instanceof M&&I._code===L.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof M&&I._code===L.NoResolverFound}static isHandled(I){return I instanceof M&&I.isHandled}}e.RemoteAuthorityResolverError=M}),define(Q[187],J([0,1,9,18,23,17,4,2,28,84,186]),function(V,e,v,L,M,D,I,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const k=30*1e3;var b;(function(O){O[O.Management=1]="Management",O[O.ExtensionHost=2]="ExtensionHost",O[O.Tunnel=3]="Tunnel"})(b=e.ConnectionType||(e.ConnectionType={}));function S(O){switch(O){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(O){const T=new M.CancellationTokenSource;return setTimeout(()=>T.cancel(),O),T.token}function m(O,T){if(O.isCancellationRequested||T.isCancellationRequested)return M.CancellationToken.Cancelled;const _=new M.CancellationTokenSource;return O.onCancellationRequested(()=>_.cancel()),T.onCancellationRequested(()=>_.cancel()),_.token}class E{constructor(T){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((_,q)=>{this._resolvePromise=_,this._rejectPromise=q}),T.isCancellationRequested?this._timeout():this._disposables.add(T.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(T){this._state==="pending"?this._disposables.add(T):T.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const T=new Error("Time limit reached");return T.code="ETIMEDOUT",T.syscall="connect",T}resolve(T){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(T))}reject(T){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(T))}}function y(O,T){const _=new E(T);return _.registerDisposable(O.onControlMessage(q=>{const X=JSON.parse(q.toString()),$=z(X);$?_.reject($):_.resolve(X)})),_.promise}function c(O,T,_,q,X,$){const N=new E($);return T.connect(_,q,X,(Z,ie)=>{N.didTimeout?(Z&&O.error(Z),ie?.dispose()):Z||!ie?N.reject(Z):N.resolve(ie)}),N.promise}function h(O,T){const _=new E(T);return O.then(q=>{_.didTimeout||_.resolve(q)},q=>{_.didTimeout||_.reject(q)}),_.promise}async function o(O,T,_,q){const X=U(O,T);O.logService.trace(`${X} 1/6. invoking socketFactory.connect().`);let $;try{$=await c(O.logService,O.socketFactory,O.host,O.port,`reconnectionToken=${O.reconnectionToken}&reconnection=${O.reconnectionProtocol?"true":"false"}`,q)}catch(oe){throw O.logService.error(`${X} socketFactory.connect() failed or timed out. Error:`),O.logService.error(oe),oe}O.logService.trace(`${X} 2/6. socketFactory.connect() was successful.`);let N,Z;O.reconnectionProtocol?(O.reconnectionProtocol.beginAcceptReconnection($,null),N=O.reconnectionProtocol,Z=!1):(N=new w.PersistentProtocol($,null),Z=!0),O.logService.trace(`${X} 3/6. sending AuthRequest control message.`);const ie={type:"auth",auth:O.connectionToken||"00000000000000000000"};N.sendControl(L.VSBuffer.fromString(JSON.stringify(ie)));try{const oe=await y(N,m(q,d(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const ae=new Error("Unexpected handshake message");throw ae.code="VSCODE_CONNECTION_ERROR",ae}O.logService.trace(`${X} 4/6. received SignRequest control message.`);const le=await h(O.signService.sign(oe.data),q),ne={type:"connectionType",commit:O.commit,signedData:le,desiredConnectionType:T};return _&&(ne.args=_),O.logService.trace(`${X} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(L.VSBuffer.fromString(JSON.stringify(ne))),{protocol:N,ownsProtocol:Z}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(O.logService.error(`${X} the handshake timed out. Error:`),O.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(O.logService.error(`${X} received error control message when negotiating connection. Error:`),O.logService.error(oe)),Z&&H(N),oe}}async function u(O,T,_,q){const X=Date.now(),$=U(O,T),{protocol:N,ownsProtocol:Z}=await o(O,T,_,q),ie=new E(q);return ie.registerDisposable(N.onControlMessage(oe=>{const le=JSON.parse(oe.toString()),ne=z(le);ne?(O.logService.error(`${$} received error control message when negotiating connection. Error:`),O.logService.error(ne),Z&&H(N),ie.reject(ne)):(O.reconnectionProtocol&&O.reconnectionProtocol.endAcceptReconnection(),O.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${Y(X)}!`),ie.resolve({protocol:N,firstMessage:le}))})),ie.promise}async function i(O,T){const{protocol:_}=await u(O,1,void 0,T);return{protocol:_}}async function l(O,T,_){const{protocol:q,firstMessage:X}=await u(O,2,T,_),$=X&&X.debugPort;return{protocol:q,debugPort:$}}async function s(O,T,_){const q=Date.now(),X=U(O,3),{protocol:$}=await o(O,3,T,_);return O.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${Y(q)}!`),$}async function r(O,T,_){const{host:q,port:X,connectionToken:$}=await O.addressProvider.getAddress();return{commit:O.commit,host:q,port:X,connectionToken:$,reconnectionToken:T,reconnectionProtocol:_,socketFactory:O.socketFactory,signService:O.signService,logService:O.logService}}async function a(O,T,_){try{const q=(0,f.generateUuid)(),X=await r(O,q,null),{protocol:$}=await i(X,M.CancellationToken.None);return new ee(O,T,_,q,$)}catch(q){throw O.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),O.logService.error(q),K.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=a;async function g(O,T){try{const _=(0,f.generateUuid)(),q=await r(O,_,null),{protocol:X,debugPort:$}=await l(q,T,M.CancellationToken.None);return new F(O,T,_,X,$)}catch(_){throw O.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),O.logService.error(_),K.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=g;async function p(O,T,_){const q=await r(O,(0,f.generateUuid)(),null);return await s(q,{host:T,port:_},M.CancellationToken.None)}e.connectRemoteAgentTunnel=p;function P(O){return(0,v.createCancelablePromise)(T=>new Promise((_,q)=>{const X=setTimeout(_,O*1e3);T.onCancellationRequested(()=>{clearTimeout(X),_()})}))}var R;(function(O){O[O.ConnectionLost=0]="ConnectionLost",O[O.ReconnectionWait=1]="ReconnectionWait",O[O.ReconnectionRunning=2]="ReconnectionRunning",O[O.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",O[O.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(T,_){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=A;class W{constructor(T,_,q,X){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.durationSeconds=q,this.cancellableTimer=X,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class j{constructor(T,_,q){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=j;class x{constructor(T,_,q){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=q,this.type=4}}e.ConnectionGainEvent=x;class re{constructor(T,_,q,X){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=q,this.handled=X,this.type=3}}e.ReconnectionPermanentFailureEvent=re;class K extends n.Disposable{constructor(T,_,q,X){super();this._connectionType=T,this._onDidStateChange=this._register(new I.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=_,this.reconnectionToken=q,this.protocol=X,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(X.onSocketClose($=>{const N=C(this._connectionType,this.reconnectionToken,!0);$?$.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${$.hadError}).`),$.error&&this._options.logService.error($.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${$.wasClean}, code: ${$.code}, reason: ${$.reason}).`),$.event&&this._options.logService.error($.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(X.onSocketTimeout(()=>{const $=C(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${$} received socket timeout event.`),this._beginReconnecting()})),K._instances.push(this),K._permanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}static triggerPermanentFailure(T,_,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=T,this._permanentFailureAttempt=_,this._permanentFailureHandled=q,this._instances.forEach(X=>X._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(K._permanentFailure)return;const T=C(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${T} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const X=q<_.length?_[q]:_[_.length-1];try{if(X>0){const N=P(X);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X,N)),this._options.logService.info(`${T} waiting for ${X} seconds before reconnecting...`);try{await N}catch{}}if(K._permanentFailure){this._options.logService.error(`${T} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${T} resolving connection...`);const $=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${T} connecting to ${$.host}:${$.port}...`),await this._reconnect($,d(k)),this._options.logService.info(`${T} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${T} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${T} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(t.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${T} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${T} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,D.isPromiseCanceledError)($)){this._options.logService.info(`${T} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof t.RemoteAuthorityResolverError){this._options.logService.error(`${T} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,t.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${T} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!K._permanentFailure)}_gotoPermanentFailure(T,_,q){this._onDidStateChange.fire(new re(this.reconnectionToken,T,_,q)),H(this.protocol)}}K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[];class ee extends K{constructor(T,_,q,X,$){super(1,T,X,$);this.client=this._register(new w.Client($,{remoteAuthority:_,clientId:q},T.ipcLogger))}async _reconnect(T,_){await i(T,_)}}e.ManagementPersistentConnection=ee;class F extends K{constructor(T,_,q,X,$){super(2,T,q,X);this._startArguments=_,this.debugPort=$}async _reconnect(T,_){await l(T,this._startArguments,_)}}e.ExtensionHostPersistentConnection=F;function H(O){try{O.acceptDisconnect();const T=O.getSocket();O.dispose(),T.dispose()}catch(T){(0,D.onUnexpectedError)(T)}}function z(O){if(O&&O.type==="error"){const T=new Error(`Connection error: ${O.reason}`);return T.code="VSCODE_CONNECTION_ERROR",T}return null}function B(O,T){for(;O.length<T;)O+=" ";return O}function C(O,T,_){return`[remote-connection][${B(S(O),13)}][${T.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function U(O,T){return`${C(T,O.reconnectionToken,!!O.reconnectionProtocol)}[${O.host}:${O.port}]`}function Y(O){return`${Date.now()-O} ms`}}),define(Q[61],J([0,1,10]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(w){return w.scheme===v.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=L;function M(w){if(!w)return;const t=w.indexOf("+");return t<0?w:w.substr(0,t)}e.getRemoteName=M;function D(w){return w.scheme!==v.Schemas.file&&w.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=D;function I(w){if(w.folders.length)return w.folders.every(t=>D(t.uri))?w.folders[0].uri:void 0;if(w.configuration&&D(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=I;function n(w){return I(w)?.scheme}e.getVirtualWorkspaceScheme=n;function f(w){return I(w)!==void 0}e.isVirtualWorkspace=f}),define(Q[188],J([0,1,27,5,61]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=D;function I(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var n;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(n=e.ExtensionType||(e.ExtensionType={}));class f{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,d){if(typeof S=="undefined"||S===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof S=="string"||typeof d=="string"){let m=typeof S=="string"?S:S.value,E=typeof d=="string"?d:d.value;return v.equalsIgnoreCase(m,E)}return S._lower===d._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=f;function w(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function t(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=t;function k(b,S){if(S&&b.enableProposedApi){const d=`onResolveRemoteAuthority:${(0,M.getRemoteName)(S)}`;return b.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[189],J([0,1,27,188]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function M(d,m){return d.uuid&&m.uuid?d.uuid===m.uuid:d.id===m.id?!0:(0,v.compareIgnoreCase)(d.id,m.id)===0}e.areSameExtensions=M;class D{constructor(m,E){this.version=E,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof D?M(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=D;function I(d,m){return`${d}.${m}`}e.getExtensionId=I;function n(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function f(d,m){return n(I(d,m))}e.getGalleryExtensionId=f;function w(d,m){const E=[],y=c=>{for(const h of E)if(h.some(o=>M(m(o),m(c))))return h;return null};for(const c of d){const h=y(c);h?h.push(c):E.push([c])}return E}e.groupByExtension=w;function t(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function k(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function b(d){const m=new Set;for(const E of d)E.malicious&&m.add(E.id.id);return m}e.getMaliciousExtensionsSet=b;function S(d,m){const E=[],y=m.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const c=y.shift();if(c&&E.every(h=>!M(h.identifier,{id:c}))){const h=d.filter(o=>M(o.identifier,{id:c}));h.length===1&&(E.push(h[0]),y.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=S}),define(Q[95],J([0,1,4,3,5,6]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,M.createDecorator)("tunnelService");var I;(function(d){d.Http="http",d.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(n=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=k;function b(d,m){return m?m!==1&&d<1024:!L.isWindows&&d<1024}e.isPortPrivileged=b;let S=class{constructor(m){this.logService=m,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m,E){return this._tunnelProvider=m,m?(this._canElevate=E.elevation,this._privacyOptions=E.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],E=Array.from(this._tunnels.values());for(let y of E){const c=Array.from(y.values());for(let h of c){const o=await h.value;o&&m.push(o)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:E}of m.values())await E.then(y=>y?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,E,y,c,h=!1,o=n.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${y} on local port ${c}.`),!m)return;E||(E="localhost");const i=this.retainOrCreateTunnel(m,E,y,c,h,o,u);return i?i.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(l);return(l.tunnelRemoteHost!==E||l.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const E=this._tunnels.get(m.tunnelRemoteHost);if(E){const y=E.get(m.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,y))}}}}async tryDisposeTunnel(m,E,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${E}.`);const c=y.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(E),c}}async closeTunnel(m,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${E} `);const y=this._tunnels.get(m);if(y&&y.has(E)){const c=y.get(E);c.refcount=0,await this.tryDisposeTunnel(m,E,c)}}addTunnelToMap(m,E,y){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(E,{refcount:1,value:y})}async removeEmptyTunnelFromMap(m,E){const y=this._tunnels.get(m);y&&(await y.get(E)||y.delete(E),y.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,E){let y=[m];t(m)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):k(m)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const c=y.map(h=>this._tunnels.get(h));for(const h of c){const o=h?.get(E);if(o)return o}}canTunnel(m){return!!w(m)}createWithProvider(m,E,y,c,h,o,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${y} on local port ${c}.`);const l={elevationRequired:h?b(c===void 0?y:c):!1},s={remoteAddress:{host:E,port:y},localAddressPort:c,privacy:o,public:o!==n.Private,protocol:u},r=m.forwardPort(s,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(E,y,r),r}};S=he([te(0,D.ILogService)],S),e.AbstractTunnelService=S}),define(Q[50],J([0,1,18,146,49,5,37]),function(V,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function f(d){return d.res.statusCode===204}async function w(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,v.streamToBuffer)(d.stream)).toString()}e.asText=w;async function t(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const E=(await(0,v.streamToBuffer)(d.stream)).toString();try{return JSON.parse(E)}catch(y){throw y.message+=`:
`+E,y}}e.asJson=t;function k(d){S(d)}e.updateProxyConfigurationsScope=k;let b;function S(d){const m=I.Registry.as(M.Extensions.Configuration),E=b;b={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[b],remove:E?[E]:[]})}S(2)}),define(Q[190],J([0,1,191,13]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function M(I,n){return I.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:I.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function D(I,n,f={}){const w=(0,v.parse)(I),t=f.proxyUrl||M(w,n);if(!t)return null;const k=(0,v.parse)(t);if(!/^https?:$/.test(k.protocol||""))return null;const b={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((S,d)=>{V(["http-proxy-agent"],S,d)}))(b):new(await new Promise((S,d)=>{V(["https-proxy-agent"],S,d)}))(b)}e.getProxyAgent=D}),define(Q[192],J([0,1,18,28]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function M(D,I,n){let f=n&&n.get("storage.serviceMachineId",0)||null;if(f)return f;try{const t=(await I.readFile(D.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(t)?t:null}catch(w){f=null}if(!f){f=(0,L.generateUuid)();try{await I.writeFile(D.serviceMachineIdResource,v.VSBuffer.fromString(f))}catch(w){}}return n&&n.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=M}),define(Q[76],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[193],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((M,D)=>V(["vsda"],M,D))}async sign(M){try{const D=await this.vsda(),I=new D.signer;if(I)return I.sign(M)}catch(D){}return M}}e.SignService=v}),define(Q[38],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Q[22],J([0,1,14,9,4,2,3,32,13,5,173,6,38]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var S;(function(m){m[m.Starting=1]="Starting",m[m.Ready=2]="Ready",m[m.AfterWindowOpen=3]="AfterWindowOpen"})(S=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class at extends D.Disposable{constructor(E,y){super();this.logService=E,this.stateMainService=y,this._onBeforeShutdown=this._register(new M.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new M.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new M.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new M.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new M.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(at.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(at.QUIT_AND_RESTART_KEY)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),I.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",E);const y=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!I.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",y),v.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",E),v.app.removeListener("window-all-closed",y),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(y){E.push(y)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(E)}catch(y){this.logService.error(y)}try{await this.stateMainService.close()}catch(y){this.logService.error(y)}})(),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===E)return;this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const y=this.phaseWhen.get(this._phase);y&&(y.open(),this.phaseWhen.delete(this._phase))}async when(E){if(E<=this._phase)return;let y=this.phaseWhen.get(E);y||(y=new L.Barrier,this.phaseWhen.set(E,y)),await y.wait()}registerWindow(E){const y=new D.DisposableStore;this.windowCounter++,y.add(E.onWillLoad(h=>this._onWillLoadWindow.fire({window:E,workspace:h.workspace,reason:h.reason})));const c=(0,f.assertIsDefined)(E.win);c.on("close",h=>{const o=E.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),h.preventDefault(),this.unload(E,1).then(u=>{if(u){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(E),E.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,y.dispose(),this.windowCounter===0&&(!I.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(E,y){await this.unload(E,3)||E.reload(y)}async unload(E,y){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const c=this._quitRequested?2:y;let h=await this.onBeforeUnloadWindowInRenderer(E,c);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(E,c),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${E.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${E.id})`),await this.onWillUnloadWindowInRenderer(E,c),!1))}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(E,y){return new Promise(c=>{const h=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${h}`,u=`vscode:cancel${h}`;v.ipcMain.once(o,()=>{c(!1)}),v.ipcMain.once(u,()=>{c(!0)}),E.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:u,reason:y})})}onBeforeUnloadWindowInMain(E,y){const c=[];return this._onBeforeUnloadWindow.fire({reason:y,window:E,veto(h){c.push(h)}}),(0,t.handleVetos)(c,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(E,y){return new Promise(c=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(o,()=>c()),E.send("vscode:onWillUnload",{replyChannel:o,reason:y})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${E}`),E&&this.stateMainService.setItem(at.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(y=>{this.pendingQuitPromiseResolve=y,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(E){this.logService.trace("Lifecycle#relaunch()");const y=process.argv.slice(1);if(E?.addArgs&&y.push(...E.addArgs),E?.removeArgs)for(const o of E.removeArgs){const u=y.indexOf(o);u>=0&&y.splice(u,1)}const c=()=>{try{if(I.isWindows){const o=(0,n.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:y})};v.app.once("quit",c),await this.quit(!0)&&v.app.removeListener("quit",c)}async kill(E){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const y of v.BrowserWindow.getAllWindows())if(y&&!y.isDestroyed()){let c;y.webContents&&!y.webContents.isDestroyed()?c=new Promise(h=>y.once("closed",h)):c=Promise.resolve(),y.destroy(),await c}})()]),v.app.exit(E)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=he([te(0,k.ILogService),te(1,b.IStateMainService)],d),e.LifecycleMainService=d}),define(Q[194],J([0,1,4,2,5,22]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let I=class extends L.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((t,k)=>{V(["native-keymap"],t,k)});this._keyboardLayoutData=n(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};I=he([te(0,D.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function n(f){const w=f.getKeyMap(),t=f.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:t}}}),define(Q[96],J([0,1,9,4,2,13,86,5]),function(V,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var w;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var t;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(t=e.StorageScope||(e.StorageScope={}));var k;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(k=e.StorageTarget||(e.StorageTarget={}));class b extends M.Disposable{constructor(E={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=E,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new M.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,M.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(E,y){y===f?(E===0?this._globalKeyTargets=void 0:E===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:E})):this._onDidChangeValue.fire({scope:E,key:y,target:this.getKeyTargets(E)[y]})}emitWillSaveState(E){this._onWillSaveState.fire({reason:E})}get(E,y,c){return this.getStorage(y)?.get(E,c)}getBoolean(E,y,c){return this.getStorage(y)?.getBoolean(E,c)}getNumber(E,y,c){return this.getStorage(y)?.getNumber(E,c)}store(E,y,c,h){if((0,D.isUndefinedOrNull)(y)){this.remove(E,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(E,c,h),this.getStorage(c)?.set(E,y)})}remove(E,y){this.withPausedEmitters(()=>{this.updateKeyTarget(E,y,void 0),this.getStorage(y)?.delete(E)})}withPausedEmitters(E){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{E()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(E,y){const c=[],h=this.getKeyTargets(E);for(const o of Object.keys(h))h[o]===y&&c.push(o);return c}updateKeyTarget(E,y,c){const h=this.getKeyTargets(y);typeof c=="number"?h[E]!==c&&(h[E]=c,this.getStorage(y)?.set(f,JSON.stringify(h))):typeof h[E]=="number"&&(delete h[E],this.getStorage(y)?.set(f,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(E){return E===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(E){const y=this.get(f,E);if(y)try{return JSON.parse(y)}catch(c){}return Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(E=w.NONE){this._onWillSaveState.fire({reason:E}),await v.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const E=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return d(E,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class S extends b{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(E=>this.emitDidChangeValue(1,E))),this._register(this.globalStorage.onDidChangeStorage(E=>this.emitDidChangeValue(0,E)))}getStorage(E){return E===0?this.globalStorage:this.workspaceStorage}getLogDetails(E){return E===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(E){}}e.InMemoryStorageService=S;async function d(m,E,y,c){const h=a=>{try{return JSON.parse(a)}catch(g){return a}},o=new Map,u=new Map;m.forEach((a,g)=>{o.set(g,a),u.set(g,h(a))});const i=new Map,l=new Map;E.forEach((a,g)=>{i.set(g,a),l.set(g,h(a))}),console.group(`Storage: Global (path: ${y})`);let s=[];o.forEach((a,g)=>{s.push({key:g,value:a})}),console.table(s),console.groupEnd(),console.log(u),console.group(`Storage: Workspace (path: ${c})`);let r=[];i.forEach((a,g)=>{r.push({key:g,value:a})}),console.table(r),console.groupEnd(),console.log(l)}e.logStorage=d}),define(Q[195],J([0,1,3,32,7,28]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(w){if(v.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function n(w,t,k,b,S,d,m,E,y,c){const h=Object.create(null);h["common.machineId"]=m,h.sessionID=(0,D.generateUuid)()+Date.now(),h.commitHash=S,h.version=d,h["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,v.PlatformToString)(v.platform),h["common.nodePlatform"]=L.platform,h["common.nodeArch"]=b,h["common.product"]=c||"desktop";const o=f(E||[]);o&&(h["common.msftInternal"]=o);let u=0;const i=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),v.isLinuxSnap&&(h["common.snap"]="true");const l=I(k);l&&(h["common.platformDetail"]=l);try{const s=await w.readFile(M.URI.file(y));h["common.source"]=s.value.toString().slice(0,30)}catch(s){}return h}e.resolveCommonProperties=n;function f(w){const t=L.env.USERDNSDOMAIN;if(!t)return!1;const k=t.toLowerCase();return w.some(b=>k===b)}e.verifyMicrosoftInternalDomain=f}),define(Q[29],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var M;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(M=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[196],J([0,1,25,66,9,39,10,8,3,7,69,19,83,73,20,21,29]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function y(i,l){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,a=new Map,g=2e4;function p(A,W,j,x){const re=W.substring(A.length+1);return M.Promises.withAsyncBody(async K=>{let ee;try{ee=await k.Promises.readdir(W,{withFileTypes:!0})}catch(z){K();return}if(x.count>=g){x.count+=ee.length,x.maxReached=!0,K();return}let F=ee.length;if(F===0){K();return}let H=ee;x.count+ee.length>g&&(x.maxReached=!0,F=g-x.count,H=ee.slice(0,F)),x.count+=ee.length;for(const z of H)if(z.isDirectory()){if(j.includes(z.name)||await p(A,(0,n.join)(W,z.name),j,x),--F==0){K();return}}else{const B=z.name.lastIndexOf(".");if(B>=0){const C=z.name.substring(B+1);C&&r.set(C,(r.get(C)??0)+1)}for(const C of s)C.relativePathPattern?.test(re)!==!1&&C.filePattern.test(z.name)&&a.set(C.tag,(a.get(C.tag)??0)+1);if(--F==0){K();return}}})}const P={count:0,maxReached:!1};await p(i,i,l,P);const R=await o(i);return{configFiles:c(a),fileTypes:c(r),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:R}}e.collectWorkspaceStats=y;function c(i){return[...L.Iterable.map(i.entries(),([l,s])=>({name:l,count:s}))].sort((l,s)=>s.count-l.count)}function h(){const i={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(t.virtualMachineHint.value()*100)}%`},l=v.cpus();return l&&l.length>0&&(i.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),i}e.getMachineInfo=h;async function o(i){try{const l=new Map,s=(0,n.join)(i,".vscode","launch.json"),r=await k.Promises.readFile(s),a=[],g=(0,D.parse)(r.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,D.getNodeType)(g)==="object"&&g.configurations)for(const p of g.configurations){const P=p.type;P&&(l.has(P)?l.set(P,l.get(P)+1):l.set(P,1))}return c(l)}catch(l){return[]}}e.collectLaunchConfigs=o;let u=class{constructor(l,s){this.telemetryService=l,this.productService=s}formatMachineInfo(l){const s=[];return s.push(`OS Version:       ${l.os}`),s.push(`CPUs:             ${l.cpus}`),s.push(`Memory (System):  ${l.memory}`),s.push(`VM:               ${l.vmHint}`),s.join(`
`)}formatEnvironment(l){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const r=v.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),f.isWindows||s.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(t.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${l.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(l.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(l,s){return Promise.all([(0,b.listProcesses)(l.mainPID),this.formatWorkspaceMetadata(l)]).then(async r=>{let[a,g]=r,p=this.formatProcessList(l,a);return s.forEach(P=>{if((0,S.isRemoteDiagnosticError)(P))p+=`
${P.errorMessage}`,g+=`
${P.errorMessage}`;else if(p+=`

Remote: ${P.hostName}`,P.processes&&(p+=`
${this.formatProcessList(l,P.processes)}`),P.workspaceMetadata){g+=`
|  Remote: ${P.hostName}`;for(const R of Object.keys(P.workspaceMetadata)){const A=P.workspaceMetadata[R];let W=`${A.fileCount} files`;A.maxFilesReached&&(W=`more than ${W}`),g+=`|    Folder (${R}): ${W}`,g+=this.formatWorkspaceStats(A)}}}),{processInfo:p,workspaceInfo:g}})}async getSystemInfo(l,s){const{memory:r,vmHint:a,os:g,cpus:p}=h(),P={os:g,memory:r,cpus:p,vmHint:a,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:s};return f.isWindows||(P.load=`${v.loadavg().map(R=>Math.round(R)).join(", ")}`),f.isLinux&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(l,s){const r=[];return(0,b.listProcesses)(l.mainPID).then(async a=>(r.push(""),r.push(this.formatEnvironment(l)),r.push(""),r.push(this.formatProcessList(l,a)),l.windows.some(g=>g.folderURIs&&g.folderURIs.length>0&&!g.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(l))),s.forEach(g=>{if((0,S.isRemoteDiagnosticError)(g))r.push(`
${g.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${g.hostName}`),r.push(this.formatMachineInfo(g.machineInfo)),g.processes&&r.push(this.formatProcessList(l,g.processes)),g.workspaceMetadata)for(const p of Object.keys(g.workspaceMetadata)){const P=g.workspaceMetadata[p];let R=`${P.fileCount} files`;P.maxFilesReached&&(R=`more than ${R}`),r.push(`Folder (${p}): ${R}`),r.push(this.formatWorkspaceStats(P))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(l){const s=[],r=60;let a=0;const g=(A,W)=>{const j=` ${A}(${W})`;a+j.length>r?(s.push(p),p="|                 ",a=p.length):a+=j.length,p+=j};let p="|      File types:";const P=10;let R=l.fileTypes.length>P?P:l.fileTypes.length;for(let A=0;A<R;A++){const W=l.fileTypes[A];g(W.name,W.count)}if(s.push(p),l.configFiles.length>=0&&(p="|      Conf files:",a=0,l.configFiles.forEach(A=>{g(A.name,A.count)}),s.push(p)),l.launchConfigFiles.length>0){let A="|      Launch Configs:";l.launchConfigFiles.forEach(W=>{A+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(A)}return s.join(`
`)}expandGPUFeatures(l){const s=Math.max(...Object.keys(l).map(r=>r.length));return Object.keys(l).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${l[r]}`).join(`
                  `)}formatWorkspaceMetadata(l){const s=[],r=[];return l.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(g=>{const p=w.URI.revive(g);if(p.scheme===I.Schemas.file){const P=p.fsPath;r.push(y(P,["node_modules",".git"]).then(R=>{let A=`${R.fileCount} files`;R.maxFilesReached&&(A=`more than ${A}`),s.push(`|    Folder (${(0,n.basename)(P)}): ${A}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${R.toString()})`)}))}else s.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(l,s){const r=new Map;l.windows.forEach(g=>r.set(g.pid,g.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(l.mainPID,r,a,s,0),a.join(`
`)}formatProcessItem(l,s,r,a,g){const p=g===0;let P;p?P=a.pid===l?`${this.productService.applicationName} main`:"remote agent":(P=`${"  ".repeat(g)} ${a.name}`,a.name==="window"&&(P=`${P} (${s.get(a.pid)})`));const R=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);r.push(`${a.load.toFixed(0).padStart(5," ")}	${(R/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(a.children)&&a.children.forEach(A=>this.formatProcessItem(l,s,r,A,g+1))}async reportWorkspaceStats(l){for(const{uri:s}of l.folders){const r=w.URI.revive(s);if(r.scheme!==I.Schemas.file)continue;const a=r.fsPath;try{const g=await y(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),g.fileTypes.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:p.name,count:p.count})}),g.launchConfigFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:p.name,count:p.count})}),g.configFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};u=he([te(0,E.ITelemetryService),te(1,m.IProductService)],u),e.DiagnosticsService=u}),define(Q[197],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(D){this.appenders=D}listen(D,I){throw new Error(`Event not found: ${I}`)}call(D,I,{eventName:n,data:f}){return this.appenders.forEach(w=>w.log(n,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class L{constructor(D){this.channel=D}log(D,I){return this.channel.call("log",{eventName:D,data:I}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Q[62],J([0,1,43,13,16,29]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(y,c){return Promise.resolve(void 0)}publicLog2(y,c){return this.publicLog(y,c)}publicLogError(y,c){return Promise.resolve(void 0)}publicLogError2(y,c){return this.publicLogError(y,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class n{async publicLog(y,c,h){}async publicLogError(y,c,h){}}e.NullEndpointTelemetryService=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(E,y){return y.onDidChangeConfiguration(c=>{c.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(c.source),configurationKeys:d(c.sourceConfig)})})}e.configurationTelemetry=f;function w(E,y){return!(y.disableTelemetry||!E.enableTelemetry)}e.supportsTelemetry=w;function t(E){const y=E.getValue(D.TELEMETRY_SETTING_ID),c=E.getValue("telemetry.enableCrashReporter");if(E.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=t;function k(E){const y=Object.create(null),c=Object.create(null),h=Object.create(null);S(E,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const u=h[o];typeof u=="number"?c[o]=u:typeof u=="boolean"?c[o]=u?1:0:typeof u=="string"?y[o]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(y[o]=u)}return{properties:y,measurements:c}}e.validateTelemetryData=k;function b(E){if(!E)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{E.indexOf(`${h}+`)===0&&(y=h)}),y}e.cleanRemoteAuthority=b;function S(E,y,c=0,h){if(!!E)for(let o of Object.getOwnPropertyNames(E)){const u=E[o],i=h?h+o:o;Array.isArray(u)?y[i]=(0,v.safeStringify)(u):u instanceof Date?y[i]=u.toISOString():(0,L.isObject)(u)?c<2?S(u,y,c+1,i+"."):y[i]=(0,v.safeStringify)(u):y[i]=u}}function d(E){if(!E)return[];const y=[];return m(y,"",E),y}function m(E,y,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(h=>m(E,y?`${y}.${h}`:h,c[h])):E.push(y)}}),define(Q[198],J([0,1,30,23,17,43,3,32,7,16,48,166,189,161,20,6,21,50,192,96,29,62]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=I.isWeb?"web":(0,k.getTargetPlatform)(I.platform,n.arch);var l;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished"})(l||(l={}));function s(...$){return String($.reduce((N,Z)=>N|Z,0))}var r;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},g={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},P={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class R{constructor(N=P){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,Z=this.state.pageSize){return new R({...this.state,pageNumber:N,pageSize:Z})}withFilter(N,...Z){const ie=[...this.state.criteria,...Z.length?Z.map(oe=>({filterType:N,value:oe})):[{filterType:N}]];return new R({...this.state,criteria:ie})}withSortBy(N){return new R({...this.state,sortBy:N})}withSortOrder(N){return new R({...this.state,sortOrder:N})}withFlags(...N){return new R({...this.state,flags:N.reduce((Z,ie)=>Z|ie,0)})}withAssetTypes(...N){return new R({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:Z,pageSize:ie,sortBy:oe,sortOrder:le,flags:ne,assetTypes:ae}=this.state;return{filters:[{criteria:N,pageNumber:Z,pageSize:ie,sortBy:oe,sortOrder:le}],assetTypes:ae,flags:ne}}get searchText(){const N=this.state.criteria.filter(Z=>Z.filterType===r.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A($,N){const Z=($||[]).filter(ie=>ie.statisticName===N)[0];return Z?Z.value:0}function W($){const N="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(ie=>ie.assetType.indexOf(N)===0).reduce((ie,oe)=>{const le=K($,oe.assetType);return le&&ie.push([oe.assetType.substring(N.length),le]),ie},[])}function j($){if($.properties){const N=$.properties.filter(oe=>oe.key===a.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=N.filter(oe=>Z.test(oe.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return K($,a.Repository)}function x($){return{uri:`${$.fallbackAssetUri}/${a.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${a.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function re($){const N=K($,a.Icon);if(N)return N;const Z=k.DefaultIconPath;return{uri:Z,fallbackUri:Z}}function K($,N){return $.files.filter(ie=>ie.assetType===N)[0]?{uri:`${$.assetUri}/${N}`,fallbackUri:`${$.fallbackAssetUri}/${N}`}:null}function ee($,N){const Z=$.properties?$.properties.filter(oe=>oe.key===N):[],ie=Z.length>0&&Z[0].value;return ie?ie.split(",").map(oe=>(0,b.adoptToGalleryExtensionId)(oe)):[]}function F($){const N=$.properties?$.properties.filter(Z=>Z.key===g.Engine):[];return N.length>0&&N[0].value||""}function H($){const N=$.properties?$.properties.filter(ie=>ie.key===g.LocalizedLanguages):[],Z=N.length>0&&N[0].value||"";return Z?Z.split(","):[]}function z($){return $.indexOf("preview")!==-1}function B($){return $.targetPlatform?(0,k.toTargetPlatform)($.targetPlatform):"undefined"}function C($){const N=(0,v.distinct)($.versions.map(B)),Z=!!$.tags?.includes(k.WEB_EXTENSION_TAG),ie=N.indexOf("web");return Z?ie===-1&&N.push("web"):ie!==-1&&N.splice(ie,1),N}function U($,N){const Z=(0,k.getFallbackTargetPlarforms)(N);for(let ie=0;ie<$.length;ie++){const oe=$[ie];if(oe.version===$[ie-1]?.version){let le=ie;const ne=B(oe);if(ne===N)for(;le>0&&$[le-1].version===oe.version;)le--;else if(Z.includes(ne))for(;le>0&&$[le-1].version===oe.version&&B($[le-1])!==N;)le--;le!==ie&&($.splice(ie,1),$.splice(le,0,oe))}}return $}e.sortExtensionVersions=U;function Y($,N,Z,ie,oe){const le=C($);let ne=$.versions[0];return ne=$.versions.find(ae=>ae.version===ne.version&&(0,k.isTargetPlatformCompatible)(B(ae),le,oe))||ne,O($,ne,le,N,Z,ie)}function O($,N,Z,ie,oe,le){const ne={manifest:K(N,a.Manifest),readme:K(N,a.Details),changelog:K(N,a.Changelog),license:K(N,a.License),repository:j(N),download:x(N),icon:re(N),coreTranslations:W(N)};return{identifier:{id:(0,b.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:N.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,description:$.shortDescription||"",installCount:A($.statistics,"install"),rating:A($.statistics,"averagerating"),ratingCount:A($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:Z,assets:ne,properties:{dependencies:ee(N,g.Dependency),extensionPack:ee(N,g.ExtensionPack),engine:F(N),localizedLanguages:H(N),targetPlatform:B(N)},preview:z($.flags),telemetryData:{index:(oe.pageNumber-1)*oe.pageSize+ie,querySource:le}}}let T=class{constructor(N,Z,ie,oe,le,ne,ae,ue){this.requestService=Z,this.logService=ie,this.environmentService=oe,this.telemetryService=le,this.fileService=ne,this.productService=ae,this.configurationService=ue;const de=ae.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=X(ae.version,ae,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,Z){const ie=[];let oe=new R().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,N.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...N.map(({id:ne})=>ne.toLowerCase()));N.every(ne=>!ne.version)&&(oe=oe.withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties,l.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(oe,i,L.CancellationToken.None);for(let ne=0;ne<le.length;ne++){const ae=le[ne];if(!ae.versions.length)continue;const ue=(0,b.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),de=N.find(ve=>(0,b.areSameExtensions)(ve,{id:ue}))?.version;if(de){const ve=ae.versions.find(Ie=>Ie.version===de);ve&&ie.push(O(ae,ve,C(ae),ne,oe))}else ie.push(Y(ae,ne,oe,void 0,i))}return ie}async getCompatibleExtension(N,Z){const ie=(0,k.isIExtensionIdentifier)(N)?null:N;if(ie){if((0,k.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(ie,Z))return ie}const{id:oe,uuid:le}=ie?ie.identifier:N;let ne=new R().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?ne=ne.withFilter(r.ExtensionId,le):ne=ne.withFilter(r.ExtensionName,oe);const{galleryExtensions:ae}=await this.queryGallery(ne,Z,L.CancellationToken.None),[ue]=ae;if(!ue||!ue.versions.length)return null;const de=C(ue);if((0,k.isNotWebExtensionInWebTargetPlatform)(de,Z))return null;for(let ve of ue.versions){if(!F(ve)){const Ie=await this.getEngine(ve);ve={...ve,properties:[...ve.properties||[],{key:g.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(ve,de,Z))return O(ue,ve,de,0,ne)}return null}async isExtensionCompatible(N,Z){if(!(0,k.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,Z))return!1;let ie=N.properties.engine;if(!ie){const oe=await this.getManifest(N,L.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");ie=oe.engines.vscode}return(0,S.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,Z,ie){if(!(0,k.isTargetPlatformCompatible)(B(N),Z,ie))return!1;const oe=await this.getEngine(N);return(0,S.isEngineValid)(oe,this.productService.version,this.productService.date)}async query(N,Z){const ie=L.CancellationToken.isCancellationToken(N)?{}:N,oe=L.CancellationToken.isCancellationToken(N)?N:Z;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=ie.text||"";const ne=(0,D.getOrDefault)(ie,me=>me.pageSize,50);let ae=new R().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,ne).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ge,Ee)=>(ae=ae.withFilter(r.Category,Ee||ge),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ge,Ee)=>(ae=ae.withFilter(r.Tag,Ee||ge),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(r.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),ae=ae.withFilter(r.SearchText,le)),ae=ae.withSortBy(0)):ie.ids?ae=ae.withFilter(r.ExtensionId,...ie.ids):ie.names?ae=ae.withFilter(r.ExtensionName,...ie.names):ae=ae.withSortBy(4),typeof ie.sortBy=="number"&&(ae=ae.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(ae=ae.withSortOrder(ie.sortOrder));const{galleryExtensions:ue,total:de}=await this.queryGallery(ae,i,oe),ve=ue.map((me,ge)=>Y(me,ge,ae,ie.source,i)),Ie=async(me,ge)=>{if(ge.isCancellationRequested)throw(0,M.canceled)();const Ee=ae.withPage(me+1),{galleryExtensions:ke}=await this.queryGallery(Ee,i,ge);return ke.map((Ae,We)=>Y(Ae,We,Ee,ie.source,i))};return{firstPage:ve,total:de,pageSize:ae.pageSize,getPage:Ie}}async queryGallery(N,Z,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,l.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(l.Unpublished));const oe=await this.commonHeadersPromise,le=JSON.stringify(N.raw),ne={...oe,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},ae=new Date().getTime();let ue,de,ve=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:ne},ie),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ve};const Ie=await(0,y.asJson)(ue);if(Ie){const me=Ie.results[0],ge=me.extensions;ge.forEach(ke=>U(ke.versions,Z));const Ee=me.resultMetadata&&me.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return ve=Ee&&Ee.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ve}}return{galleryExtensions:[],total:ve}}catch(Ie){throw de=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-ae,success:!!ue&&(0,y.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:de?(0,M.isPromiseCanceledError)(de)?"canceled":(0,M.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(N,Z,ie,oe){if(!this.isEnabled())return;const le=I.isWeb?this.api(`/itemName/${N}.${Z}/version/${ie}/statType/${oe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${Z}/${ie}/stats?statType=${oe}`),ne=I.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ne};try{await this.requestService.request({type:"POST",url:le,headers:ue},L.CancellationToken.None)}catch(de){}}async download(N,Z,ie){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const oe=(0,b.getGalleryExtensionTelemetryData)(N),le=new Date().getTime(),ne=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...oe,duration:ve}),ae=ie===1?"install":ie===2?"update":"",ue=ae?{uri:`${N.assets.download.uri}${f.URI.parse(N.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${N.assets.download.fallbackUri}${f.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:N.assets.download,de=await this.getAsset(ue);await this.fileService.writeFile(Z,de.stream),ne(new Date().getTime()-le)}async getReadme(N,Z){if(N.assets.readme){const ie=await this.getAsset(N.assets.readme,{},Z);return await(0,y.asText)(ie)||""}return""}async getManifest(N,Z){if(N.assets.manifest){const ie=await this.getAsset(N.assets.manifest,{},Z),oe=await(0,y.asText)(ie);return oe?JSON.parse(oe):null}return null}async getManifestFromRawExtensionVersion(N,Z){const ie=K(N,a.Manifest);if(!ie)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},le=await this.getAsset(ie,{headers:oe});return await(0,y.asJson)(le)}async getCoreTranslation(N,Z){const ie=N.assets.coreTranslations.filter(oe=>oe[0]===Z.toUpperCase())[0];if(ie){const oe=await this.getAsset(ie[1]),le=await(0,y.asText)(oe);return le?JSON.parse(le):null}return null}async getChangelog(N,Z){if(N.assets.changelog){const ie=await this.getAsset(N.assets.changelog,{},Z);return await(0,y.asText)(ie)||""}return""}async getAllCompatibleVersions(N,Z){let ie=new R().withFlags(l.IncludeVersions,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?ie=ie.withFilter(r.ExtensionId,N.identifier.uuid):ie=ie.withFilter(r.ExtensionName,N.identifier.id);const{galleryExtensions:oe}=await this.queryGallery(ie,Z,L.CancellationToken.None);if(!oe.length)return[];const le=C(oe[0]);if((0,k.isNotWebExtensionInWebTargetPlatform)(le,Z))return[];const ne=[];for(const ae of oe[0].versions)try{ne[ne.length-1]?.version!==ae.version&&await this.isRawExtensionVersionCompatible(ae,le,Z)&&ne.push({version:ae.version,date:ae.lastUpdated})}catch(ue){}return ne}async getAsset(N,Z={},ie=L.CancellationToken.None){const oe=await this.commonHeadersPromise,le={type:"GET"},ne={...oe,...Z.headers||{}};Z={...Z,...le,headers:ne};const ae=N.uri,ue=N.fallbackUri,de={...Z,url:ae};try{const ve=await this.requestService.request(de,ie);if(ve.res.statusCode===200)return ve;const Ie=await(0,y.asText)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${Ie}`)}catch(ve){if((0,M.isPromiseCanceledError)(ve))throw ve;const Ie=(0,M.getErrorMessage)(ve);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:Ie});const me={...Z,url:ue};return this.requestService.request(me,ie)}}async getEngine(N){let Z=F(N);if(!Z){const ie=await this.getManifestFromRawExtensionVersion(N,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");Z=ie.engines.vscode}return Z}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,y.asJson)(N),ie=new Map;if(Z)for(const oe of Z.malicious){const le=ie.get(oe)||{id:{id:oe},malicious:!0,slow:!1};le.malicious=!0,ie.set(oe,le)}return[...ie.values()]}};T=he([te(1,y.IRequestService),te(2,m.ILogService),te(3,t.IEnvironmentService),te(4,o.ITelemetryService),te(5,d.IFileService),te(6,E.IProductService),te(7,w.IConfigurationService)],T);let _=class extends T{constructor(N,Z,ie,oe,le,ne,ae,ue){super(N,Z,ie,oe,le,ne,ae,ue)}};_=he([te(0,h.IStorageService),te(1,y.IRequestService),te(2,m.ILogService),te(3,t.IEnvironmentService),te(4,o.ITelemetryService),te(5,d.IFileService),te(6,E.IProductService),te(7,w.IConfigurationService)],_),e.ExtensionGalleryService=_;let q=class extends T{constructor(N,Z,ie,oe,le,ne,ae){super(void 0,N,Z,ie,oe,le,ne,ae)}};q=he([te(0,y.IRequestService),te(1,m.ILogService),te(2,t.IEnvironmentService),te(3,o.ITelemetryService),te(4,d.IFileService),te(5,E.IProductService),te(6,w.IConfigurationService)],q),e.ExtensionGalleryServiceWithNoStorageService=q;async function X($,N,Z,ie,oe,le){const ne={"X-Market-Client-Id":`VSCode ${$}`,"User-Agent":`VSCode ${$}`},ae=await(0,c.getServiceMachineId)(Z,oe,le);return(0,u.supportsTelemetry)(N,Z)&&(0,u.getTelemetryLevel)(ie)===3&&(ne["X-Market-User-Id"]=ae),ne}e.resolveMarketplaceHeaders=X}),define(Q[199],J([0,1,2,43,3,27,147,16,49,45,37,29,62]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(E,y){this._configurationService=y,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=E.appenders,this._commonProperties=E.commonProperties||Promise.resolve({}),this._piiPaths=E.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!E.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(c=>{const h=/^[a-f0-9]+$/i.test(c["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!h})})}setExperimentProperty(E,y){this._experimentProperties[E]=y}_updateTelemetryLevel(){this._telemetryLevel=(0,b.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const E=await this._commonProperties;let y=E.sessionID,c=E["common.instanceId"],h=E["common.machineId"],o=E["common.firstSessionDate"],u=E["common.msftInternal"];return{sessionId:y,instanceId:c,machineId:h,firstSessionDate:o,msftInternal:u}}dispose(){this._disposables.dispose()}_log(E,y,c,h){return this.telemetryLevel<y?Promise.resolve(void 0):this._commonProperties.then(o=>{c=(0,L.mixin)(c,o),c=(0,L.mixin)(c,this._experimentProperties),c=(0,L.cloneAndChange)(c,u=>{if(typeof u=="string")return this._cleanupInfo(u,h)}),this._appenders.forEach(u=>u.log(E,c))},o=>{console.error(o)})}publicLog(E,y,c){return this._log(E,3,y,c)}publicLog2(E,y,c){return this.publicLog(E,y,c)}publicLogError(E,y){return this.sendErrorTelemetry?this._log(E,2,y,!0):Promise.resolve(void 0)}publicLogError2(E,y){return this.publicLogError(E,y)}_anonymizeFilePaths(E){let y=E;const c=[];for(let i of this._cleanupPatterns)for(;;){const l=i.exec(E);if(!l)break;c.push([l.index,i.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(y="";;){const i=o.exec(E);if(!i)break;!h.test(i[0])&&c.every(([l,s])=>i.index<l||i.index>=s)&&(y+=E.substring(u,i.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<E.length&&(y+=E.substr(u)),y}_removePropertiesWithPossibleUserInfo(E){if(!E)return E;const y=E.toLowerCase(),c=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(y)?"<REDACTED: secret>":c.test(y)?"<REDACTED: email>":E}_cleanupInfo(E,y){let c=E;y&&(c=this._anonymizeFilePaths(c));for(let h of this._cleanupPatterns)c=c.replace(h,"");return c=this._removePropertiesWithPossibleUserInfo(c),c}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=he([te(1,n.IConfigurationService)],S),e.TelemetryService=S;function d(){const m=(0,I.localize)(0,null,w.default.nameLong),E=w.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=M.isWeb?"":(0,I.localize)(3,null),c=(0,I.localize)(4,null),h=(0,I.localize)(5,null),o=(0,I.localize)(6,null),u=(0,I.localize)(7,null),i=`
|       | ${c} | ${h} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,l=(0,I.localize)(8,null);return`
${m} ${E} ${y}

&nbsp;

${u}
${i}

&nbsp;

${l}
`}t.Registry.as(f.Extensions.Configuration).registerConfiguration({id:k.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[k.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:d(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),t.Registry.as(f.Extensions.Configuration).registerConfiguration({id:k.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[k.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,I.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,I.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${k.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[200],J([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Q[201],J([0,1,107,4,2,5,37,200]),function(V,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var f;(function(E){function y(c){return c&&typeof c=="object"&&typeof c.id=="string"}E.isThemeColor=y})(f=e.ThemeColor||(e.ThemeColor={}));function w(E){return{id:E}}e.themeColorFromId=w;var t;(function(E){function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color=="undefined"||f.isThemeColor(l.color))}E.isThemeIcon=y;const c=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function h(l){const s=c.exec(l);if(!s)return;let[,r]=s;return{id:r}}E.fromString=h;function o(l,s){let r=l.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),s&&(r=`${r}~${s}`),{id:r}}E.modify=o;function u(l,s){return l.id===s.id&&l.color?.id===s.color?.id}E.isEqual=u;function i(l,s){return{id:l.id,color:s?w(s):void 0}}E.asThemeIcon=i,E.asClassNameArray=v.CSSIcon.asClassNameArray,E.asClassName=v.CSSIcon.asClassName,E.asCSSSelector=v.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function k(E){switch(E){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,M.toDisposable)(()=>{const c=this.themingParticipants.indexOf(y);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new b;I.Registry.add(e.Extensions.ThemingContribution,S);function d(E){return S.onColorThemeChange(E)}e.registerThemingParticipant=d;class m extends M.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,c){let h=this.theme.getColor(y);return h&&c&&(h=c(h,this.theme)),h?h.toString():null}}e.Themable=m}),define(Q[63],J([0,1,14,3,5,38]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const I="#FFFFFF",n="#1E1E1E",f="#000000",w="theme",t="themeBackground",k="windowSplash";e.IThemeMainService=(0,M.createDecorator)("themeMainService");let b=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return f;let d=this.stateMainService.getItem(t,null);if(!d){let m;(L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?m="hc-black":m=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],d=m==="hc-black"?f:m==="vs"?I:n}return L.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,m){this.stateMainService.setItems([{key:w,data:m.baseTheme},{key:t,data:m.colorInfo.background},{key:k,data:m}]),typeof d=="number"&&this.updateBackgroundColor(d,m)}updateBackgroundColor(d,m){for(const E of v.BrowserWindow.getAllWindows())if(E.id===d){E.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(k)}};b=he([te(0,D.IStateMainService)],b),e.ThemeMainService=b}),define(Q[41],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(L=e.StateType||(e.StateType={}));var M;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(M=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(D,I)=>({type:"idle",updateType:D,error:I}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Q[202],J([0,1,3,148,49,37]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[203],J([0,1,4,41]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class M{constructor(n){this.service=n}listen(n,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=M;class D{constructor(n){this.channel=n,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=D}),define(Q[97],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Q[204],J([0,1,7]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,f){throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"handleURL":return this.handler.handleURL(v.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class M{constructor(n){this.channel=n}handleURL(n,f){return this.channel.call("handleURL",[n.toJSON(),f])}}e.URLHandlerChannelClient=M;class D{constructor(n){this.next=n}async routeCall(n,f,w,t){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(w){const k=v.URI.revive(w);if(k&&k.query){const b=/\bwindowId=(\d+)/.exec(k.query);if(b){const S=b[1],d=new RegExp(`window:${S}`),m=n.connections.find(E=>d.test(E.ctx));if(m)return m}}}return this.next.routeCall(n,f,w,t)}routeEvent(n,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=D}),define(Q[205],J([0,1,9,2,7,21]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class I extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,t){const k=[...this.handlers.values()];return(0,v.first)(k.map(b=>()=>b.handleURL(w,t)),void 0,!1).then(b=>b||!1)}registerHandler(w){return this.handlers.add(w),(0,L.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=I;let n=class extends I{constructor(w){super();this.productService=w}create(w){let{authority:t,path:k,query:b,fragment:S}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&k&&k.indexOf("/")!==0&&(k=`/${k}`),M.URI.from({scheme:this.productService.urlProtocol,authority:t,path:k,query:b,fragment:S})}};n=he([te(0,D.IProductService)],n),e.NativeURLService=n}),define(Q[206],J([0,1,14,9,4,2,3,7]),function(V,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(t){try{return n.URI.parse(t)}catch(k){return null}}class w{constructor(k,b,S,d,m){if(this.urlService=b,this.uris=[],this.retryCount=0,this.flushDisposable=D.Disposable.None,this.disposables=new D.DisposableStore,this.uris=k,I.isWindows){const c=d.isBuilt?[]:[`"${d.appRoot}"`];c.push("--open-url","--"),v.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,c)}const E=M.Event.map(M.Event.fromNodeEventEmitter(v.app,"open-url",(c,h)=>({event:c,url:h})),({event:c,url:h})=>(c.preventDefault(),h));this.disposables.add(E(c=>{const h=f(c);!h||this.urlService.open(h,{originalUrl:c})})),S.getWindows().filter(c=>c.isReady).length>0?this.flush():M.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const k=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.url})||k.push(b);k.length!==0&&(this.uris=k,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(Q[207],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Q[208],J([0,1,14,2,10,7]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class I extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(M.Schemas.vscodeWebview,f)}handleWebviewRequest(f,w){try{const t=D.URI.parse(f.url),k=I.validWebviewFilePaths.get(t.path);if(typeof k=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${k}`,S=M.FileAccess.asFileUri(b,V);return w(decodeURIComponent(S.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=I,I.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Q[64],J([0,1,3]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return!!w.workspaceUri}e.isWorkspaceToOpen=L;function M(w){return!!w.folderUri}e.isFolderToOpen=M;function D(w){return!!w.fileUri}e.isFileToOpen=D;function I(w){const t=n(w),k=w.getValue("window.menuBarVisibility");return k==="default"||t==="native"&&k==="compact"||v.isMacintosh&&v.isNative?"classic":k}e.getMenuBarVisibility=I;function n(w){if(v.isWeb)return"custom";const t=w.getValue("window");if(t){if(v.isMacintosh&&t.nativeTabs===!0||v.isMacintosh&&t.nativeFullScreen===!1)return"native";const S=t.titleBarStyle;if(S==="native"||S==="custom")return S}return v.isLinux?"native":"custom"}e.getTitleBarStyle=n;function f(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=f}),define(Q[36],J([0,1,5]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var M;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));var D;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(D=e.OpenContext||(e.OpenContext={}));const I=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=I;var n;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var f;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(Q[209],J([0,1,14,4,2,208,36]),function(V,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends M.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new D.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,t){let k;if(typeof w.windowId=="number"){const{windowId:b}=w,S=this.windowsMainService.getWindowById(b);if(!S?.win)throw new Error(`Invalid windowId: ${b}`);k=S.win.webContents}else{const{webContentsId:b}=w;if(k=v.webContents.fromId(b),!k)throw new Error(`Invalid webContentsId: ${b}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(t)}async findInFrame(w,t,k,b){const S=this.getFrameByName(w,t),d=S;if(typeof d.findInFrame=="function"){d.findInFrame(k,{findNext:b.findNext,forward:b.forward});const m=(E,y)=>{y.finalUpdate&&(this._onFoundInFrame.fire(y),S.removeListener("found-in-frame",m))};S.on("found-in-frame",m)}}async stopFindInFrame(w,t,k){const S=this.getFrameByName(w,t);typeof S.stopFindInFrame=="function"&&S.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,t){const k=this.windowsMainService.getWindowById(w.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${w}`);const b=k.win.webContents.mainFrame.framesInSubtree.find(S=>S.name===t);if(!b)throw new Error(`Unknown frame: ${t}`);return b}};n=he([te(0,I.IWindowsMainService)],n),e.WebviewMainService=n}),define(Q[210],J([0,1,9,4,2]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends M.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:f,getActiveWindowId:w}){super();this.disposables=this._register(new M.DisposableStore),L.Event.latch(L.Event.any(n,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>w()),(async()=>{try{const k=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:k}catch(k){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=D}),define(Q[211],J([0,1,40,15,7,5]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var I;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function n(b){const S=b;return!!(S&&typeof S=="object"&&typeof S.id=="string"&&Array.isArray(S.folders))}e.isWorkspace=n;function f(b){const S=b;return!!(S&&typeof S=="object"&&M.URI.isUri(S.uri)&&typeof S.name=="string"&&typeof S.toResource=="function")}e.isWorkspaceFolder=f;class w{constructor(S,d,m,E,y){this._id=S,this._transient=m,this._configuration=E,this._ignorePathCasing=y,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(S){this._id=S.id,this._configuration=S.configuration,this._transient=S.transient,this._ignorePathCasing=S._ignorePathCasing,this.folders=S.folders}get folders(){return this._folders}set folders(S){this._folders=S,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(S){this._configuration=S}getFolder(S){return S&&this._foldersMap.findSubstr(S.with({scheme:S.scheme,authority:S.authority,path:S.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const S of this.folders)this._foldersMap.set(S.uri,S)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class t{constructor(S,d){this.raw=d,this.uri=S.uri,this.index=S.index,this.name=S.name}toResource(S){return(0,L.joinPath)(this.uri,S)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function k(b){return new t({uri:b,index:0,name:(0,L.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=k}),define(Q[26],J([0,1,33,39,78,34,10,8,3,15,7,151,5,61,211]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(F){return(typeof F=="string"?(0,n.extname)(F):(0,w.extname)(F))===m}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function y(F){return F.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function c(F){return F.hasOwnProperty("folderUri")}e.isRecentFolder=c;function h(F){return F.hasOwnProperty("fileUri")}e.isRecentFile=h;function o(F){const H=F;return typeof H?.id=="string"&&t.URI.isUri(H.uri)}e.isSingleFolderWorkspaceIdentifier=o;function u(F){if(F.configuration)return{id:F.id,configPath:F.configuration};if(F.folders.length===1)return{id:F.id,uri:F.folders[0].uri}}e.toWorkspaceIdentifier=u;function i(F){const H=F;return typeof H?.id=="string"&&t.URI.isUri(H.configPath)}e.isWorkspaceIdentifier=i;function l(F){const H=F;if(H?.uri)return{id:H.id,uri:t.URI.revive(H.uri)};const z=F;if(z?.configPath)return{id:z.id,configPath:t.URI.revive(z.configPath)};if(F?.id)return{id:F.id}}e.reviveIdentifier=l;function s(F,H){return w.extUriBiasedIgnorePathCase.isEqualOrParent(F,H.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(F){return a(F)||g(F)}e.isStoredWorkspaceFolder=r;function a(F){const H=F;return typeof H?.path=="string"&&(!H.name||typeof H.name=="string")}e.isRawFileWorkspaceFolder=a;function g(F){const H=F;return typeof H?.uri=="string"&&(!H.name||typeof H.name=="string")}e.isRawUriWorkspaceFolder=g;function p(F,H,z,B,C=!f.isWindows,U){if(F.scheme!==B.scheme)return{name:z,uri:F.toString(!0)};let Y=H?void 0:U.relativePath(B,F);if(Y!==void 0)Y.length===0?Y=".":f.isWindows&&F.scheme===I.Schemas.file&&!C&&(Y=Y.replace(/\//g,"\\"));else if(F.scheme===I.Schemas.file)Y=F.fsPath,f.isWindows&&(Y=(0,D.normalizeDriveLetter)(Y),C&&(Y=(0,v.toSlashes)(Y)));else{if(!U.isEqualAuthority(F.authority,B.authority))return{name:z,uri:F.toString(!0)};Y=F.path}return{name:z,path:Y}}e.getStoredWorkspaceFolder=p;function P(F,H,z){let B=[],C=new Set;const U=z.dirname(H);for(let Y of F){let O;if(a(Y))Y.path&&(O=z.resolvePath(U,Y.path));else if(g(Y))try{O=t.URI.parse(Y.uri),O.path[0]!=="/"&&(O=O.with({path:"/"+O.path}))}catch(T){console.warn(T)}if(O){let T=z.getComparisonKey(O);if(!C.has(T)){C.add(T);const _=Y.name||z.basenameOrAuthority(O);B.push(new d.WorkspaceFolder({uri:O,name:_,index:B.length},Y))}}}return B}e.toWorkspaceFolders=P;function R(F,H,z,B,C){let U=A(H,F);const Y=C.dirname(H),O=C.dirname(B),T=[],_=W(U.folders);for(const N of U.folders){const Z=a(N)?C.resolvePath(Y,N.path):t.URI.parse(N.uri);let ie;z?ie=!1:ie=!a(N)||(0,n.isAbsolute)(N.path),T.push(p(Z,ie,N.name,O,_,C))}const q={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},X=M.setProperty(F,["folders"],T,q);let $=M.applyEdits(F,X);return U.remoteAuthority===(0,S.getRemoteAuthority)(B)&&($=M.applyEdits($,M.removeProperty($,["remoteAuthority"],q))),$}e.rewriteWorkspaceFileForNewLocation=R;function A(F,H){let z=L.parse(H);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(B=>r(B));else throw new Error(`${F} looks like an invalid workspace file.`);return z}function W(F){return f.isWindows?F.some(H=>a(H)&&H.path.indexOf("/")>=0):!0}e.useSlashForPath=W;function j(F){return F.workspace&&typeof F.workspace=="object"&&typeof F.workspace.id=="string"&&typeof F.workspace.configPath=="string"}function x(F){return typeof F.folderUri=="string"}function re(F){return typeof F.fileUri=="string"}function K(F,H){const z={workspaces:[],files:[]};if(F){const B=function(U,Y){for(let O=0;O<U.length;O++)try{Y(U[O],O)}catch(T){H.warn(`Error restoring recent entry ${JSON.stringify(U[O])}: ${T.toString()}. Skip entry.`)}},C=F;if(Array.isArray(C.entries))B(C.entries,U=>{const Y=U.label,O=U.remoteAuthority;j(U)?z.workspaces.push({label:Y,remoteAuthority:O,workspace:{id:U.workspace.id,configPath:t.URI.parse(U.workspace.configPath)}}):x(U)?z.workspaces.push({label:Y,remoteAuthority:O,folderUri:t.URI.parse(U.folderUri)}):re(U)&&z.files.push({label:Y,remoteAuthority:O,fileUri:t.URI.parse(U.fileUri)})});else{const U=F;Array.isArray(U.workspaces3)&&B(U.workspaces3,(Y,O)=>{const T=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[O]||void 0;typeof Y=="object"&&typeof Y.id=="string"&&typeof Y.configURIPath=="string"?z.workspaces.push({label:T,workspace:{id:Y.id,configPath:t.URI.parse(Y.configURIPath)}}):typeof Y=="string"&&z.workspaces.push({label:T,folderUri:t.URI.parse(Y)})}),Array.isArray(U.files2)&&B(U.files2,(Y,O)=>{const T=Array.isArray(U.fileLabels)&&U.fileLabels[O]||void 0;typeof Y=="string"&&z.files.push({label:T,fileUri:t.URI.parse(Y)})})}}return z}e.restoreRecentlyOpened=K;function ee(F){const H={entries:[]};for(const z of F.workspaces)c(z)?H.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):H.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of F.files)H.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return H}e.toStoreData=ee}),define(Q[51],J([0,1,5,26]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function M(D){const I=D;return I&&(0,L.isWorkspaceIdentifier)(I.workspace)}e.isWorkspaceBackupInfo=M}),define(Q[52],J([0,1,14,9,81,34,2,68,8,3,13,19,132,5,6,38,26]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let y=class gt{constructor(h,o){this.stateMainService=h,this.logService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(h,o){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},o)}pickFolder(h,o){return this.doPick({...h,pickFolders:!0,title:(0,b.localize)(1,null)},o)}pickFile(h,o){return this.doPick({...h,pickFiles:!0,title:(0,b.localize)(2,null)},o)}pickWorkspace(h,o){const u=(0,b.localize)(3,null),i=(0,D.mnemonicButtonLabel)((0,b.localize)(4,null)),l=E.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:u,filters:l,buttonLabel:i},o)}async doPick(h,o){const u={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters};u.defaultPath=h.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(u.properties=void 0,h.pickFiles&&h.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&u.properties.push("treatPackageAsDirectory");const i=o||v.BrowserWindow.getFocusedWindow(),l=await this.showOpenDialog(u,(0,t.withNullAsUndefined)(i));if(l&&l.filePaths&&l.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(l.filePaths[0])),l.filePaths}getWindowDialogQueue(h){if(h){let o=this.windowDialogQueues.get(h.id);return o||(o=new L.Queue,this.windowDialogQueues.set(h.id,o)),o}else return this.noWindowDialogueQueue}showMessageBox(h,o){return this.getWindowDialogQueue(o).queue(async()=>o?v.dialog.showMessageBox(o,h):v.dialog.showMessageBox(h))}async showSaveDialog(h,o){const u=this.acquireFileDialogLock(h,o);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(o).queue(async()=>{let i;return o?i=await v.dialog.showSaveDialog(o,h):i=await v.dialog.showSaveDialog(h),i.filePath=this.normalizePath(i.filePath),i})}finally{(0,I.dispose)(u)}}normalizePath(h){return h&&w.isMacintosh&&(h=(0,n.normalizeNFC)(h)),h}normalizePaths(h){return h.map(o=>this.normalizePath(o))}async showOpenDialog(h,o){h.defaultPath&&(await k.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const u=this.acquireFileDialogLock(h,o);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(o).queue(async()=>{let i;return o?i=await v.dialog.showOpenDialog(o,h):i=await v.dialog.showOpenDialog(h),i.filePaths=this.normalizePaths(i.filePaths),i})}finally{(0,I.dispose)(u)}}acquireFileDialogLock(h,o){if(!o)return I.Disposable.None;let u=this.windowFileDialogLocks.get(o.id);u||(u=new Set,this.windowFileDialogLocks.set(o.id,u));const i=(0,M.hash)(h);if(!u.has(i))return u.add(i),(0,I.toDisposable)(()=>{u?.delete(i),u?.size===0&&this.windowFileDialogLocks.delete(o.id)})}};y.workingDirPickerStorageKey="pickerWorkingDir",y=he([te(0,m.IStateMainService),te(1,d.ILogService)],y),e.DialogMainService=y}),define(Q[212],J([0,1,4,2,26]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends L.Disposable{constructor(n,f){super();this.logService=n,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,f)=>(n?n.push(f):n=[f],n),D.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const f=new Map,w=new Set;return n.forEach(t=>{const k=this.storageMainService.globalStorage.get(t.key);typeof k=="string"?f.set(t.key,k):w.add(t.key)}),{changed:Array.from(f.entries()),deleted:Array.from(w.values())}}listen(n,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(n,f,w){const t=(0,M.reviveIdentifier)(w.workspace),k=await this.withStorageInitialized(t);switch(f){case"getItems":return Array.from(k.items.entries());case"updateItems":{const b=w;if(b.insert)for(const[S,d]of b.insert)k.set(S,d);b.delete&&b.delete.forEach(S=>k.delete(S));break}case"close":{if(t)return k.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(n){const f=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await f.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${w}`)}return f}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[213],J([0,1,4,2,8,28,19,86,122,6,96,29,26]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class S extends L.Disposable{constructor(y){super();this.logService=y,this._onDidChangeStorage=this._register(new v.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new v.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const y=await this.doCreate();this.storage.dispose(),this.storage=y,this._register(y.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(y);const c=y.getBoolean(t.IS_NEW_KEY);c===void 0?y.set(t.IS_NEW_KEY,!0):c&&y.set(t.IS_NEW_KEY,!1)}catch(y){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${y}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?y=>this.logService.trace(y):void 0,logError:y=>this.logService.error(y)}}doInit(y){return y.init()}get items(){return this.storage.items}get(y,c){return this.storage.get(y,c)}set(y,c){return this.storage.set(y,c)}delete(y){return this.storage.delete(y)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends S{constructor(y,c,h){super(c);this.options=y,this.environmentService=h}async doCreate(){let y;return this.options.useInMemoryStorage?y=f.SQLiteStorageDatabase.IN_MEMORY_PATH:y=(0,M.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new f.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}))}async doInit(y){await super.doInit(y),this.updateTelemetryState(y)}updateTelemetryState(y){y.get(k.instanceStorageKey,void 0)===void 0&&y.set(k.instanceStorageKey,(0,D.generateUuid)()),y.get(k.firstSessionDateStorageKey,void 0)===void 0&&y.set(k.firstSessionDateStorageKey,new Date().toUTCString());const o=y.get(k.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();y.set(k.lastSessionDateStorageKey,typeof o=="undefined"?null:o),y.set(k.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class m extends S{constructor(y,c,h,o){super(h);this.workspace=y,this.options=c,this.environmentService=o}async doCreate(){const{storageFilePath:y,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new f.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const y=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,M.join)(y,m.WORKSPACE_STORAGE_NAME);return await I.Promises.exists(y)?{storageFilePath:c,wasCreated:!1}:(await I.Promises.mkdir(y,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(y),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(y){let c;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const h=(0,M.join)(y,m.WORKSPACE_META_NAME);await I.Promises.exists(h)||await I.Promises.writeFile(h,JSON.stringify(c,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=m,m.WORKSPACE_STORAGE_NAME="state.vscdb",m.WORKSPACE_META_NAME="workspace.json"}),define(Q[98],J([0,1,42,2,48,5,22,6,213]),function(V,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,D.createDecorator)("storageMainService");let w=class extends L.Disposable{constructor(k,b,S){super();this.logService=k,this.environmentService=b,this.lifecycleMainService=S,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async k=>{k.workspace&&this.workspaceStorage(k.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(k=>{k.join(this.globalStorage.close());for(const[,b]of this.mapWorkspaceToStorage)k.join(b.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const k=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(k.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),k}createWorkspaceStorage(k){return new f.WorkspaceStorageMain(k,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(k){let b=this.mapWorkspaceToStorage.get(k.id);return b||(this.logService.trace(`StorageMainService: creating workspace storage (${k.id})`),b=this.createWorkspaceStorage(k),this.mapWorkspaceToStorage.set(k.id,b),(0,v.once)(b.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${k.id})`),this.mapWorkspaceToStorage.delete(k.id)})),b}};w=he([te(0,n.ILogService),te(1,M.IEnvironmentService),te(2,I.ILifecycleMainService)],w),e.StorageMainService=w}),define(Q[99],J([0,1,15,7,26]),function(V,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function D(f,w,t){for(const b of f){const S=b.openedWorkspace;if((0,M.isWorkspaceIdentifier)(S)){const d=t(S);if(d){if(d.folders.some(m=>v.extUriBiasedIgnorePathCase.isEqualOrParent(w,m.uri)))return b}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(w,S.configPath))return b}}const k=f.filter(b=>(0,M.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(w,b.openedWorkspace.uri));if(k.length)return k.sort((b,S)=>-(b.openedWorkspace.uri.path.length-S.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=D;function I(f,w){for(const t of f)if((0,M.isWorkspaceIdentifier)(t.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.configPath,w)||(0,M.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.uri,w))return t}e.findWindowOnWorkspaceOrFolder=I;function n(f,w){const t=k=>w.some(b=>v.extUriBiasedIgnorePathCase.isEqual(L.URI.file(b),L.URI.file(k)));for(const k of f)if(k.config?.extensionDevelopmentPath?.some(b=>t(b)))return k}e.findWindowOnExtensionDevelopmentPath=n}),define(Q[214],J([0,1,14,2,3,15,7,16,22,6,38,36,26]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let S=class mt extends L.Disposable{constructor(h,o,u,i,l){super();this.windowsMainService=h,this.stateMainService=o,this.lifecycleMainService=u,this.logService=i,this.configurationService=l,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),i&&(h.lastActiveWindow=this.toWindowState(i))}const o=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>this.toWindowState(i)));const u=E(h);this.stateMainService.setItem(mt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(u=>{const i=(0,b.isWorkspaceIdentifier)(h.openedWorkspace)&&u.workspace?.id===h.openedWorkspace.id,l=(0,b.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&u.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(u.folderUri,h.openedWorkspace.uri);(i||l)&&(u.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(h){return{workspace:(0,b.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,b.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const o=this.doGetNewWindowState(h),u=this.configurationService.getValue("window");let i;return o.hasDefaultState?i=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(i=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),i&&M.isMacintosh&&this.windowsMainService.getWindows().some(l=>l.isFullScreen)&&(i=!1)),o.mode===3&&!i&&(o.mode=1),o}doGetNewWindowState(h){const o=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=h.workspace;if((0,b.isWorkspaceIdentifier)(a)){const p=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===a.id).map(P=>P.uiState);if(p.length)return p[0]}if((0,b.isSingleFolderWorkspaceIdentifier)(a)){const p=this.state.openedWindows.filter(P=>P.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(P.folderUri,a.uri)).map(P=>P.uiState);if(p.length)return p[0]}else if(h.backupPath){const p=this.state.openedWindows.filter(P=>P.backupPath===h.backupPath).map(P=>P.uiState);if(p.length)return p[0]}const g=this.lastClosedState||this.state.lastActiveWindow;if(!o&&g)return g.uiState}let u;const i=v.screen.getAllDisplays();if(i.length===1)u=i[0];else{if(M.isMacintosh){const a=v.screen.getCursorScreenPoint();u=v.screen.getDisplayNearestPoint(a)}!u&&o&&(u=v.screen.getDisplayMatching(o.getBounds())),u||(u=v.screen.getPrimaryDisplay()||i[0])}let l=(0,k.defaultWindowState)();l.x=Math.round(u.bounds.x+u.bounds.width/2-l.width/2),l.y=Math.round(u.bounds.y+u.bounds.height/2-l.height/2);const s=this.configurationService.getValue("window");let r=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")l.mode=0,r=!1;else if(s.newWindowDimensions==="fullscreen")l.mode=3,r=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&o){const a=o.serializeWindowState();a.mode===3?l.mode=3:l=a,r=l.mode!==3&&s.newWindowDimensions==="offset"}}return r&&(l=this.ensureNoOverlap(l)),l.hasDefaultState=!0,l}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const o=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;o.some(u=>u.x===h.x||u.y===h.y);)h.x+=30,h.y+=30;return h}};S.windowsStateStorageKey="windowsState",S=he([te(0,k.IWindowsMainService),te(1,t.IStateMainService),te(2,f.ILifecycleMainService),te(3,w.ILogService),te(4,n.IConfigurationService)],S),e.WindowsStateHandler=S;function d(c){const h={openedWindows:[]},o=c||{openedWindows:[]};return o.lastActiveWindow&&(h.lastActiveWindow=m(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=m(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(h.openedWindows=o.openedWindows.map(u=>m(u))),h}e.restoreWindowsState=d;function m(c){const h={uiState:c.uiState};return c.backupPath&&(h.backupPath=c.backupPath),c.remoteAuthority&&(h.remoteAuthority=c.remoteAuthority),c.folder&&(h.folderUri=I.URI.parse(c.folder)),c.workspaceIdentifier&&(h.workspace={id:c.workspaceIdentifier.id,configPath:I.URI.parse(c.workspaceIdentifier.configURIPath)}),h}function E(c){return{lastActiveWindow:c.lastActiveWindow&&y(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&y(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(h=>y(h))}}e.getWindowsStateStoreData=E;function y(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(Q[100],J([0,1,58,31,10,3,15]),function(V,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(w){function t(){let k=w.scheme===M.Schemas.file?(0,I.originalFSPath)(w):w.toString();return D.isLinux||(k=k.toLowerCase()),(0,v.createHash)("md5").update(k).digest("hex")}return{id:t(),configPath:w}}e.getWorkspaceIdentifier=n;function f(w,t){function k(){if(w.scheme!==M.Schemas.file)return(0,v.createHash)("md5").update(w.toString()).digest("hex");if(!t)try{t=(0,L.statSync)(w.fsPath)}catch(d){return}let S;return D.isLinux?S=t.ino:D.isMacintosh?S=t.birthtime.getTime():D.isWindows&&(typeof t.birthtimeMs=="number"?S=Math.floor(t.birthtimeMs):S=t.birthtime.getTime()),(0,v.createHash)("md5").update(w.fsPath).update(S?String(S):"").digest("hex")}const b=k();if(typeof b=="string")return{id:b,uri:w}}e.getSingleFolderWorkspaceIdentifier=f}),define(Q[56],J([0,1,58,59,25,18,17,4,2,8,3,28,35,84,215]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(p){this.socket=p,this._errorListener=P=>{if(P){if(P.code==="EPIPE")return;(0,I.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(p){const P=R=>p(D.VSBuffer.wrap(R));return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(p){const P=R=>{p({type:0,hadError:R,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(p){return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(p){if(!this.socket.destroyed)try{this.socket.write(p.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,I.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,I.onUnexpectedError)(P)}}end(){this.socket.end()}drain(){return new Promise((p,P)=>{if(this.socket.bufferSize===0){p();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),p()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=m;var E;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var y;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(y||(y={}));class c extends f.Disposable{constructor(p,P,R,A){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=p,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=P,this._recordInflateBytes=A,P?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",W=>{console.error(W),(0,I.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})}),this._zlibInflate.on("data",W=>{this._pendingInflateData.push(W)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",W=>{console.error(W),(0,I.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})}),this._zlibDeflate.on("data",W=>{this._pendingDeflateData.push(W)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new S.ChunkStream,this._register(this.socket.onData(W=>this._acceptChunk(W))),this._register(this.socket.onClose(W=>this._onClose.fire(W)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):D.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._totalOutgoingDataBytes+=p.byteLength,this._zlibDeflate?(this._zlibDeflate.write(p.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let P=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.length-4),this._isEnded||this._write(D.VSBuffer.wrap(P),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(p,!1)}_write(p,P){let R=2;p.byteLength<126?R+=0:p.byteLength<2**16?R+=2:R+=8;const A=D.VSBuffer.alloc(R);if(P?A.writeUInt8(194,0):A.writeUInt8(130,0),p.byteLength<126)A.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){A.writeUInt8(126,1);let W=1;A.writeUInt8(p.byteLength>>>8&255,++W),A.writeUInt8(p.byteLength>>>0&255,++W)}else{A.writeUInt8(127,1);let W=1;A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(p.byteLength>>>24&255,++W),A.writeUInt8(p.byteLength>>>16&255,++W),A.writeUInt8(p.byteLength>>>8&255,++W),A.writeUInt8(p.byteLength>>>0&255,++W)}this._totalOutgoingWireBytes+=A.byteLength+p.byteLength,this.socket.write(D.VSBuffer.concat([A,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._totalIncomingWireBytes+=p.byteLength,this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),R=P.readUInt8(0),A=(R&128)>>>7,W=(R&64)>>>6,j=P.readUInt8(1),x=(j&128)>>>7,re=j&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(W)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),R=P.readUInt8(1),A=(R&128)>>>7;let W=R&127,j=1;W===126?W=P.readUInt8(++j)*2**8+P.readUInt8(++j):W===127&&(W=P.readUInt8(++j)*0+P.readUInt8(++j)*0+P.readUInt8(++j)*0+P.readUInt8(++j)*0+P.readUInt8(++j)*2**24+P.readUInt8(++j)*2**16+P.readUInt8(++j)*2**8+P.readUInt8(++j));let x=0;A&&(x=P.readUInt8(++j)*2**24+P.readUInt8(++j)*2**16+P.readUInt8(++j)*2**8+P.readUInt8(++j)),this._state.state=3,this._state.readLen=W,this._state.mask=x}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);h(P,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(P.buffer)),this._zlibInflate.write(P.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(D.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=P.byteLength,this._onData.fire(P))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function h(g,p){if(p===0)return;let P=g.byteLength>>>2;for(let re=0;re<P;re++){const K=g.readUInt32BE(re*4);g.writeUInt32BE(K^p,re*4)}let R=P*4,A=g.byteLength-R;const W=p>>>24&255,j=p>>>16&255,x=p>>>8&255;A>=1&&g.writeUInt8(g.readUInt8(R)^W,R),A>=2&&g.writeUInt8(g.readUInt8(R+1)^j,R+1),A>=3&&g.writeUInt8(g.readUInt8(R+2)^x,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function u(){const g=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let p;return e.XDG_RUNTIME_DIR?p=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):p=(0,w.join)((0,M.tmpdir)(),`vscode-ipc-${g}.sock`),l(p),p}e.createRandomIPCHandle=u;function i(g,p,P){const R=(0,v.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${P}-${p}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${P}-${p}.sock`):A=(0,w.join)(g,`${P}-${p}.sock`),l(A),A}e.createStaticIPCHandle=i;function l(g){const p=o[t.platform];typeof p=="number"&&g.length>=p&&console.warn(`WARNING: IPC handle "${g}" is longer than ${p} chars, try a shorter --user-data-dir`)}class s extends b.IPCServer{constructor(p){super(s.toClientConnectionEvent(p));this.server=p}static toClientConnectionEvent(p){const P=n.Event.fromNodeEventEmitter(p,"connection");return n.Event.map(P,R=>({protocol:new S.Protocol(new m(R)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(g){return new Promise((p,P)=>{const R=(0,L.createServer)();R.on("error",P),R.listen(g,()=>{R.removeListener("error",P),p(new s(R))})})}e.serve=r;function a(g,p){return new Promise((P,R)=>{const A=(0,L.createConnection)(g,()=>{A.removeListener("error",R),P(S.Client.fromSocket(new m(A),p))});A.once("error",R)})}e.connect=a}),define(Q[216],J([0,1,56]),function(V,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,w){throw new Error("No event found")}call(f,w,t){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(t);case"reloadWindow":return this.driver.reloadWindow(t);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(t[0],t[1]);case"click":return this.driver.click(t[0],t[1],t[2],t[3]);case"doubleClick":return this.driver.doubleClick(t[0],t[1]);case"setValue":return this.driver.setValue(t[0],t[1],t[2]);case"getTitle":return this.driver.getTitle(t[0]);case"isActiveElement":return this.driver.isActiveElement(t[0],t[1]);case"getElements":return this.driver.getElements(t[0],t[1],t[2]);case"getElementXY":return this.driver.getElementXY(t[0],t[1],t[2]);case"typeInEditor":return this.driver.typeInEditor(t[0],t[1],t[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(t[0],t[1]);case"writeInTerminal":return this.driver.writeInTerminal(t[0],t[1],t[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(t);case"getLocalizedStrings":return this.driver.getLocalizedStrings(t)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=L;class M{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,w){return this.channel.call("dispatchKeybinding",[f,w])}click(f,w,t,k){return this.channel.call("click",[f,w,t,k])}doubleClick(f,w){return this.channel.call("doubleClick",[f,w])}setValue(f,w,t){return this.channel.call("setValue",[f,w,t])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,w){return this.channel.call("isActiveElement",[f,w])}getElements(f,w,t){return this.channel.call("getElements",[f,w,t])}getElementXY(f,w,t,k){return this.channel.call("getElementXY",[f,w,t,k])}typeInEditor(f,w,t){return this.channel.call("typeInEditor",[f,w,t])}getTerminalBuffer(f,w){return this.channel.call("getTerminalBuffer",[f,w])}writeInTerminal(f,w,t){return this.channel.call("writeInTerminal",[f,w,t])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=M;class D{constructor(f){this.registry=f}listen(f,w){throw new Error(`Event not found: ${w}`)}call(f,w,t){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(t);case"reloadWindowDriver":return this.registry.reloadWindowDriver(t)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=D;async function I(n){const f=await(0,v.connect)(n,"driverClient"),w=f.getChannel("driver"),t=new M(w);return{client:f,driver:t}}e.connect=I}),define(Q[217],J([0,1,9,4,105,57,2,3,80,35,56,155,216,172,22,36]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function E(h){return h<21}let y=class{constructor(o,u,i,l){this.windowServer=o,this.options=u,this.windowsMainService=i,this.lifecycleMainService=l,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const u=this.windowsMainService.getWindowById(o);if(!u?.win)throw new Error("Invalid window");return(await u.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const u=this.windowsMainService.getWindowById(o);if(!u)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(u)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(o,u){await this.whenUnfrozen(o);const i=M.KeybindingParser.parseUserBinding(u);for(let l of i)await this._dispatchKeybinding(o,l)}async _dispatchKeybinding(o,u){if(u instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(o);if(!i?.win)throw new Error("Invalid window");const l=i.win.webContents,s=new D.SimpleKeybinding(!1,!1,!1,!1,u.keyCode),a=new S.USLayoutResolvedKeybinding(s.toChord(),n.OS).getElectronAccelerator(),g=[];u.ctrlKey&&g.push("ctrl"),u.metaKey&&g.push("meta"),u.shiftKey&&g.push("shift"),u.altKey&&g.push("alt"),l.sendInputEvent({type:"keyDown",keyCode:a,modifiers:g}),E(u.keyCode)||l.sendInputEvent({type:"char",keyCode:a,modifiers:g}),l.sendInputEvent({type:"keyUp",keyCode:a,modifiers:g}),await(0,v.timeout)(100)}async click(o,u,i,l){await(await this.getWindowDriver(o)).click(u,i,l)}async doubleClick(o,u){await(await this.getWindowDriver(o)).doubleClick(u)}async setValue(o,u,i){await(await this.getWindowDriver(o)).setValue(u,i)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,u){return await(await this.getWindowDriver(o)).isActiveElement(u)}async getElements(o,u,i){return await(await this.getWindowDriver(o)).getElements(u,i)}async getElementXY(o,u,i,l){return await(await this.getWindowDriver(o)).getElementXY(u,i,l)}async typeInEditor(o,u,i){await(await this.getWindowDriver(o)).typeInEditor(u,i)}async getTerminalBuffer(o,u){return await(await this.getWindowDriver(o)).getTerminalBuffer(u)}async writeInTerminal(o,u,i){await(await this.getWindowDriver(o)).writeInTerminal(u,i)}async getLocaleInfo(o){return await(await this.getWindowDriver(o)).getLocaleInfo()}async getLocalizedStrings(o){return await(await this.getWindowDriver(o)).getLocalizedStrings()}async getWindowDriver(o){await this.whenUnfrozen(o);const u=`window:${o}`,i=new w.StaticRouter(s=>s===u),l=this.windowServer.getChannel("windowDriver",i);return new k.WindowDriverChannelClient(l)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await L.Event.toPromise(this.onDidReloadingChange.event)}};y=he([te(2,m.IWindowsMainService),te(3,d.ILifecycleMainService)],y),e.Driver=y;async function c(h,o,u,i){const l=u.driverVerbose,s=i.createInstance(y,h,{verbose:l}),r=new b.WindowDriverRegistryChannel(s);h.registerChannel("windowDriverRegistry",r);const a=await(0,t.serve)(o),g=new b.DriverChannel(s);return a.registerChannel("driver",g),(0,I.combinedDisposable)(a,h)}e.serve=c}),define(Q[24],J([0,1,47,8,56,48,159,5]),function(V,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(D.IEnvironmentService);class f extends I.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,M.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([v.memoize],f.prototype,"cachedLanguagesPath",null),he([v.memoize],f.prototype,"backupHome",null),he([v.memoize],f.prototype,"backupWorkspacesPath",null),he([v.memoize],f.prototype,"mainIPCHandle",null),he([v.memoize],f.prototype,"mainLockfile",null),he([v.memoize],f.prototype,"sandbox",null),he([v.memoize],f.prototype,"driverVerbose",null),he([v.memoize],f.prototype,"disableUpdates",null),he([v.memoize],f.prototype,"disableKeytar",null),he([v.memoize],f.prototype,"codeCachePath",null),he([v.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(Q[218],J([0,1,58,31,33,10,8,3,15,7,19,51,16,24,20,6,26]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let y=class{constructor(h,o,u){this.configurationService=o,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,l)=>(0,M.isEqual)(i,l,!n.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await t.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(i){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let o=[];try{Array.isArray(h.rootURIWorkspaces)&&(o=h.rootURIWorkspaces.map(i=>({workspace:{id:i.id,configPath:w.URI.parse(i.configURIPath)},remoteAuthority:i.remoteAuthority})))}catch(i){}this.workspaces=await this.validateWorkspaces(o);let u=[];try{Array.isArray(h.folderURIWorkspaces)&&(u=h.folderURIWorkspaces.map(i=>w.URI.parse(i)))}catch(i){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,o){this.workspaces.some(i=>h.workspace.id===i.workspace.id)||(this.workspaces.push(h),this.saveSync());const u=this.getBackupPath(h.workspace.id);return o&&this.moveBackupFolderSync(u,o),u}moveBackupFolderSync(h,o){if(L.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),L.existsSync(o))try{L.renameSync(o,h)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(h){const o=h.id,u=this.workspaces.findIndex(i=>i.workspace.id===o);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(o=>this.backupUriComparer.isEqual(h,o))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const o=this.folders.findIndex(u=>this.backupUriComparer.isEqual(h,u));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(h,o){const u=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:o}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(h){const o=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,h));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(h){return(0,I.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const o=new Set,u=[];for(let i of h){const l=i.workspace;if(!(0,E.isWorkspaceIdentifier)(l))return[];if(!o.has(l.id)){o.add(l.id);const s=this.getBackupPath(l.id);await this.doHasBackups(s)?l.configPath.scheme!==D.Schemas.file||await t.Promises.exists(l.configPath.fsPath)?u.push(i):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return u}async validateFolders(h){if(!Array.isArray(h))return[];const o=[],u=new Set;for(let i of h){const l=this.backupUriComparer.getComparisonKey(i);if(!u.has(l)){u.add(l);const s=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(s)?i.scheme!==D.Schemas.file||await t.Promises.exists(i.fsPath)?o.push(i):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const o=[],u=new Set;for(let i of h){const l=i.backupFolder;if(typeof l!="string")return[];if(!u.has(l)){u.add(l);const s=this.getBackupPath(l);await this.doHasBackups(s)?o.push(i):await this.deleteStaleBackup(s)}}return o}async deleteStaleBackup(h){try{await t.Promises.exists(h)&&await t.Promises.rm(h,t.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{await t.Promises.rename(h,u)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{L.renameSync(h,u)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const h=[];for(const o of this.workspaces)await this.hasBackups(o)&&h.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&h.push(o);return h}hasBackups(h){let o;return w.URI.isUri(h)?o=this.getBackupPath(this.getFolderHash(h)):(0,k.isWorkspaceBackupInfo)(h)?o=this.getBackupPath(h.workspace.id):o=h.backupFolder,this.doHasBackups(o)}async doHasBackups(h){try{const o=await t.Promises.readdir(h);for(const u of o)try{if((await t.Promises.readdir((0,I.join)(h,u))).length>0)return!0}catch(i){}}catch(o){}return!1}saveSync(){try{(0,t.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await t.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let o;return h.scheme===D.Schemas.file?o=n.isLinux?h.fsPath:h.fsPath.toLowerCase():o=h.toString().toLowerCase(),(0,v.createHash)("md5").update(o).digest("hex")}};y=he([te(0,S.IEnvironmentMainService),te(1,b.IConfigurationService),te(2,m.ILogService)],y),e.BackupMainService=y}),define(Q[219],J([0,1,59,56]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(M,D,I,n){const f=t=>n(t,void 0),w=v.createConnection({host:M,port:D},()=>{w.removeListener("error",f);const t=Buffer.alloc(16);for(let d=0;d<16;d++)t[d]=Math.round(Math.random()*256);const k=t.toString("base64");let b=[`GET ws://${/:/.test(M)?`[${M}]`:M}:${D}/?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`];w.write(b.join(`\r
`)+`\r
\r
`);const S=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",S),n(void 0,new L.NodeSocket(w)))};w.on("data",S)});w.once("error",f)}}}),define(Q[220],J([0,1,59,114,219,9,2,16,6,21,187,95,76]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function S(y,c,h,o,u){return new d(y,c,h,o,u).waitForReady()}class d extends I.Disposable{constructor(c,h,o,u,i){super();this.defaultTunnelHost=h,this.suggestedLocalPort=i,this.privacy=k.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=v.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=l=>this._onConnection(l),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let c=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(c){c.pause();const h=(0,k.isLocalhost)(this.tunnelRemoteHost)||(0,k.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,t.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),u=o.getSocket().socket,i=o.readEntireBuffer();o.dispose(),i.byteLength>0&&c.write(i.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),u.end()}),c.on("close",()=>u.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),u.destroy()}),u.on("end",()=>c.end()),u.on("close",()=>c.end()),u.on("error",()=>{c.destroy()}),c.pipe(u),u.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),u.end()})}}let m=class extends k.AbstractTunnelService{constructor(c,h,o,u,i){super(h);this.socketFactory=c,this.signService=o,this.productService=u,this.configurationService=i}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,h,o,u,i,l,s){const r=this.getTunnelFromMap(h,o);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,o,u,i,l,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${u}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},g=S(a,this.defaultTunnelHost,h,o,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,o,g),g}}};m=he([te(1,f.ILogService),te(2,b.ISignService),te(3,w.IProductService),te(4,n.IConfigurationService)],m),e.BaseTunnelService=m;let E=class extends m{constructor(c,h,o,u){super(M.nodeSocketFactory,c,h,o,u)}};E=he([te(0,f.ILogService),te(1,b.ISignService),te(2,w.IProductService),te(3,n.IConfigurationService)],E),e.TunnelService=E}),define(Q[221],J([0,1,191,18,17,2,13,16,48,90,6,190,215]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let S=class extends D.Disposable{constructor(m,E,y){super();this.environmentService=E,this.logService=y,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,E){this.logService.trace("RequestService#request",m.url);const{proxyUrl:y,strictSSL:c}=this;let h;try{h=await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(i){this.logService.error("RequestService#request resolving shell environment failed",i)}const o={...process.env,...h},u=m.agent?m.agent:await(0,k.getProxyAgent)(m.url||"",o,{proxyUrl:y,strictSSL:c});return m.agent=u,m.strictSSL=c,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,E)}async getNodeRequest(m){return((0,v.parse)(m.url).protocol==="https:"?await new Promise((c,h)=>{V(["https"],c,h)}):await new Promise((c,h)=>{V(["http"],c,h)})).request}_request(m,E){return new Promise(async(y,c)=>{let h;const o=(0,v.parse)(m.url),u=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),i={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,I.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(i.auth=m.user+":"+m.password),h=u(i,l=>{const s=(0,I.isNumber)(m.followRedirects)?m.followRedirects:3;if(l.statusCode&&l.statusCode>=300&&l.statusCode<400&&s>0&&l.headers.location)this._request({...m,url:l.headers.location,followRedirects:s-1},E).then(y,c);else{let r=l;l.headers["content-encoding"]==="gzip"&&(r=l.pipe((0,b.createGunzip)())),y({res:l,stream:(0,L.streamToBufferReadableStream)(r)})}}),h.on("error",c),m.timeout&&h.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&h.write(m.data),h.end(),E.onCancellationRequested(()=>{h.abort(),c((0,M.canceled)())})})}async resolveProxy(m){}};S=he([te(0,n.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,t.ILogService)],S),e.RequestService=S}),define(Q[222],J([0,1,14,221]),function(V,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function M(I){return v.net.request}class D extends L.RequestService{request(n,f){return super.request({...n||{},getRawRequest:M},f)}}e.RequestMainService=D}),define(Q[223],J([0,1,14,9,4,2,10,13,85,24,22,6,45,55,63]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends D.Disposable{constructor(y,c,h,o,u,i,l){super();this.machineId=y,this.userEnv=c,this.environmentMainService=h,this.lifecycleMainService=o,this.logService=u,this.themeMainService=i,this.protocolMainService=l,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new M.Emitter),this.onDidError=M.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),v.ipcMain.on("vscode:createSharedProcessMessageChannel",async(y,c)=>this.onWindowConnection(y,c))}async onWindowConnection(y,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect();if(y.sender.isDestroyed())return h.close();y.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[h])}onWillShutdown(){const y=this.window;!y||(!y.isDestroyed()&&!y.webContents.isDestroyed()&&y.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(y.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{y.close()}catch(c){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(y=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),y()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(y=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),y()}))})()),this._whenIpcReady}createWindow(){const y=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${y.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),y.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:b.default}),this.window.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=y=>{this.logService.trace("SharedProcess#close prevented"),y.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(y,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(y,c,h)=>this._onDidError.fire({type:3,details:{reason:h,exitCode:c}})))}async connect(){await this.whenIpcReady;const y=(0,n.assertIsDefined)(this.window);return(0,f.connect)(y)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};m=he([te(2,w.IEnvironmentMainService),te(3,t.ILifecycleMainService),te(4,k.ILogService),te(5,d.IThemeMainService),te(6,S.IProtocolMainService)],m),e.SharedProcess=m}),define(Q[224],J([0,1,9,18,8,13,7,24,20,6]),function(V,e,v,L,M,D,I,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class t{constructor(S,d,m){this.storagePath=S,this.logService=d,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}}getItem(S,d){const m=this.storage[S];return(0,D.isUndefinedOrNull)(m)?d:m}setItem(S,d){this.setItems([{key:S,data:d}])}setItems(S){let d=!1;for(const{key:m,data:E}of S)this.storage[m]!==E&&((0,D.isUndefinedOrNull)(E)?(0,D.isUndefined)(this.storage[m])||(this.storage[m]=void 0,d=!0):(this.storage[m]=E,d=!0));d&&this.save()}removeItem(S){(0,D.isUndefined)(this.storage[S])||(this.storage[S]=void 0,this.save())}async save(S){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),S)}async doSave(){if(!this.initializing)return;await this.initializing;const S=JSON.stringify(this.storage,null,4);if(S!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(S)),this.lastSavedStorageContents=S}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=t;let k=class yt{constructor(S,d,m){this.fileStorage=new t(I.URI.file((0,M.join)(S.userDataPath,yt.STATE_FILE)),d,m)}async init(){return this.fileStorage.init()}getItem(S,d){return this.fileStorage.getItem(S,d)}setItem(S,d){this.fileStorage.setItem(S,d)}setItems(S){this.fileStorage.setItems(S)}removeItem(S){this.fileStorage.removeItem(S)}close(){return this.fileStorage.close()}};k.STATE_FILE="storage.json",k=he([te(0,n.IEnvironmentMainService),te(1,w.ILogService),te(2,f.IFileService)],k),e.StateMainService=k}),define(Q[77],J([0,1,9,23,4,16,24,22,6,21,50,41]),function(V,e,v,L,M,D,I,n,f,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(d,m,E){return`${E.updateUrl}/api/update/${d}/${m}/${E.commit}`}e.createUpdateURL=b;let S=class{constructor(m,E,y,c,h,o){this.lifecycleMainService=m,this.configurationService=E,this.environmentMainService=y,this.requestService=c,this.logService=h,this.productService=o,this._state=k.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.getUpdateMode(),E=this.getProductQuality(m);if(!E){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(k.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,y=>this.logService.error(y))}getUpdateMode(){return(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,v.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};S=he([te(0,n.ILifecycleMainService),te(1,D.IConfigurationService),te(2,I.IEnvironmentMainService),te(3,t.IRequestService),te(4,f.ILogService),te(5,w.IProductService)],S),e.AbstractUpdateService=S}),define(Q[225],J([0,1,14,47,4,2,16,24,22,6,21,50,29,41,77]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends d.AbstractUpdateService{constructor(y,c,h,o,u,i,l){super(y,c,o,u,i,l);this.telemetryService=h,this.disposables=new D.DisposableStore}get onRawError(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"error",(y,c)=>c)}get onRawUpdateNotAvailable(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(y,c,h)=>({url:c,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(y,c,h,o)=>({releaseNotes:c,version:h,productVersion:h,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(y){this.logService.error("UpdateService error:",y);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?y:void 0;this.setState(S.State.Idle(1,h))}buildUpdateFeedUrl(y){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,d.createUpdateURL)(c,y,this.productService);try{v.autoUpdater.setFeedURL({url:h})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return h}doCheckForUpdates(y){this.setState(S.State.CheckingForUpdates(y)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(y){this.state.type==="checking for updates"&&this.setState(S.State.Downloading(y))}onUpdateDownloaded(y){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:y.version}),this.setState(S.State.Ready(y)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(S.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([L.memoize],m.prototype,"onRawError",null),he([L.memoize],m.prototype,"onRawUpdateNotAvailable",null),he([L.memoize],m.prototype,"onRawUpdateAvailable",null),he([L.memoize],m.prototype,"onRawUpdateDownloaded",null),m=he([te(0,f.ILifecycleMainService),te(1,I.IConfigurationService),te(2,b.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,k.IRequestService),te(5,w.ILogService),te(6,t.IProductService)],m),e.DarwinUpdateService=m}),define(Q[226],J([0,1,44,31,9,4,8,24,22,6,29,41]),function(V,e,v,L,M,D,I,n,f,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{constructor(m,E,y){if(this.lifecycleMainService=m,this.logService=y,this._state=k.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(k.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return(0,M.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};b=he([te(0,f.ILifecycleMainService),te(1,n.IEnvironmentMainService),te(2,w.ILogService)],b);let S=class extends b{constructor(m,E,y,c,h,o){super(y,c,h);this.snap=m,this.snapRevision=E,this.telemetryService=o;const u=(0,L.watch)(I.dirname(this.snap)),i=D.Event.fromNodeEventEmitter(u,"change",(a,g)=>g),l=D.Event.filter(i,a=>a==="current"),r=D.Event.debounce(l,(a,g)=>g,2e3)(()=>this.checkForUpdates(!1));y.onWillShutdown(()=>{r.dispose(),u.close()})}doCheckForUpdates(){this.setState(k.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(k.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+I.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((y,c)=>(0,L.realpath)(`${I.dirname(this.snap)}/current`,(h,o)=>h?c(h):y(o))),E=I.basename(m);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};S=he([te(2,f.ILifecycleMainService),te(3,n.IEnvironmentMainService),te(4,w.ILogService),te(5,t.ITelemetryService)],S),e.SnapUpdateService=S}),define(Q[46],J([0,1,14,31,4,39,34,2,10,8,3,15,13,19,153,51,52,24,5,6,21,99,26,100]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h,o,u,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,c.createDecorator)("workspacesManagementMainService");let s=class extends n.Disposable{constructor(a,g,p,P,R){super();this.environmentMainService=a,this.logService=g,this.backupMainService=p,this.dialogMainService=P,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new M.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new M.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,g=>(0,L.readFileSync)(g,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,g=>S.Promises.readFile(g,"utf8"))}doResolveLocalWorkspace(a,g){if(!!this.isWorkspacePath(a)&&a.scheme===f.Schemas.file)try{const p=g(a.fsPath);return p instanceof Promise?p.then(P=>this.doResolveWorkspace(a,P),P=>{}):this.doResolveWorkspace(a,p)}catch{return}}isWorkspacePath(a){return(0,i.isUntitledWorkspace)(a,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,g){try{const p=this.doParseStoredWorkspace(a,g),P=(0,l.getWorkspaceIdentifier)(a);return{id:P.id,configPath:P.configPath,folders:(0,i.toWorkspaceFolders)(p.folders,P.configPath,k.extUriBiasedIgnorePathCase),remoteAuthority:p.remoteAuthority,transient:p.transient}}catch(p){this.logService.warn(p.toString())}}doParseStoredWorkspace(a,g){const p=(0,D.parse)(g);if(p&&Array.isArray(p.folders))p.folders=p.folders.filter(P=>(0,i.isStoredWorkspaceFolder)(P));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return p}async createUntitledWorkspace(a,g){const{workspace:p,storedWorkspace:P}=this.newUntitledWorkspace(a,g),R=p.configPath.fsPath;return await S.Promises.mkdir((0,w.dirname)(R),{recursive:!0}),await S.Promises.writeFile(R,JSON.stringify(P,null,"	")),p}createUntitledWorkspaceSync(a,g){const{workspace:p,storedWorkspace:P}=this.newUntitledWorkspace(a,g),R=p.configPath.fsPath;return(0,L.mkdirSync)((0,w.dirname)(R),{recursive:!0}),(0,S.writeFileSync)(R,JSON.stringify(P,null,"	")),p}newUntitledWorkspace(a=[],g){const p=(Date.now()+Math.round(Math.random()*1e3)).toString(),P=(0,k.joinPath)(this.untitledWorkspacesHome,p),R=(0,k.joinPath)(P,i.UNTITLED_WORKSPACE_NAME),A=[];for(const W of a)A.push((0,i.getStoredWorkspaceFolder)(W.uri,!0,W.name,P,!t.isWindows,k.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(R),storedWorkspace:{folders:A,remoteAuthority:g}}}async getWorkspaceIdentifier(a){return(0,l.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,i.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const g=(0,k.originalFSPath)(a.configPath);try{(0,S.rimrafSync)((0,w.dirname)(g));const p=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,L.existsSync)(p)&&(0,S.writeFileSync)((0,w.join)(p,"obsolete"),"")}catch(p){this.logService.warn(`Unable to delete untitled workspace ${g} (${p}).`)}}getUntitledWorkspacesSync(){const a=[];try{const g=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(p=>(0,k.joinPath)(this.untitledWorkspacesHome,p,i.UNTITLED_WORKSPACE_NAME));for(const p of g){const P=(0,l.getWorkspaceIdentifier)(p),R=this.resolveLocalWorkspaceSync(p);R?a.push({workspace:P,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(P)}}catch(g){g.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${g}).`)}return a}async enterWorkspace(a,g,p){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,g,p))return;const R=this.doEnterWorkspace(a,(0,l.getWorkspaceIdentifier)(p));if(!!R)return this._onDidEnterWorkspace.fire({window:a,workspace:R.workspace}),R}async isValidTargetWorkspacePath(a,g,p){if(!p)return!0;if((0,i.isWorkspaceIdentifier)(a.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,p))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(g,p)){const P={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,k.basename)(p)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(P,(0,b.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,g){if(!a.config)return;a.focus();let p;return a.config.extensionDevelopmentPath||(p=this.backupMainService.registerWorkspaceBackupSync({workspace:g,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,i.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=g,a.config.backupPath=p,{workspace:g,backupPath:p}}};s=he([te(0,y.IEnvironmentMainService),te(1,h.ILogService),te(2,m.IBackupMainService),te(3,E.IDialogMainService),te(4,o.IProductService)],s),e.WorkspacesManagementMainService=s}),define(Q[101],J([0,1,14,30,23,3,13,7,19,16,54,5,6,97,36,26,46]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,k.createDecorator)(e.ID);let y=class{constructor(h,o,u,i,l){this.logService=h,this.windowsMainService=o,this.urlService=u,this.workspacesManagementMainService=i,this.configurationService=l}async start(h,o){this.logService.trace("Received data from other instance: ",h,o),D.isMacintosh&&v.app.focus({steal:!0});const u=this.parseOpenUrl(h);if(u.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:l,url:s}of u)this.urlService.open(l,{originalUrl:s})})}else return this.startOpenWindow(h,o)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,L.coalesce)(h._urls.map(o=>{try{return{uri:n.URI.parse(o),url:o}}catch(u){return null}})):[]}async startOpenWindow(h,o){const u=(0,t.isLaunchedFromCli)(o)?0:4;let i=[];const l=h.wait&&h.waitMarkerFilePath?n.URI.file(h.waitMarkerFilePath):void 0,s=h.remote||void 0,r={context:u,cli:h,userEnv:o,waitMarkerFileURI:l,remoteAuthority:s};if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,r);else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let a=!1;if(h["new-window"]||h["unity-launch"])a=!0;else if(h["reuse-window"])a=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!D.isMacintosh}if(a)i=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const g=this.windowsMainService.getLastActiveWindow();g?(this.windowsMainService.openExistingWindow(g,r),i=[g]):i=this.windowsMainService.open({...r,forceEmpty:!0})}}else i=this.windowsMainService.open({...r,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],gotoLineMode:h.goto});if(l&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,f.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return v.BrowserWindow.getAllWindows().forEach(o=>{const u=this.windowsMainService.getWindowById(o.id);u?h.push(this.codeWindowToInfo(u)):h.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(i=>new Promise(l=>{const s=i.remoteAuthority;if(s){const r=`vscode:getDiagnosticInfoResponse${i.id}`,a={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(i):void 0};i.sendWhenReady("vscode:getDiagnosticInfo",M.CancellationToken.None,{replyChannel:r,args:a}),v.ipcMain.once(r,(g,p)=>{p||l({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),l(p)}),setTimeout(()=>{l({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else l(void 0)})))).filter(i=>!!i)}getFolderURIs(h){const o=[],u=h.openedWorkspace;if((0,m.isSingleFolderWorkspaceIdentifier)(u))o.push(u.uri);else if((0,m.isWorkspaceIdentifier)(u)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);i&&i.folders.forEach(s=>{o.push(s.uri)})}return o}codeWindowToInfo(h){const o=this.getFolderURIs(h),u=(0,I.assertIsDefined)(h.win);return this.browserWindowToInfo(u,o,h.remoteAuthority)}browserWindowToInfo(h,o=[],u){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:o,remoteAuthority:u}}};y=he([te(0,b.ILogService),te(1,d.IWindowsMainService),te(2,S.IURLService),te(3,E.IWorkspacesManagementMainService),te(4,w.IConfigurationService)],y),e.LaunchMainService=y}),define(Q[53],J([0,1,44,14,25,113,47,4,34,2,10,8,3,7,82,69,19,145,52,24,5,22,6,21,29,63,36,26,46]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h,o,u,i,l,s,r,a,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let P=class lt extends w.Disposable{constructor(A,W,j,x,re,K,ee,F,H,z){super();this.sharedProcess=A,this.windowsMainService=W,this.dialogMainService=j,this.lifecycleMainService=x,this.environmentMainService=re,this.telemetryService=K,this.logService=ee,this.productService=F,this.themeMainService=H,this.workspacesManagementMainService=z,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,B=>B.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(B,C)=>C.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(B,C)=>C.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(B,C)=>C.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),B=>!!B),B=>B.id),n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(B,C)=>C.id),B=>!!this.windowsMainService.getWindowById(B))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(B,C,U)=>U),B=>!(Array.isArray(B)&&B.length===1&&B[0]==="workArea")),n.Event.fromNodeEventEmitter(L.screen,"display-added"),n.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(A){return this.windowsMainService.getWindowCount()}async getActiveWindowId(A){const W=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(A,W,j){return Array.isArray(W)?this.doOpenWindow(A,W,j):this.doOpenEmptyWindow(A,W)}async doOpenWindow(A,W,j=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:A,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:j.forceNewWindow,forceReuseWindow:j.forceReuseWindow,preferNewWindow:j.preferNewWindow,diffMode:j.diffMode,addMode:j.addMode,gotoLineMode:j.gotoLineMode,noRecentEntry:j.noRecentEntry,waitMarkerFileURI:j.waitMarkerFileURI,remoteAuthority:j.remoteAuthority||void 0})}async doOpenEmptyWindow(A,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:A},W)}async toggleFullScreen(A){const W=this.windowById(A);W&&W.toggleFullScreen()}async handleTitleDoubleClick(A){const W=this.windowById(A);W&&W.handleTitleDoubleClick()}async isMaximized(A){const W=this.windowById(A);return W?.win?W.win.isMaximized():!1}async maximizeWindow(A){const W=this.windowById(A);W?.win&&W.win.maximize()}async unmaximizeWindow(A){const W=this.windowById(A);W?.win&&W.win.unmaximize()}async minimizeWindow(A){const W=this.windowById(A);W?.win&&W.win.minimize()}async focusWindow(A,W){W&&typeof W.windowId=="number"&&(A=W.windowId);const j=this.windowById(A);j&&j.focus({force:W?.force??!1})}async setMinimumSize(A,W,j){const x=this.windowById(A);if(x?.win){const[re,K]=x.win.getSize(),[ee,F]=x.win.getMinimumSize(),[H,z]=[W??ee,j??F],[B,C]=[Math.max(re,H),Math.max(K,z)];(ee!==H||F!==z)&&x.win.setMinimumSize(H,z),(re!==B||K!==C)&&x.win.setSize(B,C)}}async saveWindowSplash(A,W){this.themeMainService.saveWindowSplash(A,W)}async installShellCommand(A){const{source:W,target:j}=await this.getShellCommandLink();try{const{symbolicLink:x}=await E.SymlinkSupport.stat(W);if(x&&!x.dangling){const re=await(0,d.realpath)(W);if(j===re)return}await E.Promises.unlink(W)}catch(x){if(x.code!=="ENOENT")throw x}try{await E.Promises.symlink(j,W)}catch(x){if(x.code!=="EACCES"&&x.code!=="ENOENT")throw x;const{response:re}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,y.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${j}' '${W}'\\" with administrator privileges"`;await(0,D.promisify)(v.exec)(K)}catch(K){throw new Error((0,y.localize)(3,null,W))}}}async uninstallShellCommand(A){const{source:W}=await this.getShellCommandLink();try{await E.Promises.unlink(W)}catch(j){switch(j.code){case"EACCES":const{response:x}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,y.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(x===0)try{const re=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,D.promisify)(v.exec)(re)}catch(re){throw new Error((0,y.localize)(7,null,W))}break;case"ENOENT":break;default:throw j}}}async getShellCommandLink(){const A=(0,k.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await E.Promises.exists(A))throw new Error((0,y.localize)(8,null,A));return{source:W,target:A}}async showMessageBox(A,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(A))}async showSaveDialog(A,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(A))}async showOpenDialog(A,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(A))}toBrowserWindow(A){const W=this.windowById(A);if(W?.win)return W.win}async pickFileFolderAndOpen(A,W){const j=await this.dialogMainService.pickFileFolder(W);j&&(this.sendPickerTelemetry(j,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all(j.map(async x=>await E.SymlinkSupport.existsDirectory(x)?{folderUri:S.URI.file(x)}:{fileUri:S.URI.file(x)})),W,A))}async pickFolderAndOpen(A,W){const j=await this.dialogMainService.pickFolder(W);j&&(this.sendPickerTelemetry(j,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked(j.map(x=>({folderUri:S.URI.file(x)})),W,A))}async pickFileAndOpen(A,W){const j=await this.dialogMainService.pickFile(W);j&&(this.sendPickerTelemetry(j,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked(j.map(x=>({fileUri:S.URI.file(x)})),W,A))}async pickWorkspaceAndOpen(A,W){const j=await this.dialogMainService.pickWorkspace(W);j&&(this.sendPickerTelemetry(j,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked(j.map(x=>({workspaceUri:S.URI.file(x)})),W,A))}doOpenPicked(A,W,j){this.windowsMainService.open({context:3,contextWindowId:j,cli:this.environmentMainService.args,urisToOpen:A,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(A,W,j){const x=A?A.length:0;this.telemetryService.publicLog(W,{...j,outcome:x?"success":"canceled",numberOfPaths:x})}async showItemInFolder(A,W){L.shell.showItemInFolder(W)}async setRepresentedFilename(A,W){const j=this.windowById(A);j&&j.setRepresentedFilename(W)}async setDocumentEdited(A,W){const j=this.windowById(A);j&&j.setDocumentEdited(W)}async openExternal(A,W){return b.isLinuxSnap?this.safeSnapOpenExternal(W):L.shell.openExternal(W),!0}safeSnapOpenExternal(A){const W=process.env.GDK_PIXBUF_MODULE_FILE,j=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(A),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=j}moveItemToTrash(A,W){return L.shell.trashItem(W)}async isAdmin(){let A;return b.isWindows?A=(await new Promise((W,j)=>{V(["native-is-elevated"],W,j)}))():A=process.getuid()===0,A}async writeElevated(A,W,j,x){const re=await new Promise((K,ee)=>{V(["sudo-prompt"],K,ee)});return new Promise((K,ee)=>{const F=[`"${this.cliPath}"`];x?.unlock&&F.push("--file-chmod"),F.push("--file-write",`"${W.fsPath}"`,`"${j.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};re.exec(F.join(" "),H,(z,B,C)=>{B&&this.logService.trace(`[sudo-prompt] received stdout: ${B}`),C&&this.logService.trace(`[sudo-prompt] received stderr: ${C}`),z?ee(z):K(void 0)})})}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,k.join)(this.environmentMainService.appRoot,"bin","code"):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,M.totalmem)(),freemem:(0,M.freemem)(),loadavg:(0,M.loadavg)()}}async getOSProperties(){return{arch:(0,M.arch)(),platform:(0,M.platform)(),release:(0,M.release)(),type:(0,M.type)(),cpus:(0,M.cpus)()}}async getOSVirtualMachineHint(){return m.virtualMachineHint.value()}get osColorScheme(){return{highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(A,W,j){process.kill(W,j)}async readClipboardText(A,W){return L.clipboard.readText(W)}async writeClipboardText(A,W,j){return L.clipboard.writeText(W,j)}async readClipboardFindText(A){return L.clipboard.readFindText()}async writeClipboardFindText(A,W){return L.clipboard.writeFindText(W)}async writeClipboardBuffer(A,W,j,x){return L.clipboard.writeBuffer(W,Buffer.from(j),x)}async readClipboardBuffer(A,W){return L.clipboard.readBuffer(W)}async hasClipboard(A,W,j){return L.clipboard.has(W,j)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(A,W){const j=this.windowById(A);j&&j.updateTouchBar(W)}async notifyReady(A){const W=this.windowById(A);W&&W.setReady()}async relaunch(A,W){return this.lifecycleMainService.relaunch(W)}async reload(A,W){const j=this.windowById(A);if(j){if((0,g.isWorkspaceIdentifier)(j.openedWorkspace)){const x=j.openedWorkspace.configPath;if(x.scheme===t.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(x))?.transient)return this.openWindow(j.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(j,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(A){this.closeWindowById(A,A)}async closeWindowById(A,W){const j=this.windowById(W);if(j?.win)return j.win.close()}async quit(A){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(A,W){await this.lifecycleMainService.kill(W)}async resolveProxy(A,W){const x=this.windowById(A)?.win?.webContents?.session;if(x)return x.resolveProxy(W)}async openDevTools(A,W){const j=this.windowById(A);j?.win&&j.win.webContents.openDevTools(W)}async toggleDevTools(A){const W=this.windowById(A);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(A,W){const j=this.windowById(A);j?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&j.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(A,W,j,x){if(!b.isWindows)return;const re=await new Promise((K,ee)=>{V(["vscode-windows-registry"],K,ee)});try{return re.GetStringRegKey(W,j,x)}catch{return}}async getPassword(A,W,j){const x=await this.withKeytar(),re=await x.getPassword(W,j);if(re)try{let{content:K,hasNextChunk:ee}=JSON.parse(re);if(!K||!ee)return re;let F=1;for(;ee;){const H=await x.getPassword(W,`${j}-${F}`),z=JSON.parse(H);K+=z.content,ee=z.hasNextChunk,F++}return K}catch{return re}return re}async setPassword(A,W,j,x){const re=await this.withKeytar(),K=3,ee=async(F,H,z)=>{let B=0,C;for(;B<K;)try{await re.setPassword(F,H,z);return}catch(U){C=U,this.logService.warn("Error attempting to set a password: ",U),B++,await new Promise(Y=>setTimeout(Y,200))}throw C};if(b.isWindows&&x.length>lt.MAX_PASSWORD_LENGTH){let F=0,H=0,z=!0;for(;z;){const B=x.substring(F,F+lt.PASSWORD_CHUNK_SIZE);F+=lt.PASSWORD_CHUNK_SIZE,z=x.length-F>0;const C={content:B,hasNextChunk:z};await ee(W,H?`${j}-${H}`:j,JSON.stringify(C)),H++}}else await ee(W,j,x);this._onDidChangePassword.fire({service:W,account:j})}async deletePassword(A,W,j){const re=await(await this.withKeytar()).deletePassword(W,j);return re&&this._onDidChangePassword.fire({service:W,account:j}),re}async findPassword(A,W){return(await this.withKeytar()).findPassword(W)}async findCredentials(A,W){return(await this.withKeytar()).findCredentials(W)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((A,W)=>{V(["keytar"],A,W)})}windowById(A){if(typeof A=="number")return this.windowsMainService.getWindowById(A)}};P.MAX_PASSWORD_LENGTH=2500,P.PASSWORD_CHUNK_SIZE=P.MAX_PASSWORD_LENGTH-100,he([I.memoize],P.prototype,"cliPath",null),P=he([te(1,a.IWindowsMainService),te(2,c.IDialogMainService),te(3,u.ILifecycleMainService),te(4,h.IEnvironmentMainService),te(5,s.ITelemetryService),te(6,i.ILogService),te(7,l.IProductService),te(8,r.IThemeMainService),te(9,p.IWorkspacesManagementMainService)],P),e.NativeHostMainService=P}),define(Q[227],J([0,1,14,23,4,81,2,28,88,6,53,21,36]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var S;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(S||(S={}));let d=class extends I.Disposable{constructor(E,y,c,h,o){super();this.logService=E,this.windowsMainService=y,this.nativeHostMainService=c,this.encryptionMainService=h,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=S.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const E=M.Event.fromNodeEventEmitter(v.app,"login",(y,c,h,o,u)=>({event:y,webContents:c,req:h,authInfo:o,callback:u}));this._register(E(this.onLogin,this))}async onLogin({event:E,authInfo:y,req:c,callback:h}){if(!y.isProxy)return;if(!this.pendingProxyResolve&&this.state===S.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}E.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(y);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(o?.username,o?.password)}async resolveProxyCredentials(E){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const y=await this.doResolveProxyCredentials(E);if(y)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),y;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(E){this.logService.trace("auth#doResolveProxyCredentials - enter",E);const y=String((0,D.hash)({scheme:E.scheme,host:E.host,port:E.port}));let c,h;try{const l=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y);if(l){const s=JSON.parse(await this.encryptionMainService.decrypt(l));c=s.username,h=s.password}}catch(l){this.logService.error(l)}if(this.state!==S.StoredCredentialsUsed&&typeof c=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=S.StoredCredentialsUsed,{username:c,password:h};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const u={authInfo:E,username:this.sessionCredentials?.username??c,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,u),this.state=S.LoginDialogShown;const i=await new Promise(l=>{const s=async(r,a,g)=>{if(a===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",s),g){const p={username:g.username,password:g.password};try{if(g.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(p));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y,P)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y)}catch(P){this.logService.error(P)}l({username:p.username,password:p.password})}else l(void 0)};o.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=i,i}};d=he([te(0,w.ILogService),te(1,b.IWindowsMainService),te(2,t.INativeHostMainService),te(3,f.IEncryptionMainService),te(4,k.IProductService)],d),e.ProxyAuthHandler=d}),define(Q[228],J([0,1,14,25,34,2,10,3,83,143,73,52,24,5,101,6,53,45,21,55,64]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,S.createDecorator)("issueMainService");let u=class St{constructor(l,s,r,a,g,p,P,R,A){this.userEnv=l,this.environmentMainService=s,this.launchMainService=r,this.logService=a,this.diagnosticsService=g,this.dialogMainService=p,this.nativeHostMainService=P,this.protocolMainService=R,this.productService=A,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async l=>{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(s,r);this.safeSend(l,"vscode:issueSystemInfoResponse",a)}),v.ipcMain.on("vscode:listProcesses",async l=>{const s=[];try{const r=await this.launchMainService.getMainProcessId();s.push({name:(0,w.localize)(0,null),rootProcess:await(0,f.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(g=>{(0,t.isRemoteDiagnosticError)(g)?s.push({name:g.hostName,rootProcess:g}):g.processes&&s.push({name:g.hostName,rootProcess:g.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(l,"vscode:listProcessesResponse",s)}),v.ipcMain.on("vscode:issueReporterClipboard",async l=>{const s={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,M.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(l,"vscode:issueReporterClipboardResponse",r.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async l=>{const s=await this.getPerformanceInfo();this.safeSend(l,"vscode:issuePerformanceInfoResponse",s)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const l={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,M.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(l,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(l,s)=>{const{id:r,from:a,args:g}=s;let p;switch(a){case"issueReporter":p=this.issueReporterParentWindow;break;case"processExplorer":p=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}p&&p.webContents.send("vscode:runAction",{id:r,from:a,args:g})}),v.ipcMain.on("vscode:openExternal",(l,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),v.ipcMain.on("vscode:closeIssueReporter",l=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",l=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async l=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(l,"vscode:windowsInfoResponse",s.windows)})}safeSend(l,s,...r){l.sender.isDestroyed()||l.sender.send(s,...r)}async openReporter(l){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new D.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,r,{backgroundColor:l.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:l.zoomLevel,alwaysOnTop:!1}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:l,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:y.default}),this.issueReporterWindow.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(l){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new D.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,r,{backgroundColor:l.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:l,product:y.default}),this.processExplorerWindow.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(l,s,r){const a=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:r.title,backgroundColor:r.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return a.setMenuBarVisibility(!1),a}async getSystemStatus(){const[l,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(l,s)}getWindowPosition(l,s,r){let a;const g=v.screen.getAllDisplays();if(g.length===1)a=g[0];else{if(n.isMacintosh){const R=v.screen.getCursorScreenPoint();a=v.screen.getDisplayNearestPoint(R)}!a&&l&&(a=v.screen.getDisplayMatching(l.getBounds())),a||(a=v.screen.getPrimaryDisplay()||g[0])}const p={width:s,height:r},P=a.bounds;return p.x=P.x+P.width/2-p.width/2,p.y=P.y+P.height/2-p.height/2,P.width>0&&P.height>0&&(p.x<P.x&&(p.x=P.x),p.y<P.y&&(p.y=P.y),p.x>P.x+P.width&&(p.x=P.x),p.y>P.y+P.height&&(p.y=P.y),p.width>P.width&&(p.width=P.width),p.height>P.height&&(p.height=P.height)),p}async getPerformanceInfo(){try{const[l,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(l,s)}catch(l){throw this.logService.warn("issueService#getPerformanceInfo ",l.message),l}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([te(1,b.IEnvironmentMainService),te(2,d.ILaunchMainService),te(3,m.ILogService),te(4,t.IDiagnosticsService),te(5,k.IDialogMainService),te(6,E.INativeHostMainService),te(7,h.IProtocolMainService),te(8,c.IProductService)],u),e.IssueMainService=u}),define(Q[229],J([0,1,23,16,24,22,6,53,21,50,29,41,77]),function(V,e,v,L,M,D,I,n,f,w,t,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let S=class extends b.AbstractUpdateService{constructor(m,E,y,c,h,o,u,i){super(m,E,c,h,o,i);this.telemetryService=y,this.nativeHostMainService=u}buildUpdateFeedUrl(m){return(0,b.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(k.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},v.CancellationToken.None).then(w.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(k.State.Idle(1))):this.setState(k.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const y=m?E.message||E:void 0;this.setState(k.State.Idle(1,y))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(k.State.Idle(1))}};S=he([te(0,D.ILifecycleMainService),te(1,L.IConfigurationService),te(2,t.ITelemetryService),te(3,M.IEnvironmentMainService),te(4,w.IRequestService),te(5,I.ILogService),te(6,n.INativeHostMainService),te(7,f.IProductService)],S),e.LinuxUpdateService=S}),define(Q[230],J([0,1,44,31,25,9,23,47,8,7,110,19,16,24,20,22,6,53,21,50,29,41,77]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h,o,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(g,p=1e3){for(;!g();)await(0,D.timeout)(p)}let s;function r(){return typeof s=="undefined"&&(s=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),s}let a=class extends i.AbstractUpdateService{constructor(p,P,R,A,W,j,x,re,K){super(p,P,A,W,j,K);this.telemetryService=R,this.fileService=x,this.nativeHostMainService=re}get cachePath(){const p=f.join((0,M.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return k.Promises.mkdir(p,{recursive:!0}).then(()=>p)}initialize(){super.initialize(),r()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(p){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),r()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,i.createUpdateURL)(P,p,this.productService)}doCheckForUpdates(p){!this.url||(this.setState(u.State.CheckingForUpdates(p)),this.requestService.request({url:this.url},I.CancellationToken.None).then(h.asJson).then(P=>{const R=r();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p}),this.setState(u.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(u.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(u.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(A=>k.Promises.exists(A).then(W=>{if(W)return Promise.resolve(A);const j=P.url,x=P.hash,re=`${A}.tmp`;return this.requestService.request({url:j},I.CancellationToken.None).then(K=>this.fileService.writeFile(w.URI.file(re),K.stream)).then(x?()=>(0,t.checksum)(re,P.hash):()=>{}).then(()=>k.Promises.rename(re,A)).then(()=>A)})).then(A=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},W&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(P)):this.setState(u.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p});const R=p?P.message||P:void 0;this.setState(u.State.Idle(r(),R))}))}async doDownloadUpdate(p){p.update.url&&this.nativeHostMainService.openExternal(void 0,p.update.url),this.setState(u.State.Idle(r()))}async getUpdatePackagePath(p){const P=await this.cachePath;return f.join(P,`CodeSetup-${this.productService.quality}-${p}.exe`)}async cleanup(p=null){const P=p?j=>!new RegExp(`${this.productService.quality}-${p}\\.exe$`).test(j):()=>!0,R=await this.cachePath,W=(await k.Promises.readdir(R)).filter(P).map(async j=>{try{await k.Promises.unlink(f.join(R,j))}catch(x){}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const p=this.state.update;this.setState(u.State.Updating(p));const P=await this.cachePath;this.availableUpdate.updateFilePath=f.join(P,`CodeSetup-${this.productService.quality}-${p.version}.flag`),await k.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(r()))});const A=`${this.productService.win32MutexName}-ready`,W=await new Promise((j,x)=>{V(["windows-mutex"],j,x)});l(()=>W.isActive(A)).then(()=>this.setState(u.State.Ready(p)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}};he([n.memoize],a.prototype,"cachePath",null),a=he([te(0,m.ILifecycleMainService),te(1,b.IConfigurationService),te(2,o.ITelemetryService),te(3,S.IEnvironmentMainService),te(4,h.IRequestService),te(5,E.ILogService),te(6,d.IFileService),te(7,y.INativeHostMainService),te(8,c.IProductService)],a),e.Win32UpdateService=a}),define(Q[231],J([0,1,14,9,23,4,34,2,10,8,75,3,7,149,51,16,52,24,54,198,20,22,6,21,55,98,29,201,63,64,36,26,46]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h,o,u,i,l,s,r,a,g,p,P,R,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var j;(function(re){re[re.NONE=0]="NONE",re[re.LOADING=1]="LOADING",re[re.NAVIGATING=2]="NAVIGATING",re[re.READY=3]="READY"})(j||(j={}));let x=class extends n.Disposable{constructor(K,ee,F,H,z,B,C,U,Y,O,T,_,q,X){super();this.logService=ee,this.environmentMainService=F,this.fileService=H,this.configurationService=B,this.themeMainService=C,this.workspacesManagementMainService=U,this.backupMainService=Y,this.telemetryService=O,this.dialogMainService=T,this.lifecycleMainService=_,this.productService=q,this.protocolMainService=X,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[$,N]=this.restoreWindowState(K.state);this.windowState=$,this.logService.trace("window#ctor: using window state",$);const Z=this.windowState.mode===0||this.windowState.mode===3,ie=this.configurationService.getValue("window"),oe={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:P.WindowMinimumSize.WIDTH,minHeight:P.WindowMinimumSize.HEIGHT,show:!Z,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,P.zoomLevelToZoomFactor)(ie?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};k.isLinux?oe.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):k.isWindows&&!this.environmentMainService.isBuilt&&(oe.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),k.isMacintosh&&!this.useNativeFullScreen()&&(oe.fullscreenable=!1),k.isMacintosh&&(oe.acceptFirstMouse=!0,ie?.clickThroughInactive===!1&&(oe.acceptFirstMouse=!1));const le=k.isMacintosh&&ie?.nativeTabs===!0;le&&(oe.tabbingIdentifier=this.productService.nameShort);const ne=(0,P.getTitleBarStyle)(this.configurationService)==="custom";if(ne&&(oe.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,k.isMacintosh||(oe.frame=!1)),(0,t.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(oe),(0,t.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),k.isMacintosh&&ne&&this._win.setSheetOffset(22),k.isMacintosh&&N&&(!le||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ae=>typeof ae=="number")){const ae=this.windowState;this._win.setBounds({width:ae.width,height:ae.height,x:ae.x,y:ae.y})}Z&&((0,t.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,t.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:$=>z.globalStorage.get($),store:($,N)=>z.globalStorage.set($,N)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(K){k.isMacintosh?this._win.setRepresentedFilename(K):this.representedFilename=K}getRepresentedFilename(){return k.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(K){k.isMacintosh&&this._win.setDocumentEdited(K),this.documentEdited=K}isDocumentEdited(){return k.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(K){k.isMacintosh&&K?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(K=>{if(this.isReady)return K(this);this.whenReadyCallbacks.push(K)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(K=>{function ee(){F.dispose(),H.dispose(),K()}const F=this.onDidClose(()=>ee()),H=this.onWillLoad(()=>ee())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(z,B)=>this.onWindowError(2,B)),this._win.webContents.on("did-fail-load",(z,B,C)=>this.onWindowError(3,{reason:C,exitCode:B})),this._win.webContents.on("will-prevent-unload",z=>{z.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const K=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),ee=z=>{for(let B=z;B;B=B.parent)if(B.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},F=z=>z.resourceType==="xhr"||ee(z.frame);this._win.webContents.session.webRequest.onBeforeRequest((z,B)=>{const C=b.URI.parse(z.url);return C.path.endsWith(".svg")&&!K.has(C.scheme)?B({cancel:!F(z)}):B({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((z,B)=>{const C=z.responseHeaders,U=C["content-type"]||C["Content-Type"];if(U&&Array.isArray(U)){const Y=b.URI.parse(z.url);if(Y.path.endsWith(".svg")&&K.has(Y.scheme))return C["Content-Type"]=["image/svg+xml"],B({cancel:!1,responseHeaders:C});if(!Y.path.includes(f.Schemas.vscodeRemoteResource)&&U.some(O=>O.toLowerCase().includes("image/svg")))return B({cancel:!F(z)})}return B({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",z,this._win)}),this._win.on("unmaximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",M.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",M.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(z=>this.onDidDeleteUntitledWorkspace(z)));const H=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:H},async(z,B)=>{const C=await this.marketplaceHeadersPromise;B({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,C)})})}async onWindowError(K,ee){switch(K){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:K,reason:ee?.reason,code:ee?.exitCode}),K){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(K===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const F=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,S.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,S.localize)(2,null))],message:(0,S.localize)(3,null),detail:(0,S.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;F.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):F.response===2&&this.destroyWindow()}else if(K===2){let F;ee?F=(0,S.localize)(6,null,ee.reason,ee.exitCode??"<unknown>"):F=(0,S.localize)(5,null);const H=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,S.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,S.localize)(8,null))],message:F,detail:(0,S.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;H.response===0?this.reload():H.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(K){this.openedWorkspace?.id===K.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const K=this.getMenuBarVisibility();K!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=K,this.setMenuBarVisibility(K));let ee=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;ee?.endsWith("/")&&(ee=ee.substr(0,ee.length-1));const F=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((ee||"").indexOf("@")===-1&&(ee!==this.currentHttpProxy||F!==this.currentNoProxy)){this.currentHttpProxy=ee,this.currentNoProxy=F;const H=ee||"",z=F?`${F},<local>`:"<local>";this.logService.trace(`Setting proxy to '${H}', bypassing '${z}'`),this._win.webContents.session.setProxy({proxyRules:H,proxyBypassRules:z,pacScript:""})}}addTabbedWindow(K){k.isMacintosh&&K.win&&this._win.addTabbedWindow(K.win)}load(K,ee=Object.create(null)){this.isDocumentEdited()&&(!ee.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),ee.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(K,ee),this.readyState===0?this.currentConfig=K:(this.pendingLoadConfig=K,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const F=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:K.workspace,reason:ee.isReload?3:F?2:1})}updateConfiguration(K,ee){const F=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(F){const H=(0,c.isLaunchedFromCli)(F)&&!(0,c.isLaunchedFromCli)(K.userEnv),z=this.isExtensionDevelopmentHost;(H||z)&&(K.userEnv={...F,...K.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(K.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),ee.disableExtensions!==void 0&&(K["disable-extensions"]=ee.disableExtensions),K.fullscreen=this.isFullScreen,K.maximized=this._win.isMaximized(),K.partsSplash=this.themeMainService.getWindowSplash(),(0,t.mark)("code/willOpenNewWindow"),K.perfMarks=(0,t.getMarks)(),this.configObjectUrl.update(K)}async reload(K){const ee=Object.assign({},this.currentConfig);ee.workspace=await this.validateWorkspaceBeforeReload(ee),delete ee.filesToOpenOrCreate,delete ee.filesToDiff,delete ee.filesToWait,this.isExtensionDevelopmentHost&&K&&(ee.verbose=K.verbose,ee.debugId=K.debugId,ee.extensionEnvironment=K.extensionEnvironment,ee["inspect-extensions"]=K["inspect-extensions"],ee["inspect-brk-extensions"]=K["inspect-brk-extensions"],ee["extensions-dir"]=K["extensions-dir"]),ee.isInitialStartup=!1,this.load(ee,{isReload:!0,disableExtensions:K?.["disable-extensions"]})}async validateWorkspaceBeforeReload(K){if((0,A.isWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.configPath;if(ee.scheme===f.Schemas.file&&!await this.fileService.exists(ee))return}else if((0,A.isSingleFolderWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.uri;if(ee.scheme===f.Schemas.file&&!await this.fileService.exists(ee))return}return K.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let F;try{F=v.screen.getDisplayMatching(this.getBounds())}catch(B){}const H=(0,R.defaultWindowState)();return{mode:3,display:F?F.id:void 0,width:this.windowState.width||H.width,height:this.windowState.height||H.height,x:this.windowState.x||0,y:this.windowState.y||0}}const K=Object.create(null);let ee;if(!k.isMacintosh&&this._win.isMaximized()?ee=0:ee=1,ee===0?K.mode=0:K.mode=1,ee===1||ee===0){let F;ee===1?F=this.getBounds():F=this._win.getNormalBounds(),K.x=F.x,K.y=F.y,K.width=F.width,K.height=F.height}return K}restoreWindowState(K){(0,t.mark)("code/willRestoreCodeWindowState");let ee=!1;if(K)try{const F=v.screen.getAllDisplays();ee=F.length>1,K=this.validateWindowState(K,F)}catch(F){this.logService.warn(`Unexpected error validating window state: ${F}
${F.stack}`)}return(0,t.mark)("code/didRestoreCodeWindowState"),[K||(0,R.defaultWindowState)(),ee]}validateWindowState(K,ee){if(this.logService.trace(`window#validateWindowState: validating window state on ${ee.length} display(s)`,K),typeof K.x!="number"||typeof K.y!="number"||typeof K.width!="number"||typeof K.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(K.width<=0||K.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(ee.length===1){const z=this.getWorkingArea(ee[0]);if(z){let B=function(){!K||typeof K.x!="number"||typeof K.y!="number"||!z||(K.x<z.x&&(K.x=z.x),K.y<z.y&&(K.y=z.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",z),B(),K.width>z.width&&(K.width=z.width),K.height>z.height&&(K.height=z.height),K.x>z.x+z.width-128&&(K.x=z.x+z.width-K.width),K.y>z.y+z.height-128&&(K.y=z.y+z.height-K.height),B()}return K}if(K.display&&K.mode===3){const z=ee.find(B=>B.id===K.display);if(z&&typeof z.bounds?.x=="number"&&typeof z.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const B=(0,R.defaultWindowState)(3);return B.x=z.bounds.x,B.y=z.bounds.y,B}}let F,H;try{F=v.screen.getDisplayMatching({x:K.x,y:K.y,width:K.width,height:K.height}),H=this.getWorkingArea(F)}catch(z){}if(F&&H&&K.x+K.width>H.x&&K.y+K.height>H.y&&K.x<H.x+H.width&&K.y<H.y+H.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",H),K}getWorkingArea(K){if(K.workArea.width>0&&K.workArea.height>0)return K.workArea;if(K.bounds.width>0&&K.bounds.height>0)return K.bounds}getBounds(){const[K,ee]=this._win.getPosition(),[F,H]=this._win.getSize();return{x:K,y:ee,width:F,height:H}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(K){this.useNativeFullScreen()?this.setNativeFullScreen(K):this.setSimpleFullScreen(K),this.sendWhenReady(K?"vscode:enterFullScreen":"vscode:leaveFullScreen",M.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(K){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(K)}setSimpleFullScreen(K){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(K),this._win.webContents.focus()}useNativeFullScreen(){const K=this.configurationService.getValue("window");return!K||typeof K.nativeFullScreen!="boolean"||K.nativeTabs?!0:K.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let K=(0,P.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(K)<0&&(K="classic"),K}setMenuBarVisibility(K,ee=!0){k.isMacintosh||(K==="toggle"&&ee&&this.send("vscode:showInfoMessage",(0,S.localize)(10,null)),K==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(K)}):this.doSetMenuBarVisibility(K))}doSetMenuBarVisibility(K){const ee=this.isFullScreen;switch(K){case"classic":this._win.setMenuBarVisibility(!ee),this._win.autoHideMenuBar=ee;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(k.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(K,ee,...F){this.isReady?this.send(K,...F):this.ready().then(()=>{ee.isCancellationRequested||this.send(K,...F)})}send(K,...ee){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${K} for window that is destroyed`);return}this._win.webContents.send(K,...ee)}}updateTouchBar(K){!k.isMacintosh||this.touchBarGroups.forEach((ee,F)=>{const H=K[F];ee.segments=this.createTouchBarGroupSegments(H)})}createTouchBar(){if(!!k.isMacintosh){for(let K=0;K<10;K++){const ee=this.createTouchBarGroup();this.touchBarGroups.push(ee)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(K=[]){const ee=this.createTouchBarGroupSegments(K),F=new v.TouchBar.TouchBarSegmentedControl({segments:ee,mode:"buttons",segmentStyle:"automatic",change:H=>{this.sendWhenReady("vscode:runAction",M.CancellationToken.None,{id:F.segments[H].id,from:"touchbar"})}});return F}createTouchBarGroupSegments(K=[]){return K.map(F=>{let H;F.icon&&!g.ThemeIcon.isThemeIcon(F.icon)&&F.icon?.dark?.scheme===f.Schemas.file&&(H=v.nativeImage.createFromPath(b.URI.revive(F.icon.dark).fsPath),H.isEmpty()&&(H=void 0));let z;return typeof F.title=="string"?z=F.title:z=F.title.value,{id:F.id,label:H?void 0:z,icon:H}})}dispose(){super.dispose(),this._win=null}};x=he([te(1,i.ILogService),te(2,y.IEnvironmentMainService),te(3,o.IFileService),te(4,r.IStorageMainService),te(5,m.IConfigurationService),te(6,p.IThemeMainService),te(7,W.IWorkspacesManagementMainService),te(8,d.IBackupMainService),te(9,a.ITelemetryService),te(10,E.IDialogMainService),te(11,u.ILifecycleMainService),te(12,l.IProductService),te(13,s.IProtocolMainService)],x),e.CodeWindow=x}),define(Q[65],J([0,1,14,30,9,4,34,2,10,3,15,7,19,152,5,22,6,38,26,46]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let o=class He extends n.Disposable{constructor(g,p,P,R){super();this.stateMainService=g,this.logService=p,this.workspacesManagementMainService=P,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new D.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(g=>this.addRecentlyOpened([{workspace:g.workspace}])))}handleWindowsJumpList(){!w.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(g){const p=[],P=[];for(let R of g)if((0,c.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&l(p,R.workspace)===-1&&p.push(R);else if((0,c.isRecentFolder)(R))s(p,R.folderUri)===-1&&p.push(R);else{const A=r(P,R.fileUri)>=0,W=R.fileUri.scheme===f.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,t.basename)(R.fileUri))>=0;!A&&!W&&(P.push(R),w.isWindows&&R.fileUri.scheme===f.Schemas.file&&v.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(p,P),p.length>He.MAX_TOTAL_RECENT_ENTRIES&&(p.length=He.MAX_TOTAL_RECENT_ENTRIES),P.length>He.MAX_TOTAL_RECENT_ENTRIES&&(P.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:p,files:P}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(g){const p=W=>{const j=i(W);for(const x of g)if(t.extUriBiasedIgnorePathCase.isEqual(x,j))return!1;return!0},P=this.getRecentlyOpened(),R=P.workspaces.filter(p),A=P.files.filter(p);(R.length!==P.workspaces.length||A.length!==P.files.length)&&(this.saveRecentlyOpened({files:A,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;v.app.clearRecentDocuments();const g=this.getRecentlyOpened(),p=[];let P=0;for(let A=0;A<g.workspaces.length&&P<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;A++){const W=i(g.workspaces[A]);if(W.scheme===f.Schemas.file){const j=(0,t.originalFSPath)(W);await b.Promises.exists(j)&&(p.push(j),P++)}}const R=[];for(let A=0;A<g.files.length&&P<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;A++){const W=i(g.files[A]);if(W.scheme===f.Schemas.file){const j=(0,t.originalFSPath)(W);if(He.COMMON_FILES_FILTER.includes((0,t.basename)(W))||p.includes(j))continue;await b.Promises.exists(j)&&(R.push(j),P++)}}R.reverse().forEach(A=>v.app.addRecentDocument(A)),p.reverse().forEach(A=>v.app.addRecentDocument(A))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(g){const p=[],P=[],R=g?.config?.workspace;(0,c.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?p.push({workspace:R}):(0,c.isSingleFolderWorkspaceIdentifier)(R)&&p.push({folderUri:R.uri});const A=g?.config?.filesToOpenOrCreate;if(A)for(let W of A){const j=W.fileUri;j&&r(P,j)===-1&&P.push({fileUri:j})}return this.addEntriesFromStorage(p,P),{workspaces:p,files:P}}addEntriesFromStorage(g,p){let P=this.getRecentlyOpenedFromStorage();for(let R of P.workspaces){let A=(0,c.isRecentFolder)(R)?s(g,R.folderUri):l(g,R.workspace);A>=0?g[A].label=g[A].label||R.label:g.push(R)}for(let R of P.files){let A=r(p,R.fileUri);A>=0?p[A].label=p[A].label||R.label:p.push(R)}}getRecentlyOpenedFromStorage(){const g=this.stateMainService.getItem(He.recentlyOpenedStorageKey);return(0,c.restoreRecentlyOpened)(g,this.logService)}saveRecentlyOpened(g){const p=(0,c.toStoreData)(g);this.stateMainService.setItem(He.recentlyOpenedStorageKey,p)}updateWindowsJumpList(){if(!w.isWindows)return;const g=[];if(g.push({type:"tasks",items:[{type:"task",title:(0,S.localize)(0,null),description:(0,S.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let p=[];for(let A of v.app.getJumpListSettings().removedItems){const W=A.args;if(W){const j=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(W);j&&p.push(k.URI.parse(j[2]))}}this.removeRecentlyOpened(p);let P=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(A=>{const W=(0,c.isRecentWorkspace)(A)?A.workspace:A.folderUri,{title:j,description:x}=this.getWindowsJumpListLabel(W,A.label);let re;return k.URI.isUri(W)?re=`--folder-uri "${W.toString()}"`:(P=!0,re=`--file-uri "${W.configPath.toString()}"`),{type:"task",title:j.substr(0,255),description:x.substr(0,255),program:process.execPath,args:re,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&g.push({type:"custom",name:P?(0,S.localize)(2,null):(0,S.localize)(3,null),items:R})}g.push({type:"recent"});try{v.app.setJumpList(g)}catch(p){this.logService.warn("updateWindowsJumpList#setJumpList",p)}}getWindowsJumpListLabel(g,p){if(p)return{title:(0,I.splitName)(p).name,description:p};if(k.URI.isUri(g))return{title:(0,t.basename)(g),description:u(g)};if(this.workspacesManagementMainService.isUntitledWorkspace(g))return{title:(0,S.localize)(4,null),description:""};let P=(0,t.basename)(g.configPath);return P.endsWith(c.WORKSPACE_EXTENSION)&&(P=P.substr(0,P.length-c.WORKSPACE_EXTENSION.length-1)),{title:(0,S.localize)(5,null,P),description:u(g.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([te(0,y.IStateMainService),te(1,E.ILogService),te(2,h.IWorkspacesManagementMainService),te(3,m.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function u(a){return a.scheme==="file"?(0,I.normalizeDriveLetter)(a.fsPath):a.toString()}function i(a){return(0,c.isRecentFolder)(a)?a.folderUri:(0,c.isRecentFile)(a)?a.fileUri:a.workspace.configPath}function l(a,g){return a.findIndex(p=>(0,c.isRecentWorkspace)(p)&&p.workspace.id===g.id)}function s(a,g){return a.findIndex(p=>(0,c.isRecentFolder)(p)&&t.extUriBiasedIgnorePathCase.isEqual(p.folderUri,g))}function r(a,g){return a.findIndex(p=>t.extUriBiasedIgnorePathCase.isEqual(p.fileUri,g))}}),define(Q[232],J([0,1,14,9,23,34,3,7,144,16,24,22,6,178,53,21,38,29,41,64,36,65]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let l=class wt{constructor(a,g,p,P,R,A,W,j,x,re,K){this.updateService=a,this.configurationService=g,this.windowsMainService=p,this.environmentMainService=P,this.telemetryService=R,this.workspacesHistoryMainService=A,this.stateMainService=W,this.lifecycleMainService=j,this.logService=x,this.nativeHostMainService=re,this.productService=K,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(I.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const a=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);a&&(a.menus&&(this.menubarMenus=a.menus),a.keybindings&&(this.keybindings=a.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,W,j)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,W,j)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,W,j)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(j),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,W,j)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(j),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const a=this.productService.twitterUrl;a&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(a,"openTwitterUrl"));const g=this.productService.requestFeatureUrl;g&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(g,"openUserVoiceUrl"));const p=this.productService.reportIssueUrl;p&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(p,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(I.language){const A=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${A}lang=${I.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(a=>this.onDidChangeWindowsCount(a)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let a=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get currentEnableNativeTabs(){if(!I.isMacintosh)return!1;let a=this.configurationService.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,g){this.menubarMenus=a.menus,this.keybindings=a.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,a),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(a){!I.isMacintosh||(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.closedLastWindow=a.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!I.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const a=v.Menu.getApplicationMenu();if(a&&this.oldMenus.push(a),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(I.isMacintosh?new v.Menu:null);return}const g=new v.Menu;let p;if(I.isMacintosh){const R=new v.Menu;p=new v.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),g.append(p)}if(I.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new v.Menu;R.append(new v.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:R});this.setMenuById(R,"File"),g.append(A)}if(this.shouldDrawMenu("Edit")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),g.append(A)}if(this.shouldDrawMenu("Selection")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),g.append(A)}if(this.shouldDrawMenu("View")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:R});this.setMenuById(R,"View"),g.append(A)}if(this.shouldDrawMenu("Go")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),g.append(A)}if(this.shouldDrawMenu("Run")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),g.append(A)}if(this.shouldDrawMenu("Terminal")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),g.append(A)}let P;if(this.shouldDrawMenu("Window")){const R=new v.Menu;P=new v.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(P&&g.append(P),this.shouldDrawMenu("Help")){const R=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),g.append(A)}g.items&&g.items.length>0?v.Menu.setApplicationMenu(g):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(a){const g=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),p=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const ee=new v.Menu;this.setMenuById(ee,"Preferences"),P=new v.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:ee})}const R=new v.Menu,A=new v.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),W=new v.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),j=new v.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new v.MenuItem({label:f.localize(15,null),role:"unhide"}),re=new v.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const ee=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||ee?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),K=[g];K.push(...p),P&&K.push(s(),P),K.push(s(),A,s(),W,j,x,s(),re),K.forEach(ee=>a.append(ee))}shouldDrawMenu(a){if(!I.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(a){case"File":case"Help":if(I.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[a];case"Window":if(I.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[a]}}setMenu(a,g){g.forEach(p=>{if((0,S.isMenubarMenuItemSeparator)(p))a.append(s());else if((0,S.isMenubarMenuItemSubmenu)(p)){const P=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(p.label),submenu:P});this.setMenu(P,p.submenu.items),a.append(R)}else(0,S.isMenubarMenuItemRecentAction)(p)?a.append(this.createOpenRecentMenuItem(p)):(0,S.isMenubarMenuItemAction)(p)&&(p.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(a),I.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[p.id]?a.append(new v.MenuItem(this.likeAction(p.id,{label:this.mnemonicLabel(p.label),click:this.fallbackMenuHandlers[p.id]}))):a.append(this.createMenuItem(p.label,p.id,!1,p.checked)):a.append(this.createMenuItem(p.label,p.id,p.enabled!==!1,!!p.checked)):a.append(this.createMenuItem(p.label,p.id,p.enabled!==!1,!!p.checked)))})}setMenuById(a,g){this.menubarMenus&&this.menubarMenus[g]&&this.setMenu(a,this.menubarMenus[g].items)}insertCheckForUpdatesItems(a){const g=this.getUpdateMenuItems();g.length&&(g.forEach(p=>a.append(p)),a.append(s()))}createOpenRecentMenuItem(a){const g=n.URI.revive(a.uri),p=a.id,P=p==="openRecentFile"?{fileUri:g}:p==="openRecentWorkspace"?{workspaceUri:g}:{folderUri:g};return new v.MenuItem(this.likeAction(p,{label:a.label,click:(R,A,W)=>{const j=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:j,gotoLineMode:!1,remoteAuthority:a.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([g])}},!1))}isOptionClick(a){return!!(a&&(!I.isMacintosh&&(a.ctrlKey||a.shiftKey)||I.isMacintosh&&(a.metaKey||a.altKey)))}createRoleMenuItem(a,g,p){const P={label:this.mnemonicLabel(a),role:p,enabled:!0};return new v.MenuItem(this.withKeybinding(g,P))}setMacWindowMenu(a){const g=new v.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),p=new v.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new v.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(s()),A.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[g,p,s(),R,...A,s(),P].forEach(W=>a.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(a,g,p,P){const R=this.mnemonicLabel(a),A=typeof g=="function"?g:(K,ee,F)=>{const H=K?K.userSettingsLabel:null;let z=g;Array.isArray(g)&&(z=this.isOptionClick(F)?g[1]:g[0]),H&&F.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:H}):this.runActionInRenderer({type:"commandId",commandId:z})},W=typeof p=="boolean"?p:this.windowsMainService.getWindowCount()>0,j=typeof P=="boolean"?P:!1,x={label:R,click:A,enabled:W};j&&(x.type="checkbox",x.checked=j);let re;return typeof g=="string"?re=g:Array.isArray(g)&&(re=g[0]),I.isMacintosh&&(re==="editor.action.clipboardCutAction"?x.role="cut":re==="editor.action.clipboardCopyAction"?x.role="copy":re==="editor.action.clipboardPasteAction"&&(x.role="paste"),re==="undo"?x.click=this.makeContextAwareClickHandler(A,{inDevTools:K=>K.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?x.click=this.makeContextAwareClickHandler(A,{inDevTools:K=>K.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(A,{inDevTools:K=>K.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(re,x))}makeContextAwareClickHandler(a,g){return(p,P,R)=>{const A=v.BrowserWindow.getFocusedWindow();if(!A)return g.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return g.inDevTools(A.webContents.devToolsWebContents);a(p,P||A,R)}}runActionInRenderer(a){let g=v.BrowserWindow.getFocusedWindow();if(!g){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(g=P.win)}const p=g?this.windowsMainService.getWindowById(g.id):void 0;if(p){if(this.logService.trace("menubar#runActionInRenderer",a),I.isMacintosh&&!this.environmentMainService.isBuilt&&!p.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const P={id:a.commandId,from:"menu"};p.sendWhenReady("vscode:runAction",M.CancellationToken.None,P)}else{const P={userSettingsLabel:a.userSettingsLabel};p.sendWhenReady("vscode:runKeybinding",M.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",a)}withKeybinding(a,g){const p=typeof a=="string"?this.keybindings[a]:void 0;if(p?.label){if(p.isNative!==!1)g.accelerator=p.label,g.userSettingsLabel=p.userSettingsLabel;else if(typeof g.label=="string"){const P=g.label.indexOf("[");P>=0?g.label=`${g.label.substr(0,P)} [${p.label}]`:g.label=`${g.label} [${p.label}]`}}else g.accelerator=void 0;return g}likeAction(a,g,p=!g.accelerator){p&&(g=this.withKeybinding(a,g));const P=g.click;return g.click=(R,A,W)=>{this.reportMenuActionTelemetry(a),P&&P(R,A,W)},g}openUrl(a,g){this.nativeHostMainService.openExternal(void 0,a),this.reportMenuActionTelemetry(g)}reportMenuActionTelemetry(a){this.telemetryService.publicLog2("workbenchActionExecuted",{id:a,from:i})}mnemonicLabel(a){return(0,D.mnemonicMenuLabel)(a,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=he([te(0,c.IUpdateService),te(1,w.IConfigurationService),te(2,o.IWindowsMainService),te(3,t.IEnvironmentMainService),te(4,y.ITelemetryService),te(5,u.IWorkspacesHistoryMainService),te(6,E.IStateMainService),te(7,k.ILifecycleMainService),te(8,b.ILogService),te(9,d.INativeHostMainService),te(10,m.IProductService)],l),e.Menubar=l;function s(){return new v.MenuItem({type:"separator"})}}),define(Q[233],J([0,1,5,22,6,232]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let I=class{constructor(f,w,t){this.instantiationService=f,this.lifecycleMainService=w,this.logService=t,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(D.Menubar)}async updateMenubar(f,w){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(w,f)}};I=he([te(0,v.IInstantiationService),te(1,L.ILifecycleMainService),te(2,M.ILogService)],I),e.MenubarMainService=I}),define(Q[234],J([0,1,14,31,25,30,23,4,33,42,34,2,10,8,75,3,32,15,13,7,150,51,16,52,24,20,5,22,6,45,21,55,61,38,64,231,99,214,26,100,65,46]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h,o,u,i,l,s,r,a,g,p,P,R,A,W,j,x,re,K,ee,F,H,z,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function C(O){return(0,F.isWorkspaceIdentifier)(O?.workspace)}function U(O){return(0,F.isSingleFolderWorkspaceIdentifier)(O?.workspace)}let Y=class Ze extends k.Disposable{constructor(T,_,q,X,$,N,Z,ie,oe,le,ne,ae,ue,de,ve){super();this.machineId=T,this.initialUserEnv=_,this.logService=q,this.stateMainService=X,this.environmentMainService=$,this.lifecycleMainService=N,this.backupMainService=Z,this.configurationService=ie,this.workspacesHistoryMainService=oe,this.workspacesManagementMainService=le,this.instantiationService=ne,this.dialogMainService=ae,this.fileService=ue,this.productService=de,this.protocolMainService=ve,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new ee.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(T=>this._onDidSignalReadyWindow.fire(T.window))),this._register(this.onDidSignalReadyWindow(T=>{if(T.config?.extensionDevelopmentPath||T.config?.extensionTestsPath){const _=new k.DisposableStore;if(_.add(n.Event.any(T.onDidClose,T.onDidDestroy)(()=>_.dispose())),T.config.extensionDevelopmentPath)for(const q of T.config.extensionDevelopmentPath)_.add(this.protocolMainService.addValidFileRoot(h.URI.file(q)));T.config.extensionTestsPath&&_.add(this.protocolMainService.addValidFileRoot(h.URI.file(T.config.extensionTestsPath)))}}))}openEmptyWindow(T,_){let q=this.environmentMainService.args;const X=_?.remoteAuthority||void 0,$=!0,N=_?.forceReuseWindow,Z=!N;return this.open({...T,cli:q,forceEmpty:$,forceNewWindow:Z,forceReuseWindow:N,remoteAuthority:X})}openExistingWindow(T,_){T.focus(),this.handleWaitMarkerFile(_,[T])}open(T){this.logService.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const _=[],q=[],X=[],$=[],N=[];let Z,ie=0;const oe=this.getPathsToOpen(T);this.logService.trace("windowsManager#open pathsToOpen",oe);for(const ue of oe)U(ue)?T.addMode?_.push(ue):q.push(ue):C(ue)?X.push(ue):ue.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ue.remoteAuthority}),Z.filesToOpenOrCreate.push(ue)):ue.backupPath?N.push({backupFolder:(0,S.basename)(ue.backupPath),remoteAuthority:ue.remoteAuthority}):ie++;T.diffMode&&Z&&Z.filesToOpenOrCreate.length>=2&&(Z.filesToDiff=Z.filesToOpenOrCreate.slice(0,2),Z.filesToOpenOrCreate=[]),Z&&T.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?($.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),X.push(...$),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:le,filesOpenedInWindow:ne}=this.doOpen(T,X,q,N,ie,Z,_);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${X.length}, foldersToOpen: ${q.length}, emptyToRestore: ${N.length}, emptyToOpen: ${ie})`),le.length>1)if(ne)ne.focus();else{const ue=this.windowsStateHandler.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let de=!0,ve=!0;if(ue){const Ie=le.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),de=!1,ve=!1)}if(de)for(let Ie=le.length-1;Ie>=0;Ie--){const me=le[Ie];if(!(me.openedWorkspace&&$.some(ge=>me.openedWorkspace&&ge.workspace.id===me.openedWorkspace.id)||me.backupPath&&N.some(ge=>me.backupPath&&ge.backupFolder===(0,S.basename)(me.backupPath)))){me.focus(),ve=!1;break}}ve&&le[le.length-1].focus()}const ae=Z&&Z.filesToDiff.length>0;if(!le.some(ue=>ue.isExtensionDevelopmentHost)&&!ae&&!T.noRecentEntry){const ue=[];for(const de of oe)C(de)&&!de.transient?ue.push({label:de.label,workspace:de.workspace,remoteAuthority:de.remoteAuthority}):U(de)?ue.push({label:de.label,folderUri:de.workspace.uri,remoteAuthority:de.remoteAuthority}):de.fileUri&&ue.push({label:de.label,fileUri:de.fileUri,remoteAuthority:de.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ue)}return this.handleWaitMarkerFile(T,le),le}handleWaitMarkerFile(T,_){const q=T.waitMarkerFileURI;T.context===0&&q&&_.length===1&&_[0]&&(async()=>{await _[0].whenClosedOrLoaded;try{await this.fileService.del(q)}catch(X){}})()}doOpen(T,_,q,X,$,N,Z){const ie=[];let oe;function le(me,ge){ie.push(me),ge&&(oe=me,N=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:ae}=this.shouldOpenNewWindow(T);if(!T.initialStartup&&Z.length>0){const me=Z[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(me);ge&&le(this.doAddFoldersToExistingWindow(ge,Z.map(Ee=>Ee.workspace.uri)))}const ue=q.length+_.length+X.length;if(N&&ue===0){const me=N.filesToOpenOrCreate[0]||N.filesToDiff[0],ge=this.getWindows().filter(ke=>N&&ke.remoteAuthority===N.remoteAuthority);let Ee;me?.fileUri&&!ae&&((T.context===4||T.context===0||T.context===1)&&(Ee=(0,K.findWindowOnFile)(ge,me.fileUri,ke=>ke.configPath.scheme===b.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(ge))),Ee?(0,F.isWorkspaceIdentifier)(Ee.openedWorkspace)?_.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,F.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?q.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):le(this.doOpenFilesInExistingWindow(T,Ee,N),!0):le(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow}),!0)}const de=(0,D.distinct)(_,me=>me.workspace.id);if(de.length>0){const me=(0,D.coalesce)(de.map(ge=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(me.length>0){const ge=me[0],Ee=N?.remoteAuthority===ge.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(T,ge,Ee),!!Ee),ne=!0}de.forEach(ge=>{if(me.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===ge.workspace.id))return;const Ee=ge.remoteAuthority,ke=N?.remoteAuthority===Ee?N:void 0;le(this.doOpenFolderOrWorkspace(T,ge,ne,ke),!!ke),ne=!0})}const ve=(0,D.distinct)(q,me=>y.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(ve.length>0){const me=(0,D.coalesce)(ve.map(ge=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(me.length>0){const ge=me[0],Ee=N?.remoteAuthority===ge.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(T,ge,Ee),!!Ee),ne=!0}ve.forEach(ge=>{if(me.some(Ae=>(0,F.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,ge.workspace.uri)))return;const Ee=ge.remoteAuthority,ke=N?.remoteAuthority===Ee?N:void 0;le(this.doOpenFolderOrWorkspace(T,ge,ne,ke),!!ke),ne=!0})}const Ie=(0,D.distinct)(X,me=>me.backupFolder);if(Ie.length>0&&Ie.forEach(me=>{const ge=me.remoteAuthority,Ee=N?.remoteAuthority===ge?N:void 0;le(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:Ee,remoteAuthority:ge,forceNewWindow:!0,forceNewTabbedWindow:T.forceNewTabbedWindow,emptyWindowBackupInfo:me}),!!Ee),ne=!0}),ie.length===0||N){N&&!$&&$++;const me=N?N.remoteAuthority:T.remoteAuthority;for(let ge=0;ge<$;ge++)le(this.doOpenEmpty(T,ne,me,N),!!N),ne=!0}return{windows:(0,D.distinct)(ie),filesOpenedInWindow:oe}}doOpenFilesInExistingWindow(T,_,q){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),_.focus();const X={filesToOpenOrCreate:q?.filesToOpenOrCreate,filesToDiff:q?.filesToDiff,filesToWait:q?.filesToWait,termProgram:T?.userEnv?.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",I.CancellationToken.None,X),_}doAddFoldersToExistingWindow(T,_){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),T.focus();const q={foldersToAdd:_};return T.sendWhenReady("vscode:addFolders",I.CancellationToken.None,q),T}doOpenEmpty(T,_,q,X,$){return!_&&!$&&typeof T.contextWindowId=="number"&&($=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:q,forceNewWindow:_,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:X,windowToUse:$})}doOpenFolderOrWorkspace(T,_,q,X,$){return!q&&!$&&typeof T.contextWindowId=="number"&&($=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({workspace:_.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:q,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:X,windowToUse:$})}getPathsToOpen(T){let _,q=!1,X=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(_=this.doExtractPathsFromAPI(T),q=!0):T.forceEmpty?_=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(_=this.doExtractPathsFromCLI(T.cli),_.length===0&&_.push(Object.create(null)),q=!0):(_=this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),X=!0),!T.addMode&&q){const $=_.filter(N=>U(N));if($.length>1){const N=$[0].remoteAuthority;if($.every(Z=>Z.remoteAuthority===N)){const Z=this.workspacesManagementMainService.createUntitledWorkspaceSync($.map(ie=>({uri:ie.workspace.uri})));_.push({workspace:Z,remoteAuthority:N}),_=_.filter(ie=>!U(ie))}}}return T.initialStartup&&!X&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&_.unshift(...this.doGetPathsFromLastSession().filter($=>C($)||U($)||$.backupPath)),_}doExtractPathsFromAPI(T){const _=[],q={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority};for(const X of(0,D.coalesce)(T.urisToOpen||[])){const $=this.resolveOpenable(X,q);if($)$.label=X.label,_.push($);else{const N=this.resourceFromOpenable(X),Z={title:this.productService.nameLong,type:"info",buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(0,null))],defaultId:0,message:N.scheme===b.Schemas.file?(0,o.localize)(1,null):(0,o.localize)(2,null),detail:N.scheme===b.Schemas.file?(0,o.localize)(3,null,(0,t.getPathLabel)(N.fsPath,this.environmentMainService)):(0,o.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,c.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return _}doExtractPathsFromCLI(T){const _=[],q={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:!1},X=T["folder-uri"];if(X)for(const Z of X){const ie=this.cliArgToUri(Z);if(ie){const oe=this.resolveOpenable({folderUri:ie},q);oe&&_.push(oe)}}const $=T["file-uri"];if($)for(const Z of $){const ie=this.cliArgToUri(Z);if(ie){const oe=this.resolveOpenable((0,F.hasWorkspaceFileExtension)(Z)?{workspaceUri:ie}:{fileUri:ie},q);oe&&_.push(oe)}}const N=T._;for(const Z of N){const ie=q.remoteAuthority?this.doResolvePathRemote(Z,q):this.doResolveFilePath(Z,q);ie&&_.push(ie)}return _}cliArgToUri(T){try{const _=h.URI.parse(T);if(!_.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${T}`);return}return _}catch(_){this.logService.error(`Invalid URI input string: ${T}, ${_.message}`)}}doGetPathsFromLastSession(){const T=this.getRestoreWindowsSetting();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":const _=[];T!=="one"&&_.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&_.push(this.windowsStateHandler.state.lastActiveWindow);const q=[];for(const X of _)if(X.workspace){const $=this.resolveOpenable({workspaceUri:X.workspace.configPath},{remoteAuthority:X.remoteAuthority,rejectTransientWorkspaces:!0});C($)&&q.push($)}else if(X.folderUri){const $=this.resolveOpenable({folderUri:X.folderUri},{remoteAuthority:X.remoteAuthority});U($)&&q.push($)}else T!=="folders"&&X.backupPath&&q.push({backupPath:X.backupPath,remoteAuthority:X.remoteAuthority});return q}}getRestoreWindowsSetting(){let T;return this.lifecycleMainService.wasRestarted?T="all":(T=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")),T}resolveOpenable(T,_=Object.create(null)){let q=this.resourceFromOpenable(T);return q.scheme===b.Schemas.file?((0,x.isFileToOpen)(T)&&(_={..._,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(q.fsPath,_)):this.doResolveRemoteOpenable(T,_)}doResolveRemoteOpenable(T,_){let q=this.resourceFromOpenable(T);const X=(0,W.getRemoteAuthority)(q)||_.remoteAuthority;if(q=(0,y.removeTrailingPathSeparator)((0,y.normalizePath)(q)),(0,x.isFileToOpen)(T)){if(_.gotoLineMode){const{path:$,line:N,column:Z}=(0,f.parseLineAndColumnAware)(q.path);return{fileUri:q.with({path:$}),selection:N?{startLineNumber:N,startColumn:Z||1}:void 0,remoteAuthority:X}}return{fileUri:q,remoteAuthority:X}}else if((0,x.isWorkspaceToOpen)(T))return{workspace:(0,H.getWorkspaceIdentifier)(q),remoteAuthority:X};return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:X}}resourceFromOpenable(T){return(0,x.isWorkspaceToOpen)(T)?T.workspaceUri:(0,x.isFolderToOpen)(T)?T.folderUri:T.fileUri}doResolveFilePath(T,_){let q,X;_.gotoLineMode&&({path:T,line:q,column:X}=(0,f.parseLineAndColumnAware)(T)),T=(0,f.sanitizeFilePath)((0,S.normalize)(T),(0,E.cwd)());try{const $=(0,L.statSync)(T);if($.isFile()){if(!_.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(T));if(N)return N.transient&&_.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},remoteAuthority:N.remoteAuthority,exists:!0,transient:N.transient}}return{fileUri:h.URI.file(T),selection:q?{startLineNumber:q,startColumn:X||1}:void 0,exists:!0}}else if($.isDirectory())return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(h.URI.file(T),$),exists:!0}}catch($){const N=h.URI.file(T);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),_.ignoreFileNotFound)return{fileUri:N,exists:!1}}}doResolvePathRemote(T,_){const q=T.charCodeAt(0),X=_.remoteAuthority;let $,N;_.gotoLineMode&&({path:T,line:$,column:N}=(0,f.parseLineAndColumnAware)(T)),q!==47&&((0,f.isWindowsDriveLetter)(q)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,f.toSlashes)(T)),T=`/${T}`);const Z=h.URI.from({scheme:b.Schemas.vscodeRemote,authority:X,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,F.hasWorkspaceFileExtension)(T))return _.forceOpenWorkspaceAsFile?{fileUri:Z,selection:$?{startLineNumber:$,startColumn:N||1}:void 0,remoteAuthority:_.remoteAuthority}:{workspace:(0,H.getWorkspaceIdentifier)(Z),remoteAuthority:X};if(_.gotoLineMode||S.posix.basename(T).indexOf(".")!==-1)return{fileUri:Z,selection:$?{startLineNumber:$,startColumn:N||1}:void 0,remoteAuthority:X}}return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:X}}shouldOpenNewWindow(T){const _=this.configurationService.getValue("window"),q=_?.openFoldersInNewWindow||"default",X=_?.openFilesInNewWindow||"off";let $=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(q==="on"||q==="off")&&($=q==="on");let N=!1;return T.forceNewWindow||T.forceReuseWindow?N=!!T.forceNewWindow&&!T.forceReuseWindow:(m.isMacintosh?T.context===1&&(N=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!T.cli.extensionDevelopmentPath&&(X==="on"||X==="off")&&(N=X==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(T,_){const q=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),T);if(q)return this.lifecycleMainService.reload(q,_.cli),q.focus(),[q];let X=_.cli["folder-uri"]||[],$=_.cli["file-uri"]||[],N=_.cli._;if(!N.length&&!X.length&&!$.length&&!_.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=le&&(le.workspace||le.folderUri);ne&&(h.URI.isUri(ne)?ne.scheme===b.Schemas.file?N=[ne.fsPath]:X=[ne.toString()]:ne.configPath.scheme===b.Schemas.file?N=[(0,y.originalFSPath)(ne.configPath)]:$=[ne.configPath.toString()])}let Z=_.remoteAuthority;for(const le of T)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=h.URI.parse(le),ae=(0,W.getRemoteAuthority)(ne);ae&&(Z?ae!==Z&&this.logService.error("more than one extension development path authority"):Z=ae)}N=N.filter(le=>{const ne=h.URI.file(le);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,W.getRemoteAuthority)(ne)===Z}),X=X.filter(le=>{const ne=this.cliArgToUri(le);return ne&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,W.getRemoteAuthority)(ne)===Z:!1}),$=$.filter(le=>{const ne=this.cliArgToUri(le);return ne&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,W.getRemoteAuthority)(ne)===Z:!1}),_.cli._=N,_.cli["folder-uri"]=X,_.cli["file-uri"]=$;const ie=!N.length&&!X.length&&!$.length,oe={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:Z};return this.open(oe)}openInBrowserWindow(T){const _=this.configurationService.getValue("window"),q={...this.environmentMainService.args,...T.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:T.emptyWindowBackupInfo?(0,S.join)(this.environmentMainService.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:{...this.initialUserEnv,...T.userEnv},filesToOpenOrCreate:T.filesToOpen?.filesToOpenOrCreate,filesToDiff:T.filesToOpen?.filesToDiff,filesToWait:T.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:T.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof _?.zoomLevel=="number"?_.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),autoDetectHighContrast:_?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let X;if(!T.forceNewWindow&&!T.forceNewTabbedWindow&&(X=T.windowToUse||this.getLastActiveWindow(),X&&X.focus()),X){const $=X.config;!q.extensionDevelopmentPath&&$&&!!$.extensionDevelopmentPath&&(q.extensionDevelopmentPath=$.extensionDevelopmentPath,q.verbose=$.verbose,q["inspect-brk-extensions"]=$["inspect-brk-extensions"],q.debugId=$.debugId,q.extensionEnvironment=$.extensionEnvironment,q["inspect-extensions"]=$["inspect-extensions"],q["extensions-dir"]=$["extensions-dir"])}else{const $=this.windowsStateHandler.getNewWindowState(q);(0,d.mark)("code/willCreateCodeWindow");const N=X=this.instantiationService.createInstance(re.CodeWindow,{state:$,extensionDevelopmentPath:q.extensionDevelopmentPath,isExtensionTestHost:!!q.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),T.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(N)}Ze.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,w.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,w.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const Z=(0,c.assertIsDefined)(N.win?.webContents);Z.removeAllListeners("devtools-reload-page"),Z.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return q.windowId=X.id,X.isReady?this.lifecycleMainService.unload(X,4).then($=>{$||this.doOpenInBrowserWindow(X,q,T)}):this.doOpenInBrowserWindow(X,q,T),X}doOpenInBrowserWindow(T,_,q){if(!_.extensionDevelopmentPath)if((0,F.isWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:_.workspace,remoteAuthority:_.remoteAuthority});else if((0,F.isSingleFolderWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerFolderBackupSync(_.workspace.uri);else{const X=q.emptyWindowBackupInfo&&q.emptyWindowBackupInfo.backupFolder;_.backupPath=this.backupMainService.registerEmptyWindowBackupSync(X,_.remoteAuthority)}T.load(_)}onWindowClosed(T){const _=Ze.WINDOWS.indexOf(T);Ze.WINDOWS.splice(_,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const T=v.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(T){return this.doGetLastActiveWindow(this.getWindows().filter(_=>_.remoteAuthority===T))}doGetLastActiveWindow(T){const _=Math.max.apply(Math,T.map(q=>q.lastFocusTime));return T.find(q=>q.lastFocusTime===_)}sendToFocused(T,..._){const q=this.getFocusedWindow()||this.getLastActiveWindow();q&&q.sendWhenReady(T,I.CancellationToken.None,..._)}sendToAll(T,_,q){for(const X of this.getWindows())q&&q.indexOf(X.id)>=0||X.sendWhenReady(T,I.CancellationToken.None,_)}getWindows(){return Ze.WINDOWS}getWindowCount(){return Ze.WINDOWS.length}getWindowById(T){const _=this.getWindows().filter(q=>q.id===T);return(0,D.firstOrDefault)(_)}getWindowByWebContents(T){const _=v.BrowserWindow.fromWebContents(T);if(!!_)return this.getWindowById(_.id)}};Y.WINDOWS=[],Y=he([te(2,p.ILogService),te(3,j.IStateMainService),te(4,s.IEnvironmentMainService),te(5,g.ILifecycleMainService),te(6,u.IBackupMainService),te(7,i.IConfigurationService),te(8,z.IWorkspacesHistoryMainService),te(9,B.IWorkspacesManagementMainService),te(10,a.IInstantiationService),te(11,l.IDialogMainService),te(12,r.IFileService),te(13,R.IProductService),te(14,A.IProtocolMainService)],Y),e.WindowsMainService=Y}),define(Q[235],J([0,1,51,36,65,46]),function(V,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let I=class{constructor(f,w,t,k){this.workspacesManagementMainService=f,this.windowsMainService=w,this.workspacesHistoryMainService=t,this.backupMainService=k,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,w){const t=this.windowsMainService.getWindowById(f);if(t)return this.workspacesManagementMainService.enterWorkspace(t,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(f,w,t){return this.workspacesManagementMainService.createUntitledWorkspace(w,t)}deleteUntitledWorkspace(f,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(f,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}async removeRecentlyOpened(f,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};I=he([te(0,D.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,M.IWorkspacesHistoryMainService),te(3,v.IBackupMainService)],I),e.WorkspacesMainService=I}),define(Q[236],J([0,1,14,31,25,18,60,17,33,42,39,34,2,10,8,3,15,13,7,28,69,118,35,121,85,227,130,51,218,16,174,157,73,52,217,88,24,54,90,167,181,89,168,20,72,5,74,228,194,101,22,6,176,233,53,21,61,223,76,38,212,98,195,29,197,199,62,41,203,225,229,226,230,97,204,205,206,207,209,36,234,210,26,65,235,46]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h,o,u,i,l,s,r,a,g,p,P,R,A,W,j,x,re,K,ee,F,H,z,B,C,U,Y,O,T,_,q,X,$,N,Z,ie,oe,le,ne,ae,ue,de,ve,Ie,me,ge,Ee,ke,Ae,We,Oe,Ye,Xe,ct,Ke,xe,et,G,se,ce,we,be,Le,Ue,Fe,Ne,Be,ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ut=class extends b.Disposable{constructor(fe,ye,Se,pe,Pe,De,Me,Re,Te,qe){super();this.mainProcessNodeIpcServer=fe,this.userEnv=ye,this.mainInstantiationService=Se,this.logService=pe,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Re,this.fileService=Te,this.productService=qe,this.configureSession(),this.registerListeners()}configureSession(){const fe=pe=>pe?.startsWith(`${S.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((pe,Pe,De,Me)=>fe(Me.requestingUrl)?De(ye.has(Pe)):De(!1)),v.session.defaultSession.setPermissionCheckHandler((pe,Pe,De,Me)=>fe(Me.requestingUrl)?ye.has(Pe):!1);const Se=v.session.defaultSession;typeof Se.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Se.setCodeCachePath((0,d.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,n.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,n.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,n.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Se,pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",pe)}),v.app.on("activate",(Se,pe)=>{this.logService.trace("app#activate"),pe||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Se,pe)=>{pe.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),pe.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let fe=[],ye;v.app.on("open-file",(Se,pe)=>{this.logService.trace("app#open-file: ",pe),Se.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(pe)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],ye=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",Se=>{const pe=this.windowsMainService?.getWindowByWebContents(Se.sender);let Pe,De;return pe?.config?(Pe=pe.config,De={...process.env,...pe.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De)}),v.ipcMain.handle("vscode:writeNlsFile",(Se,pe,Pe)=>{const De=this.validateNlsPath([pe]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,D.VSBuffer.fromString(Pe))}),v.ipcMain.handle("vscode:readNlsFile",async(Se,...pe)=>{const Pe=this.validateNlsPath(pe);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(fe){let ye;for(const Se of fe)typeof Se=="string"&&(typeof ye!="string"?ye=Se:ye=(0,d.join)(ye,Se));if(!(typeof ye!="string"||!(0,d.isAbsolute)(ye)||!(0,f.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!m.isLinux)))return c.URI.file(ye)}onUnexpectedError(fe){if(fe){const ye={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;m.isWindows&&fe&&v.app.setAppUserModelId(fe);try{m.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const ye=new l.Server;this.logService.trace("Resolving machine identifier...");const Se=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:pe,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(Se),Me=await this.initServices(Se,pe,Pe);if(this.environmentMainService.driverHandle){const Te=await(0,x.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Te=>this.initChannels(Te,ye,De));const Re=Me.invokeFunction(Te=>this.openFirstWindow(Te,ye));Me.invokeFunction(Te=>this.afterWindowOpen(Te,pe)),this.environmentMainService.args.trace&&Me.invokeFunction(Te=>this.stopTracingEventually(Te,Re))}async resolveMachineId(){let fe=this.stateMainService.getItem(ge.machineIdKey);return(!fe||m.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,o.getMachineId)(),this.stateMainService.setItem(ge.machineIdKey,fe)),fe}setupSharedProcess(fe){const ye=this._register(this.mainInstantiationService.createInstance(ae.SharedProcess,fe,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(Pe,"main")})(),pe=(async()=>(await ye.whenReady(),Se))();return{sharedProcess:ye,sharedProcessReady:pe,sharedProcessClient:Se}}async initServices(fe,ye,Se){const pe=new T.ServiceCollection;switch(process.platform){case"win32":pe.set(We.IUpdateService,new Y.SyncDescriptor(Ke.Win32UpdateService));break;case"linux":m.isLinuxSnap?pe.set(We.IUpdateService,new Y.SyncDescriptor(ct.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(We.IUpdateService,new Y.SyncDescriptor(Xe.LinuxUpdateService));break;case"darwin":pe.set(We.IUpdateService,new Y.SyncDescriptor(Ye.DarwinUpdateService));break}pe.set(be.IWindowsMainService,new Y.SyncDescriptor(Le.WindowsMainService,[fe,this.userEnv])),pe.set(j.IDialogMainService,new Y.SyncDescriptor(j.DialogMainService)),pe.set(X.ILaunchMainService,new Y.SyncDescriptor(X.LaunchMainService)),pe.set(W.IDiagnosticsService,i.ProxyChannel.toService((0,i.getDelayedChannel)(Se.then(De=>De.getChannel("diagnostics"))))),pe.set(_.IIssueMainService,new Y.SyncDescriptor(_.IssueMainService,[this.userEnv])),pe.set(re.IEncryptionMainService,new Y.SyncDescriptor(re.EncryptionMainService,[fe])),pe.set(q.IKeyboardLayoutMainService,new Y.SyncDescriptor(q.KeyboardLayoutMainService)),pe.set(oe.INativeHostMainService,new Y.SyncDescriptor(oe.NativeHostMainService,[ye])),pe.set(ce.IWebviewManagerService,new Y.SyncDescriptor(we.WebviewMainService)),pe.set(Fe.IWorkspacesService,new Y.SyncDescriptor(Be.WorkspacesMainService)),pe.set(ze.IWorkspacesManagementMainService,new Y.SyncDescriptor(ze.WorkspacesManagementMainService)),pe.set(Ne.IWorkspacesHistoryMainService,new Y.SyncDescriptor(Ne.WorkspacesHistoryMainService)),pe.set(ie.IMenubarMainService,new Y.SyncDescriptor(ie.MenubarMainService)),pe.set(H.IExtensionUrlTrustService,new Y.SyncDescriptor(z.ExtensionUrlTrustService)),pe.set(Ie.IStorageMainService,new Y.SyncDescriptor(Ie.StorageMainService)),m.isWindows?pe.set(B.IExternalTerminalMainService,new Y.SyncDescriptor(C.WindowsExternalTerminalService)):m.isMacintosh?pe.set(B.IExternalTerminalMainService,new Y.SyncDescriptor(C.MacExternalTerminalService)):m.isLinux&&pe.set(B.IExternalTerminalMainService,new Y.SyncDescriptor(C.LinuxExternalTerminalService));const Pe=new p.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(pe.set(g.IBackupMainService,Pe),pe.set(xe.IURLService,new Y.SyncDescriptor(G.NativeURLService)),(0,Ae.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,i.getDelayedChannel)(Se.then(Ge=>Ge.getChannel("telemetryAppender"))),Me=new Ee.TelemetryAppenderClient(De),Re=(0,me.resolveCommonProperties)(this.fileService,(0,M.release)(),(0,M.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],qe={appenders:[Me],commonProperties:Re,piiPaths:Te,sendErrorTelemetry:!0};pe.set(ge.ITelemetryService,new Y.SyncDescriptor(ke.TelemetryService,[qe]))}else pe.set(ge.ITelemetryService,Ae.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(pe)}initChannels(fe,ye,Se){const pe=i.ProxyChannel.fromService(fe.get(X.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",pe),ye.registerChannel(R.UserConfigurationFileServiceId,i.ProxyChannel.fromService(new R.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Pe=new Oe.UpdateChannel(fe.get(We.IUpdateService));ye.registerChannel("update",Pe);const De=i.ProxyChannel.fromService(fe.get(_.IIssueMainService));ye.registerChannel("issue",De);const Me=i.ProxyChannel.fromService(fe.get(re.IEncryptionMainService));ye.registerChannel("encryption",Me);const Re=i.ProxyChannel.fromService(fe.get(ue.ISignService));ye.registerChannel("sign",Re);const Te=i.ProxyChannel.fromService(fe.get(q.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",Te),this.nativeHostMainService=fe.get(oe.INativeHostMainService);const qe=i.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",qe),Se.then($e=>$e.registerChannel("nativeHost",qe));const Ge=i.ProxyChannel.fromService(fe.get(Fe.IWorkspacesService));ye.registerChannel("workspaces",Ge);const tt=i.ProxyChannel.fromService(fe.get(ie.IMenubarMainService));ye.registerChannel("menubar",tt);const it=i.ProxyChannel.fromService(fe.get(xe.IURLService));ye.registerChannel("url",it);const ht=i.ProxyChannel.fromService(fe.get(H.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",ht);const Ce=i.ProxyChannel.fromService(fe.get(ce.IWebviewManagerService));ye.registerChannel("webview",Ce);const nt=this._register(new ve.StorageDatabaseChannel(this.logService,fe.get(Ie.IStorageMainService)));ye.registerChannel("storage",nt),Se.then($e=>$e.registerChannel("storage",nt));const rt=i.ProxyChannel.fromService(fe.get(B.IExternalTerminalMainService));ye.registerChannel("externalTerminal",rt);const Qe=new Z.LogLevelChannel(fe.get(N.ILogService));ye.registerChannel("logLevel",Qe),Se.then($e=>$e.registerChannel("logLevel",Qe));const st=new Z.LoggerChannel(fe.get(N.ILoggerService));ye.registerChannel("logger",st),Se.then($e=>$e.registerChannel("logger",st));const ot=new A.ElectronExtensionHostDebugBroadcastChannel(fe.get(be.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",ot)}openFirstWindow(fe,ye){const Se=this.windowsMainService=fe.get(be.IWindowsMainService),pe=fe.get(xe.IURLService),Pe=fe.get(oe.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(_e=>{try{return{uri:c.URI.parse(_e),url:_e}}catch{return}}).filter(_e=>{if(!_e||this.shouldBlockURI(_e.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(_e.uri);return Je?(De.push(Je),!1):!0}),Re=this,Te=this.environmentMainService,qe=this.productService;pe.registerHandler({async handleURL(_e,Je){if(_e.scheme===qe.urlProtocol&&_e.path==="workspace"&&(_e=_e.with({authority:"file",path:c.URI.parse(_e.query).path,query:""})),Re.shouldBlockURI(_e))return!0;const vt=Re.getWindowOpenableFromProtocolLink(_e);if(vt){const[ft]=Se.open({context:5,cli:{...Te.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(m.isMacintosh&&Se.getWindowCount()===0){const[ft]=Se.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ne.getRemoteAuthority)(_e)});return await ft.ready(),pe.open(_e,Je)}return!1}});const Ge=this._register(new Ue.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),tt=new i.StaticRouter(_e=>Ge.getActiveClientId().then(Je=>_e===Je)),it=new et.URLHandlerRouter(tt),ht=ye.getChannel("urlHandler",it);pe.registerHandler(new et.URLHandlerChannelClient(ht)),this._register(new se.ElectronURLListener(Me,pe,Se,this.environmentMainService,this.productService));const Ce=this.environmentMainService.args,nt=global.macOpenFiles,rt=(0,ee.isLaunchedFromCli)(process.env)?0:4,Qe=Ce._.length,st=!!Ce["folder-uri"],ot=!!Ce["file-uri"],$e=Ce["skip-add-to-recently-opened"]===!0,dt=Ce.wait&&Ce.waitMarkerFilePath?c.URI.file(Ce.waitMarkerFilePath):void 0,pt=Ce.remote||void 0;return De.length>0?Se.open({context:rt,cli:Ce,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ce["new-window"]&&!Qe&&!st&&!ot?Se.open({context:rt,cli:Ce,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:$e,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):nt.length&&!Qe&&!st&&!ot?Se.open({context:1,cli:Ce,urisToOpen:nt.map(_e=>this.getWindowOpenableFromPathSync(_e)),noRecentEntry:$e,waitMarkerFileURI:dt,initialStartup:!0}):Se.open({context:rt,cli:Ce,forceNewWindow:Ce["new-window"]||!Qe&&Ce["unity-launch"],diffMode:Ce.diff,noRecentEntry:$e,waitMarkerFileURI:dt,gotoLineMode:Ce.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(fe){return!!(fe.authority===S.Schemas.file&&m.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,k.mnemonicButtonLabel)((0,a.localize)(0,null)),(0,k.mnemonicButtonLabel)((0,a.localize)(1,null))],defaultId:0,cancelId:1,message:(0,a.localize)(2,null,(0,k.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,a.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===S.Schemas.file){const ye=c.URI.file(fe.fsPath);return(0,Fe.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(fe.authority===S.Schemas.vscodeRemote){const ye=fe.path.indexOf(d.posix.sep,1);if(ye!==-1){const Se=fe.path.substring(1,ye),pe=fe.path.substring(ye),Pe=c.URI.from({scheme:S.Schemas.vscodeRemote,authority:Se,path:pe,query:fe.query,fragment:fe.fragment});return(0,Fe.hasWorkspaceFileExtension)(pe)?{workspaceUri:Pe}:/:[\d]+$/.test(pe)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(fe){try{if((0,L.statSync)(fe).isDirectory())return{folderUri:c.URI.file(fe)};if((0,Fe.hasWorkspaceFileExtension)(fe))return{workspaceUri:c.URI.file(fe)}}catch(ye){}return{fileUri:c.URI.file(fe)}}async afterWindowOpen(fe,ye){this.lifecycleMainService.phase=3;let Se=!1;(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0);const pe=fe.get(ge.ITelemetryService);this._register(ye.onDidError(({type:Me,details:Re})=>{let Te;switch(Me){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}(0,n.onUnexpectedError)(new Error(Te)),pe.publicLog2("sharedprocesserror",{type:Me,reason:Re?.reason,code:Re?.exitCode,visible:ye.isVisible(),shuttingdown:Se})}));const Pe=this.productService.win32MutexName;if(m.isWindows&&Pe)try{const Me=V.__$__nodeRequire("windows-mutex").Mutex,Re=new Me(Pe);(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Me){this.logService.error(Me)}v.protocol.registerHttpProtocol(S.Schemas.vscodeRemoteResource,(Me,Re)=>{Re({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=fe.get(We.IUpdateService);(De instanceof Ke.Win32UpdateService||De instanceof Xe.LinuxUpdateService||De instanceof Ye.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,t.stripComments)(Re))["enable-crash-reporter"]===void 0){const Ge=(0,Ae.getTelemetryLevel)(this.configurationService)>=1,tt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ge},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.generateUuid)()}"`,"}"],it=Re.substring(0,Re.length-2).concat(`,
`,tt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(it))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(fe,ye){try{return await(0,F.resolveShellEnv)(this.logService,fe,ye)}catch(Se){this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",(0,I.toErrorMessage)(Se))}return{}}stopTracingEventually(fe,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Se=fe.get(j.IDialogMainService);let pe=!1;const Pe=async Me=>{if(pe)return;pe=!0;const Re=await v.contentTracing.stopRecording((0,E.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):Se.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,a.localize)(4,null),detail:(0,a.localize)(5,null,Re),buttons:[(0,k.mnemonicButtonLabel)((0,a.localize)(6,null))],defaultId:0,noLink:!0},(0,y.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(ye.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};ut=he([te(2,O.IInstantiationService),te(3,N.ILogService),te(4,K.IEnvironmentMainService),te(5,$.ILifecycleMainService),te(6,P.IConfigurationService),te(7,de.IStateMainService),te(8,U.IFileService),te(9,le.IProductService)],ut),e.CodeApplication=ut}),define(Q[241],J([0,1,14,31,30,9,60,17,33,42,34,10,8,75,3,32,27,19,35,56,236,11,16,185,196,24,54,160,20,179,180,72,170,74,22,92,6,177,93,45,21,55,182,95,220,50,222,76,193,38,224,62,63,202]),function(V,e,v,L,M,D,I,n,f,w,t,k,b,S,d,m,E,y,c,h,o,u,i,l,s,r,a,g,p,P,R,A,W,j,x,re,K,ee,F,H,z,B,C,U,Y,O,T,_,q,X,$,N,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(ne){console.error(ne.message),v.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(ge=>console.error(ge));const[ne,ae,ue,de,ve,Ie,me]=this.createServices();try{try{await this.initServices(ue,de,ve)}catch(ge){throw this.handleStartupDataDirError(ue,me.nameLong,ge),ge}await ne.invokeFunction(async ge=>{const Ee=ge.get(K.ILogService),ke=ge.get(x.ILifecycleMainService),Ae=ge.get(p.IFileService),We=await this.claimInstance(Ee,ue,ke,ne,me,!0);return y.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Oe=>{Ee.warn(`Error writing main lockfile: ${Oe.stack}`)}),Ie.logger=new F.SpdLogLogger("main",(0,b.join)(ue.logsPath,"main.log"),!0,Ie.getLevel()),(0,w.once)(ke.onWillShutdown)(Oe=>{Ae.dispose(),de.dispose(),Oe.join(y.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),ne.createInstance(o.CodeApplication,We,ae).startup()})}catch(ge){ne.invokeFunction(this.quit,ge)}}createServices(){const ne=new j.ServiceCollection,ae={_serviceBrand:void 0,...H.default};ne.set(z.IProductService,ae);const ue=new r.EnvironmentMainService(this.resolveArgs(),ae),de=this.patchEnvironment(ue);ne.set(r.IEnvironmentMainService,ue);const ve=new re.BufferLogService,Ie=new K.MultiplexLogService([new K.ConsoleMainLogger((0,K.getLogLevel)(ue)),ve]);process.once("exit",()=>Ie.dispose()),ne.set(K.ILogService,Ie);const me=new P.FileService(Ie);ne.set(p.IFileService,me);const ge=new R.DiskFileSystemProvider(Ie);me.registerProvider(k.Schemas.file,ge),ne.set(K.ILoggerService,new ee.LoggerService(Ie,me));const Ee=new l.ConfigurationService(ue.settingsResource,me);ne.set(i.IConfigurationService,Ee),ne.set(x.ILifecycleMainService,new A.SyncDescriptor(x.LifecycleMainService));const ke=new $.StateMainService(ue,Ie,me);return ne.set(X.IStateMainService,ke),ne.set(O.IRequestService,new A.SyncDescriptor(T.RequestMainService)),ne.set(Z.IThemeMainService,new A.SyncDescriptor(Z.ThemeMainService)),ne.set(_.ISignService,new A.SyncDescriptor(q.SignService)),ne.set(U.ITunnelService,new A.SyncDescriptor(Y.TunnelService)),ne.set(B.IProtocolMainService,new A.SyncDescriptor(C.ProtocolMainService)),[new W.InstantiationService(ne,!0),de,ue,Ee,ke,ve,ae]}patchEnvironment(ne){const ae={VSCODE_IPC_HOOK:ne.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const de=process.env[ue];typeof de=="string"&&(ae[ue]=de)}),Object.assign(process.env,ae),ae}initServices(ne,ae,ue){return D.Promises.settled([Promise.all([ne.extensionsPath,ne.codeCachePath,ne.logsPath,ne.globalStorageHome.fsPath,ne.workspaceStorageHome.fsPath,ne.backupHome].map(de=>de?y.Promises.mkdir(de,{recursive:!0}):void 0)),ae.initialize(),ue.init()])}async claimInstance(ne,ae,ue,de,ve,Ie){let me;try{(0,S.mark)("code/willStartMainServer"),me=await(0,h.serve)(ae.mainIPCHandle),(0,S.mark)("code/didStartMainServer"),(0,w.once)(ue.onWillShutdown)(()=>me.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ae,ve.nameLong,ge),ge;let Ee;try{Ee=await(0,h.connect)(ae.mainIPCHandle,"main")}catch(We){if(!Ie||d.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,ve.nameShort),(0,u.localize)(1,null),ve.nameLong),We;try{(0,L.unlinkSync)(ae.mainIPCHandle)}catch(Oe){throw ne.warn("Could not delete obsolete instance handle",Oe),Oe}return this.claimInstance(ne,ae,ue,de,ve,!1)}if(ae.extensionTestsLocationURI&&!ae.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ne.error(We),Ee.dispose(),new Error(We)}let ke;!ae.args.wait&&!ae.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,ve.nameShort),(0,u.localize)(3,null),ve.nameLong)},1e4));const Ae=c.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0});if(ae.args.status)return de.invokeFunction(async()=>{const We=new s.DiagnosticsService(N.NullTelemetryService,ve),Oe=await Ae.getMainProcessInfo(),Ye=await Ae.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Xe=await We.getDiagnostics(Oe,Ye);throw console.log(Xe),new n.ExpectedError});throw d.isWindows&&await this.windowsAllowSetForegroundWindow(Ae,ne),ne.trace("Sending env to running instance..."),await Ae.start(ae.args,process.env),Ee.dispose(),ke&&clearTimeout(ke),new n.ExpectedError("Sent env to running instance. Terminating...")}if(ae.args.status)throw ne.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),me}handleStartupDataDirError(ne,ae,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const de=(0,M.coalesce)([ne.userDataPath,ne.extensionsPath,h.XDG_RUNTIME_DIR]).map(ve=>(0,t.getPathLabel)(ve,ne));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,I.toErrorMessage)(ue),de.join(`
`)),ae)}}showStartupWarningDialog(ne,ae,ue){v.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,t.mnemonicButtonLabel)((0,u.localize)(6,null))],message:ne,detail:ae,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ne,ae){if(d.isWindows){const ue=await ne.getMainProcessId();ae.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((de,ve)=>{V(["windows-foreground-love"],de,ve)})).allowSetForegroundWindow(ue)}catch(de){ae.error(de)}}}quit(ne,ae){const ue=ne.get(K.ILogService),de=ne.get(x.ILifecycleMainService);let ve=0;ae&&(ae.isExpected?ae.message&&ue.trace(ae.message):(ve=1,ae.stack?ue.error(ae.stack):ue.error(`Startup error: ${ae.toString()}`))),de.kill(ve)}resolveArgs(){const ne=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(ne.wait&&!ne.waitMarkerFilePath){const ae=(0,g.createWaitMarkerFile)(ne.verbose);ae&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",ae),ne.waitMarkerFilePath=ae)}return ne}validatePaths(ne){if(ne["open-url"]&&(ne._urls=ne._,ne._=[]),!ne.remote){const ae=this.doValidatePaths(ne._,ne.goto);ne._=ae}return ne}doValidatePaths(ne,ae){const ue=(0,m.cwd)(),de=ne.map(me=>{let ge=String(me),Ee;ae&&(Ee=(0,f.parseLineAndColumnAware)(ge),ge=Ee.path),ge&&(ge=this.preparePath(ue,ge));const ke=(0,f.sanitizeFilePath)(ge,ue),Ae=(0,b.basename)(ke);return Ae&&!(0,f.isValidBasename)(Ae)?null:ae&&Ee?(Ee.path=ke,this.toPath(Ee)):ke}),ve=d.isWindows||d.isMacintosh,Ie=(0,M.distinct)(de,me=>me&&ve?me.toLowerCase():me||"");return(0,M.coalesce)(Ie)}preparePath(ne,ae){return d.isWindows&&(ae=(0,E.rtrim)(ae,'"')),ae=(0,E.trim)((0,E.trim)(ae," "),"	"),d.isWindows&&(ae=(0,b.resolve)(ne,ae),ae=(0,E.rtrim)(ae,".")),ae}toPath(ne){const ae=[ne.path];return typeof ne.line=="number"&&ae.push(String(ne.line)),typeof ne.column=="number"&&ae.push(String(ne.column)),ae.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/34eeebdd66033633ac22efd5fab928ae37916168/core/vs/code/electron-main/main.js.map
