/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(se){for(var e=[],h=0,M=se.length;h<M;h++)e[h]=be[se[h]];return e};define(be[42],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=h}),define(be[52],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const h=Object.prototype.hasOwnProperty;function M(t){const y=[];for(let n in t)h.call(t,n)&&y.push(t[n]);return y}e.values=M;function E(t,y){for(let n in t)if(h.call(t,n)&&y({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=E;function A(t,y){const n=Object.create(null);for(const f of t){const s=y(f);let c=n[s];c||(c=n[s]=[]),c.push(f)}return n}e.groupBy=A;function F(t){const y=Object.create(null);return t&&t.forEach((n,f)=>{y[f]=n}),y}e.fromMap=F;function C(t,y){const n=[],f=[];for(let s of t)y.has(s)||n.push(s);for(let s of y)t.has(s)||f.push(s);return{removed:n,added:f}}e.diffSets=C;function S(t,y){const n=[],f=[];for(let[s,c]of t)y.has(s)||n.push(c);for(let[s,c]of y)t.has(s)||f.push(c);return{removed:n,added:f}}e.diffMaps=S;class T{constructor(){this.map=new Map}add(y,n){let f=this.map.get(y);f||(f=new Set,this.map.set(y,f)),f.add(n)}delete(y,n){const f=this.map.get(y);!f||(f.delete(n),f.size===0&&this.map.delete(y))}forEach(y,n){const f=this.map.get(y);!f||f.forEach(n)}}e.SetMap=T}),define(be[53],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function h(F){return(C,S,T)=>{let t=null,y=null;if(typeof T.value=="function"?(t="value",y=T.value):typeof T.get=="function"&&(t="get",y=T.get),!y)throw new Error("not supported");T[t]=F(y,S)}}e.createDecorator=h;function M(F,C,S){let T=null,t=null;if(typeof S.value=="function"?(T="value",t=S.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(T="get",t=S.get),!t)throw new Error("not supported");const y=`$memoize$${C}`;S[T]=function(...n){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[y]}}e.memoize=M;function E(F,C,S){return h((T,t)=>{const y=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...f){this[n]||(this[n]=S?S():void 0),clearTimeout(this[y]),C&&(this[n]=C(this[n],...f),f=[this[n]]),this[y]=setTimeout(()=>{T.apply(this,f),this[n]=S?S():void 0},F)}})}e.debounce=E;function A(F,C,S){return h((T,t)=>{const y=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,f=`$throttle$lastRun$${t}`,s=`$throttle$pending$${t}`;return function(...c){if(this[n]||(this[n]=S?S():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[n]=C(this[n],...c)),this[s])return;const p=this[f]+F;p<=Date.now()?(this[f]=Date.now(),T.apply(this,[this[n]]),this[n]=S?S():void 0):(this[s]=!0,this[y]=setTimeout(()=>{this[s]=!1,this[f]=Date.now(),T.apply(this,[this[n]]),this[n]=S?S():void 0},p-Date.now()))}})}e.throttle=A}),define(be[14],Ee([0,1,16]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(j,le=0){return j[j.length-(1+le)]}e.tail=M;function E(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=E;function A(j,le,ee=(ve,Re)=>ve===Re){if(j===le)return!0;if(!j||!le||j.length!==le.length)return!1;for(let ve=0,Re=j.length;ve<Re;ve++)if(!ee(j[ve],le[ve]))return!1;return!0}e.equals=A;function F(j,le,ee){let ve=0,Re=j.length-1;for(;ve<=Re;){const Fe=(ve+Re)/2|0,Oe=ee(j[Fe],le);if(Oe<0)ve=Fe+1;else if(Oe>0)Re=Fe-1;else return Fe}return-(ve+1)}e.binarySearch=F;function C(j,le){let ee=0,ve=j.length;if(ve===0)return 0;for(;ee<ve;){const Re=Math.floor((ee+ve)/2);le(j[Re])?ve=Re:ee=Re+1}return ee}e.findFirstInSorted=C;function S(j,le,ee){if(j=j|0,j>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Re=[],Fe=[],Oe=[];for(let Ke of le){const je=ee(Ke,ve);je<0?Re.push(Ke):je>0?Fe.push(Ke):Oe.push(Ke)}return j<Re.length?S(j,Re,ee):j<Re.length+Oe.length?Oe[0]:S(j-(Re.length+Oe.length),Fe,ee)}e.quickSelect=S;function T(j,le){const ee=[];let ve;for(const Re of j.slice(0).sort(le))!ve||le(ve[0],Re)!==0?(ve=[Re],ee.push(ve)):ve.push(Re);return ee}e.groupBy=T;function t(j,le,ee){const ve=[];function Re(Ke,je,Ve){if(je===0&&Ve.length===0)return;const U=ve[ve.length-1];U&&U.start+U.deleteCount===Ke?(U.deleteCount+=je,U.toInsert.push(...Ve)):ve.push({start:Ke,deleteCount:je,toInsert:Ve})}let Fe=0,Oe=0;for(;;){if(Fe===j.length){Re(Fe,0,le.slice(Oe));break}if(Oe===le.length){Re(Fe,j.length-Fe,[]);break}const Ke=j[Fe],je=le[Oe],Ve=ee(Ke,je);Ve===0?(Fe+=1,Oe+=1):Ve<0?(Re(Fe,1,[]),Fe+=1):Ve>0&&(Re(Fe,0,[je]),Oe+=1)}return ve}e.sortedDiff=t;function y(j,le,ee){const ve=t(j,le,ee),Re=[],Fe=[];for(const Oe of ve)Re.push(...j.slice(Oe.start,Oe.start+Oe.deleteCount)),Fe.push(...Oe.toInsert);return{removed:Re,added:Fe}}e.delta=y;function n(j,le,ee){if(ee===0)return[];const ve=j.slice(0,ee).sort(le);return s(j,le,ve,ee,j.length),ve}e.top=n;function f(j,le,ee,ve,Re){return ee===0?Promise.resolve([]):new Promise((Fe,Oe)=>{(async()=>{const Ke=j.length,je=j.slice(0,ee).sort(le);for(let Ve=ee,U=Math.min(ee+ve,Ke);Ve<Ke;Ve=U,U=Math.min(U+ve,Ke)){if(Ve>ee&&await new Promise(Q=>setTimeout(Q)),Re&&Re.isCancellationRequested)throw(0,h.canceled)();s(j,le,je,Ve,U)}return je})().then(Fe,Oe)})}e.topAsync=f;function s(j,le,ee,ve,Re){for(const Fe=ee.length;ve<Re;ve++){const Oe=j[ve];if(le(Oe,ee[Fe-1])<0){ee.pop();const Ke=C(ee,je=>le(Oe,je)<0);ee.splice(Ke,0,Oe)}}}function c(j){return j.filter(le=>!!le)}e.coalesce=c;function p(j){let le=0;for(let ee=0;ee<j.length;ee++)j[ee]&&(j[le]=j[ee],le+=1);j.length=le}e.coalesceInPlace=p;function P(j,le,ee){j.splice(ee,0,j.splice(le,1)[0])}e.move=P;function D(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=D;function l(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=l;function u(j,le=ee=>ee){const ee=new Set;return j.filter(ve=>{const Re=le(ve);return ee.has(Re)?!1:(ee.add(Re),!0)})}e.distinct=u;function _(j){const le=Object.create(null);return ee=>{const ve=j(ee);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=_;function i(j,le){const ee=g(j,le);if(ee!==-1)return j[ee]}e.findLast=i;function g(j,le){for(let ee=j.length-1;ee>=0;ee--){const ve=j[ee];if(le(ve))return ee}return-1}e.lastIndex=g;function a(j,le){return j.length>0?j[0]:le}e.firstOrDefault=a;function r(j,le,ee=(ve,Re)=>ve===Re){let ve=0;for(let Re=0,Fe=Math.min(j.length,le.length);Re<Fe&&ee(j[Re],le[Re]);Re++)ve++;return ve}e.commonPrefixLength=r;function v(j){return[].concat(...j)}e.flatten=v;function o(j,le){let ee=typeof le=="number"?j:0;typeof le=="number"?ee=j:(ee=0,le=j);const ve=[];if(ee<=le)for(let Re=ee;Re<le;Re++)ve.push(Re);else for(let Re=ee;Re>le;Re--)ve.push(Re);return ve}e.range=o;function d(j,le,ee){return j.reduce((ve,Re)=>(ve[le(Re)]=ee?ee(Re):Re,ve),Object.create(null))}e.index=d;function w(j,le){return j.push(le),()=>I(j,le)}e.insert=w;function I(j,le){const ee=j.indexOf(le);if(ee>-1)return j.splice(ee,1),le}e.remove=I;function m(j,le,ee){const ve=j.slice(0,le),Re=j.slice(le);return ve.concat(ee,Re)}e.arrayInsert=m;function k(j,le){let ee;if(typeof le=="number"){let ve=le;ee=()=>{const Re=Math.sin(ve++)*179426549;return Re-Math.floor(Re)}}else ee=Math.random;for(let ve=j.length-1;ve>0;ve-=1){const Re=Math.floor(ee()*(ve+1)),Fe=j[ve];j[ve]=j[Re],j[Re]=Fe}}e.shuffle=k;function R(j,le){const ee=j.indexOf(le);ee>-1&&(j.splice(ee,1),j.unshift(le))}e.pushToStart=R;function L(j,le){const ee=j.indexOf(le);ee>-1&&(j.splice(ee,1),j.push(le))}e.pushToEnd=L;function b(j,le){return Array.isArray(j)?j.map(le):le(j)}e.mapArrayOrNot=b;function B(j){return Array.isArray(j)?j:[j]}e.asArray=B;function $(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=$;function x(j,le){for(const ee of j){const ve=le(ee);if(ve!==void 0)return ve}}e.mapFind=x;function K(j,le,ee){const ve=W(j,le),Re=j.length,Fe=ee.length;j.length=Re+Fe;for(let Oe=Re-1;Oe>=ve;Oe--)j[Oe+Fe]=j[Oe];for(let Oe=0;Oe<Fe;Oe++)j[Oe+ve]=ee[Oe]}e.insertInto=K;function H(j,le,ee,ve){const Re=W(j,le),Fe=j.splice(Re,ee);return K(j,Re,ve),Fe}e.splice=H;function W(j,le){return le<0?Math.max(le+j.length,0):Math.min(le,j.length)}function ne(j,le){let ee=Number.MAX_SAFE_INTEGER,ve=0;return j.forEach((Re,Fe)=>{const Oe=le(Re);Oe<ee&&(ee=Oe,ve=Fe)}),ve}e.minIndex=ne;function V(j,le){let ee=Number.MIN_SAFE_INTEGER,ve=0;return j.forEach((Re,Fe)=>{const Oe=le(Re);Oe>ee&&(ee=Oe,ve=Fe)}),ve}e.maxIndex=V;class J{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let ee=this.firstIdx;for(;ee<this.items.length&&le(this.items[ee]);)ee++;const ve=ee===this.firstIdx?null:this.items.slice(this.firstIdx,ee);return this.firstIdx=ee,ve}takeFromEndWhile(le){let ee=this.lastIdx;for(;ee>=0&&le(this.items[ee]);)ee--;const ve=ee===this.lastIdx?null:this.items.slice(ee+1,this.lastIdx+1);return this.lastIdx=ee,ve}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=J}),define(be[54],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(be[102],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function F(i,g=!1){let a=0,r=i.length,v="",o=0,d=16,w=0;function I($){let x=0,K=0;for(;x<$;){const H=i.charCodeAt(a);if(H>=48&&H<=57)K=K*16+H-48;else if(H>=65&&H<=70)K=K*16+H-65+10;else if(H>=97&&H<=102)K=K*16+H-97+10;else break;a++,x++}return x<$&&(K=-1),K}function m($){a=$,v="",o=0,d=16,w=0}function k(){const $=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&T(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&T(i.charCodeAt(a)))for(a++;a<i.length&&T(i.charCodeAt(a));)a++;else return w=3,i.substring($,a);let x=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&T(i.charCodeAt(a))){for(a++;a<i.length&&T(i.charCodeAt(a));)a++;x=a}else w=3;return i.substring($,x)}function R(){let $="",x=a;for(;;){if(a>=r){$+=i.substring(x,a),w=2;break}const K=i.charCodeAt(a);if(K===34){$+=i.substring(x,a),a++;break}if(K===92){if($+=i.substring(x,a),a++,a>=r){w=2;break}switch(i.charCodeAt(a++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const W=I(4);W>=0?$+=String.fromCharCode(W):w=4;break;default:w=5}x=a;continue}if(K>=0&&K<=31)if(S(K)){$+=i.substring(x,a),w=2;break}else w=6;a++}return $}function L(){if(v="",w=0,o=a,a>=r)return o=r,d=17;let $=i.charCodeAt(a);if(C($)){do a++,v+=String.fromCharCode($),$=i.charCodeAt(a);while(C($));return d=15}if(S($))return a++,v+=String.fromCharCode($),$===13&&i.charCodeAt(a)===10&&(a++,v+=`
`),d=14;switch($){case 123:return a++,d=1;case 125:return a++,d=2;case 91:return a++,d=3;case 93:return a++,d=4;case 58:return a++,d=6;case 44:return a++,d=5;case 34:return a++,v=R(),d=10;case 47:const x=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<r&&!S(i.charCodeAt(a));)a++;return v=i.substring(x,a),d=12}if(i.charCodeAt(a+1)===42){a+=2;const K=r-1;let H=!1;for(;a<K;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,H=!0;break}a++}return H||(a++,w=1),v=i.substring(x,a),d=13}return v+=String.fromCharCode($),a++,d=16;case 45:if(v+=String.fromCharCode($),a++,a===r||!T(i.charCodeAt(a)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=k(),d=11;default:for(;a<r&&b($);)a++,$=i.charCodeAt(a);if(o!==a){switch(v=i.substring(o,a),v){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return v+=String.fromCharCode($),a++,d=16}}function b($){if(C($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let $;do $=L();while($>=12&&$<=15);return $}return{setPosition:m,getPosition:()=>a,scan:g?B:L,getToken:()=>d,getTokenValue:()=>v,getTokenOffset:()=>o,getTokenLength:()=>a-o,getTokenError:()=>w}}e.createScanner=F;function C(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function T(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function y(i,g){const a=[],r=new Object;let v;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function w(I,m,k,R){o.value=I,o.offset=m,o.length=k,o.type=R,o.colonOffset=void 0,v=o}try{l(i,{onObjectBegin:(I,m)=>{if(g<=I)throw r;v=void 0,d=g>I,a.push("")},onObjectProperty:(I,m,k)=>{if(g<m||(w(I,m,k,"property"),a[a.length-1]=I,g<=m+k))throw r},onObjectEnd:(I,m)=>{if(g<=I)throw r;v=void 0,a.pop()},onArrayBegin:(I,m)=>{if(g<=I)throw r;v=void 0,a.push(0)},onArrayEnd:(I,m)=>{if(g<=I)throw r;v=void 0,a.pop()},onLiteralValue:(I,m,k)=>{if(g<m||(w(I,m,k,_(I)),g<=m+k))throw r},onSeparator:(I,m,k)=>{if(g<=m)throw r;if(I===":"&&v&&v.type==="property")v.colonOffset=m,d=!1,v=void 0;else if(I===","){const R=a[a.length-1];typeof R=="number"?a[a.length-1]=R+1:(d=!0,a[a.length-1]=""),v=void 0}}})}catch(I){if(I!==r)throw I}return{path:a,previousNode:v,isAtPropertyKey:d,matches:I=>{let m=0;for(let k=0;m<I.length&&k<a.length;k++)if(I[m]===a[k]||I[m]==="*")m++;else if(I[m]!=="**")return!1;return m===I.length}}}e.getLocation=y;function n(i,g=[],a=A.DEFAULT){let r=null,v=[];const o=[];function d(I){Array.isArray(v)?v.push(I):r!==null&&(v[r]=I)}return l(i,{onObjectBegin:()=>{const I={};d(I),o.push(v),v=I,r=null},onObjectProperty:I=>{r=I},onObjectEnd:()=>{v=o.pop()},onArrayBegin:()=>{const I=[];d(I),o.push(v),v=I,r=null},onArrayEnd:()=>{v=o.pop()},onLiteralValue:d,onError:(I,m,k)=>{g.push({error:I,offset:m,length:k})}},a),v[0]}e.parse=n;function f(i,g=[],a=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(I){r.type==="property"&&(r.length=I-r.offset,r=r.parent)}function o(I){return r.children.push(I),I}l(i,{onObjectBegin:I=>{r=o({type:"object",offset:I,length:-1,parent:r,children:[]})},onObjectProperty:(I,m,k)=>{r=o({type:"property",offset:m,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:I,offset:m,length:k,parent:r})},onObjectEnd:(I,m)=>{r.length=I+m-r.offset,r=r.parent,v(I+m)},onArrayBegin:(I,m)=>{r=o({type:"array",offset:I,length:-1,parent:r,children:[]})},onArrayEnd:(I,m)=>{r.length=I+m-r.offset,r=r.parent,v(I+m)},onLiteralValue:(I,m,k)=>{o({type:_(I),offset:m,length:k,parent:r,value:I}),v(m+k)},onSeparator:(I,m,k)=>{r.type==="property"&&(I===":"?r.colonOffset=m:I===","&&v(m))},onError:(I,m,k)=>{g.push({error:I,offset:m,length:k})}},a);const w=r.children[0];return w&&delete w.parent,w}e.parseTree=f;function s(i,g){if(!i)return;let a=i;for(let r of g)if(typeof r=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let v=!1;for(const o of a.children)if(Array.isArray(o.children)&&o.children[0].value===r){a=o.children[1],v=!0;break}if(!v)return}else{const v=r;if(a.type!=="array"||v<0||!Array.isArray(a.children)||v>=a.children.length)return;a=a.children[v]}return a}e.findNodeAtLocation=s;function c(i){if(!i.parent||!i.parent.children)return[];const g=c(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;g.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&g.push(a)}return g}e.getNodePath=c;function p(i){switch(i.type){case"array":return i.children.map(p);case"object":const g=Object.create(null);for(let a of i.children){const r=a.children[1];r&&(g[a.children[0].value]=p(r))}return g;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=p;function P(i,g,a=!1){return g>=i.offset&&g<i.offset+i.length||a&&g===i.offset+i.length}e.contains=P;function D(i,g,a=!1){if(P(i,g,a)){const r=i.children;if(Array.isArray(r))for(let v=0;v<r.length&&r[v].offset<=g;v++){const o=D(r[v],g,a);if(o)return o}return i}}e.findNodeAtOffset=D;function l(i,g,a=A.DEFAULT){const r=F(i,!1);function v(ee){return ee?()=>ee(r.getTokenOffset(),r.getTokenLength()):()=>!0}function o(ee){return ee?ve=>ee(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const d=v(g.onObjectBegin),w=o(g.onObjectProperty),I=v(g.onObjectEnd),m=v(g.onArrayBegin),k=v(g.onArrayEnd),R=o(g.onLiteralValue),L=o(g.onSeparator),b=v(g.onComment),B=o(g.onError),$=a&&a.disallowComments,x=a&&a.allowTrailingComma;function K(){for(;;){const ee=r.scan();switch(r.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(ee){case 12:case 13:$?H(10):b();break;case 16:H(1);break;case 15:case 14:break;default:return ee}}}function H(ee,ve=[],Re=[]){if(B(ee),ve.length+Re.length>0){let Fe=r.getToken();for(;Fe!==17;){if(ve.indexOf(Fe)!==-1){K();break}else if(Re.indexOf(Fe)!==-1)break;Fe=K()}}}function W(ee){const ve=r.getTokenValue();return ee?R(ve):w(ve),K(),!0}function ne(){switch(r.getToken()){case 11:let ee=0;try{ee=JSON.parse(r.getTokenValue()),typeof ee!="number"&&(H(2),ee=0)}catch(ve){H(2)}R(ee);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return K(),!0}function V(){return r.getToken()!==10?(H(3,[],[2,5]),!1):(W(!1),r.getToken()===6?(L(":"),K(),le()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function J(){d(),K();let ee=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ee||H(4,[],[]),L(","),K(),r.getToken()===2&&x)break}else ee&&H(6,[],[]);V()||H(4,[],[2,5]),ee=!0}return I(),r.getToken()!==2?H(7,[2],[]):K(),!0}function j(){m(),K();let ee=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ee||H(4,[],[]),L(","),K(),r.getToken()===4&&x)break}else ee&&H(6,[],[]);le()||H(4,[],[4,5]),ee=!0}return k(),r.getToken()!==4?H(8,[4],[]):K(),!0}function le(){switch(r.getToken()){case 3:return j();case 1:return J();case 10:return W(!0);default:return ne()}}return K(),r.getToken()===17?a.allowEmptyContent?!0:(H(4,[],[]),!1):le()?(r.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=l;function u(i,g){let a=F(i),r=[],v,o=0,d;do switch(d=a.getPosition(),v=a.scan(),v){case 12:case 13:case 17:o!==d&&r.push(i.substring(o,d)),g!==void 0&&r.push(a.getTokenValue().replace(/[^\r\n]/g,g)),o=a.getPosition();break}while(v!==17);return r.join("")}e.stripComments=u;function _(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=_}),define(be[103],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new h(()=>E(this.getValue()))}}e.Lazy=h}),function(se,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(se=typeof globalThis!="undefined"?globalThis:se||self,se.marked=e())}(this,function(){"use strict";function se(Pe,Se){for(var Ce=0;Ce<Se.length;Ce++){var ie=Se[Ce];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(Pe,ie.key,ie)}}function e(Pe,Se,Ce){return Se&&se(Pe.prototype,Se),Ce&&se(Pe,Ce),Pe}function h(Pe,Se){if(!!Pe){if(typeof Pe=="string")return M(Pe,Se);var Ce=Object.prototype.toString.call(Pe).slice(8,-1);if(Ce==="Object"&&Pe.constructor&&(Ce=Pe.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Pe);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Pe,Se)}}function M(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var Ce=0,ie=new Array(Se);Ce<Se;Ce++)ie[Ce]=Pe[Ce];return ie}function E(Pe,Se){var Ce=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Ce)return(Ce=Ce.call(Pe)).next.bind(Ce);if(Array.isArray(Pe)||(Ce=h(Pe))||Se&&Pe&&typeof Pe.length=="number"){Ce&&(Pe=Ce);var ie=0;return function(){return ie>=Pe.length?{done:!0}:{done:!1,value:Pe[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Pe){A.exports.defaults=Pe}A.exports={defaults:F(),getDefaults:F,changeDefaults:C};var S=/[&<>"']/,T=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(Se){return n[Se]};function s(Pe,Se){if(Se){if(S.test(Pe))return Pe.replace(T,f)}else if(t.test(Pe))return Pe.replace(y,f);return Pe}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(Pe){return Pe.replace(c,function(Se,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var P=/(^|[^\[])\^/g;function D(Pe,Se){Pe=Pe.source||Pe,Se=Se||"";var Ce={replace:function(ue,me){return me=me.source||me,me=me.replace(P,"$1"),Pe=Pe.replace(ue,me),Ce},getRegex:function(){return new RegExp(Pe,Se)}};return Ce}var l=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function _(Pe,Se,Ce){if(Pe){var ie;try{ie=decodeURIComponent(p(Ce)).replace(l,"").toLowerCase()}catch(ue){return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}Se&&!u.test(Ce)&&(Ce=v(Se,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(ue){return null}return Ce}var i={},g=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Pe,Se){i[" "+Pe]||(g.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=I(Pe,"/",!0)),Pe=i[" "+Pe];var Ce=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ce?Se:Pe.replace(a,"$1")+Se:Se.charAt(0)==="/"?Ce?Se:Pe.replace(r,"$1")+Se:Pe+Se}var o={exec:function(){}};function d(Pe){for(var Se=1,Ce,ie;Se<arguments.length;Se++){Ce=arguments[Se];for(ie in Ce)Object.prototype.hasOwnProperty.call(Ce,ie)&&(Pe[ie]=Ce[ie])}return Pe}function w(Pe,Se){var Ce=Pe.replace(/\|/g,function(me,fe,Ie){for(var xe=!1,Ne=fe;--Ne>=0&&Ie[Ne]==="\\";)xe=!xe;return xe?"|":" |"}),ie=Ce.split(/ \|/),ue=0;if(ie[0].trim()||ie.shift(),ie[ie.length-1].trim()||ie.pop(),ie.length>Se)ie.splice(Se);else for(;ie.length<Se;)ie.push("");for(;ue<ie.length;ue++)ie[ue]=ie[ue].trim().replace(/\\\|/g,"|");return ie}function I(Pe,Se,Ce){var ie=Pe.length;if(ie===0)return"";for(var ue=0;ue<ie;){var me=Pe.charAt(ie-ue-1);if(me===Se&&!Ce)ue++;else if(me!==Se&&Ce)ue++;else break}return Pe.substr(0,ie-ue)}function m(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var Ce=Pe.length,ie=0,ue=0;ue<Ce;ue++)if(Pe[ue]==="\\")ue++;else if(Pe[ue]===Se[0])ie++;else if(Pe[ue]===Se[1]&&(ie--,ie<0))return ue;return-1}function k(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Pe,Se){if(Se<1)return"";for(var Ce="";Se>1;)Se&1&&(Ce+=Pe),Se>>=1,Pe+=Pe;return Ce+Pe}var L={escape:s,unescape:p,edit:D,cleanUrl:_,resolveUrl:v,noopTest:o,merge:d,splitCells:w,rtrim:I,findClosingBracket:m,checkSanitizeDeprecation:k,repeatString:R},b=A.exports.defaults,B=L.rtrim,$=L.splitCells,x=L.escape,K=L.findClosingBracket;function H(Pe,Se,Ce,ie){var ue=Se.href,me=Se.title?x(Se.title):null,fe=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){ie.state.inLink=!0;var Ie={type:"link",raw:Ce,href:ue,title:me,text:fe,tokens:ie.inlineTokens(fe,[])};return ie.state.inLink=!1,Ie}else return{type:"image",raw:Ce,href:ue,title:me,text:x(fe)}}function W(Pe,Se){var Ce=Pe.match(/^(\s+)(?:```)/);if(Ce===null)return Se;var ie=Ce[1];return Se.split(`
`).map(function(ue){var me=ue.match(/^\s+/);if(me===null)return ue;var fe=me[0];return fe.length>=ie.length?ue.slice(ie.length):ue}).join(`
`)}var ne=function(){function Pe(Ce){this.options=Ce||b}var Se=Pe.prototype;return Se.space=function(ie){var ue=this.rules.block.newline.exec(ie);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},Se.code=function(ie){var ue=this.rules.block.code.exec(ie);if(ue){var me=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?me:B(me,`
`)}}},Se.fences=function(ie){var ue=this.rules.block.fences.exec(ie);if(ue){var me=ue[0],fe=W(me,ue[3]||"");return{type:"code",raw:me,lang:ue[2]?ue[2].trim():ue[2],text:fe}}},Se.heading=function(ie){var ue=this.rules.block.heading.exec(ie);if(ue){var me=ue[2].trim();if(/#$/.test(me)){var fe=B(me,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(me=fe.trim())}var Ie={type:"heading",raw:ue[0],depth:ue[1].length,text:me,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},Se.hr=function(ie){var ue=this.rules.block.hr.exec(ie);if(ue)return{type:"hr",raw:ue[0]}},Se.blockquote=function(ie){var ue=this.rules.block.blockquote.exec(ie);if(ue){var me=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},Se.list=function(ie){var ue=this.rules.block.list.exec(ie);if(ue){var me,fe,Ie,xe,Ne,qe,it,Le,de,ge,X=ue[1].trim(),z=X.length>1,we={type:"list",raw:"",ordered:z,start:z?+X.slice(0,-1):"",loose:!1,items:[]};X=z?"\\d{1,9}\\"+X.slice(-1):"\\"+X,this.options.pedantic&&(X=z?X:"[*+-]");for(var ke=new RegExp("^( {0,3}"+X+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ie&&!(this.rules.block.hr.test(ie)||!(ue=ke.exec(ie)));){de=ue[2].split(`
`),this.options.pedantic?(xe=2,ge=de[0].trimLeft()):(xe=ue[2].search(/[^ ]/),xe=ue[1].length+(xe>4?1:xe),ge=de[0].slice(xe-ue[1].length)),qe=!1,me=ue[0],!de[0]&&/^ *$/.test(de[1])&&(me=ue[1]+de.slice(0,2).join(`
`)+`
`,we.loose=!0,de=[]);var Je=new RegExp("^ {0,"+Math.min(3,xe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Ne=1;Ne<de.length;Ne++){if(Le=de[Ne],this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Je.test(Le)){me=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}if(!qe){Le.trim()||(qe=!0),Le.search(/[^ ]/)>=xe?ge+=`
`+Le.slice(xe):ge+=`
`+Le;continue}if(Le.search(/[^ ]/)>=xe||!Le.trim()){ge+=`
`+Le.slice(xe);continue}else{me=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}}we.loose||(it?we.loose=!0:/\n *\n *$/.test(me)&&(it=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(ge),fe&&(Ie=fe[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:me,task:!!fe,checked:Ie,loose:!1,text:ge}),we.raw+=me,ie=ie.slice(me.length)}we.items[we.items.length-1].raw=me.trimRight(),we.items[we.items.length-1].text=ge.trimRight(),we.raw=we.raw.trimRight();var Ue=we.items.length;for(Ne=0;Ne<Ue;Ne++)this.lexer.state.top=!1,we.items[Ne].tokens=this.lexer.blockTokens(we.items[Ne].text,[]),we.items[Ne].tokens.some(function(ct){return ct.type==="space"})&&(we.loose=!0,we.items[Ne].loose=!0);return we}},Se.html=function(ie){var ue=this.rules.block.html.exec(ie);if(ue){var me={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(me.type="paragraph",me.text=this.options.sanitizer?this.options.sanitizer(ue[0]):x(ue[0]),me.tokens=[],this.lexer.inline(me.text,me.tokens)),me}},Se.def=function(ie){var ue=this.rules.block.def.exec(ie);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var me=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ue[0],href:ue[2],title:ue[3]}}},Se.table=function(ie){var ue=this.rules.block.table.exec(ie);if(ue){var me={type:"table",header:$(ue[1]).map(function(it){return{text:it}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ue[0];var fe=me.align.length,Ie,xe,Ne,qe;for(Ie=0;Ie<fe;Ie++)/^ *-+: *$/.test(me.align[Ie])?me.align[Ie]="right":/^ *:-+: *$/.test(me.align[Ie])?me.align[Ie]="center":/^ *:-+ *$/.test(me.align[Ie])?me.align[Ie]="left":me.align[Ie]=null;for(fe=me.rows.length,Ie=0;Ie<fe;Ie++)me.rows[Ie]=$(me.rows[Ie],me.header.length).map(function(it){return{text:it}});for(fe=me.header.length,xe=0;xe<fe;xe++)me.header[xe].tokens=[],this.lexer.inlineTokens(me.header[xe].text,me.header[xe].tokens);for(fe=me.rows.length,xe=0;xe<fe;xe++)for(qe=me.rows[xe],Ne=0;Ne<qe.length;Ne++)qe[Ne].tokens=[],this.lexer.inlineTokens(qe[Ne].text,qe[Ne].tokens);return me}}},Se.lheading=function(ie){var ue=this.rules.block.lheading.exec(ie);if(ue){var me={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.paragraph=function(ie){var ue=this.rules.block.paragraph.exec(ie);if(ue){var me={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.text=function(ie){var ue=this.rules.block.text.exec(ie);if(ue){var me={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.escape=function(ie){var ue=this.rules.inline.escape.exec(ie);if(ue)return{type:"escape",raw:ue[0],text:x(ue[1])}},Se.tag=function(ie){var ue=this.rules.inline.tag.exec(ie);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):x(ue[0]):ue[0]}},Se.link=function(ie){var ue=this.rules.inline.link.exec(ie);if(ue){var me=ue[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var fe=B(me.slice(0,-1),"\\");if((me.length-fe.length)%2==0)return}else{var Ie=K(ue[2],"()");if(Ie>-1){var xe=ue[0].indexOf("!")===0?5:4,Ne=xe+ue[1].length+Ie;ue[2]=ue[2].substring(0,Ie),ue[0]=ue[0].substring(0,Ne).trim(),ue[3]=""}}var qe=ue[2],it="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(qe);Le&&(qe=Le[1],it=Le[3])}else it=ue[3]?ue[3].slice(1,-1):"";return qe=qe.trim(),/^</.test(qe)&&(this.options.pedantic&&!/>$/.test(me)?qe=qe.slice(1):qe=qe.slice(1,-1)),H(ue,{href:qe&&qe.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Se.reflink=function(ie,ue){var me;if((me=this.rules.inline.reflink.exec(ie))||(me=this.rules.inline.nolink.exec(ie))){var fe=(me[2]||me[1]).replace(/\s+/g," ");if(fe=ue[fe.toLowerCase()],!fe||!fe.href){var Ie=me[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return H(me,fe,me[0],this.lexer)}},Se.emStrong=function(ie,ue,me){me===void 0&&(me="");var fe=this.rules.inline.emStrong.lDelim.exec(ie);if(!!fe&&!(fe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=fe[1]||fe[2]||"";if(!Ie||Ie&&(me===""||this.rules.inline.punctuation.exec(me))){var xe=fe[0].length-1,Ne,qe,it=xe,Le=0,de=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,ue=ue.slice(-1*ie.length+xe);(fe=de.exec(ue))!=null;)if(Ne=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ne){if(qe=Ne.length,fe[3]||fe[4]){it+=qe;continue}else if((fe[5]||fe[6])&&xe%3&&!((xe+qe)%3)){Le+=qe;continue}if(it-=qe,!(it>0)){if(qe=Math.min(qe,qe+it+Le),Math.min(xe,qe)%2){var ge=ie.slice(1,xe+fe.index+qe);return{type:"em",raw:ie.slice(0,xe+fe.index+qe+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var X=ie.slice(2,xe+fe.index+qe-1);return{type:"strong",raw:ie.slice(0,xe+fe.index+qe+1),text:X,tokens:this.lexer.inlineTokens(X,[])}}}}}},Se.codespan=function(ie){var ue=this.rules.inline.code.exec(ie);if(ue){var me=ue[2].replace(/\n/g," "),fe=/[^ ]/.test(me),Ie=/^ /.test(me)&&/ $/.test(me);return fe&&Ie&&(me=me.substring(1,me.length-1)),me=x(me,!0),{type:"codespan",raw:ue[0],text:me}}},Se.br=function(ie){var ue=this.rules.inline.br.exec(ie);if(ue)return{type:"br",raw:ue[0]}},Se.del=function(ie){var ue=this.rules.inline.del.exec(ie);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},Se.autolink=function(ie,ue){var me=this.rules.inline.autolink.exec(ie);if(me){var fe,Ie;return me[2]==="@"?(fe=x(this.options.mangle?ue(me[1]):me[1]),Ie="mailto:"+fe):(fe=x(me[1]),Ie=fe),{type:"link",raw:me[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},Se.url=function(ie,ue){var me;if(me=this.rules.inline.url.exec(ie)){var fe,Ie;if(me[2]==="@")fe=x(this.options.mangle?ue(me[0]):me[0]),Ie="mailto:"+fe;else{var xe;do xe=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(xe!==me[0]);fe=x(me[0]),me[1]==="www."?Ie="http://"+fe:Ie=fe}return{type:"link",raw:me[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},Se.inlineText=function(ie,ue){var me=this.rules.inline.text.exec(ie);if(me){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):x(me[0]):me[0]:fe=x(this.options.smartypants?ue(me[0]):me[0]),{type:"text",raw:me[0],text:fe}}},Pe}(),V=L.noopTest,J=L.edit,j=L.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:V,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=J(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=J(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=J(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=J(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=J(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=J(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=j({},le),le.gfm=j({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=J(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=j({},le.normal,{html:J(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:V,paragraph:J(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:V,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:V,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=J(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=J(le._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=J(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=J(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=J(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=J(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=J(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=J(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=J(ee.reflink).replace("label",ee._label).getRegex(),ee.reflinkSearch=J(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=j({},ee),ee.pedantic=j({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:J(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:J(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=j({},ee.normal,{escape:J(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=J(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=j({},ee.gfm,{br:J(ee.br).replace("{2,}","*").getRegex(),text:J(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:ee},Re=ne,Fe=A.exports.defaults,Oe=ve.block,Ke=ve.inline,je=L.repeatString;function Ve(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(Pe){var Se="",Ce,ie,ue=Pe.length;for(Ce=0;Ce<ue;Ce++)ie=Pe.charCodeAt(Ce),Math.random()>.5&&(ie="x"+ie.toString(16)),Se+="&#"+ie+";";return Se}var Q=function(){function Pe(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Fe,this.options.tokenizer=this.options.tokenizer||new Re,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ie={block:Oe.normal,inline:Ke.normal};this.options.pedantic?(ie.block=Oe.pedantic,ie.inline=Ke.pedantic):this.options.gfm&&(ie.block=Oe.gfm,this.options.breaks?ie.inline=Ke.breaks:ie.inline=Ke.gfm),this.tokenizer.rules=ie}Pe.lex=function(ie,ue){var me=new Pe(ue);return me.lex(ie)},Pe.lexInline=function(ie,ue){var me=new Pe(ue);return me.inlineTokens(ie)};var Se=Pe.prototype;return Se.lex=function(ie){ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Se.blockTokens=function(ie,ue){var me=this;ue===void 0&&(ue=[]),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var fe,Ie,xe,Ne;ie;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(fe=it.call({lexer:me},ie,ue))?(ie=ie.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.space(ie)){ie=ie.substring(fe.raw.length),fe.type&&ue.push(fe);continue}if(fe=this.tokenizer.code(ie)){ie=ie.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(fe=this.tokenizer.fences(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.heading(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.hr(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.blockquote(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.list(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.html(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.def(ie)){ie=ie.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.lheading(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(xe=ie,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,Le=ie.slice(1),de=void 0;me.options.extensions.startBlock.forEach(function(ge){de=ge.call({lexer:this},Le),typeof de=="number"&&de>=0&&(it=Math.min(it,de))}),it<Infinity&&it>=0&&(xe=ie.substring(0,it+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(xe))){Ie=ue[ue.length-1],Ne&&Ie.type==="paragraph"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe),Ne=xe.length!==ie.length,ie=ie.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(ie)){ie=ie.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(ie){var qe="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return this.state.top=!0,ue},Se.inline=function(ie,ue){this.inlineQueue.push({src:ie,tokens:ue})},Se.inlineTokens=function(ie,ue){var me=this;ue===void 0&&(ue=[]);var fe,Ie,xe,Ne=ie,qe,it,Le;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(qe=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)de.includes(qe[0].slice(qe[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,qe.index)+"["+je("a",qe[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(qe=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,qe.index)+"["+je("a",qe[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(qe=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,qe.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;)if(it||(Le=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(fe=X.call({lexer:me},ie,ue))?(ie=ie.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.tag(ie)){ie=ie.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.link(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.emStrong(ie,Ne,Le)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.codespan(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.br(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.del(ie)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.autolink(ie,U)){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(ie,U))){ie=ie.substring(fe.raw.length),ue.push(fe);continue}if(xe=ie,this.options.extensions&&this.options.extensions.startInline&&function(){var X=Infinity,z=ie.slice(1),we=void 0;me.options.extensions.startInline.forEach(function(ke){we=ke.call({lexer:this},z),typeof we=="number"&&we>=0&&(X=Math.min(X,we))}),X<Infinity&&X>=0&&(xe=ie.substring(0,X+1))}(),fe=this.tokenizer.inlineText(xe,Ve)){ie=ie.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(Le=fe.raw.slice(-1)),it=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(ie){var ge="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ue},e(Pe,null,[{key:"rules",get:function(){return{block:Oe,inline:Ke}}}]),Pe}(),te=A.exports.defaults,ae=L.cleanUrl,G=L.escape,oe=function(){function Pe(Ce){this.options=Ce||te}var Se=Pe.prototype;return Se.code=function(ie,ue,me){var fe=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(ie,fe);Ie!=null&&Ie!==ie&&(me=!0,ie=Ie)}return ie=ie.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+G(fe,!0)+'">'+(me?ie:G(ie,!0))+`</code></pre>
`:"<pre><code>"+(me?ie:G(ie,!0))+`</code></pre>
`},Se.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},Se.html=function(ie){return ie},Se.heading=function(ie,ue,me,fe){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+fe.slug(me)+'">'+ie+"</h"+ue+`>
`:"<h"+ue+">"+ie+"</h"+ue+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ie,ue,me){var fe=ue?"ol":"ul",Ie=ue&&me!==1?' start="'+me+'"':"";return"<"+fe+Ie+`>
`+ie+"</"+fe+`>
`},Se.listitem=function(ie){return"<li>"+ie+`</li>
`},Se.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ie){return"<p>"+ie+`</p>
`},Se.table=function(ie,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+ue+`</table>
`},Se.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},Se.tablecell=function(ie,ue){var me=ue.header?"th":"td",fe=ue.align?"<"+me+' align="'+ue.align+'">':"<"+me+">";return fe+ie+"</"+me+`>
`},Se.strong=function(ie){return"<strong>"+ie+"</strong>"},Se.em=function(ie){return"<em>"+ie+"</em>"},Se.codespan=function(ie){return"<code>"+ie+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ie){return"<del>"+ie+"</del>"},Se.link=function(ie,ue,me){if(ie=ae(this.options.sanitize,this.options.baseUrl,ie),ie===null)return me;var fe='<a href="'+G(ie)+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=">"+me+"</a>",fe},Se.image=function(ie,ue,me){if(ie=ae(this.options.sanitize,this.options.baseUrl,ie),ie===null)return me;var fe='<img src="'+ie+'" alt="'+me+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=this.options.xhtml?"/>":">",fe},Se.text=function(ie){return ie},Pe}(),he=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(ie){return ie},Se.em=function(ie){return ie},Se.codespan=function(ie){return ie},Se.del=function(ie){return ie},Se.html=function(ie){return ie},Se.text=function(ie){return ie},Se.link=function(ie,ue,me){return""+me},Se.image=function(ie,ue,me){return""+me},Se.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ie,ue){var me=ie,fe=0;if(this.seen.hasOwnProperty(me)){fe=this.seen[ie];do fe++,me=ie+"-"+fe;while(this.seen.hasOwnProperty(me))}return ue||(this.seen[ie]=fe,this.seen[me]=0),me},Se.slug=function(ie,ue){ue===void 0&&(ue={});var me=this.serialize(ie);return this.getNextSafeSlug(me,ue.dryrun)},Pe}(),Be=oe,He=he,Qe=Te,et=A.exports.defaults,ot=L.unescape,ye=function(){function Pe(Ce){this.options=Ce||et,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Qe}Pe.parse=function(ie,ue){var me=new Pe(ue);return me.parse(ie)},Pe.parseInline=function(ie,ue){var me=new Pe(ue);return me.parseInline(ie)};var Se=Pe.prototype;return Se.parse=function(ie,ue){ue===void 0&&(ue=!0);var me="",fe,Ie,xe,Ne,qe,it,Le,de,ge,X,z,we,ke,Je,Ue,ct,pt,lt,gt,ht=ie.length;for(fe=0;fe<ht;fe++){if(X=ie[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(gt=this.options.extensions.renderers[X.type].call({parser:this},X),gt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){me+=gt||"";continue}switch(X.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(X.tokens),X.depth,ot(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(de="",Le="",Ne=X.header.length,Ie=0;Ie<Ne;Ie++)Le+=this.renderer.tablecell(this.parseInline(X.header[Ie].tokens),{header:!0,align:X.align[Ie]});for(de+=this.renderer.tablerow(Le),ge="",Ne=X.rows.length,Ie=0;Ie<Ne;Ie++){for(it=X.rows[Ie],Le="",qe=it.length,xe=0;xe<qe;xe++)Le+=this.renderer.tablecell(this.parseInline(it[xe].tokens),{header:!1,align:X.align[xe]});ge+=this.renderer.tablerow(Le)}me+=this.renderer.table(de,ge);continue}case"blockquote":{ge=this.parse(X.tokens),me+=this.renderer.blockquote(ge);continue}case"list":{for(z=X.ordered,we=X.start,ke=X.loose,Ne=X.items.length,ge="",Ie=0;Ie<Ne;Ie++)Ue=X.items[Ie],ct=Ue.checked,pt=Ue.task,Je="",Ue.task&&(lt=this.renderer.checkbox(ct),ke?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=lt+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=lt+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:lt}):Je+=lt),Je+=this.parse(Ue.tokens,ke),ge+=this.renderer.listitem(Je,pt,ct);me+=this.renderer.list(ge,z,we);continue}case"html":{me+=this.renderer.html(X.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(ge=X.tokens?this.parseInline(X.tokens):X.text;fe+1<ht&&ie[fe+1].type==="text";)X=ie[++fe],ge+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);me+=ue?this.renderer.paragraph(ge):ge;continue}default:{var _t='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(_t);return}else throw new Error(_t)}}}return me},Se.parseInline=function(ie,ue){ue=ue||this.renderer;var me="",fe,Ie,xe,Ne=ie.length;for(fe=0;fe<Ne;fe++){if(Ie=ie[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(xe=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),xe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){me+=xe||"";continue}switch(Ie.type){case"escape":{me+=ue.text(Ie.text);break}case"html":{me+=ue.html(Ie.text);break}case"link":{me+=ue.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ue));break}case"image":{me+=ue.image(Ie.href,Ie.title,Ie.text);break}case"strong":{me+=ue.strong(this.parseInline(Ie.tokens,ue));break}case"em":{me+=ue.em(this.parseInline(Ie.tokens,ue));break}case"codespan":{me+=ue.codespan(Ie.text);break}case"br":{me+=ue.br();break}case"del":{me+=ue.del(this.parseInline(Ie.tokens,ue));break}case"text":{me+=ue.text(Ie.text);break}default:{var qe='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(qe);return}else throw new Error(qe)}}}return me},Pe}(),nt=Q,q=ye,Z=ne,pe=oe,We=he,Ye=Te,rt=L.merge,ft=L.checkSanitizeDeprecation,dt=L.escape,St=A.exports.getDefaults,It=A.exports.changeDefaults,Tt=A.exports.defaults;function Xe(Pe,Se,Ce){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(Ce=Se,Se=null),Se=rt({},Xe.defaults,Se||{}),ft(Se),Ce){var ie=Se.highlight,ue;try{ue=nt.lex(Pe,Se)}catch(xe){return Ce(xe)}var me=function(Ne){var qe;if(!Ne)try{Se.walkTokens&&Xe.walkTokens(ue,Se.walkTokens),qe=q.parse(ue,Se)}catch(it){Ne=it}return Se.highlight=ie,Ne?Ce(Ne):Ce(null,qe)};if(!ie||ie.length<3||(delete Se.highlight,!ue.length))return me();var fe=0;Xe.walkTokens(ue,function(xe){xe.type==="code"&&(fe++,setTimeout(function(){ie(xe.text,xe.lang,function(Ne,qe){if(Ne)return me(Ne);qe!=null&&qe!==xe.text&&(xe.text=qe,xe.escaped=!0),fe--,fe===0&&me()})},0))}),fe===0&&me();return}try{var Ie=nt.lex(Pe,Se);return Se.walkTokens&&Xe.walkTokens(Ie,Se.walkTokens),q.parse(Ie,Se)}catch(xe){if(xe.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+dt(xe.message+"",!0)+"</pre>";throw xe}}Xe.options=Xe.setOptions=function(Pe){return rt(Xe.defaults,Pe),It(Xe.defaults),Xe},Xe.getDefaults=St,Xe.defaults=Tt,Xe.use=function(){for(var Pe=this,Se=arguments.length,Ce=new Array(Se),ie=0;ie<Se;ie++)Ce[ie]=arguments[ie];var ue=rt.apply(void 0,[{}].concat(Ce)),me=Xe.defaults.extensions||{renderers:{},childTokens:{}},fe;Ce.forEach(function(Ie){if(Ie.extensions&&(fe=!0,Ie.extensions.forEach(function(Ne){if(!Ne.name)throw new Error("extension name required");if(Ne.renderer){var qe=me.renderers?me.renderers[Ne.name]:null;qe?me.renderers[Ne.name]=function(){for(var it=arguments.length,Le=new Array(it),de=0;de<it;de++)Le[de]=arguments[de];var ge=Ne.renderer.apply(this,Le);return ge===!1&&(ge=qe.apply(this,Le)),ge}:me.renderers[Ne.name]=Ne.renderer}if(Ne.tokenizer){if(!Ne.level||Ne.level!=="block"&&Ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");me[Ne.level]?me[Ne.level].unshift(Ne.tokenizer):me[Ne.level]=[Ne.tokenizer],Ne.start&&(Ne.level==="block"?me.startBlock?me.startBlock.push(Ne.start):me.startBlock=[Ne.start]:Ne.level==="inline"&&(me.startInline?me.startInline.push(Ne.start):me.startInline=[Ne.start]))}Ne.childTokens&&(me.childTokens[Ne.name]=Ne.childTokens)})),Ie.renderer&&function(){var Ne=Xe.defaults.renderer||new pe,qe=function(de){var ge=Ne[de];Ne[de]=function(){for(var X=arguments.length,z=new Array(X),we=0;we<X;we++)z[we]=arguments[we];var ke=Ie.renderer[de].apply(Ne,z);return ke===!1&&(ke=ge.apply(Ne,z)),ke}};for(var it in Ie.renderer)qe(it);ue.renderer=Ne}(),Ie.tokenizer&&function(){var Ne=Xe.defaults.tokenizer||new Z,qe=function(de){var ge=Ne[de];Ne[de]=function(){for(var X=arguments.length,z=new Array(X),we=0;we<X;we++)z[we]=arguments[we];var ke=Ie.tokenizer[de].apply(Ne,z);return ke===!1&&(ke=ge.apply(Ne,z)),ke}};for(var it in Ie.tokenizer)qe(it);ue.tokenizer=Ne}(),Ie.walkTokens){var xe=Xe.defaults.walkTokens;ue.walkTokens=function(Ne){Ie.walkTokens.call(Pe,Ne),xe&&xe(Ne)}}fe&&(ue.extensions=me),Xe.setOptions(ue)})},Xe.walkTokens=function(Pe,Se){for(var Ce=function(){var fe=ue.value;switch(Se(fe),fe.type){case"table":{for(var Ie=E(fe.header),xe;!(xe=Ie()).done;){var Ne=xe.value;Xe.walkTokens(Ne.tokens,Se)}for(var qe=E(fe.rows),it;!(it=qe()).done;)for(var Le=it.value,de=E(Le),ge;!(ge=de()).done;){var X=ge.value;Xe.walkTokens(X.tokens,Se)}break}case"list":{Xe.walkTokens(fe.items,Se);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[fe.type]?Xe.defaults.extensions.childTokens[fe.type].forEach(function(z){Xe.walkTokens(fe[z],Se)}):fe.tokens&&Xe.walkTokens(fe.tokens,Se)}},ie=E(Pe),ue;!(ue=ie()).done;)Ce()},Xe.parseInline=function(Pe,Se){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=rt({},Xe.defaults,Se||{}),ft(Se);try{var Ce=nt.lexInline(Pe,Se);return Se.walkTokens&&Xe.walkTokens(Ce,Se.walkTokens),q.parseInline(Ce,Se)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+dt(ie.message+"",!0)+"</pre>";throw ie}},Xe.Parser=q,Xe.parser=q.parse,Xe.Renderer=pe,Xe.TextRenderer=We,Xe.Lexer=nt,Xe.lexer=nt.lex,Xe.Tokenizer=Z,Xe.Slugger=Ye,Xe.parse=Xe;var vt=Xe;return vt}),define(be[76],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function h(F,C,S){return Math.min(Math.max(F,C),S)}e.clamp=h;function M(F,C){return(C+F%C)%C}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class A{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function se(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function F(S){A.push(S,Date.now())}function C(){const S=[];for(let T=0;T<A.length;T+=2)S.push({name:A[T],startTime:A[T+1]});return S}return{mark:F,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const F of performance.getEntriesByType("mark"))A.push({name:F.name,startTime:Math.round(E+F.startTime)});return A}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function h(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=h(M))}(),define(be[104],Ee([0,1]),function(se,e){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(C,S,T){this.level=C,this.key=S,this.value=T,this.forward=[]}}const E=void 0;class A{constructor(C,S=2**16){this.comparator=C,this[h]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new M(this._maxLevel,E,E)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,E,E)}has(C){return Boolean(A._search(this,C,this.comparator))}get(C){return A._search(this,C,this.comparator)?.value}set(C,S){return A._insert(this,C,S,this.comparator)&&(this._size+=1),this}delete(C){const S=A._delete(this,C,this.comparator);return S&&(this._size-=1),S}forEach(C,S){let T=this._header.forward[0];for(;T;)C.call(S,T.value,T.key,this),T=T.forward[0]}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",S=this._header.forward[0];for(;S;)C+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return C}static _search(C,S,T){let t=C._header;for(let y=C._level-1;y>=0;y--)for(;t.forward[y]&&T(t.forward[y].key,S)<0;)t=t.forward[y];if(t=t.forward[0],t&&T(t.key,S)===0)return t}static _insert(C,S,T,t){let y=[],n=C._header;for(let f=C._level-1;f>=0;f--){for(;n.forward[f]&&t(n.forward[f].key,S)<0;)n=n.forward[f];y[f]=n}if(n=n.forward[0],n&&t(n.key,S)===0)return n.value=T,!1;{let f=A._randomLevel(C);if(f>C._level){for(let s=C._level;s<f;s++)y[s]=C._header;C._level=f}n=new M(f,S,T);for(let s=0;s<f;s++)n.forward[s]=y[s].forward[s],y[s].forward[s]=n;return!0}}static _randomLevel(C,S=.5){let T=1;for(;Math.random()<S&&T<C._maxLevel;)T+=1;return T}static _delete(C,S,T){let t=[],y=C._header;for(let n=C._level-1;n>=0;n--){for(;y.forward[n]&&T(y.forward[n].key,S)<0;)y=y.forward[n];t[n]=y}if(y=y.forward[0],!y||T(y.key,S)!==0)return!1;for(let n=0;n<C._level&&t[n].forward[n]===y;n++)t[n].forward[n]=y.forward[n];for(;C._level>0&&C._header.forward[C._level-1]===E;)C._level-=1;return!0}}e.SkipList=A}),define(be[34],Ee([0,1,3]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new h.Emitter}add(y){const n=this._icons.get(y.id);n?y.description?n.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function A(t,y){return new C(t,y)}e.registerCodicon=A;function F(t){return t?t.replace(/\$\((.*?)\)/g,(y,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class C{constructor(y,n,f){this.id=y,this.definition=n,this.description=f,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function S(t,y){const n=["codicon","codicon-"+t];return y&&n.push("codicon-modifier-"+y),n}e.getClassNamesArray=S;var T;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(c){if(c instanceof C)return["codicon","codicon-"+c.id];const p=y.exec(c.id);if(!p)return n(C.error);let[,P,D]=p;const l=["codicon","codicon-"+P];return D&&l.push("codicon-modifier-"+D.substr(1)),l}t.asClassNameArray=n;function f(c){return n(c).join(" ")}t.asClassName=f;function s(c){return"."+n(c).join(".")}t.asCSSSelector=s})(T=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"})}(C=e.Codicon||(e.Codicon={}))}),define(be[105],Ee([0,1,16,6]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(l){const u=l;return u?[u.on,u.pause,u.resume,u.destroy].every(_=>typeof _=="function"):!1}e.isReadableStream=E;function A(l){const u=l;return u?E(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=A;function F(l,u){return new C(l,u)}e.newWriteableStream=F;class C{constructor(u,_){this.reducer=u,this.options=_,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(_=>this.pendingWritePromises.push(_))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(_=>_(u))}emitError(u){this.listeners.error.length===0?(0,h.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(_=>_(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,_){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(_),this.resume();break;case"end":this.listeners.end.push(_),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(_),this.state.flowing&&this.flowErrors();break}}removeListener(u,_){if(this.state.destroyed)return;let i;switch(u){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const g=i.indexOf(_);g>=0&&i.splice(g,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const _=[...this.pendingWritePromises];this.pendingWritePromises.length=0,_.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(l,u){const _=[];let i;for(;(i=l.read())!==null;)_.push(i);return u(_)}e.consumeReadable=S;function T(l,u,_){const i=[];let g;for(;(g=l.read())!==null&&i.length<_;)i.push(g);return g===null&&i.length>0?u(i):{read:()=>{if(i.length>0)return i.shift();if(typeof g!="undefined"){const a=g;return g=void 0,a}return l.read()}}}e.peekReadable=T;function t(l,u){return new Promise((_,i)=>{const g=[];y(l,{onData:a=>{u&&g.push(a)},onError:a=>{u?i(a):_(void 0)},onEnd:()=>{_(u?u(g):void 0)}})})}e.consumeStream=t;function y(l,u){l.on("error",_=>u.onError(_)),l.on("end",()=>u.onEnd()),l.on("data",_=>u.onData(_))}e.listenStream=y;function n(l,u){return new Promise((_,i)=>{const g=new M.DisposableStore,a=[],r=d=>{if(a.push(d),a.length>u)return g.dispose(),l.pause(),_({stream:l,buffer:a,ended:!1})},v=d=>i(d),o=()=>_({stream:l,buffer:a,ended:!0});g.add((0,M.toDisposable)(()=>l.removeListener("error",v))),l.on("error",v),g.add((0,M.toDisposable)(()=>l.removeListener("end",o))),l.on("end",o),g.add((0,M.toDisposable)(()=>l.removeListener("data",r))),l.on("data",r)})}e.peekStream=n;function f(l,u){const _=F(u);return _.end(l),_}e.toStream=f;function s(){const l=F(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=s;function c(l){let u=!1;return{read:()=>u?null:(u=!0,l)}}e.toReadable=c;function p(l,u,_){const i=F(_);return y(l,{onData:g=>i.write(u.data(g)),onError:g=>i.error(u.error?u.error(g):g),onEnd:()=>i.end()}),i}e.transform=p;function P(l,u,_){let i=!1;return{read:()=>{const g=u.read();return i?g:(i=!0,g!==null?_([l,g]):l)}}}e.prefixedReadable=P;function D(l,u,_){let i=!1;const g=F(_);return y(u,{onData:a=>i?g.write(a):(i=!0,g.write(_([l,a]))),onError:a=>g.error(a),onEnd:()=>{i||(i=!0,g.write(l)),g.end()}}),g}e.prefixedStream=D}),define(be[22],Ee([0,1,105]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,A;class F{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return M?new F(Buffer.allocUnsafe(r)):new F(new Uint8Array(r))}static wrap(r){return M&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new F(r)}static fromString(r,v){return!(v?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(r)):(E||(E=new TextEncoder),new F(E.encode(r)))}static concat(r,v){if(typeof v=="undefined"){v=0;for(let w=0,I=r.length;w<I;w++)v+=r[w].byteLength}const o=F.alloc(v);let d=0;for(let w=0,I=r.length;w<I;w++){const m=r[w];o.set(m,d),d+=m.byteLength}return o}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,v){return new F(this.buffer.subarray(r,v))}set(r,v){r instanceof F?this.buffer.set(r.buffer,v):this.buffer.set(r,v)}readUInt32BE(r){return T(this.buffer,r)}writeUInt32BE(r,v){t(this.buffer,r,v)}readUInt32LE(r){return y(this.buffer,r)}writeUInt32LE(r,v){n(this.buffer,r,v)}readUInt8(r){return f(this.buffer,r)}writeUInt8(r,v){s(this.buffer,r,v)}}e.VSBuffer=F;function C(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0}e.readUInt16LE=C;function S(a,r,v){a[v+0]=r&255,r=r>>>8,a[v+1]=r&255}e.writeUInt16LE=S;function T(a,r){return a[r]*2**24+a[r+1]*2**16+a[r+2]*2**8+a[r+3]}e.readUInt32BE=T;function t(a,r,v){a[v+3]=r,r=r>>>8,a[v+2]=r,r=r>>>8,a[v+1]=r,r=r>>>8,a[v]=r}e.writeUInt32BE=t;function y(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0|a[r+2]<<16>>>0|a[r+3]<<24>>>0}e.readUInt32LE=y;function n(a,r,v){a[v+0]=r&255,r=r>>>8,a[v+1]=r&255,r=r>>>8,a[v+2]=r&255,r=r>>>8,a[v+3]=r&255}e.writeUInt32LE=n;function f(a,r){return a[r]}e.readUInt8=f;function s(a,r,v){a[v]=r}e.writeUInt8=s;function c(a){return h.consumeReadable(a,r=>F.concat(r))}e.readableToBuffer=c;function p(a){return h.toReadable(a)}e.bufferToReadable=p;function P(a){return h.consumeStream(a,r=>F.concat(r))}e.streamToBuffer=P;async function D(a){return a.ended?F.concat(a.buffer):F.concat([...a.buffer,await P(a.stream)])}e.bufferedStreamToBuffer=D;function l(a){return h.toStream(a,r=>F.concat(r))}e.bufferToStream=l;function u(a){return h.transform(a,{data:r=>typeof r=="string"?F.fromString(r):F.wrap(r)},r=>F.concat(r))}e.streamToBufferReadableStream=u;function _(a){return h.newWriteableStream(r=>F.concat(r),a)}e.newWriteableBufferStream=_;function i(a,r){return h.prefixedReadable(a,r,v=>F.concat(v))}e.prefixedBufferReadable=i;function g(a,r){return h.prefixedStream(a,r,v=>F.concat(v))}e.prefixedBufferStream=g}),define(be[35],Ee([0,1,9]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const A="error",F="warning",C="warn",S="info",T="ignore";function t(n){return n?h.equalsIgnoreCase(A,n)?E.Error:h.equalsIgnoreCase(F,n)||h.equalsIgnoreCase(C,n)?E.Warning:h.equalsIgnoreCase(S,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function y(n){switch(n){case E.Error:return A;case E.Warning:return F;case E.Info:return S;default:return T}}E.toString=y}(M||(M={})),e.default=M}),define(be[43],Ee([0,1,17,25,9,10]),function(se,e,h,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(a){return a===47||a===92}e.isPathSeparator=F;function C(a){return a.replace(/[\\/]/g,h.posix.sep)}e.toSlashes=C;function S(a){return a.indexOf("/")===-1&&(a=C(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=S;function T(a,r=h.posix.sep){if(!a)return"";const v=a.length,o=a.charCodeAt(0);if(F(o)){if(F(a.charCodeAt(1))&&!F(a.charCodeAt(2))){let w=3;const I=w;for(;w<v&&!F(a.charCodeAt(w));w++);if(I!==w&&!F(a.charCodeAt(w+1))){for(w+=1;w<v;w++)if(F(a.charCodeAt(w)))return a.slice(0,w+1).replace(/[\\/]/g,r)}}return r}else if(P(o)&&a.charCodeAt(1)===58)return F(a.charCodeAt(2))?a.slice(0,2)+r:a.slice(0,2);let d=a.indexOf("://");if(d!==-1){for(d+=3;d<v;d++)if(F(a.charCodeAt(d)))return a.slice(0,d+1)}return""}e.getRoot=T;function t(a){if(!M.isWindows||!a||a.length<5)return!1;let r=a.charCodeAt(0);if(r!==92||(r=a.charCodeAt(1),r!==92))return!1;let v=2;const o=v;for(;v<a.length&&(r=a.charCodeAt(v),r!==92);v++);return!(o===v||(r=a.charCodeAt(v+1),isNaN(r)||r===92))}e.isUNC=t;const y=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(a,r=M.isWindows){const v=r?y:n;return!(!a||a.length===0||/^\s+$/.test(a)||(v.lastIndex=0,v.test(a))||r&&f.test(a)||a==="."||a===".."||r&&a[a.length-1]==="."||r&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=s;function c(a,r,v){const o=a===r;return!v||o?o:!a||!r?!1:(0,E.equalsIgnoreCase)(a,r)}e.isEqual=c;function p(a,r,v,o=h.sep){if(a===r)return!0;if(!a||!r||r.length>a.length)return!1;if(v){if(!(0,E.startsWithIgnoreCase)(a,r))return!1;if(r.length===a.length)return!0;let w=r.length;return r.charAt(r.length-1)===o&&w--,a.charAt(w)===o}return r.charAt(r.length-1)!==o&&(r+=o),a.indexOf(r)===0}e.isEqualOrParent=p;function P(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=P;function D(a,r){return M.isWindows&&a.endsWith(":")&&(a+=h.sep),(0,h.isAbsolute)(a)||(a=(0,h.join)(r,a)),a=(0,h.normalize)(a),M.isWindows?(a=(0,E.rtrim)(a,h.sep),a.endsWith(":")&&(a+=h.sep)):(a=(0,E.rtrim)(a,h.sep),a||(a=h.sep)),a}e.sanitizeFilePath=D;function l(a){const r=(0,h.normalize)(a);return M.isWindows?a.length>3?!1:u(r)&&(a.length===2||r.charCodeAt(2)===92):r===h.posix.sep}e.isRootOrDriveLetter=l;function u(a){return M.isWindows?P(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function _(a){return u(a)?a[0]:void 0}e.getDriveLetter=_;function i(a,r,v){return r.length>a.length?-1:a===r?0:(v&&(a=a.toLowerCase(),r=r.toLowerCase()),a.indexOf(r))}e.indexOfPath=i;function g(a){const r=a.split(":");let v,o,d;if(r.forEach(w=>{const I=Number(w);(0,A.isNumber)(I)?o===void 0?o=I:d===void 0&&(d=I):v=v?[v,w].join(":"):w}),!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:o!==void 0?o:void 0,column:d!==void 0?d:o!==void 0?1:void 0}}e.parseLineAndColumnAware=g}),define(be[23],Ee([0,1,10]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.keys(c).forEach(P=>{c[P]&&typeof c[P]=="object"?p[P]=M(c[P]):p[P]=c[P]}),p}e.deepClone=M;function E(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const P=p.shift();Object.freeze(P);for(const D in P)if(A.call(P,D)){const l=P[D];typeof l=="object"&&!Object.isFrozen(l)&&p.push(l)}}return c}e.deepFreeze=E;const A=Object.prototype.hasOwnProperty;function F(c,p){return C(c,p,new Set)}e.cloneAndChange=F;function C(c,p,P){if((0,h.isUndefinedOrNull)(c))return c;const D=p(c);if(typeof D!="undefined")return D;if((0,h.isArray)(c)){const l=[];for(const u of c)l.push(C(u,p,P));return l}if((0,h.isObject)(c)){if(P.has(c))throw new Error("Cannot clone recursive data-structure");P.add(c);const l={};for(let u in c)A.call(c,u)&&(l[u]=C(c[u],p,P));return P.delete(c),l}return c}function S(c,p,P=!0){return(0,h.isObject)(c)?((0,h.isObject)(p)&&Object.keys(p).forEach(D=>{D in c?P&&((0,h.isObject)(c[D])&&(0,h.isObject)(p[D])?S(c[D],p[D],P):c[D]=p[D]):c[D]=p[D]}),c):p}e.mixin=S;function T(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let P,D;if(Array.isArray(c)){if(c.length!==p.length)return!1;for(P=0;P<c.length;P++)if(!T(c[P],p[P]))return!1}else{const l=[];for(D in c)l.push(D);l.sort();const u=[];for(D in p)u.push(D);if(u.sort(),!T(l,u))return!1;for(P=0;P<l.length;P++)if(!T(c[l[P]],p[l[P]]))return!1}return!0}e.equals=T;function t(c){const p=new Set;return JSON.stringify(c,(P,D)=>{if((0,h.isObject)(D)||Array.isArray(D)){if(p.has(D))return"[Circular]";p.add(D)}return D})}e.safeStringify=t;function y(c,p,P){const D=p(c);return typeof D=="undefined"?P:D}e.getOrDefault=y;function n(c,p){const P=Object.create(null);return!c||!p||Object.keys(p).forEach(l=>{const u=c[l],_=p[l];T(u,_)||(P[l]=_)}),P}e.distinct=n;function f(c,p){const P=p.toLowerCase(),D=Object.keys(c).find(l=>l.toLowerCase()===P);return D?c[D]:c[p]}e.getCaseInsensitive=f;function s(c,p){const P=Object.create(null);for(const D of Object.keys(c))p(D,c[D])&&(P[D]=c[D]);return P}e.filter=s});var Ze=this&&this.__classPrivateFieldSet||function(se,e,h,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,h):E?E.value=h:e.set(se,h),h},Ae=this&&this.__classPrivateFieldGet||function(se,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(se):M?M.value:e.get(se)};define(be[20],Ee([0,1,14,9,2]),function(se,e,h,M,E){"use strict";var A,F,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(a,r,v){let o=a.get(r);return o===void 0&&(o=v,a.set(r,o)),o}e.getOrSet=S;function T(a){const r=[];return a.forEach((v,o)=>{r.push(`${o} => ${v}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=T;function t(a){const r=[];return a.forEach(v=>{r.push(v)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=t;class y{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const v=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return v-o}value(){return this._value[this._pos]}}e.StringIterator=y;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class f{constructor(r=!0,v=!0){this._splitOnBackslash=r,this._caseSensitive=v}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const v=this._value.charCodeAt(this._to);if(v===47||this._splitOnBackslash&&v===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var s;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(s||(s={}));class c{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(P||(P={}));class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new c(r))}static forPaths(){return new D(new f)}static forStrings(){return new D(new y)}static forConfigKeys(){return new D(new n)}clear(){this._root=void 0}fill(r,v){if(v){const o=v.slice(0);(0,h.shuffle)(o);for(let d of o)this.set(d,r)}else{const o=r.slice(0);(0,h.shuffle)(o);for(let d of o)this.set(d[0],d[1])}}set(r,v){const o=this._iter.reset(r);let d;this._root||(this._root=new p,this._root.segment=o.value());const w=[];for(d=this._root;;){const m=o.cmp(d.segment);if(m>0)d.left||(d.left=new p,d.left.segment=o.value()),w.push([-1,d]),d=d.left;else if(m<0)d.right||(d.right=new p,d.right.segment=o.value()),w.push([1,d]),d=d.right;else if(o.hasNext())o.next(),d.mid||(d.mid=new p,d.mid.segment=o.value()),w.push([0,d]),d=d.mid;else break}const I=d.value;d.value=v,d.key=r;for(let m=w.length-1;m>=0;m--){const k=w[m][1];k.updateHeight();const R=k.balanceFactor();if(R<-1||R>1){const L=w[m][0],b=w[m+1][0];if(L===1&&b===1)w[m][1]=k.rotateLeft();else if(L===-1&&b===-1)w[m][1]=k.rotateRight();else if(L===1&&b===-1)k.right=w[m+1][1]=w[m+1][1].rotateRight(),w[m][1]=k.rotateLeft();else if(L===-1&&b===1)k.left=w[m+1][1]=w[m+1][1].rotateLeft(),w[m][1]=k.rotateRight();else throw new Error;if(m>0)switch(w[m-1][0]){case-1:w[m-1][1].left=w[m][1];break;case 1:w[m-1][1].right=w[m][1];break;case 0:w[m-1][1].mid=w[m][1];break}else this._root=w[0][1]}}return I}get(r){return this._getNode(r)?.value}_getNode(r){const v=this._iter.reset(r);let o=this._root;for(;o;){const d=v.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(v.hasNext())v.next(),o=o.mid;else break}return o}has(r){const v=this._getNode(r);return!(v?.value===void 0&&v?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,v){const o=this._iter.reset(r),d=[];let w=this._root;for(;w;){const I=o.cmp(w.segment);if(I>0)d.push([-1,w]),w=w.left;else if(I<0)d.push([1,w]),w=w.right;else if(o.hasNext())o.next(),d.push([0,w]),w=w.mid;else break}if(!!w){if(v?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const I=this._min(w.right),{key:m,value:k,segment:R}=I;this._delete(I.key,!1),w.key=m,w.value=k,w.segment=R}else{const I=w.left??w.right;if(d.length>0){const[m,k]=d[d.length-1];switch(m){case-1:k.left=I;break;case 0:k.mid=I;break;case 1:k.right=I;break}}else this._root=I}for(let I=d.length-1;I>=0;I--){const m=d[I][1];m.updateHeight();const k=m.balanceFactor();if(k>1?(m.right.balanceFactor()>=0||(m.right=d[I+1][1]=d[I+1][1].rotateRight()),d[I][1]=m.rotateLeft()):k<-1&&(m.left.balanceFactor()<=0||(m.left=d[I+1][1]=d[I+1][1].rotateLeft()),d[I][1]=m.rotateRight()),I>0)switch(d[I-1][0]){case-1:d[I-1][1].left=d[I][1];break;case 1:d[I-1][1].right=d[I][1];break;case 0:d[I-1][1].mid=d[I][1];break}else this._root=d[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const v=this._iter.reset(r);let o=this._root,d;for(;o;){const w=v.cmp(o.segment);if(w>0)o=o.left;else if(w<0)o=o.right;else if(v.hasNext())v.next(),d=o.value||d,o=o.mid;else break}return o&&o.value||d}findSuperstr(r){const v=this._iter.reset(r);let o=this._root;for(;o;){const d=v.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(v.hasNext())v.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[v,o]of this)r(o,v)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=v=>{if(!v)return!0;const o=v.balanceFactor();return o<-1||o>1?!1:r(v.left)&&r(v.right)};return r(this._root)}}e.TernarySearchTree=D;class l{constructor(r,v){this[A]="ResourceMap",r instanceof l?(this.map=new Map(r.map),this.toKey=v??l.defaultToKey):(this.map=new Map,this.toKey=r??l.defaultToKey)}set(r,v){return this.map.set(this.toKey(r),v),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,v){typeof v!="undefined"&&(r=r.bind(v));for(let[o,d]of this.map)r(d,E.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield E.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[E.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[E.URI.parse(r[0]),r[1]]}}e.ResourceMap=l,l.defaultToKey=a=>a.toString();var u;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class _{constructor(){this[F]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,v=0){const o=this._map.get(r);if(!!o)return v!==0&&this.touch(o,v),o.value}set(r,v,o=0){let d=this._map.get(r);if(d)d.value=v,o!==0&&this.touch(d,o);else{switch(d={key:r,value:v,next:void 0,previous:void 0},o){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(r,d),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const v=this._map.get(r);if(!!v)return this._map.delete(r),this.removeItem(v),this._size--,v.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,v){const o=this._state;let d=this._head;for(;d;){if(v?r.bind(v)(d.value,d.key,this):r(d.value,d.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const r=this,v=this._state;let o=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:o.key,done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return d}values(){const r=this,v=this._state;let o=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:o.value,done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return d}entries(){const r=this,v=this._state;let o=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:[o.key,o.value],done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return d}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let v=this._head,o=this.size;for(;v&&o>r;)this._map.delete(v.key),v=v.next,o--;this._head=v,this._size=o,v&&(v.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const v=r.next,o=r.previous;if(!v||!o)throw new Error("Invalid list");v.previous=o,o.next=v}r.next=void 0,r.previous=void 0,this._state++}touch(r,v){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(r===this._head)return;const o=r.next,d=r.previous;r===this._tail?(d.next=void 0,this._tail=d):(o.previous=d,d.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(v===2){if(r===this._tail)return;const o=r.next,d=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=d,d.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((v,o)=>{r.push([o,v])}),r}fromJSON(r){this.clear();for(const[v,o]of r)this.set(v,o)}}e.LinkedMap=_;class i extends _{constructor(r,v=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,v),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,v=2){return super.get(r,v)}peek(r){return super.get(r,0)}set(r,v){return super.set(r,v,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class g{constructor(r){C.set(this,void 0),Ze(this,C,r,"f")}get size(){return Ae(this,C,"f").size}forEach(r,v){Ae(this,C,"f").forEach(r,v)}get(r){return Ae(this,C,"f").get(r)}has(r){return Ae(this,C,"f").has(r)}entries(){return Ae(this,C,"f").entries()}keys(){return Ae(this,C,"f").keys()}values(){return Ae(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Ae(this,C,"f").entries()}}e.ReadonlyMapView=g}),define(be[106],Ee([0,1,20,9]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...G){return function(oe,he){for(let Te=0,Be=G.length;Te<Be;Te++){const He=G[Te](oe,he);if(He)return He}return null}}e.or=E,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(G,oe,he){if(!he||he.length<oe.length)return null;let Te;return G?Te=M.startsWithIgnoreCase(he,oe):Te=he.indexOf(oe)===0,Te?oe.length>0?[{start:0,end:oe.length}]:[]:null}function F(G,oe){const he=oe.toLowerCase().indexOf(G.toLowerCase());return he===-1?null:[{start:he,end:he+G.length}]}e.matchesContiguousSubString=F;function C(G,oe){return S(G.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=C;function S(G,oe,he,Te){if(he===G.length)return[];if(Te===oe.length)return null;if(G[he]===oe[Te]){let Be=null;return(Be=S(G,oe,he+1,Te+1))?P({start:Te,end:Te+1},Be):null}return S(G,oe,he,Te+1)}function T(G){return 97<=G&&G<=122}function t(G){return 65<=G&&G<=90}e.isUpper=t;function y(G){return 48<=G&&G<=57}function n(G){return G===32||G===9||G===10||G===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(G=>f.add(G.charCodeAt(0)));function s(G){return n(G)||f.has(G)}function c(G,oe){return G===oe||s(G)&&s(oe)}function p(G){return T(G)||t(G)||y(G)}function P(G,oe){return oe.length===0?oe=[G]:G.end===oe[0].start?oe[0].start=G.start:oe.unshift(G),oe}function D(G,oe){for(let he=oe;he<G.length;he++){const Te=G.charCodeAt(he);if(t(Te)||y(Te)||he>0&&!p(G.charCodeAt(he-1)))return he}return G.length}function l(G,oe,he,Te){if(he===G.length)return[];if(Te===oe.length)return null;if(G[he]!==oe[Te].toLowerCase())return null;{let Be=null,He=Te+1;for(Be=l(G,oe,he+1,Te+1);!Be&&(He=D(oe,He))<oe.length;)Be=l(G,oe,he+1,He),He++;return Be===null?null:P({start:Te,end:Te+1},Be)}}function u(G){let oe=0,he=0,Te=0,Be=0,He=0;for(let nt=0;nt<G.length;nt++)He=G.charCodeAt(nt),t(He)&&oe++,T(He)&&he++,p(He)&&Te++,y(He)&&Be++;const Qe=oe/G.length,et=he/G.length,ot=Te/G.length,ye=Be/G.length;return{upperPercent:Qe,lowerPercent:et,alphaPercent:ot,numericPercent:ye}}function _(G){const{upperPercent:oe,lowerPercent:he}=G;return he===0&&oe>.6}function i(G){const{upperPercent:oe,lowerPercent:he,alphaPercent:Te,numericPercent:Be}=G;return he>.2&&oe<.8&&Te>.6&&Be<.2}function g(G){let oe=0,he=0,Te=0,Be=0;for(let He=0;He<G.length;He++)Te=G.charCodeAt(He),t(Te)&&oe++,T(Te)&&he++,n(Te)&&Be++;return(oe===0||he===0)&&Be===0?G.length<=30:oe<=5}function a(G,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!g(G)||oe.length>60)return null;const he=u(oe);if(!i(he)){if(!_(he))return null;oe=oe.toLowerCase()}let Te=null,Be=0;for(G=G.toLowerCase();Be<oe.length&&(Te=l(G,oe,0,Be))===null;)Be=D(oe,Be+1);return Te}e.matchesCamelCase=a;function r(G,oe,he=!1){if(!oe||oe.length===0)return null;let Te=null,Be=0;for(G=G.toLowerCase(),oe=oe.toLowerCase();Be<oe.length&&(Te=v(G,oe,0,Be,he))===null;)Be=o(oe,Be+1);return Te}e.matchesWords=r;function v(G,oe,he,Te,Be){if(he===G.length)return[];if(Te===oe.length)return null;if(c(G.charCodeAt(he),oe.charCodeAt(Te))){let He=null,Qe=Te+1;if(He=v(G,oe,he+1,Te+1,Be),!Be)for(;!He&&(Qe=o(oe,Qe))<oe.length;)He=v(G,oe,he+1,Qe,Be),Qe++;return He===null?null:P({start:Te,end:Te+1},He)}else return null}function o(G,oe){for(let he=oe;he<G.length;he++)if(s(G.charCodeAt(he))||he>0&&s(G.charCodeAt(he-1)))return he;return G.length}const d=E(e.matchesPrefix,a,F),w=E(e.matchesPrefix,a,C),I=new h.LRUCache(1e4);function m(G,oe,he=!1){if(typeof G!="string"||typeof oe!="string")return null;let Te=I.get(G);Te||(Te=new RegExp(M.convertSimple2RegExpPattern(G),"i"),I.set(G,Te));const Be=Te.exec(oe);return Be?[{start:Be.index,end:Be.index+Be[0].length}]:he?w(G,oe):d(G,oe)}e.matchesFuzzy=m;function k(G,oe){const he=Ke(G,G.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return he?L(he):null}e.matchesFuzzy2=k;function R(G,oe,he,Te,Be,He){const Qe=Math.min(13,G.length);for(;he<Qe;he++){const et=Ke(G,oe,he,Te,Be,He,!1);if(et)return et}return[0,He]}e.anyScore=R;function L(G){if(typeof G=="undefined")return[];const oe=[],he=G[1];for(let Te=G.length-1;Te>1;Te--){const Be=G[Te]+he,He=oe[oe.length-1];He&&He.end===Be?He.end=Be+1:oe.push({start:Be,end:Be+1})}return oe}e.createMatches=L;const b=128;function B(){const G=[],oe=[];for(let he=0;he<=b;he++)oe[he]=0;for(let he=0;he<=b;he++)G.push(oe.slice(0));return G}function $(G){const oe=[];for(let he=0;he<=G;he++)oe[he]=0;return oe}const x=$(2*b),K=$(2*b),H=B(),W=B(),ne=B(),V=!1;function J(G,oe,he,Te,Be){function He(et,ot,ye=" "){for(;et.length<ot;)et=ye+et;return et}let Qe=` |   |${Te.split("").map(et=>He(et,3)).join("|")}
`;for(let et=0;et<=he;et++)et===0?Qe+=" |":Qe+=`${oe[et-1]}|`,Qe+=G[et].slice(0,Be+1).map(ot=>He(ot.toString(),3)).join("|")+`
`;return Qe}function j(G,oe,he,Te){G=G.substr(oe),he=he.substr(Te),console.log(J(W,G,G.length,he,he.length)),console.log(J(ne,G,G.length,he,he.length)),console.log(J(H,G,G.length,he,he.length))}function le(G,oe){if(oe<0||oe>=G.length)return!1;const he=G.codePointAt(oe);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function ee(G,oe){if(oe<0||oe>=G.length)return!1;switch(G.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ve(G,oe,he){return oe[G]!==he[G]}function Re(G,oe,he,Te,Be,He,Qe=!1){for(;oe<he&&Be<He;)G[oe]===Te[Be]&&(Qe&&(x[oe]=Be),oe+=1),Be+=1;return oe===he}e.isPatternInWord=Re;var Fe;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var Oe;(function(G){G.Default=[-100,0];function oe(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}G.isDefault=oe})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function Ke(G,oe,he,Te,Be,He,Qe){const et=G.length>b?b:G.length,ot=Te.length>b?b:Te.length;if(he>=et||He>=ot||et-he>ot-He||!Re(oe,he,et,Be,He,ot,!0))return;je(et,ot,he,He,oe,Be);let ye=1,nt=1,q=he,Z=He;const pe=[!1];for(ye=1,q=he;q<et;ye++,q++){const dt=x[q],St=K[q],It=q+1<et?K[q+1]:ot;for(nt=dt-He+1,Z=dt;Z<It;nt++,Z++){let Tt=Number.MIN_SAFE_INTEGER,Xe=!1;Z<=St&&(Tt=Ve(G,oe,q,he,Te,Be,Z,ot,He,H[ye-1][nt-1]===0,pe));let vt=0;Tt!==Number.MAX_SAFE_INTEGER&&(Xe=!0,vt=Tt+W[ye-1][nt-1]);const Pe=Z>dt,Se=Pe?W[ye][nt-1]+(H[ye][nt-1]>0?-5:0):0,Ce=Z>dt+1&&H[ye][nt-1]>0,ie=Ce?W[ye][nt-2]+(H[ye][nt-2]>0?-5:0):0;if(Ce&&(!Pe||ie>=Se)&&(!Xe||ie>=vt))W[ye][nt]=ie,ne[ye][nt]=3,H[ye][nt]=0;else if(Pe&&(!Xe||Se>=vt))W[ye][nt]=Se,ne[ye][nt]=2,H[ye][nt]=0;else if(Xe)W[ye][nt]=vt,ne[ye][nt]=1,H[ye][nt]=H[ye-1][nt-1]+1;else throw new Error("not possible")}}if(V&&j(G,he,Te,He),!pe[0]&&!Qe)return;ye--,nt--;const We=[W[ye][nt],He];let Ye=0,rt=0;for(;ye>=1;){let dt=nt;do{const St=ne[ye][dt];if(St===3)dt=dt-2;else if(St===2)dt=dt-1;else break}while(dt>=1);Ye>1&&oe[he+ye-1]===Be[He+nt-1]&&!ve(dt+He-1,Te,Be)&&Ye+1>H[ye][dt]&&(dt=nt),dt===nt?Ye++:Ye=1,rt||(rt=dt),ye--,nt=dt-1,We.push(nt)}ot===et&&(We[0]+=2);const ft=rt-et;return We[0]-=ft,We}e.fuzzyScore=Ke;function je(G,oe,he,Te,Be,He){let Qe=G-1,et=oe-1;for(;Qe>=he&&et>=Te;)Be[Qe]===He[et]&&(K[Qe]=et,Qe--),et--}function Ve(G,oe,he,Te,Be,He,Qe,et,ot,ye,nt){if(oe[he]!==He[Qe])return Number.MIN_SAFE_INTEGER;let q=1,Z=!1;return Qe===he-Te?q=G[he]===Be[Qe]?7:5:ve(Qe,Be,He)&&(Qe===0||!ve(Qe-1,Be,He))?(q=G[he]===Be[Qe]?7:5,Z=!0):le(He,Qe)&&(Qe===0||!le(He,Qe-1))?q=5:(le(He,Qe-1)||ee(He,Qe-1))&&(q=5,Z=!0),q>1&&he===Te&&(nt[0]=!0),Z||(Z=ve(Qe,Be,He)||le(He,Qe-1)||ee(He,Qe-1)),he===Te?Qe>ot&&(q-=Z?3:5):ye?q+=Z?2:0:q+=Z?0:1,Qe+1===et&&(q-=Z?3:5),q}function U(G,oe,he,Te,Be,He,Qe){return te(G,oe,he,Te,Be,He,!0,Qe)}e.fuzzyScoreGracefulAggressive=U;function Q(G,oe,he,Te,Be,He,Qe){return te(G,oe,he,Te,Be,He,!1,Qe)}e.fuzzyScoreGraceful=Q;function te(G,oe,he,Te,Be,He,Qe,et){let ot=Ke(G,oe,he,Te,Be,He,et);if(ot&&!Qe)return ot;if(G.length>=3){const ye=Math.min(7,G.length-1);for(let nt=he+1;nt<ye;nt++){const q=ae(G,nt);if(q){const Z=Ke(q,q.toLowerCase(),he,Te,Be,He,et);Z&&(Z[0]-=3,(!ot||Z[0]>ot[0])&&(ot=Z))}}}return ot}function ae(G,oe){if(oe+1>=G.length)return;const he=G[oe],Te=G[oe+1];if(he!==Te)return G.slice(0,oe)+Te+he+G.slice(oe+2)}}),define(be[107],Ee([0,1,34,106,9]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${A.source}`,"g");function C(c){return c.replace(F,(p,P)=>P?p:`\\${p}`)}e.escapeIcons=C;const S=new RegExp(`\\\\${A.source}`,"g");function T(c){return c.replace(S,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=T;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function y(c){return c.indexOf(e.iconStartMarker)===-1?c:c.replace(t,(p,P,D,l)=>D?p:P||l||"")}e.stripIcons=y;function n(c){const p=c.indexOf(e.iconStartMarker);return p===-1?{text:c}:f(c,p)}e.parseLabelWithIcons=n;function f(c,p){const P=[];let D="";function l(o){if(o){D+=o;for(const d of o)P.push(i)}}let u=-1,_="",i=0,g,a,r=p;const v=c.length;for(l(c.substr(0,p));r<v;)g=c[r],a=c[r+1],g===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(u=r,l(_),_=e.iconStartMarker,r++):g===")"&&u!==-1?(i+=r-u+1,u=-1,_=""):u!==-1?/^[a-z0-9\-]$/i.test(g)?_+=g:(l(_),u=-1,_=""):l(g),r++;return l(_),{text:D,iconOffsets:P}}function s(c,p,P=!1){const{text:D,iconOffsets:l}=p;if(!l||l.length===0)return(0,M.matchesFuzzy)(c,D,P);const u=(0,E.ltrim)(D," "),_=D.length-u.length,i=(0,M.matchesFuzzy)(c,u,P);if(i)for(const g of i){const a=l[g.start+_]+_;g.start+=a,g.end+=a}return i}e.matchesFuzzyIconAware=s}),define(be[77],Ee([0,1,16,107]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(f="",s=!1){if(this.value=f,typeof this.value!="string")throw(0,h.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(f,s=0){return this.value+=T(this.supportThemeIcons?(0,M.escapeIcons)(f):f).replace(/([ \t]+)/g,(c,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,s){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=A;function F(n){return C(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function C(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function S(n,f){return n===f?!0:!n||!f?!1:n.value===f.value&&n.isTrusted===f.isTrusted&&n.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=S;function T(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function y(n){const f=[],s=n.split("|").map(p=>p.trim());n=s[0];const c=s[1];if(c){const p=/height=(\d+)/.exec(c),P=/width=(\d+)/.exec(c),D=p?p[1]:"",l=P?P[1]:"",u=isFinite(parseInt(l)),_=isFinite(parseInt(D));u&&f.push(`width="${l}"`),_&&f.push(`height="${D}"`)}return{href:n,dimensions:f}}e.parseHrefAndDimensions=y}),define(be[55],Ee([0,1,22,9,2]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,S)}e.stringify=A;function F(t){let y=JSON.parse(t);return y=T(y),y}e.parse=F;var C;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function S(t,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,M.regExpFlags)(y)}:y}function T(t,y=0){if(!t||y>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof h.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=T(t[n],y+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=T(t[n],y+1))}return t}e.revive=T}),define(be[11],Ee([0,1,25,2]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,T,t){this._hosts[S]=T,this._ports[S]=t}setConnectionToken(S,T){this._connectionTokens[S]=T}rewrite(S){if(this._delegate)return this._delegate(S);const T=S.authority;let t=this._hosts[T];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const y=this._ports[T],n=this._connectionTokens[T];let f=`path=${encodeURIComponent(S.path)}`;return typeof n=="string"&&(f+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:h.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${y}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new A;class F{asBrowserUri(S,T){const t=this.toUri(S,T);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(h.isNative||typeof h.globals.importScripts=="function"&&h.globals.origin===`${E.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(S,T){const t=this.toUri(S,T);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(S,T){return M.URI.isUri(S)?S:M.URI.parse(T.toUrl(S))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(be[24],Ee([0,1,43,11,17,25,9,2]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(f){return(0,C.uriToFsPath)(f,!0)}e.originalFSPath=S;class T{constructor(s){this._ignorePathCasing=s}compare(s,c,p=!1){return s===c?0:(0,F.compare)(this.getComparisonKey(s,p),this.getComparisonKey(c,p))}isEqual(s,c,p=!1){return s===c?!0:!s||!c?!1:this.getComparisonKey(s,p)===this.getComparisonKey(c,p)}getComparisonKey(s,c=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,c,p=!1){if(s.scheme===c.scheme){if(s.scheme===M.Schemas.file)return h.isEqualOrParent(S(s),S(c),this._ignorePathCasing(s))&&s.query===c.query&&(p||s.fragment===c.fragment);if((0,e.isEqualAuthority)(s.authority,c.authority))return h.isEqualOrParent(s.path,c.path,this._ignorePathCasing(s),"/")&&s.query===c.query&&(p||s.fragment===c.fragment)}return!1}joinPath(s,...c){return C.URI.joinPath(s,...c)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return E.posix.basename(s.path)}extname(s){return E.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let c;return s.scheme===M.Schemas.file?c=C.URI.file(E.dirname(S(s))).path:(c=E.posix.dirname(s.path),s.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),c="/")),s.with({path:c})}normalizePath(s){if(!s.path.length)return s;let c;return s.scheme===M.Schemas.file?c=C.URI.file(E.normalize(S(s))).path:c=E.posix.normalize(s.path),s.with({path:c})}relativePath(s,c){if(s.scheme!==c.scheme||!(0,e.isEqualAuthority)(s.authority,c.authority))return;if(s.scheme===M.Schemas.file){const D=E.relative(S(s),S(c));return A.isWindows?h.toSlashes(D):D}let p=s.path||"/",P=c.path||"/";if(this._ignorePathCasing(s)){let D=0;for(const l=Math.min(p.length,P.length);D<l&&!(p.charCodeAt(D)!==P.charCodeAt(D)&&p.charAt(D).toLowerCase()!==P.charAt(D).toLowerCase());D++);p=P.substr(0,D)+p.substr(D)}return E.posix.relative(p,P)}resolvePath(s,c){if(s.scheme===M.Schemas.file){const p=C.URI.file(E.resolve(S(s),c));return s.with({authority:p.authority,path:p.path})}return c=h.toPosixPath(c),s.with({path:E.posix.resolve(s.path,c)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,c){return s===c||(0,F.equalsIgnoreCase)(s,c)}hasTrailingPathSeparator(s,c=E.sep){if(s.scheme===M.Schemas.file){const p=S(s);return p.length>h.getRoot(p).length&&p[p.length-1]===c}else{const p=s.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,c=E.sep){return(0,e.hasTrailingPathSeparator)(s,c)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,c=E.sep){let p=!1;if(s.scheme===M.Schemas.file){const P=S(s);p=P!==void 0&&P.length===h.getRoot(P).length&&P[P.length-1]===c}else{c="/";const P=s.path;p=P.length===1&&P.charCodeAt(P.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(s,c)?s.with({path:s.path+"/"}):s}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(f=>f.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(f,s){const c=[];for(let p=0;p<f.length;p++){const P=s(f[p]);f.some((D,l)=>l===p?!1:(0,e.isEqualOrParent)(P,s(D)))||c.push(f[p])}return c}e.distinctParents=t;var y;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function s(c){const p=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(l=>{const[u,_]=l.split(":");u&&_&&p.set(u,_)});const D=c.path.substring(0,c.path.indexOf(";"));return D&&p.set(f.META_DATA_MIME,D),p}f.parseMetaData=s})(y=e.DataUri||(e.DataUri={}));function n(f,s,c){if(s){let p=f.path;return p&&p[0]!==E.posix.sep&&(p=E.posix.sep+p),f.with({scheme:c,authority:s,path:p})}return f.with({scheme:c})}e.toLocalResource=n}),define(be[12],Ee([0,1,21,16,3,6,24]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(H){return!!H&&typeof H.then=="function"}e.isThenable=C;function S(H){const W=new h.CancellationTokenSource,ne=H(W.token),V=new Promise((J,j)=>{const le=W.token.onCancellationRequested(()=>{le.dispose(),W.dispose(),j((0,M.canceled)())});Promise.resolve(ne).then(ee=>{le.dispose(),W.dispose(),J(ee)},ee=>{le.dispose(),W.dispose(),j(ee)})});return new class{cancel(){W.cancel()}then(J,j){return V.then(J,j)}catch(J){return this.then(void 0,J)}finally(J){return V.finally(J)}}}e.createCancelablePromise=S;function T(H,W,ne){return Promise.race([H,new Promise(V=>W.onCancellationRequested(()=>V(ne)))])}e.raceCancellation=T;async function t(H){let W=-1;const ne=H.map((J,j)=>J.then(le=>(W=j,le))),V=await Promise.race(ne);return H.forEach((J,j)=>{j!==W&&J.cancel()}),V}e.raceCancellablePromises=t;function y(H,W,ne){let V;const J=setTimeout(()=>{V?.(void 0),ne?.()},W);return Promise.race([H.finally(()=>clearTimeout(J)),new Promise(j=>V=j)])}e.raceTimeout=y;function n(H){return new Promise((W,ne)=>{const V=H();C(V)?V.then(W,ne):W(V)})}e.asPromise=n;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const ne=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(ne,ne).then(V)})}return new Promise((ne,V)=>{this.queuedPromise.then(ne,V)})}return this.activePromise=W(),new Promise((ne,V)=>{this.activePromise.then(J=>{this.activePromise=null,ne(J)},J=>{this.activePromise=null,V(J)})})}}e.Throttler=f;class s{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=s;class c{constructor(){this.promiseMap=new Map}queue(W,ne){const J=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.promiseMap.get(W)===J&&this.promiseMap.delete(W)});return this.promiseMap.set(W,J),J}}e.SequencerByKey=c;class p{constructor(W){this.defaultDelay=W,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,ne=this.defaultDelay){return this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,J)=>{this.doResolve=V,this.doReject=J}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ne),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class P{constructor(W){this.delayer=new p(W),this.throttler=new f}trigger(W,ne){return this.delayer.trigger(()=>this.throttler.queue(W),ne)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class D{constructor(){this._isOpen=!1,this._promise=new Promise((W,ne)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=D;class l extends D{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function u(H,W){return W?new Promise((ne,V)=>{const J=setTimeout(()=>{j.dispose(),ne()},H),j=W.onCancellationRequested(()=>{clearTimeout(J),j.dispose(),V((0,M.canceled)())})}):S(ne=>u(H,ne))}e.timeout=u;function _(H,W=0){const ne=setTimeout(H,W);return(0,A.toDisposable)(()=>clearTimeout(ne))}e.disposableTimeout=_;function i(H){const W=[];let ne=0;const V=H.length;function J(){return ne<V?H[ne++]():null}function j(le){le!=null&&W.push(le);const ee=J();return ee?ee.then(j):Promise.resolve(W)}return Promise.resolve(null).then(j)}e.sequence=i;function g(H,W=V=>!!V,ne=null){let V=0;const J=H.length,j=()=>{if(V>=J)return Promise.resolve(ne);const le=H[V++];return Promise.resolve(le()).then(ve=>W(ve)?Promise.resolve(ve):j())};return j()}e.first=g;function a(H,W=V=>!!V,ne=null){if(H.length===0)return Promise.resolve(ne);let V=H.length;const J=()=>{V=-1;for(const j of H)j.cancel?.()};return new Promise((j,le)=>{for(const ee of H)ee.then(ve=>{--V>=0&&W(ve)?(J(),j(ve)):V===0&&j(ne)}).catch(ve=>{--V>=0&&(J(),le(ve))})})}e.firstParallel=a;class r{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(W){return this._size++,new Promise((ne,V)=>{this.outstandingPromises.push({factory:W,c:ne,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const ne=W.factory();ne.then(W.c,W.e),ne.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class v extends r{constructor(){super(1)}}e.Queue=v;class o{constructor(){this.queues=new Map}queueFor(W,ne=F.extUri){const V=ne.getComparisonKey(W);let J=this.queues.get(V);return J||(J=new v,E.Event.once(J.onFinished)(()=>{J?.dispose(),this.queues.delete(V)}),this.queues.set(V,J)),J}dispose(){this.queues.forEach(W=>W.dispose()),this.queues.clear()}}e.ResourceQueue=o;class d{constructor(W,ne){this._token=-1,typeof W=="function"&&typeof ne=="number"&&this.setIfNotSet(W,ne)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,ne){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},ne)}setIfNotSet(W,ne){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},ne))}}e.TimeoutTimer=d;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,ne){this.cancel(),this._token=setInterval(()=>{W()},ne)}}e.IntervalTimer=w;class I{constructor(W,ne){this.timeoutToken=-1,this.runner=W,this.timeout=ne,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=I;class m{constructor(W,ne){ne%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=ne,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=m;class k extends I{constructor(W,ne){super(W,ne);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=k;class R extends A.Disposable{constructor(W,ne,V,J){super();this.maxWorkChunkSize=W,this.maxPendingWork=ne,this.throttleDelay=V,this.handler=J,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.maxPendingWork)return!1}else if(this.pending+W.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new I(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{const W=setTimeout(()=>{const V=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0,clearTimeout(W))}}}:e.runWhenIdle=(H,W)=>{const ne=requestIdleCallback(H,typeof W=="number"?{timeout:W}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(ne))}}}}();class L{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(ne){this._error=ne}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function b(H,W,ne){let V;for(let J=0;J<ne;J++)try{return await H()}catch(j){V=j,await u(W)}throw V}e.retry=b;class B{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,ne,V){return this._pending={taskId:W,cancel:()=>V?.(),promise:ne},ne.then(()=>this.donePending(W),()=>this.donePending(W)),ne}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let ne,V;const J=new Promise((j,le)=>{ne=j,V=le});this._next={run:W,promise:J,promiseResolve:ne,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=B;class ${constructor(W){this.interval=W,this.lastIncrementTime=0,this.value=0}increment(){const W=Date.now();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,ne)=>{this.completeCallback=W,this.errorCallback=ne})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(W){return new Promise(ne=>{this.completeCallback(W),this.resolved=!0,ne()})}error(W){return new Promise(ne=>{this.errorCallback(W),this.rejected=!0,ne()})}cancel(){new Promise(W=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,W()})}}e.DeferredPromise=x;var K;(function(H){async function W(V){let J;const j=await Promise.all(V.map(le=>le.then(ee=>ee,ee=>{J||(J=ee)})));if(typeof J!="undefined")throw J;return j}H.settled=W;function ne(V){return new Promise(async(J,j)=>{try{await V(J,j)}catch(le){j(le)}})}H.withAsyncBody=ne})(K=e.Promises||(e.Promises={}))}),define(be[108],Ee([0,1,12,17]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new h.IdleValue(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),A=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(I,m,k=!1){const R=I||"",L=m||"",b=E.value.collator.compare(R,L);return E.value.collatorIsNumeric&&b===0&&R!==L?R<L?-1:1:b}e.compareFileNames=C;function S(I,m){const k=A.value.collator;return I=I||"",m=m||"",_(k,I,m)}e.compareFileNamesDefault=S;function T(I,m){const k=A.value.collator;return I=I||"",m=m||"",r(I,m)||_(k,I,m)}e.compareFileNamesUpper=T;function t(I,m){const k=A.value.collator;return I=I||"",m=m||"",a(I,m)||_(k,I,m)}e.compareFileNamesLower=t;function y(I,m){return I=I||"",m=m||"",I===m?0:I<m?-1:1}e.compareFileNamesUnicode=y;function n(I,m,k=!1){k||(I=I&&I.toLowerCase(),m=m&&m.toLowerCase());const[R,L]=l(I),[b,B]=l(m);return R!==b?R<b?-1:1:L===B?0:L<B?-1:1}e.noIntlCompareFileNames=n;function f(I,m){const[k,R]=l(I),[L,b]=l(m);let B=E.value.collator.compare(R,b);if(B===0){if(E.value.collatorIsNumeric&&R!==b)return R<b?-1:1;if(B=E.value.collator.compare(k,L),E.value.collatorIsNumeric&&B===0&&k!==L)return k<L?-1:1}return B}e.compareFileExtensions=f;function s(I,m){I=I||"",m=m||"";const k=u(I),R=u(m),L=A.value.collator,b=F.value.collator;return _(b,k,R)||_(L,I,m)}e.compareFileExtensionsDefault=s;function c(I,m){I=I||"",m=m||"";const k=u(I),R=u(m),L=A.value.collator,b=F.value.collator;return _(b,k,R)||r(I,m)||_(L,I,m)}e.compareFileExtensionsUpper=c;function p(I,m){I=I||"",m=m||"";const k=u(I),R=u(m),L=A.value.collator,b=F.value.collator;return _(b,k,R)||a(I,m)||_(L,I,m)}e.compareFileExtensionsLower=p;function P(I,m){I=I||"",m=m||"";const k=u(I).toLowerCase(),R=u(m).toLowerCase();return k!==R?k<R?-1:1:I!==m?I<m?-1:1:0}e.compareFileExtensionsUnicode=P;const D=/^(.*?)(\.([^.]*))?$/;function l(I,m=!1){const k=I?D.exec(I):[];let R=[k&&k[1]||"",k&&k[3]||""];return m&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function u(I){const m=I?D.exec(I):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function _(I,m,k){let R=I.compare(m,k);return R!==0?R:m.length!==k.length?m.length<k.length?-1:1:0}function i(I){const m=I.charAt(0);return m.toLocaleUpperCase()!==m}function g(I){const m=I.charAt(0);return m.toLocaleLowerCase()!==m}function a(I,m){return i(I)&&g(m)?-1:g(I)&&i(m)?1:0}function r(I,m){return g(I)&&i(m)?-1:i(I)&&g(m)?1:0}function v(I,m,k=!1){return k||(I=I&&I.toLowerCase(),m=m&&m.toLowerCase()),I===m?0:I<m?-1:1}function o(I,m,k=!1){const R=I.split(M.sep),L=m.split(M.sep),b=R.length-1,B=L.length-1;let $,x;for(let K=0;;K++){if($=b===K,x=B===K,$&&x)return C(R[K],L[K],k);if($)return-1;if(x)return 1;const H=v(R[K],L[K],k);if(H!==0)return H}}e.comparePaths=o;function d(I,m,k){const R=I.toLowerCase(),L=m.toLowerCase(),b=w(I,m,k);if(b)return b;const B=R.endsWith(k),$=L.endsWith(k);if(B!==$)return B?-1:1;const x=C(R,L);return x!==0?x:R.localeCompare(L)}e.compareAnything=d;function w(I,m,k){const R=I.toLowerCase(),L=m.toLowerCase(),b=R.startsWith(k),B=L.startsWith(k);if(b!==B)return b?-1:1;if(b&&B){if(R.length<L.length)return-1;if(R.length>L.length)return 1}return 0}e.compareByPrefix=w}),define(be[27],Ee([0,1,12,43,20,17,9]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const S="**",T="/",t="[/\\\\]",y="[^/\\\\]",n=/\//g;function f(V){switch(V){case 0:return"";case 1:return`${y}*?`;default:return`(?:${t}|${y}+${t}|${t}${y}+)*?`}}function s(V,J){if(!V)return[];const j=[];let le=!1,ee=!1,ve="";for(const Re of V){switch(Re){case J:if(!le&&!ee){j.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ve+=Re}return ve&&j.push(ve),j}e.splitGlobAware=s;function c(V){if(!V)return"";let J="";const j=s(V,T);if(j.every(le=>le===S))J=".*";else{let le=!1;j.forEach((ee,ve)=>{if(ee===S){le||(J+=f(2),le=!0);return}let Re=!1,Fe="",Oe=!1,Ke="";for(const je of ee){if(je!=="}"&&Re){Fe+=je;continue}if(Oe&&(je!=="]"||!Ke)){let Ve;je==="-"?Ve=je:(je==="^"||je==="!")&&!Ke?Ve="^":je===T?Ve="":Ve=F.escapeRegExpCharacters(je),Ke+=Ve;continue}switch(je){case"{":Re=!0;continue;case"[":Oe=!0;continue;case"}":J+=`(?:${s(Fe,",").map(Q=>c(Q)).join("|")})`,Re=!1,Fe="";break;case"]":J+="["+Ke+"]",Oe=!1,Ke="";break;case"?":J+=y;continue;case"*":J+=f(1);continue;default:J+=F.escapeRegExpCharacters(je)}}ve<j.length-1&&(j[ve+1]!==S||ve+2<j.length)&&(J+=t),le=!1})}return J}const p=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,_=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),g=function(){return!1},a=function(){return null};function r(V,J){if(!V)return a;let j;typeof V!="string"?j=V.pattern:j=V,j=j.trim();const le=`${j}_${!!J.trimForExclusions}`;let ee=i.get(le);if(ee)return v(ee,V);let ve;if(p.test(j)){const Re=j.substr(4);ee=function(Fe,Oe){return typeof Fe=="string"&&Fe.endsWith(Re)?j:null}}else(ve=P.exec(o(j,J)))?ee=d(ve[1],j):(J.trimForExclusions?l:D).test(j)?ee=w(j,J):(ve=u.exec(o(j,J)))?ee=I(ve[1].substr(1),j,!0):(ve=_.exec(o(j,J)))?ee=I(ve[1],j,!1):ee=m(j);return i.set(le,ee),v(ee,V)}function v(V,J){return typeof J=="string"?V:function(j,le){return M.isEqualOrParent(j,J.base)?V(A.relative(J.base,j),le):null}}function o(V,J){return J.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function d(V,J){const j=`/${V}`,le=`\\${V}`,ee=function(Re,Fe){return typeof Re!="string"?null:Fe?Fe===V?J:null:Re===V||Re.endsWith(j)||Re.endsWith(le)?J:null},ve=[V];return ee.basenames=ve,ee.patterns=[J],ee.allBasenames=ve,ee}function w(V,J){const j=ne(V.slice(1,-1).split(",").map(Fe=>r(Fe,J)).filter(Fe=>Fe!==a),V),le=j.length;if(!le)return a;if(le===1)return j[0];const ee=function(Fe,Oe){for(let Ke=0,je=j.length;Ke<je;Ke++)if(j[Ke](Fe,Oe))return V;return null},ve=j.find(Fe=>!!Fe.allBasenames);ve&&(ee.allBasenames=ve.allBasenames);const Re=j.reduce((Fe,Oe)=>Oe.allPaths?Fe.concat(Oe.allPaths):Fe,[]);return Re.length&&(ee.allPaths=Re),ee}function I(V,J,j){const le=A.sep===A.posix.sep,ee=le?V:V.replace(n,A.sep),ve=A.sep+ee,Re=A.posix.sep+V,Fe=j?function(Oe,Ke){return typeof Oe=="string"&&(Oe===ee||Oe.endsWith(ve)||!le&&(Oe===V||Oe.endsWith(Re)))?J:null}:function(Oe,Ke){return typeof Oe=="string"&&(Oe===ee||!le&&Oe===V)?J:null};return Fe.allPaths=[(j?"*/":"./")+V],Fe}function m(V){try{const J=new RegExp(`^${c(V)}$`);return function(j){return J.lastIndex=0,typeof j=="string"&&J.test(j)?V:null}}catch(J){return a}}function k(V,J,j){return!V||typeof J!="string"?!1:R(V)(J,void 0,j)}e.match=k;function R(V,J={}){if(!V)return g;if(typeof V=="string"||$(V)){const j=r(V,J);if(j===a)return g;const le=function(ee,ve){return!!j(ee,ve)};return j.allBasenames&&(le.allBasenames=j.allBasenames),j.allPaths&&(le.allPaths=j.allPaths),le}return H(V,J)}e.parse=R;function L(V){if(!V)return;let J;return j=>(J||(J=(V()||Promise.resolve([])).then(le=>le?B(le):{})),J.then(le=>!!le[j]))}e.hasSiblingPromiseFn=L;function b(V){if(!V)return;let J;return j=>{if(!J){const le=V();J=le?B(le):{}}return!!J[j]}}e.hasSiblingFn=b;function B(V){const J={};for(const j of V)J[j]=!0;return J}function $(V){const J=V;return J&&typeof J.base=="string"&&typeof J.pattern=="string"}e.isRelativePattern=$;function x(V){return V.allBasenames||[]}e.getBasenameTerms=x;function K(V){return V.allPaths||[]}e.getPathTerms=K;function H(V,J){const j=ne(Object.getOwnPropertyNames(V).map(Fe=>W(Fe,V[Fe],J)).filter(Fe=>Fe!==a)),le=j.length;if(!le)return a;if(!j.some(Fe=>!!Fe.requiresSiblings)){if(le===1)return j[0];const Fe=function(je,Ve){for(let U=0,Q=j.length;U<Q;U++){const te=j[U](je,Ve);if(te)return te}return null},Oe=j.find(je=>!!je.allBasenames);Oe&&(Fe.allBasenames=Oe.allBasenames);const Ke=j.reduce((je,Ve)=>Ve.allPaths?je.concat(Ve.allPaths):je,[]);return Ke.length&&(Fe.allPaths=Ke),Fe}const ee=function(Fe,Oe,Ke){let je;for(let Ve=0,U=j.length;Ve<U;Ve++){const Q=j[Ve];Q.requiresSiblings&&Ke&&(Oe||(Oe=A.basename(Fe)),je||(je=Oe.substr(0,Oe.length-A.extname(Fe).length)));const te=Q(Fe,Oe,je,Ke);if(te)return te}return null},ve=j.find(Fe=>!!Fe.allBasenames);ve&&(ee.allBasenames=ve.allBasenames);const Re=j.reduce((Fe,Oe)=>Oe.allPaths?Fe.concat(Oe.allPaths):Fe,[]);return Re.length&&(ee.allPaths=Re),ee}function W(V,J,j){if(J===!1)return a;const le=r(V,j);if(le===a)return a;if(typeof J=="boolean")return le;if(J){const ee=J.when;if(typeof ee=="string"){const ve=(Re,Fe,Oe,Ke)=>{if(!Ke||!le(Re,Fe))return null;const je=ee.replace("$(basename)",Oe),Ve=Ke(je);return(0,h.isThenable)(Ve)?Ve.then(U=>U?V:null):Ve?V:null};return ve.requiresSiblings=!0,ve}}return le}function ne(V,J){const j=V.filter(Fe=>!!Fe.basenames);if(j.length<2)return V;const le=j.reduce((Fe,Oe)=>{const Ke=Oe.basenames;return Ke?Fe.concat(Ke):Fe},[]);let ee;if(J){ee=[];for(let Fe=0,Oe=le.length;Fe<Oe;Fe++)ee.push(J)}else ee=j.reduce((Fe,Oe)=>{const Ke=Oe.patterns;return Ke?Fe.concat(Ke):Fe},[]);const ve=function(Fe,Oe){if(typeof Fe!="string")return null;if(!Oe){let je;for(je=Fe.length;je>0;je--){const Ve=Fe.charCodeAt(je-1);if(Ve===47||Ve===92)break}Oe=Fe.substr(je)}const Ke=le.indexOf(Oe);return Ke!==-1?ee[Ke]:null};ve.basenames=le,ve.patterns=ee,ve.allBasenames=le;const Re=V.filter(Fe=>!Fe.basenames);return Re.push(ve),Re}}),define(be[78],Ee([0,1,43,11,17,25,24,9,2]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(r,v,o){if(typeof r=="string"&&(r=S.URI.file(r)),o){const w=o.getWorkspaceFolder(r);if(w){const I=o.getWorkspace().folders.length>1;let m;if((0,F.isEqual)(w.uri,r)?m="":m=(0,F.relativePath)(w.uri,r),I){const k=w.name?w.name:(0,F.basename)(w.uri);m=m?k+" \u2022 "+m:k}return m}}if(r.scheme!==M.Schemas.file&&r.scheme!==M.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(r.fsPath))return(0,E.normalize)(y(r.fsPath));let d=(0,E.normalize)(r.fsPath);return!A.isWindows&&v?.userHome&&(d=f(d,v.userHome.fsPath)),d}e.getPathLabel=T;function t(r){if(!r)return;typeof r=="string"&&(r=S.URI.file(r));const v=(0,F.basename)(r)||(r.scheme===M.Schemas.file?r.fsPath:r.path);return A.isWindows&&(0,h.isRootOrDriveLetter)(v)?y(v):v}e.getBaseLabel=t;function y(r){return(0,h.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=y;let n=Object.create(null);function f(r,v){if(A.isWindows||!r||!v)return r;let o=n.original===v?n.normalized:void 0;return o||(o=`${(0,C.rtrim)(v,E.posix.sep)}${E.posix.sep}`,n={original:v,normalized:o}),(A.isLinux?r.startsWith(o):(0,C.startsWithIgnoreCase)(r,o))&&(r=`~/${r.substr(o.length)}`),r}e.tildify=f;function s(r,v){return r.replace(/^~($|\/|\\)/,`${v}$1`)}e.untildify=s;const c="\u2026",p="\\\\",P="~";function D(r,v=E.sep){const o=new Array(r.length);let d=!1;for(let w=0;w<r.length;w++){let I=r[w];if(I===""){o[w]=`.${v}`;continue}if(!I){o[w]=I;continue}d=!0;let m="";I.indexOf(p)===0?(m=I.substr(0,I.indexOf(p)+p.length),I=I.substr(I.indexOf(p)+p.length)):I.indexOf(v)===0?(m=I.substr(0,I.indexOf(v)+v.length),I=I.substr(I.indexOf(v)+v.length)):I.indexOf(P)===0&&(m=I.substr(0,I.indexOf(P)+P.length),I=I.substr(I.indexOf(P)+P.length));const k=I.split(v);for(let R=1;d&&R<=k.length;R++)for(let L=k.length-R;d&&L>=0;L--){d=!1;let b=k.slice(L,L+R).join(v);for(let B=0;!d&&B<r.length;B++)if(B!==w&&r[B]&&r[B].indexOf(b)>-1){const $=L+R===k.length,x=L>0&&r[B].indexOf(v)>-1?v+b:b,K=r[B].endsWith(x);d=!$||K}if(!d){let B="";(k[0].endsWith(":")||m!=="")&&(L===1&&(L=0,R++,b=k[0]+v+b),L>0&&(B=k[0]+v),B=m+B),L>0&&(B=B+c+v),B=B+b,L+R<k.length&&(B=B+v+c),o[w]=B}}d&&(o[w]=I)}return o}e.shorten=D;var l;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function u(r,v=Object.create(null)){const o=[];let d=!1,w="";for(const I of r)if(I==="$"||d&&I==="{")w&&o.push({value:w,type:l.TEXT}),w="",d=!0;else if(I==="}"&&d){const m=v[w];if(typeof m=="string")m.length&&o.push({value:m,type:l.VARIABLE});else if(m){const k=o[o.length-1];(!k||k.type!==l.SEPARATOR)&&o.push({value:m.label,type:l.SEPARATOR})}w="",d=!1}else w+=I;return w&&!d&&o.push({value:w,type:l.TEXT}),o.filter((I,m)=>{if(I.type===l.SEPARATOR){const k=o[m-1],R=o[m+1];return[k,R].every(L=>L&&(L.type===l.VARIABLE||L.type===l.TEXT)&&L.value.length>0)}return!0}).map(I=>I.value).join("")}e.template=u;function _(r,v){return A.isMacintosh||v?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=_;function i(r,v){return A.isMacintosh||v?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,o=>o==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function g(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=g;function a(r){const v=r.indexOf("/")!==-1?E.posix:E.win32,o=v.basename(r),d=v.dirname(r);return o.length?{name:o,parentPath:d}:{name:d,parentPath:""}}e.splitName=a}),define(be[79],Ee([0,1,27,11,17,24,9]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown",r.latex="text/latex"})(C=e.Mimes||(e.Mimes={}));let S=[],T=[],t=[];function y(r,v=!1){const o=n(r);S.push(o),o.userConfigured?t.push(o):T.push(o),v&&!o.userConfigured&&S.forEach(d=>{d.mime===o.mime||d.userConfigured||(o.extension&&d.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&d.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&d.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&d.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=y;function n(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,h.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(E.posix.sep)>=0:!1}}function f(r){r?(S=S.filter(v=>!v.userConfigured),t=[]):(S=[],T=[],t=[])}e.clearTextMimes=f;function s(r,v){let o;if(r)switch(r.scheme){case M.Schemas.file:o=r.fsPath;break;case M.Schemas.data:o=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:o=r.path}if(!o)return[C.unknown];o=o.toLowerCase();const d=(0,E.basename)(o),w=c(o,d,t);if(w)return[w,C.text];const I=c(o,d,T);if(I)return[I,C.text];if(v){const m=p(v);if(m)return[m,C.text]}return[C.unknown]}e.guessMimeTypes=s;function c(r,v,o){let d=null,w=null,I=null;for(let m=o.length-1;m>=0;m--){const k=o[m];if(v===k.filenameLowercase){d=k;break}if(k.filepattern&&(!w||k.filepattern.length>w.filepattern.length)){const R=k.filepatternOnPath?r:v;k.filepatternLowercase?.(R)&&(w=k)}k.extension&&(!I||k.extension.length>I.extension.length)&&v.endsWith(k.extensionLowercase)&&(I=k)}return d?d.mime:w?w.mime:I?I.mime:null}function p(r){if((0,F.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let v=S.length-1;v>=0;v--){const o=S[v];if(!o.firstline)continue;const d=r.match(o.firstline);if(d&&d.length>0)return o.mime}return null}function P(r){return r?typeof r=="string"?r===C.binary||r===C.text||r===C.unknown:r.length===1&&P(r[0]):!0}e.isUnspecific=P;const D={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function u(r){const v=(0,E.extname)(r),o=D[v.toLowerCase()];return o!==void 0?o:_(r)}e.getMediaOrTextMime=u;function _(r){const v=(0,E.extname)(r);return l[v.toLowerCase()]}e.getMediaMime=_;function i(r){for(const v in l)if(l[v]===r)return v}e.getExtensionForMimeType=i;const g=/^(.+)\/(.+?)(;.+)?$/;function a(r,v){const o=g.exec(r);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:v?void 0:r}e.normalizeMimeType=a}),define(be[109],Ee([0,1,2]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class E{constructor(y){this._uriTransformer=y}transformIncoming(y){const n=this._uriTransformer.transformIncoming(y);return n===y?y:M(h.URI.from(n))}transformOutgoing(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:M(h.URI.from(n))}transformOutgoingURI(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:h.URI.from(n)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,y,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof h.URI)return y.transformOutgoing(t);for(let f in t)if(Object.hasOwnProperty.call(t,f)){const s=A(t[f],y,n+1);s!==null&&(t[f]=s)}}return null}function F(t,y){const n=A(t,y,0);return n===null?t:n}e.transformOutgoingURIs=F;function C(t,y,n,f){if(!t||f>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?h.URI.revive(y.transformIncoming(t)):y.transformIncoming(t);for(let s in t)if(Object.hasOwnProperty.call(t,s)){const c=C(t[s],y,n,f+1);c!==null&&(t[s]=c)}}return null}function S(t,y){const n=C(t,y,!1,0);return n===null?t:n}e.transformIncomingURIs=S;function T(t,y){const n=C(t,y,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=T}),define(be[36],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(S){return h.test(S)}e.isUUID=M;const E=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(S){for(let T=0;T<S.length;T++)S[T]=Math.floor(Math.random()*256);return S};function C(){F(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let S=0,T="";return T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T+="-",T+=A[E[S++]],T+=A[E[S++]],T+="-",T+=A[E[S++]],T+=A[E[S++]],T+="-",T+=A[E[S++]],T+=A[E[S++]],T+="-",T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T+=A[E[S++]],T}e.generateUuid=C}),define(be[110],Ee([0,1,227]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends h.CharacterClassifier{constructor(C){super(0);for(let S=0,T=C.length;S<T;S++)this.set(C.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function A(F){let C={};return S=>(C.hasOwnProperty(S)||(C[S]=F(S)),C[S])}e.getMapForWordSeparators=A(F=>new E(F))}),define(be[80],Ee([0,1,23]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.BracketPairWithMinIndentation=e.BracketPair=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),this.indentSize=_.tabSize|0,this.insertSpaces=Boolean(_.insertSpaces),this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=Boolean(_.trimAutoWhitespace),this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,h.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class T{constructor(_,i){this._findMatchBrand=void 0,this.range=_,this.matches=i}}e.FindMatch=T;var t;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var y;(function(u){u[u.Disabled=0]="Disabled",u[u.EnabledForActive=1]="EnabledForActive",u[u.Enabled=2]="Enabled"})(y=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class n{constructor(_,i,g){this.visibleColumn=_,this.className=i,this.horizontalLine=g}}e.IndentGuide=n;class f{constructor(_,i){this.top=_,this.endColumn=i}}e.IndentGuideHorizontalLine=f;class s{constructor(_,i,g,a){this.range=_,this.openingBracketRange=i,this.closingBracketRange=g,this.nestingLevel=a}}e.BracketPair=s;class c extends s{constructor(_,i,g,a,r){super(_,i,g,a);this.minVisibleColumnIndentation=r}}e.BracketPairWithMinIndentation=c;var p;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None"})(p=e.PositionAffinity||(e.PositionAffinity={}));var P;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class D{constructor(_,i,g,a,r,v){this.identifier=_,this.range=i,this.text=g,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=r,this._isTracked=v}}e.ValidAnnotatedEditOperation=D;class l{constructor(_,i,g){this.reverseEdits=_,this.changes=i,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=l}),define(be[111],Ee([0,1,9,110,112,44,80]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class S{constructor(l,u,_,i){this.searchString=l,this.isRegex=u,this.matchCase=_,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=T(this.searchString):l=this.searchString.indexOf(`
`)>=0;let u=null;try{u=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(i){return null}if(!u)return null;let _=!this.isRegex&&!l;return _&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(_=this.matchCase),new t(u,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,_?this.searchString:null)}}e.SearchParams=S;function T(D){if(!D||D.length===0)return!1;for(let l=0,u=D.length;l<u;l++)if(D.charCodeAt(l)===92){if(l++,l>=u)break;const i=D.charCodeAt(l);if(i===110||i===114||i===87)return!0}return!1}e.isMultilineRegexSource=T;class t{constructor(l,u,_){this.regex=l,this.wordSeparators=u,this.simpleSearch=_}}e.SearchData=t;function y(D,l,u){if(!u)return new F.FindMatch(D,null);let _=[];for(let i=0,g=l.length;i<g;i++)_[i]=l[i];return new F.FindMatch(D,_)}e.createFindMatch=y;class n{constructor(l){let u=[],_=0;for(let i=0,g=l.length;i<g;i++)l.charCodeAt(i)===10&&(u[_++]=i);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(l){const u=this._lineFeedsOffsets;let _=0,i=u.length-1;if(i===-1||l<=u[0])return 0;for(;_<i;){const g=_+((i-_)/2>>0);u[g]>=l?i=g-1:u[g+1]>=l?(_=g,i=g):_=g+1}return _+1}}class f{static findMatches(l,u,_,i,g){const a=u.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(l,_,new P(a.wordSeparators,a.regex),i,g):this._doFindMatchesLineByLine(l,_,a,i,g):[]}static _getMultilineMatchRange(l,u,_,i,g,a){let r,v=0;i?(v=i.findLineFeedCountBeforeOffset(g),r=u+g+v):r=u+g;let o;if(i){let m=i.findLineFeedCountBeforeOffset(g+a.length)-v;o=r+a.length+m}else o=r+a.length;const d=l.getPositionAt(r),w=l.getPositionAt(o);return new A.Range(d.lineNumber,d.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(l,u,_,i,g){const a=l.getOffsetAt(u.getStartPosition()),r=l.getValueInRange(u,1),v=l.getEOL()===`\r
`?new n(r):null,o=[];let d=0,w;for(_.reset(0);w=_.next(r);)if(o[d++]=y(this._getMultilineMatchRange(l,a,r,v,w.index,w[0]),w,i),d>=g)return o;return o}static _doFindMatchesLineByLine(l,u,_,i,g){const a=[];let r=0;if(u.startLineNumber===u.endLineNumber){const o=l.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return r=this._findMatchesInLine(_,o,u.startLineNumber,u.startColumn-1,r,a,i,g),a}const v=l.getLineContent(u.startLineNumber).substring(u.startColumn-1);r=this._findMatchesInLine(_,v,u.startLineNumber,u.startColumn-1,r,a,i,g);for(let o=u.startLineNumber+1;o<u.endLineNumber&&r<g;o++)r=this._findMatchesInLine(_,l.getLineContent(o),o,0,r,a,i,g);if(r<g){const o=l.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);r=this._findMatchesInLine(_,o,u.endLineNumber,0,r,a,i,g)}return a}static _findMatchesInLine(l,u,_,i,g,a,r,v){const o=l.wordSeparators;if(!r&&l.simpleSearch){const I=l.simpleSearch,m=I.length,k=u.length;let R=-m;for(;(R=u.indexOf(I,R+m))!==-1;)if((!o||p(o,u,k,R,m))&&(a[g++]=new F.FindMatch(new A.Range(_,R+1+i,_,R+1+m+i),null),g>=v))return g;return g}const d=new P(l.wordSeparators,l.regex);let w;d.reset(0);do if(w=d.next(u),w&&(a[g++]=y(new A.Range(_,w.index+1+i,_,w.index+1+w[0].length+i),w,r),g>=v))return g;while(w);return g}static findNextMatch(l,u,_,i){const g=u.parseSearchRequest();if(!g)return null;const a=new P(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindNextMatchMultiline(l,_,a,i):this._doFindNextMatchLineByLine(l,_,a,i)}static _doFindNextMatchMultiline(l,u,_,i){const g=new E.Position(u.lineNumber,1),a=l.getOffsetAt(g),r=l.getLineCount(),v=l.getValueInRange(new A.Range(g.lineNumber,g.column,r,l.getLineMaxColumn(r)),1),o=l.getEOL()===`\r
`?new n(v):null;_.reset(u.column-1);let d=_.next(v);return d?y(this._getMultilineMatchRange(l,a,v,o,d.index,d[0]),d,i):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(l,new E.Position(1,1),_,i):null}static _doFindNextMatchLineByLine(l,u,_,i){const g=l.getLineCount(),a=u.lineNumber,r=l.getLineContent(a),v=this._findFirstMatchInLine(_,r,a,u.column,i);if(v)return v;for(let o=1;o<=g;o++){const d=(a+o-1)%g,w=l.getLineContent(d+1),I=this._findFirstMatchInLine(_,w,d+1,1,i);if(I)return I}return null}static _findFirstMatchInLine(l,u,_,i,g){l.reset(i-1);const a=l.next(u);return a?y(new A.Range(_,a.index+1,_,a.index+1+a[0].length),a,g):null}static findPreviousMatch(l,u,_,i){const g=u.parseSearchRequest();if(!g)return null;const a=new P(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindPreviousMatchMultiline(l,_,a,i):this._doFindPreviousMatchLineByLine(l,_,a,i)}static _doFindPreviousMatchMultiline(l,u,_,i){const g=this._doFindMatchesMultiline(l,new A.Range(1,1,u.lineNumber,u.column),_,i,10*C);if(g.length>0)return g[g.length-1];const a=l.getLineCount();return u.lineNumber!==a||u.column!==l.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(l,new E.Position(a,l.getLineMaxColumn(a)),_,i):null}static _doFindPreviousMatchLineByLine(l,u,_,i){const g=l.getLineCount(),a=u.lineNumber,r=l.getLineContent(a).substring(0,u.column-1),v=this._findLastMatchInLine(_,r,a,i);if(v)return v;for(let o=1;o<=g;o++){const d=(g+a-o-1)%g,w=l.getLineContent(d+1),I=this._findLastMatchInLine(_,w,d+1,i);if(I)return I}return null}static _findLastMatchInLine(l,u,_,i){let g=null,a;for(l.reset(0);a=l.next(u);)g=y(new A.Range(_,a.index+1,_,a.index+1+a[0].length),a,i);return g}}e.TextModelSearch=f;function s(D,l,u,_,i){if(_===0)return!0;const g=l.charCodeAt(_-1);if(D.get(g)!==0||g===13||g===10)return!0;if(i>0){const a=l.charCodeAt(_);if(D.get(a)!==0)return!0}return!1}function c(D,l,u,_,i){if(_+i===u)return!0;const g=l.charCodeAt(_+i);if(D.get(g)!==0||g===13||g===10)return!0;if(i>0){const a=l.charCodeAt(_+i-1);if(D.get(a)!==0)return!0}return!1}function p(D,l,u,_,i){return s(D,l,u,_,i)&&c(D,l,u,_,i)}e.isValidMatch=p;class P{constructor(l,u){this._wordSeparators=l,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const u=l.length;let _;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(_=this._searchRegex.exec(l),!_))return null;const i=_.index,g=_[0].length;if(i===this._prevMatchStartIndex&&g===this._prevMatchLength){if(g===0){h.getNextCodePoint(l,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=g,!this._wordSeparators||p(this._wordSeparators,l,u,i,g))return _}while(_);return null}}e.Searcher=P}),define(be[113],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(h=e.IndentAction||(e.IndentAction={}));class M{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let S=0,T=C.notIn.length;S<T;S++)switch(C.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of C)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=E;function A(F,C,S){F.has(C)?F.get(C).push(S):F.set(C,[S])}}),define(be[56],Ee([0,1,27,17]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(A,F,C,S){if(Array.isArray(A)){let T=0;for(const t of A){const y=E(t,F,C,S);if(y===10)return y;y>T&&(T=y)}return T}else{if(typeof A=="string")return S?A==="*"?5:A===C?10:0:0;if(A){const{language:T,pattern:t,scheme:y,hasAccessToAllModels:n}=A;if(!S&&!n)return 0;let f=0;if(y)if(y===F.scheme)f=10;else if(y==="*")f=5;else return 0;if(T)if(T===C)f=10;else if(T==="*")f=Math.max(f,5);else return 0;if(t){let s;if(typeof t=="string"?s=t:s={...t,base:(0,M.normalize)(t.base)},s===F.fsPath||(0,h.match)(s,F.fsPath))f=10;else return 0}return f}else return 0}}e.score=E}),define(be[114],Ee([0,1,3,6]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,C){return this._map.set(F,C),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===C&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,C){let S=null,T=!1;return this._promises.set(F,C.then(t=>{this._promises.delete(F),!(T||!t)&&(S=this.register(F,t))})),(0,M.toDisposable)(()=>{T=!0,S&&S.dispose()})}getPromise(F){const C=this.get(F);if(C)return Promise.resolve(C);const S=this._promises.get(F);return S?S.then(T=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(be[81],Ee([0,1,22,25]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(E||(E={}));function A(y){for(let n=0,f=y.length;n<f;n+=4){const s=y[n+0],c=y[n+1],p=y[n+2],P=y[n+3];y[n+0]=P,y[n+1]=p,y[n+2]=c,y[n+3]=s}}function F(y){const n=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return M.isLittleEndian()||A(n),h.VSBuffer.wrap(n)}function C(y){const n=y.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const f=new Uint8Array(n.byteLength);return f.set(n),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function S(y){const n=new Uint32Array(T(y));let f=0;if(n[f++]=y.id,y.type==="full")n[f++]=1,n[f++]=y.data.length,n.set(y.data,f),f+=y.data.length;else{n[f++]=2,n[f++]=y.deltas.length;for(const s of y.deltas)n[f++]=s.start,n[f++]=s.deleteCount,s.data?(n[f++]=s.data.length,n.set(s.data,f),f+=s.data.length):n[f++]=0}return F(n)}e.encodeSemanticTokensDto=S;function T(y){let n=0;if(n+=1+1,y.type==="full")n+=1+y.data.length;else{n+=1,n+=(1+1+1)*y.deltas.length;for(const f of y.deltas)f.data&&(n+=f.data.length)}return n}function t(y){const n=C(y);let f=0;const s=n[f++];if(n[f++]===1){const D=n[f++],l=n.subarray(f,f+D);return f+=D,{id:s,type:"full",data:l}}const p=n[f++];let P=[];for(let D=0;D<p;D++){const l=n[f++],u=n[f++],_=n[f++];let i;_>0&&(i=n.subarray(f,f+_),f+=_),P[D]={start:l,deleteCount:u,data:i}}return{id:s,type:"delta",deltas:P}}e.decodeSemanticTokensDto=t}),define(be[115],Ee([18,19]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(be[45],Ee([0,1,14,10,115]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(T,t){return t&&(T.stack||T.stacktrace)?E.localize(0,null,C(T),F(T.stack)||F(T.stacktrace)):C(T)}function F(T){return Array.isArray(T)?T.join(`
`):T}function C(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?E.localize(1,null,T.message):T.message||E.localize(2,null)}function S(T=null,t=!1){if(!T)return E.localize(3,null);if(Array.isArray(T)){const y=h.coalesce(T),n=S(y[0],t);return y.length>1?E.localize(4,null,n,y.length):n}if(M.isString(T))return T;if(T.detail){const y=T.detail;if(y.error)return A(y.error,t);if(y.exception)return A(y.exception,t)}return T.stack?A(T,t):T.message?T.message:E.localize(5,null)}e.toErrorMessage=S}),define(be[116],Ee([18,19]),function(se,e){return se.create("vs/editor/common/config/editorOptions",e)}),define(be[117],Ee([0,1,116,25,118]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=F;class C{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,pe){this._values[Z]=pe}}e.ValidatedEditorOptions=C;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class T{constructor(Z,pe,We,Ye){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ye}compute(Z,pe,We){return We}}class t{constructor(Z,pe=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(Z){return this.defaultValue}}class y{constructor(Z,pe,We,Ye){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ye}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,pe,We){return We}}function n(q,Z){return typeof q=="undefined"?Z:q==="false"?!1:Boolean(q)}e.boolean=n;class f extends y{constructor(Z,pe,We,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=We),super(Z,pe,We,Ye)}validate(Z){return n(Z,this.defaultValue)}}function s(q,Z,pe,We){if(typeof q=="undefined")return Z;let Ye=parseInt(q,10);return isNaN(Ye)?Z:(Ye=Math.max(pe,Ye),Ye=Math.min(We,Ye),Ye|0)}e.clampedInt=s;class c extends y{constructor(Z,pe,We,Ye,rt,ft=void 0){typeof ft!="undefined"&&(ft.type="integer",ft.default=We,ft.minimum=Ye,ft.maximum=rt),super(Z,pe,We,ft),this.minimum=Ye,this.maximum=rt}static clampedInt(Z,pe,We,Ye){return s(Z,pe,We,Ye)}validate(Z){return c.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class p extends y{constructor(Z,pe,We,Ye,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=We),super(Z,pe,We,rt),this.validationFn=Ye}static clamp(Z,pe,We){return Z<pe?pe:Z>We?We:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return pe;const We=parseFloat(Z);return isNaN(We)?pe:We}validate(Z){return this.validationFn(p.float(Z,this.defaultValue))}}class P extends y{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,We,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=We),super(Z,pe,We,Ye)}validate(Z){return P.string(Z,this.defaultValue)}}function D(q,Z,pe){return typeof q!="string"||pe.indexOf(q)===-1?Z:q}e.stringSet=D;class l extends y{constructor(Z,pe,We,Ye,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Ye,rt.default=We),super(Z,pe,We,rt),this._allowedValues=Ye}validate(Z){return D(Z,this.defaultValue,this._allowedValues)}}class u extends T{constructor(Z,pe,We,Ye,rt,ft,dt=void 0){typeof dt!="undefined"&&(dt.type="string",dt.enum=rt,dt.default=Ye),super(Z,pe,We,dt),this._allowedValues=rt,this._convert=ft}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function _(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",description:h.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,We){return We===0?Z.accessibilitySupport:We}}class g extends T{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:h.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:n(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(q){switch(q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function d(q){switch(q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class w extends t{constructor(){super(126,[65,33])}compute(Z,pe,We){const Ye=["monaco-editor"];return pe.get(33)&&Ye.push(pe.get(33)),Z.extraEditorClassName&&Ye.push(Z.extraEditorClassName),pe.get(65)==="default"?Ye.push("mouse-default"):pe.get(65)==="copy"&&Ye.push("mouse-copy"),pe.get(99)&&Ye.push("showUnused"),pe.get(124)&&Ye.push("showDeprecated"),Ye.join(" ")}}class I extends f{constructor(){super(32,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(Z,pe,We){return We&&Z.emptySelectionClipboard}}class m extends T{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:h.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:h.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:n(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":D(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":D(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(pe.loop,this.defaultValue.loop)}}}class k extends T{constructor(){super(44,"fontLigatures",k.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?k.OFF:Z==="true"?k.ON:Z:Boolean(Z)?k.ON:k.OFF}}e.EditorFontLigatures=k,k.OFF='"liga" off, "calt" off',k.ON='"liga" on, "calt" on';class R extends t{constructor(){super(43)}compute(Z,pe,We){return Z.fontInfo}}class L extends y{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(22,null)})}validate(Z){let pe=p.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(pe,6,100)}compute(Z,pe,We){return Z.fontInfo.fontSize}}class b extends T{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:b.MINIMUM_VALUE,maximum:b.MAXIMUM_VALUE,errorMessage:h.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:b.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(24,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(c.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,b.MINIMUM_VALUE,b.MAXIMUM_VALUE))}}b.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],b.MINIMUM_VALUE=1,b.MAXIMUM_VALUE=1e3;class B extends T{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[h.localize(25,null),h.localize(26,null),h.localize(27,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:h.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:h.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:h.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:We,description:h.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:We,description:h.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:We,description:h.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:We,description:h.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:We,description:h.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{multiple:D(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??D(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??D(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??D(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??D(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??D(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:P.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:P.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:P.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:P.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:P.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends T{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(52,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:h.localize(39,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:h.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:h.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),delay:c.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:n(pe.sticky,this.defaultValue.sticky)}}}var x;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class K extends t{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(Z,pe,We){return K.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,We=Z.scrollBeyondLastLine?pe-1:0,Ye=(Z.viewLineCount+We)/(Z.pixelRatio*Z.height),rt=Math.floor(Z.viewLineCount/Ye);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:We,desiredRatio:Ye,minimapLineCount:rt}}static _computeMinimapLayout(Z,pe){const We=Z.outerWidth,Ye=Z.outerHeight,rt=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const ft=pe.stableMinimapLayoutInput,dt=ft&&Z.outerHeight===ft.outerHeight&&Z.lineHeight===ft.lineHeight&&Z.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&Z.pixelRatio===ft.pixelRatio&&Z.scrollBeyondLastLine===ft.scrollBeyondLastLine&&Z.minimap.enabled===ft.minimap.enabled&&Z.minimap.side===ft.minimap.side&&Z.minimap.size===ft.minimap.size&&Z.minimap.showSlider===ft.minimap.showSlider&&Z.minimap.renderCharacters===ft.minimap.renderCharacters&&Z.minimap.maxColumn===ft.minimap.maxColumn&&Z.minimap.scale===ft.minimap.scale&&Z.verticalScrollbarWidth===ft.verticalScrollbarWidth&&Z.isViewportWrapping===ft.isViewportWrapping,St=Z.lineHeight,It=Z.typicalHalfwidthCharacterWidth,Tt=Z.scrollBeyondLastLine,Xe=Z.minimap.renderCharacters;let vt=rt>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Pe=Z.minimap.maxColumn,Se=Z.minimap.size,Ce=Z.minimap.side,ie=Z.verticalScrollbarWidth,ue=Z.viewLineCount,me=Z.remainingWidth,fe=Z.isViewportWrapping,Ie=Xe?2:3;let xe=Math.floor(rt*Ye);const Ne=xe/rt;let qe=!1,it=!1,Le=Ie*vt,de=vt/rt,ge=1;if(Se==="fill"||Se==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:pt,desiredRatio:lt,minimapLineCount:gt}=K.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:Tt,height:Ye,lineHeight:St,pixelRatio:rt});if(ue/gt>1)qe=!0,it=!0,vt=1,Le=1,de=vt/rt;else{let _t=!1,wt=vt+1;if(Se==="fit"){const Ft=Math.ceil((ue+pt)*Le);fe&&dt&&me<=pe.stableFitRemainingWidth?(_t=!0,wt=pe.stableFitMaxMinimapScale):_t=Ft>xe}if(Se==="fill"||_t){qe=!0;const Ft=vt;Le=Math.min(St*rt,Math.max(1,Math.floor(1/lt))),fe&&dt&&me<=pe.stableFitRemainingWidth&&(wt=pe.stableFitMaxMinimapScale),vt=Math.min(wt,Math.max(1,Math.floor(Le/Ie))),vt>Ft&&(ge=Math.min(2,vt/Ft)),de=vt/rt/ge,xe=Math.ceil(Math.max(ct,ue+pt)*Le),fe?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=me,pe.stableFitMaxMinimapScale=vt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const X=Math.floor(Pe*de),z=Math.min(X,Math.max(0,Math.floor((me-ie-2)*de/(It+de)))+e.MINIMAP_GUTTER_WIDTH);let we=Math.floor(rt*z);const ke=we/rt;we=Math.floor(we*ge);const Je=Xe?1:2,Ue=Ce==="left"?0:We-z-ie;return{renderMinimap:Je,minimapLeft:Ue,minimapWidth:z,minimapHeightIsEditorHeight:qe,minimapIsSampling:it,minimapScale:vt,minimapLineHeight:Le,minimapCanvasInnerWidth:we,minimapCanvasInnerHeight:xe,minimapCanvasOuterWidth:ke,minimapCanvasOuterHeight:Ne}}static computeLayout(Z,pe){const We=pe.outerWidth|0,Ye=pe.outerHeight|0,rt=pe.lineHeight|0,ft=pe.lineNumbersDigitCount|0,dt=pe.typicalHalfwidthCharacterWidth,St=pe.maxDigitWidth,It=pe.pixelRatio,Tt=pe.viewLineCount,Xe=Z.get(121),vt=Xe==="inherit"?Z.get(120):Xe,Pe=vt==="inherit"?Z.get(116):vt,Se=Z.get(119),Ce=Z.get(2),ie=pe.isDominatedByLongLines,ue=Z.get(49),me=Z.get(59).renderType!==0,fe=Z.get(60),Ie=Z.get(93),xe=Z.get(64),Ne=Z.get(91),qe=Ne.verticalScrollbarSize,it=Ne.verticalHasArrows,Le=Ne.arrowSize,de=Ne.horizontalScrollbarSize,ge=Z.get(57),X=Z.get(37);let z;if(typeof ge=="string"&&/^\d+(\.\d+)?ch$/.test(ge)){const Mt=parseFloat(ge.substr(0,ge.length-2));z=c.clampedInt(Mt*dt,0,0,1e3)}else z=c.clampedInt(ge,0,0,1e3);X&&(z+=16);let we=0;if(me){const Mt=Math.max(ft,fe);we=Math.round(Mt*St)}let ke=0;ue&&(ke=rt);let Je=0,Ue=Je+ke,ct=Ue+we,pt=ct+z;const lt=We-ke-we-z;let gt=!1,ht=!1,_t=-1;Ce!==2&&(vt==="inherit"&&ie?(gt=!0,ht=!0):Pe==="on"||Pe==="bounded"?ht=!0:Pe==="wordWrapColumn"&&(_t=Se));const wt=K._computeMinimapLayout({outerWidth:We,outerHeight:Ye,lineHeight:rt,typicalHalfwidthCharacterWidth:dt,pixelRatio:It,scrollBeyondLastLine:Ie,minimap:xe,verticalScrollbarWidth:qe,viewLineCount:Tt,remainingWidth:lt,isViewportWrapping:ht},pe.memory||new S);wt.renderMinimap!==0&&wt.minimapLeft===0&&(Je+=wt.minimapWidth,Ue+=wt.minimapWidth,ct+=wt.minimapWidth,pt+=wt.minimapWidth);const Ft=lt-wt.minimapWidth,Vt=Math.max(1,Math.floor((Ft-qe-2)/dt)),Dt=it?Le:0;return ht&&(_t=Math.max(1,Vt),Pe==="bounded"&&(_t=Math.min(_t,Se))),{width:We,height:Ye,glyphMarginLeft:Je,glyphMarginWidth:ke,lineNumbersLeft:Ue,lineNumbersWidth:we,decorationsLeft:ct,decorationsWidth:z,contentLeft:pt,contentWidth:Ft,minimap:wt,viewportColumn:Vt,isWordWrapMinified:gt,isViewportWrapping:ht,wrappingColumn:_t,verticalScrollbarWidth:qe,horizontalScrollbarHeight:de,overviewRuler:{top:Dt,width:qe,height:Ye-2*Dt,right:0}}}}e.EditorLayoutInfoComputer=K;class H extends T{constructor(){const Z={enabled:!0};super(56,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:h.localize(42,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:n(Z.enabled,this.defaultValue.enabled)}}}class W extends T{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:h.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:h.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:h.localize(45,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:P.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class ne extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>p.clamp(Z,0,150),{markdownDescription:h.localize(46,null)})}compute(Z,pe,We){return Z.fontInfo.lineHeight}}class V extends T{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:h.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(48,null),h.localize(49,null),h.localize(50,null)],default:Z.size,description:h.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:h.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:h.localize(53,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:h.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:h.localize(56,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),size:D(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:D(pe.side,this.defaultValue.side,["right","left"]),showSlider:D(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(pe.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(pe.scale,1,1,3),maxColumn:c.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function J(q){return q==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(58,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:c.clampedInt(pe.top,0,0,1e3),bottom:c.clampedInt(pe.bottom,0,0,1e3)}}}class le extends T{constructor(){const Z={enabled:!0,cycle:!1};super(75,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:h.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:h.localize(60,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),cycle:n(pe.cycle,this.defaultValue.cycle)}}}class ee extends t{constructor(){super(127)}compute(Z,pe,We){return Z.pixelRatio}}class ve extends T{constructor(){const Z={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:h.localize(61,null)},comments:{type:"boolean",default:Z.comments,description:h.localize(62,null)},other:{type:"boolean",default:Z.other,description:h.localize(63,null)}}}],default:Z,description:h.localize(64,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const pe=Z,We={other:n(pe.other,this.defaultValue.other),comments:n(pe.comments,this.defaultValue.comments),strings:n(pe.strings,this.defaultValue.strings)};return We.other&&We.comments&&We.strings?!0:!We.other&&!We.comments&&!We.strings?!1:We}return this.defaultValue}}var Re;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(Re=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(65,null),h.localize(66,null),h.localize(67,null),h.localize(68,null)],default:"on",description:h.localize(69,null)})}validate(Z){let pe=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(pe=4,We=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:We}}}function Oe(q){const Z=q.get(86);return Z==="editable"?q.get(80):Z!=="on"}e.filterValidationDecorations=Oe;class Ke extends T{constructor(){const Z=[],pe={type:"number",description:h.localize(70,null)};super(90,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:h.localize(71,null),format:"color-hex"}}}]},default:Z,description:h.localize(72,null)})}validate(Z){if(Array.isArray(Z)){let pe=[];for(let We of Z)if(typeof We=="number")pe.push({column:c.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Ye=We;pe.push({column:c.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((We,Ye)=>We.column-Ye.column),pe}return this.defaultValue}}function je(q,Z){if(typeof q!="string")return Z;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ve extends T{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(73,null),h.localize(74,null),h.localize(75,null)],default:"auto",description:h.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(77,null),h.localize(78,null),h.localize(79,null)],default:"auto",description:h.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:h.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:h.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:h.localize(83,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,We=c.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=c.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(pe.vertical,this.defaultValue.vertical),horizontal:je(pe.horizontal,this.defaultValue.horizontal),useShadows:n(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:c.clampedInt(pe.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:c.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:n(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class U extends T{constructor(){const Z={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:h.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),mode:D(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends T{constructor(){const Z={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,description:h.localize(85,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:n(Z.enabled,this.defaultValue.enabled)}}}class te extends T{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],default:Z.bracketPairs,description:h.localize(86,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],default:Z.bracketPairsHorizontal,description:h.localize(87,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:h.localize(88,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:h.localize(89,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Z.highlightActiveIndentation,description:h.localize(90,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{bracketPairs:ae(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ae(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ae(q,Z,pe){const We=pe.indexOf(q);return We===-1?Z:pe[We]}class G extends T{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(91,null),h.localize(92,null)],default:Z.insertMode,description:h.localize(93,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:h.localize(94,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:h.localize(95,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:h.localize(96,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:h.localize(97,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:h.localize(98,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:h.localize(99,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:h.localize(100,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:h.localize(101,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(102,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(103,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(104,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(105,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(106,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(107,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(108,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(109,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(110,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(111,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(112,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(113,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(114,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(115,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(116,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(117,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(118,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(119,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(120,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(121,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(122,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(123,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(124,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(125,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(126,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(127,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(128,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(129,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(130,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(131,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:D(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(pe.showIcons,this.defaultValue.showIcons),showStatusBar:n(pe.showStatusBar,this.defaultValue.showStatusBar),preview:n(pe.preview,this.defaultValue.preview),previewMode:D(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(pe.showMethods,this.defaultValue.showMethods),showFunctions:n(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:n(pe.showFields,this.defaultValue.showFields),showVariables:n(pe.showVariables,this.defaultValue.showVariables),showClasses:n(pe.showClasses,this.defaultValue.showClasses),showStructs:n(pe.showStructs,this.defaultValue.showStructs),showInterfaces:n(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(pe.showModules,this.defaultValue.showModules),showProperties:n(pe.showProperties,this.defaultValue.showProperties),showEvents:n(pe.showEvents,this.defaultValue.showEvents),showOperators:n(pe.showOperators,this.defaultValue.showOperators),showUnits:n(pe.showUnits,this.defaultValue.showUnits),showValues:n(pe.showValues,this.defaultValue.showValues),showConstants:n(pe.showConstants,this.defaultValue.showConstants),showEnums:n(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(pe.showKeywords,this.defaultValue.showKeywords),showWords:n(pe.showWords,this.defaultValue.showWords),showColors:n(pe.showColors,this.defaultValue.showColors),showFiles:n(pe.showFiles,this.defaultValue.showFiles),showReferences:n(pe.showReferences,this.defaultValue.showReferences),showFolders:n(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(pe.showSnippets,this.defaultValue.showSnippets),showUsers:n(pe.showUsers,this.defaultValue.showUsers),showIssues:n(pe.showIssues,this.defaultValue.showIssues)}}}class oe extends T{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(133,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class he extends t{constructor(){super(128,[80])}compute(Z,pe,We){return pe.get(80)?!0:Z.tabFocusMode}}var Te;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(Te=e.WrappingIndent||(e.WrappingIndent={}));function Be(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class He extends t{constructor(){super(130,[129])}compute(Z,pe,We){const Ye=pe.get(129);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const Qe="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",ot="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?et:M.isLinux?ot:Qe,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(q){return e.editorOptionsRegistry[q.id]=q,q}var nt;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=42]="fontFamily",q[q.fontInfo=43]="fontInfo",q[q.fontLigatures=44]="fontLigatures",q[q.fontSize=45]="fontSize",q[q.fontWeight=46]="fontWeight",q[q.formatOnPaste=47]="formatOnPaste",q[q.formatOnType=48]="formatOnType",q[q.glyphMargin=49]="glyphMargin",q[q.gotoLocation=50]="gotoLocation",q[q.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",q[q.hover=52]="hover",q[q.inDiffEditor=53]="inDiffEditor",q[q.inlineSuggest=54]="inlineSuggest",q[q.letterSpacing=55]="letterSpacing",q[q.lightbulb=56]="lightbulb",q[q.lineDecorationsWidth=57]="lineDecorationsWidth",q[q.lineHeight=58]="lineHeight",q[q.lineNumbers=59]="lineNumbers",q[q.lineNumbersMinChars=60]="lineNumbersMinChars",q[q.linkedEditing=61]="linkedEditing",q[q.links=62]="links",q[q.matchBrackets=63]="matchBrackets",q[q.minimap=64]="minimap",q[q.mouseStyle=65]="mouseStyle",q[q.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=67]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",q[q.multiCursorModifier=69]="multiCursorModifier",q[q.multiCursorPaste=70]="multiCursorPaste",q[q.occurrencesHighlight=71]="occurrencesHighlight",q[q.overviewRulerBorder=72]="overviewRulerBorder",q[q.overviewRulerLanes=73]="overviewRulerLanes",q[q.padding=74]="padding",q[q.parameterHints=75]="parameterHints",q[q.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",q[q.quickSuggestions=78]="quickSuggestions",q[q.quickSuggestionsDelay=79]="quickSuggestionsDelay",q[q.readOnly=80]="readOnly",q[q.renameOnType=81]="renameOnType",q[q.renderControlCharacters=82]="renderControlCharacters",q[q.renderFinalNewline=83]="renderFinalNewline",q[q.renderLineHighlight=84]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=86]="renderValidationDecorations",q[q.renderWhitespace=87]="renderWhitespace",q[q.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",q[q.roundedSelection=89]="roundedSelection",q[q.rulers=90]="rulers",q[q.scrollbar=91]="scrollbar",q[q.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=93]="scrollBeyondLastLine",q[q.scrollPredominantAxis=94]="scrollPredominantAxis",q[q.selectionClipboard=95]="selectionClipboard",q[q.selectionHighlight=96]="selectionHighlight",q[q.selectOnLineNumbers=97]="selectOnLineNumbers",q[q.showFoldingControls=98]="showFoldingControls",q[q.showUnused=99]="showUnused",q[q.snippetSuggestions=100]="snippetSuggestions",q[q.smartSelect=101]="smartSelect",q[q.smoothScrolling=102]="smoothScrolling",q[q.stickyTabStops=103]="stickyTabStops",q[q.stopRenderingLineAfter=104]="stopRenderingLineAfter",q[q.suggest=105]="suggest",q[q.suggestFontSize=106]="suggestFontSize",q[q.suggestLineHeight=107]="suggestLineHeight",q[q.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",q[q.suggestSelection=109]="suggestSelection",q[q.tabCompletion=110]="tabCompletion",q[q.tabIndex=111]="tabIndex",q[q.unusualLineTerminators=112]="unusualLineTerminators",q[q.useShadowDOM=113]="useShadowDOM",q[q.useTabStops=114]="useTabStops",q[q.wordSeparators=115]="wordSeparators",q[q.wordWrap=116]="wordWrap",q[q.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=119]="wordWrapColumn",q[q.wordWrapOverride1=120]="wordWrapOverride1",q[q.wordWrapOverride2=121]="wordWrapOverride2",q[q.wrappingIndent=122]="wrappingIndent",q[q.wrappingStrategy=123]="wrappingStrategy",q[q.showDeprecated=124]="showDeprecated",q[q.inlayHints=125]="inlayHints",q[q.editorClassName=126]="editorClassName",q[q.pixelRatio=127]="pixelRatio",q[q.tabFocusMode=128]="tabFocusMode",q[q.layoutInfo=129]="layoutInfo",q[q.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(134,null)})),acceptSuggestionOnEnter:ye(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(135,null),""],markdownDescription:h.localize(136,null)})),accessibilitySupport:ye(new i),accessibilityPageSize:ye(new c(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(137,null)})),ariaLabel:ye(new P(4,"ariaLabel",h.localize(138,null))),autoClosingBrackets:ye(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(139,null),h.localize(140,null),""],description:h.localize(141,null)})),autoClosingDelete:ye(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(142,null),""],description:h.localize(143,null)})),autoClosingOvertype:ye(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(144,null),""],description:h.localize(145,null)})),autoClosingQuotes:ye(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(146,null),h.localize(147,null),""],description:h.localize(148,null)})),autoIndent:ye(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],_,{enumDescriptions:[h.localize(149,null),h.localize(150,null),h.localize(151,null),h.localize(152,null),h.localize(153,null)],description:h.localize(154,null)})),automaticLayout:ye(new f(10,"automaticLayout",!1)),autoSurround:ye(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(155,null),h.localize(156,null),h.localize(157,null),""],description:h.localize(158,null)})),bracketPairColorization:ye(new Q),bracketPairGuides:ye(new te),stickyTabStops:ye(new f(103,"stickyTabStops",!1,{description:h.localize(159,null)})),codeLens:ye(new f(14,"codeLens",!0,{description:h.localize(160,null)})),codeLensFontFamily:ye(new P(15,"codeLensFontFamily","",{description:h.localize(161,null)})),codeLensFontSize:ye(new c(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(162,null)})),colorDecorators:ye(new f(17,"colorDecorators",!0,{description:h.localize(163,null)})),columnSelection:ye(new f(18,"columnSelection",!1,{description:h.localize(164,null)})),comments:ye(new g),contextmenu:ye(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new f(21,"copyWithSyntaxHighlighting",!0,{description:h.localize(165,null)})),cursorBlinking:ye(new u(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:h.localize(166,null)})),cursorSmoothCaretAnimation:ye(new f(23,"cursorSmoothCaretAnimation",!1,{description:h.localize(167,null)})),cursorStyle:ye(new u(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],d,{description:h.localize(168,null)})),cursorSurroundingLines:ye(new c(25,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(169,null)})),cursorSurroundingLinesStyle:ye(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(170,null),h.localize(171,null)],description:h.localize(172,null)})),cursorWidth:ye(new c(27,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(173,null)})),disableLayerHinting:ye(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new f(30,"domReadOnly",!1)),dragAndDrop:ye(new f(31,"dragAndDrop",!0,{description:h.localize(174,null)})),emptySelectionClipboard:ye(new I),extraEditorClassName:ye(new P(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new p(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:h.localize(175,null)})),find:ye(new m),fixedOverflowWidgets:ye(new f(36,"fixedOverflowWidgets",!1)),folding:ye(new f(37,"folding",!0,{description:h.localize(176,null)})),foldingStrategy:ye(new l(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(177,null),h.localize(178,null)],description:h.localize(179,null)})),foldingHighlight:ye(new f(39,"foldingHighlight",!0,{description:h.localize(180,null)})),foldingImportsByDefault:ye(new f(40,"foldingImportsByDefault",!1,{description:h.localize(181,null)})),unfoldOnClickAfterEndOfLine:ye(new f(41,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(182,null)})),fontFamily:ye(new P(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(183,null)})),fontInfo:ye(new R),fontLigatures2:ye(new k),fontSize:ye(new L),fontWeight:ye(new b),formatOnPaste:ye(new f(47,"formatOnPaste",!1,{description:h.localize(184,null)})),formatOnType:ye(new f(48,"formatOnType",!1,{description:h.localize(185,null)})),glyphMargin:ye(new f(49,"glyphMargin",!0,{description:h.localize(186,null)})),gotoLocation:ye(new B),hideCursorInOverviewRuler:ye(new f(51,"hideCursorInOverviewRuler",!1,{description:h.localize(187,null)})),hover:ye(new $),inDiffEditor:ye(new f(53,"inDiffEditor",!1)),letterSpacing:ye(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>p.clamp(q,-5,20),{description:h.localize(188,null)})),lightbulb:ye(new H),lineDecorationsWidth:ye(new y(57,"lineDecorationsWidth",10)),lineHeight:ye(new ne),lineNumbers:ye(new Fe),lineNumbersMinChars:ye(new c(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new f(61,"linkedEditing",!1,{description:h.localize(189,null)})),links:ye(new f(62,"links",!0,{description:h.localize(190,null)})),matchBrackets:ye(new l(63,"matchBrackets","always",["always","near","never"],{description:h.localize(191,null)})),minimap:ye(new V),mouseStyle:ye(new l(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new p(66,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:h.localize(192,null)})),mouseWheelZoom:ye(new f(67,"mouseWheelZoom",!1,{markdownDescription:h.localize(193,null)})),multiCursorMergeOverlapping:ye(new f(68,"multiCursorMergeOverlapping",!0,{description:h.localize(194,null)})),multiCursorModifier:ye(new u(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],J,{markdownEnumDescriptions:[h.localize(195,null),h.localize(196,null)],markdownDescription:h.localize(197,null)})),multiCursorPaste:ye(new l(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(198,null),h.localize(199,null)],markdownDescription:h.localize(200,null)})),occurrencesHighlight:ye(new f(71,"occurrencesHighlight",!0,{description:h.localize(201,null)})),overviewRulerBorder:ye(new f(72,"overviewRulerBorder",!0,{description:h.localize(202,null)})),overviewRulerLanes:ye(new c(73,"overviewRulerLanes",3,0,3)),padding:ye(new j),parameterHints:ye(new le),peekWidgetDefaultFocus:ye(new l(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(203,null),h.localize(204,null)],description:h.localize(205,null)})),definitionLinkOpensInPeek:ye(new f(77,"definitionLinkOpensInPeek",!1,{description:h.localize(206,null)})),quickSuggestions:ye(new ve),quickSuggestionsDelay:ye(new c(79,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(207,null)})),readOnly:ye(new f(80,"readOnly",!1)),renameOnType:ye(new f(81,"renameOnType",!1,{description:h.localize(208,null),markdownDeprecationMessage:h.localize(209,null)})),renderControlCharacters:ye(new f(82,"renderControlCharacters",!1,{description:h.localize(210,null)})),renderFinalNewline:ye(new f(83,"renderFinalNewline",!0,{description:h.localize(211,null)})),renderLineHighlight:ye(new l(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(212,null)],description:h.localize(213,null)})),renderLineHighlightOnlyWhenFocus:ye(new f(85,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(214,null)})),renderValidationDecorations:ye(new l(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new l(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(215,null),h.localize(216,null),h.localize(217,null),""],description:h.localize(218,null)})),revealHorizontalRightPadding:ye(new c(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new f(89,"roundedSelection",!0,{description:h.localize(219,null)})),rulers:ye(new Ke),scrollbar:ye(new Ve),scrollBeyondLastColumn:ye(new c(92,"scrollBeyondLastColumn",5,0,1073741824,{description:h.localize(220,null)})),scrollBeyondLastLine:ye(new f(93,"scrollBeyondLastLine",!0,{description:h.localize(221,null)})),scrollPredominantAxis:ye(new f(94,"scrollPredominantAxis",!0,{description:h.localize(222,null)})),selectionClipboard:ye(new f(95,"selectionClipboard",!0,{description:h.localize(223,null),included:M.isLinux})),selectionHighlight:ye(new f(96,"selectionHighlight",!0,{description:h.localize(224,null)})),selectOnLineNumbers:ye(new f(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new l(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[h.localize(225,null),h.localize(226,null)],description:h.localize(227,null)})),showUnused:ye(new f(99,"showUnused",!0,{description:h.localize(228,null)})),showDeprecated:ye(new f(124,"showDeprecated",!0,{description:h.localize(229,null)})),inlayHints:ye(new W),snippetSuggestions:ye(new l(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(230,null),h.localize(231,null),h.localize(232,null),h.localize(233,null)],description:h.localize(234,null)})),smartSelect:ye(new oe),smoothScrolling:ye(new f(102,"smoothScrolling",!1,{description:h.localize(235,null)})),stopRenderingLineAfter:ye(new c(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new G),inlineSuggest:ye(new U),suggestFontSize:ye(new c(106,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(236,null)})),suggestLineHeight:ye(new c(107,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(237,null)})),suggestOnTriggerCharacters:ye(new f(108,"suggestOnTriggerCharacters",!0,{description:h.localize(238,null)})),suggestSelection:ye(new l(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(239,null),h.localize(240,null),h.localize(241,null)],description:h.localize(242,null)})),tabCompletion:ye(new l(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(243,null),h.localize(244,null),h.localize(245,null)],description:h.localize(246,null)})),tabIndex:ye(new c(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new l(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(247,null),h.localize(248,null),h.localize(249,null)],description:h.localize(250,null)})),useShadowDOM:ye(new f(113,"useShadowDOM",!0)),useTabStops:ye(new f(114,"useTabStops",!0,{description:h.localize(251,null)})),wordSeparators:ye(new P(115,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:h.localize(252,null)})),wordWrap:ye(new l(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(253,null),h.localize(254,null),h.localize(255,null),h.localize(256,null)],description:h.localize(257,null)})),wordWrapBreakAfterCharacters:ye(new P(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new P(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new c(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(258,null)})),wordWrapOverride1:ye(new l(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new l(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new u(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Be,{enumDescriptions:[h.localize(259,null),h.localize(260,null),h.localize(261,null),h.localize(262,null)],description:h.localize(263,null)})),wrappingStrategy:ye(new l(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[h.localize(264,null),h.localize(265,null)],description:h.localize(266,null)})),editorClassName:ye(new w),pixelRatio:ye(new ee),tabFocusMode:ye(new he),layoutInfo:ye(new K),wrappingInfo:ye(new He)}}),define(be[119],Ee([18,19]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[120],Ee([18,19]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[121],Ee([18,19]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(be[122],Ee([18,19]),function(se,e){return se.create("vs/platform/markers/common/markers",e)}),define(be[123],Ee([18,19]),function(se,e){return se.create("vs/platform/theme/common/iconRegistry",e)}),define(be[124],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[125],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[126],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostProgress",e)}),define(be[127],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[128],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[129],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[130],Ee([18,19]),function(se,e){return se.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[131],Ee([18,19]),function(se,e){return se.create("vs/workbench/common/editor",e)}),define(be[132],Ee([18,19]),function(se,e){return se.create("vs/workbench/common/views",e)}),define(be[133],Ee([18,19]),function(se,e){return se.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[134],Ee([18,19]),function(se,e){return se.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[135],Ee([18,19]),function(se,e){return se.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[136],Ee([18,19]),function(se,e){return se.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[137],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var h;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(h=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[138],Ee([0,1,120]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function F(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=n.match(M);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=F;function C(n){if(!n)return null;let f=n.majorBase,s=n.majorMustEqual,c=n.minorBase,p=n.minorMustEqual,P=n.patchBase,D=n.patchMustEqual;n.hasCaret&&(f===0||(p=!1),D=!1);let l=0;if(n.preRelease){const u=E.exec(n.preRelease);if(u){const[,_,i,g]=u;l=Date.UTC(Number(_),Number(i)-1,Number(g))}}return{majorBase:f,majorMustEqual:s,minorBase:c,minorMustEqual:p,patchBase:P,patchMustEqual:D,isMinimum:n.hasGreaterEquals,notBefore:l}}e.normalizeVersion=C;function S(n,f,s){let c;typeof n=="string"?c=C(F(n)):c=n;let p;f instanceof Date?p=f.getTime():typeof f=="string"&&(p=new Date(f).getTime());let P;if(typeof s=="string"?P=C(F(s)):P=s,!c||!P)return!1;let D=c.majorBase,l=c.minorBase,u=c.patchBase,_=P.majorBase,i=P.minorBase,g=P.patchBase,a=P.notBefore,r=P.majorMustEqual,v=P.minorMustEqual,o=P.patchMustEqual;return P.isMinimum?D>_?!0:D<_?!1:l>i?!0:l<i||p&&p<a?!1:u>=g:(D===1&&_===0&&(!r||!v||!o)&&(_=1,i=0,g=0,r=!0,v=!1,o=!1),D<_?!1:D>_?!r:l<i?!1:l>i?!v:u<g?!1:u>g?!o:!(p&&p<a))}e.isValidVersion=S;function T(n,f,s,c){return s.isBuiltin||typeof s.main=="undefined"?!0:y(n,f,s.engines.vscode,c)}e.isValidExtensionVersion=T;function t(n,f,s){return n==="*"||y(f,s,n)}e.isEngineValid=t;function y(n,f,s,c=[]){let p=C(F(s));if(!p)return c.push(h.localize(0,null,s)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return c.push(h.localize(1,null,s)),!1}else if(!p.majorMustEqual)return c.push(h.localize(2,null,s)),!1;return S(n,f,p)?!0:(c.push(h.localize(3,null,n,s)),!1)}}),define(be[82],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(E,A=[],F=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=h}),define(be[57],Ee([0,1,82]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(F,C,S){C instanceof h.SyncDescriptor||(C=new h.SyncDescriptor(C,[],S)),M.push([F,C])}e.registerSingleton=E;function A(){return M}e.getSingletonServiceDescriptors=A}),define(be[139],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=h;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let F of this._nodes.values())F.outgoing.size===0&&A.push(F);return A}insertEdge(A,F){const C=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(F);C.outgoing.set(this._hashFn(F),S),S.incoming.set(this._hashFn(A),C)}removeNode(A){const F=this._hashFn(A);this._nodes.delete(F);for(let C of this._nodes.values())C.outgoing.delete(F),C.incoming.delete(F)}lookupOrInsertNode(A){const F=this._hashFn(A);let C=this._nodes.get(F);return C||(C=new h(A),this._nodes.set(F,C)),C}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[F,C]of this._nodes)A.push(`${F}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,F]of this._nodes){const C=new Set([A]),S=this._findCycle(F,C);if(S)return S}}_findCycle(A,F){for(let[C,S]of A.outgoing){if(F.has(C))return[...F,C].join(" -> ");F.add(C);const T=this._findCycle(S,F);if(T)return T;F.delete(C)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(T){return T[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(h=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(C,S,T,t){S[h.DI_TARGET]===S?S[h.DI_DEPENDENCIES].push({id:C,index:T,optional:t}):(S[h.DI_DEPENDENCIES]=[{id:C,index:T,optional:t}],S[h.DI_TARGET]=S)}function E(C){if(h.serviceIds.has(C))return h.serviceIds.get(C);const S=function(T,t,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(S,T,y,!1)};return S.toString=()=>C,h.serviceIds.set(C,S),S}e.createDecorator=E;function A(C){return C}e.refineServiceDecorator=A;function F(C){return function(S,T,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(C,S,t,!0)}}e.optional=F}),define(be[140],Ee([0,1,4]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,h.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[141],Ee([0,1,3,58,6,20,76,56,140]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(T):!!c.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new h.Emitter}get onDidChange(){return this._onDidChange.event}register(p,P){let D={selector:p,provider:P,_score:-1,_time:this._clock++};return this._entries.push(D),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(D){let l=this._entries.indexOf(D);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),D=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const P=[];for(let D of this._entries)D._score>0&&P.push(D.provider);return P}ordered(p){const P=[];return this._orderedForEach(p,D=>P.push(D.provider)),P}orderedGroups(p){const P=[];let D,l;return this._orderedForEach(p,u=>{D&&l===u._score?D.push(u.provider):(l=u._score,D=[u.provider],P.push(D))}),P}_orderedForEach(p,P){if(!!p){this._updateScores(p);for(const D of this._entries)D._score>0&&P(D)}}_updateScores(p){let P={uri:p.uri.toString(),language:p.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===P.language&&this._lastCandidate.uri===P.uri)){this._lastCandidate=P;for(let D of this._entries)if(D._score=(0,C.score)(D.selector,p.uri,p.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(p)),T(D.selector)&&D._score>0){for(let l of this._entries)l._score=0;D._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(p,P){return p._score<P._score?1:p._score>P._score?-1:p._time<P._time?1:p._time>P._time?-1:0}}e.LanguageFeatureRegistry=t;const y=new WeakMap;let n=0;function f(c){let p=y.get(c);return p===void 0&&(p=++n,y.set(c,p)),p}class s{constructor(p,P,D=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=P,this.max=D,this._cache=new A.LRUCache(50,.7)}_key(p){return p.id+this._registry.all(p).reduce((P,D)=>(0,M.doHash)(f(D),P),0)}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const P=this._key(p),D=this._cache.get(P);return this._clamp(D?.value)}update(p,P){const D=this._key(p);let l=this._cache.get(D);return l||(l=new F.MovingAverage,this._cache.set(D,l)),l.update(P),this.get(p)}}e.LanguageFeatureRequestDelays=s}),define(be[59],Ee([0,1,2,44,141,114,34]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(m){m[m.Null=0]="Null",m[m.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class S{constructor(k,R){this.language=k,this.id=R}}e.LanguageIdentifier=S;var T;(function(m){m[m.NotSet=-1]="NotSet",m[m.None=0]="None",m[m.Italic=1]="Italic",m[m.Bold=2]="Bold",m[m.Underline=4]="Underline"})(T=e.FontStyle||(e.FontStyle={}));var t;(function(m){m[m.None=0]="None",m[m.DefaultForeground=1]="DefaultForeground",m[m.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var y;(function(m){m[m.Other=0]="Other",m[m.Comment=1]="Comment",m[m.String=2]="String",m[m.RegEx=4]="RegEx"})(y=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(m){m[m.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",m[m.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",m[m.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",m[m.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",m[m.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",m[m.ITALIC_MASK=2048]="ITALIC_MASK",m[m.BOLD_MASK=4096]="BOLD_MASK",m[m.UNDERLINE_MASK=8192]="UNDERLINE_MASK",m[m.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",m[m.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",m[m.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",m[m.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",m[m.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",m[m.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",m[m.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",m[m.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",m[m.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",m[m.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&1792)>>>8}static getFontStyle(k){return(k&14336)>>>11}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){let R=this.getForeground(k),L="mtk"+R,b=this.getFontStyle(k);return b&1&&(L+=" mtki"),b&2&&(L+=" mtkb"),b&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(k,R){const L=this.getForeground(k),b=this.getFontStyle(k);let B=`color: ${R[L]};`;return b&1&&(B+="font-style: italic;"),b&2&&(B+="font-weight: bold;"),b&4&&(B+="text-decoration: underline;"),B}}e.TokenMetadata=f;var s;(function(m){m[m.Method=0]="Method",m[m.Function=1]="Function",m[m.Constructor=2]="Constructor",m[m.Field=3]="Field",m[m.Variable=4]="Variable",m[m.Class=5]="Class",m[m.Struct=6]="Struct",m[m.Interface=7]="Interface",m[m.Module=8]="Module",m[m.Property=9]="Property",m[m.Event=10]="Event",m[m.Operator=11]="Operator",m[m.Unit=12]="Unit",m[m.Value=13]="Value",m[m.Constant=14]="Constant",m[m.Enum=15]="Enum",m[m.EnumMember=16]="EnumMember",m[m.Keyword=17]="Keyword",m[m.Text=18]="Text",m[m.Color=19]="Color",m[m.File=20]="File",m[m.Reference=21]="Reference",m[m.Customcolor=22]="Customcolor",m[m.Folder=23]="Folder",m[m.TypeParameter=24]="TypeParameter",m[m.User=25]="User",m[m.Issue=26]="Issue",m[m.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let m=Object.create(null);return m[0]="symbol-method",m[1]="symbol-function",m[2]="symbol-constructor",m[3]="symbol-field",m[4]="symbol-variable",m[5]="symbol-class",m[6]="symbol-struct",m[7]="symbol-interface",m[8]="symbol-module",m[9]="symbol-property",m[10]="symbol-event",m[11]="symbol-operator",m[12]="symbol-unit",m[13]="symbol-value",m[14]="symbol-constant",m[15]="symbol-enum",m[16]="symbol-enum-member",m[17]="symbol-keyword",m[27]="symbol-snippet",m[18]="symbol-text",m[19]="symbol-color",m[20]="symbol-file",m[21]="symbol-reference",m[22]="symbol-customcolor",m[23]="symbol-folder",m[24]="symbol-type-parameter",m[25]="account",m[26]="issues",function(k){const R=m[k];let L=R&&F.iconRegistry.get(R);return L||(console.info("No codicon found for CompletionItemKind "+k),L=F.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let m=Object.create(null);return m.method=0,m.function=1,m.constructor=2,m.field=3,m.variable=4,m.class=5,m.struct=6,m.interface=7,m.module=8,m.property=9,m.event=10,m.operator=11,m.unit=12,m.value=13,m.constant=14,m.enum=15,m["enum-member"]=16,m.enumMember=16,m.keyword=17,m.snippet=27,m.text=18,m.color=19,m.file=20,m.reference=21,m.customcolor=22,m.folder=23,m["type-parameter"]=24,m.typeParameter=24,m.account=25,m.issue=26,function(k,R){let L=m[k];return typeof L=="undefined"&&!R&&(L=9),L}}();var c;(function(m){m[m.Deprecated=1]="Deprecated"})(c=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(m){m[m.KeepWhitespace=1]="KeepWhitespace",m[m.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var P;(function(m){m[m.Invoke=0]="Invoke",m[m.TriggerCharacter=1]="TriggerCharacter",m[m.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(P=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var D;(function(m){m[m.Automatic=0]="Automatic",m[m.Explicit=1]="Explicit"})(D=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var l;(function(m){m[m.Invoke=1]="Invoke",m[m.Auto=2]="Auto"})(l=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(m){m[m.Invoke=1]="Invoke",m[m.TriggerCharacter=2]="TriggerCharacter",m[m.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _;(function(m){m[m.Text=0]="Text",m[m.Read=1]="Read",m[m.Write=2]="Write"})(_=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(m){return m&&h.URI.isUri(m.uri)&&M.Range.isIRange(m.range)&&(M.Range.isIRange(m.originSelectionRange)||M.Range.isIRange(m.targetSelectionRange))}e.isLocationLink=i;var g;(function(m){m[m.File=0]="File",m[m.Module=1]="Module",m[m.Namespace=2]="Namespace",m[m.Package=3]="Package",m[m.Class=4]="Class",m[m.Method=5]="Method",m[m.Property=6]="Property",m[m.Field=7]="Field",m[m.Constructor=8]="Constructor",m[m.Enum=9]="Enum",m[m.Interface=10]="Interface",m[m.Function=11]="Function",m[m.Variable=12]="Variable",m[m.Constant=13]="Constant",m[m.String=14]="String",m[m.Number=15]="Number",m[m.Boolean=16]="Boolean",m[m.Array=17]="Array",m[m.Object=18]="Object",m[m.Key=19]="Key",m[m.Null=20]="Null",m[m.EnumMember=21]="EnumMember",m[m.Struct=22]="Struct",m[m.Event=23]="Event",m[m.Operator=24]="Operator",m[m.TypeParameter=25]="TypeParameter"})(g=e.SymbolKind||(e.SymbolKind={}));var a;(function(m){m[m.Deprecated=1]="Deprecated"})(a=e.SymbolTag||(e.SymbolTag={}));var r;(function(m){const k=new Map;k.set("file",0),k.set("module",1),k.set("namespace",2),k.set("package",3),k.set("class",4),k.set("method",5),k.set("property",6),k.set("field",7),k.set("constructor",8),k.set("enum",9),k.set("interface",10),k.set("function",11),k.set("variable",12),k.set("constant",13),k.set("string",14),k.set("number",15),k.set("boolean",16),k.set("array",17),k.set("object",18),k.set("key",19),k.set("null",20),k.set("enum-member",21),k.set("struct",22),k.set("event",23),k.set("operator",24),k.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function L($){return k.get($)}m.fromString=L;function b($){return R.get($)}m.toString=b;function B($,x){const K=R.get($);let H=K&&F.iconRegistry.get("symbol-"+K);return H||(console.info("No codicon found for SymbolKind "+$),H=F.Codicon.symbolProperty),`${x?"inline":"block"} ${H.classNames}`}m.toCssClassName=B})(r=e.SymbolKinds||(e.SymbolKinds={}));class v{constructor(k){this.value=k}}e.FoldingRangeKind=v,v.Comment=new v("comment"),v.Imports=new v("imports"),v.Region=new v("region");var o;(function(m){m[m.Collapsed=0]="Collapsed",m[m.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(m){m[m.Editing=0]="Editing",m[m.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var w;(function(m){m[m.Other=0]="Other",m[m.Type=1]="Type",m[m.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var I;(function(m){m[m.None=0]="None",m[m.Option=1]="Option",m[m.Default=2]="Default",m[m.Preferred=3]="Preferred"})(I=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[46],Ee([0,1,25,9,4]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=h.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",h.isMacintosh),F.set("isLinux",h.isLinux),F.set("isWindows",h.isWindows),F.set("isWeb",h.isWeb),F.set("isMacNative",h.isMacintosh&&!h.isWeb),F.set("isEdge",A.indexOf("Edg/")>=0),F.set("isFirefox",A.indexOf("Firefox")>=0),F.set("isChrome",A.indexOf("Chrome")>=0),F.set("isSafari",A.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var S;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return n.INSTANCE}static true(){return f.INSTANCE}static has(b){return s.create(b)}static equals(b,B){return c.create(b,B)}static notEquals(b,B){return D.create(b,B)}static regex(b,B){return a.create(b,B)}static in(b,B){return p.create(b,B)}static not(b){return l.create(b)}static and(...b){return o.create(b,null)}static or(...b){return d.create(b,null,!0)}static greater(b,B){return u.create(b,B)}static less(b,B){return i.create(b,B)}static deserialize(b,B=!1){if(!!b)return this._deserializeOrExpression(b,B)}static _deserializeOrExpression(b,B){let $=b.split("||");return d.create($.map(x=>this._deserializeAndExpression(x,B)),null,!0)}static _deserializeAndExpression(b,B){let $=b.split("&&");return o.create($.map(x=>this._deserializeOne(x,B)),null)}static _deserializeOne(b,B){if(b=b.trim(),b.indexOf("!=")>=0){let $=b.split("!=");return D.create($[0].trim(),this._deserializeValue($[1],B))}if(b.indexOf("==")>=0){let $=b.split("==");return c.create($[0].trim(),this._deserializeValue($[1],B))}if(b.indexOf("=~")>=0){let $=b.split("=~");return a.create($[0].trim(),this._deserializeRegexValue($[1],B))}if(b.indexOf(" in ")>=0){let $=b.split(" in ");return p.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(b)){const $=b.split(">=");return _.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(b)){const $=b.split(">");return u.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(b)){const $=b.split("<=");return g.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(b)){const $=b.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(b)?l.create(b.substr(1).trim()):s.create(b)}static _deserializeValue(b,B){if(b=b.trim(),b==="true")return!0;if(b==="false")return!1;let $=/^'([^']*)'$/.exec(b);return $?$[1].trim():b}static _deserializeRegexValue(b,B){if((0,M.isFalsyOrWhitespace)(b)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let $=b.indexOf("/"),x=b.lastIndexOf("/");if($===x||$<0){if(B)throw new Error(`bad regexp-value '${b}', missing /-enclosure`);return console.warn(`bad regexp-value '${b}', missing /-enclosure`),null}let K=b.slice($+1,x),H=b[x+1]==="i"?"i":"";try{return new RegExp(K,H)}catch(W){if(B)throw new Error(`bad regexp-value '${b}', parse error: ${W}`);return console.warn(`bad regexp-value '${b}', parse error: ${W}`),null}}}e.ContextKeyExpr=T;function t(L,b){const B=L?L.substituteConstants():void 0,$=b?b.substituteConstants():void 0;return!B&&!$?!0:!B||!$?!1:B.equals($)}e.expressionsAreEqualWithConstantSubstitution=t;function y(L,b){return L.cmp(b)}class n{constructor(){this.type=0}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class f{constructor(){this.type=1}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class s{constructor(b,B){this.key=b,this.negated=B,this.type=2}static create(b,B=null){const $=F.get(b);return typeof $=="boolean"?$?f.INSTANCE:n.INSTANCE:new s(b,B)}cmp(b){return b.type!==this.type?this.type-b.type:I(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=F.get(this.key);return typeof b=="boolean"?b?f.INSTANCE:n.INSTANCE:this}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=s;class c{constructor(b,B,$){this.key=b,this.value=B,this.negated=$,this.type=4}static create(b,B,$=null){if(typeof B=="boolean")return B?s.create(b,$):l.create(b,$);const x=F.get(b);return typeof x=="boolean"?B===(x?"true":"false")?f.INSTANCE:n.INSTANCE:new c(b,B,$)}cmp(b){return b.type!==this.type?this.type-b.type:m(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){const b=F.get(this.key);if(typeof b=="boolean"){const B=b?"true":"false";return this.value===B?f.INSTANCE:n.INSTANCE}return this}evaluate(b){return b.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(b){return b.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=c;class p{constructor(b,B){this.key=b,this.valueKey=B,this.type=10,this.negated=null}static create(b,B){return new p(b,B)}cmp(b){return b.type!==this.type?this.type-b.type:m(this.key,this.valueKey,b.key,b.valueKey)}equals(b){return b.type===this.type?this.key===b.key&&this.valueKey===b.valueKey:!1}substituteConstants(){return this}evaluate(b){const B=b.getValue(this.valueKey),$=b.getValue(this.key);return Array.isArray(B)?B.indexOf($)>=0:typeof $=="string"&&typeof B=="object"&&B!==null?C.call(B,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(b){return b.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this)),this.negated}}e.ContextKeyInExpr=p;class P{constructor(b){this._actual=b,this.type=11}static create(b){return new P(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}substituteConstants(){return this}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new P(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotInExpr=P;class D{constructor(b,B,$){this.key=b,this.value=B,this.negated=$,this.type=5}static create(b,B,$=null){if(typeof B=="boolean")return B?l.create(b,$):s.create(b,$);const x=F.get(b);return typeof x=="boolean"?B===(x?"true":"false")?n.INSTANCE:f.INSTANCE:new D(b,B,$)}cmp(b){return b.type!==this.type?this.type-b.type:m(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){const b=F.get(this.key);if(typeof b=="boolean"){const B=b?"true":"false";return this.value===B?n.INSTANCE:f.INSTANCE}return this}evaluate(b){return b.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(b){return b.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=D;class l{constructor(b,B){this.key=b,this.negated=B,this.type=3}static create(b,B=null){const $=F.get(b);return typeof $=="boolean"?$?n.INSTANCE:f.INSTANCE:new l(b,B)}cmp(b){return b.type!==this.type?this.type-b.type:I(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=F.get(this.key);return typeof b=="boolean"?b?n.INSTANCE:f.INSTANCE:this}evaluate(b){return!b.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(b){return b.mapNot(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=l;class u{constructor(b,B,$){this.key=b,this.value=B,this.negated=$,this.type=12}static create(b,B,$=null){return new u(b,B,$)}cmp(b){return b.type!==this.type?this.type-b.type:m(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return parseFloat(b.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class _{constructor(b,B,$){this.key=b,this.value=B,this.negated=$,this.type=13}static create(b,B,$=null){return new _(b,B,$)}cmp(b){return b.type!==this.type?this.type-b.type:m(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return parseFloat(b.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=_;class i{constructor(b,B,$){this.key=b,this.value=B,this.negated=$,this.type=14}static create(b,B,$=null){return new i(b,B,$)}cmp(b){return b.type!==this.type?this.type-b.type:m(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return parseFloat(b.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class g{constructor(b,B,$){this.key=b,this.value=B,this.negated=$,this.type=15}static create(b,B,$=null){return new g(b,B,$)}cmp(b){return b.type!==this.type?this.type-b.type:m(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return parseFloat(b.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=g;class a{constructor(b,B){this.key=b,this.regexp=B,this.type=7,this.negated=null}static create(b,B){return new a(b,B)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.key<b.key)return-1;if(this.key>b.key)return 1;const B=this.regexp?this.regexp.source:"",$=b.regexp?b.regexp.source:"";return B<$?-1:B>$?1:0}equals(b){if(b.type===this.type){const B=this.regexp?this.regexp.source:"",$=b.regexp?b.regexp.source:"";return this.key===b.key&&B===$}return!1}substituteConstants(){return this}evaluate(b){let B=b.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const b=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${b}`}keys(){return[this.key]}map(b){return b.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class r{constructor(b){this._actual=b,this.type=8}static create(b){return new r(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}substituteConstants(){return this}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new r(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function v(L){let b=null;for(let B=0,$=L.length;B<$;B++){const x=L[B].substituteConstants();if(L[B]!==x&&b===null){b=[];for(let K=0;K<B;K++)b[K]=L[K]}b!==null&&(b[B]=x)}return b===null?L:b}class o{constructor(b,B){this.expr=b,this.negated=B,this.type=6}static create(b,B){return o._normalizeArr(b,B)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let B=0,$=this.expr.length;B<$;B++){const x=y(this.expr[B],b.expr[B]);if(x!==0)return x}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let B=0,$=this.expr.length;B<$;B++)if(!this.expr[B].equals(b.expr[B]))return!1;return!0}return!1}substituteConstants(){const b=v(this.expr);return b===this.expr?this:o.create(b,this.negated)}evaluate(b){for(let B=0,$=this.expr.length;B<$;B++)if(!this.expr[B].evaluate(b))return!1;return!0}static _normalizeArr(b,B){const $=[];let x=!1;for(const K of b)if(!!K){if(K.type===1){x=!0;continue}if(K.type===0)return n.INSTANCE;if(K.type===6){$.push(...K.expr);continue}$.push(K)}if($.length===0&&x)return f.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(y);for(let K=1;K<$.length;K++)$[K-1].equals($[K])&&($.splice(K,1),K--);if($.length===1)return $[0];for(;$.length>1;){const K=$[$.length-1];if(K.type!==9)break;$.pop();const H=$.pop(),W=$.length===0,ne=d.create(K.expr.map(V=>o.create([V,H],null)),null,W);ne&&($.push(ne),$.sort(y))}return $.length===1?$[0]:new o($,B)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(let B of this.expr)b.push(...B.keys());return b}map(b){return new o(this.expr.map(B=>B.map(b)),null)}negate(){if(!this.negated){const b=[];for(let B of this.expr)b.push(B.negate());this.negated=d.create(b,this,!0)}return this.negated}}class d{constructor(b,B){this.expr=b,this.negated=B,this.type=9}static create(b,B,$){return d._normalizeArr(b,B,$)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let B=0,$=this.expr.length;B<$;B++){const x=y(this.expr[B],b.expr[B]);if(x!==0)return x}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let B=0,$=this.expr.length;B<$;B++)if(!this.expr[B].equals(b.expr[B]))return!1;return!0}return!1}substituteConstants(){const b=v(this.expr);return b===this.expr?this:d.create(b,this.negated,!1)}evaluate(b){for(let B=0,$=this.expr.length;B<$;B++)if(this.expr[B].evaluate(b))return!0;return!1}static _normalizeArr(b,B,$){let x=[],K=!1;if(b){for(let H=0,W=b.length;H<W;H++){const ne=b[H];if(!!ne){if(ne.type===0){K=!0;continue}if(ne.type===1)return f.INSTANCE;if(ne.type===9){x=x.concat(ne.expr);continue}x.push(ne)}}if(x.length===0&&K)return n.INSTANCE;x.sort(y)}if(x.length!==0){if(x.length===1)return x[0];for(let H=1;H<x.length;H++)x[H-1].equals(x[H])&&(x.splice(H,1),H--);if(x.length===1)return x[0];if($){for(let H=0;H<x.length;H++)for(let W=H+1;W<x.length;W++)k(x[H],x[W])&&(x.splice(W,1),W--);if(x.length===1)return x[0]}return new d(x,B)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(let B of this.expr)b.push(...B.keys());return b}map(b){return new d(this.expr.map(B=>B.map(b)),null)}negate(){if(!this.negated){let b=[];for(let B of this.expr)b.push(B.negate());for(;b.length>1;){const B=b.shift(),$=b.shift(),x=[];for(const H of R(B))for(const W of R($))x.push(o.create([H,W],null));const K=b.length===0;b.unshift(d.create(x,null,K))}this.negated=b[0]}return this.negated}}class w extends s{constructor(b,B,$){super(b,null);this._defaultValue=B,typeof $=="object"?w._info.push({...$,key:b}):$!==!0&&w._info.push({key:b,description:$,type:B!=null?typeof B:void 0})}static all(){return w._info.values()}bindTo(b){return b.createKey(this.key,this._defaultValue)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return c.create(this.key,b)}notEqualsTo(b){return D.create(this.key,b)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I(L,b){return L<b?-1:L>b?1:0}function m(L,b,B,$){return L<B?-1:L>B?1:b<$?-1:b>$?1:0}function k(L,b){if(b.type===6&&L.type!==9&&L.type!==6){for(const x of b.expr)if(L.equals(x))return!0}const B=L.negate(),$=R(B).concat(R(b));$.sort(y);for(let x=0;x<$.length;x++){const H=$[x].negate();for(let W=x+1;W<$.length;W++){const ne=$[W];if(H.equals(ne))return!0}}return!1}e.implies=k;function R(L){return L.type===9?L.expr:[L]}}),define(be[142],Ee([0,1,4]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(be[60],Ee([0,1,20,17,9,10,2,121,4]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function T(x){return x.create===!0}e.isFileOpenForWriteOptions=T;var t;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var y;(function(x){x[x.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var n;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=f;function s(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=s;function c(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function p(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=p;var P;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class D extends Error{constructor(K,H){super(K);this.code=H}}e.FileSystemProviderError=D;function l(x,K){const H=new D(x.toString(),K);return _(H,K),H}e.createFileSystemProviderError=l;function u(x){return x||l((0,C.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=u;function _(x,K){return x.name=K?`${K} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=_;function i(x){if(!x)return P.Unknown;if(x instanceof D)return x.code;const K=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!K)return P.Unknown;switch(K[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=i;function g(x){if(x instanceof w)return x.fileOperationResult;switch(i(x)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=g;var a;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY"})(a=e.FileOperation||(e.FileOperation={}));class r{constructor(K,H,W){this.resource=K,this.operation=H,this.target=W}isOperation(K){return this.operation===K}}e.FileOperationEvent=r;var v;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class o{constructor(K,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;const W=new Map;for(const ne of K){const V=W.get(ne.type);V?V.push([ne.resource,ne]):W.set(ne.type,[[ne.resource,ne]])}for(const[ne,V]of W)switch(ne){case 1:this.added=h.TernarySearchTree.forUris(()=>H),this.added.fill(V);break;case 0:this.updated=h.TernarySearchTree.forUris(()=>H),this.updated.fill(V);break;case 2:this.deleted=h.TernarySearchTree.forUris(()=>H),this.deleted.fill(V);break}}contains(K,...H){return this.doContains(K,{includeChildren:!1},...H)}affects(K,...H){return this.doContains(K,{includeChildren:!0},...H)}doContains(K,H,...W){if(!K)return!1;const ne=W.length>0;return!!((!ne||W.includes(1))&&(this.added?.get(K)||H.includeChildren&&this.added?.findSuperstr(K))||(!ne||W.includes(0))&&(this.updated?.get(K)||H.includeChildren&&this.updated?.findSuperstr(K))||(!ne||W.includes(2))&&(this.deleted?.findSubstr(K)||H.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function d(x,K,H){return!x||!K||x===K||K.length>x.length?!1:(K.charAt(K.length-1)!==M.sep&&(K+=M.sep),H?(0,E.startsWithIgnoreCase)(x,K):x.indexOf(K)===0)}e.isParent=d;class w extends Error{constructor(K,H,W){super(K);this.fileOperationResult=H,this.options=W}}e.FileOperationError=w;class I extends w{constructor(K,H,W){super(K,2,W);this.stat=H}}e.NotModifiedSinceFileOperationError=I;var m;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(m=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=R;async function L(x,K){if(!K.hasProvider(F.URI.from({scheme:x.scheme})))return new Promise(H=>{const W=K.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===x.scheme&&ne.added&&(W.dispose(),H())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class b{static formatSize(K){return(0,A.isNumber)(K)||(K=0),K<b.KB?(0,C.localize)(1,null,K.toFixed(0)):K<b.MB?(0,C.localize)(2,null,(K/b.KB).toFixed(2)):K<b.GB?(0,C.localize)(3,null,(K/b.MB).toFixed(2)):K<b.TB?(0,C.localize)(4,null,(K/b.GB).toFixed(2)):(0,C.localize)(5,null,(K/b.TB).toFixed(2))}}e.ByteSize=b,b.KB=1024,b.MB=b.KB*b.KB,b.GB=b.MB*b.KB,b.TB=b.GB*b.KB;var B;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function $(x){return{maxFileSize:x===0?300*b.MB:16*b.GB,maxHeapSize:x===0?700*b.MB:2*700*b.MB}}e.getPlatformLimits=$}),define(be[61],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...E){this._entries=new Map;for(let[A,F]of E)this.set(A,F)}set(E,A){const F=this._entries.get(E);return this._entries.set(E,A),F}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=h}),define(be[143],Ee([0,1,12,16,82,139,4,61]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class T extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class t{constructor(s=new C.ServiceCollection,c=!1,p){this._activeInstantiations=new Set,this._services=s,this._strict=c,this._parent=p,this._services.set(F.IInstantiationService,this)}createChild(s){return new t(s,this._strict,this)}invokeFunction(s,...c){let p=n.traceInvocation(s),P=!1;try{return s({get:(l,u)=>{if(P)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const _=this._getOrCreateServiceInstance(l,p);if(!_&&u!==F.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return _}},...c)}finally{P=!0,p.stop()}}createInstance(s,...c){let p,P;return s instanceof E.SyncDescriptor?(p=n.traceCreation(s.ctor),P=this._createInstance(s.ctor,s.staticArguments.concat(c),p)):(p=n.traceCreation(s),P=this._createInstance(s,c,p)),p.stop(),P}_createInstance(s,c=[],p){let P=F._util.getServiceDependencies(s).sort((u,_)=>u.index-_.index),D=[];for(const u of P){let _=this._getOrCreateServiceInstance(u.id,p);if(!_&&this._strict&&!u.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${u.id}.`);D.push(_)}let l=P.length>0?P[0].index:c.length;if(c.length!==l){console.warn(`[createInstance] First service dependency of ${s.name} at position ${l+1} conflicts with ${c.length} static arguments`);let u=l-c.length;u>0?c=c.concat(new Array(u)):c=c.slice(0,l)}return new s(...[...c,...D])}_setServiceInstance(s,c){if(this._services.get(s)instanceof E.SyncDescriptor)this._services.set(s,c);else if(this._parent)this._parent._setServiceInstance(s,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let c=this._services.get(s);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):c}_getOrCreateServiceInstance(s,c){let p=this._getServiceInstanceOrDescriptor(s);return p instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,p,c.branch(s,!0)):(c.branch(s,!1),p)}_safeCreateAndCacheServiceInstance(s,c,p){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,c,p)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,c,p){const P=new A.Graph(u=>u.id.toString());let D=0;const l=[{id:s,desc:c,_trace:p}];for(;l.length;){const u=l.pop();if(P.lookupOrInsertNode(u),D++>1e3)throw new T(P);for(let _ of F._util.getServiceDependencies(u.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(_.id);if(!i&&!_.optional&&console.warn(`[createInstance] ${s} depends on ${_.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const g={id:_.id,desc:i,_trace:u._trace.branch(_.id,!0)};P.insertEdge(u,g),l.push(g)}}}for(;;){const u=P.roots();if(u.length===0){if(!P.isEmpty())throw new T(P);break}for(const{data:_}of u){if(this._getServiceInstanceOrDescriptor(_.id)instanceof E.SyncDescriptor){const g=this._createServiceInstanceWithOwner(_.id,_.desc.ctor,_.desc.staticArguments,_.desc.supportsDelayedInstantiation,_._trace);this._setServiceInstance(_.id,g)}P.removeNode(_)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,c,p=[],P,D){if(this._services.get(s)instanceof E.SyncDescriptor)return this._createServiceInstance(c,p,P,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,c,p,P,D);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(s,c=[],p,P){if(p){const D=new h.IdleValue(()=>this._createInstance(s,c,P));return new Proxy(Object.create(null),{get(l,u){if(u in l)return l[u];let _=D.value,i=_[u];return typeof i!="function"||(i=i.bind(_),l[u]=i),i},set(l,u,_){return D.value[u]=_,!0}})}else return this._createInstance(s,c,P)}}e.InstantiationService=t;var y;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(y||(y={}));class n{constructor(s,c){this.type=s,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return S?new n(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(s){return S?new n(0,s.name):n._None}branch(s,c){let p=new n(2,s.toString());return this._dep.push([s,c,p]),p}stop(){let s=Date.now()-this._start;n._totals+=s;let c=!1;function p(D,l){let u=[],_=new Array(D+1).join("	");for(const[i,g,a]of l._dep)if(g&&a){c=!0,u.push(`${_}CREATES -> ${i}`);let r=p(D+1,a);r&&u.push(r)}else u.push(`${_}uses -> ${i}`);return u.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(s>2||c)&&console.log(P.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,45,3,6,25,4]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function C(){return new Date().toISOString()}var S;(function(_){_[_.Trace=0]="Trace",_[_.Debug=1]="Debug",_[_.Info=2]="Info",_[_.Warning=3]="Warning",_[_.Error=4]="Error",_[_.Critical=5]="Critical",_[_.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class T extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class t extends T{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...g){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([i,...g]))}debug(i,...g){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([i,...g]))}info(i,...g){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([i,...g]))}warn(i,...g){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([i,...g]))}error(i,...g){if(this.checkLogLevel(S.Error))if(i instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=i.stack,this.log(S.Error,this.format(a))}else this.log(S.Error,this.format([i,...g]))}critical(i,...g){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([i,...g]))}flush(){}format(i){let g="";for(let a=0;a<i.length;a++){let r=i[a];if(typeof r=="object")try{r=JSON.stringify(r)}catch(v){}g+=(a>0?" ":"")+r}return g}}e.AbstractMessageLogger=t;class y extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...g){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...g):console.log(`[main ${C()}]`,i,...g))}debug(i,...g){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...g):console.log(`[main ${C()}]`,i,...g))}info(i,...g){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...g):console.log(`[main ${C()}]`,i,...g))}warn(i,...g){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,i,...g):console.warn(`[main ${C()}]`,i,...g))}error(i,...g){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,i,...g):console.error(`[main ${C()}]`,i,...g))}critical(i,...g){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,i,...g):console.error(`[main ${C()}]`,i,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class n extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...g){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",i,...g)}debug(i,...g){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...g)}info(i,...g){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",i,...g)}warn(i,...g){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",i,...g)}error(i,...g){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",i,...g)}critical(i,...g){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...g)}dispose(){}flush(){}}e.ConsoleLogger=n;class f extends T{constructor(i,g=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(g)}trace(i,...g){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(i),...g])}debug(i,...g){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(i),...g])}info(i,...g){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(i),...g])}warn(i,...g){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(i),...g])}error(i,...g){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(i),...g])}critical(i,...g){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(i),...g])}extractMessage(i){return typeof i=="string"?i:(0,h.toErrorMessage)(i,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class s extends T{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const g of this.logServices)g.setLevel(i);super.setLevel(i)}trace(i,...g){for(const a of this.logServices)a.trace(i,...g)}debug(i,...g){for(const a of this.logServices)a.debug(i,...g)}info(i,...g){for(const a of this.logServices)a.info(i,...g)}warn(i,...g){for(const a of this.logServices)a.warn(i,...g)}error(i,...g){for(const a of this.logServices)a.error(i,...g)}critical(i,...g){for(const a of this.logServices)a.critical(i,...g)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=s;class c extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...g){this.logger.trace(i,...g)}debug(i,...g){this.logger.debug(i,...g)}info(i,...g){this.logger.info(i,...g)}warn(i,...g){this.logger.warn(i,...g)}error(i,...g){this.logger.error(i,...g)}critical(i,...g){this.logger.critical(i,...g)}flush(){this.logger.flush()}}e.LogService=c;class p extends E.Disposable{constructor(i,g){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(g(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(a))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,g){let a=this.loggers.get(i.toString());return a||(a=this.doCreateLogger(i,g?.always?S.Trace:this.logLevel,g),this.loggers.set(i.toString(),a),g?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class P{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return S.Info}trace(i,...g){}debug(i,...g){}info(i,...g){}warn(i,...g){}error(i,...g){}critical(i,...g){}dispose(){}flush(){}}e.NullLogService=P;function D(_){if(_.verbose)return S.Trace;if(typeof _.logLevel=="string"){const i=l(_.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=D;function l(_){switch(_){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function u(_){switch(_){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=u}),define(be[83],Ee([0,1,35,122,4]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var F;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function T(s,c){return c-s}S.compare=T;const t=Object.create(null);t[S.Error]=(0,M.localize)(0,null),t[S.Warning]=(0,M.localize)(1,null),t[S.Info]=(0,M.localize)(2,null);function y(s){return t[s]||""}S.toString=y;function n(s){switch(s){case h.default.Error:return S.Error;case h.default.Warning:return S.Warning;case h.default.Info:return S.Info;case h.default.Ignore:return S.Hint}}S.fromSeverity=n;function f(s){switch(s){case S.Error:return h.default.Error;case S.Warning:return h.default.Warning;case S.Info:return h.default.Info;case S.Hint:return h.default.Ignore}}S.toSeverity=f}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(S){const T="";function t(n){return y(n,!0)}S.makeKey=t;function y(n,f){let s=[T];return n.source?s.push(n.source.replace("\xA6","\\\xA6")):s.push(T),n.code?typeof n.code=="string"?s.push(n.code.replace("\xA6","\\\xA6")):s.push(n.code.value.replace("\xA6","\\\xA6")):s.push(T),n.severity!==void 0&&n.severity!==null?s.push(F.toString(n.severity)):s.push(T),n.message&&f?s.push(n.message.replace("\xA6","\\\xA6")):s.push(T),n.startLineNumber!==void 0&&n.startLineNumber!==null?s.push(n.startLineNumber.toString()):s.push(T),n.startColumn!==void 0&&n.startColumn!==null?s.push(n.startColumn.toString()):s.push(T),n.endLineNumber!==void 0&&n.endLineNumber!==null?s.push(n.endLineNumber.toString()):s.push(T),n.endColumn!==void 0&&n.endColumn!==null?s.push(n.endColumn.toString()):s.push(T),s.push(T),s.join("\xA6")}S.makeKeyOptionalMessage=y})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[144],Ee([0,1,3,35,4]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new S,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=C;class S{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=S}),define(be[145],Ee([0,1,6,9,2,4]),function(se,e,h,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return h.Disposable.None},registerValidator(){return h.Disposable.None},registerExternalUriResolver(){return h.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return h.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function F(C,S){return E.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,S):(0,M.startsWithIgnoreCase)(C,S+":")}e.matchesScheme=F});var $e=this&&this.__decorate||function(se,e,h,M){var E=arguments.length,A=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,h):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(se,e,h,M);else for(var C=se.length-1;C>=0;C--)(F=se[C])&&(A=(E<3?F(A):E>3?F(e,h,A):F(e,h))||A);return E>3&&A&&Object.defineProperty(e,h,A),A},ze=this&&this.__param||function(se,e){return function(h,M){e(h,M,se)}};define(be[146],Ee([0,1,12,21,6,4]),function(se,e,h,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let S=class extends E.Disposable{constructor(y,n){super();this.deferred=new h.DeferredPromise,n.withProgress(y,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};S=$e([ze(1,e.IProgressService)],S),e.UnmanagedProgress=S;class T extends E.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(y){this.stop();const n=++this.currentOperationId,f=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:f.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,42,10]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(F,C){h.ok(M.isString(F)),h.ok(M.isObject(C)),h.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,C)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new E}),define(be[84],Ee([0,1,3,28]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class A{constructor(){this._onDidChangeSchema=new h.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,T){this.schemasById[E(S)]=T,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new A;M.Registry.add(e.Extensions.JSONContribution,F)}),define(be[62],Ee([0,1,14,3,10,119,84,28]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=C.Registry.as(F.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(l,u=!0){this.registerConfigurations([l],u)}registerConfigurations(l,u=!0){const _=this.doRegisterConfigurations(l,u);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterConfigurations(l){const u=this.doDeregisterConfigurations(l);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}updateConfigurations({add:l,remove:u}){const _=[];_.push(...this.doDeregisterConfigurations(u)),_.push(...this.doRegisterConfigurations(l,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,h.distinct)(_))}registerDefaultConfigurations(l){const u=[],_=[];for(const i of l)for(const g in i)if(u.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]={...this.defaultValues[g]||{},...i[g]};const a={type:"object",default:this.defaultValues[g],description:A.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};_.push(f(g)),this.configurationProperties[g]=a,this.defaultLanguageConfigurationOverridesNode.properties[g]=a}else{this.defaultValues[g]=i[g];const a=this.configurationProperties[g];a&&(this.updatePropertyDefaultValue(g,a),this.updateSchema(g,a))}this.registerOverrideIdentifiers(_),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterDefaultConfigurations(l){const u=[];for(const _ of l)for(const i in _)if(u.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const g=this.configurationProperties[i];g&&(this.updatePropertyDefaultValue(i,g),this.updateSchema(i,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const u of l)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,u){const _=[];return l.forEach(i=>{_.push(...this.validateAndRegisterProperties(i,u,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),_}doDeregisterConfigurations(l){const u=[],_=i=>{if(i.properties)for(const g in i.properties)u.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,i.properties[g]);i.allOf&&i.allOf.forEach(g=>_(g))};for(const i of l){_(i);const g=this.configurationContributors.indexOf(i);g!==-1&&this.configurationContributors.splice(g,1)}return u}validateAndRegisterProperties(l,u=!0,_,i=3){i=E.isUndefinedOrNull(l.scope)?i:l.scope;let g=[],a=l.properties;if(a)for(let v in a){if(u&&p(v)){delete a[v];continue}const o=a[v];if(this.updatePropertyDefaultValue(v,o),e.OVERRIDE_PROPERTY_PATTERN.test(v)?o.scope=void 0:(o.scope=E.isUndefinedOrNull(o.scope)?i:o.scope,o.restricted=E.isUndefinedOrNull(o.restricted)?!!_?.restrictedConfigurations?.includes(v):o.restricted),a[v].hasOwnProperty("included")&&!a[v].included){this.excludedConfigurationProperties[v]=a[v],delete a[v];continue}else this.configurationProperties[v]=a[v];!a[v].deprecationMessage&&a[v].markdownDeprecationMessage&&(a[v].deprecationMessage=a[v].markdownDeprecationMessage),g.push(v)}let r=l.allOf;if(r)for(let v of r)g.push(...this.validateAndRegisterProperties(v,u,_,i));return g}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(l){const u=_=>{let i=_.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);let g=_.allOf;g&&g.forEach(u)};u(l)}updateSchema(l,u){switch(e.allSettings.properties[l]=u,u.scope){case 1:e.applicationSettings.properties[l]=u;break;case 2:e.machineSettings.properties[l]=u;break;case 6:e.machineOverridableSettings.properties[l]=u;break;case 3:e.windowSettings.properties[l]=u;break;case 4:e.resourceSettings.properties[l]=u;break;case 5:e.resourceSettings.properties[l]=u,this.resourceLanguageSettingsSchema.properties[l]=u;break}}removeFromSchema(l,u){switch(delete e.allSettings.properties[l],u.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const u=`[${l}]`,_={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,_),e.allSettings.properties[u]=_,e.applicationSettings.properties[u]=_,e.machineSettings.properties[u]=_,e.machineOverridableSettings.properties[u]=_,e.windowSettings.properties[u]=_,e.resourceSettings.properties[u]=_}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,u){let _=this.defaultValues[l];E.isUndefined(_)&&(_=u.default),E.isUndefined(_)&&(_=s(u.type)),u.default=_}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function f(D){return D.substring(1,D.length-1)}e.overrideIdentifierFromKey=f;function s(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=s;const c=new y;C.Registry.add(e.Extensions.Configuration,c);function p(D){return D.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(D)?A.localize(5,null,D):c.getConfigurationProperties()[D]!==void 0?A.localize(6,null,D):null:A.localize(4,null)}e.validateProperty=p;function P(){const D=[],l=c.getConfigurationProperties();for(const u of Object.keys(l))D.push([u,l[u].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=P}),define(be[85],Ee([0,1,23,10,2,62,4,28]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function S(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof E.URI)}e.isConfigurationOverrides=S;var T;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function y(g,a){const r=a?g?a.keys.filter(k=>g.keys.indexOf(k)===-1):[...a.keys]:[],v=g?a?g.keys.filter(k=>a.keys.indexOf(k)===-1):[...g.keys]:[],o=[];if(a&&g){for(const k of g.keys)if(a.keys.indexOf(k)!==-1){const R=P(g.contents,k),L=P(a.contents,k);h.equals(R,L)||o.push(k)}}const d=[],w=k=>{const R={};for(const L of k)for(const b of L.identifiers)R[_(b)]=L;return R},I=a?w(a.overrides):{},m=g?w(g.overrides):{};if(Object.keys(I).length)for(const k of r){const R=I[k];R&&d.push([(0,A.overrideIdentifierFromKey)(k),R.keys])}if(Object.keys(m).length)for(const k of v){const R=m[k];R&&d.push([(0,A.overrideIdentifierFromKey)(k),R.keys])}if(Object.keys(I).length&&Object.keys(m).length)for(const k of o){const R=m[k],L=I[k];if(R&&L){const b=y({contents:R.contents,keys:R.keys,overrides:[]},{contents:L.contents,keys:L.keys,overrides:[]});d.push([(0,A.overrideIdentifierFromKey)(k),[...b.added,...b.removed,...b.updated]])}}return{added:r,removed:v,updated:o,overrides:d}}e.compare=y;function n(g,a){const r=[];for(const v of Object.keys(g))if(A.OVERRIDE_PROPERTY_PATTERN.test(v)){const o={};for(const d in g[v])o[d]=g[v][d];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(v).trim()],keys:Object.keys(o),contents:f(o,a)})}return r}e.toOverrides=n;function f(g,a){const r=Object.create(null);for(let v in g)s(r,v,g[v],a);return r}e.toValuesTree=f;function s(g,a,r,v){const o=a.split("."),d=o.pop();let w=g;for(let I=0;I<o.length;I++){let m=o[I],k=w[m];switch(typeof k){case"undefined":k=w[m]=Object.create(null);break;case"object":break;default:v(`Ignoring ${a} as ${o.slice(0,I+1).join(".")} is ${JSON.stringify(k)}`);return}w=k}if(typeof w=="object"&&w!==null)try{w[d]=r}catch(I){v(`Ignoring ${a} as ${o.join(".")} is ${JSON.stringify(w)}`)}else v(`Ignoring ${a} as ${o.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=s;function c(g,a){const r=a.split(".");p(g,r)}e.removeFromValueTree=c;function p(g,a){const r=a.shift();if(a.length===0){delete g[r];return}if(Object.keys(g).indexOf(r)!==-1){const v=g[r];typeof v=="object"&&!Array.isArray(v)&&(p(v,a),Object.keys(v).length===0&&delete g[r])}}function P(g,a,r){function v(w,I){let m=w;for(const k of I){if(typeof m!="object"||m===null)return;m=m[k]}return m}const o=a.split("."),d=v(g,o);return typeof d=="undefined"?r:d}e.getConfigurationValue=P;function D(g,a,r){Object.keys(a).forEach(v=>{v!=="__proto__"&&(v in g?M.isObject(g[v])&&M.isObject(a[v])?D(g[v],a[v],r):r&&(g[v]=a[v]):g[v]=a[v])})}e.merge=D;function l(){const g=C.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(g)}e.getConfigurationKeys=l;function u(){const g=Object.create(null),a=C.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in a){let v=a[r].default;s(g,r,v,o=>console.error(`Conflict in default settings: ${o}`))}return g}e.getDefaultValues=u;function _(g){return`[${g}]`}e.keyFromOverrideIdentifier=_;function i(g,a,r){const v=g.inspect(a),o=g.inspect(r);return typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:v.defaultValue}e.getMigratedSettingValue=i}),define(be[147],Ee([0,1,14,3,102,6,20,23,10,2,85,62,28]),function(se,e,h,M,E,A,F,C,S,T,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(i={},g=[],a=[]){this._contents=i,this._keys=g,this._overrides=a,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,g){const a=this.getContentsForOverrideIdentifer(g);return a?i?(0,t.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){for(const g of this.overrides)if(g.identifiers.indexOf(i)!==-1)return g.keys;return[]}override(i){let g=this.overrideConfigurations.get(i);return g||(g=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,g)),g}merge(...i){const g=C.deepClone(this.contents),a=C.deepClone(this.overrides),r=[...this.keys];for(const v of i){this.mergeContents(g,v.contents);for(const o of v.overrides){const[d]=a.filter(w=>h.equals(w.identifiers,o.identifiers));d?this.mergeContents(d.contents,o.contents):a.push(C.deepClone(o))}for(const o of v.keys)r.indexOf(o)===-1&&r.push(o)}return new f(g,r,a)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const g=this.getContentsForOverrideIdentifer(i);if(!g||typeof g!="object"||!Object.keys(g).length)return this;let a={};for(const r of h.distinct([...Object.keys(this.contents),...Object.keys(g)])){let v=this.contents[r],o=g[r];o&&(typeof v=="object"&&typeof o=="object"?(v=C.deepClone(v),this.mergeContents(v,o)):v=o),a[r]=v}return new f(a,this.keys,this.overrides)}mergeContents(i,g){for(const a of Object.keys(g)){if(a in i&&S.isObject(i[a])&&S.isObject(g[a])){this.mergeContents(i[a],g[a]);continue}i[a]=C.deepClone(g[a])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?C.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const g of this.overrides)if(g.identifiers.indexOf(i)!==-1)return g.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,g){this.addKey(i),(0,t.addToValueTree)(this.contents,i,g,a=>{throw new Error(a)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let g=this.keys.length;for(let a=0;a<g;a++)i.indexOf(this.keys[a])===0&&(g=a);this.keys.splice(g,1,i)}removeKey(i){let g=this.keys.indexOf(i);return g!==-1?(this.keys.splice(g,1),!0):!1}}e.ConfigurationModel=f;class s extends f{constructor(){const i=(0,t.getDefaultValues)(),g=(0,t.getConfigurationKeys)(),a=[];for(const r of Object.keys(i))y.OVERRIDE_PROPERTY_PATTERN.test(r)&&a.push({identifiers:[(0,y.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(i[r]),contents:(0,t.toValuesTree)(i[r],v=>console.error(`Conflict in default settings file: ${v}`))});super(i,g,a)}}e.DefaultConfigurationModel=s;class c{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,g){if(!S.isUndefinedOrNull(i)){const a=this.doParseContent(i);this.parseRaw(a,g)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,g){this._raw=i;const{contents:a,keys:r,overrides:v,restricted:o}=this.doParseRaw(i,g);this._configurationModel=new f(a,r,v),this._restrictedConfigurations=o||[]}doParseContent(i){let g={},a=null,r=[],v=[],o=[];function d(I){Array.isArray(r)?r.push(I):a!==null&&(r[a]=I)}let w={onObjectBegin:()=>{let I={};d(I),v.push(r),r=I,a=null},onObjectProperty:I=>{a=I},onObjectEnd:()=>{r=v.pop()},onArrayBegin:()=>{let I=[];d(I),v.push(r),r=I,a=null},onArrayEnd:()=>{r=v.pop()},onLiteralValue:d,onError:(I,m,k)=>{o.push({error:I,offset:m,length:k})}};if(i)try{E.visit(i,w),g=r[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return g}doParseRaw(i,g){const a=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,a,!0,g);i=r.raw;const v=(0,t.toValuesTree)(i,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),o=Object.keys(i),d=(0,t.toOverrides)(i,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:v,keys:o,overrides:d,restricted:r.restricted}}filter(i,g,a,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const v={},o=[];for(let d in i)if(y.OVERRIDE_PROPERTY_PATTERN.test(d)&&a){const w=this.filter(i[d],g,!1,r);v[d]=w.raw,o.push(...w.restricted)}else{const w=g[d],I=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&o.push(d),(I===void 0||r.scopes===void 0||r.scopes.includes(I))&&(r.skipRestricted&&w?.restricted||(v[d]=i[d]))}return{raw:v,restricted:o}}}e.ConfigurationModelParser=c;class p extends A.Disposable{constructor(i,g,a,r){super();this.userSettingsResource=i,this.scopes=g,this.fileService=r,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class P{constructor(i,g,a=new f,r=new f,v=new F.ResourceMap,o=new f,d=new F.ResourceMap,w=!0){this._defaultConfiguration=i,this._localUserConfiguration=g,this._remoteUserConfiguration=a,this._workspaceConfiguration=r,this._folderConfigurations=v,this._memoryConfiguration=o,this._memoryConfigurationByResource=d,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,g,a){return this.getConsolidateConfigurationModel(g,a).getValue(i)}updateValue(i,g,a={}){let r;a.resource?(r=this._memoryConfigurationByResource.get(a.resource),r||(r=new f,this._memoryConfigurationByResource.set(a.resource,r))):r=this._memoryConfiguration,g===void 0?r.removeValue(i):r.setValue(i,g),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,g,a){const r=this.getConsolidateConfigurationModel(g,a),v=this.getFolderConfigurationModelForResource(g.resource,a),o=g.resource?this._memoryConfigurationByResource.get(g.resource)||this._memoryConfiguration:this._memoryConfiguration,d=g.overrideIdentifier?this._defaultConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),w=g.overrideIdentifier?this.userConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),I=g.overrideIdentifier?this.localUserConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),m=g.overrideIdentifier?this.remoteUserConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),k=a?g.overrideIdentifier?this._workspaceConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,R=v?g.overrideIdentifier?v.freeze().override(g.overrideIdentifier).getValue(i):v.freeze().getValue(i):void 0,L=g.overrideIdentifier?o.override(g.overrideIdentifier).getValue(i):o.getValue(i),b=r.getValue(i),B=h.distinct(h.flatten(r.overrides.map($=>$.identifiers))).filter($=>r.getOverrideValue(i,$)!==void 0);return{defaultValue:d,userValue:w,userLocalValue:I,userRemoteValue:m,workspaceValue:k,workspaceFolderValue:R,memoryValue:L,value:b,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,userLocal:I!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,userRemote:m!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:v?.freeze().getValue(i),override:g.overrideIdentifier?v?.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:o.getValue(i),override:g.overrideIdentifier?o.getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,overrideIdentifiers:B.length?B:void 0}}keys(i){const g=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:g?g.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,g){this._folderConfigurations.set(i,g),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,g){const a=g.filter(r=>y.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const v=(0,y.overrideIdentifierFromKey)(r),o=this._defaultConfiguration.getKeysForOverrideIdentifier(v),d=i.getKeysForOverrideIdentifier(v),w=[...d.filter(I=>o.indexOf(I)===-1),...o.filter(I=>d.indexOf(I)===-1),...o.filter(I=>!C.equals(this._defaultConfiguration.override(v).getValue(I),i.override(v).getValue(I)))];return[v,w]});return this.updateDefaultConfiguration(i),{keys:g,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.localUserConfiguration,i),o=[...g,...a,...r];return o.length&&this.updateLocalUserConfiguration(i),{keys:o,overrides:v}}compareAndUpdateRemoteUserConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.remoteUserConfiguration,i);let o=[...g,...a,...r];return o.length&&this.updateRemoteUserConfiguration(i),{keys:o,overrides:v}}compareAndUpdateWorkspaceConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.workspaceConfiguration,i);let o=[...g,...a,...r];return o.length&&this.updateWorkspaceConfiguration(i),{keys:o,overrides:v}}compareAndUpdateFolderConfiguration(i,g){const a=this.folderConfigurations.get(i),{added:r,updated:v,removed:o,overrides:d}=(0,t.compare)(a,g);let w=[...r,...v,...o];return(w.length||!a)&&this.updateFolderConfiguration(i,g),{keys:w,overrides:d}}compareAndDeleteFolderConfiguration(i){const g=this.folderConfigurations.get(i);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:r,removed:v,overrides:o}=(0,t.compare)(g,void 0);return{keys:[...a,...r,...v],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,g){let a=this.getConsolidatedConfigurationModelForResource(i,g);return i.overrideIdentifier?a.override(i.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:i},g){let a=this.getWorkspaceConsolidatedConfiguration();if(g&&i){const r=g.getFolder(i);r&&(a=this.getFolderConsolidatedConfiguration(r.uri)||a);const v=this._memoryConfigurationByResource.get(i);v&&(a=a.merge(v))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let g=this._foldersConsolidatedConfigurations.get(i);if(!g){const a=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(g=a.merge(r),this._freeze&&(g=g.freeze()),this._foldersConsolidatedConfigurations.set(i,g)):g=a}return g}getFolderConfigurationModelForResource(i,g){if(g&&i){const a=g.getFolder(i);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,g)=>{const{contents:a,overrides:r,keys:v}=this._folderConfigurations.get(g);return i.push([g,{contents:a,overrides:r,keys:v}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(g=>i.add(g)),this.userConfiguration.freeze().keys.forEach(g=>i.add(g)),this._workspaceConfiguration.freeze().keys.forEach(g=>i.add(g)),this._folderConfigurations.forEach(g=>g.freeze().keys.forEach(a=>i.add(a))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const g=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(r=>g.add(r))),[...g.values()]}static parse(i){const g=this.parseConfigurationModel(i.defaults),a=this.parseConfigurationModel(i.user),r=this.parseConfigurationModel(i.workspace),v=i.folders.reduce((o,d)=>(o.set(T.URI.revive(d[0]),this.parseConfigurationModel(d[1])),o),new F.ResourceMap);return new P(g,a,new f,r,v,new f,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new f(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=P;function D(..._){if(_.length===0)return{keys:[],overrides:[]};if(_.length===1)return _[0];const i=new Set,g=new Map;for(const r of _)r.keys.forEach(v=>i.add(v)),r.overrides.forEach(([v,o])=>{const d=(0,F.getOrSet)(g,v,new Set);o.forEach(w=>d.add(w))});const a=[];return g.forEach((r,v)=>a.push([v,[...r.values()]])),{keys:[...i.values()],overrides:a}}e.mergeChanges=D;class l{constructor(i,g,a,r){this.change=i,this.previous=g,this.currentConfiguraiton=a,this.currentWorkspace=r,this._previousConfiguration=void 0;const v=new Set;i.keys.forEach(d=>v.add(d)),i.overrides.forEach(([,d])=>d.forEach(w=>v.add(w))),this.affectedKeys=[...v.values()];const o=new f;this.affectedKeys.forEach(d=>o.setValue(d,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,g){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(g){const a=this.previousConfiguration?this.previousConfiguration.getValue(i,g,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,g,this.currentWorkspace);return!C.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(i,g){let a=(0,t.toValuesTree)({[g]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(i=i[r],!i)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=l;class u extends l{constructor(i,g,a,r){super({keys:i.allKeys(),overrides:[]},void 0,i,g);this.source=a,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=u}),define(be[86],Ee([0,1,4]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(F,C=M.Unknown,S){super(F);this._message=F,this._code=C,this._detail=S,this.isHandled=C===M.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(F){return F instanceof E&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof E&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof E&&F.isHandled}}e.RemoteAuthorityResolverError=E}),define(be[63],Ee([0,1,11]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(T){return T.scheme===h.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=M;function E(T){if(!T)return;const t=T.indexOf("+");return t<0?T:T.substr(0,t)}e.getRemoteName=E;function A(T){return T.scheme!==h.Schemas.file&&T.scheme!==h.Schemas.vscodeRemote}e.isVirtualResource=A;function F(T){if(T.folders.length)return T.folders.every(t=>A(t.uri))?T.folders[0].uri:void 0;if(T.configuration&&A(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=F;function C(T){return F(T)?.scheme}e.getVirtualWorkspaceScheme=C;function S(T){return F(T)!==void 0}e.isVirtualWorkspace=S}),define(be[26],Ee([0,1,9,4,63]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=A;function F(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));class S{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,s){if(typeof f=="undefined"||f===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof f=="string"||typeof s=="string"){let c=typeof f=="string"?f:f.value,p=typeof s=="string"?s:s.value;return h.equalsIgnoreCase(c,p)}return f._lower===s._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=S;function T(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function t(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=t;function y(n,f){if(f&&n.enableProposedApi){const s=`onResolveRemoteAuthority:${(0,E.getRemoteName)(f)}`;return n.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[148],Ee([0,1,9,26]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(s,c){return s.uuid&&c.uuid?s.uuid===c.uuid:s.id===c.id?!0:(0,h.compareIgnoreCase)(s.id,c.id)===0}e.areSameExtensions=E;class A{constructor(c,p){this.version=p,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof A?E(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=A;function F(s,c){return`${s}.${c}`}e.getExtensionId=F;function C(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function S(s,c){return C(F(s,c))}e.getGalleryExtensionId=S;function T(s,c){const p=[],P=D=>{for(const l of p)if(l.some(u=>E(c(u),c(D))))return l;return null};for(const D of s){const l=P(D);l?l.push(D):p.push([D])}return p}e.groupByExtension=T;function t(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function y(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(s){const c=new Set;for(const p of s)p.malicious&&c.add(p.id.id);return c}e.getMaliciousExtensionsSet=n;function f(s,c){const p=[],P=c.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const D=P.shift();if(D&&p.every(l=>!E(l.identifier,{id:D}))){const l=s.filter(u=>E(u.identifier,{id:D}));l.length===1&&(p.push(l[0]),P.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=f}),define(be[149],Ee([0,1,3,25,4,15]),function(se,e,h,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService");var F;(function(s){s.Http="http",s.Https="https"})(F=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=y;function n(s,c){return c?c!==1&&s<1024:!M.isWindows&&s<1024}e.isPortPrivileged=n;let f=class{constructor(c){this.logService=c,this._onTunnelOpened=new h.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new h.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new h.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c,p){return this._tunnelProvider=c,c?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],p=Array.from(this._tunnels.values());for(let P of p){const D=Array.from(P.values());for(let l of D){const u=await l.value;u&&c.push(u)}}return c}async dispose(){for(const c of this._tunnels.values()){for(const{value:p}of c.values())await p.then(P=>P?.dispose());c.clear()}this._tunnels.clear()}openTunnel(c,p,P,D,l=!1,u=C.Private,_){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${P} on local port ${D}.`),!c)return;p||(p="localhost");const i=this.retainOrCreateTunnel(c,p,P,D,l,u,_);return i?i.then(g=>{if(!g){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(g);return(g.tunnelRemoteHost!==p||g.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const p=this._tunnels.get(c.tunnelRemoteHost);if(p){const P=p.get(c.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,P))}}}}async tryDisposeTunnel(c,p,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${p}.`);const D=P.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(p),D}}async closeTunnel(c,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${p} `);const P=this._tunnels.get(c);if(P&&P.has(p)){const D=P.get(p);D.refcount=0,await this.tryDisposeTunnel(c,p,D)}}addTunnelToMap(c,p,P){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(p,{refcount:1,value:P})}async removeEmptyTunnelFromMap(c,p){const P=this._tunnels.get(c);P&&(await P.get(p)||P.delete(p),P.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,p){let P=[c];t(c)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):y(c)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const D=P.map(l=>this._tunnels.get(l));for(const l of D){const u=l?.get(p);if(u)return u}}canTunnel(c){return!!T(c)}createWithProvider(c,p,P,D,l,u,_){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${P} on local port ${D}.`);const g={elevationRequired:l?n(D===void 0?P:D):!1},a={remoteAddress:{host:p,port:P},localAddressPort:D,privacy:u,public:u!==C.Private,protocol:_},r=c.forwardPort(a,g);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(p,P,r),r}};f=$e([ze(0,A.ILogService)],f),e.AbstractTunnelService=f}),define(be[150],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,F=5){let C;return C=A(S=>{const T=typeof S=="string"?S:S.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(T);return}const y=setTimeout(()=>this.flushBuffer(E),F);t={data:[T],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(E),C.dispose()}},this._terminalBufferMap.set(E,t)}),C}stopBuffering(E){const A=this._terminalBufferMap.get(E);A&&A.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=h}),define(be[151],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var h;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(h=e.ColorScheme||(e.ColorScheme={}))}),define(be[47],Ee([0,1,34,3,6,4,28,151]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(p){function P(D){return D&&typeof D=="object"&&typeof D.id=="string"}p.isThemeColor=P})(S=e.ThemeColor||(e.ThemeColor={}));function T(p){return{id:p}}e.themeColorFromId=T;var t;(function(p){function P(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color=="undefined"||S.isThemeColor(g.color))}p.isThemeIcon=P;const D=new RegExp(`^\\$\\((${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?)\\)$`);function l(g){const a=D.exec(g);if(!a)return;let[,r]=a;return{id:r}}p.fromString=l;function u(g,a){let r=g.id;const v=r.lastIndexOf("~");return v!==-1&&(r=r.substring(0,v)),a&&(r=`${r}~${a}`),{id:r}}p.modify=u;function _(g,a){return g.id===a.id&&g.color?.id===a.color?.id}p.isEqual=_;function i(g,a){return{id:g.id,color:a?T(a):void 0}}p.asThemeIcon=i,p.asClassNameArray=h.CSSIcon.asClassNameArray,p.asClassName=h.CSSIcon.asClassName,p.asCSSSelector=h.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=h.Codicon.file,e.FolderThemeIcon=h.Codicon.folder;function y(p){switch(p){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,E.toDisposable)(()=>{const D=this.themingParticipants.indexOf(P);this.themingParticipants.splice(D,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new n;F.Registry.add(e.Extensions.ThemingContribution,f);function s(p){return f.onColorThemeChange(p)}e.registerThemingParticipant=s;class c extends E.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(D=>this.onThemeChange(D)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,D){let l=this.theme.getColor(P);return l&&D&&(l=D(l,this.theme)),l?l.toString():null}}e.Themable=c}),define(be[152],Ee([0,1,12,34,3,123,84,28,47]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(P,D,l,u){const _=this.iconsById[P];if(_){if(l&&!_.description){_.description=l,this.iconSchema.properties[P].markdownDescription=`${l} $(${P})`;const a=this.iconReferenceSchema.enum.indexOf(P);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=l),this._onDidChange.fire()}return _}let i={id:P,description:l,defaults:D,deprecationMessage:u};this.iconsById[P]=i;let g={$ref:"#/definitions/icons"};return u&&(g.deprecationMessage=u),l&&(g.markdownDescription=`${l}: $(${P})`),this.iconSchema.properties[P]=g,this.iconReferenceSchema.enum.push(P),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:P}}deregisterIcon(P){delete this.iconsById[P],delete this.iconSchema.properties[P];const D=this.iconReferenceSchema.enum.indexOf(P);D!==-1&&(this.iconReferenceSchema.enum.splice(D,1),this.iconReferenceSchema.enumDescriptions.splice(D,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(P=>this.iconsById[P])}getIcon(P){return this.iconsById[P]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(P,D){const l=this.iconFontsById[P];if(l)return l;let u={id:P,definition:D};return this.iconFontsById[P]=u,this._onDidChange.fire(),u}deregisterIconFont(P){delete this.iconFontsById[P]}getIconFonts(){return Object.keys(this.iconFontsById).map(P=>this.iconFontsById[P])}getIconFont(P){return this.iconFontsById[P]}toString(){const P=(_,i)=>_.id.localeCompare(i.id),D=_=>{for(;S.ThemeIcon.isThemeIcon(_.defaults);)_=this.iconsById[_.defaults.id];return`codicon codicon-${_?_.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(_=>this.iconsById[_]);for(const _ of u.filter(i=>!!i.description).sort(P))l.push(`|<i class="${D(_)}"></i>|${_.id}|${S.ThemeIcon.isThemeIcon(_.defaults)?_.defaults.id:_.id}|${_.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const _ of u.filter(i=>!S.ThemeIcon.isThemeIcon(i.defaults)).sort(P))l.push(`|<i class="${D(_)}"></i>|${_.id}|`);return l.join(`
`)}}const t=new T;C.Registry.add(e.Extensions.IconContribution,t);function y(p,P,D,l){return t.registerIcon(p,P,D,l)}e.registerIcon=y;function n(){return t}e.getIconRegistry=n;function f(){for(const p of M.iconRegistry.all)t.registerIcon(p.id,p.definition,p.description);M.iconRegistry.onDidRegister(p=>t.registerIcon(p.id,p.definition,p.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let s=C.Registry.as(F.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,t.getIconSchema());const c=new h.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.widgetClose=y("widget-close",M.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=y("goto-previous-location",M.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=y("goto-next-location",M.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=S.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[48],Ee([0,1,20,24,2,4]),function(se,e,h,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function C(n){const f=n;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=C;function S(n){const f=n;return!!(f&&typeof f=="object"&&E.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=S;class T{constructor(f,s,c,p,P){this._id=f,this._transient=c,this._configuration=p,this._ignorePathCasing=P,this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class t{constructor(f,s){this.raw=s,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,M.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function y(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=y}),define(be[64],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const A=this._idPool++;return this._data.set(A,E),this.logDebugInfo(),A}get(E,A){return this._data.has(E)?this._data.get(E)[A]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!h.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=h,h.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(C=>{const S=this._providerInfo.get(C.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(C,S){S===null?this._providerInfo.delete(C):this._providerInfo.set(C,S)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(be[153],Ee([0,1,12]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,C,S){this._deferredPromises=new Map,this._id=F,this._shared=C,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of T.values())t.complete()}catch(t){for(const y of T.values())y.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,C){let S=this._value[F];return typeof S=="undefined"&&(S=C),S}update(F,C){this._value[F]=C;let S=this._deferredPromises.get(F);if(S!==void 0)return S.p;const T=new h.DeferredPromise;return this._deferredPromises.set(F,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(F,C){super(F.identifier.value,!0,C);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=E}),define(be[154],Ee([0,1,3,2,15]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(C,S){this._logService=C,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new h.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,S,T){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptModelChanged(S.value,T)}$acceptDirtyStateChanged(C,S){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptDirty(S)}$acceptModelSaved(C){const S=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(C,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,S);const T=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));T.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};A=$e([ze(0,E.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(be[13],Ee([0,1,4]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var Ze=this&&this.__classPrivateFieldSet||function(se,e,h,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,h):E?E.value=h:e.set(se,h),h},Ae=this&&this.__classPrivateFieldGet||function(se,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(se):M?M.value:e.get(se)};define(be[155],Ee([0,1,26,3]),function(se,e,h,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(C,S){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(C.identifier),Ze(this,E,S,"f"),Ae(this,E,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(C){return Ae(this,E,"f").get(this._id,C)}store(C,S){return Ae(this,E,"f").store(this._id,C,S)}delete(C){return Ae(this,E,"f").delete(this._id,C)}}e.ExtensionSecrets=A,E=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(be[49],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var h;(function(D){D[D.Upsert=0]="Upsert",D[D.RemoveChild=1]="RemoveChild",D[D.Invalidated=2]="Invalidated",D[D.SetProp=3]="SetProp",D[D.Bulk=4]="Bulk"})(h=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(D,l)=>{const u={controllerId:l};return M.set(D,u),u};e.createPrivateApiFor=E;const A=D=>M.get(D);e.getPrivateApiFor=A;const F=(D,l,u,_)=>{let i=u;return{enumerable:!0,configurable:!1,get(){return i},set(g){if(!_(i,g)){const a=i;i=g,D.listener?.({op:3,key:l,value:g,previous:a})}}}},C=(D,l)=>D===l,S={range:(D,l)=>D===l?!0:!D||!l?!1:D.isEqual(l),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(D,l)=>!(D.length!==l.length||D.some(u=>!l.find(_=>u.id===_.id)))},T=Object.keys(S),t=(D,l)=>({range:F(D,"range",void 0,S.range),label:F(D,"label",l,S.label),description:F(D,"description",void 0,S.description),canResolveChildren:F(D,"canResolveChildren",!1,S.canResolveChildren),busy:F(D,"busy",!1,S.busy),error:F(D,"error",void 0,S.error),tags:F(D,"tags",[],S.tags)}),y=(D,l)=>{const u=new Map;for(const _ of T)S[_](D[_],l[_])||u.set(_,l[_]);return u};e.diffTestItems=y;class n extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=n;class f extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class s extends Error{constructor(l,u,_){super(`TestItem with ID "${l}" is from controller "${u}" and cannot be added as a child of an item from controller "${_}".`)}}e.MixedTestItemController=s;const c=D=>{const l=(0,e.getPrivateApiFor)(D);let u=new Map;return{get size(){return u.size},forEach(_,i){for(const g of u.values())_.call(i,g,this)},replace(_){const i=new Map,g=new Set(u.keys()),a={op:4,ops:[]};for(const r of _){if(!(r instanceof p))throw new f(r.id);const v=(0,e.getPrivateApiFor)(r).controllerId;if(v!==l.controllerId)throw new s(r.id,v,l.controllerId);if(i.has(r.id))throw new n(r.id);i.set(r.id,r),g.delete(r.id),a.ops.push({op:0,item:r})}for(const r of g.keys())a.ops.push({op:1,id:r});l.listener?.(a),u=i},add(_){if(!(_ instanceof p))throw new f(_.id);u.set(_.id,_),l.listener?.({op:0,item:_})},delete(_){u.delete(_)&&l.listener?.({op:1,id:_})},get(_){return u.get(_)},toJSON(){return Array.from(u.values())},[Symbol.iterator](){return u.values()}}};class p{constructor(l,u,_,i){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const g=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof P?void 0:g.parent}},children:{value:c(this),enumerable:!0,writable:!1},...t(g,_)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class P extends p{constructor(l,u){super(l,l,u,void 0)}}e.TestItemRootImpl=P}),define(be[65],Ee([0,1,4,149,3,13]),function(se,e,h,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var F;(function(S){function T(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:y.protocol}}S.fromApiTunnel=T;function t(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==M.TunnelPrivacyId.ConstantPrivate&&y.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}S.fromServiceTunnel=t})(F=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,h.createDecorator)("IExtHostTunnelService");let C=class{constructor(T){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,t){}async getTunnels(){return[]}async setTunnelExtensionFunctions(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,t){return{dispose:()=>{}}}async $providePortAttributes(T,t,y,n,f){return[]}async $forwardPort(T,t){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=$e([ze(0,A.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var Ze=this&&this.__classPrivateFieldSet||function(se,e,h,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,h):E?E.value=h:e.set(se,h),h},Ae=this&&this.__classPrivateFieldGet||function(se,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(se):M?M.value:e.get(se)};define(be[7],Ee([0,1,14,16,77,20,79,10,2,36,60,86]),function(se,e,h,M,E,A,F,C,S,T,t,y){"use strict";var n,f,s,c,p,P,D,l,u,_,i,g,a,r,v,o,d,w,I,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let R=p=class{constructor(O){n.set(this,void 0),Ze(this,n,O,"f")}static from(...O){let re=O;return new p(function(){if(re){for(const _e of re)_e&&typeof _e.dispose=="function"&&_e.dispose();re=void 0}})}dispose(){typeof Ae(this,n,"f")=="function"&&(Ae(this,n,"f").call(this),Ze(this,n,void 0,"f"))}};n=new WeakMap,R=p=$e([k],R),e.Disposable=R;let L=P=class{constructor(O,re){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(re<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=re}static Min(...O){if(O.length===0)throw new TypeError;let re=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isBefore(re)&&(re=Ge)}return re}static Max(...O){if(O.length===0)throw new TypeError;let re=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isAfter(re)&&(re=Ge)}return re}static isPosition(O){if(!O)return!1;if(O instanceof P)return!0;let{line:re,character:_e}=O;return typeof re=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,re=0){if(O===null||re===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,re=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&re===0?this:new P(this.line+_e,this.character+re)}with(O,re=this.character){if(O===null||re===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,re=typeof O.character=="number"?O.character:this.character),_e===this.line&&re===this.character?this:new P(_e,re)}toJSON(){return{line:this.line,character:this.character}}};L=P=$e([k],L),e.Position=L;let b=D=class{constructor(O,re,_e,Ge){let tt,at;if(typeof O=="number"&&typeof re=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new L(O,re),at=new L(_e,Ge)):O instanceof L&&re instanceof L&&(tt=O,at=re),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(O){return O instanceof D?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof D?this.contains(O._start)&&this.contains(O._end):O instanceof L?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const re=L.Max(O.start,this._start),_e=L.Min(O.end,this._end);if(!re.isAfter(_e))return new D(re,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const re=L.Min(O.start,this._start),_e=L.Max(O.end,this.end);return new D(re,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,re=this.end){if(O===null||re===null)throw(0,M.illegalArgument)();let _e;return O?L.isPosition(O)?_e=O:(_e=O.start||this.start,re=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&re.isEqual(this.end)?this:new D(_e,re)}toJSON(){return[this.start,this.end]}};b=D=$e([k],b),e.Range=b;let B=l=class extends b{constructor(O,re,_e,Ge){let tt,at;if(typeof O=="number"&&typeof re=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new L(O,re),at=new L(_e,Ge)):O instanceof L&&re instanceof L&&(tt=O,at=re),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(O){return O instanceof l?!0:O?b.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};B=l=$e([k],B),e.Selection=B;class ${constructor(O,re,_e){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(re),this.connectionToken=_e}}e.ResolvedAuthority=$;class x extends Error{constructor(O,re=y.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=re,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable(O,re){return new x(O,y.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(O){return new x(O,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var K;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var H;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(H=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=u=class{constructor(O,re){this._range=O,this._newText=re}static isTextEdit(O){return O instanceof u?!0:O?b.isRange(O)&&typeof O.newText=="string":!1}static replace(O,re){return new u(O,re)}static insert(O,re){return u.replace(new b(O,O),re)}static delete(O){return u.replace(O,"")}static setEndOfLine(O){const re=new u(new b(new L(0,0),new L(0,0)),"");return re.newEol=O,re}get range(){return this._range}set range(O){if(O&&!b.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=u=$e([k],W),e.TextEdit=W;var ne;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(ne=e.FileEditType||(e.FileEditType={}));let V=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,re,_e,Ge){this._edits.push({_type:1,from:O,to:re,options:_e,metadata:Ge})}createFile(O,re,_e){this._edits.push({_type:1,from:void 0,to:O,options:re,metadata:_e})}deleteFile(O,re,_e){this._edits.push({_type:1,from:O,to:void 0,options:re,metadata:_e})}replaceNotebookMetadata(O,re,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(O,re,_e,Ge,tt){let at,ut,Ct=[],At;if(zt.isNotebookRange(re)&&Ot.isNotebookCellDataArray(_e)&&!Ot.isNotebookCellDataArray(Ge)?(at=re.start,ut=re.end,Ct=_e,At=Ge):typeof re=="number"&&typeof _e=="number"&&Ot.isNotebookCellDataArray(Ge)&&(at=re,ut=_e,Ct=Ge,At=tt),at===void 0||ut===void 0)throw new Error("Invalid arguments");(at!==ut||Ct.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:ut-at,cells:Ct,metadata:At})}replaceNotebookCellMetadata(O,re,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:re,metadata:_e}})}replace(O,re,_e,Ge){this._edits.push({_type:2,uri:O,edit:new W(re,_e),metadata:Ge})}insert(O,re,_e,Ge){this.replace(O,new b(re,re),_e,Ge)}delete(O,re,_e){this.replace(O,re,"",_e)}has(O){return this._edits.some(re=>re._type===2&&re.uri.toString()===O.toString())}set(O,re){if(re)for(const _e of re)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,h.coalesceInPlace)(this._edits)}}get(O){const re=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&re.push(_e.edit);return re}entries(){const O=new A.ResourceMap;for(let re of this._edits)if(re._type===2){let _e=O.get(re.uri);_e||(_e=[re.uri,[]],O.set(re.uri,_e)),_e[1].push(re.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};V=$e([k],V),e.WorkspaceEdit=V;let J=_=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof _?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=_._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,re=this._tabstop++){if(typeof O=="function"){const _e=new _;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=_._escape(O);return this.value+="${",this.value+=re,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,re=this._tabstop++){const _e=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,re){if(typeof re=="function"){const _e=new _;_e._tabstop=this._tabstop,re(_e),this._tabstop=_e._tabstop,re=_e.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,re&&(this.value+=":",this.value+=re),this.value+="}",this}};J=_=$e([k],J),e.SnippetString=J;var j;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(j=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ee=i=class{constructor(O,re){if(this.uri=O,re)if(re instanceof b)this.range=re;else if(re instanceof L)this.range=new b(re,re);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof i?!0:O?b.isRange(O.range)&&S.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ee=i=$e([k],ee),e.Location=ee;let ve=class{constructor(O,re){this.location=O,this.message=re}static is(O){return O?typeof O.message=="string"&&O.location&&b.isRange(O.location.range)&&S.URI.isUri(O.location.uri):!1}static isEqual(O,re){return O===re?!0:!O||!re?!1:O.message===re.message&&O.location.range.isEqual(re.location.range)&&O.location.uri.toString()===re.location.uri.toString()}};ve=$e([k],ve),e.DiagnosticRelatedInformation=ve;let Re=class{constructor(O,re,_e=le.Error){if(!b.isRange(O))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=O,this.message=re,this.severity=_e}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,re){return O===re?!0:!O||!re?!1:O.message===re.message&&O.severity===re.severity&&O.code===re.code&&O.severity===re.severity&&O.source===re.source&&O.range.isEqual(re.range)&&(0,h.equals)(O.tags,re.tags)&&(0,h.equals)(O.relatedInformation,re.relatedInformation,ve.isEqual)}};Re=$e([k],Re),e.Diagnostic=Re;let Fe=class{constructor(O,re){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=re}};Fe=$e([k],Fe),e.Hover=Fe;var Oe;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Oe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ke=class{constructor(O,re=Oe.Text){this.range=O,this.kind=re}toJSON(){return{range:this.range,kind:Oe[this.kind]}}};Ke=$e([k],Ke),e.DocumentHighlight=Ke;var je;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var Ve;(function(N){N[N.Deprecated=1]="Deprecated"})(Ve=e.SymbolTag||(e.SymbolTag={}));let U=g=class{constructor(O,re,_e,Ge,tt){this.name=O,this.kind=re,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ge instanceof ee?this.location=Ge:_e instanceof b&&(this.location=new ee(Ge,_e)),g.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};U=g=$e([k],U),e.SymbolInformation=U;let Q=a=class{constructor(O,re,_e,Ge,tt){this.name=O,this.detail=re,this.kind=_e,this.range=Ge,this.selectionRange=tt,this.children=[],a.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(a.validate)}};Q=a=$e([k],Q),e.DocumentSymbol=Q;var te;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(O,re){this.title=O,this.kind=re}};ae=$e([k],ae),e.CodeAction=ae;let G=r=class{constructor(O){this.value=O}append(O){return new r(this.value?this.value+r.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+r.sep)}};G.sep=".",G=r=$e([k],G),e.CodeActionKind=G,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll");let oe=class{constructor(O,re){if(this.range=O,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=$e([k],oe),e.SelectionRange=oe;class he{constructor(O,re,_e,Ge,tt,at){this.kind=O,this.name=re,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=he;class Te{constructor(O,re){this.fromRanges=re,this.from=O}}e.CallHierarchyIncomingCall=Te;class Be{constructor(O,re){this.fromRanges=re,this.to=O}}e.CallHierarchyOutgoingCall=Be;var He;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(He=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(O,re){this.range=O,this.command=re}get isResolved(){return!!this.command}};Qe=$e([k],Qe),e.CodeLens=Qe;let et=v=class{constructor(O,re=!1){f.set(this,void 0),Ze(this,f,new E.MarkdownString(O,{supportThemeIcons:re}),"f")}static isMarkdownString(O){return O instanceof v?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ae(this,f,"f").value}set value(O){Ae(this,f,"f").value=O}get isTrusted(){return Ae(this,f,"f").isTrusted}set isTrusted(O){Ae(this,f,"f").isTrusted=O}get supportThemeIcons(){return Ae(this,f,"f").supportThemeIcons}set supportThemeIcons(O){Ae(this,f,"f").supportThemeIcons=O}get supportHtml(){return Ae(this,f,"f").supportHtml}set supportHtml(O){Ae(this,f,"f").supportHtml=O}appendText(O){return Ae(this,f,"f").appendText(O),this}appendMarkdown(O){return Ae(this,f,"f").appendMarkdown(O),this}appendCodeblock(O,re){return Ae(this,f,"f").appendCodeblock(re??"",O),this}};f=new WeakMap,et=v=$e([k],et),e.MarkdownString=et;let ot=class{constructor(O,re){this.label=O,this.documentation=re}};ot=$e([k],ot),e.ParameterInformation=ot;let ye=class{constructor(O,re){this.label=O,this.documentation=re,this.parameters=[]}};ye=$e([k],ye),e.SignatureInformation=ye;let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};nt=$e([k],nt),e.SignatureHelp=nt;var q;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Z;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Z=e.InlayHintKind||(e.InlayHintKind={}));let pe=class{constructor(O,re,_e){this.text=O,this.position=re,this.kind=_e}};pe=$e([k],pe),e.InlayHint=pe;var We;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(We=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ye;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Ye=e.CompletionItemKind||(e.CompletionItemKind={}));var rt;(function(N){N[N.Deprecated=1]="Deprecated"})(rt=e.CompletionItemTag||(e.CompletionItemTag={}));let ft=class{constructor(O,re){this.label=O,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Ye[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ft=$e([k],ft),e.CompletionItem=ft;let dt=class{constructor(O=[],re=!1){this.items=O,this.isIncomplete=re}};dt=$e([k],dt),e.CompletionList=dt;let St=class{constructor(O,re,_e){this.text=O,this.range=re,this.command=_e}};St=$e([k],St),e.InlineSuggestion=St;let It=class{constructor(O){this.items=O}};It=$e([k],It),e.InlineSuggestions=It;var Tt;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(Tt=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var vt;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(vt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Se;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Se=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ce;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ie;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(ie=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(re){switch(re){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let me=class{constructor(O,re){if(re&&!S.URI.isUri(re))throw(0,M.illegalArgument)("target");if(!b.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=re}};me=$e([k],me),e.DocumentLink=me;let fe=class{constructor(O,re,_e,Ge){this.red=O,this.green=re,this.blue=_e,this.alpha=Ge}};fe=$e([k],fe),e.Color=fe;let Ie=class{constructor(O,re){if(re&&!(re instanceof fe))throw(0,M.illegalArgument)("color");if(!b.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=re}};Ie=$e([k],Ie),e.ColorInformation=Ie;let xe=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};xe=$e([k],xe),e.ColorPresentation=xe;var Ne;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Ne=e.ColorFormat||(e.ColorFormat={}));var qe;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(qe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class it{constructor(O,re,_e){if(this.startIndex=O,this.length=re,this.tooltip=_e,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof re!="number"||re<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=it;var Le;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Le=e.TerminalLocation||(e.TerminalLocation={}));class de{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=de;var ge;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(ge=e.TaskRevealKind||(e.TaskRevealKind={}));var X;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(X=e.TaskPanelKind||(e.TaskPanelKind={}));let z=o=class{constructor(O,re){if(this.label=re,typeof O!="string"||typeof re!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};z.Clean=new o("clean","Clean"),z.Build=new o("build","Build"),z.Rebuild=new o("rebuild","Rebuild"),z.Test=new o("test","Test"),z=o=$e([k],z),e.TaskGroup=z;function we(N){let O="";for(let re=0;re<N.length;re++)O+=N[re].replace(/,/g,",,")+",";return O}let ke=class{constructor(O,re,_e){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=_e):this._options=re)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let re of this._args)O.push(re);return we(O)}};ke=$e([k],ke),e.ProcessExecution=ke;let Je=class{constructor(O,re,_e){if(this._args=[],Array.isArray(re)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=re,this._options=_e}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=re}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)O.push(typeof re=="string"?re:re.value);return we(O)}};Je=$e([k],Je),e.ShellExecution=Je;var Ue;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(Ue=e.ShellQuoting||(e.ShellQuoting={}));var ct;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(ct=e.TaskScope||(e.TaskScope={}));class pt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=pt;let lt=d=class{constructor(O,re,_e,Ge,tt,at){this.__deprecated=!1,this._definition=this.definition=O;let ut;typeof re=="string"?(this._name=this.name=re,this._source=this.source=_e,this.execution=Ge,ut=tt,this.__deprecated=!0):re===ct.Global||re===ct.Workspace?(this.target=re,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,ut=at):(this.target=re,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,ut=at),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ke?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const re=this._definition.type;(d.EmptyType===re||d.ProcessType===re||d.ShellType===re||d.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=d=$e([k],lt),e.Task=lt;var gt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let ht=class{constructor(O,re=_t.None){this.collapsibleState=re,S.URI.isUri(O)?this.resourceUri=O:this.label=O}};ht=$e([k],ht),e.TreeItem=ht;var _t;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let wt=class{constructor(O,re){this.id=O,this.color=re}};wt=$e([k],wt),e.ThemeIcon=wt,wt.File=new wt("file"),wt.Folder=new wt("folder");let Ft=class{constructor(O){this.id=O}};Ft=$e([k],Ft),e.ThemeColor=Ft;var Vt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Dt=class{constructor(O,re){if(typeof O!="string"&&(!O||!S.URI.isUri(O)&&!S.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof re!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=S.URI.file(O),this.base=O):S.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=re}};Dt=$e([k],Dt),e.RelativePattern=Dt;let Mt=class{constructor(O,re,_e,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof re=="string"&&(this.condition=re),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};Mt=$e([k],Mt),e.Breakpoint=Mt;let ti=class extends Mt{constructor(O,re,_e,Ge,tt){super(re,_e,Ge,tt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};ti=$e([k],ti),e.SourceBreakpoint=ti;let bt=class extends Mt{constructor(O,re,_e,Ge,tt){super(re,_e,Ge,tt);this.functionName=O}};bt=$e([k],bt),e.FunctionBreakpoint=bt;let Qt=class extends Mt{constructor(O,re,_e,Ge,tt,at,ut){super(Ge,tt,at,ut);if(!re)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=re,this.canPersist=_e}};Qt=$e([k],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(O,re,_e){this.command=O,this.args=re||[],this.options=_e}};jt=$e([k],jt),e.DebugAdapterExecutable=jt;let ii=class{constructor(O,re){this.port=O,this.host=re}};ii=$e([k],ii),e.DebugAdapterServer=ii;let ni=class{constructor(O){this.path=O}};ni=$e([k],ni),e.DebugAdapterNamedPipeServer=ni;let Pt=class{constructor(O){this.implementation=O}};Pt=$e([k],Pt),e.DebugAdapterInlineImplementation=Pt;let Yt=class{constructor(O,re){this.range=O,this.expression=re}};Yt=$e([k],Yt),e.EvaluatableExpression=Yt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,re){this.range=O,this.text=re}};Wt=$e([k],Wt),e.InlineValueText=Wt;let Ht=class{constructor(O,re,_e=!0){this.range=O,this.variableName=re,this.caseSensitiveLookup=_e}};Ht=$e([k],Ht),e.InlineValueVariableLookup=Ht;let mt=class{constructor(O,re){this.range=O,this.expression=re}};mt=$e([k],mt),e.InlineValueEvaluatableExpression=mt;let ri=class{constructor(O,re){this.frameId=O,this.stoppedLocation=re}};ri=$e([k],ri),e.InlineValueContext=ri;var xt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(xt=e.FileChangeType||(e.FileChangeType={}));let Bt=w=class extends Error{constructor(O,re=t.FileSystemProviderErrorCode.Unknown,_e){super(S.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new w(O,t.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(O){return new w(O,t.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(O){return new w(O,t.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(O){return new w(O,t.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(O){return new w(O,t.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(O){return new w(O,t.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Bt=w=$e([k],Bt),e.FileSystemError=Bt;let Jt=class{constructor(O,re,_e){this.start=O,this.end=re,this.kind=_e}};Jt=$e([k],Jt),e.FoldingRange=Jt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(O,re=[]){this.tokenTypes=O,this.tokenModifiers=re}}e.SemanticTokensLegend=fi;function Xt(N){return typeof N=="undefined"||(0,C.isStringArray)(N)}class si{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let re=0,_e=O.tokenTypes.length;re<_e;re++)this._tokenTypeStrToInt.set(O.tokenTypes[re],re);for(let re=0,_e=O.tokenModifiers.length;re<_e;re++)this._tokenModifierStrToInt.set(O.tokenModifiers[re],re)}}push(O,re,_e,Ge,tt){if(typeof O=="number"&&typeof re=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,re,_e,Ge,tt);if(b.isRange(O)&&typeof re=="string"&&Xt(_e))return this._push(O,re,_e);throw(0,M.illegalArgument)()}_push(O,re,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,tt=O.start.character,at=O.end.character-O.start.character,ut=this._tokenTypeStrToInt.get(re);let Ct=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);Ct|=1<<Lt>>>0}this._pushEncoded(Ge,tt,at,ut,Ct)}_pushEncoded(O,re,_e,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let At=0,Lt=0;for(let Nt=0;Nt<Ct;Nt++){let Ut=this._data[5*Nt],ci=this._data[5*Nt+1];Ut===0?(Ut=At,ci+=Lt):Ut+=At,this._data[5*Nt]=Ut,this._data[5*Nt+1]=ci,At=Ut,Lt=ci}}let at=O,ut=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=re}static _sortAndDeltaEncode(O){let re=[];const _e=O.length/5|0;for(let ut=0;ut<_e;ut++)re[ut]=ut;re.sort((ut,Ct)=>{const At=O[5*ut],Lt=O[5*Ct];if(At===Lt){const Nt=O[5*ut+1],Ut=O[5*Ct+1];return Nt-Ut}return At-Lt});const Ge=new Uint32Array(O.length);let tt=0,at=0;for(let ut=0;ut<_e;ut++){const Ct=5*re[ut],At=O[Ct+0],Lt=O[Ct+1],Nt=O[Ct+2],Ut=O[Ct+3],ci=O[Ct+4],xi=At-tt,qi=xi===0?Lt-at:Lt,di=5*ut;Ge[di+0]=xi,Ge[di+1]=qi,Ge[di+2]=Nt,Ge[di+3]=Ut,Ge[di+4]=ci,tt=At,at=Lt}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(si._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=si;class qt{constructor(O,re){this.resultId=re,this.data=O}}e.SemanticTokens=qt;class oi{constructor(O,re,_e){this.start=O,this.deleteCount=re,this.data=_e}}e.SemanticTokensEdit=oi;class _i{constructor(O,re){this.resultId=re,this.edits=O}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Zt=class{constructor(){}};Zt.Back={iconPath:new wt("arrow-left")},Zt=$e([k],Zt),e.QuickInputButtons=Zt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,re,_e){this.badge=O,this.tooltip=re,this.color=_e}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let ai=class{constructor(O){this.kind=O}};ai=$e([k],ai),e.ColorTheme=ai;var li;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(li=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(O,re){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(re<0)throw(0,M.illegalArgument)("end must be positive");O<=re?(this._start=O,this._end=re):(this._start=re,this._end=O)}static isNotebookRange(O){return O instanceof zt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let re=this._start,_e=this._end;return O.start!==void 0&&(re=O.start),O.end!==void 0&&(_e=O.end),re===this._start&&_e===this._end?this:new zt(re,_e)}}e.NotebookRange=zt;class Ot{constructor(O,re,_e,Ge,tt,at,ut){this.kind=O,this.value=re,this.languageId=_e,this.mime=Ge,this.outputs=tt??[],this.metadata=at,this.executionSummary=ut,Ot.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(re=>Ot.isNotebookCellData(re))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Ot;class Me{constructor(O){this.cells=O}}e.NotebookData=Me;class Rt{constructor(O,re){this.data=O,this.mime=re;const _e=(0,F.normalizeMimeType)(re,!0);if(!_e)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof Rt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const re={name:O.name,message:O.message,stack:O.stack};return Rt.json(re,"application/vnd.code.notebook.error")}static stdout(O){return Rt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Rt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,re="application/octet-stream"){return new Rt(O,re)}static text(O,re=F.Mimes.text){const _e=Ae(Rt,s,"f",c).encode(String(O));return new Rt(_e,re)}static json(O,re="application/json"){const _e=JSON.stringify(O,void 0,"	");return Rt.text(_e,re)}}e.NotebookCellOutputItem=Rt,s=Rt,c={value:new TextEncoder};class Kt{constructor(O,re,_e){this.items=Kt.ensureUniqueMimeTypes(O,!0),typeof re=="string"?(this.id=re,this.metadata=_e):(this.id=(0,T.generateUuid)(),this.metadata=re??_e)}static isNotebookCellOutput(O){return O instanceof Kt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,C.isArray)(O.items)}static ensureUniqueMimeTypes(O,re=!1){const _e=new Set,Ge=new Set;for(let tt=0;tt<O.length;tt++){const at=O[tt],ut=(0,F.normalizeMimeType)(at.mime);if(!_e.has(ut)){_e.add(ut);continue}Ge.add(tt),re&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?O:O.filter((tt,at)=>!Ge.has(at))}}e.NotebookCellOutput=Kt;var Et;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Et=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(O,re){this.text=O,this.alignment=re}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(O,re=[]){this.uri=O,this.provides=(0,h.asArray)(re)}}e.NotebookRendererScript=Pi;let ui=class{constructor(O,re){this.label=O,this.timestamp=re}};ui=$e([k],ui),e.TimelineItem=ui;var Ti;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ai;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ai=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(O,re){this.ranges=O,this.wordPattern=re}}e.LinkedEditingRanges=Ri;class Fi{constructor(O,re){this._port=O,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Y=class{constructor(O,re,_e){this.include=O,this.exclude=re,this.profile=_e}};Y=$e([k],Y),e.TestRunRequest=Y;let ce=I=class{constructor(O){this.message=O}static diff(O,re,_e){const Ge=new I(O);return Ge.expectedOutput=re,Ge.actualOutput=_e,Ge}};ce=I=$e([k],ce),e.TestMessage=ce;let De=class{constructor(O){this.id=O}};De=$e([k],De),e.TestTag=De;let st=class{constructor(O,re){this.covered=O,this.total=re}};st=$e([k],st),e.CoveredCount=st;let yt=m=class{constructor(O,re,_e,Ge){this.uri=O,this.statementCoverage=re,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(O,re){const _e=new st(0,0),Ge=new st(0,0),tt=new st(0,0);for(const ut of re)if("branches"in ut){_e.total+=1,_e.covered+=ut.executionCount>0?1:0;for(const Ct of ut.branches)Ge.total+=1,Ge.covered+=Ct.executionCount>0?1:0}else tt.total+=1,tt.covered+=ut.executionCount>0?1:0;const at=new m(O,_e,Ge.total>0?Ge:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=re,at}};yt=m=$e([k],yt),e.FileCoverage=yt;let kt=class{constructor(O,re,_e=[]){this.executionCount=O,this.location=re,this.branches=_e}};kt=$e([k],kt),e.StatementCoverage=kt;let Oi=class{constructor(O,re){this.executionCount=O,this.location=re}};Oi=$e([k],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(O,re){this.executionCount=O,this.location=re}};Ni=$e([k],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(O,re,_e,Ge,tt,at){this.kind=O,this.name=re,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=ji}),define(be[88],Ee([0,1,42,11,9,228,118,7,14]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function t(s,c){c?T.set(s,c):T.delete(s)}e.setWordDefinitionFor=t;function y(s){return T.get(s)}e.getWordDefinitionFor=y;class n extends A.MirrorTextModel{constructor(c,p,P,D,l,u,_,i){super(p,P,D,l);this._proxy=c,this._languageId=u,this._isDirty=_,this._notebook=i,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return(0,S.equals)(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===M.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},get notebook(){return c._notebook},save(){return c._save()},getText(p){return p?c._getTextInRange(p):c.getText()},get eol(){return c._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(p){return c._lineAt(p)},offsetAt(p){return c._offsetAt(p)},positionAt(p){return c._positionAt(p)},validateRange(p){return c._validateRange(p)},validatePosition(p){return c._validatePosition(p)},getWordRangeAtPosition(p,P){return c._getWordRangeAtPosition(p,P)}}}return Object.freeze(this._document)}_acceptLanguageId(c){(0,h.ok)(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){(0,h.ok)(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const p=this._validateRange(c);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const P=this._eol,D=p.start.line,l=p.end.line,u=[];u.push(this._lines[D].substring(p.start.character));for(let _=D+1;_<l;_++)u.push(this._lines[_]);return u.push(this._lines[l].substring(0,p.end.character)),u.join(P)}_lineAt(c){let p;if(c instanceof C.Position?p=c.line:typeof c=="number"&&(p=c),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new f(p,this._lines[p],p===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(c),P=this._lines[p.index].length;return new C.Position(p.index,Math.min(p.remainder,P))}_validateRange(c){if(!(c instanceof C.Range))throw new Error("Invalid argument");const p=this._validatePosition(c.start),P=this._validatePosition(c.end);return p===c.start&&P===c.end?c:new C.Range(p.line,p.character,P.line,P.character)}_validatePosition(c){if(!(c instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:p,character:P}=c,D=!1;if(p<0)p=0,P=0,D=!0;else if(p>=this._lines.length)p=this._lines.length-1,P=this._lines[p].length,D=!0;else{const l=this._lines[p].length;P<0?(P=0,D=!0):P>l&&(P=l,D=!0)}return D?new C.Position(p,P):c}_getWordRangeAtPosition(c,p){const P=this._validatePosition(c);if(!p)p=y(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const D=(0,F.getWordAtText)(P.character+1,(0,F.ensureValidWordDefinition)(p),this._lines[P.line],0);if(D)return new C.Range(P.line,D.startColumn-1,P.line,D.endColumn-1)}}e.ExtHostDocumentData=n;class f{constructor(c,p,P){this._line=c,this._text=p,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(be[156],Ee([0,1,7,3,229,6,56,20,2,36]),function(se,e,h,M,E,A,F,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,f,s,c){this._notebook=s,this._selector=c,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(P=>{const D=this._cellUris.get(P.document.uri);D!==void 0&&(this._cellLengths.changeValue(D,this._cells[D].document.getText().length+1),this._cellLines.changeValue(D,this._cells[D].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(P=>p(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const n=[],f=[];for(const s of this._notebook.getCells())s.kind===h.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),n.push(s.document.getText().length+1),f.push(s.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(n){if(!n){let D="";for(const l of this._cells)D+=l.document.getText()+`
`;return D=D.slice(0,-1),D}if(n.isEmpty)return"";const f=this.locationAt(n.start),s=this.locationAt(n.end),c=this._cellUris.get(f.uri),p=this._cellUris.get(s.uri);if(c===void 0||p===void 0)return"";if(c===p)return this._cells[c].document.getText(new h.Range(f.range.start,s.range.end));const P=[this._cells[c].document.getText(new h.Range(f.range.start,new h.Position(this._cells[c].document.lineCount,0)))];for(let D=c+1;D<p;D++)P.push(this._cells[D].document.getText());return P.push(this._cells[p].document.getText(new h.Range(new h.Position(0,0),s.range.end))),P.join(`
`)}offsetAt(n){const f=this._cellLines.getIndexOf(n.line),s=this._cellLengths.getPrefixSum(f.index-1),c=this._cells[f.index].document.offsetAt(n.with(f.remainder));return s+c}positionAt(n){if(typeof n=="number"){const s=this._cellLengths.getIndexOf(n),c=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(c)}const f=this._cellUris.get(n.uri);if(f!==void 0){const s=this._cellLines.getPrefixSum(f-1);return new h.Position(s+n.range.start.line,n.range.start.character)}return new h.Position(0,0)}locationAt(n){h.Range.isRange(n)||(n=new h.Range(n,n));const f=this._cellLines.getIndexOf(n.start.line);let s=f;n.isEmpty||(s=this._cellLines.getIndexOf(n.end.line));const c=new h.Position(f.remainder,n.start.character),p=new h.Position(s.remainder,n.end.character),P=new h.Range(c,p),D=this._cells[f.index];return new h.Location(D.document.uri,D.document.validateRange(P))}contains(n){return this._cellUris.has(n)}validateRange(n){const f=this.validatePosition(n.start),s=this.validatePosition(n.end);return n.with(f,s)}validatePosition(n){const f=this._cellLines.getIndexOf(n.line),s=new h.Position(f.remainder,n.character),c=this._cells[f.index].document.validatePosition(s),p=this._cellLines.getPrefixSum(f.index-1);return new h.Position(p+c.line,c.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[157],Ee([0,1,7,13,3]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(C){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let S=C==="light"?h.ColorThemeKind.Light:C==="dark"?h.ColorThemeKind.Dark:h.ColorThemeKind.HighContrast;this._actual=new h.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=$e([ze(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[66],Ee([0,1,4]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(be[158],Ee([0,1,22]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(S){let T=this.buffers.indexOf(S);return T<0&&(T=this.buffers.length,this.buffers.push(S)),T}}function E(C,S){if(S.serializeBuffersForPostMessage){const T=new M,t=(f,s)=>{if(s instanceof ArrayBuffer){const c=T.add(s);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(s)){const c=A(s);if(c){const p=T.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:c,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},y=JSON.stringify(C,t),n=T.buffers.map(f=>{const s=new Uint8Array(f);return h.VSBuffer.wrap(s)});return{message:y,buffers:n}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=E;function A(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(C,S){const T=S.map(n=>{const f=new ArrayBuffer(n.byteLength);return new Uint8Array(f).set(n.buffer),f}),t=S.length?(n,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const s=f,{index:c}=s,p=T[c];if(s.view)switch(s.view.type){case 1:return new Int8Array(p,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return f}:void 0;return{message:JSON.parse(C,t),arrayBuffers:T}}e.deserializeWebviewMessage=F}),define(be[159],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var h;(function(M){function E(F){const C={items:new Map};return F.types.forEach((S,T)=>{C.items.set(S,{asString:async()=>F.items[T].asString})}),C}M.toITreeDataTransfer=E;async function A(F){const C={types:[],items:[]},S=Array.from(F.items.entries());for(const T of S)C.types.push(T[0]),C.items.push({asString:await T[1].asString()});return C}M.toTreeDataTransferDTO=A})(h=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[67],Ee([0,1,11,2]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(C,S){return C.scheme===h.Schemas.http||C.scheme===h.Schemas.https?C:(S&&S.authority&&S.isRemote&&C.scheme===h.Schemas.file&&(C=M.URI.from({scheme:h.Schemas.vscodeRemote,authority:S.authority,path:C.path})),M.URI.from({scheme:h.Schemas.https,authority:`${C.scheme}+${A(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=E;function A(C){return C.replace(/./g,S=>{const T=S.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?S:"-"+T.toString(16).padStart(4,"0")})}function F(C){return C.replace(/-([0-9a-f]{4})/g,(S,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=F}),define(be[160],Ee([0,1,3,6,67]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(C,S,T){this._proxy=C,this._editors=S,this._initData=T,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const t=S.getVisibleTextEditors();for(const y of this._insets.values())t.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,S,T,t,y){let n;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===C){n=l;break}if(!n)throw new Error("not a visible editor");const f=this,s=this._handlePool++,c=new h.Emitter,p=new h.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,E.asWebviewUri)(l,f._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(l){this._options=l,f._proxy.$setOptions(s,l)}get options(){return this._options}set html(l){this._html=l,f._proxy.$setHtml(s,l)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(l){return f._proxy.$postMessage(s,l)}},D=new class{constructor(){this.editor=C,this.line=S,this.height=T,this.webview=P,this.onDidDispose=p.event}dispose(){f._insets.has(s)&&(f._insets.delete(s),f._proxy.$disposeEditorInset(s),p.fire(),p.dispose(),c.dispose())}};return this._proxy.$createEditorInset(s,n.id,n.value.document.uri,S+1,T,t||{},y.identifier,y.extensionLocation),this._insets.set(s,{editor:C,inset:D,onDidReceiveMessage:c}),D}$onDidDispose(C){const S=this._insets.get(C);S&&S.inset.dispose()}$onDidReceiveMessage(C,S){const T=this._insets.get(C);T&&T.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(be[161],Ee([0,1,131,10,2,6,4,46,28,14,11]),function(se,e,h,M,E,A,F,C,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,h.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,h.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,h.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,h.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,h.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new C.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,h.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,h.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,h.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,h.localize)(10,null)),e.SideBySideEditorActiveContext=new C.RawContextKey("sideBySideEditorActive",!1,(0,h.localize)(11,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,h.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,h.localize)(13,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,h.localize)(14,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,h.localize)(15,null)),e.ActiveEditorGroupLockedContext=new C.RawContextKey("activeEditorGroupLocked",!1,(0,h.localize)(16,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,h.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,h.localize)(18,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,h.localize)(19,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,h.localize)(20,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,h.localize)(21,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,h.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function y(L,b,B){for(const $ of B.visibleEditorPanes)if($.group.id===b&&L.matches($.input))return $.getViewState()}e.findViewStateForEditor=y;function n(L){if(u(L))return!1;const b=L;return E.URI.isUri(b?.resource)}e.isResourceEditorInput=n;function f(L){if(u(L))return!1;const b=L;return b?.original!==void 0&&b.modified!==void 0}e.isResourceDiffEditorInput=f;function s(L){if(u(L)||f(L))return!1;const b=L;return b?.primary!==void 0&&b.secondary!==void 0}e.isResourceSideBySideEditorInput=s;function c(L){if(u(L))return!1;const b=L;return b?b.resource===void 0||b.resource.scheme===t.Schemas.untitled||b.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=c;var p;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(p=e.Verbosity||(e.Verbosity={}));var P;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(P=e.SaveReason||(e.SaveReason={}));var D;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(D=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends A.Disposable{}e.AbstractEditorInput=l;function u(L){return L instanceof l}e.isEditorInput=u;function _(L){const b=L;return E.URI.isUri(b?.preferredResource)}function i(L){const b=L;return u(b?.primary)&&u(b?.secondary)}e.isSideBySideEditorInput=i;function g(L){const b=L;return u(b?.modified)&&u(b?.original)}e.isDiffEditorInput=g;function a(L){return u(L?.editor)}e.isEditorInputWithOptions=a;function r(L){const b=L;return a(L)&&b?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function v(L){const b=L;return typeof b?.groupId=="number"&&u(b.editor)}e.isEditorIdentifier=v;var o;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var d;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(d=e.SideBySideEditor||(e.SideBySideEditor={}));class w{getOriginalUri(b,B){if(!b)return;if(B?.supportSideBySide){const{primary:x,secondary:K}=this.getSideEditors(b);if(x&&K){if(B?.supportSideBySide===d.BOTH)return{primary:this.getOriginalUri(x,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===d.ANY)return this.getOriginalUri(x,{filterByScheme:B.filterByScheme})??this.getOriginalUri(K,{filterByScheme:B.filterByScheme});b=B.supportSideBySide===d.PRIMARY?x:K}}if(f(b)||s(b))return;const $=_(b)?b.preferredResource:b.resource;return!$||!B||!B.filterByScheme?$:this.filterUri($,B.filterByScheme)}getSideEditors(b){return i(b)||s(b)?{primary:b.primary,secondary:b.secondary}:g(b)||f(b)?{primary:b.modified,secondary:b.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(b,B){if(!b)return;if(B?.supportSideBySide){const{primary:x,secondary:K}=this.getSideEditors(b);if(x&&K){if(B?.supportSideBySide===d.BOTH)return{primary:this.getCanonicalUri(x,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===d.ANY)return this.getCanonicalUri(x,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:B.filterByScheme});b=B.supportSideBySide===d.PRIMARY?x:K}}if(f(b)||s(b))return;const $=b.resource;return!$||!B||!B.filterByScheme?$:this.filterUri($,B.filterByScheme)}filterUri(b,B){if(Array.isArray(B)){if(B.some($=>b.scheme===$))return b}else if(B===b.scheme)return b}}e.EditorResourceAccessor=new w;var I;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(I=e.CloseDirection||(e.CloseDirection={}));class m{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(b){const B=this.instantiationService=b.get(F.IInstantiationService);for(const[$,x]of this.editorSerializerConstructors)this.createEditorSerializer($,x,B);this.editorSerializerConstructors.clear()}createEditorSerializer(b,B,$){const x=$.createInstance(B);this.editorSerializerInstances.set(b,x)}registerFileEditorFactory(b){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=b}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(b,B){if(this.editorSerializerConstructors.has(b)||this.editorSerializerInstances.has(b))throw new Error(`A editor serializer with type ID '${b}' was already registered.`);return this.instantiationService?this.createEditorSerializer(b,B,this.instantiationService):this.editorSerializerConstructors.set(b,B),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(b),this.editorSerializerInstances.delete(b)})}getEditorSerializer(b){return this.editorSerializerInstances.get(typeof b=="string"?b:b.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new m);async function k(L,b){if(!L||!L.length)return[];const B=await Promise.all(L.map(async $=>{const x=E.URI.revive($.fileUri);if(!x||!await b.canHandleResource(x))return;const H=typeof $.exists=="boolean"?$.exists:await b.exists(x);if(!H&&$.openOnlyIfExists)return;const W={selection:H?$.selection:void 0,pinned:!0,override:$.editorOverrideId};let ne;return H?ne={resource:x,options:W}:ne={resource:x,options:W,forceUntitled:!0},ne}));return(0,T.coalesce)(B)}e.pathsToEditors=k;var R;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(R=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[162],Ee([0,1,3,46,132,4,6,20,28,14,52,23,34,152]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",n.Codicon.window,(0,E.localize)(0,null));var s;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var c;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(c=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function p(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=p;function P(v){return`viewContainer.${v}.enabled`}e.getEnabledViewContainerContextKey=P;class D extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new h.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new h.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(o,d,w){const I=this.get(o.id);if(I)return I;const m=o;return m.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:m.openCommandActionDescriptor??{id:m.id},(0,C.getOrSet)(this.viewContainers,d,[]).push(m),w?.isDefault&&this.defaultViewContainers.push(m),this._onDidRegister.fire({viewContainer:m,viewContainerLocation:d}),m}deregisterViewContainer(o){for(const d of this.viewContainers.keys()){const w=this.viewContainers.get(d),I=w?.indexOf(o);if(I!==-1){w?.splice(I,1),w.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:o,viewContainerLocation:d});return}}}get(o){return this.all.filter(d=>d.id===o)[0]}getViewContainers(o){return[...this.viewContainers.get(o)||[]]}getViewContainerLocation(o){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(w=>w?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===o)}}S.Registry.add(s.ViewContainersRegistry,new D);var l;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function u(v,o){const d=v.group??l.More,w=o.group??l.More;return d!==w?d.localeCompare(w):(v.order??5)-(o.order??5)}class _ extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new h.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new h.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new h.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new h.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(o,d){this.registerViews2([{views:o,viewContainer:d}])}registerViews2(o){o.forEach(({views:d,viewContainer:w})=>this.addViews(d,w)),this._onViewsRegistered.fire(o)}deregisterViews(o,d){const w=this.removeViews(o,d);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:d})}moveViews(o,d){for(const w of this._views.keys())if(w!==d){const I=this.removeViews(o,w);I.length&&(this.addViews(I,d),this._onDidChangeContainer.fire({views:I,from:w,to:d}))}}getViews(o){return this._views.get(o)||[]}getView(o){for(const d of this._viewContainers){const w=(this._views.get(d)||[]).filter(I=>I.id===o)[0];if(w)return w}return null}getViewContainer(o){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(I=>I.id===o)[0])return d;return null}registerViewWelcomeContent(o,d){return this._viewWelcomeContents.add(o,d),this._onDidChangeViewWelcomeContent.fire(o),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(o,d),this._onDidChangeViewWelcomeContent.fire(o)})}registerViewWelcomeContent2(o,d){const w=new Map;for(const[I,m]of d)this._viewWelcomeContents.add(o,m),w.set(I,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(o,m),this._onDidChangeViewWelcomeContent.fire(o)}));return this._onDidChangeViewWelcomeContent.fire(o),w}getViewWelcomeContent(o){const d=[];return this._viewWelcomeContents.forEach(o,w=>d.push(w)),d.sort(u)}addViews(o,d){let w=this._views.get(d);w||(w=[],this._views.set(d,w),this._viewContainers.push(d));for(const I of o){if(this.getView(I.id)!==null)throw new Error((0,E.localize)(1,null,I.id));w.push(I)}}removeViews(o,d){const w=this._views.get(d);if(!w)return[];const I=[],m=[];for(const k of w)o.includes(k)?I.push(k):m.push(k);return I.length&&(m.length?this._views.set(d,m):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),I}}S.Registry.add(s.ViewsRegistry,new _),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(v){return`view.${v}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var g;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(g=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(o,d){this.resolved=!1,this._hasResolve=!1,(0,y.mixin)(this,o),this._hasResolve=!!d,this.resolve=async w=>{if(d&&!this.resolved){const I=await d(w);I&&(this.tooltip=this.tooltip??I.tooltip,this.command=this.command??I.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[163],Ee([0,1,3,12,133]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,S,T,t){const y={command:C};if(S&&Object.keys(S).length>0&&(y.arguments=S),this.internalSend("request",y),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const f=this.pendingRequests.get(y.seq);if(f){this.pendingRequests.delete(y.seq);const s={type:"response",seq:0,request_seq:y.seq,success:!1,command:C,message:(0,E.localize)(0,null,t,C)};f(s)}},t)}return T&&this.pendingRequests.set(y.seq,T),y.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,S){return C.type!=="event"||S.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,M.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const S=C,T=this.pendingRequests.get(S.request_seq);T&&(this.pendingRequests.delete(S.request_seq),T(S));break}}}internalSend(C,S){S.type=C,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((S,T)=>C.set(T,S)),await(0,M.timeout)(500),C.forEach((S,T)=>{S({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[164],Ee([0,1,9,2,17,23,11]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function S(a,r,v){return a.replace(C,function(o,d){return r&&d.length>0&&d[0]!=="_"?o:v&&v.hasOwnProperty(d)?v[d]:o})}e.formatPII=S;function T(a){const r={};for(const v of Object.keys(a))v.startsWith("!")||(r[v]=a[v]);return r}e.filterExceptionsFromTelemetry=T;function t(a){return a.configuration.request==="attach"&&!y(a)&&(!a.parentSession||t(a.parentSession))}e.isSessionAttach=t;function y(a){let r=a.configuration.type;if(!!r)return r==="vslsShare"&&(r=a.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(r,"extensionhost")||(0,h.equalsIgnoreCase)(r,"pwa-extensionhost")?a:a.parentSession?y(a.parentSession):void 0}e.getExtensionHostDebugSession=y;function n(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=n;function f(a,r,v){let o,d=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,I=null;for(;I=w.exec(a);){let m=I.index+1,k=m+I[0].length;if(m<=r&&k>=v){o=I[0],d=m;break}}if(o){let m=/\w+/g,k=null;for(;(k=m.exec(o))&&!(k.index+1+d+k[0].length>=v););k&&(o=o.substring(0,m.lastIndex))}return o?{start:d,end:d+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(a){return!!(a&&a.match(s))}e.isUri=c;function p(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(c(a.path))return M.URI.parse(a.path);if((0,E.isAbsolute)(a.path))return M.URI.file(a.path)}return a.path}function P(a){if(typeof a.path=="object"){const r=M.URI.revive(a.path);if(r)return r.scheme===F.Schemas.file?r.fsPath:r.toString()}return a.path}function D(a,r){const v=r?p:P,o=(0,A.deepClone)(a);return u(o,(d,w)=>{d&&w&&(w.path=v(w))}),o}e.convertToDAPaths=D;function l(a,r){const v=r?p:P,o=(0,A.deepClone)(a);return u(o,(d,w)=>{!d&&w&&(w.path=v(w))}),o}e.convertToVSCPaths=l;function u(a,r){switch(a.type){case"event":const v=a;switch(v.event){case"output":r(!1,v.body.source);break;case"loadedSource":r(!1,v.body.source);break;case"breakpoint":r(!1,v.body.breakpoint.source);break;default:break}break;case"request":const o=a;switch(o.command){case"setBreakpoints":r(!0,o.arguments.source);break;case"breakpointLocations":r(!0,o.arguments.source);break;case"source":r(!0,o.arguments.source);break;case"gotoTargets":r(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(w=>r(!1,w));break;default:break}break;case"response":const d=a;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(w=>r(!1,w.source));break;case"loadedSources":d.body.sources.forEach(w=>r(!1,w));break;case"scopes":d.body.scopes.forEach(w=>r(!1,w.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(w=>r(!1,w.source));break;case"setBreakpoints":d.body.breakpoints.forEach(w=>r(!1,w.source));break;default:break}break}}function _(a){return a.filter(r=>!r.presentation?.hidden).sort((r,v)=>r.presentation?v.presentation?r.presentation.group?v.presentation.group?r.presentation.group!==v.presentation.group?r.presentation.group.localeCompare(v.presentation.group):i(r.presentation.order,v.presentation.order):-1:v.presentation.group?1:i(r.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=_;function i(a,r){return typeof a!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:a-r}async function g(a,r){const v=a.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorMode});if(v!=="none"&&(await r.saveAll(),v==="allEditorsInActiveGroup")){const o=r.activeEditorPane;o&&await r.save({editor:o.input,groupId:o.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=g}),define(be[89],Ee([0,1,27,79,11,17,25,46]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(m){m[m.Markup=1]="Markup",m[m.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(m){m[m.Running=1]="Running",m[m.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(m){m[m.Pending=2]="Pending",m[m.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(m){m[m.WithHardKernelDependency=0]="WithHardKernelDependency",m[m.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",m[m.Pure=2]="Pure",m[m.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(m){m.Always="always",m.Never="never",m.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(m){m[m.ModelChange=1]="ModelChange",m[m.Move=2]="Move",m[m.ChangeLanguage=5]="ChangeLanguage",m[m.Initialize=6]="Initialize",m[m.ChangeCellMetadata=7]="ChangeCellMetadata",m[m.Output=8]="Output",m[m.OutputItem=9]="OutputItem",m[m.ChangeCellContent=10]="ChangeCellContent",m[m.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",m[m.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",m[m.ChangeCellMime=13]="ChangeCellMime",m[m.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(m){m[m.Handle=0]="Handle",m[m.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var c;(function(m){m[m.Replace=1]="Replace",m[m.Output=2]="Output",m[m.Metadata=3]="Metadata",m[m.CellLanguage=4]="CellLanguage",m[m.DocumentMetadata=5]="DocumentMetadata",m[m.Move=6]="Move",m[m.OutputItems=7]="OutputItems",m[m.PartialMetadata=8]="PartialMetadata",m[m.PartialInternalMetadata=9]="PartialInternalMetadata"})(c=e.CellEditType||(e.CellEditType={}));var p;(function(m){m.scheme=E.Schemas.vscodeNotebookCell;const k=/^ch(\d{7,})/;function R(x,K){return x.with({scheme:m.scheme,fragment:`ch${K.toString().padStart(7,"0")}${x.scheme!==E.Schemas.file?x.scheme:""}`})}m.generate=R;function L(x){if(x.scheme!==m.scheme)return;const K=k.exec(x.fragment);return K?{handle:Number(K[1]),notebook:x.with({scheme:x.fragment.substr(K[0].length)||E.Schemas.file,fragment:null})}:void 0}m.parse=L;function b(x){if(x.scheme!==E.Schemas.vscodeNotebookCellMetadata)return;const K=k.exec(x.fragment);return K?{handle:Number(K[1]),notebook:x.with({scheme:x.fragment.substr(K[0].length)||E.Schemas.file,fragment:null})}:void 0}m.parseCellMetadataUri=b;function B(x,K,H){return x.with({scheme:H,fragment:`ch${K.toString().padStart(7,"0")}${x.scheme!==E.Schemas.file?x.scheme:""}`})}m.generateCellUri=B;function $(x,K){if(x.scheme!==K)return;const H=k.exec(x.fragment);return H?{handle:Number(H[1]),notebook:x.with({scheme:x.fragment.substr(H[0].length)||E.Schemas.file,fragment:null})}:void 0}m.parseCellUri=$})(p=e.CellUri||(e.CellUri={}));const P=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function D(m){return P.get(m)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=D;function l(m){return P.get(m)?.supportedByCore??!1}e.mimeTypeSupportedByCore=l;function u(m){return P.get(m)?.mergeable??!1}e.mimeTypeIsMergeable=u;function _(m,k){return F.isWindows&&(m=m.replace(/\//g,"\\"),k=k.replace(/\//g,"\\")),h.match(m,k)}function i(m,k,R){let L=0;for(let b=0;b<k.length;b++){if(_(k[b],m))return L;L++}for(let b=0;b<R.length;b++){if(_(R[b],m))return L;L++}return L}function g(m,k,R){return m.sort((L,b)=>i(L,k,R)-i(b,k,R))}e.sortMimeTypes=g;function a(m,k,R,L=(b,B)=>b===B){const b=[];function B(K,H,W){if(H===0&&W.length===0)return;const ne=b[b.length-1];ne&&ne.start+ne.deleteCount===K?(ne.deleteCount+=H,ne.toInsert.push(...W)):b.push({start:K,deleteCount:H,toInsert:W})}let $=0,x=0;for(;;){if($===m.length){B($,0,k.slice(x));break}if(x===k.length){B($,m.length-$,[]);break}const K=m[$],H=k[x];if(L(K,H)){$+=1,x+=1;continue}R(H)?(B($,1,[]),$+=1):(B($,0,[H]),x+=1)}return b}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(m){m.default="default",m.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function v(m){const k=m;return!!((typeof k.include=="string"||h.isRelativePattern(k.include))&&(typeof k.exclude=="string"||h.isRelativePattern(k.exclude)))}e.isDocumentExcludePattern=v;function o(m,k,R){if(Array.isArray(m.viewType)&&m.viewType.indexOf(k)>=0||m.viewType===k)return!0;if(m.filenamePattern){let L=v(m.filenamePattern)?m.filenamePattern.include:m.filenamePattern,b=v(m.filenamePattern)?m.filenamePattern.exclude:void 0;if(h.match(L,(0,A.basename)(R.fsPath).toLowerCase()))return!(b&&h.match(b,(0,A.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class d{constructor(k){this.textModel=k}getElements(){const k=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)k[R]=this.textModel.cells[R].getHashValue();return k}}e.CellSequence=d,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class I{static create(k){return`${I._prefix}${k}`}static parse(k){if(k.startsWith(I._prefix))return k.substr(I._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=I,I._prefix="notebook/"}),define(be[165],Ee([0,1,4]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,h.createDecorator)("INotebookExecutionService")}),define(be[166],Ee([0,1,135,4,46]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,h.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,h.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,h.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[167],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=h;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var h;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(h=e.TestResultState||(e.TestResultState={}));var M;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var A;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&(y.item=y.item?Object.assign(y.item,n.item):n.item)};e.applyTestItemUpdate=F;var C;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var S;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(n){}update(n){}remove(n,f){}complete(){}}e.IncrementalChangeCollector=T;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const f=this.createChangeCollector();for(const s of n)switch(s[0]){case 0:{const c=s[1];if(c.parent){if(this.items.has(c.parent)){const p=this.items.get(c.parent);p.children.add(c.item.extId);const P=this.createItem(c,p);this.items.set(c.item.extId,P),f.add(P)}}else{const p=this.createItem(c);this.roots.add(p),this.items.set(c.item.extId,p),f.add(p)}c.expand===2&&this.busyControllerCount++;break}case 1:{const c=s[1],p=this.items.get(c.extId);if(!p)break;c.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,c),f.update(p);break}case 2:{const c=this.items.get(s[1]);if(!c)break;c.parent?this.items.get(c.parent).children.delete(c.item.extId):this.roots.delete(c);const p=[[s[1]]];for(;p.length;)for(const P of p.pop()){const D=this.items.get(P);D&&(p.push(D.children),this.items.delete(P),f.remove(D,D!==c),D.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}f.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=t}),define(be[68],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(A){A.Delimiter="\0"})(h=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(F,C=F.length){if(this.path=F,this.viewEnd=C,F.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,C,S=F.parent){if(F.id===C)return new E([C]);let T=[F.id];for(let t=S;t&&t.id!==C;t=t.parent)T.push(t.id);return T.push(C),new E(T.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new E(F.split("\0"))}static join(F,C){return new E([...F.path,C])}static joinToString(F,C){return F.toString()+"\0"+C}static compare(F,C){return F===C?0:C.startsWith(F+"\0")?2:F.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new E(this.path,F)}compare(F){if(typeof F=="string")return E.compare(this.toString(),F);for(let C=0;C<F.viewEnd&&C<this.viewEnd;C++)if(F.path[C]!==this.path[C])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=E}),define(be[168],Ee([0,1,17,91,10,23,25,78,136]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(y,n,f){this._contributedVariables=new Map,this._context=y,this._labelService=n,f&&(this._envVariablesPromise=f.then(s=>this.prepareEnv(s)))}prepareEnv(y){if(F.isWindows){const n=Object.create(null);return Object.keys(y).forEach(f=>{n[f.toLowerCase()]=y[f]}),n}return y}resolveWithEnvironment(y,n,f){return this.recursiveResolve(this.prepareEnv(y),n?n.uri:void 0,f)}async resolveAsync(y,n){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,n)}async resolveAnyBase(y,n,f,s){const c=A.deepClone(n);return F.isWindows&&c.windows?Object.keys(c.windows).forEach(p=>c[p]=c.windows[p]):F.isMacintosh&&c.osx?Object.keys(c.osx).forEach(p=>c[p]=c.osx[p]):F.isLinux&&c.linux&&Object.keys(c.linux).forEach(p=>c[p]=c.linux[p]),delete c.windows,delete c.osx,delete c.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,c,f,s)}async resolveAnyAsync(y,n,f){return this.resolveAnyBase(y,n,f)}async resolveAnyMap(y,n,f){const s=new Map;return{newConfig:await this.resolveAnyBase(y,n,f,s),resolvedVariables:s}}resolveWithInteractionReplace(y,n,f,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,n,f,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,n){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,n)}recursiveResolve(y,n,f,s,c){if(E.isString(f))return this.resolveString(y,n,f,s,c);if(E.isArray(f))return f.map(p=>this.recursiveResolve(y,n,p,s,c));if(E.isObject(f)){let p=Object.create(null);return Object.keys(f).forEach(P=>{const D=this.resolveString(y,n,P,s,c);p[D]=this.recursiveResolve(y,n,f[P],s,c)}),p}return f}resolveString(y,n,f,s,c){return f.replace(T.VARIABLE_REGEXP,(P,D)=>{if(D.includes(T.VARIABLE_LHS))return P;let l=this.evaluateSingleVariable(y,P,D,n,s);return c&&c.set(D,l),l!==P&&E.isString(l)&&l.match(T.VARIABLE_REGEXP)&&(l=this.resolveString(y,n,l,s,c)),l})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,n,f,s,c){let p;const P=f.split(":");P.length>1&&(f=P[0],p=P[1]);const D=()=>{const _=this._context.getFilePath();if(_)return _;throw new Error((0,S.localize)(0,null,n))},l=()=>{const _=D();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,S.localize)(1,null,n,h.basename(_)))},u=()=>{if(p){const _=this._context.getFolderUri(p);if(_)return _;throw new Error((0,S.localize)(2,null,n,p))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,n)):new Error((0,S.localize)(4,null,n))};switch(f){case"env":if(p){if(y){const _=y[F.isWindows?p.toLowerCase():p];if(E.isString(_))return _}return""}throw new Error((0,S.localize)(5,null,n));case"config":if(p){const _=this._context.getConfigurationValue(s,p);if(E.isUndefinedOrNull(_))throw new Error((0,S.localize)(6,null,n,p));if(E.isObject(_))throw new Error((0,S.localize)(7,null,n,p));return _}throw new Error((0,S.localize)(8,null,n));case"command":return this.resolveFromMap(n,p,c,"command");case"input":return this.resolveFromMap(n,p,c,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return s||p?(0,C.normalizeDriveLetter)(this.fsPath(u())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(u()));case"lineNumber":const _=this._context.getLineNumber();if(_)return _;throw new Error((0,S.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,S.localize)(10,null,n));case"file":return D();case"fileWorkspaceFolder":return l();case"relativeFile":return s||p?h.relative(this.fsPath(u()),D()):D();case"relativeFileDirname":const g=h.dirname(D());if(s||p){const o=h.relative(this.fsPath(u()),g);return o.length===0?".":o}return g;case"fileDirname":return h.dirname(D());case"fileExtname":return h.extname(D());case"fileBasename":return h.basename(D());case"fileBasenameNoExtension":const a=h.basename(D());return a.slice(0,a.length-h.extname(a).length);case"fileDirnameBasename":return h.basename(h.dirname(D()));case"execPath":const r=this._context.getExecPath();return r||n;case"execInstallFolder":const v=this._context.getAppRoot();return v||n;case"pathSeparator":return h.sep;default:try{const o=p?`${f}:${p}`:f;return this.resolveFromMap(n,o,c,void 0)}catch(o){return n}}}}resolveFromMap(y,n,f,s){if(n&&f){const c=s===void 0?f[n]:f[s+":"+n];if(typeof c=="string")return c;throw new Error((0,S.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,161]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var E;(function(c){c[c.UP=0]="UP",c[c.DOWN=1]="DOWN",c[c.LEFT=2]="LEFT",c[c.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var A;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(c){c[c.FIRST=0]="FIRST",c[c.LAST=1]="LAST",c[c.NEXT=2]="NEXT",c[c.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var C;(function(c){c[c.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",c[c.EVEN=1]="EVEN",c[c.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(c){c[c.COPY_EDITORS=0]="COPY_EDITORS",c[c.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function T(c){const p=c;return(0,M.isEditorInput)(p?.editor)&&(0,M.isEditorInput)(p?.replacement)}e.isEditorReplacement=T;var t;(function(c){c[c.CREATION_TIME=0]="CREATION_TIME",c[c.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",c[c.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(c){c[c.GROUP_ACTIVE=0]="GROUP_ACTIVE",c[c.GROUP_INDEX=1]="GROUP_INDEX",c[c.GROUP_LOCKED=2]="GROUP_LOCKED",c[c.EDITOR_OPEN=3]="EDITOR_OPEN",c[c.EDITOR_CLOSE=4]="EDITOR_CLOSE",c[c.EDITOR_MOVE=5]="EDITOR_MOVE",c[c.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",c[c.EDITOR_LABEL=7]="EDITOR_LABEL",c[c.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",c[c.EDITOR_PIN=9]="EDITOR_PIN",c[c.EDITOR_STICKY=10]="EDITOR_STICKY",c[c.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(y=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(c){c[c.NEW_EDITOR=1]="NEW_EDITOR",c[c.MOVE_EDITOR=2]="MOVE_EDITOR",c[c.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function f(c){const p=c;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=f;function s(c){return c.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=s}),define(be[169],Ee([0,1,4,92]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(A){const F=A;return typeof A=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=E}),define(be[8],Ee([0,1,14,22,77,230,55,23,10,2,44,59,137,83,49,89,68,169,7]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(de){function ge(z){const{selectionStartLineNumber:we,selectionStartColumn:ke,positionLineNumber:Je,positionColumn:Ue}=z,ct=new D.Position(we-1,ke-1),pt=new D.Position(Je-1,Ue-1);return new D.Selection(ct,pt)}de.to=ge;function X(z){const{anchor:we,active:ke}=z;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:ke.line+1,positionColumn:ke.character+1}}de.from=X})(l=e.Selection||(e.Selection={}));var u;(function(de){function ge(z){if(!z)return;const{start:we,end:ke}=z;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:ke.line+1,endColumn:ke.character+1}}de.from=ge;function X(z){if(!z)return;const{startLineNumber:we,startColumn:ke,endLineNumber:Je,endColumn:Ue}=z;return new D.Range(we-1,ke-1,Je-1,Ue-1)}de.to=X})(u=e.Range||(e.Range={}));var _;(function(de){function ge(X){switch(X){case 1:return D.StandardTokenType.Comment;case 0:return D.StandardTokenType.Other;case 4:return D.StandardTokenType.RegEx;case 2:return D.StandardTokenType.String}}de.to=ge})(_=e.TokenType||(e.TokenType={}));var i;(function(de){function ge(z){return new D.Position(z.lineNumber-1,z.column-1)}de.to=ge;function X(z){return{lineNumber:z.line+1,column:z.character+1}}de.from=X})(i=e.Position||(e.Position={}));var g;(function(de){function ge(we,ke){return(0,h.coalesce)((0,h.asArray)(we).map(Je=>X(Je,ke)))}de.from=ge;function X(we,ke){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:z(we.scheme,ke),pattern:typeof we.pattern=="undefined"?void 0:rt.from(we.pattern),exclusive:we.exclusive}}function z(we,ke){return ke&&typeof we=="string"?ke.transformOutgoingScheme(we):we}})(g=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(de){function ge(z){switch(z){case D.DiagnosticTag.Unnecessary:return 1;case D.DiagnosticTag.Deprecated:return 2}}de.from=ge;function X(z){switch(z){case 1:return D.DiagnosticTag.Unnecessary;case 2:return D.DiagnosticTag.Deprecated;default:return}}de.to=X})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(de){function ge(z){let we;return z.code&&((0,S.isString)(z.code)||(0,S.isNumber)(z.code)?we=String(z.code):we={value:String(z.code.value),target:z.code.target}),{...u.from(z.range),message:z.message,source:z.source,code:we,severity:o.from(z.severity),relatedInformation:z.relatedInformation&&z.relatedInformation.map(v.from),tags:Array.isArray(z.tags)?(0,h.coalesce)(z.tags.map(a.from)):void 0}}de.from=ge;function X(z){const we=new D.Diagnostic(u.to(z),z.message,o.to(z.severity));return we.source=z.source,we.code=(0,S.isString)(z.code)?z.code:z.code?.value,we.relatedInformation=z.relatedInformation&&z.relatedInformation.map(v.to),we.tags=z.tags&&(0,h.coalesce)(z.tags.map(a.to)),we}de.to=X})(r=e.Diagnostic||(e.Diagnostic={}));var v;(function(de){function ge(z){return{...u.from(z.location.range),message:z.message,resource:z.location.uri}}de.from=ge;function X(z){return new D.DiagnosticRelatedInformation(new D.Location(z.resource,u.to(z)),z.message)}de.to=X})(v=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(de){function ge(z){switch(z){case D.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case D.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case D.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case D.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}de.from=ge;function X(z){switch(z){case f.MarkerSeverity.Info:return D.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return D.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return D.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return D.DiagnosticSeverity.Hint;default:return D.DiagnosticSeverity.Error}}de.to=X})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var d;(function(de){function ge(z){return typeof z=="number"&&z>=D.ViewColumn.One?z-1:z===D.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}de.from=ge;function X(z){if(typeof z=="number"&&z>=0)return z+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=X})(d=e.ViewColumn||(e.ViewColumn={}));function w(de){return typeof de.range!="undefined"}function I(de){return de.length===0?!0:!!w(de[0])}e.isDecorationOptionsArr=I;var m;(function(de){function ge(Ue){return Ue.map(de.from)}de.fromMany=ge;function X(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function z(Ue){let ct;if(X(Ue)){const{language:ht,value:_t}=Ue;ct={value:"```"+ht+`
`+_t+"\n```\n"}}else D.MarkdownString.isMarkdownString(Ue)?ct={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml}:typeof Ue=="string"?ct={value:Ue}:ct={value:""};const pt=Object.create(null);ct.uris=pt;const lt=ht=>{try{let _t=T.URI.parse(ht,!0);_t=_t.with({query:we(_t.query,pt)}),pt[ht]=_t}catch(_t){}return""},gt=new A.Renderer;return gt.link=lt,gt.image=ht=>lt(E.parseHrefAndDimensions(ht).href),A(ct.value,{renderer:gt}),ct}de.from=z;function we(Ue,ct){if(!Ue)return Ue;let pt;try{pt=(0,F.parse)(Ue)}catch(gt){}if(!pt)return Ue;let lt=!1;return pt=(0,C.cloneAndChange)(pt,gt=>{if(T.URI.isUri(gt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ht]=gt,lt=!0,ht}else return}),lt?JSON.stringify(pt):Ue}function ke(Ue){const ct=new D.MarkdownString(Ue.value,Ue.supportThemeIcons);return ct.isTrusted=Ue.isTrusted,ct.supportHtml=Ue.supportHtml,ct}de.to=ke;function Je(Ue){if(!!Ue)return typeof Ue=="string"?Ue:de.from(Ue)}de.fromStrict=Je})(m=e.MarkdownString||(e.MarkdownString={}));function k(de){return I(de)?de.map(ge=>({range:u.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?m.fromMany(ge.hoverMessage):ge.hoverMessage?m.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):de.map(ge=>({range:u.from(ge)}))}e.fromRangeOrRangeWithMessage=k;function R(de){return typeof de=="undefined"?de:typeof de=="string"?T.URI.file(de):de}e.pathOrURIToURI=R;var L;(function(de){function ge(X){return typeof X=="undefined"?X:{contentText:X.contentText,contentIconPath:X.contentIconPath?R(X.contentIconPath):void 0,border:X.border,borderColor:X.borderColor,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,color:X.color,backgroundColor:X.backgroundColor,margin:X.margin,width:X.width,height:X.height}}de.from=ge})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var b;(function(de){function ge(X){return typeof X=="undefined"?X:{backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?R(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?L.from(X.before):void 0,after:X.after?L.from(X.after):void 0}}de.from=ge})(b=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(de){function ge(X){if(typeof X=="undefined")return X;switch(X){case D.DecorationRangeBehavior.OpenOpen:return 0;case D.DecorationRangeBehavior.ClosedClosed:return 1;case D.DecorationRangeBehavior.OpenClosed:return 2;case D.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=ge})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(de){function ge(X){return{isWholeLine:X.isWholeLine,rangeBehavior:X.rangeBehavior?B.from(X.rangeBehavior):void 0,overviewRulerLane:X.overviewRulerLane,light:X.light?b.from(X.light):void 0,dark:X.dark?b.from(X.dark):void 0,backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?R(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?L.from(X.before):void 0,after:X.after?L.from(X.after):void 0}}de.from=ge})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(de){function ge(z){return{text:z.newText,eol:z.newEol&&q.from(z.newEol),range:u.from(z.range)}}de.from=ge;function X(z){const we=new D.TextEdit(u.to(z.range),z.text);return we.newEol=typeof z.eol=="undefined"?void 0:q.to(z.eol),we}de.to=X})(x=e.TextEdit||(e.TextEdit={}));var K;(function(de){function ge(z,we,ke){const Je={edits:[]};if(z instanceof D.WorkspaceEdit)for(let Ue of z._allEntries())if(Ue._type===1)Je.edits.push({_type:1,oldUri:Ue.from,newUri:Ue.to,options:Ue.options,metadata:Ue.metadata});else if(Ue._type===2){const ct=we?.getDocument(Ue.uri);Je.edits.push({_type:2,resource:Ue.uri,edit:x.from(Ue.edit),modelVersionId:ct?.version,metadata:Ue.metadata})}else Ue._type===3?Je.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:ke?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version}):Ue._type===5&&Je.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:ke?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(Xe.from)}});return Je}de.from=ge;function X(z){const we=new D.WorkspaceEdit;for(const ke of z.edits)ke.edit?we.replace(T.URI.revive(ke.resource),u.to(ke.edit.range),ke.edit.text):we.renameFile(T.URI.revive(ke.oldUri),T.URI.revive(ke.newUri),ke.options);return we}de.to=X})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(de){const ge=Object.create(null);ge[D.SymbolKind.File]=0,ge[D.SymbolKind.Module]=1,ge[D.SymbolKind.Namespace]=2,ge[D.SymbolKind.Package]=3,ge[D.SymbolKind.Class]=4,ge[D.SymbolKind.Method]=5,ge[D.SymbolKind.Property]=6,ge[D.SymbolKind.Field]=7,ge[D.SymbolKind.Constructor]=8,ge[D.SymbolKind.Enum]=9,ge[D.SymbolKind.Interface]=10,ge[D.SymbolKind.Function]=11,ge[D.SymbolKind.Variable]=12,ge[D.SymbolKind.Constant]=13,ge[D.SymbolKind.String]=14,ge[D.SymbolKind.Number]=15,ge[D.SymbolKind.Boolean]=16,ge[D.SymbolKind.Array]=17,ge[D.SymbolKind.Object]=18,ge[D.SymbolKind.Key]=19,ge[D.SymbolKind.Null]=20,ge[D.SymbolKind.EnumMember]=21,ge[D.SymbolKind.Struct]=22,ge[D.SymbolKind.Event]=23,ge[D.SymbolKind.Operator]=24,ge[D.SymbolKind.TypeParameter]=25;function X(we){return typeof ge[we]=="number"?ge[we]:6}de.from=X;function z(we){for(const ke in ge)if(ge[ke]===we)return Number(ke);return D.SymbolKind.Property}de.to=z})(H=e.SymbolKind||(e.SymbolKind={}));var W;(function(de){function ge(z){switch(z){case D.SymbolTag.Deprecated:return 1}}de.from=ge;function X(z){switch(z){case 1:return D.SymbolTag.Deprecated}}de.to=X})(W=e.SymbolTag||(e.SymbolTag={}));var ne;(function(de){function ge(z){return{name:z.name,kind:H.from(z.kind),tags:z.tags&&z.tags.map(W.from),containerName:z.containerName,location:ee.from(z.location)}}de.from=ge;function X(z){const we=new D.SymbolInformation(z.name,H.to(z.kind),z.containerName,ee.to(z.location));return we.tags=z.tags&&z.tags.map(W.to),we}de.to=X})(ne=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(de){function ge(z){const we={name:z.name||"!!MISSING: name!!",detail:z.detail,range:u.from(z.range),selectionRange:u.from(z.selectionRange),kind:H.from(z.kind),tags:z.tags?.map(W.from)??[]};return z.children&&(we.children=z.children.map(ge)),we}de.from=ge;function X(z){const we=new D.DocumentSymbol(z.name,z.detail,H.to(z.kind),u.to(z.range),u.to(z.selectionRange));return(0,h.isNonEmptyArray)(z.tags)&&(we.tags=z.tags.map(W.to)),z.children&&(we.children=z.children.map(X)),we}de.to=X})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var J;(function(de){function ge(z){const we=new D.CallHierarchyItem(H.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),u.to(z.range),u.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=ge;function X(z,we,ke){if(we=we??z._sessionId,ke=ke??z._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,name:z.name,detail:z.detail,kind:H.from(z.kind),uri:z.uri,range:u.from(z.range),selectionRange:u.from(z.selectionRange),tags:z.tags?.map(W.from)}}de.from=X})(J=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(de){function ge(X){return new D.CallHierarchyIncomingCall(J.to(X.from),X.fromRanges.map(z=>u.to(z)))}de.to=ge})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var le;(function(de){function ge(X){return new D.CallHierarchyOutgoingCall(J.to(X.to),X.fromRanges.map(z=>u.to(z)))}de.to=ge})(le=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ee;(function(de){function ge(z){return{range:z.range&&u.from(z.range),uri:z.uri}}de.from=ge;function X(z){return new D.Location(T.URI.revive(z.uri),u.to(z.range))}de.to=X})(ee=e.location||(e.location={}));var ve;(function(de){function ge(z){const we=z,ke=z;return{originSelectionRange:we.originSelectionRange?u.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:ke.uri,range:u.from(we.targetRange?we.targetRange:ke.range),targetSelectionRange:we.targetSelectionRange?u.from(we.targetSelectionRange):void 0}}de.from=ge;function X(z){return{targetUri:T.URI.revive(z.uri),targetRange:u.to(z.range),targetSelectionRange:z.targetSelectionRange?u.to(z.targetSelectionRange):void 0,originSelectionRange:z.originSelectionRange?u.to(z.originSelectionRange):void 0}}de.to=X})(ve=e.DefinitionLink||(e.DefinitionLink={}));var Re;(function(de){function ge(z){return{range:u.from(z.range),contents:m.fromMany(z.contents)}}de.from=ge;function X(z){return new D.Hover(z.contents.map(m.to),u.to(z.range))}de.to=X})(Re=e.Hover||(e.Hover={}));var Fe;(function(de){function ge(z){return{range:u.from(z.range),expression:z.expression}}de.from=ge;function X(z){return new D.EvaluatableExpression(u.to(z.range),z.expression)}de.to=X})(Fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Oe;(function(de){function ge(z){if(z instanceof D.InlineValueText)return{type:"text",range:u.from(z.range),text:z.text};if(z instanceof D.InlineValueVariableLookup)return{type:"variable",range:u.from(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};if(z instanceof D.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(z.range),expression:z.expression};throw new Error("Unknown 'InlineValue' type")}de.from=ge;function X(z){switch(z.type){case"text":return{range:u.to(z.range),text:z.text};case"variable":return{range:u.to(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};case"expression":return{range:u.to(z.range),expression:z.expression}}}de.to=X})(Oe=e.InlineValue||(e.InlineValue={}));var Ke;(function(de){function ge(z){return{frameId:z.frameId,stoppedLocation:u.from(z.stoppedLocation)}}de.from=ge;function X(z){return new D.InlineValueContext(z.frameId,u.to(z.stoppedLocation))}de.to=X})(Ke=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(de){function ge(z){return{range:u.from(z.range),kind:z.kind}}de.from=ge;function X(z){return new D.DocumentHighlight(u.to(z.range),z.kind)}de.to=X})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var Ve;(function(de){function ge(X){switch(X){case 1:return D.CompletionTriggerKind.TriggerCharacter;case 2:return D.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return D.CompletionTriggerKind.Invoke}}de.to=ge})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var U;(function(de){function ge(X){return{triggerKind:Ve.to(X.triggerKind),triggerCharacter:X.triggerCharacter}}de.to=ge})(U=e.CompletionContext||(e.CompletionContext={}));var Q;(function(de){function ge(z){switch(z){case D.CompletionItemTag.Deprecated:return 1}}de.from=ge;function X(z){switch(z){case 1:return D.CompletionItemTag.Deprecated}}de.to=X})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));var te;(function(de){const ge=new Map([[D.CompletionItemKind.Method,0],[D.CompletionItemKind.Function,1],[D.CompletionItemKind.Constructor,2],[D.CompletionItemKind.Field,3],[D.CompletionItemKind.Variable,4],[D.CompletionItemKind.Class,5],[D.CompletionItemKind.Interface,7],[D.CompletionItemKind.Struct,6],[D.CompletionItemKind.Module,8],[D.CompletionItemKind.Property,9],[D.CompletionItemKind.Unit,12],[D.CompletionItemKind.Value,13],[D.CompletionItemKind.Constant,14],[D.CompletionItemKind.Enum,15],[D.CompletionItemKind.EnumMember,16],[D.CompletionItemKind.Keyword,17],[D.CompletionItemKind.Snippet,27],[D.CompletionItemKind.Text,18],[D.CompletionItemKind.Color,19],[D.CompletionItemKind.File,20],[D.CompletionItemKind.Reference,21],[D.CompletionItemKind.Folder,23],[D.CompletionItemKind.Event,10],[D.CompletionItemKind.Operator,11],[D.CompletionItemKind.TypeParameter,24],[D.CompletionItemKind.Issue,26],[D.CompletionItemKind.User,25]]);function X(ke){return ge.get(ke)??9}de.from=X;const z=new Map([[0,D.CompletionItemKind.Method],[1,D.CompletionItemKind.Function],[2,D.CompletionItemKind.Constructor],[3,D.CompletionItemKind.Field],[4,D.CompletionItemKind.Variable],[5,D.CompletionItemKind.Class],[7,D.CompletionItemKind.Interface],[6,D.CompletionItemKind.Struct],[8,D.CompletionItemKind.Module],[9,D.CompletionItemKind.Property],[12,D.CompletionItemKind.Unit],[13,D.CompletionItemKind.Value],[14,D.CompletionItemKind.Constant],[15,D.CompletionItemKind.Enum],[16,D.CompletionItemKind.EnumMember],[17,D.CompletionItemKind.Keyword],[27,D.CompletionItemKind.Snippet],[18,D.CompletionItemKind.Text],[19,D.CompletionItemKind.Color],[20,D.CompletionItemKind.File],[21,D.CompletionItemKind.Reference],[23,D.CompletionItemKind.Folder],[10,D.CompletionItemKind.Event],[11,D.CompletionItemKind.Operator],[24,D.CompletionItemKind.TypeParameter],[25,D.CompletionItemKind.User],[26,D.CompletionItemKind.Issue]]);function we(ke){return z.get(ke)??D.CompletionItemKind.Property}de.to=we})(te=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(de){function ge(X,z){const we=new D.CompletionItem(X.label);return we.insertText=X.insertText,we.kind=te.to(X.kind),we.tags=X.tags?.map(Q.to),we.detail=X.detail,we.documentation=E.isMarkdownString(X.documentation)?m.to(X.documentation):X.documentation,we.sortText=X.sortText,we.filterText=X.filterText,we.preselect=X.preselect,we.commitCharacters=X.commitCharacters,t.Range.isIRange(X.range)?we.range=u.to(X.range):typeof X.range=="object"&&(we.range={inserting:u.to(X.range.insert),replacing:u.to(X.range.replace)}),we.keepWhitespace=typeof X.insertTextRules=="undefined"?!1:Boolean(X.insertTextRules&1),typeof X.insertTextRules!="undefined"&&X.insertTextRules&4?we.insertText=new D.SnippetString(X.insertText):(we.insertText=X.insertText,we.textEdit=we.range instanceof D.Range?new D.TextEdit(we.range,we.insertText):void 0),X.additionalTextEdits&&X.additionalTextEdits.length>0&&(we.additionalTextEdits=X.additionalTextEdits.map(ke=>x.to(ke))),we.command=z&&X.command?z.fromInternal(X.command):void 0,we}de.to=ge})(ae=e.CompletionItem||(e.CompletionItem={}));var G;(function(de){function ge(z){return{label:z.label,documentation:z.documentation?m.fromStrict(z.documentation):void 0}}de.from=ge;function X(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?m.to(z.documentation):z.documentation}}de.to=X})(G=e.ParameterInformation||(e.ParameterInformation={}));var oe;(function(de){function ge(z){return{label:z.label,documentation:z.documentation?m.fromStrict(z.documentation):void 0,parameters:Array.isArray(z.parameters)?z.parameters.map(G.from):[],activeParameter:z.activeParameter}}de.from=ge;function X(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?m.to(z.documentation):z.documentation,parameters:Array.isArray(z.parameters)?z.parameters.map(G.to):[],activeParameter:z.activeParameter}}de.to=X})(oe=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(de){function ge(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(oe.from):[]}}de.from=ge;function X(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(oe.to):[]}}de.to=X})(he=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(de){function ge(z){return{text:z.text,position:i.from(z.position),kind:Be.from(z.kind??D.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter}}de.from=ge;function X(z){const we=new D.InlayHint(z.text,i.to(z.position),Be.to(z.kind));return we.whitespaceAfter=z.whitespaceAfter,we.whitespaceBefore=z.whitespaceBefore,we}de.to=X})(Te=e.InlayHint||(e.InlayHint={}));var Be;(function(de){function ge(z){return z}de.from=ge;function X(z){return z}de.to=X})(Be=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(de){function ge(z){return{range:u.from(z.range),url:z.target,tooltip:z.tooltip}}de.from=ge;function X(z){let we;if(z.url)try{we=typeof z.url=="string"?T.URI.parse(z.url,!0):T.URI.revive(z.url)}catch(ke){}return new D.DocumentLink(u.to(z.range),we)}de.to=X})(He=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(de){function ge(z){const we=new D.ColorPresentation(z.label);return z.textEdit&&(we.textEdit=x.to(z.textEdit)),z.additionalTextEdits&&(we.additionalTextEdits=z.additionalTextEdits.map(ke=>x.to(ke))),we}de.to=ge;function X(z){return{label:z.label,textEdit:z.textEdit?x.from(z.textEdit):void 0,additionalTextEdits:z.additionalTextEdits?z.additionalTextEdits.map(we=>x.from(we)):void 0}}de.from=X})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(de){function ge(z){return new D.Color(z[0],z[1],z[2],z[3])}de.to=ge;function X(z){return[z.red,z.green,z.blue,z.alpha]}de.from=X})(et=e.Color||(e.Color={}));var ot;(function(de){function ge(z){return{range:u.from(z.range)}}de.from=ge;function X(z){return new D.SelectionRange(u.to(z.range))}de.to=X})(ot=e.SelectionRange||(e.SelectionRange={}));var ye;(function(de){function ge(X){switch(X){case 2:return D.TextDocumentSaveReason.AfterDelay;case 1:return D.TextDocumentSaveReason.Manual;case 3:case 4:return D.TextDocumentSaveReason.FocusOut}}de.to=ge})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(de){function ge(z){switch(z){case D.TextEditorLineNumbersStyle.Off:return 0;case D.TextEditorLineNumbersStyle.Relative:return 2;case D.TextEditorLineNumbersStyle.On:default:return 1}}de.from=ge;function X(z){switch(z){case 0:return D.TextEditorLineNumbersStyle.Off;case 2:return D.TextEditorLineNumbersStyle.Relative;case 1:default:return D.TextEditorLineNumbersStyle.On}}de.to=X})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var q;(function(de){function ge(z){if(z===D.EndOfLine.CRLF)return 1;if(z===D.EndOfLine.LF)return 0}de.from=ge;function X(z){if(z===1)return D.EndOfLine.CRLF;if(z===0)return D.EndOfLine.LF}de.to=X})(q=e.EndOfLine||(e.EndOfLine={}));var Z;(function(de){function ge(X){if(typeof X=="object")return X.viewId;switch(X){case D.ProgressLocation.SourceControl:return 3;case D.ProgressLocation.Window:return 10;case D.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=ge})(Z=e.ProgressLocation||(e.ProgressLocation={}));var pe;(function(de){function ge(X){const z={start:X.start+1,end:X.end+1};return X.kind&&(z.kind=We.from(X.kind)),z}de.from=ge})(pe=e.FoldingRange||(e.FoldingRange={}));var We;(function(de){function ge(X){if(X)switch(X){case D.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case D.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case D.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}de.from=ge})(We=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ye;(function(de){function ge(X){if(X)return{pinned:typeof X.preview=="boolean"?!X.preview:void 0,inactive:X.background,preserveFocus:X.preserveFocus,selection:typeof X.selection=="object"?u.from(X.selection):void 0,override:typeof X.override=="boolean"?n.EditorResolution.DISABLED:void 0}}de.from=ge})(Ye=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var rt;(function(de){function ge(z){return z instanceof D.RelativePattern||typeof z=="string"?z:X(z)?new D.RelativePattern(z.base,z.pattern):z}de.from=ge;function X(z){const we=z;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(rt=e.GlobPattern||(e.GlobPattern={}));var ft;(function(de){function ge(X){if(X){if(Array.isArray(X))return X.map(ge);if(typeof X=="string")return X;{const z=X;return{language:z.language,scheme:z.scheme,pattern:typeof z.pattern=="undefined"?void 0:rt.from(z.pattern),exclusive:z.exclusive}}}else return}de.from=ge})(ft=e.LanguageSelector||(e.LanguageSelector={}));var dt;(function(de){function ge(z){return{start:z.start,end:z.end}}de.from=ge;function X(z){return new D.NotebookRange(z.start,z.end)}de.to=X})(dt=e.NotebookRange||(e.NotebookRange={}));var St;(function(de){function ge(z){return{timing:typeof z.runStartTime=="number"&&typeof z.runEndTime=="number"?{startTime:z.runStartTime,endTime:z.runEndTime}:void 0,executionOrder:z.executionOrder,success:z.lastRunSuccess}}de.to=ge;function X(z){return{lastRunSuccess:z.success,runStartTime:z.timing?.startTime,runEndTime:z.timing?.endTime,executionOrder:z.executionOrder}}de.from=X})(St=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var It;(function(de){function ge(z){switch(z){case D.NotebookCellKind.Markup:return c.CellKind.Markup;case D.NotebookCellKind.Code:default:return c.CellKind.Code}}de.from=ge;function X(z){switch(z){case c.CellKind.Markup:return D.NotebookCellKind.Markup;case c.CellKind.Code:default:return D.NotebookCellKind.Code}}de.to=X})(It=e.NotebookCellKind||(e.NotebookCellKind={}));var Tt;(function(de){function ge(z){const we={metadata:z.metadata??Object.create(null),cells:[]};for(let ke of z.cells)D.NotebookCellData.validate(ke),we.cells.push(Xe.from(ke));return we}de.from=ge;function X(z){const we=new D.NotebookData(z.cells.map(Xe.to));return(0,S.isEmptyObject)(z.metadata)||(we.metadata=z.metadata),we}de.to=X})(Tt=e.NotebookData||(e.NotebookData={}));var Xe;(function(de){function ge(z){return{cellKind:It.from(z.kind),language:z.languageId,mime:z.mime,source:z.value,metadata:z.metadata,internalMetadata:St.from(z.executionSummary??{}),outputs:z.outputs?z.outputs.map(Pe.from):[]}}de.from=ge;function X(z){return new D.NotebookCellData(It.to(z.cellKind),z.source,z.language,z.mime,z.outputs?z.outputs.map(Pe.to):void 0,z.metadata,z.internalMetadata?St.to(z.internalMetadata):void 0)}de.to=X})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var vt;(function(de){function ge(z){return{mime:z.mime,valueBytes:M.VSBuffer.wrap(z.data)}}de.from=ge;function X(z){return new D.NotebookCellOutputItem(z.valueBytes.buffer,z.mime)}de.to=X})(vt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(de){function ge(z){return{outputId:z.id,items:z.items.map(vt.from),metadata:z.metadata}}de.from=ge;function X(z){const we=z.items.map(vt.to);return new D.NotebookCellOutput(we,z.outputId,z.metadata)}de.to=X})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Se;(function(de){function ge(ke){if(ke!=null){if(ke instanceof D.RelativePattern||typeof ke=="string")return ke;if(we(ke))return new D.RelativePattern(ke.base,ke.pattern);if(z(ke))return{include:rt.from(ke.include)||void 0,exclude:rt.from(ke.exclude)||void 0}}}de.from=ge;function X(ke){return typeof ke=="string"?ke:we(ke)?{base:ke.base,pattern:ke.pattern}:{include:ke.include,exclude:ke.exclude}}de.to=X;function z(ke){const Je=ke,Ue=rt.from(Je.include);if(!(Ue&&Ue instanceof D.RelativePattern||typeof Ue=="string"))return!1;const ct=rt.from(Je.exclude);return!!(ct&&ct instanceof D.RelativePattern||typeof ct=="string")}function we(ke){const Je=ke;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Se=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ce;(function(de){function ge(X){return{backgroundColor:X.backgroundColor,borderColor:X.borderColor,top:X.top?L.from(X.top):void 0}}de.from=ge})(Ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ie;(function(de){function ge(X,z,we){const ke=typeof X.command=="string"?{title:"",command:X.command}:X.command;return{alignment:X.alignment===D.NotebookCellStatusBarAlignment.Left?1:2,command:z.toInternal(ke,we),text:X.text,tooltip:X.tooltip,accessibilityInformation:X.accessibilityInformation,priority:X.priority}}de.from=ge})(ie=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(de){function ge(X){return{transientOutputs:X?.transientOutputs??!1,transientCellMetadata:X?.transientCellMetadata??{},transientDocumentMetadata:X?.transientDocumentMetadata??{}}}de.from=ge})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var me;(function(de){function ge(z){return{uri:z.uri,provides:z.provides}}de.from=ge;function X(z){return new D.NotebookRendererScript(T.URI.revive(z.uri),z.provides)}de.to=X})(me=e.NotebookRendererScript||(e.NotebookRendererScript={}));var fe;(function(de){function ge(z){return{message:m.fromStrict(z.message)||"",type:0,expected:z.expectedOutput,actual:z.actualOutput,location:z.location?ee.from(z.location):void 0}}de.from=ge;function X(z){const we=new D.TestMessage(typeof z.message=="string"?z.message:m.to(z.message));return we.actualOutput=z.actual,we.expectedOutput=z.expected,we.location=z.location?ee.to(z.location):void 0,we}de.to=X})(fe=e.TestMessage||(e.TestMessage={}));var Ie;(function(de){let ge;(function(X){X.Delimiter="\0"})(ge||(ge={})),de.namespace=(X,z)=>X+"\0"+z,de.denamespace=X=>{const z=X.indexOf("\0");return{ctrlId:X.slice(0,z),tagId:X.slice(z+1)}}})(Ie=e.TestTag||(e.TestTag={}));var xe;(function(de){function ge(ke){const Je=(0,s.getPrivateApiFor)(ke).controllerId;return{extId:p.TestId.fromExtHostTestItem(ke,Je).toString(),label:ke.label,uri:ke.uri,tags:ke.tags.map(Ue=>Ie.namespace(Je,Ue.id)),range:u.from(ke.range)||null,description:ke.description||null,error:ke.error&&m.fromStrict(ke.error)||null}}de.from=ge;function X(ke){return{id:p.TestId.fromString(ke.extId).localId,label:ke.label,uri:T.URI.revive(ke.uri),tags:(ke.tags||[]).map(Je=>{const{tagId:Ue}=Ie.denamespace(Je);return new D.TestTag(Ue)}),range:u.to(ke.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:ke.description||void 0}}de.toPlain=X;function z(ke){const Je=p.TestId.fromString(ke.extId),Ue=new s.TestItemImpl(Je.controllerId,Je.localId,ke.label,T.URI.revive(ke.uri));return Ue.range=u.to(ke.range||void 0),Ue.description=ke.description||void 0,Ue}function we(ke){let Je;for(const Ue of ke.tests){const ct=z(Ue.item);(0,s.getPrivateApiFor)(ct).parent=Je,Je=ct}return Je}de.toItemFromContext=we})(xe=e.TestItem||(e.TestItem={})),function(de){function ge(z){return{id:z.id}}de.from=ge;function X(z){return new D.TestTag(z.id)}de.to=X}(Ie=e.TestTag||(e.TestTag={}));var Ne;(function(de){const ge=(z,we)=>{const ke={...xe.toPlain(z.item),parent:void 0,taskStates:z.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(Ue=>Ue.type===0).map(fe.to)})),children:z.children.map(Je=>we.get(Je)).filter(S.isDefined).map(Je=>ge(Je,we))};for(const Je of ke.children)Je.parent=ke;return ke};function X(z){const we=[],ke=new Map;for(const Je of z.items)ke.set(Je.item.extId,Je),z.request.targets.some(Ue=>Ue.controllerId===Je.controllerId&&Ue.testIds.includes(Je.item.extId))&&we.push(Je);return{completedAt:z.completedAt,results:we.map(Je=>ge(Je,ke))}}de.to=X})(Ne=e.TestResults||(e.TestResults={}));var qe;(function(de){function ge(ke){return{covered:ke.covered,total:ke.covered}}function X(ke){return"line"in ke?i.from(ke):u.from(ke)}function z(ke){return"branches"in ke?{count:ke.executionCount,location:X(ke.location),type:1,branches:ke.branches.length?ke.branches.map(Je=>({count:Je.executionCount,location:Je.location&&X(Je.location)})):void 0}:{type:0,count:ke.executionCount,location:X(ke.location)}}de.fromDetailed=z;function we(ke){return{uri:ke.uri,statement:ge(ke.statementCoverage),branch:ke.branchCoverage&&ge(ke.branchCoverage),function:ke.functionCoverage&&ge(ke.functionCoverage),details:ke.detailedCoverage?.map(z)}}de.fromFile=we})(qe=e.TestCoverage||(e.TestCoverage={}));var it;(function(de){function ge(X){switch(X){case 1:return D.CodeActionTriggerKind.Invoke;case 2:return D.CodeActionTriggerKind.Automatic}}de.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Le;(function(de){function ge(z){const we=new D.TypeHierarchyItem(H.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),u.to(z.range),u.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=ge;function X(z,we,ke){if(we=we??z._sessionId,ke=ke??z._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,kind:H.from(z.kind),name:z.name,detail:z.detail??"",uri:z.uri,range:u.from(z.range),selectionRange:u.from(z.selectionRange),tags:z.tags?.map(W.from)}}de.from=X})(Le=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[170],Ee([0,1,2,16,7,8,231]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(T,t,y,n={timeout:1500,errors:3}){this._logService=T,this._documents=t,this._mainThreadBulkEdits=y,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(t,y,n)=>{const s={dispose:this._callbacks.push([t,y,T])};return Array.isArray(n)&&n.push(s),s}}async $participateInSave(T,t){const y=h.URI.revive(T);let n=!1;const f=setTimeout(()=>n=!0,this._thresholds.timeout),s=[];try{for(let c of[...this._callbacks]){if(n)break;const p=this._documents.getDocument(y),P=await this._deliverEventAsyncAndBlameBadListeners(c,{document:p,reason:A.TextDocumentSaveReason.to(t)});s.push(P)}}finally{clearTimeout(f)}return s}_deliverEventAsyncAndBlameBadListeners([T,t,y],n){const f=this._badListeners.get(T);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,T,t,n).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const c=this._badListeners.get(T);this._badListeners.set(T,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,t,y,n){const f=[],s=Date.now(),{document:c,reason:p}=n,{version:P}=c,D=Object.freeze({document:c,reason:p,waitUntil(l){if(Object.isFrozen(f))throw(0,M.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(l))}});try{t.apply(y,[D])}catch(l){return Promise.reject(l)}return Object.freeze(f),new Promise((l,u)=>{const _=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(_),l(i)}).catch(i=>{clearTimeout(_),u(i)})}).then(l=>{const u={edits:[]};for(const _ of l)if(Array.isArray(_)&&_.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:g,range:a}of _)u.edits.push({_type:2,resource:c.uri,edit:{range:a&&A.Range.from(a),text:i,eol:g&&A.EndOfLine.from(g)}});if(u.edits.length!==0)return P===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(be[171],Ee([0,1,3,27,2,8,7]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(t,y,n,f,s){this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter,this._config=0,n&&(this._config+=1),f&&(this._config+=2),s&&(this._config+=4);const c=(0,M.parse)(y),p=t(P=>{if(!n)for(let D of P.created){const l=E.URI.revive(D);c(l.fsPath)&&this._onDidCreate.fire(l)}if(!f)for(let D of P.changed){const l=E.URI.revive(D);c(l.fsPath)&&this._onDidChange.fire(l)}if(!s)for(let D of P.deleted){const l=E.URI.revive(D);c(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(t,y,n){this._logService=y,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,y,n,f){return new C(this._onFileSystemEvent.event,t,y,n,f)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,y){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:y.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:y.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:y.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,y){return(n,f,s)=>{const c=function(P){n.call(f,P)};return c.extension=t,y.event(c,void 0,s)}}async $onWillRunFileOperation(t,y,n,f){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:y.map(s=>({oldUri:E.URI.revive(s.source),newUri:E.URI.revive(s.target)}))},n,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:y.map(s=>E.URI.revive(s.target))},n,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:y.map(s=>E.URI.revive(s.target))},n,f)}}async _fireWillEvent(t,y,n,f){const s=new Set,c=[];if(await t.fireAsync(y,f,async(P,D)=>{const l=Date.now(),u=await Promise.resolve(P);u instanceof F.WorkspaceEdit&&(c.push(u),s.add(D.extension.displayName??D.extension.identifier.value)),Date.now()-l>n&&this._logService.warn("SLOW file-participant",D.extension.identifier)}),f.isCancellationRequested||c.length===0)return;const p={edits:[]};for(let P of c){let{edits:D}=A.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(D)}return{edit:p,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=S}),define(be[172],Ee([0,1,11,23,2,8,7,89]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(n,f,s,c){this.start=n,this.deletedCount=f,this.deletedItems=s,this.items=c}static asApiEvents(n){return n.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(s=>s.apiCell)}))}}class T{constructor(n,f,s){this.notebook=n,this._extHostDocument=f,this._cellData=s,this.handle=s.handle,this.uri=E.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=s.internalMetadata??{},this._metadata=Object.freeze(s.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(s.internalMetadata??{}))}static asModelAddData(n,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return n._mime},set mime(s){n._mime=s},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,f,s){const c=s.map(A.NotebookCellOutputItem.to),p=this._outputs.find(P=>P.id===n);p&&(f||(p.items.length=0),p.items.push(...c))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=T;class t{constructor(n,f,s,c,p,P){this._proxy=n,this._textDocumentsAndEditors=f,this._textDocuments=s,this._emitter=c,this.uri=p,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=P.viewType,this._metadata=Object.freeze(P.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,P.cells]],!0),this._versionId=P.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===h.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(f){return f=n._validateIndex(f),n._cells[f].apiCell},getCells(f){return(f?n._getCells(f):n._cells).map(c=>c.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,f){this._versionId=n.versionId,this._isDirty=f;for(const s of n.rawEvents)s.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===C.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(s.index,s.metadata):s.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(s.index,s.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let f=n.start|0,s=n.end|0;return f<0&&(f=0),s>this._cells.length&&(s=this._cells.length),n.with({start:f,end:s})}_getCells(n){n=this._validateRange(n);const f=[];for(let s=n.start;s<n.end;s++)f.push(this._cells[s]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,f){if(this._disposed)return;const s=[],c=[],p=[];n.reverse().forEach(P=>{const l=P[2].map(i=>{const g=new T(this,this._textDocumentsAndEditors,i);return f||c.push(T.asModelAddData(this.apiNotebook,i)),g}),u=new S(P[0],P[1],[],l),_=this._cells.splice(P[0],P[1],...l);for(const i of _)p.push(i.uri),u.deletedItems.push(i.apiCell);s.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:p}),f||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(s)}))}_moveCell(n,f){const s=this._cells.splice(n,1);this._cells.splice(f,0,...s);const c=[new S(n,1,s.map(p=>p.apiCell),[]),new S(f,0,[],s)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(c)}))}_setCellOutputs(n,f){const s=this._cells[n];s.setOutputs(f),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_setCellOutputItems(n,f,s,c){const p=this._cells[n];p.setOutputItems(f,s,c),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(n,f){const s=this._cells[n];s.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(s.uri,f)}_changeCellMime(n,f){const s=this._cells[n];s.apiCell.mime=f}_changeCellMetadata(n,f){const s=this._cells[n],c=s.apiCell.metadata;s.setMetadata(f);const p=s.apiCell.metadata;(0,M.equals)(c,p)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell}))}_changeCellInternalMetadata(n,f){const s=this._cells[n],c=s.internalMetadata;if(s.setInternalMetadata(f),c.runState!==f.runState){const p=f.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell,state:p}))}}getCellFromApiCell(n){return this._cells.find(f=>f.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(f=>f.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:T})}replaceCells(S,T,t){this._throwIfFinalized(),!(S===T&&t.length===0)&&this._collectedEdits.push({editType:1,index:S,count:T-S,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(S,T,t,y,n,f){this.id=S,this._proxy=T,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=y,this._viewColumn=f}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(T){if(!Array.isArray(T)||!T.every(h.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");S._selections=T,S._trySetSelections(T)},get visibleRanges(){return S._visibleRanges},revealRange(T,t){S._proxy.$tryRevealRange(S.id,M.NotebookRange.from(T),t??h.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(T){const t=new A(this.document.version);return T(t),S._applyEdit(t.finalize())},setDecorations(T,t){return S.setDecorations(T,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(M.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const T=[];let t=-1;for(let y=0;y<S.cellEdits.length;y++){if(t<0){T.push(S.cellEdits[y]),t++;continue}const f=T[t],s=S.cellEdits[y];if(f.editType===1&&s.editType===1&&f.index===s.index){f.cells.push(...S.cellEdits[y].cells),f.count+=S.cellEdits[y].count;continue}T.push(S.cellEdits[y]),t++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,T)}setDecorations(S,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return T.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(T),S.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(be[173],Ee([0,1,8,146,126,21,53,16]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,f,s){const c=this._handles++,{title:p,location:P,cancellable:D}=f,l={label:(0,E.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(c,{location:h.ProgressLocation.from(P),title:p,source:l,cancellable:D},n).catch(C.onUnexpectedExternalError),this._withProgress(c,s,!!D)}_withProgress(n,f,s){let c;s&&(c=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,c));const p=D=>{this._proxy.$progressEnd(D),this._mapHandleToCancellationSource.delete(D),c&&c.dispose()};let P;try{P=f(new t(this._proxy,n),s&&c?c.token:A.CancellationToken.None)}catch(D){throw p(n),D}return P.then(D=>p(n),D=>p(n)),P}$acceptProgressCanceled(n){const f=this._mapHandleToCancellationSource.get(n);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=S;function T(y,n){return y.message=n.message,typeof n.increment=="number"&&(typeof y.increment=="number"?y.increment+=n.increment:y.increment=n.increment),y}class t extends M.Progress{constructor(n,f){super(s=>this.throttledReport(s));this._proxy=n,this._handle=f}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}$e([(0,F.throttle)(100,(y,n)=>T(y,n),()=>Object.create(null))],t.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,42,16,54,8,7]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(n,f,s){const c=C._Keys.nextId();n.$registerTextEditorDecorationType(f.identifier,c,A.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:c,dispose(){n.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=C,C._Keys=new E.IdGenerator("TextEditorDecorationType");class S{constructor(n,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,f){this._throwIfFinalized();let s=null;if(n instanceof F.Position)s=new F.Range(n,n);else if(n instanceof F.Range)s=n;else throw new Error("Unrecognized location");this._pushEdit(s,f,!1)}insert(n,f){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),f,!0)}delete(n){this._throwIfFinalized();let f=null;if(n instanceof F.Range)f=n;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(n,f,s){const c=this._document.validateRange(n);this._collectedEdits.push({range:c,text:f,forceMoveMarkers:s})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=S;class T{constructor(n,f,s,c){this._proxy=n,this._id=f,this._accept(s),this._logService=c;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(P){p._setTabSize(P)},get insertSpaces(){return p._insertSpaces},set insertSpaces(P){p._setInsertSpaces(P)},get cursorStyle(){return p._cursorStyle},set cursorStyle(P){p._setCursorStyle(P)},get lineNumbers(){return p._lineNumbers},set lineNumbers(P){p._setLineNumbers(P)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const f=Math.floor(n);return f>0?f:null}if(typeof n=="string"){const f=parseInt(n,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(n){const f=this._validateTabSize(n);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const f=this._validateInsertSpaces(n);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const f={};let s=!1;if(typeof n.tabSize!="undefined"){const c=this._validateTabSize(n.tabSize);c==="auto"?(s=!0,f.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,s=!0,f.tabSize=c)}if(typeof n.insertSpaces!="undefined"){const c=this._validateInsertSpaces(n.insertSpaces);c==="auto"?(s=!0,f.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,s=!0,f.insertSpaces=c)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,s=!0,f.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,s=!0,f.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(n){n.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=T;class t{constructor(n,f,s,c,p,P,D,l){this.id=n,this._proxy=f,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new T(this._proxy,this.id,P,s),this._visibleRanges=D,this._viewColumn=l;const u=this;this.value=Object.freeze({get document(){return c.getValue()},set document(_){throw(0,M.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(_){if(!(_ instanceof F.Selection))throw(0,M.illegalArgument)("selection");u._selections=[_],u._trySetSelection()},get selections(){return u._selections},set selections(_){if(!Array.isArray(_)||_.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");u._selections=_,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(_){throw(0,M.readonly)("visibleRanges")},get options(){return u._options.value},set options(_){u._disposed||u._options.assign(_)},get viewColumn(){return u._viewColumn},set viewColumn(_){throw(0,M.readonly)("viewColumn")},edit(_,i={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new S(c.getValue(),i);return _(g),u._applyEdit(g)},insertSnippet(_,i,g={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=u._selections.map(r=>A.Range.from(r));else if(i instanceof F.Position){const{lineNumber:r,column:v}=A.Position.from(i);a=[{startLineNumber:r,startColumn:v,endLineNumber:r,endColumn:v}]}else if(i instanceof F.Range)a=[A.Range.from(i)];else{a=[];for(const r of i)if(r instanceof F.Range)a.push(A.Range.from(r));else{const{lineNumber:v,column:o}=A.Position.from(r);a.push({startLineNumber:v,startColumn:o,endLineNumber:v,endColumn:o})}}return f.$tryInsertSnippet(n,_.value,a,g)},setDecorations(_,i){const g=i.length===0;g&&!u._hasDecorationsForKey.has(_.key)||(g?u._hasDecorationsForKey.delete(_.key):u._hasDecorationsForKey.add(_.key),u._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return f.$trySetDecorations(n,_.key,A.fromRangeOrRangeWithMessage(i));{const a=new Array(4*i.length);for(let r=0,v=i.length;r<v;r++){const o=i[r];a[4*r]=o.start.line+1,a[4*r+1]=o.start.character+1,a[4*r+2]=o.end.line+1,a[4*r+3]=o.end.character+1}return f.$trySetDecorationsFast(n,_.key,a)}}))},revealRange(_,i){u._runOnProxy(()=>f.$tryRevealRange(n,A.Range.from(_),i||F.TextEditorRevealType.Default))},show(_){f.$tryShowEditor(n,A.ViewColumn.from(_))},hide(){f.$tryHideEditor(n)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,h.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,h.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,h.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,h.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const f=n.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const s=f.edits.map(p=>p.range);s.sort((p,P)=>p.end.line===P.end.line?p.end.character===P.end.character?p.start.line===P.start.line?p.start.character-P.start.character:p.start.line-P.start.line:p.end.character-P.end.character:p.end.line-P.end.line);for(let p=0,P=s.length-1;p<P;p++){const D=s[p].end;if(s[p+1].start.isBefore(D))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=f.edits.map(p=>({range:A.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,c,{setEndOfLine:typeof f.setEndOfLine=="number"?A.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=t}),define(be[174],Ee([0,1,129,24,2,3,6,162,12,7,10,14,8,21,159]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function c(D,l){if((0,t.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let u;return Array.isArray(D.highlights)&&(u=D.highlights.filter(_=>_.length===2&&typeof _[0]=="number"&&typeof _[1]=="number"),u=u.length?u:void 0),{label:D.label,highlights:u}}}class p{constructor(l,u,_){this._proxy=l,this.commands=u,this.logService=_,this.treeViews=new Map;function i(g){return g&&g.$treeViewId&&g.$treeItemHandle}u.registerArgumentProcessor({processArgument:g=>i(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(a=>i(a)?this.convertArgument(a):a):g})}registerTreeDataProvider(l,u,_){const i=this.createTreeView(l,{treeDataProvider:u},_);return{dispose:()=>i.dispose()}}createTreeView(l,u,_){if(!u||!u.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=u.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!u.showCollapseAll,canSelectMany:!!u.canSelectMany,canDragAndDrop:i}),a=this.createExtHostTreeView(l,u,_);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(r){a.message=r},get title(){return a.title},set title(r){a.title=r},get description(){return a.description},set description(r){a.description=r},reveal:(r,v)=>a.reveal(r,v),dispose:async()=>{await g,this.treeViews.delete(l),a.dispose()}}}$getChildren(l,u){const _=this.treeViews.get(l);return _?_.getChildren(u):Promise.reject(new Error((0,h.localize)(0,null,l)))}async $onDrop(l,u,_){const i=this.treeViews.get(l);if(!i)return Promise.reject(new Error((0,h.localize)(1,null,l)));const g=s.TreeDataTransferConverter.toITreeDataTransfer(u);if(g.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const r=JSON.parse(await g.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(v=>i.getExtensionElement(v)).filter(v=>!!v);r.length>0?g.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(r)}):g.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(g,_)}async $hasResolve(l){const u=this.treeViews.get(l);if(!u)throw new Error((0,h.localize)(2,null,l));return u.hasResolve}$resolve(l,u,_){const i=this.treeViews.get(l);if(!i)throw new Error((0,h.localize)(3,null,l));return i.resolveTreeItem(u,_)}$setExpanded(l,u,_){const i=this.treeViews.get(l);if(!i)throw new Error((0,h.localize)(4,null,l));i.setExpanded(u,_)}$setSelection(l,u){const _=this.treeViews.get(l);if(!_)throw new Error((0,h.localize)(5,null,l));_.setSelection(u)}$setVisible(l,u){const _=this.treeViews.get(l);if(!_)throw new Error((0,h.localize)(6,null,l));_.setVisible(u)}createExtHostTreeView(l,u,_){const i=new P(l,u,this._proxy,this.commands.converter,this.logService,_);return this.treeViews.set(l,i),i}convertArgument(l){const u=this.treeViews.get(l.$treeViewId);return u?u.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=p;class P extends F.Disposable{constructor(l,u,_,i,g,a){super();if(this.viewId=l,this.proxy=_,this.commands=i,this.logService=g,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,a.contributes&&a.contributes.views)for(const o in a.contributes.views)for(const d of a.contributes.views[o])d.id===l&&(this._title=d.name);this.dataProvider=u.treeDataProvider,this.dndController=u.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(o=>this._onDidChangeData.fire({message:!1,element:o}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let r,v;this._register(A.Event.debounce(this._onDidChangeData.event,(o,d)=>(o||(o={message:!1,elements:[]}),d.element!==!1&&(r||(r=new Promise(w=>v=w),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(d.element)?o.elements.push(...d.element):o.elements.push(d.element)),d.message&&(o.message=!0),o),200,!0)(({message:o,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=v;return r=null,this.refresh(d).then(()=>w())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,t.isUndefinedOrNull)(l))}async getChildren(l){const u=l?this.getExtensionElement(l):void 0;if(l&&!u)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let _=this.getChildrenNodes(l);return _||(_=await this.fetchChildrenNodes(u)),_?_.map(i=>i.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,u){u=u||{select:!0,focus:!1};const _=(0,t.isUndefinedOrNull)(u.select)?!0:u.select,i=(0,t.isUndefinedOrNull)(u.focus)?!1:u.focus,g=(0,t.isUndefinedOrNull)(u.expand)?!1:u.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(a=>this.resolveTreeNode(l,a[a.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:a.map(v=>v.item)},{select:_,focus:i,expand:g})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:_,focus:i,expand:g})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}setExpanded(l,u){const _=this.getExtensionElement(l);_&&(u?this._onDidExpandElement.fire(Object.freeze({element:_})):this._onDidCollapseElement.fire(Object.freeze({element:_})))}setSelection(l){(0,y.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(l,u){const _=this.getExtensionElement(u);if(!!_)return(0,S.asPromise)(()=>this.dndController?.onDrop(l,_))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,u){if(!this.dataProvider.resolveTreeItem)return;const _=this.elements.get(l);if(_){const i=this.nodes.get(_);if(i){const g=await this.dataProvider.resolveTreeItem(i.extensionItem,_,u)??i.extensionItem;return i.item.tooltip=this.getTooltip(g.tooltip),i.item.command=this.getCommand(i.disposableStore,g.command),i.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(u=>u?this.resolveUnknownParentChain(u).then(_=>this.resolveTreeNode(u,_[_.length-1]).then(i=>(_.push(i),_))):Promise.resolve([]))}resolveParent(l){const u=this.nodes.get(l);return u?Promise.resolve(u.parent?this.elements.get(u.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,u){const _=this.nodes.get(l);return _?Promise.resolve(_):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(i=>this.createHandle(l,i,u,!0)).then(i=>this.getChildren(u?u.item.handle:void 0).then(()=>{const g=this.getExtensionElement(i);if(g){const a=this.nodes.get(g);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(l){if(l){let u;if(typeof l=="string"){const _=this.getExtensionElement(l);u=_?this.nodes.get(_):void 0}else u=l;return u&&u.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const u=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const _=l?this.nodes.get(l):void 0,i=await this.dataProvider.getChildren(l);if(u.token.isCancellationRequested)return;const g=await Promise.all((0,y.coalesce)(i||[]).map(async a=>{const r=await this.dataProvider.getTreeItem(a);return r&&!u.token.isCancellationRequested?this.createAndRegisterTreeNode(a,r,_):null}));return u.token.isCancellationRequested?void 0:(0,y.coalesce)(g)}finally{u.dispose()}}refresh(l){if(l.some(_=>!_))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const _=this.getHandlesToRefresh(l);if(_.length)return this.refreshHandles(_)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const u=new Set,_=l.map(g=>this.nodes.get(g));for(const g of _)if(g&&!u.has(g.item.handle)){let a=g;for(;a&&a.parent&&_.findIndex(r=>a&&a.parent&&r&&r.item.handle===a.parent.item.handle)===-1;){const r=this.elements.get(a.parent.item.handle);a=r?this.nodes.get(r):void 0}a&&!a.parent&&u.add(g.item.handle)}const i=[];return u.forEach(g=>{const a=this.elements.get(g);if(a){const r=this.nodes.get(a);r&&(!r.parent||!u.has(r.parent.item.handle))&&i.push(g)}}),i}refreshHandles(l){const u={};return Promise.all(l.map(_=>this.refreshNode(_).then(i=>{i&&(u[_]=i.item)}))).then(()=>Object.keys(u).length?this.proxy.$refresh(this.viewId,u):void 0)}refreshNode(l){const u=this.getExtensionElement(l);if(u){const _=this.nodes.get(u);if(_)return this.clearChildren(u),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(i=>{if(i){const g=this.createTreeNode(u,i,_.parent);return this.updateNodeCache(u,g,_,_.parent),_.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,u,_){const i=this.createTreeNode(l,u,_);if(u.id&&this.elements.has(i.item.handle))throw new Error((0,h.localize)(7,null,u.id));return this.addNodeToCache(l,i),this.addNodeToParentCache(i,_),i}getTooltip(l){return T.MarkdownString.isMarkdownString(l)?n.MarkdownString.from(l):l}getCommand(l,u){return u?this.commands.toInternal(u,l):void 0}createTreeNode(l,u,_){const i=new F.DisposableStore,g=this.createHandle(l,u,_),a=this.getLightIconPath(u);return{item:{handle:g,parentHandle:_?_.item.handle:void 0,label:c(u.label,this.extension),description:u.description,resourceUri:u.resourceUri,tooltip:this.getTooltip(u.tooltip),command:this.getCommand(i,u.command),contextValue:u.contextValue,icon:a,iconDark:this.getDarkIconPath(u)||a,themeIcon:this.getThemeIcon(u),collapsibleState:(0,t.isUndefinedOrNull)(u.collapsibleState)?T.TreeItemCollapsibleState.None:u.collapsibleState,accessibilityInformation:u.accessibilityInformation},extensionItem:u,parent:_,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(l){return l.iconPath instanceof T.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:u,label:_,resourceUri:i},g,a){if(u)return`${P.ID_HANDLE_PREFIX}/${u}`;const r=c(_,this.extension),v=g?g.item.handle:P.LABEL_HANDLE_PREFIX;let o=r?r.label:i?(0,M.basename)(i):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const d=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,w=this.getChildrenNodes(g)||[];let I,m=0;do{if(I=`${v}/${m}:${o}`,a||!this.elements.has(I)||d===I)break;m++}while(m<=w.length);return I}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof T.ThemeIcon))return typeof l.iconPath=="string"||E.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof T.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return E.URI.isUri(l)?l:E.URI.file(l)}addNodeToCache(l,u){this.elements.set(u.item.handle,l),this.nodes.set(l,u)}updateNodeCache(l,u,_,i){this.elements.delete(u.item.handle),this.nodes.delete(l),u.item.handle!==_.item.handle&&this.elements.delete(_.item.handle),this.addNodeToCache(l,u);const g=this.getChildrenNodes(i)||[],a=g.filter(r=>r.item.handle===_.item.handle)[0];a&&g.splice(g.indexOf(a),1,u)}addNodeToParentCache(l,u){u?(u.children||(u.children=[]),u.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const u=this.nodes.get(l);if(u){if(u.children)for(const _ of u.children){const i=this.elements.get(_.item.handle);i&&this.clear(i)}u.children=void 0}}else this.clearAll()}clear(l){const u=this.nodes.get(l);if(u){if(u.children)for(const _ of u.children){const i=this.elements.get(_.item.handle);i&&this.clear(i)}this.nodes.delete(l),this.elements.delete(u.item.handle),u.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}P.LABEL_HANDLE_PREFIX="0",P.ID_HANDLE_PREFIX="1"}),define(be[175],Ee([0,1,12,3,6,10,49,8,90,68]),function(se,e,h,M,E,A,F,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const f=this.diff[this.diff.length-1];if(f&&n[0]===1){if(f[0]===1&&f[1].extId===n[1].extId){(0,S.applyTestItemUpdate)(f[1],n[1]);return}if(f[0]===0&&f[1].item.extId===n[1].extId){(0,S.applyTestItemUpdate)(f[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,f){const s=this.tree.get(n);if(!!s){if((s.expandLevels===void 0||f>s.expandLevels)&&(s.expandLevels=f),s.expand===1){const c=this.resolveChildren(s);return c.isOpen()?this.expandChildren(s,f-1):c.wait().then(()=>this.expandChildren(s,f-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,f-1)):this.expandChildren(s,f-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,f){switch(f.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(n.fullId,f.id));break;case 0:this.upsertItem(f.item,n);break;case 4:for(const D of f.ops)this.onTestItemEvent(n,D);break;case 3:const{key:s,value:c,previous:p}=f,P=n.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(c,p,P);break;case"range":this.pushDiff([1,{extId:P,item:{range:C.Range.from(c)}}]);break;case"error":this.pushDiff([1,{extId:P,item:{error:C.MarkdownString.fromStrict(c)||null}}]);break;default:this.pushDiff([1,{extId:P,item:{[s]:c??null}}]);break}break;default:(0,A.assertNever)(f)}}upsertItem(n,f){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const s=T.TestId.fromExtHostTestItem(n,this.root.id,f?.actual),c=(0,F.getPrivateApiFor)(n);c.parent&&c.parent!==f?.actual&&c.parent.children.delete(n.id);let p=this.tree.get(s.toString());if(!p){p={fullId:s,actual:n,parent:f?s.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(p.fullId.toString(),p),this.setItemParent(n,f),this.pushDiff([0,{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:C.TestItem.from(n)}]),this.connectItemAndChildren(n,p,f);return}if(p.actual===n){this.connectItem(n,p,f);return}const P=p.actual.children,D=p.actual,l=(0,F.diffTestItems)(D,n);(0,F.getPrivateApiFor)(D).listener=void 0,p.actual=n,p.expand=0;for(const[u,_]of l)this.onTestItemEvent(p,{op:3,key:u,value:_,previous:D[u]});this.connectItemAndChildren(n,p,f);for(const u of P)n.children.get(u.id)||this.removeItem(T.TestId.joinToString(s,u.id))}diffTagRefs(n,f,s){const c=new Set(f.map(p=>p.id));for(const p of n)c.delete(p.id)||this.incrementTagRefs(p);this.pushDiff([1,{extId:s,item:{tags:n.map(p=>C.TestTag.namespace(this.controllerId,p.id))}}]),c.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const f=this.tags.get(n.id);f?f.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:C.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const f=this.tags.get(n);f&&!--f.refCount&&(this.tags.delete(n),this.pushDiff([6,C.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,f){(0,F.getPrivateApiFor)(n).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(n,f,s){this.setItemParent(n,s);const c=(0,F.getPrivateApiFor)(n);c.parent=s?.actual,c.listener=p=>this.onTestItemEvent(f,p),this.updateExpandability(f)}connectItemAndChildren(n,f,s){this.connectItem(n,f,s);for(const c of n.children)this.upsertItem(c,f)}updateExpandability(n){let f;this._resolveHandler?n.resolveBarrier?f=n.resolveBarrier.isOpen()?3:2:f=n.actual.canResolveChildren?1:0:f=0,f!==n.expand&&(n.expand=f,this.pushDiff([1,{extId:n.fullId.toString(),expand:f}]),f===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,f){if(f<0)return;const s=[];for(const c of n.actual.children){const p=this.expand(T.TestId.joinToString(n.fullId,c.id),f);(0,h.isThenable)(p)&&s.push(p)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const p=new h.Barrier;return p.open(),p}n.expand=2,this.pushExpandStateUpdate(n);const f=n.resolveBarrier=new h.Barrier,s=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=p.stack||p.message||String(p))};let c;try{c=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(p){s(p)}return(0,h.isThenable)(c)?c.catch(s).then(()=>{f.open(),this.updateExpandability(n)}):(f.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const f=this.tree.get(n);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const s=[f];for(;s.length;){const c=s.pop();if(!!c){(0,F.getPrivateApiFor)(c.actual).listener=void 0;for(const p of c.actual.tags)this.decrementTagRefs(p.id);this.tree.delete(c.fullId.toString());for(const p of c.actual.children)s.push(this.tree.get(T.TestId.joinToString(c.fullId,p.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[176],Ee([0,1,4,142]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(M.IEnvironmentService)}),define(be[177],Ee([0,1,26,3,17]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(h.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(h.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let y of t.activationEvents)y==="onUri"&&(y=`onUri:${h.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(t)}}keepOnly(t){const y=new Set;t.forEach(n=>y.add(h.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>y.has(h.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,y){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(n.map(f=>f.identifier)),y.length>0){const f=new Set;y.forEach(s=>f.add(h.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!f.has(h.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,P){this.addNode(p),this.addNode(P),this._arcs.has(p)?this._arcs.get(p).push(P):this._arcs.set(p,[P])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,P){const D=y.getArcs(p);for(let l=0;l<D.length;l++)if(!P.has(D[l]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let p of t){const P=h.ExtensionIdentifier.toKey(p.identifier);if(n.set(P,p),p.extensionDependencies)for(let D of p.extensionDependencies){const l=h.ExtensionIdentifier.toKey(D);y.addArc(P,l)}}let f=new Set;y.getNodes().filter(p=>y.getArcs(p).length===0).forEach(p=>f.add(p));let s=y.getNodes().filter(p=>!f.has(p)),c;do{c=!1;for(let p=0;p<s.length;p++){const P=s[p];y.hasOnlyGoodArcs(P,f)&&(s.splice(p,1),p--,f.add(P),c=!0)}}while(c);return s.map(p=>n.get(p))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(h.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const y=this._activationMap.get(t);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const y=this._extensionsMap.get(h.ExtensionIdentifier.toKey(t));return y||void 0}}e.ExtensionDescriptionRegistry=F;var C;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(C||(C={}));function S(T,t){const y=T.isBuiltin?0:T.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(y!==n)return y-n;const f=E.posix.basename(T.extensionLocation.path),s=E.posix.basename(t.extensionLocation.path);return f<s?-1:f>s?1:0}}),define(be[178],Ee([0,1,22]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function A(C){const S=h.VSBuffer.alloc(1);switch(C){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=A;function F(C,S){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=F}),define(be[30],Ee([0,1,3,2,4,26,148]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var C;(function(u){u[u.None=0]="None",u[u.LocalProcess=1]="LocalProcess",u[u.LocalWebWorker=2]="LocalWebWorker",u[u.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(u){switch(u){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class T{constructor(_){this.dependency=_}}e.MissingExtensionDependency=T;var t;(function(u){u[u.LocalProcess=0]="LocalProcess",u[u.LocalWebWorker=1]="LocalWebWorker",u[u.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(u){switch(u){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=y;class n{constructor(_,i,g,a){this.codeLoadingTime=_,this.activateCallTime=i,this.activateResolvedTime=g,this.activationReason=a}}e.ActivationTimes=n;class f{constructor(_,i){this.description=_,this.value=i}}e.ExtensionPointContribution=f,e.ExtensionHostLogFileName="exthost";var s;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function c(u){u.enableProposedApi||p(u)}e.checkProposedApiEnabled=c;function p(u){throw new Error(`[${u.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${u.identifier.value}`)}e.throwProposedApiError=p;function P(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation}}e.toExtension=P;function D(u,_){return{identifier:new A.ExtensionIdentifier(u.identifier.id),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!_,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid}}e.toExtensionDescription=D;class l{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(_,i){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,i,g,a,r){}_onDidActivateExtensionError(_,i){}_onExtensionRuntimeError(_,i){}_onExtensionHostExit(_){}}e.NullExtensionService=l}),define(be[179],Ee([0,1,26,30,15]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class F{constructor(s,c,p,P){this.startup=s,this.codeLoadingTime=c,this.activateCallTime=p,this.activateResolvedTime=P}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class C{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,c){return s===-1||c===-1?-1:c-s}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class S{constructor(s,c,p,P,D,l){this.activationFailed=s,this.activationFailedError=c,this.activationTimes=p,this.module=P,this.exports=D,this.subscriptions=l}}e.ActivatedExtension=S;class T extends S{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class t extends S{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class y extends S{constructor(s){super(!0,s,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=y;let n=class{constructor(s,c,p,P,D){this._logService=D,this._registry=s,this._resolvedExtensionsSet=new Set,c.forEach(l=>this._resolvedExtensionsSet.add(h.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,p.forEach(l=>this._hostExtensionsMap.set(h.ExtensionIdentifier.toKey(l),l)),this._host=P,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const c=h.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(c)}getActivatedExtension(s){const c=h.ExtensionIdentifier.toKey(s),p=this._activatedExtensions.get(c);if(!p)throw new Error("Extension `"+s.value+"` is not known or not activated");return p}activateByEvent(s,c){if(this._alreadyActivatedEvents[s])return A;const p=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(p.map(P=>({id:P.identifier,reason:{startup:c,extensionId:P.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,c){const p=this._registry.getExtensionDescription(s);if(!p)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:p.identifier,reason:c}])}_handleActivateRequest(s,c,p){if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(s.id))){c[h.ExtensionIdentifier.toKey(s.id)]=s;return}const P=this._registry.getExtensionDescription(s.id);if(!P){const u=new Error(`Cannot activate unknown extension '${s.id.value}'`);this._host.onExtensionActivationError(s.id,u,new M.MissingExtensionDependency(s.id.value)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(s.id),new y(u));return}const D=typeof P.extensionDependencies=="undefined"?[]:P.extensionDependencies;let l=!0;for(let u=0,_=D.length;u<_;u++){const i=D[u];if(this._resolvedExtensionsSet.has(h.ExtensionIdentifier.toKey(i)))continue;const g=this._activatedExtensions.get(h.ExtensionIdentifier.toKey(i));if(g&&!g.activationFailed)continue;if(g&&g.activationFailed){const o=P.displayName||P.identifier.value,d=this._registry.getExtensionDescription(i),w=d&&d.displayName||i,I=new Error(`Cannot activate the '${o}' extension because its dependency '${w}' failed to activate`);I.detail=g.activationFailedError,this._host.onExtensionActivationError(P.identifier,I,null),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(P.identifier),new y(I));return}if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(i))){l=!1,c[h.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(h.ExtensionIdentifier.toKey(i)),reason:s.reason};continue}const a=this._registry.getExtensionDescription(i);if(a){if(!a.main&&!a.browser)continue;l=!1,c[h.ExtensionIdentifier.toKey(i)]={id:a.identifier,reason:s.reason};continue}const r=P.displayName||P.identifier.value,v=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(P.identifier,v,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(P.identifier),new y(v));return}l?c[h.ExtensionIdentifier.toKey(P.identifier)]=s:p.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(D=>!this._activatedExtensions.has(h.ExtensionIdentifier.toKey(D.id))),s.length===0))return Promise.resolve(void 0);const c=Object.create(null),p=[];for(let D=0,l=s.length;D<l;D++)this._handleActivateRequest(s[D],c,p);for(let D=0,l=p.length;D<l;D++){const u=h.ExtensionIdentifier.toKey(p[D].id);c[u]&&delete c[u]}const P=Object.keys(c).map(D=>c[D]);return p.length===0?Promise.all(P.map(D=>this._activateExtension(D.id,D.reason))).then(D=>{}):this._activateExtensions(P).then(D=>this._activateExtensions(p))}_activateExtension(s,c){const p=h.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const P=this._activatingExtensions.get(p);if(P)return P;const D=this._host.actualActivateExtension(s,c).then(void 0,l=>{const u=new Error;return l&&l.name&&(u.name=l.name),l&&l.message?u.message=`Activating extension '${s.value}' failed: ${l.message}.`:u.message=`Activating extension '${s.value}' failed: ${l}.`,l&&l.stack&&(u.stack=l.stack),this._host.onExtensionActivationError(s,u,null),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(l),new y(l)}).then(l=>{this._activatedExtensions.set(p,l),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,D),D}};n=$e([ze(4,E.ILogService)],n),e.ExtensionsActivator=n}),define(be[180],Ee([0,1,16]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,F)=>{this._actualOk=A,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,h.onUnexpectedError)(A))}then(A,F){return this._ensureActual().then(A,F)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(be[38],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class h{constructor(T,t){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=t,this.nid=++h.count}}e.ProxyIdentifier=h,h.count=0;const M=[];function E(S){const T=new h(!0,S);return M[T.nid]=T,T}e.createMainContextProxyIdentifier=E;function A(S){const T=new h(!1,S);return M[T.nid]=T,T}e.createExtHostContextProxyIdentifier=A;function F(S){return M[S].sid}e.getStringIdentifierForProxy=F;class C{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=C}),define(be[5],Ee([0,1,55,2,38]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var F;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(l){l.name="$ident";function u(i,g){return Object.defineProperty(i,l.name,{value:g,enumerable:!0}),i}l.mixin=u;function _(i){return i[l.name]}l.of=_})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(u){return u._id=f._n++,u}}e.IdObject=f,f._n=0;var s;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function P(l){if(l&&l.edits)for(const u of l.edits)typeof u.resource=="object"?u.resource=M.URI.revive(u.resource):(u.newUri=M.URI.revive(u.newUri),u.oldUri=M.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,h.revive)(u.metadata));return l}e.reviveWorkspaceEditDto=P;var D;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(D=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[69],Ee([0,1,5,3,4]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(C){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,S){return this._proxy.$getPassword(C,S)}store(C,S,T){return this._proxy.$setPassword(C,S,T)}delete(C,S){return this._proxy.$deletePassword(C,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(be[70],Ee([0,1,4,15,5,13]),function(se,e,h,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(S,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(E.MainContext.MainThreadTelemetry)}report(S,T,t){const y=this.getUsageKey(S,T);this._reportedUsages.has(y)||(this._reportedUsages.add(y),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:S}))}getUsageKey(S,T){return`${S}-${T.identifier.value}`}};F=$e([ze(0,A.IExtHostRpcService),ze(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(C,S,T){}})}),define(be[181],Ee([0,1,3,5,7,26]),function(se,e,h,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,T,t,y={}){const n=A.ExtensionIdentifier.toKey(S.identifier),f=this._inFlightRequests.get(n)||[],s=[...t].sort().join(" ");let c=f.find(p=>p.scopes===s);if(c)return c.result;{const p=this._getSession(S,n,T,t,y);c={scopes:s,result:p},f.push(c),this._inFlightRequests.set(n,f);try{await p}finally{const P=f.findIndex(D=>D.scopes===s);P>-1&&(f.splice(P),this._inFlightRequests.set(n,f))}return p}}async _getSession(S,T,t,y,n={}){await this._proxy.$ensureProvider(t);const f=S.displayName||S.name;return this._proxy.$getSession(t,y,T,f,n)}async removeSession(S,T){const t=this._authenticationProviders.get(S);return t?t.provider.removeSession(T):this._proxy.$removeSession(S,T)}registerAuthenticationProvider(S,T,t,y){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:T,provider:t,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===S)||this._providers.push({id:S,label:T});const n=t.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(S,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,T,y?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(S);const f=this._providers.findIndex(s=>s.id===S);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,T){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,T){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,T){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,T){return this._onDidChangeSessions.fire({provider:{id:S,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(be[182],Ee([0,1,5,13,8]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(C,S){this._extHostDocumentsAndEditors=S,this._proxy=C.getProxy(h.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const S=E.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};A=$e([ze(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[183],Ee([0,1,5]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const F=A.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(C){return F.$writeText(C)}})}}e.ExtHostClipboard=M}),define(be[39],Ee([0,1,10,7,8,23,5,14,15,55,44,112,2,6,4,13,49,22,38,45]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=class{constructor(v,o){this._commands=new Map,this._apiCommands=new Map,this._proxy=v.getProxy(F.MainContext.MainThreadCommands),this._logService=o,this.converter=new _(this,d=>{const w=this._apiCommands.get(d);return w?.result===g.Void?w:void 0},o),this._argumentProcessors=[{processArgument(d){return(0,T.revive)(d)}},{processArgument(d){return(0,A.cloneAndChange)(d,function(w){if(t.Range.isIRange(w))return E.Range.to(w);if(y.Position.isIPosition(w))return E.Position.to(w);if(t.Range.isIRange(w.range)&&n.URI.isUri(w.uri))return E.location.to(w);if(w instanceof P.VSBuffer)return w.buffer.buffer;if(!Array.isArray(w))return w})}}]}registerArgumentProcessor(v){this._argumentProcessors.push(v)}registerApiCommand(v){const o=this.registerCommand(!1,v.id,async(...d)=>{const w=v.args.map((m,k)=>{if(!m.validate(d[k]))throw new Error(`Invalid argument '${m.name}' when running '${v.id}', received: ${d[k]}`);return m.convert(d[k])}),I=await this.executeCommand(v.internalId,...w);return v.result.convert(I,d,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this._apiCommands.set(v.id,v),new M.Disposable(()=>{o.dispose(),this._apiCommands.delete(v.id)})}registerCommand(v,o,d,w,I,m){if(this._logService.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this._commands.has(o))throw new Error(`command '${o}' already exists`);return this._commands.set(o,{callback:d,thisArg:w,description:I,extension:m}),v&&this._proxy.$registerCommand(o),new M.Disposable(()=>{this._commands.delete(o)&&v&&this._proxy.$unregisterCommand(o)})}executeCommand(v,...o){return this._logService.trace("ExtHostCommands#executeCommand",v),this._doExecuteCommand(v,o,!0)}async _doExecuteCommand(v,o,d){if(this._commands.has(v))return this._executeContributedCommand(v,o,!1);{let w=!1;const I=(0,A.cloneAndChange)(o,function(m){if(m instanceof M.Position)return E.Position.from(m);if(m instanceof M.Range)return E.Range.from(m);if(m instanceof M.Location)return E.location.from(m);if(M.NotebookRange.isNotebookRange(m))return E.NotebookRange.from(m);if(m instanceof ArrayBuffer)return w=!0,P.VSBuffer.wrap(new Uint8Array(m));if(m instanceof Uint8Array)return w=!0,P.VSBuffer.wrap(m);if(!Array.isArray(m))return m});try{const m=await this._proxy.$executeCommand(v,w?new D.SerializableObjectWithBuffers(I):I,d);return(0,T.revive)(m)}catch(m){if(m instanceof Error&&m.message==="$executeCommand:retry")return this._doExecuteCommand(v,o,!1);throw m}}}async _executeContributedCommand(v,o,d){const w=this._commands.get(v);if(!w)throw new Error("Unknown command");let{callback:I,thisArg:m,description:k}=w;if(k)for(let R=0;R<k.args.length;R++)try{(0,h.validateConstraint)(o[R],k.args[R].constraint)}catch(L){throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${k.args[R].name}' - ${k.args[R].description}`)}try{return await I.apply(m,o)}catch(R){if(v===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...o);L&&(v=L.command)}throw this._logService.error(R,v,w.extension?.identifier),d?new class extends Error{constructor(){super((0,l.toErrorMessage)(R));this.id=v,this.source=w.extension?.displayName??w.extension?.name}}:R}}$executeContributedCommand(v,...o){return this._logService.trace("ExtHostCommands#$executeContributedCommand",v),this._commands.has(v)?(o=o.map(d=>this._argumentProcessors.reduce((w,I)=>I.processArgument(w),d)),this._executeContributedCommand(v,o,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this._logService.trace("ExtHostCommands#getCommands",v),this._proxy.$getCommands().then(o=>(v&&(o=o.filter(d=>d[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const v=Object.create(null);for(let[o,d]of this._commands){let{description:w}=d;w&&(v[o]=w)}return Promise.resolve(v)}};u=$e([ze(0,c.IExtHostRpcService),ze(1,S.ILogService)],u),e.ExtHostCommands=u,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class _{constructor(v,o,d){this._commands=v,this._lookupApiCommand=o,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(v,o){if(!v)return;const d={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return d;const w=this._lookupApiCommand(v.command);if(w)d.id=w.internalId,d.arguments=w.args.map((I,m)=>I.convert(v.arguments&&v.arguments[m]));else if((0,C.isNonEmptyArray)(v.arguments)){const I=++this._cachIdPool;this._cache.set(I,v),o.add((0,f.toDisposable)(()=>{this._cache.delete(I),this._logService.trace("CommandsConverter#DISPOSE",I)})),d.$ident=I,d.id=this.delegatingCommandId,d.arguments=[I],this._logService.trace("CommandsConverter#CREATE",v.command,I)}return d}fromInternal(v){const o=F.ObjectIdentifier.of(v);return typeof o=="number"?this._cache.get(o):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this._cache.get(v[0])}_executeConvertedCommand(...v){const o=this.getActualCommand(...v);return this._logService.trace("CommandsConverter#EXECUTE",v[0],o?o.command:"MISSING"),o?this._commands.executeCommand(o.command,...o.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=_;class i{constructor(v,o,d,w){this.name=v,this.description=o,this.validate=d,this.convert=w}optional(){return new i(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,o){return new i(v??this.name,o??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),i.Position=new i("position","A position in a text document",r=>M.Position.isPosition(r),E.Position.from),i.Range=new i("range","A range in a text document",r=>M.Range.isRange(r),E.Range.from),i.Selection=new i("selection","A selection in a text document",r=>M.Selection.isSelection(r),E.Selection.from),i.Number=new i("number","",r=>typeof r=="number",r=>r),i.String=new i("string","",r=>typeof r=="string",r=>r),i.CallHierarchyItem=new i("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",r=>r instanceof p.TestItemImpl,E.TestItem.from);class g{constructor(v,o){this.description=v,this.convert=o}}e.ApiCommandResult=g,g.Void=new g("no result",r=>r);class a{constructor(v,o,d,w,I){this.id=v,this.internalId=o,this.description=d,this.args=w,this.result=I}}e.ApiCommand=a}),define(be[184],Ee([0,1,8,7,59,39,14,81]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(h.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,f)=>{if((0,F.isFalsyOrEmpty)(n))return;class s extends M.SymbolInformation{static to(p){const P=new s(p.name,h.SymbolKind.to(p.kind),p.containerName||"",new M.Location(f[0],h.Range.to(p.range)));return P.detail=p.detail,P.range=P.location.range,P.selectionRange=h.Range.to(p.selectionRange),P.children=p.children?p.children.map(s.to):[],P}}return n.map(s.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(h.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(h.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(f=>M.Position.isPosition(f)),n=>n.map(h.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(f=>{let s;for(const c of f.reverse())s=new M.SelectionRange(h.Range.to(c),s);return s}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const f=[];if(Array.isArray(n))for(let s of n)f.push(...s[1].map(h.WorkspaceSymbol.to));return f})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(h.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(h.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(h.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:h.Range.to(n.range),placeholder:n.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return h.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(h.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,C.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,C.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,f,s)=>{if(!n)return new M.CompletionList([]);const c=n.suggestions.map(p=>h.CompletionItem.to(p,s));return new M.CompletionList(c,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return h.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,f,s)=>t(c=>new M.CodeLens(h.Range.to(c.range),c.command&&s.fromInternal(c.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?h.Selection.from(n):h.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,f,s)=>t(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(c.command)}else{const p=new M.CodeAction(c.title,c.kind?new M.CodeActionKind(c.kind):void 0);return c.edit&&(p.edit=h.WorkspaceEdit.to(c.edit)),c.command&&(p.command=s.fromInternal(c.command)),p.isPreferred=c.isPreferred,p}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(f=>new M.ColorInformation(h.Range.to(f.range),h.Color.to(f.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,h.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:h.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(h.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(h.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(f=>h.NotebookExclusiveDocumentPattern.to(f))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(h.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[h.ViewColumn.from(n.viewColumn),h.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[h.ViewColumn.from(n.viewColumn),h.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[h.ViewColumn.from(n.viewColumn),h.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(h.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(h.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(h.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class T{static register(f){S.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=T;function t(n){return f=>{if(Array.isArray(f))return f.map(n)}}function y(n){if(!Array.isArray(n))return;const f=[];for(const s of n)E.isLocationLink(s)?f.push(h.DefinitionLink.to(s)):f.push(h.location.to(s));return f}}),define(be[185],Ee([0,1,12,53,3,6,2,59,26,8,7,5]),function(se,e,h,M,E,A,F,C,S,T,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(f,s,c){const p=f.getProxy(y.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const v=this._commentControllers.get(r.handle);return v||r}else if(r&&r.$mid===7){const v=this._commentControllers.get(r.commentControlHandle);if(!v)return r;const o=v.getCommentThread(r.commentThreadHandle);return o||r}else if(r&&r.$mid===8){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const o=v.getCommentThread(r.thread.commentThreadHandle);return o?{thread:o,text:r.text}:r}else if(r&&r.$mid===9){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const o=v.getCommentThread(r.thread.commentThreadHandle);if(!o)return r;let d=r.commentUniqueId,w=o.getCommentByUniqueId(d);return w||r}else if(r&&r.$mid===10){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const o=v.getCommentThread(r.thread.commentThreadHandle);if(!o)return r;let d=r.text,w=r.commentUniqueId,I=o.getCommentByUniqueId(w);return I?(I.body=d,I):r}return r}})}createCommentController(r,v,o){const d=P.handlePool++,w=new l(r,d,v,o);this._commentControllers.set(w.handle,w);const I=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(r.identifier))||[];return I.push(w),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(r.identifier),I),w.value}$createCommentThreadTemplate(r,v,o){const d=this._commentControllers.get(r);!d||d.$createCommentThreadTemplate(v,o)}async $updateCommentThreadTemplate(r,v,o){const d=this._commentControllers.get(r);!d||d.$updateCommentThreadTemplate(v,o)}$deleteCommentThread(r,v){const o=this._commentControllers.get(r);o&&o.$deleteCommentThread(v)}$provideCommentingRanges(r,v,o){const d=this._commentControllers.get(r);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const w=c.getDocument(F.URI.revive(v));return(0,h.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(w,o)).then(I=>I?I.map(m=>T.Range.from(m)):void 0)}$toggleReaction(r,v,o,d,w){const I=this._commentControllers.get(r);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const m=I.getCommentThread(v);if(m){const k=m.getCommentByUniqueId(d.uniqueIdInThread);if(I!==void 0&&k&&I.reactionHandler)return I.reactionHandler(k,i(w))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class D{constructor(r,v,o,d,w,I,m){this._commentControllerHandle=v,this._id=o,this._uri=d,this._range=w,this._comments=I,this.handle=D._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),p.$createCommentThread(v,this.handle,this._id,this._uri,T.Range.from(this._range),m),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(v,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(R){k.range=R},get comments(){return k.comments},set comments(R){k.comments=R},get collapsibleState(){return k.collapsibleState},set collapsibleState(R){k.collapsibleState=R},get canReply(){return k.canReply},set canReply(R){k.canReply=R},get contextValue(){return k.contextValue},set contextValue(R){k.contextValue=R},get label(){return k.label},set label(R){k.label=R},dispose:()=>{k.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const r=o=>Object.prototype.hasOwnProperty.call(this.modifications,o),v={};r("range")&&(v.range=T.Range.from(this._range)),r("label")&&(v.label=this.label),r("contextValue")&&(v.contextValue=this.contextValue),r("comments")&&(v.comments=this._comments.map(o=>u(this,o,this._commentsMap))),r("collapsibleState")&&(v.collapseState=g(this._collapseState)),r("canReply")&&(v.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,v)}getCommentByUniqueId(r){for(let v of this._commentsMap){let o=v[0],d=v[1];if(r===d)return o}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}D._handlePool=0,$e([(0,M.debounce)(100)],D.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(r,v,o,d){this._extension=r,this._handle=v,this._id=o,this._label=d,this._threads=new Map,p.$registerCommentController(this.handle,o,d);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(I){w.options=I},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(I){w.commentingRangeProvider=I},get reactionHandler(){return w.reactionHandler},set reactionHandler(I){w.reactionHandler=I},createCommentThread(I,m,k){return w.createCommentThread(I,m,k).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,v,o,d){if(typeof r=="string"){const w=new D(this.id,this.handle,r,v,o,d,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new D(this.id,this.handle,void 0,r,v,o,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(r,v){const o=new D(this.id,this.handle,void 0,F.URI.revive(r),T.Range.to(v),[],this._extension.identifier);return o.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(o.handle,o),o}$updateCommentThreadTemplate(r,v){let o=this._threads.get(r);o&&(o.range=T.Range.to(v))}$deleteCommentThread(r){let v=this._threads.get(r);v&&v.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function u(a,r,v){let o=v.get(r);o||(o=++a.commentHandle,v.set(r,o));const d=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:o,body:T.MarkdownString.from(r.body),userName:r.author.name,userIconPath:d,label:r.label,commentReactions:r.reactions?r.reactions.map(w=>_(w)):void 0}}function _(a){return{label:a.label,iconPath:a.iconPath?T.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function i(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?F.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function g(a){if(a!==void 0)switch(a){case t.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,13,15,14,9,17]),function(se,e,h,M,E,A,F,C,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class vi{constructor(f,s){this._logService=s,this._provider=new Map,this._proxy=f.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,s){const c=vi._handlePool++;this._provider.set(c,{provider:f,extensionId:s}),this._proxy.$registerDecorationProvider(c,s.value);const p=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(c,null);return}let D=(0,S.asArray)(P);if(D.length<=vi._maxEventSize){this._proxy.$onDidChange(c,D);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,D.length);const l=D.map(i=>({uri:i,rank:(0,T.count)(i.path,"/")})),u=(0,S.groupBy)(l,(i,g)=>i.rank-g.rank||(0,T.compare)(i.uri.path,g.uri.path));let _=[];e:for(let i of u){let g;for(let a of i){let r=(0,t.dirname)(a.uri.path);if(g!==r&&(g=r,_.push(a.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(c,_)});return new E.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(f,s,c){if(!this._provider.has(f))return Object.create(null);const p=Object.create(null),{provider:P,extensionId:D}=this._provider.get(f);return await Promise.all(s.map(async l=>{try{const{uri:u,id:_}=l,i=await Promise.resolve(P.provideFileDecoration(h.URI.revive(u),c));if(!i)return;try{E.FileDecoration.validate(i),p[_]=[i.propagate,i.tooltip,i.badge,i.color]}catch(g){this._logService.warn(`INVALID decoration from extension '${D.value}': ${g}`)}}catch(u){this._logService.error(u)}})),p}};y._handlePool=0,y._maxEventSize=250,y=$e([ze(0,F.IExtHostRpcService),ze(1,C.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(se,e,h,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,h):E?E.value=h:e.set(se,h),h},Ae=this&&this.__classPrivateFieldGet||function(se,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(se):M?M.value:e.get(se)};define(be[186],Ee([0,1,124,83,2,5,7,8,3,15,20,37,104]),function(se,e,h,M,E,A,F,C,S,T,t,y,n){"use strict";var f,s,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{constructor(l,u,_,i,g,a){this._name=l,this._owner=u,this._maxDiagnosticsPerFile=_,f.set(this,void 0),s.set(this,void 0),c.set(this,void 0),this._isDisposed=!1,Ze(this,c,new n.SkipList((r,v)=>i.compare(r,v)),"f"),Ze(this,f,g,"f"),Ze(this,s,a,"f")}dispose(){this._isDisposed||(Ae(this,s,"f").fire([...Ae(this,c,"f").keys()]),Ae(this,f,"f")&&Ae(this,f,"f").$clear(this._owner),Ae(this,c,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,u){if(!l){this.clear();return}this._checkDisposed();let _=[];if(E.URI.isUri(l)){if(!u){this.delete(l);return}Ae(this,c,"f").set(l,u.slice()),_=[l]}else if(Array.isArray(l)){_=[];let g;l=[...l].sort(p._compareIndexedTuplesByUri);for(const a of l){const[r,v]=a;if((!g||r.toString()!==g.toString())&&(g&&Ae(this,c,"f").get(g).length===0&&Ae(this,c,"f").delete(g),g=r,_.push(r),Ae(this,c,"f").set(r,[])),v){const o=Ae(this,c,"f").get(r);o&&o.push(...v)}else{const o=Ae(this,c,"f").get(r);o&&(o.length=0)}}}if(Ae(this,s,"f").fire(_),!Ae(this,f,"f"))return;const i=[];for(let g of _){let a=[];const r=Ae(this,c,"f").get(g);if(r)if(r.length>this._maxDiagnosticsPerFile){a=[];const v=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(let d of r)if(d.severity===v[o]&&a.push(C.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;a.push({severity:M.MarkerSeverity.Info,message:(0,h.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=r.map(v=>C.Diagnostic.from(v));i.push([g,a])}Ae(this,f,"f").$changeMany(this._owner,i)}delete(l){this._checkDisposed(),Ae(this,s,"f").fire([l]),Ae(this,c,"f").delete(l),Ae(this,f,"f")&&Ae(this,f,"f").$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),Ae(this,s,"f").fire([...Ae(this,c,"f").keys()]),Ae(this,c,"f").clear(),Ae(this,f,"f")&&Ae(this,f,"f").$clear(this._owner)}forEach(l,u){this._checkDisposed();for(let _ of Ae(this,c,"f").keys())l.apply(u,[_,this.get(_),this])}get(l){this._checkDisposed();const u=Ae(this,c,"f").get(l);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(Ae(this,c,"f").get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,u){return l[0].toString()<u[0].toString()?-1:l[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=p,f=new WeakMap,s=new WeakMap,c=new WeakMap;let P=class ei{constructor(l,u,_){this._logService=u,this._fileSystemInfoService=_,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ei._mapper),this._proxy=l.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(l){const u=new t.ResourceMap;for(const _ of l)u.set(_,_);return{uris:Object.freeze(Array.from(u.values()))}}createDiagnosticCollection(l,u){const{_collections:_,_proxy:i,_onDidChangeDiagnostics:g,_logService:a,_fileSystemInfoService:r}=this,v=new class{$changeMany(w,I){i.$changeMany(w,I),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,w,I.length===0?"CLEARING":I)}$clear(w){i.$clear(w),a.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,w)}dispose(){i.dispose()}};let o;if(!u)u="_generated_diagnostic_collection_name_#"+ei._idPool++,o=u;else if(!_.has(u))o=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do o=u+ei._idPool++;while(_.has(o))}return new class extends p{constructor(){super(u,o,ei._maxDiagnosticsPerFile,r.extUri,v,g);_.set(o,this)}dispose(){super.dispose(),_.delete(o)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const u=new Map,_=[];for(const i of this._collections.values())i.forEach((g,a)=>{let r=u.get(g.toString());typeof r=="undefined"&&(r=_.length,u.set(g.toString(),r),_.push([g,[]])),_[r][1]=_[r][1].concat(...a)});return _}}_getDiagnostics(l){let u=[];for(let _ of this._collections.values())_.has(l)&&(u=u.concat(_.get(l)));return u}$acceptMarkersChange(l){if(!this._mirrorCollection){const u="_generated_mirror",_=new p(u,u,ei._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(u,_),this._mirrorCollection=_}for(const[u,_]of l)this._mirrorCollection.set(E.URI.revive(u),_.map(C.Diagnostic.to))}};P._idPool=0,P._maxDiagnosticsPerFile=1e3,P=$e([ze(1,T.ILogService),ze(2,y.IExtHostFileSystemInfo)],P),e.ExtHostDiagnostics=P}),define(be[187],Ee([0,1,2,5]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(C=>C?C.map(S=>h.URI.revive(S)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(C=>C?h.URI.revive(C):void 0)}}e.ExtHostDialogs=E}),define(be[188],Ee([0,1,16,2,7,5,11,21,9]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(y,n,f){this._documentsAndEditors=n,this._logService=f,this._documentContentProviders=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,n){if(Object.keys(F.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const f=T._handlePool++;this._documentContentProviders.set(f,n),this._proxy.$registerTextContentProvider(f,y);let s;return typeof n.onDidChange=="function"&&(s=n.onDidChange(c=>{if(c.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(f,c).then(p=>{if(!p&&typeof p!="string")return;const P=this._documentsAndEditors.getDocument(c);if(!P)return;const D=(0,S.splitLines)(p);if(!P.equalLines(D))return this._proxy.$onVirtualDocumentChange(c,p)},h.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(y,n){const f=this._documentContentProviders.get(y);return f?Promise.resolve(f.provideTextDocumentContent(M.URI.revive(n),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(be[189],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(se,e,h,M,E,A,F,C,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(f,s){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const p of c)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const p of c)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const s=this._documentsAndEditors.getDocument(f);if(s)return s}getDocument(f){const s=this.getDocumentData(f);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return s.document}ensureDocumentData(f){const s=this._documentsAndEditors.getDocument(f);if(s)return Promise.resolve(s);let c=this._documentLoader.get(f.toString());return c||(c=this._proxy.$tryOpenDocument(f).then(p=>{this._documentLoader.delete(f.toString());const P=E.URI.revive(p);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(P))},p=>(this._documentLoader.delete(f.toString()),Promise.reject(p))),this._documentLoader.set(f.toString(),c)),c}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(s=>E.URI.revive(s))}$acceptModelModeChanged(f,s){const c=E.URI.revive(f),p=this._documentsAndEditors.getDocument(c);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(s),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(f){const s=E.URI.revive(f),c=this._documentsAndEditors.getDocument(s);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(f,s){const c=E.URI.revive(f),p=this._documentsAndEditors.getDocument(c);if(!p)throw new Error("unknown document");p._acceptIsDirty(s),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,s,c){const p=E.URI.revive(f),P=this._documentsAndEditors.getDocument(p);if(!P)throw new Error("unknown document");P._acceptIsDirty(c),P.onEvents(s);let D;s.isUndoing?D=t.TextDocumentChangeReason.Undo:s.isRedoing&&(D=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:P.document,contentChanges:s.changes.map(l=>({range:C.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:D}))}setWordDefinitionFor(f,s){(0,F.setWordDefinitionFor)(f,s)}}e.ExtHostDocuments=y}),define(be[50],Ee([0,1,42,3,6,2,4,5,88,13,94,8,15,20,11,232,103]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let D=class{constructor(u,_){this._extHostRpc=u,this._logService=_,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const _=[],i=[],g=[];if(u.removedDocuments)for(const a of u.removedDocuments){const r=A.URI.revive(a),v=this._documents.get(r);v?.unref()&&(this._documents.delete(r),_.push(v.value))}if(u.addedDocuments)for(const a of u.addedDocuments){const r=A.URI.revive(a.uri);let v=this._documents.get(r);if(v&&r.scheme!==s.Schemas.vscodeNotebookCell&&r.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);v||(v=new P(new S.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),r,a.lines,a.EOL,a.versionId,a.modeId,a.isDirty,a.notebook)),this._documents.set(r,v),i.push(v.value)),v.ref()}if(u.removedEditors)for(const a of u.removedEditors){const r=this._editors.get(a);this._editors.delete(a),r&&g.push(r)}if(u.addedEditors)for(const a of u.addedEditors){const r=A.URI.revive(a.documentUri);h.ok(this._documents.has(r),`document '${r}' does not exist`),h.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const v=this._documents.get(r).value,o=new t.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>v.document),a.selections.map(y.Selection.to),a.options,a.visibleRanges.map(d=>y.Range.to(d)),typeof a.editorPosition=="number"?y.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,o)}u.newActiveEditor!==void 0&&(h.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,E.dispose)(_),(0,E.dispose)(g),u.removedDocuments&&this._onDidRemoveDocuments.fire(_),u.addedDocuments&&this._onDidAddDocuments.fire(i),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){return this._documents.get(u)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!this._activeEditorId)return;const _=this._editors.get(this._activeEditorId);return u?_:_?.value}allEditors(){return[...this._editors.values()]}};D=$e([ze(0,T.IExtHostRpcService),ze(1,n.ILogService)],D),e.ExtHostDocumentsAndEditors=D,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[71],Ee([0,1,8,5,2,3,4,13,12]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,F.createDecorator)("IExtHostEditorTabs");let T=class{constructor(y){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=y.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(y){let n=-1;this._tabs=y.map((s,c)=>(s.isActive&&(n=c),Object.freeze({label:s.label,viewColumn:h.ViewColumn.to(s.viewColumn),index:c,resource:E.URI.revive(s.resource),additionalResourcesAndViewIds:s.additionalResourcesAndViewIds.map(({resource:p,viewId:P})=>({resource:E.URI.revive(p),viewId:P})),viewId:s.editorId,isActive:s.isActive,move:async(p,P)=>{this._proxy.$moveTab(s,p,h.ViewColumn.from(P)),await(0,S.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(s),await(0,S.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((s,c)=>s.viewColumn===c.viewColumn?s.index-c.index:s.viewColumn-c.viewColumn);const f=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==f&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=$e([ze(0,C.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(be[190],Ee([0,1,2,5,6,7,8,233,9,22]),function(se,e,h,M,E,A,F,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const s=this._schemes.indexOf(f);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),s=[];let c,p,P=14,D=14;for(const l of f){let u=c?(0,S.commonPrefixLength)(c,l):0;for(u===0?p=1:p=D;u<l.length;u++)u+1===l.length?(P=D,D=9):D+=1,s.push([p,l.toUpperCase().charCodeAt(u),D]),s.push([p,l.toLowerCase().charCodeAt(u),D]),p=D;c=l,D=P}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new C.StateMachine(s)}}provideDocumentLinks(f){this._initStateMachine();const s=[],c=C.LinkComputer.computeLinks({getLineContent(p){return f.lineAt(p-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const p of c){const P=F.DocumentLink.to(p);P.target&&s.push(P)}return s}}class y{constructor(f,s){this._extHostLanguageFeatures=s,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,s,c,p={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(P,c);let D=2;p.isCaseSensitive&&(D+=1024),p.isReadonly&&(D+=2048),typeof c.copy=="function"&&(D+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&(D+=4),this._proxy.$registerFileSystemProvider(P,s,D).catch(u=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${s}`),console.error(u)});const l=c.onDidChangeFile(u=>{const _=[];for(const i of u){let{uri:g,type:a}=i;if(g.scheme!==s)continue;let r;switch(a){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}_.push({resource:g,type:r})}this._proxy.$onFileSystemChange(P,_)});return(0,E.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(f){const{type:s,ctime:c,mtime:p,size:P,permissions:D}=f;return{type:s,ctime:c,mtime:p,size:P,permissions:D}}$stat(f,s){return Promise.resolve(this._getFsProvider(f).stat(h.URI.revive(s))).then(c=>y._asIStat(c))}$readdir(f,s){return Promise.resolve(this._getFsProvider(f).readDirectory(h.URI.revive(s)))}$readFile(f,s){return Promise.resolve(this._getFsProvider(f).readFile(h.URI.revive(s))).then(c=>T.VSBuffer.wrap(c))}$writeFile(f,s,c,p){return Promise.resolve(this._getFsProvider(f).writeFile(h.URI.revive(s),c.buffer,p))}$delete(f,s,c){return Promise.resolve(this._getFsProvider(f).delete(h.URI.revive(s),c))}$rename(f,s,c,p){return Promise.resolve(this._getFsProvider(f).rename(h.URI.revive(s),h.URI.revive(c),p))}$copy(f,s,c,p){const P=this._getFsProvider(f);if(!P.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(P.copy(h.URI.revive(s),h.URI.revive(c),p))}$mkdir(f,s){return Promise.resolve(this._getFsProvider(f).createDirectory(h.URI.revive(s)))}$watch(f,s,c,p){const P=this._getFsProvider(f).watch(h.URI.revive(c),p);this._watches.set(s,P)}$unwatch(f,s){const c=this._watches.get(s);c&&(c.dispose(),this._watches.delete(s))}$open(f,s,c){const p=this._getFsProvider(f);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(h.URI.revive(s),c))}$close(f,s){const c=this._getFsProvider(f);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(s))}$read(f,s,c,p){const P=this._getFsProvider(f);if(!P.read)throw new Error('FileSystemProvider does not implement "read"');const D=T.VSBuffer.alloc(p);return Promise.resolve(P.read(s,c,D.buffer,0,p)).then(l=>D.slice(0,l))}$write(f,s,c,p){const P=this._getFsProvider(f);if(!P.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(P.write(s,c,p.buffer,0,p.byteLength))}_getFsProvider(f){const s=this._fsProvider.get(f);if(!s){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return s}}e.ExtHostFileSystem=y}),define(be[72],Ee([0,1,5,60,7,22,4,13,37]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class $t{constructor(y,n){const f=y.getProxy(h.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return f.$stat(s).catch($t._handleError)},readDirectory(s){return f.$readdir(s).catch($t._handleError)},createDirectory(s){return f.$mkdir(s).catch($t._handleError)},async readFile(s){return f.$readFile(s).then(c=>c.buffer).catch($t._handleError)},writeFile(s,c){return f.$writeFile(s,A.VSBuffer.wrap(c)).catch($t._handleError)},delete(s,c){return f.$delete(s,{recursive:!1,useTrash:!1,...c}).catch($t._handleError)},rename(s,c,p){return f.$rename(s,c,{overwrite:!1,...p}).catch($t._handleError)},copy(s,c,p){return f.$copy(s,c,{overwrite:!1,...p}).catch($t._handleError)},isWritableFileSystem(s){const c=n.getCapabilities(s);if(typeof c=="number")return!(c&2048)}})}static _handleError(y){if(!(y instanceof Error))throw new E.FileSystemError(String(y));if(y.name==="ENOPRO")throw E.FileSystemError.Unavailable(y.message);switch(y.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(y.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(y.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(y.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(y.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(y.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(y.message);default:throw new E.FileSystemError(y.message,y.name)}}};T=$e([ze(0,C.IExtHostRpcService),ze(1,S.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(be[191],Ee([0,1,2,39]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(F,C,S,T){this._extHostNotebooks=C,this._textDocumentsAndEditors=S,this._commands=T;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new M.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new M.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new M.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new M.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:h.URI.revive(y.notebookUri),inputUri:h.URI.revive(y.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:h.URI.revive(y.notebookUri),inputUri:h.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,C,S,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:S,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(h.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=E}),define(be[192],Ee([0,1,6,5]),function(se,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,F),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=E}),define(be[193],Ee([0,1,2,23,8,7,5,9,44,14,10,234,6,81,54,64,194,16,3]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentSymbols(U,Q){const te=this._documents.getDocument(U),ae=await this._provider.provideDocumentSymbols(te,Q);if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(E.DocumentSymbol.from):l._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((ae,G)=>{let oe=ae.location.range.start.compareTo(G.location.range.start);return oe===0&&(oe=G.location.range.end.compareTo(ae.location.range.end)),oe});const Q=[],te=[];for(const ae of U){const G={name:ae.name||"!!MISSING: name!!",kind:E.SymbolKind.from(ae.kind),tags:ae.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:E.Range.from(ae.location.range),selectionRange:E.Range.from(ae.location.range),children:[]};for(;;){if(te.length===0){te.push(G),Q.push(G);break}const oe=te[te.length-1];if(S.Range.containsRange(oe.range,G.range)&&!S.Range.equalsRange(oe.range,G.range)){oe.children&&oe.children.push(G),te.push(G);break}te.pop()}}return Q}}class u{constructor(U,Q,te){this._documents=U,this._commands=Q,this._provider=te,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,Q){const te=this._documents.getDocument(U),ae=await this._provider.provideCodeLenses(te,Q);if(!ae||Q.isCancellationRequested)return;const G=this._cache.add(ae),oe=new n.DisposableStore;this._disposables.set(G,oe);const he={cacheId:G,lenses:[]};for(let Te=0;Te<ae.length;Te++)he.lenses.push({cacheId:[G,Te],range:E.Range.from(ae[Te].range),command:this._commands.toInternal(ae[Te].command,oe)});return he}async resolveCodeLens(U,Q){const te=U.cacheId&&this._cache.get(...U.cacheId);if(!te)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?ae=te:ae=await this._provider.resolveCodeLens(te,Q),ae||(ae=te),Q.isCancellationRequested)return;const G=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!G)return U.command=this._commands.toInternal(ae.command??u._badCmd,G),U}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function _(Ve){return Array.isArray(Ve)?Ve.map(E.DefinitionLink.from):Ve?[E.DefinitionLink.from(Ve)]:[]}class i{constructor(U,Q){this._documents=U,this._provider=Q}async provideDefinition(U,Q,te){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideDefinition(ae,G,te);return _(oe)}}class g{constructor(U,Q){this._documents=U,this._provider=Q}async provideDeclaration(U,Q,te){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideDeclaration(ae,G,te);return _(oe)}}class a{constructor(U,Q){this._documents=U,this._provider=Q}async provideImplementation(U,Q,te){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideImplementation(ae,G,te);return _(oe)}}class r{constructor(U,Q){this._documents=U,this._provider=Q}async provideTypeDefinition(U,Q,te){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideTypeDefinition(ae,G,te);return _(oe)}}class v{constructor(U,Q){this._documents=U,this._provider=Q}async provideHover(U,Q,te){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideHover(ae,G,te);if(!(!oe||(0,T.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(G)),oe.range||(oe.range=new A.Range(G,G)),E.Hover.from(oe)}}class o{constructor(U,Q){this._documents=U,this._provider=Q}async provideEvaluatableExpression(U,Q,te){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideEvaluatableExpression(ae,G,te);if(oe)return E.EvaluatableExpression.from(oe)}}class d{constructor(U,Q){this._documents=U,this._provider=Q}async provideInlineValues(U,Q,te,ae){const G=this._documents.getDocument(U),oe=await this._provider.provideInlineValues(G,E.Range.to(Q),E.InlineValueContext.to(te),ae);if(Array.isArray(oe))return oe.map(he=>E.InlineValue.from(he))}}class w{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentHighlights(U,Q,te){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideDocumentHighlights(ae,G,te);if(Array.isArray(oe))return oe.map(E.DocumentHighlight.from)}}class I{constructor(U,Q){this._documents=U,this._provider=Q}async provideLinkedEditingRanges(U,Q,te){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.provideLinkedEditingRanges(ae,G,te);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,T.coalesce)(oe.ranges.map(E.Range.from)),wordPattern:oe.wordPattern}}}class m{constructor(U,Q){this._documents=U,this._provider=Q}async provideReferences(U,Q,te,ae){const G=this._documents.getDocument(U),oe=E.Position.to(Q),he=await this._provider.provideReferences(G,oe,te,ae);if(Array.isArray(he))return he.map(E.location.from)}}class k{constructor(U,Q,te,ae,G,oe,he){this._documents=U,this._commands=Q,this._diagnostics=te,this._provider=ae,this._logService=G,this._extension=oe,this._apiDeprecation=he,this._cache=new c.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,Q,te,ae){const G=this._documents.getDocument(U),oe=y.Selection.isISelection(Q)?E.Selection.to(Q):E.Range.to(Q),he=[];for(const ot of this._diagnostics.getDiagnostics(U))if(oe.intersection(ot.range)&&he.push(ot)>k._maxCodeActionsPerFile)break;const Te={diagnostics:he,only:te.only?new A.CodeActionKind(te.only):void 0,triggerKind:E.CodeActionTriggerKind.to(te.trigger)},Be=await this._provider.provideCodeActions(G,oe,Te,ae);if(!(0,T.isNonEmptyArray)(Be)||ae.isCancellationRequested)return;const He=this._cache.add(Be),Qe=new n.DisposableStore;this._disposables.set(He,Qe);const et=[];for(let ot=0;ot<Be.length;ot++){const ye=Be[ot];!ye||(k._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Qe)})):(Te.only&&(ye.kind?Te.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[He,ot],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Qe),diagnostics:ye.diagnostics&&ye.diagnostics.map(E.Diagnostic.from),edit:ye.edit&&E.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:He,actions:et}}async resolveCodeAction(U,Q){const[te,ae]=U,G=this._cache.get(te,ae);if(!G||k._isCommand(G)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(G,Q)??G;return oe?.edit?E.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}k._maxCodeActionsPerFile=1e3;class R{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentFormattingEdits(U,Q,te){const ae=this._documents.getDocument(U),G=await this._provider.provideDocumentFormattingEdits(ae,Q,te);if(Array.isArray(G))return G.map(E.TextEdit.from)}}class L{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentRangeFormattingEdits(U,Q,te,ae){const G=this._documents.getDocument(U),oe=E.Range.to(Q),he=await this._provider.provideDocumentRangeFormattingEdits(G,oe,te,ae);if(Array.isArray(he))return he.map(E.TextEdit.from)}}class b{constructor(U,Q){this._documents=U,this._provider=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,Q,te,ae,G){const oe=this._documents.getDocument(U),he=E.Position.to(Q),Te=await this._provider.provideOnTypeFormattingEdits(oe,he,te,ae,G);if(Array.isArray(Te))return Te.map(E.TextEdit.from)}}class B{constructor(U,Q){this._provider=U,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(U,Q){const te=F.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(U,Q);if((0,T.isNonEmptyArray)(ae))for(const G of ae){if(!G)continue;if(!G.name){this._logService.warn("INVALID SymbolInformation, lacks name",G);continue}const oe=F.IdObject.mixin(E.WorkspaceSymbol.from(G));this._symbolCache.set(oe._id,G),te.symbols.push(oe)}return te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te}async resolveWorkspaceSymbol(U,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const te=this._symbolCache.get(U._id);if(te){const ae=await this._provider.resolveWorkspaceSymbol(te,Q);return ae&&(0,M.mixin)(U,E.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(U){const Q=this._resultCache.get(U);if(Q){for(let[te,ae]=Q;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(U)}}}class ${constructor(U,Q,te){this._documents=U,this._provider=Q,this._logService=te}static supportsResolving(U){return typeof U.prepareRename=="function"}async provideRenameEdits(U,Q,te,ae){const G=this._documents.getDocument(U),oe=E.Position.to(Q);try{const he=await this._provider.provideRenameEdits(G,oe,te,ae);return he?E.WorkspaceEdit.from(he):void 0}catch(he){const Te=$._asMessage(he);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(U,Q,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(U),G=E.Position.to(Q);try{const oe=await this._provider.prepareRename(ae,G,te);let he,Te;if(A.Range.isRange(oe)?(he=oe,Te=ae.getText(oe)):(0,t.isObject)(oe)&&(he=oe.range,Te=oe.placeholder),!he||!Te)return;if(he.start.line>G.line||he.end.line<G.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(he),text:Te}}catch(oe){const he=$._asMessage(oe);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class x{constructor(U,Q){this.resultId=U,this.tokens=Q}}class K{constructor(U,Q){this._documents=U,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,Q,te){const ae=this._documents.getDocument(U),G=Q!==0?this._previousResults.get(Q):null;let oe=typeof G?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,G.resultId,te):await this._provider.provideDocumentSemanticTokens(ae,te);return G&&this._previousResults.delete(Q),oe?(oe=K._fixProvidedSemanticTokens(oe),this._send(K._convertToEdits(G,oe),oe)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return K._isSemanticTokens(U)?K._isCorrectSemanticTokens(U)?U:new A.SemanticTokens(new Uint32Array(U.data),U.resultId):K._isSemanticTokensEdits(U)?K._isCorrectSemanticTokensEdits(U)?U:new A.SemanticTokensEdits(U.edits.map(Q=>new A.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const Q of U.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,Q){if(!K._isSemanticTokens(Q)||!U||!U.tokens)return Q;const te=U.tokens,ae=te.length,G=Q.data,oe=G.length;let he=0;const Te=Math.min(ae,oe);for(;he<Te&&te[he]===G[he];)he++;if(he===ae&&he===oe)return new A.SemanticTokensEdits([],Q.resultId);let Be=0;const He=Te-he;for(;Be<He&&te[ae-Be-1]===G[oe-Be-1];)Be++;return new A.SemanticTokensEdits([{start:he,deleteCount:ae-he-Be,data:G.subarray(he,oe-Be)}],Q.resultId)}_send(U,Q){if(K._isSemanticTokens(U)){const te=this._nextResultId++;return this._previousResults.set(te,new x(U.resultId,U.data)),(0,f.encodeSemanticTokensDto)({id:te,type:"full",data:U.data})}if(K._isSemanticTokensEdits(U)){const te=this._nextResultId++;return K._isSemanticTokens(Q)?this._previousResults.set(te,new x(Q.resultId,Q.data)):this._previousResults.set(te,new x(U.resultId)),(0,f.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(U.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=K;class H{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentRangeSemanticTokens(U,Q,te){const ae=this._documents.getDocument(U),G=await this._provider.provideDocumentRangeSemanticTokens(ae,E.Range.to(Q),te);return G?this._send(G):null}_send(U){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=H;class W{constructor(U,Q,te,ae,G){this._documents=U,this._commands=Q,this._provider=te,this._apiDeprecation=ae,this._extension=G,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,Q,te,ae){const G=this._documents.getDocument(U),oe=E.Position.to(Q),he=G.getWordRangeAtPosition(oe)||new A.Range(oe,oe),Te=he.with({end:oe}),Be=new p.StopWatch(!0),He=await this._provider.provideCompletionItems(G,oe,ae,E.CompletionContext.to(te));if(!He||ae.isCancellationRequested)return;const Qe=Array.isArray(He)?new A.CompletionList(He):He,et=W.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),ot=new n.DisposableStore;this._disposables.set(et,ot);const ye=[],nt={x:et,b:ye,a:{replace:E.Range.from(he),insert:E.Range.from(Te)},c:Qe.isIncomplete||void 0,d:Be.elapsed()};for(let q=0;q<Qe.items.length;q++){const Z=Qe.items[q],pe=this._convertCompletionItem(Z,[et,q],Te,he);ye.push(pe)}return nt}async resolveCompletionItem(U,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...U);if(!te)return;const ae=await this._provider.resolveCompletionItem(te,Q);if(!!ae)return this._convertCompletionItem(ae,U)}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,Q,te,ae){const G=this._disposables.get(Q[0]);if(!G)throw Error("DisposableStore is missing...");const oe={x:Q,a:U.label,b:U.kind!==void 0?E.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(E.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(U.command,G)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=U.textEdit.newText):typeof U.insertText=="string"?oe.h=U.insertText:U.insertText instanceof A.SnippetString&&(oe.h=U.insertText.value,oe.i|=4);let he;return U.textEdit?he=U.textEdit.range:U.range&&(he=U.range),A.Range.isRange(he)?oe.j=E.Range.from(he):he&&(!te?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(oe.j={insert:E.Range.from(he.inserting),replace:E.Range.from(he.replacing)}),oe}}class ne{constructor(U,Q,te){this._documents=U,this._provider=Q,this._commands=te,this._cache=new c.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(U,Q,te,ae){const G=this._documents.getDocument(U),oe=E.Position.to(Q),he=await this._provider.provideInlineCompletionItems(G,oe,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:E.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:te.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Te=(0,t.isArray)(he)?{items:he}:he,Be=this._cache.add(Te.items);let He;return{pid:Be,items:Te.items.map((Qe,et)=>{let ot;return Qe.command&&(He||(He=new n.DisposableStore,this._disposables.set(Be,He)),ot=this._commands.toInternal(Qe.command,He)),{text:Qe.text,range:Qe.range?E.Range.from(Qe.range):void 0,command:ot,idx:et}})}}disposeCompletions(U){this._cache.delete(U);const Q=this._disposables.get(U);Q&&Q.clear(),this._disposables.delete(U)}handleDidShowCompletionItem(U,Q){const te=this._cache.get(U,Q);te&&V.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class V{constructor(){this._onDidShowCompletionItemEmitter=new D.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(U){let Q=V.map.get(U);return Q||(Q=new V,V.map.set(U,Q)),Q}fireOnDidShowCompletionItem(U){this._onDidShowCompletionItemEmitter.fire(U)}}e.InlineCompletionController=V,V.map=new WeakMap;class J{constructor(U,Q){this._documents=U,this._provider=Q,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(U,Q,te,ae){const G=this._documents.getDocument(U),oe=E.Position.to(Q),he=this.reviveContext(te),Te=await this._provider.provideSignatureHelp(G,oe,ae,he);if(Te){const Be=this._cache.add([Te]);return{...E.SignatureHelp.from(Te),id:Be}}}reviveContext(U){let Q;if(U.activeSignatureHelp){const te=E.SignatureHelp.to(U.activeSignatureHelp),ae=this._cache.get(U.activeSignatureHelp.id,0);ae?(Q=ae,Q.activeSignature=te.activeSignature,Q.activeParameter=te.activeParameter):Q=te}return{...U,activeSignatureHelp:Q}}releaseSignatureHelp(U){this._cache.delete(U)}}class j{constructor(U,Q){this._documents=U,this._provider=Q}async provideInlayHints(U,Q,te){const ae=this._documents.getDocument(U),G=await this._provider.provideInlayHints(ae,E.Range.to(Q),te);return G?{hints:G.map(E.InlayHint.from)}:void 0}}class le{constructor(U,Q){this._documents=U,this._provider=Q,this._cache=new c.Cache("DocumentLink")}async provideLinks(U,Q){const te=this._documents.getDocument(U),ae=await this._provider.provideDocumentLinks(te,Q);if(!(!Array.isArray(ae)||ae.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(E.DocumentLink.from)};{const G=this._cache.add(ae),oe={links:[],id:G};for(let he=0;he<ae.length;he++){if(!le._validateLink(ae[he]))continue;const Te=E.DocumentLink.from(ae[he]);Te.cacheId=[G,he],oe.links.push(Te)}return oe}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...U);if(!te)return;const ae=await this._provider.resolveDocumentLink(te,Q);if(!(!ae||!le._validateLink(ae)))return E.DocumentLink.from(ae)}releaseLinks(U){this._cache.delete(U)}}class ee{constructor(U,Q){this._documents=U,this._provider=Q}async provideColors(U,Q){const te=this._documents.getDocument(U),ae=await this._provider.provideDocumentColors(te,Q);return Array.isArray(ae)?ae.map(oe=>({color:E.Color.from(oe.color),range:E.Range.from(oe.range)})):[]}async provideColorPresentations(U,Q,te){const ae=this._documents.getDocument(U),G=E.Range.to(Q.range),oe=E.Color.to(Q.color),he=await this._provider.provideColorPresentations(oe,{document:ae,range:G},te);if(!!Array.isArray(he))return he.map(E.ColorPresentation.from)}}class ve{constructor(U,Q){this._documents=U,this._provider=Q}async provideFoldingRanges(U,Q,te){const ae=this._documents.getDocument(U),G=await this._provider.provideFoldingRanges(ae,Q,te);if(!!Array.isArray(G))return G.map(E.FoldingRange.from)}}class Re{constructor(U,Q,te){this._documents=U,this._provider=Q,this._logService=te}async provideSelectionRanges(U,Q,te){const ae=this._documents.getDocument(U),G=Q.map(E.Position.to),oe=await this._provider.provideSelectionRanges(ae,G,te);if(!(0,T.isNonEmptyArray)(oe))return[];if(oe.length!==G.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Te=0;Te<G.length;Te++){const Be=[];he.push(Be);let He=G[Te],Qe=oe[Te];for(;;){if(!Qe.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(E.SelectionRange.from(Qe)),!Qe.parent)break;He=Qe.range,Qe=Qe.parent}}return he}}class Fe{constructor(U,Q){this._documents=U,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(U,Q,te){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.prepareCallHierarchy(ae,G,te);if(!oe)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(oe)?oe.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,oe)]}async provideCallsTo(U,Q,te){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!G)return G.map(oe=>({from:this._cacheAndConvertItem(U,oe.from),fromRanges:oe.fromRanges.map(he=>E.Range.from(he))}))}async provideCallsFrom(U,Q,te){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!G)return G.map(oe=>({to:this._cacheAndConvertItem(U,oe.to),fromRanges:oe.fromRanges.map(he=>E.Range.from(he))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,Q){const te=this._cache.get(U),ae=E.CallHierarchyItem.from(Q,U,te.size.toString(36));return te.set(ae._itemId,Q),ae}_itemFromCache(U,Q){return this._cache.get(U)?.get(Q)}}class Oe{constructor(U,Q){this._documents=U,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(U,Q,te){const ae=this._documents.getDocument(U),G=E.Position.to(Q),oe=await this._provider.prepareTypeHierarchy(ae,G,te);if(!oe)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(oe)?oe.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,oe)]}async provideSupertypes(U,Q,te){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySupertypes(ae,te);if(!!G)return G.map(oe=>this._cacheAndConvertItem(U,oe))}async provideSubtypes(U,Q,te){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySubtypes(ae,te);if(!!G)return G.map(oe=>this._cacheAndConvertItem(U,oe))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,Q){const te=this._cache.get(U),ae=E.TypeHierarchyItem.from(Q,U,te.size.toString(36));return te.set(ae._itemId,Q),ae}_itemFromCache(U,Q){return this._cache.get(U)?.get(Q)}}class Ke{constructor(U,Q){this.adapter=U,this.extension=Q}}class je{constructor(U,Q,te,ae,G,oe,he){this._adapter=new Map,this._uriTransformer=Q,this._proxy=U.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=G,this._logService=oe,this._apiDeprecation=he}_transformDocumentSelector(U){return E.DocumentSelector.from(U,this._uriTransformer)}_createDisposable(U){return new A.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return je._handlePool++}_withAdapter(U,Q,te,ae,G=!1){const oe=this._adapter.get(U);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof Q){let he;oe.extension&&(he=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Te=te(oe.adapter,oe.extension),Be=oe.extension;return Be&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-he}ms`),He=>{G&&He instanceof P.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error(He))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,Q){const te=this._nextHandle();return this._adapter.set(te,new Ke(U,Q)),te}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,Q,te,ae){const G=this._addNewAdapter(new l(this._documents,te),U),oe=ae&&ae.label||je._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(G,this._transformDocumentSelector(Q),oe),this._createDisposable(G)}$provideDocumentSymbols(U,Q,te){return this._withAdapter(U,l,ae=>ae.provideDocumentSymbols(h.URI.revive(Q),te),void 0)}registerCodeLensProvider(U,Q,te){const ae=this._nextHandle(),G=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ke(new u(this._documents,this._commands.converter,te),U)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Q),G);let oe=this._createDisposable(ae);if(G!==void 0){const he=te.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(G));oe=A.Disposable.from(oe,he)}return oe}$provideCodeLenses(U,Q,te){return this._withAdapter(U,u,ae=>ae.provideCodeLenses(h.URI.revive(Q),te),void 0)}$resolveCodeLens(U,Q,te){return this._withAdapter(U,u,ae=>ae.resolveCodeLens(Q,te),void 0)}$releaseCodeLenses(U,Q){this._withAdapter(U,u,te=>Promise.resolve(te.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(U,Q,te){const ae=this._addNewAdapter(new i(this._documents,te),U);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDefinition(U,Q,te,ae){return this._withAdapter(U,i,G=>G.provideDefinition(h.URI.revive(Q),te,ae),[])}registerDeclarationProvider(U,Q,te){const ae=this._addNewAdapter(new g(this._documents,te),U);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDeclaration(U,Q,te,ae){return this._withAdapter(U,g,G=>G.provideDeclaration(h.URI.revive(Q),te,ae),[])}registerImplementationProvider(U,Q,te){const ae=this._addNewAdapter(new a(this._documents,te),U);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideImplementation(U,Q,te,ae){return this._withAdapter(U,a,G=>G.provideImplementation(h.URI.revive(Q),te,ae),[])}registerTypeDefinitionProvider(U,Q,te){const ae=this._addNewAdapter(new r(this._documents,te),U);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideTypeDefinition(U,Q,te,ae){return this._withAdapter(U,r,G=>G.provideTypeDefinition(h.URI.revive(Q),te,ae),[])}registerHoverProvider(U,Q,te,ae){const G=this._addNewAdapter(new v(this._documents,te),U);return this._proxy.$registerHoverProvider(G,this._transformDocumentSelector(Q)),this._createDisposable(G)}$provideHover(U,Q,te,ae){return this._withAdapter(U,v,G=>G.provideHover(h.URI.revive(Q),te,ae),void 0)}registerEvaluatableExpressionProvider(U,Q,te,ae){const G=this._addNewAdapter(new o(this._documents,te),U);return this._proxy.$registerEvaluatableExpressionProvider(G,this._transformDocumentSelector(Q)),this._createDisposable(G)}$provideEvaluatableExpression(U,Q,te,ae){return this._withAdapter(U,o,G=>G.provideEvaluatableExpression(h.URI.revive(Q),te,ae),void 0)}registerInlineValuesProvider(U,Q,te,ae){const G=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new d(this._documents,te),U);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(Q),G);let he=this._createDisposable(oe);if(G!==void 0){const Te=te.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(G));he=A.Disposable.from(he,Te)}return he}$provideInlineValues(U,Q,te,ae,G){return this._withAdapter(U,d,oe=>oe.provideInlineValues(h.URI.revive(Q),te,ae,G),void 0)}registerDocumentHighlightProvider(U,Q,te){const ae=this._addNewAdapter(new w(this._documents,te),U);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentHighlights(U,Q,te,ae){return this._withAdapter(U,w,G=>G.provideDocumentHighlights(h.URI.revive(Q),te,ae),void 0)}registerLinkedEditingRangeProvider(U,Q,te){const ae=this._addNewAdapter(new I(this._documents,te),U);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideLinkedEditingRanges(U,Q,te,ae){return this._withAdapter(U,I,async G=>{const oe=await G.provideLinkedEditingRanges(h.URI.revive(Q),te,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?je._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(U,Q,te){const ae=this._addNewAdapter(new m(this._documents,te),U);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideReferences(U,Q,te,ae,G){return this._withAdapter(U,m,oe=>oe.provideReferences(h.URI.revive(Q),te,ae,G),void 0)}registerCodeActionProvider(U,Q,te,ae){const G=new n.DisposableStore,oe=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,te,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(Q),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,G)}))},je._extLabel(U),Boolean(te.resolveCodeAction)),G.add(this._createDisposable(oe)),G}$provideCodeActions(U,Q,te,ae,G){return this._withAdapter(U,k,oe=>oe.provideCodeActions(h.URI.revive(Q),te,ae,G),void 0)}$resolveCodeAction(U,Q,te){return this._withAdapter(U,k,ae=>ae.resolveCodeAction(Q,te),void 0)}$releaseCodeActions(U,Q){this._withAdapter(U,k,te=>Promise.resolve(te.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(U,Q,te){const ae=this._addNewAdapter(new R(this._documents,te),U);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Q),U.identifier,U.displayName||U.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(U,Q,te,ae){return this._withAdapter(U,R,G=>G.provideDocumentFormattingEdits(h.URI.revive(Q),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(U,Q,te){const ae=this._addNewAdapter(new L(this._documents,te),U);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Q),U.identifier,U.displayName||U.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(U,Q,te,ae,G){return this._withAdapter(U,L,oe=>oe.provideDocumentRangeFormattingEdits(h.URI.revive(Q),te,ae,G),void 0)}registerOnTypeFormattingEditProvider(U,Q,te,ae){const G=this._addNewAdapter(new b(this._documents,te),U);return this._proxy.$registerOnTypeFormattingSupport(G,this._transformDocumentSelector(Q),ae,U.identifier),this._createDisposable(G)}$provideOnTypeFormattingEdits(U,Q,te,ae,G,oe){return this._withAdapter(U,b,he=>he.provideOnTypeFormattingEdits(h.URI.revive(Q),te,ae,G,oe),void 0)}registerWorkspaceSymbolProvider(U,Q){const te=this._addNewAdapter(new B(Q,this._logService),U);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(U,Q,te){return this._withAdapter(U,B,ae=>ae.provideWorkspaceSymbols(Q,te),{symbols:[]})}$resolveWorkspaceSymbol(U,Q,te){return this._withAdapter(U,B,ae=>ae.resolveWorkspaceSymbol(Q,te),void 0)}$releaseWorkspaceSymbols(U,Q){this._withAdapter(U,B,te=>te.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(U,Q,te){const ae=this._addNewAdapter(new $(this._documents,te,this._logService),U);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Q),$.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(U,Q,te,ae,G){return this._withAdapter(U,$,oe=>oe.provideRenameEdits(h.URI.revive(Q),te,ae,G),void 0)}$resolveRenameLocation(U,Q,te,ae){return this._withAdapter(U,$,G=>G.resolveRenameLocation(h.URI.revive(Q),te,ae),void 0)}registerDocumentSemanticTokensProvider(U,Q,te,ae){const G=this._nextHandle(),oe=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(G,new Ke(new K(this._documents,te),U)),this._proxy.$registerDocumentSemanticTokensProvider(G,this._transformDocumentSelector(Q),ae,oe);let he=this._createDisposable(G);if(oe){const Te=te.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(oe));he=A.Disposable.from(he,Te)}return he}$provideDocumentSemanticTokens(U,Q,te,ae){return this._withAdapter(U,K,G=>G.provideDocumentSemanticTokens(h.URI.revive(Q),te,ae),null,!0)}$releaseDocumentSemanticTokens(U,Q){this._withAdapter(U,K,te=>te.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(U,Q,te,ae){const G=this._addNewAdapter(new H(this._documents,te),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(G,this._transformDocumentSelector(Q),ae),this._createDisposable(G)}$provideDocumentRangeSemanticTokens(U,Q,te,ae){return this._withAdapter(U,H,G=>G.provideDocumentRangeSemanticTokens(h.URI.revive(Q),te,ae),null,!0)}registerCompletionItemProvider(U,Q,te,ae){const G=this._addNewAdapter(new W(this._documents,this._commands.converter,te,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(G,this._transformDocumentSelector(Q),ae,W.supportsResolving(te),`${U.identifier.value}(${ae.join("")})`),this._createDisposable(G)}$provideCompletionItems(U,Q,te,ae,G){return this._withAdapter(U,W,oe=>oe.provideCompletionItems(h.URI.revive(Q),te,ae,G),void 0)}$resolveCompletionItem(U,Q,te){return this._withAdapter(U,W,ae=>ae.resolveCompletionItem(Q,te),void 0)}$releaseCompletionItems(U,Q){this._withAdapter(U,W,te=>te.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(U,Q,te){const ae=this._addNewAdapter(new ne(this._documents,te,this._commands.converter),U);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideInlineCompletions(U,Q,te,ae,G){return this._withAdapter(U,ne,oe=>oe.provideInlineCompletions(h.URI.revive(Q),te,ae,G),void 0)}$handleInlineCompletionDidShow(U,Q,te){this._withAdapter(U,ne,async ae=>{ae.handleDidShowCompletionItem(Q,te)},void 0)}$freeInlineCompletionsList(U,Q){this._withAdapter(U,ne,async te=>{te.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider(U,Q,te,ae){const G=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new J(this._documents,te),U);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(Q),G),this._createDisposable(oe)}$provideSignatureHelp(U,Q,te,ae,G){return this._withAdapter(U,J,oe=>oe.provideSignatureHelp(h.URI.revive(Q),te,ae,G),void 0)}$releaseSignatureHelp(U,Q){this._withAdapter(U,J,te=>te.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(U,Q,te){const ae=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,G=this._addNewAdapter(new j(this._documents,te),U);this._proxy.$registerInlayHintsProvider(G,this._transformDocumentSelector(Q),ae);let oe=this._createDisposable(G);if(ae!==void 0){const he=te.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(ae));oe=A.Disposable.from(oe,he)}return oe}$provideInlayHints(U,Q,te,ae){return this._withAdapter(U,j,G=>G.provideInlayHints(h.URI.revive(Q),te,ae),void 0)}registerDocumentLinkProvider(U,Q,te){const ae=this._addNewAdapter(new le(this._documents,te),U);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Q),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(U,Q,te){return this._withAdapter(U,le,ae=>ae.provideLinks(h.URI.revive(Q),te),void 0)}$resolveDocumentLink(U,Q,te){return this._withAdapter(U,le,ae=>ae.resolveLink(Q,te),void 0)}$releaseDocumentLinks(U,Q){this._withAdapter(U,le,te=>te.releaseLinks(Q),void 0)}registerColorProvider(U,Q,te){const ae=this._addNewAdapter(new ee(this._documents,te),U);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentColors(U,Q,te){return this._withAdapter(U,ee,ae=>ae.provideColors(h.URI.revive(Q),te),[])}$provideColorPresentations(U,Q,te,ae){return this._withAdapter(U,ee,G=>G.provideColorPresentations(h.URI.revive(Q),te,ae),void 0)}registerFoldingRangeProvider(U,Q,te){const ae=this._nextHandle(),G=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ke(new ve(this._documents,te),U)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Q),G);let oe=this._createDisposable(ae);if(G!==void 0){const he=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(G));oe=A.Disposable.from(oe,he)}return oe}$provideFoldingRanges(U,Q,te,ae){return this._withAdapter(U,ve,G=>G.provideFoldingRanges(h.URI.revive(Q),te,ae),void 0)}registerSelectionRangeProvider(U,Q,te){const ae=this._addNewAdapter(new Re(this._documents,te,this._logService),U);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideSelectionRanges(U,Q,te,ae){return this._withAdapter(U,Re,G=>G.provideSelectionRanges(h.URI.revive(Q),te,ae),[])}registerCallHierarchyProvider(U,Q,te){const ae=this._addNewAdapter(new Fe(this._documents,te),U);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareCallHierarchy(U,Q,te,ae){return this._withAdapter(U,Fe,G=>Promise.resolve(G.prepareSession(h.URI.revive(Q),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(U,Q,te,ae){return this._withAdapter(U,Fe,G=>G.provideCallsTo(Q,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(U,Q,te,ae){return this._withAdapter(U,Fe,G=>G.provideCallsFrom(Q,te,ae),void 0)}$releaseCallHierarchy(U,Q){this._withAdapter(U,Fe,te=>Promise.resolve(te.releaseSession(Q)),void 0)}registerTypeHierarchyProvider(U,Q,te){const ae=this._addNewAdapter(new Oe(this._documents,te),U);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareTypeHierarchy(U,Q,te,ae){return this._withAdapter(U,Oe,G=>Promise.resolve(G.prepareSession(h.URI.revive(Q),te,ae)),void 0)}$provideTypeHierarchySupertypes(U,Q,te,ae){return this._withAdapter(U,Oe,G=>G.provideSupertypes(Q,te,ae),void 0)}$provideTypeHierarchySubtypes(U,Q,te,ae){return this._withAdapter(U,Oe,G=>G.provideSubtypes(Q,te,ae),void 0)}$releaseTypeHierarchy(U,Q){this._withAdapter(U,Oe,te=>Promise.resolve(te.releaseSession(Q)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,C.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:je._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:je._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?je._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?je._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:je._serializeRegExp(U.beforeText),afterText:U.afterText?je._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?je._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(je._serializeOnEnterRule)}setLanguageConfiguration(U,Q,te){let{wordPattern:ae}=te;if(ae&&(0,C.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Q,ae):this._documents.setWordDefinitionFor(Q,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const G=this._nextHandle(),oe={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?je._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?je._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?je._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(G,Q,oe),this._createDisposable(G)}$setWordDefinitions(U){for(const Q of U)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=je,je._handlePool=0}),define(be[195],Ee([0,1,5,8,7,35,12,6]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(t,y,n,f){this._documents=y,this._commands=n,this._uriTransformer=f,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(h.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,y){await this._proxy.$changeLanguage(t,y);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,y){const n=t.version,f=M.Position.from(y),s=await this._proxy.$tokensAtPosition(t.uri,f),c={type:E.StandardTokenType.Other,range:t.getWordRangeAtPosition(y)??new E.Range(y.line,y.character,y.line,y.character)};if(!s)return c;const p={range:M.Range.to(s.range),type:M.TokenType.to(s.type)};return!p.range.contains(y)||n!==t.version?c:p}createLanguageStatusItem(t,y,n){const f=this._handlePool++,s=this._proxy,c=this._ids,p=`${t.identifier.value}/${y}`;if(c.has(p))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);c.add(p);const P={selector:n,id:y,name:t.displayName??t.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let D,l=new C.DisposableStore;const u=()=>{D?.dispose(),D=(0,F.disposableTimeout)(()=>{l.clear(),this._proxy.$setLanguageStatus(f,{id:p,name:P.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(P.selector,this._uriTransformer),label:P.text,detail:P.detail??"",severity:P.severity===E.LanguageStatusSeverity.Error?A.default.Error:P.severity===E.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:P.command&&this._commands.toInternal(P.command,l),accessibilityInfo:P.accessibilityInformation})},0)},_={dispose(){l.dispose(),D?.dispose(),s.$removeLanguageStatus(f),c.delete(p)},get id(){return P.id},get name(){return P.name},set name(i){P.name=i,u()},get selector(){return P.selector},set selector(i){P.selector=i,u()},get text(){return P.text},set text(i){P.text=i,u()},get detail(){return P.detail},set detail(i){P.detail=i,u()},get severity(){return P.severity},set severity(i){P.severity=i,u()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(i){P.accessibilityInformation=i,u()},get command(){return P.command},set command(i){P.command=i,u()}};return u(),_}}e.ExtHostLanguages=S}),define(be[196],Ee([0,1,5,15,30]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(C){return C&&C.title}let F=class{constructor(S,T){this._logService=T,this._proxy=S.getProxy(h.MainContext.MainThreadMessageService)}showMessage(S,T,t,y,n){const f={extension:S};let s;typeof y=="string"||A(y)?s=[y,...n]:(f.modal=y?.modal,f.useCustom=y?.useCustom,f.detail=y?.detail,s=n),f.useCustom&&(0,E.checkProposedApiEnabled)(S);const c=[];for(let p=0;p<s.length;p++){const P=s[p];if(typeof P=="string")c.push({title:P,handle:p,isCloseAffordance:!1});else if(typeof P=="object"){let{title:D,isCloseAffordance:l}=P;c.push({title:D,isCloseAffordance:!!l,handle:p})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(T,t,f,c).then(p=>{if(typeof p=="number")return s[p]})}};F=$e([ze(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(be[197],Ee([0,1,22,3,58,6,20,9,10,2,64,5,8,7,38,172,93]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(l,u,_,i,g){this._textDocumentsAndEditors=_,this._textDocuments=i,this._extensionStoragePaths=g,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const r=a.notebookEditor?.notebookUri,v=a.cell.handle,d=this._documents.get(r)?.getCell(v);if(d)return d.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const u=this._editors.get(l);if(!u)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(l){for(const[u,_]of this._editors)if(_.apiEditor===l)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,u){const _=this._documents.get(l);if(!_&&!u)throw new Error(`NO notebook document for '${l}'`);return _}_getProviderData(l){const u=this._notebookContentProviders.get(l);if(!u)throw new Error(`NO provider for '${l}'`);return u}registerNotebookContentProvider(l,u,_,i,g){if((0,C.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:l,provider:_});let a;return _.onDidChangeNotebookContentOptions&&(a=_.onDidChangeNotebookContentOptions(()=>{const r=n.NotebookDocumentContentOptions.from(_.options);this._notebookProxy.$updateNotebookProviderOptions(u,r)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},u,n.NotebookDocumentContentOptions.from(i),P._convertNotebookRegistrationData(l,g)),new f.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(l,u){if(!u)return;const _=u.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(u.filenamePattern&&!_){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:u.displayName,filenamePattern:_,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,u,_){const i=P._notebookStatusBarItemProviderHandlePool++,g=typeof _.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,_),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,g,u);let a;return g!==void 0&&(a=_.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(g))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,g),a&&a.dispose()})}async createNotebookDocument(l){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&n.NotebookData.from(l.content)});return T.URI.revive(u)}async openNotebookDocument(l){const u=this._documents.get(l);if(u)return u.apiNotebook;const _=await this._notebookDocumentsProxy.$tryOpenNotebook(l),i=this._documents.get(T.URI.revive(_));return(0,S.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(l,u){T.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let _;typeof u=="object"?_={position:n.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(n.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:_={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,_),g=i&&this._editors.get(i)?.apiEditor;if(g)return g;throw i?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,u,_,i){const g=this._notebookStatusBarItemProviders.get(l),a=T.URI.revive(u),r=this._documents.get(a);if(!r||!g)return;const v=r.getCellFromIndex(_);if(!v)return;const o=await g.provideCellStatusBarItems(v.apiCell,i);if(!o)return;const d=new A.DisposableStore,w=this._statusBarCache.add([d]),m=(Array.isArray(o)?o:[o]).map(k=>n.NotebookStatusBarItem.from(k,this._commandsConverter,d));return{cacheId:w,items:m}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,u,_,i,g){if((0,C.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,_),this._notebookProxy.$registerNotebookSerializer(a,{id:l.identifier,location:l.extensionLocation},u,n.NotebookDocumentContentOptions.from(i),P._convertNotebookRegistrationData(l,g)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(l,u,_){const i=this._notebookSerializer.get(l);if(!i)throw new Error("NO serializer found");const g=await i.deserializeNotebook(u.buffer,_);return new s.SerializableObjectWithBuffers(n.NotebookData.from(g))}async $notebookToData(l,u,_){const i=this._notebookSerializer.get(l);if(!i)throw new Error("NO serializer found");const g=await i.serializeNotebook(n.NotebookData.to(u.value),_);return h.VSBuffer.wrap(g)}async $openNotebook(l,u,_,i,g){const{provider:a}=this._getProviderData(l),r=await a.openNotebook(T.URI.revive(u),{backupId:_,untitledDocumentData:i?.buffer},g);return new s.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(n.NotebookCellData.from)})}async $saveNotebook(l,u,_){const i=this.getNotebookDocument(T.URI.revive(u)),{provider:g}=this._getProviderData(l);return await g.saveNotebook(i.apiNotebook,_),!0}async $saveNotebookAs(l,u,_,i){const g=this.getNotebookDocument(T.URI.revive(u)),{provider:a}=this._getProviderData(l);return await a.saveNotebookAs(T.URI.revive(_),g.apiNotebook,i),!0}async $backupNotebook(l,u,_){const i=this.getNotebookDocument(T.URI.revive(u)),g=this._getProviderData(l),a=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension),r=String((0,E.hash)([i.uri.toString(),this._backupIdPool++])),v=T.URI.joinPath(a,r),o=await g.provider.backupNotebook(i.apiNotebook,{destination:v},_);return i.updateBackup(o),o.id}_createExtHostEditor(l,u,_){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const i=new p.ExtHostNotebookEditor(u,this._notebookEditorsProxy,l,_.visibleRanges.map(n.NotebookRange.to),_.selections.map(n.NotebookRange.to),typeof _.viewColumn=="number"?n.ViewColumn.to(_.viewColumn):void 0);this._editors.set(u,i)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const _ of l.value.removedDocuments){const i=T.URI.revive(_),g=this._documents.get(i);g&&(g.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(g.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===i.toString()&&this._editors.delete(a.id)}if(l.value.addedDocuments){const _=[];for(const i of l.value.addedDocuments){const g=T.URI.revive(i.uri);if(this._documents.has(g))throw new Error(`adding EXISTING notebook ${g} `);const a=this,r=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(v){a._onDidChangeNotebookCells.fire(v)},emitCellOutputsChange(v){a._onDidChangeCellOutputs.fire(v)},emitCellMetadataChange(v){a._onDidChangeCellMetadata.fire(v)},emitCellExecutionStateChange(v){a._onDidChangeCellExecutionState.fire(v)}},g,i);_.push(...i.cells.map(v=>c.ExtHostCell.asModelAddData(r.apiNotebook,v))),this._documents.get(g)?.dispose(),this._documents.set(g,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:_}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(l.value.addedEditors)for(const _ of l.value.addedEditors){if(this._editors.has(_.id))return;const i=T.URI.revive(_.documentUri),g=this._documents.get(i);g&&this._createExtHostEditor(g,_.id,_)}const u=[];if(l.value.removedEditors)for(const _ of l.value.removedEditors){const i=this._editors.get(_);i&&(this._editors.delete(_),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),u.push(i))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const _=new Set;this._visibleNotebookEditors.forEach(i=>_.add(i.id));for(const i of this._editors.values()){const g=_.has(i.id);i._acceptVisibility(g)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(be[198],Ee([0,1,3,54,15,5,13,8]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(y,n){const f=S._Keys.nextId();y.$registerNotebookEditorDecorationType(f,C.NotebookDecorationRenderOptions.from(n)),this.value={key:f,dispose(){y.$removeNotebookEditorDecorationType(f)}}}}S._Keys=new M.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(y,n,f){this._logService=y,this._extHostRpc=n,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new S(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,n);const f=this._notebooksAndEditors.getEditorById(y);n.visibleRanges&&f._acceptVisibleRanges(n.visibleRanges.ranges.map(C.NotebookRange.to)),n.selections&&f._acceptSelections(n.selections.selections.map(C.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const n in y)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(C.ViewColumn.to(y[n]))}};T=$e([ze(0,E.ILogService),ze(1,F.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(be[199],Ee([0,1,14,12,21,3,6,20,2,26,15,5,39,8,7,67,165,30,38]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let l=class{constructor(a,r,v,o,d){this._initData=r,this._extHostNotebook=v,this._commands=o,this._logService=d,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=a.getProxy(y.MainContext.MainThreadNotebookKernels);const w=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",I=>!0,I=>{if(I&&"notebookEditor"in I&&"id"in I){const m=this._extHostNotebook.getIdByEditor(I.notebookEditor);return{id:I.id,extension:I.extension,notebookEditorId:m}}else if(I&&"notebookEditor"in I){const m=this._extHostNotebook.getIdByEditor(I.notebookEditor);if(m===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${I.notebookEditor.document.uri.toString()}`);return{notebookEditorId:m}}return I})],n.ApiCommandResult.Void);this._commands.registerApiCommand(w)}createNotebookController(a,r,v,o,d,w){for(let J of this._kernelData.values())if(J.controller.id===r&&T.ExtensionIdentifier.equals(a.identifier,J.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const I=this._handlePool++,m=this;this._logService.trace(`NotebookController[${I}], CREATED by ${a.identifier.value}, ${r}`);const k=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${a.identifier}'`);let R=!1;const L=new F.DisposableStore,b=new A.Emitter,B=new A.Emitter,$={id:`${a.identifier.value}/${r}`,notebookType:v,extensionId:a.identifier,extensionLocation:a.extensionLocation,label:o||a.identifier.value,preloads:w?w.map(f.NotebookRendererScript.from):[]};let x=d??k,K;this._proxy.$addKernel(I,$).catch(J=>{console.log(J),R=!0});let H=0;const W=()=>{if(R)return;const J=++H;Promise.resolve().then(()=>{J===H&&this._proxy.$updateKernel(I,$)})},ne=new C.ResourceMap,V={get id(){return r},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:b.event,get label(){return $.label},set label(J){$.label=J??a.displayName??a.name,W()},get detail(){return $.detail??""},set detail(J){$.detail=J,W()},get description(){return $.description??""},set description(J){$.description=J,W()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(J){$.supportedLanguages=J,W()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(J){$.supportsExecutionOrder=J,W()},get rendererScripts(){return $.preloads?$.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(J){x=J??k},get interruptHandler(){return K},set interruptHandler(J){K=J,$.supportsInterrupt=Boolean(J),W()},createNotebookCellExecution(J){if(R)throw new Error("notebook controller is DISPOSED");if(!ne.has(J.notebook.uri))throw m._logService.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${J.notebook.uri.toString()}`);return m._createNotebookCellExecution(J)},dispose:()=>{R||(this._logService.trace(`NotebookController[${I}], DISPOSED`),R=!0,this._kernelData.delete(I),L.dispose(),b.dispose(),B.dispose(),this._proxy.$removeKernel(I))},updateNotebookAffinity(J,j){m._proxy.$updateNotebookPriority(I,J.uri,j)},onDidReceiveMessage:B.event,postMessage(J,j){return(0,P.checkProposedApiEnabled)(a),m._proxy.$postMessage(I,j&&m._extHostNotebook.getIdByEditor(j),J)},asWebviewUri(J){return(0,P.checkProposedApiEnabled)(a),(0,c.asWebviewUri)(J,m._initData.remote)}};return this._kernelData.set(I,{extensionId:a.identifier,controller:V,onDidReceiveMessage:B,onDidChangeSelection:b,associatedNotebooks:ne}),V}$acceptNotebookAssociation(a,r,v){const o=this._kernelData.get(a);if(o){const d=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));v?o.associatedNotebooks.set(d.uri,!0):o.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${a}] ASSOCIATE notebook`,d.uri.toString(),v),o.onDidChangeSelection.fire({selected:v,notebook:d.apiNotebook})}}async $executeCells(a,r,v){const o=this._kernelData.get(a);if(!o)return;const d=this._extHostNotebook.getNotebookDocument(S.URI.revive(r)),w=[];for(let I of v){const m=d.getCell(I);m&&w.push(m.apiCell)}try{this._logService.trace(`NotebookController[${a}] EXECUTE cells`,d.uri.toString(),w.length),await o.controller.executeHandler.call(o.controller,w,d.apiNotebook,o.controller)}catch(I){this._logService.error(`NotebookController[${a}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(a,r,v){const o=this._kernelData.get(a);if(!o)return;const d=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,d.apiNotebook);else for(let w of v){const I=d.getCell(w);I&&this._activeExecutions.get(I.uri)?.cancel()}}$acceptKernelMessageFromRenderer(a,r,v){const o=this._kernelData.get(a);if(!o)return;const d=this._extHostNotebook.getEditorById(r);o.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:v}))}_createNotebookCellExecution(a){if(a.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this._extHostNotebook.getNotebookDocument(a.notebook.uri).getCellFromApiCell(a);if(!v)throw new Error("invalid cell");if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const o=new _(v.notebook,v,this._proxy);this._activeExecutions.set(v.uri,o);const d=o.onDidChangeState(()=>{o.state===u.Resolved&&(o.dispose(),d.dispose(),this._activeExecutions.delete(v.uri))});return o.asApiObject()}};l=$e([ze(4,t.ILogService)],l),e.ExtHostNotebookKernels=l;var u;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(u||(u={}));class _ extends F.Disposable{constructor(a,r,v){super();this._document=a,this._cell=r,this._proxy=v,this._handle=_.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new i(10,o=>this.update(o)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(a){await this._collector.addItem(a)}async update(a){const r=Array.isArray(a)?a:[a];return this._proxy.$updateExecutions(new D.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===u.Init)throw new Error("Must call start before modifying cell output");if(this._state===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(a){let r=this._cell;if(a&&(r=this._document.getCellFromApiCell(a)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(a){return a.map(r=>{const v=s.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return v===r.items?f.NotebookCellOutput.from(r):f.NotebookCellOutput.from({items:v,id:r.id,metadata:r.metadata})})}async updateOutputs(a,r,v){const o=this.cellIndexToHandle(r),d=this.validateAndConvertOutputs((0,h.asArray)(a));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:o,append:v,outputs:d})}async updateOutputItems(a,r,v){return a=s.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(a),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:a.map(f.NotebookCellOutputItem.from),outputId:r.id,append:v})}asApiObject(){const a=this;return Object.freeze({get token(){return a._tokenSource.token},get cell(){return a._cell.apiCell},get executionOrder(){return a._executionOrder},set executionOrder(v){a._executionOrder=v,a.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,executionOrder:a._executionOrder}])},start(v){if(a._state===u.Resolved||a._state===u.Started)throw new Error("Cannot call start again");a._state=u.Started,a._onDidChangeState.fire(),a.update({editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,runStartTime:v})},end(v,o){if(a._state===u.Resolved)throw new Error("Cannot call resolve twice");a._state=u.Resolved,a._onDidChangeState.fire(),a.updateSoon({editType:p.CellExecutionUpdateType.Complete,executionHandle:a._handle,runEndTime:o,lastRunSuccess:v}),a._collector.flush(),a._proxy.$removeExecution(a._handle)},clearOutput(v){return a.verifyStateForOutput(),a.updateOutputs([],v,!1)},appendOutput(v,o){return a.verifyStateForOutput(),a.updateOutputs(v,o,!0)},replaceOutput(v,o){return a.verifyStateForOutput(),a.updateOutputs(v,o,!1)},appendOutputItems(v,o){return a.verifyStateForOutput(),a.updateOutputItems(v,o,!0)},replaceOutputItems(v,o){return a.verifyStateForOutput(),a.updateOutputItems(v,o,!1)}})}}_.HANDLE=0;class i{constructor(a,r){this.delay=a,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(a){return this.batch.push(a),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const a=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>a.complete())}}}),define(be[200],Ee([0,1,3,5,93]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(C,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,S,T){const t=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(S)?.fire({editor:t.apiEditor,message:T})}createRendererMessaging(C,S){if(!C.contributes?.notebookRenderer?.some(n=>n.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const T=!!C.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,f,s)=>{const c=T?n:p=>{const P={};t.set(P,p.editor),n({editor:P,message:p.message})};return this.getOrCreateEmitterFor(S).event(c,f,s)},postMessage:(n,f)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,f]=[f,n]);const s=T?f:t.get(f),c=s&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(s);return this.proxy.$postMessage(c?.id,S,n)}}}getOrCreateEmitterFor(C){let S=this._rendererMessageEmitters.get(C);return S||(S=new h.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,S),S)}}e.ExtHostNotebookRenderers=A}),define(be[96],Ee([0,1,5,3,6,22,4,13]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends E.Disposable{constructor(s,c,p,P,D){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=D,this._id=D.$register(this.name,c,p,P),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?A.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(c=>this._proxy.$clear(c,s))}show(s,c){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof s=="boolean"?s:c)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class T extends S{constructor(s,c,p){super(s,!1,void 0,c,p)}append(s){super.append(s),this._id.then(c=>this._proxy.$append(c,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class t extends S{constructor(s,c,p){super(s,!0,c,void 0,p)}append(s){throw new Error("Not supported")}}class y{constructor(s,c){this.name=s,this._channel=c}append(s){this._channel.then(c=>c.append(s))}appendLine(s){this._channel.then(c=>c.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,c){this._channel.then(p=>p.show(s,c))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=y;let n=class{constructor(s){this._proxy=s.getProxy(h.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s,c){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new T(s,c.identifier.value,this._proxy)}createOutputChannelFromLogFile(s,c){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!c)throw new Error("illegal argument `file`. must not be falsy");return new t(s,c,this._proxy)}};n=$e([ze(0,C.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(be[201],Ee([0,1,12,21,3,6,5,2,7,16,14,35,47]),function(se,e,h,M,E,A,F,C,S,T,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(s,c,p){const P=s.getProxy(F.MainContext.MainThreadQuickOpen);class D{constructor(o,d){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=d}showQuickPick(o,d,w,I=M.CancellationToken.None){this._onDidSelectItem=void 0;const m=Promise.resolve(o),k=++this._instances,R=P.$show(k,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},I),L={},b=R.then(()=>L);return Promise.race([b,m]).then(B=>{if(B!==L)return m.then($=>{const x=[];for(let K=0;K<$.length;K++){const H=$[K];let W,ne,V,J,j;typeof H=="string"?W=H:(W=H.label,ne=H.description,V=H.detail,J=H.picked,j=H.alwaysShow),x.push({label:W,description:ne,handle:K,detail:V,picked:J,alwaysShow:j})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{w.onDidSelectItem($[K])}),P.$setItems(k,x),R.then(K=>{if(typeof K=="number")return $[K];if(Array.isArray(K))return K.map(H=>$[H])})})}).then(void 0,B=>{if(!(0,T.isPromiseCanceledError)(B))return P.$setError(k,B),Promise.reject(B)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,d=M.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,P.$input(o,typeof this._validateInput=="function",d).then(void 0,w=>{if(!(0,T.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(o){return this._validateInput?(0,h.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,d=M.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!w)return;const I=await this._workspace.getWorkspaceFolders2();if(!!I)return I.find(m=>m.uri.toString()===w.uri.toString())}createQuickPick(o,d){const w=new a(o,d,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(o){const d=new r(o,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(o,d){const w=this._sessions.get(o);w&&w._fireDidChangeValue(d)}$onDidAccept(o){const d=this._sessions.get(o);d&&d._fireDidAccept()}$onDidChangeActive(o,d){const w=this._sessions.get(o);w instanceof a&&w._fireDidChangeActive(d)}$onDidChangeSelection(o,d){const w=this._sessions.get(o);w instanceof a&&w._fireDidChangeSelection(d)}$onDidTriggerButton(o,d){const w=this._sessions.get(o);w&&w._fireDidTriggerButton(d)}$onDidTriggerItemButton(o,d,w){const I=this._sessions.get(o);I instanceof a&&I._fireDidTriggerItemButton(d,w)}$onDidHide(o){const d=this._sessions.get(o);d&&d._fireDidHide()}}class l{constructor(o,d){this._extensionId=o,this._onDidDispose=d,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((d,w)=>{const I=d===S.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(I,d)}),this.update({buttons:o.map((d,w)=>({...g(d),tooltip:d.tooltip,handle:d===S.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const d=this._handlesToButtons.get(o);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),P.$dispose(this._id))}update(o){if(!this._disposed){for(const d of Object.keys(o)){const w=o[d];this._pendingUpdate[d]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){P.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}l._nextId=1;function u(v){if(v instanceof S.ThemeIcon)return{id:v.id};const o=i(v),d=_(v);return{dark:typeof o=="string"?C.URI.file(o):o,light:typeof d=="string"?C.URI.file(d):d}}function _(v){return typeof v=="object"&&"light"in v?v.light:v}function i(v){return typeof v=="object"&&"dark"in v?v.dark:v}function g(v){const o=u(v.iconPath);let d,w;return"id"in o?w=n.ThemeIcon.asClassName(o):d=o,{iconPath:d,iconClass:w}}class a extends l{constructor(o,d,w){super(o,w);this.enableProposedApi=d,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((d,w)=>{this._handlesToItems.set(w,d),this._itemsToHandles.set(d,w)}),this.update({items:o.map((d,w)=>({label:d.label,description:d.description,handle:w,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons&&this.enableProposedApi?d.buttons.map((I,m)=>({...g(I),tooltip:I.tooltip,handle:m})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(o){const d=(0,t.coalesce)(o.map(w=>this._handlesToItems.get(w)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(o){const d=(0,t.coalesce)(o.map(w=>this._handlesToItems.get(w)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(o,d){const w=this._handlesToItems.get(o);if(!w||!w.buttons||!w.buttons.length)return;const I=w.buttons[d];I&&this._onDidTriggerItemButtonEmitter.fire({button:I,item:w})}}class r extends l{constructor(o,d){super(o,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?y.default.Error:y.default.Ignore})}}return new D(c,p)}e.createExtHostQuickOpen=f}),define(be[202],Ee([0,1,2,3,53,6,12,5,14,108,15,26,30,47,8]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function c(o){if(o)return typeof o.iconPath=="string"?h.URI.file(o.iconPath):h.URI.isUri(o.iconPath)||f.ThemeIcon.isThemeIcon(o.iconPath)?o.iconPath:void 0}function p(o,d){if(!o.iconPath&&!d.iconPath)return 0;if(o.iconPath){if(!d.iconPath)return 1}else return-1;const w=typeof o.iconPath=="string"?o.iconPath:h.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id,I=typeof d.iconPath=="string"?d.iconPath:h.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,T.comparePaths)(w,I)}function P(o,d){let w=0;if(o.strikeThrough!==d.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==d.faded)return o.faded?1:-1;if(o.tooltip!==d.tooltip)return(o.tooltip||"").localeCompare(d.tooltip||"");if(w=p(o,d),w!==0)return w;if(o.light&&d.light)w=p(o.light,d.light);else{if(o.light)return 1;if(d.light)return-1}if(w!==0)return w;if(o.dark&&d.dark)w=p(o.dark,d.dark);else{if(o.dark)return 1;if(d.dark)return-1}return w}function D(o,d){if(o.command!==d.command)return o.command<d.command?-1:1;if(o.title!==d.title)return o.title<d.title?-1:1;if(o.tooltip!==d.tooltip){if(o.tooltip!==void 0&&d.tooltip!==void 0)return o.tooltip<d.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(o.arguments===d.arguments)return 0;if(o.arguments)if(d.arguments){if(o.arguments.length!==d.arguments.length)return o.arguments.length-d.arguments.length}else return 1;else return-1;for(let w=0;w<o.arguments.length;w++){const I=o.arguments[w],m=d.arguments[w];if(I!==m)return I<m?-1:1}return 0}function l(o,d){let w=(0,T.comparePaths)(o.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(w!==0)return w;if(o.command&&d.command)w=D(o.command,d.command);else{if(o.command)return 1;if(d.command)return-1}if(w!==0)return w;if(o.decorations&&d.decorations)w=P(o.decorations,d.decorations);else{if(o.decorations)return 1;if(d.decorations)return-1}return w}function u(o,d){for(let w=0;w<o.length;w++)if(o[w]!==d[w])return!1;return!0}function _(o,d){return o.command===d.command&&o.title===d.title&&o.tooltip===d.tooltip&&(o.arguments&&d.arguments?u(o.arguments,d.arguments):o.arguments===d.arguments)}function i(o,d){return(0,S.equals)(o,d,_)}class g{constructor(d,w,I){this._extension=d,this._proxy=w,this._sourceControlHandle=I,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,n.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,w){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,w)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=g;class a{constructor(d,w,I,m,k){this._proxy=d,this._commands=w,this._sourceControlHandle=I,this._id=m,this._label=k,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,w){const I=this._resourceStatesCommandsMap.get(d);return I?(0,F.asPromise)(()=>this._commands.executeCommand(I.command,...I.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(l),I=(0,S.sortedDiff)(this._resourceSnapshot,d,l).map(R=>{const L=R.toInsert.map(b=>{const B=this._resourceHandlePool++;this._resourceStatesMap.set(B,b);const $=b.resourceUri;let x;if(b.command)if(b.command.command==="vscode.open"||b.command.command==="vscode.diff"){const ve=new A.DisposableStore;x=this._commands.converter.toInternal(b.command,ve),this._resourceStatesDisposablesMap.set(B,ve)}else this._resourceStatesCommandsMap.set(B,b.command);const K=c(b.decorations),H=b.decorations&&c(b.decorations.light)||K,W=b.decorations&&c(b.decorations.dark)||K,ne=[H,W],V=b.decorations&&b.decorations.tooltip||"",J=b.decorations&&!!b.decorations.strikeThrough,j=b.decorations&&!!b.decorations.faded,le=b.contextValue||"";return{rawResource:[B,$,ne,V,J,j,le,x],handle:B}});return{start:R.start,deleteCount:R.deleteCount,toInsert:L}}),m=I.map(({start:R,deleteCount:L,toInsert:b})=>[R,L,b.map(B=>B.rawResource)]),k=I.reverse();for(const{start:R,deleteCount:L,toInsert:b}of k){const B=b.map(x=>x.handle),$=this._handlesSnapshot.splice(R,L,...B);for(const x of $)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),this._resourceStatesDisposablesMap.get(x)?.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=d,m}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class r{constructor(d,w,I,m,k,R){this._extension=d,this._proxy=w,this._commands=I,this._id=m,this._label=k,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,m,k,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=d;const w=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,n.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(d){(0,n.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=d;const w=d!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&i(this._statusBarCommands,d))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=d;const w=(d||[]).map(I=>this._commands.converter.toInternal(I,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(d,w){const I=new a(this._proxy,this._commands,this.handle,d,w),m=M.Event.once(I.onDidDispose)(()=>this.createdResourceGroups.delete(I));return this.createdResourceGroups.set(I,m),this.eventuallyAddResourceGroups(),I}eventuallyAddResourceGroups(){const d=[],w=[];for(const[I,m]of this.createdResourceGroups){m.dispose();const k=I.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(I),this.eventuallyUpdateResourceStates()});M.Event.once(I.onDidDispose)(()=>{this.updatedResourceGroups.delete(I),k.dispose(),this._groups.delete(I.handle),this._proxy.$unregisterGroup(this.handle,I.handle)}),d.push([I.handle,I.id,I.label,I.features]);const R=I._takeResourceStateSnapshot();R.length>0&&w.push([I.handle,R]),this._groups.set(I.handle,I)}this._proxy.$registerGroups(this.handle,d,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(w=>{const I=w._takeResourceStateSnapshot();I.length!==0&&d.push([w.handle,I])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,$e([(0,E.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),$e([(0,E.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let v=class Bi{constructor(d,w,I){this._commands=w,this.logService=I,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=d.getProxy(C.MainContext.MainThreadSCM),this._telemetry=d.getProxy(C.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===3){const k=this._sourceControls.get(m.sourceControlHandle);if(!k)return m;const R=k.getResourceGroup(m.groupHandle);return R?R.getResourceState(m.handle):m}else if(m&&m.$mid===4){const k=this._sourceControls.get(m.sourceControlHandle);return k?k.getResourceGroup(m.groupHandle):m}else if(m&&m.$mid===5){const k=this._sourceControls.get(m.handle);return k||m}return m}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,w,I,m){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,w,I,m),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const k=Bi._handlePool++,R=new r(d,this._proxy,this._commands,w,I,m);this._sourceControls.set(k,R);const L=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(d.identifier))||[];return L.push(R),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(d.identifier),L),R}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const w=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(d.identifier)),I=w&&w[w.length-1];return I&&I.inputBox}$provideOriginalResource(d,w,I){const m=h.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,m.toString());const k=this._sourceControls.get(d);return!k||!k.quickDiffProvider||!k.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>k.quickDiffProvider.provideOriginalResource(m,I)).then(R=>R||null)}$onInputBoxValueChange(d,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const I=this._sourceControls.get(d);return I&&I.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(d,w,I,m){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,w,I);const k=this._sourceControls.get(d);if(!k)return Promise.resolve(void 0);const R=k.getResourceGroup(w);return R?R.$executeResourceCommand(I,m):Promise.resolve(void 0)}$validateInput(d,w,I){this.logService.trace("ExtHostSCM#$validateInput",d);const m=this._sourceControls.get(d);return!m||!m.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>m.inputBox.validateInput(w,I)).then(k=>{if(!k)return Promise.resolve(void 0);const R=s.MarkdownString.fromStrict(k.message);return R?Promise.resolve([R,k.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};v._handlePool=0,v=$e([ze(2,t.ILogService)],v),e.ExtHostSCM=v});var Ze=this&&this.__classPrivateFieldSet||function(se,e,h,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,h):E?E.value=h:e.set(se,h),h},Ae=this&&this.__classPrivateFieldGet||function(se,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(se):M?M.value:e.get(se)};define(be[203],Ee([0,1,7,5,127,6,8,10]),function(se,e,h,M,E,A,F,C){"use strict";var S,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(s,c,p,P,D=h.StatusBarAlignment.Left,l){S.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Ze(this,S,s,"f"),Ze(this,T,c,"f"),this._entryId=t.ID_GEN++,this._extension=p,this._id=P,this._alignment=D,this._priority=this.validatePriority(l)}validatePriority(s){if(!!(0,C.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!t.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:Ae(this,T,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:Ae(this,T,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let c;this._name?c=this._name:c=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const P=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,S,"f").$setEntry(this._entryId,s,c,this._text,P,this._command?.internal,p,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,S=new WeakMap,T=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const c={message:s};return this._messages.unshift(c),this._update(),new h.Disposable(()=>{const p=this._messages.indexOf(c);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(s,c){this._proxy=s.getProxy(M.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new y(this)}createStatusBarEntry(s,c,p,P){return new t(this._proxy,this._commands,s,c,p,P)}setStatusBarMessage(s,c){const p=this._statusMessage.setMessage(s);let P;return typeof c=="number"?P=setTimeout(()=>p.dispose(),c):typeof c!="undefined"&&c.then(()=>p.dispose(),()=>p.dispose()),new h.Disposable(()=>{p.dispose(),clearTimeout(P)})}}e.ExtHostStatusBar=n}),define(be[73],Ee([0,1,5,3,4]),function(se,e,h,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(C){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,S){this._proxy.$registerExtensionStorageKeysToSync(C,S)}getValue(C,S,T){return this._proxy.$getValue(C,S).then(t=>t||T)}setValue(C,S,T){return this._proxy.$setValue(C,S,T)}$acceptValue(C,S,T){this._onDidChangeStorage.fire({shared:C,key:S,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(be[74],Ee([0,1,4,29,15,72,2]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let C=class{constructor(T,t,y){this._logService=t,this._extHostFileSystem=y,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(T){return F.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,t=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(T){if(this._value)return F.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return F.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=$e([ze(0,M.IExtHostInitDataService),ze(1,E.ILogService),ze(2,A.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(be[40],Ee([0,1,3,5,4,2,13,6,7,128,16,167,21,36,150,47,10,12]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class D{constructor(o,d,w,I){this._proxy=o,this._id=d,this._creationOptions=w,this._name=I,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(k=>this._pidPromiseComplete=k);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},get state(){return m._state},sendText(k,R=!0){m._checkDisposed(),m._proxy.$sendText(m._id,k,R)},show(k){m._checkDisposed(),m._proxy.$show(m._id,k)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(o,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,p.withNullAsUndefined)(o.shellPath),shellArgs:(0,p.withNullAsUndefined)(o.shellArgs),cwd:(0,p.withNullAsUndefined)(o.cwd),env:(0,p.withNullAsUndefined)(o.env),icon:(0,p.withNullAsUndefined)(a(o.iconPath)),color:c.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,p.withNullAsUndefined)(o.message),strictEnv:(0,p.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(o.location,d?.resolvedExtHostIdentifier)})}async createExtensionTerminal(o,d,w,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:w,color:c.ThemeColor.isThemeColor(I)?I.id:void 0,location:this._serializeParentTerminal(o,d)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,d){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in o?{viewColumn:o.viewColumn,preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitCode(o){this._exitStatus=Object.freeze({code:o})}setDimensions(o,d){return o===this._cols&&d===this._rows||o===0||d===0?!1:(this._cols=o,this._rows=d,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=D;class l{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new h.Emitter,this._onProcessTitleChanged=new h.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new h.Emitter,this._onProcessShellTypeChanged=new h.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new h.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(o){return Promise.resolve("")}async updateProperty(o,d){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput&&this._pty.handleInput(o)}resize(o,d){this._pty.setDimensions&&this._pty.setDimensions({columns:o,rows:d})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose&&this._pty.onDidClose((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d&&{cols:d.columns,rows:d.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(d=>this._onProcessTitleChanged.fire(d)),this._pty.open(o||void 0),this._pty.setDimensions&&o&&this._pty.setDimensions(o),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=l;let u=1,_=class extends C.Disposable{constructor(o,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new h.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new h.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new h.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new h.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new h.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[w,I]of this._terminalProcesses)I.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,d){const w=new D(this._proxy,(0,f.generateUuid)(),o,o.name),I=new l(o.pty);return w.createExtensionTerminal(o.location,this._serializeParentTerminal(o,d).resolvedExtHostIdentifier,a(o.iconPath),r(o.color)).then(m=>{const k=this._setupExtHostProcessListeners(m,I);this._terminalProcessDisposables[m]=k}),this._terminals.push(w),w.value}_serializeParentTerminal(o,d){if(d=d||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const w=o.location.parentTerminal;if(w){const I=this._terminals.find(m=>m.value===w);I&&(d.resolvedExtHostIdentifier=I._id)}}else o.location&&typeof o.location!="object"?d.location=o.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(o,d){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const I=new l(d),m=this._setupExtHostProcessListeners(o,I);this._terminalProcessDisposables[o]=m}async $acceptActiveTerminalChanged(o){const d=this._activeTerminal;if(o===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const w=this._getTerminalById(o);w&&(this._activeTerminal=w,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,d){const w=this._getTerminalById(o);w&&this._onDidWriteTerminalData.fire({terminal:w.value,data:d})}async $acceptTerminalDimensions(o,d,w){const I=this._getTerminalById(o);I&&I.setDimensions(d,w)&&this._onDidChangeTerminalDimensions.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptTerminalMaximumDimensions(o,d,w){this._terminalProcesses.get(o)?.resize(d,w)}async $acceptTerminalTitleChange(o,d){const w=this._getTerminalById(o);w&&(w.name=d)}async $acceptTerminalClosed(o,d){const w=this._getTerminalObjectIndexById(this._terminals,o);if(w!==null){const I=this._terminals.splice(w,1)[0];I.setExitCode(d),this._onDidCloseTerminal.fire(I.value)}}$acceptTerminalOpened(o,d,w,I){if(d){const R=this._getTerminalObjectIndexById(this._terminals,d);if(R!==null){this._terminals[R]._id=o,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const m={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:A.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},k=new D(this._proxy,o,m,w);this._terminals.push(k),this._onDidOpenTerminal.fire(k.value),k.isOpen=!0}async $acceptTerminalProcessId(o,d){const w=this._getTerminalById(o);w&&w._setProcessId(d)}async $startExtensionTerminal(o,d){const w=this._getTerminalById(o);if(!w)return{message:(0,T.localize)(0,null,o)};w.isOpen||await new Promise(m=>{const k=this.onDidOpenTerminal(async R=>{R===w.value&&(k.dispose(),m())})});const I=this._terminalProcesses.get(o);I?I.startSendingEvents(d):this._extensionTerminalAwaitingStart[o]={initialDimensions:d}}_setupExtHostProcessListeners(o,d){const w=new C.DisposableStore;w.add(d.onProcessReady(m=>this._proxy.$sendProcessReady(o,m.pid,m.cwd))),w.add(d.onProcessTitleChanged(m=>this._proxy.$sendProcessTitle(o,m))),this._bufferer.startBuffering(o,d.onProcessData),w.add(d.onProcessExit(m=>this._onProcessExit(o,m))),d.onProcessOverrideDimensions&&w.add(d.onProcessOverrideDimensions(m=>this._proxy.$sendOverrideDimensions(o,m))),this._terminalProcesses.set(o,d);const I=this._extensionTerminalAwaitingStart[o];return I&&d instanceof l&&(d.startSendingEvents(I.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),w}$acceptProcessAckDataEvent(o,d){this._terminalProcesses.get(o)?.acknowledgeDataEvent(d)}$acceptProcessInput(o,d){this._terminalProcesses.get(o)?.input(d)}$acceptTerminalInteraction(o){const d=this._getTerminalById(o);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(o,d,w){try{this._terminalProcesses.get(o)?.resize(d,w)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(o,d){this._terminalProcesses.get(o)?.shutdown(d)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(d=>this._proxy.$sendProcessInitialCwd(o,d))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(d=>this._proxy.$sendProcessCwd(o,d))}$acceptProcessRequestLatency(o){return o}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,d,w){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,w),this._proxy.$registerProfileProvider(d,o.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(o,d){const w=new n.CancellationTokenSource().token,I=await this._profileProviders.get(o)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,d);return}this.createTerminalFromOptions(I.options,d)}}async $provideLinks(o,d){const w=this._getTerminalById(o);if(!w)return[];this._terminalLinkCache.delete(o);const I=this._terminalLinkCancellationSource.get(o);I&&I.dispose(!0);const m=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,m);const k=[],R={terminal:w.value,line:d},L=[];for(const $ of this._linkProviders)L.push(P.Promises.withAsyncBody(async x=>{m.token.onCancellationRequested(()=>x({provider:$,links:[]}));const K=await $.provideTerminalLinks(R,m.token)||[];m.token.isCancellationRequested||x({provider:$,links:K})}));const b=await Promise.all(L);if(m.token.isCancellationRequested)return[];const B=new Map;for(const $ of b)$&&$.links.length>0&&k.push(...$.links.map(x=>{const K={id:u++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return B.set(K.id,{provider:$.provider,link:x}),K}));return this._terminalLinkCache.set(o,B),k}$activateLink(o,d){const w=this._terminalLinkCache.get(o)?.get(d);!w||w.provider.handleTerminalLink(w.link)}_onProcessExit(o,d){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const w=this._terminalProcessDisposables[o];w&&(w.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,d)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,d){const w=this._getTerminalObjectIndexById(o,d);return w!==null?o[w]:null}_getTerminalObjectIndexById(o,d){let w=null;return o.some((I,m)=>I._id===d?(w=m,!0):!1),w}getEnvironmentVariableCollection(o){let d=this._environmentVariableCollections.get(o.identifier.value);return d||(d=new i,this._setEnvironmentVariableCollection(o.identifier.value,d)),d}_syncEnvironmentVariableCollection(o,d){const w=(0,y.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(o,d.persistent,w.length===0?void 0:w)}$initEnvironmentVariableCollections(o){o.forEach(d=>{const w=d[0],I=new i(d[1]);this._setEnvironmentVariableCollection(w,I)})}$acceptDefaultProfile(o,d){this._defaultProfile=o,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(o,d){this._environmentVariableCollections.set(o,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,d)})}};_=$e([ze(1,F.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class i{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,d){this._setIfDiffers(o,{value:d,type:S.EnvironmentVariableMutatorType.Replace})}append(o,d){this._setIfDiffers(o,{value:d,type:S.EnvironmentVariableMutatorType.Append})}prepend(o,d){this._setIfDiffers(o,{value:d,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,d){const w=this.map.get(o);(!w||w.value!==d.value||w.type!==d.type)&&(this.map.set(o,d),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,d){this.map.forEach((w,I)=>o.call(d,I,w,this))}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let g=class extends _{constructor(o){super(!1,o)}createTerminal(o,d,w){throw new t.NotSupportedError}createTerminalFromOptions(o,d){throw new t.NotSupportedError}};g=$e([ze(0,F.IExtHostRpcService)],g),e.WorkerExtHostTerminalService=g;function a(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function r(v){return c.ThemeColor.isThemeColor(v)?v:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(se,e,h,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,h):E?E.value=h:e.set(se,h),h},Ae=this&&this.__classPrivateFieldGet||function(se,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(se):M?M.value:e.get(se)};define(be[204],Ee([0,1,14,22,21,3,235,58,6,23,10,36,5,13,49,8,7,175,90,68]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D,l){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let _=class{constructor(R,L){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(n.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new g(this.proxy),L.registerArgumentProcessor({processArgument:b=>b?.$mid===13?c.TestItem.toItemFromContext(b):b})}createTestController(R,L){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const b=new S.DisposableStore,B=b.add(new P.SingleUseTestCollection(R));B.root.label=L;const $=new Map,x=this.proxy,K={items:B.root.children,get label(){return L},set label(W){L=W,B.root.label=W,x.$updateControllerLabel(R,L)},get id(){return R},createRunProfile:(W,ne,V,J,j)=>{let le=(0,C.hash)(W);for(;$.has(le);)le++;const ee=new I(this.proxy,R,le,W,ne,V,J,j);return $.set(le,ee),ee},createTestItem(W,ne,V){return new s.TestItemImpl(R,W,ne,V)},createTestRun:(W,ne,V=!0)=>this.runTracker.createTestRun(R,B,W,ne,V),set resolveHandler(W){B.resolveHandler=W},get resolveHandler(){return B.resolveHandler},dispose:()=>{b.dispose()}};K.createRunConfiguration=K.createRunProfile,x.$registerTestController(R,L),b.add((0,S.toDisposable)(()=>x.$unregisterTestController(R)));const H={controller:K,collection:B,profiles:$};return this.controllers.set(R,H),b.add((0,S.toDisposable)(()=>this.controllers.delete(R))),b.add(B.onDidGenerateDiff(W=>x.$publishDiff(R,W))),K}createTestObserver(){return this.observer.checkout()}async runTests(R,L=E.CancellationToken.None){const b=a(R);if(!b)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(b.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map($=>$.id)??[B.collection.root.id],profileGroup:m[b.kind],profileId:b.profileId,controllerId:b.controllerId}],exclude:R.exclude?.map($=>$.id)},L)}$provideFileCoverage(R,L,b){return(0,h.mapFind)(this.runTracker.trackers,$=>$.id===R?$.getCoverage(L):void 0)?.provideFileCoverage(b)??Promise.resolve([])}$resolveFileCoverage(R,L,b,B){return(0,h.mapFind)(this.runTracker.trackers,x=>x.id===R?x.getCoverage(L):void 0)?.resolveFileCoverage(b,B)??Promise.resolve([])}$configureRunProfile(R,L){this.controllers.get(R)?.profiles.get(L)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(L=>(0,T.deepFreeze)(c.TestResults.to(L))).concat(this.results).sort((L,b)=>b.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,L){const b=this.controllers.get(l.TestId.fromString(R).controllerId)?.collection;b&&(await b.expand(R,L<0?Infinity:L),b.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,L){const b=this.controllers.get(R.controllerId);if(!b)return;const{collection:B,profiles:$}=b,x=$.get(R.profileId);if(!x)return;const K=R.testIds.map(V=>B.tree.get(V)).filter(t.isDefined),H=R.excludeExtIds.map(V=>b.collection.tree.get(V)).filter(t.isDefined).filter(V=>K.some(J=>J.fullId.compare(V.fullId)===2));if(!K.length)return;const W=new p.TestRunRequest(K.some(V=>V.actual instanceof s.TestItemRootImpl)?void 0:K.map(V=>V.actual),H.map(V=>V.actual),x),ne=this.runTracker.prepareForMainThreadTestRun(W,r.fromInternal(R,b.collection),L);try{await x.runHandler(W,L)}finally{ne.isRunning&&!L.isCancellationRequested&&await A.Event.toPromise(ne.onEnd),ne.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};_=$e([ze(0,f.IExtHostRpcService)],_),e.ExtHostTesting=_;class i extends S.Disposable{constructor(R,L,b){super();this.dto=R,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(b)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:B}of this.tasks.values())B.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const L=this.dto.id,b=this.dto.controllerId,B=(0,y.generateUuid)(),$=new v(this.proxy,L,B),x=ne=>(V,...J)=>{if(H){console.warn(`Setting the state of test "${V.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(V)||(this.ensureTestIsKnown(V),ne(V,...J))},K=(ne,V)=>{const J=V instanceof Array?V.map(c.TestMessage.from):[c.TestMessage.from(V)];if(ne.uri&&ne.range){const j={range:c.Range.from(ne.range),uri:ne.uri};for(const le of J)le.location=le.location||j}this.proxy.$appendTestMessagesInRun(L,B,l.TestId.fromExtHostTestItem(ne,b).toString(),J)};let H=!1;const W={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return $.coverageProvider},set coverageProvider(ne){$.coverageProvider=ne},enqueued:x(ne=>{this.proxy.$updateTestStateInRun(L,B,l.TestId.fromExtHostTestItem(ne,b).toString(),1)}),skipped:x(ne=>{this.proxy.$updateTestStateInRun(L,B,l.TestId.fromExtHostTestItem(ne,b).toString(),5)}),started:x(ne=>{this.proxy.$updateTestStateInRun(L,B,l.TestId.fromExtHostTestItem(ne,b).toString(),2)}),errored:x((ne,V,J)=>{K(ne,V),this.proxy.$updateTestStateInRun(L,B,l.TestId.fromExtHostTestItem(ne,b).toString(),6,J)}),failed:x((ne,V,J)=>{K(ne,V),this.proxy.$updateTestStateInRun(L,B,l.TestId.fromExtHostTestItem(ne,b).toString(),4,J)}),passed:x((ne,V)=>{this.proxy.$updateTestStateInRun(L,B,l.TestId.fromExtHostTestItem(ne,this.dto.controllerId).toString(),3,V)}),appendOutput:(ne,V,J)=>{H||(J&&(this.dto.isIncluded(J)?this.ensureTestIsKnown(J):J=void 0),this.proxy.$appendOutputToRun(L,B,M.VSBuffer.fromString(ne),V&&c.location.from(V),J&&l.TestId.fromExtHostTestItem(J,b).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(L,B),this.tasks.delete(B),this.isRunning||this.dispose())}};return this.tasks.set(B,{run:W,coverage:$}),this.proxy.$startedTestRunTask(L,{id:B,name:R,running:!0}),W}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof s.TestItemImpl))throw new s.InvalidTestItemError(R.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const L=[],b=this.dto.colllection.root;for(;;){const B=c.TestItem.from(R);if(L.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),R===b))break;R=R.parent||b}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class g{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,L,b){return this.getTracker(R,L,b)}cancelRunById(R){for(const L of this.tracked.values())if(L.id===R){L.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,L,b,B,$){const x=this.tracked.get(b);if(x)return x.createRun(B);const K=r.fromPublic(R,L,b,$),H=a(b);this.proxy.$startedExtensionTestRun({controllerId:R,profile:H&&{group:m[H.kind],id:H.profileId},exclude:b.exclude?.map(ne=>ne.id)??[],id:K.id,include:b.include?.map(ne=>ne.id)??[L.root.id],persist:$});const W=this.getTracker(b,K);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),W.createRun(B)}getTracker(R,L,b){const B=new i(L,this.proxy,b);return this.tracked.set(R,B),B.onEnd(()=>this.tracked.delete(R)),B}}e.TestRunCoordinator=g;const a=k=>{if(!!k.profile){if(!(k.profile instanceof I))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return k.profile}};class r{constructor(R,L,b,B,$,x){this.controllerId=R,this.id=L,this.isPersisted=$,this.colllection=x,this.includePrefix=b.map(K=>K+"\0"),this.excludePrefix=B.map(K=>K+"\0")}static fromPublic(R,L,b,B){return new r(R,(0,y.generateUuid)(),b.include?.map($=>l.TestId.fromExtHostTestItem($,R).toString())??[R],b.exclude?.map($=>l.TestId.fromExtHostTestItem($,R).toString())??[],B,L)}static fromInternal(R,L){return new r(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,L)}isIncluded(R){const L=l.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const b of this.excludePrefix)if(L===b||L.startsWith(b))return!1;for(const b of this.includePrefix)if(L===b||L.startsWith(b))return!0;return!1}}e.TestRunDto=r;class v{constructor(R,L,b){this.proxy=R,this.runId=L,this.taskId=b}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(R,L){const b=await this.fileCoverage;let B=b?.[R];return!this._coverageProvider||!b||!B?[]:(B.detailedCoverage||(B=b[R]=await this._coverageProvider.resolveFileCoverage?.(B,L)??B),B.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class o extends D.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,c.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:L,removed:b}=this;return{get added(){return[...R].map(B=>B.revived)},get updated(){return[...L].map(B=>B.revived)},get removed(){return[...b].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends D.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,L){return{...R,revived:c.TestItem.toPlain(R.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=d;class w{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(L=>L.revived)},dispose:(0,F.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class I{constructor(R,L,b,B,$,x,K=!1,H=void 0){this.controllerId=L,this.profileId=b,this._label=B,this.kind=$,this.runHandler=x,this._isDefault=K,this._tag=H,u.set(this,void 0),Ze(this,u,R,"f");const W=m[$];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Ae(this,u,"f").$publishTestRunProfile({profileId:b,controllerId:L,tag:H?c.TestTag.namespace(this.controllerId,H.id):null,label:B,group:W,isDefault:K,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Ae(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Ae(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Ae(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?c.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Ae(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Ae(this,u,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=I,u=new WeakMap;const m={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(be[205],Ee([0,1,3,14,5,94,8,7]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(t,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const y=this._extHostDocumentsAndEditors.allEditors();return t?y:y.map(n=>n.value)}async showTextDocument(t,y,n){let f;typeof y=="number"?f={position:F.ViewColumn.from(y),preserveFocus:n}:typeof y=="object"?f={position:F.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?F.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:f={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(t.uri,f),c=s&&this._extHostDocumentsAndEditors.getEditor(s);if(c)return c.value;throw s?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,y){return new A.TextEditorDecorationType(this._proxy,t,y).value}$acceptEditorPropertiesChanged(t,y){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(y.options&&n._acceptOptions(y.options),y.selections){const f=y.selections.selections.map(F.Selection.to);n._acceptSelections(f)}if(y.visibleRanges){const f=M.coalesce(y.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(f)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...y.options,lineNumbers:F.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const f=C.TextEditorSelectionChangeKind.fromValue(y.selections.source),s=y.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:s,kind:f})}if(y.visibleRanges){const f=M.coalesce(y.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:f})}}$acceptEditorPositionData(t){for(const y in t){const n=this._extHostDocumentsAndEditors.getEditor(y);if(!n)throw new Error("Unknown text editor");const f=F.ViewColumn.to(t[y]);n.value.viewColumn!==f&&(n._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:f}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=S}),define(be[206],Ee([0,1,2,4,5,6,7]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class C{constructor(t,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const f=n.uri===void 0?void 0:h.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(S(f))?.get(n.handle)}return n}})}async $getTimeline(t,y,n,f,s){return this._providers.get(t)?.provideTimeline(h.URI.revive(y),n,f,s)}registerTimelineProvider(t,y,n,f){const s=new A.DisposableStore,c=this.convertTimelineItem(y.id,f,s).bind(this);let p;y.onDidChange&&(p=y.onDidChange(D=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...D,id:y.id}),this));const P=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:t,onDidChange:void 0,async provideTimeline(D,l,u,_){_?.resetCache&&(s.clear(),P.get(y.id)?.clear());const i=await y.provideTimeline(D,l,u);if(i==null)return;const g=c(D,_);return{...i,source:y.id,items:i.items.map(g)}},dispose(){for(const D of P.values())D.get(y.id)?.clear();p?.dispose(),s.dispose()}})}convertTimelineItem(t,y,n){return(f,s)=>{let c;if(s?.cacheResults){let p=this._itemsBySourceAndUriMap.get(t);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(t,p));const P=S(f);c=p.get(P),c===void 0&&(c=new Map,p.set(P,c))}return p=>{const{iconPath:P,...D}=p,l=`${t}|${p.id??p.timestamp}`;c?.set(l,p);let u,_,i;return p.iconPath&&(P instanceof F.ThemeIcon?i={id:P.id,color:P.color}:h.URI.isUri(P)?(u=P,_=P):{light:u,dark:_}=P),{...D,id:D.id??void 0,handle:l,source:t,command:p.command?y.toInternal(p.command,n):void 0,icon:u,iconDark:_,themeIcon:i,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=C;function S(T){return T?.toString()}}),define(be[207],Ee([0,1,6,11,2,5]),function(se,e,h,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,T,t,y){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const n=y.schemes.find(f=>!F.supportedSchemes.has(f));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,t),this._proxy.$registerUriOpener(T,y.schemes,S,y.label),(0,h.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(S,T,t){const y=this._openers.get(S);if(!y)throw new Error(`Unknown opener with id: ${S}`);const n=E.URI.revive(T);return y.canOpenExternalUri(n,t)}async $openUri(S,T,t){const y=this._openers.get(S);if(!y)throw new Error(`Unknown opener id: '${S}'`);return y.openExternalUri(E.URI.revive(T.resolvedUri),{sourceUri:E.URI.revive(T.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[208],Ee([0,1,5,2,6,16,26]),function(se,e,h,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(T,t){if(this.handles.has(F.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const y=C.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(T)),this.handlers.set(y,t),this._proxy.$registerUriHandler(y,T),(0,E.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(T)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(T,t){const y=this.handlers.get(T);if(!y)return Promise.resolve(void 0);try{y.handleUri(M.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(T){return M.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=C,C.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(se,e,h,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,h):E?E.value=h:e.set(se,h),h},Ae=this&&this.__classPrivateFieldGet||function(se,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(se):M?M.value:e.get(se)};define(be[51],Ee([0,1,3,11,2,138,158,67,5]),function(se,e,h,M,E,A,F,C,S){"use strict";var T,t,y,n,f,s,c,p,P,D,l,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class _{constructor(w,I,m,k,R,L,b){T.set(this,void 0),t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),f.set(this,void 0),s.set(this,void 0),c.set(this,""),p.set(this,void 0),P.set(this,!1),D.set(this,!1),l.set(this,!1),this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new h.Emitter),this._onDidDispose=Ae(this,u,"f").event,Ze(this,T,w,"f"),Ze(this,t,I,"f"),Ze(this,p,m,"f"),Ze(this,n,k,"f"),Ze(this,f,R,"f"),Ze(this,s,L,"f"),Ze(this,l,i(L),"f"),Ze(this,y,b,"f")}dispose(){Ze(this,P,!0,"f"),Ae(this,u,"f").fire(),Ae(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return Ze(this,D,!0,"f"),(0,C.asWebviewUri)(w,Ae(this,n,"f").remote)}get cspSource(){const w=Ae(this,s,"f").extensionLocation;return w.scheme===M.Schemas.https||w.scheme===M.Schemas.http?w+" "+C.webviewGenericCspSource:C.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,c,"f")}set html(w){this.assertNotDisposed(),Ae(this,c,"f")!==w&&(Ze(this,c,w,"f"),!Ae(this,D,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(Ze(this,D,!0,"f"),Ae(this,y,"f").report("Webview vscode-resource: uris",Ae(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,t,"f").$setHtml(Ae(this,T,"f"),w))}get options(){return this.assertNotDisposed(),Ae(this,p,"f")}set options(w){this.assertNotDisposed(),Ae(this,t,"f").$setOptions(Ae(this,T,"f"),r(Ae(this,s,"f"),Ae(this,f,"f"),w)),Ze(this,p,w,"f")}async postMessage(w){if(Ae(this,P,"f"))return!1;const I=(0,F.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Ae(this,l,"f")});return Ae(this,t,"f").$postMessage(Ae(this,T,"f"),I.message,...I.buffers)}assertNotDisposed(){if(Ae(this,P,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=_,T=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,f=new WeakMap,s=new WeakMap,c=new WeakMap,p=new WeakMap,P=new WeakMap,D=new WeakMap,l=new WeakMap,u=new WeakMap;function i(d){try{const w=(0,A.normalizeVersion)((0,A.parseVersion)(d.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;class g{constructor(w,I,m,k,R){this.initData=I,this.workspace=m,this._logService=k,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=w.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(w,I,...m){const k=this.getWebview(w);if(k){const{message:R}=(0,F.deserializeWebviewMessage)(I,m);k._onMessageEmitter.fire(R)}}$onMissingCsp(w,I){this._logService.warn(`${I} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,I,m){const k=new _(w,this._webviewProxy,v(I),this.initData,this.workspace,m,this._deprecationService);return this._webviews.set(w,k),k._onDidDispose(()=>{this._webviews.delete(w)}),k}deleteWebview(w){this._webviews.delete(w)}getWebview(w){return this._webviews.get(w)}}e.ExtHostWebviews=g;function a(d){return{id:d.identifier,location:d.extensionLocation}}e.toExtensionData=a;function r(d,w,I){return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,enableForms:I.enableForms,portMapping:I.portMapping,localResourceRoots:I.localResourceRoots||o(d,w)}}e.serializeWebviewOptions=r;function v(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(w=>E.URI.from(w))}}e.reviveOptions=v;function o(d,w){return[...(w?.getWorkspaceFolders()||[]).map(I=>I.uri),d.extensionLocation]}}),define(be[209],Ee([0,1,21,58,6,11,24,2,8,51,64,5,7]),function(se,e,h,M,E,A,F,C,S,T,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(i,g){this.document=i,this._storagePath=g,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,g){await this.getEdit(i).undo(),g||this.disposeBackup()}async redo(i,g){await this.getEdit(i).redo(),g||this.disposeBackup()}disposeEdits(i){for(const g of i)this._edits.delete(g)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=u(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const g=this._edits.get(i,0);if(!g)throw new Error("No edit found");return g}}class s{constructor(){this._documents=new Map}get(i,g){return this._documents.get(this.key(i,g))}add(i,g,a){const r=this.key(i,g.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${i} resource:${g.uri}`);const v=new f(g,a);return this._documents.set(r,v),v}delete(i,g){const a=this.key(i,g.uri);this._documents.delete(a)}key(i,g){return`${i}@@@${g}`}}var c;(function(_){_[_.Text=0]="Text",_[_.Custom=1]="Custom"})(c||(c={}));class p{constructor(){this._providers=new Map}addTextProvider(i,g,a){return this.add(0,i,g,a)}addCustomProvider(i,g,a){return this.add(1,i,g,a)}get(i){return this._providers.get(i)}add(i,g,a,r){if(this._providers.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this._providers.set(g,{type:i,extension:a,provider:r}),new n.Disposable(()=>this._providers.delete(g))}}class P{constructor(i,g,a,r,v){this._extHostDocuments=g,this._extensionStoragePaths=a,this._extHostWebview=r,this._extHostWebviewPanels=v,this._editorProviders=new p,this._documents=new s,this._proxy=i.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,g,a,r){const v=new E.DisposableStore;return D(a)?(v.add(this._editorProviders.addTextProvider(g,i,a)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(i),g,r.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(i))):(v.add(this._editorProviders.addCustomProvider(g,i,a)),this.supportEditing(a)&&v.add(a.onDidChangeCustomDocument(o=>{const d=this.getCustomDocumentEntry(g,o.document.uri);if(l(o)){const w=d.addEdit(o);this._proxy.$onDidEdit(o.document.uri,g,w,o.label)}else this._proxy.$onContentChange(o.document.uri,g)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(i),g,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(v,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(g)}))}async $createCustomDocument(i,g,a,r,v){const o=this._editorProviders.get(g);if(!o)throw new Error(`No provider found for '${g}'`);if(o.type!==1)throw new Error(`Invalid provide type for '${g}'`);const d=C.URI.revive(i),w=await o.provider.openCustomDocument(d,{backupId:a,untitledDocumentData:r?.buffer},v);let I;return this.supportEditing(o.provider)&&this._extensionStoragePaths&&(I=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension)),this._documents.add(g,w,I),{editable:this.supportEditing(o.provider)}}async $disposeCustomDocument(i,g){const a=this._editorProviders.get(g);if(!a)throw new Error(`No provider found for '${g}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${g}'`);const r=C.URI.revive(i),{document:v}=this.getCustomDocumentEntry(g,r);this._documents.delete(g,v),v.dispose()}async $resolveWebviewEditor(i,g,a,r,v,o){const d=this._editorProviders.get(a);if(!d)throw new Error(`No provider found for '${a}'`);const w=S.ViewColumn.to(v),I=this._extHostWebview.createNewWebview(g,r.webviewOptions,d.extension),m=this._extHostWebviewPanels.createNewWebviewPanel(g,a,r.title,w,r.panelOptions,I),k=C.URI.revive(i);switch(d.type){case 1:{const{document:R}=this.getCustomDocumentEntry(a,k);return d.provider.resolveCustomEditor(R,m,o)}case 0:{const R=this._extHostDocuments.getDocument(k);return d.provider.resolveCustomTextEditor(R,m,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,g,a){this.getCustomDocumentEntry(g,i).disposeEdits(a)}async $onMoveCustomEditor(i,g,a){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const v=this._extHostWebviewPanels.getWebviewPanel(i);if(!v)throw new Error("No webview found");const o=C.URI.revive(g),d=this._extHostDocuments.getDocument(o);await r.provider.moveCustomTextEditor(d,v,h.CancellationToken.None)}async $undo(i,g,a,r){return this.getCustomDocumentEntry(g,i).undo(a,r)}async $redo(i,g,a,r){return this.getCustomDocumentEntry(g,i).redo(a,r)}async $revert(i,g,a){const r=this.getCustomDocumentEntry(g,i);await this.getCustomEditorProvider(g).revertCustomDocument(r.document,a),r.disposeBackup()}async $onSave(i,g,a){const r=this.getCustomDocumentEntry(g,i);await this.getCustomEditorProvider(g).saveCustomDocument(r.document,a),r.disposeBackup()}async $onSaveAs(i,g,a,r){const v=this.getCustomDocumentEntry(g,i);return this.getCustomEditorProvider(g).saveCustomDocumentAs(v.document,C.URI.revive(a),r)}async $backup(i,g,a){const r=this.getCustomDocumentEntry(g,i),o=await this.getCustomEditorProvider(g).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},a);return r.updateBackup(o),o.id}getCustomDocumentEntry(i,g){const a=this._documents.get(i,C.URI.revive(g));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(i){const a=this._editorProviders.get(i)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function D(_){return typeof _.resolveCustomTextEditor=="function"}function l(_){return typeof _.undo=="function"&&typeof _.redo=="function"}function u(_){const i=_.scheme===A.Schemas.file||_.scheme===A.Schemas.untitled?_.fsPath:_.toString();return(0,M.hash)(i)+""}});var Ze=this&&this.__classPrivateFieldSet||function(se,e,h,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,h):E?E.value=h:e.set(se,h),h},Ae=this&&this.__classPrivateFieldGet||function(se,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(se):M?M.value:e.get(se)};define(be[210],Ee([0,1,3,6,2,36,8,51,5,7]),function(se,e,h,M,E,A,F,C,S,T){"use strict";var t,y,n,f,s,c,p,P,D,l,u,_,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class g extends M.Disposable{constructor(o,d,w,I,m,k,R){super();t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),f.set(this,void 0),s.set(this,void 0),c.set(this,void 0),p.set(this,void 0),P.set(this,void 0),D.set(this,!0),l.set(this,!0),u.set(this,!1),_.set(this,this._register(new h.Emitter)),this.onDidDispose=Ae(this,_,"f").event,i.set(this,this._register(new h.Emitter)),this.onDidChangeViewState=Ae(this,i,"f").event,Ze(this,t,o,"f"),Ze(this,y,d,"f"),Ze(this,n,w,"f"),Ze(this,s,k,"f"),Ze(this,P,m,"f"),Ze(this,c,I,"f"),Ze(this,f,R,"f")}dispose(){Ae(this,u,"f")||(Ze(this,u,!0,"f"),Ae(this,_,"f").fire(),Ae(this,y,"f").$disposeWebview(Ae(this,t,"f")),Ae(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,f,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,n,"f")}get title(){return this.assertNotDisposed(),Ae(this,c,"f")}set title(o){this.assertNotDisposed(),Ae(this,c,"f")!==o&&(Ze(this,c,o,"f"),Ae(this,y,"f").$setTitle(Ae(this,t,"f"),o))}get iconPath(){return this.assertNotDisposed(),Ae(this,p,"f")}set iconPath(o){this.assertNotDisposed(),Ae(this,p,"f")!==o&&(Ze(this,p,o,"f"),Ae(this,y,"f").$setIconPath(Ae(this,t,"f"),E.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return Ae(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,P,"f")=="number"&&Ae(this,P,"f")<0))return Ae(this,P,"f")}get active(){return this.assertNotDisposed(),Ae(this,l,"f")}get visible(){return this.assertNotDisposed(),Ae(this,D,"f")}_updateViewState(o){Ae(this,u,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(Ze(this,l,o.active,"f"),Ze(this,D,o.visible,"f"),Ze(this,P,o.viewColumn,"f"),Ae(this,i,"f").fire({webviewPanel:this}))}reveal(o,d){this.assertNotDisposed(),Ae(this,y,"f").$reveal(Ae(this,t,"f"),{viewColumn:o?F.ViewColumn.from(o):void 0,preserveFocus:!!d})}assertNotDisposed(){if(Ae(this,u,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,y=new WeakMap,n=new WeakMap,f=new WeakMap,s=new WeakMap,c=new WeakMap,p=new WeakMap,P=new WeakMap,D=new WeakMap,l=new WeakMap,u=new WeakMap,_=new WeakMap,i=new WeakMap;class a{constructor(o,d,w){this.webviews=d,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=o.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(o,d,w,I,m={}){const k=typeof I=="object"?I.viewColumn:I,R={viewColumn:F.ViewColumn.from(k),preserveFocus:typeof I=="object"&&!!I.preserveFocus},L=(0,C.shouldSerializeBuffersForPostMessage)(o),b=a.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(o),b,d,{title:w,panelOptions:r(m),webviewOptions:(0,C.serializeWebviewOptions)(o,this.workspace,m),serializeBuffersForPostMessage:L},R);const B=this.webviews.createNewWebview(b,m,o);return this.createNewWebviewPanel(b,d,w,k,m,B)}$onDidChangeWebviewPanelViewStates(o){const d=Object.keys(o);d.sort((w,I)=>{const m=o[w],k=o[I];return m.active?1:k.active?-1:+m.visible-+k.visible});for(const w of d){const I=this.getWebviewPanel(w);if(!I)continue;const m=o[w];I._updateViewState({active:m.active,visible:m.visible,viewColumn:F.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(o){this.getWebviewPanel(o)?.dispose(),this._webviewPanels.delete(o),this.webviews.deleteWebview(o)}registerWebviewPanelSerializer(o,d,w){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:w,extension:o}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(o)}),new T.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(o,d,w,I){const m=this._serializers.get(d);if(!m)throw new Error(`No serializer found for '${d}'`);const{serializer:k,extension:R}=m,L=this.webviews.createNewWebview(o,w.webviewOptions,R),b=this.createNewWebviewPanel(o,d,w.title,I,w.panelOptions,L);await k.deserializeWebviewPanel(b,w.state)}createNewWebviewPanel(o,d,w,I,m,k){const R=new g(o,this._proxy,d,w,I,m,k);return this._webviewPanels.set(o,R),R}getWebviewPanel(o){return this._webviewPanels.get(o)}}e.ExtHostWebviewPanels=a;function r(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(se,e,h,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,h):E?E.value=h:e.set(se,h),h},Ae=this&&this.__classPrivateFieldGet||function(se,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(se):M?M.value:e.get(se)};define(be[211],Ee([0,1,3,6,51,5,7]),function(se,e,h,M,E,A,F){"use strict";var C,S,T,t,y,n,f,s,c,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends M.Disposable{constructor(u,_,i,g,a,r){super();C.set(this,void 0),S.set(this,void 0),T.set(this,void 0),t.set(this,void 0),y.set(this,!1),n.set(this,void 0),f.set(this,void 0),s.set(this,void 0),c.set(this,this._register(new h.Emitter)),this.onDidChangeVisibility=Ae(this,c,"f").event,p.set(this,this._register(new h.Emitter)),this.onDidDispose=Ae(this,p,"f").event,Ze(this,T,i,"f"),Ze(this,f,g,"f"),Ze(this,C,u,"f"),Ze(this,S,_,"f"),Ze(this,t,a,"f"),Ze(this,n,r,"f")}dispose(){Ae(this,y,"f")||(Ze(this,y,!0,"f"),Ae(this,p,"f").fire(),Ae(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,f,"f")}set title(u){this.assertNotDisposed(),Ae(this,f,"f")!==u&&(Ze(this,f,u,"f"),Ae(this,S,"f").$setWebviewViewTitle(Ae(this,C,"f"),u))}get description(){return this.assertNotDisposed(),Ae(this,s,"f")}set description(u){this.assertNotDisposed(),Ae(this,s,"f")!==u&&(Ze(this,s,u,"f"),Ae(this,S,"f").$setWebviewViewDescription(Ae(this,C,"f"),u))}get visible(){return Ae(this,n,"f")}get webview(){return Ae(this,t,"f")}get viewType(){return Ae(this,T,"f")}_setVisible(u){u===Ae(this,n,"f")||Ae(this,y,"f")||(Ze(this,n,u,"f"),Ae(this,c,"f").fire())}show(u){this.assertNotDisposed(),Ae(this,S,"f").$show(Ae(this,C,"f"),!!u)}assertNotDisposed(){if(Ae(this,y,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,S=new WeakMap,T=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,f=new WeakMap,s=new WeakMap,c=new WeakMap,p=new WeakMap;class D{constructor(u,_){this._extHostWebview=_,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,_,i,g){if(this._viewProviders.has(_))throw new Error(`View provider for '${_}' already registered`);return this._viewProviders.set(_,{provider:i,extension:u}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(u),_,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(_),this._proxy.$unregisterWebviewViewProvider(_)})}async $resolveWebviewView(u,_,i,g,a){const r=this._viewProviders.get(_);if(!r)throw new Error(`No view provider found for '${_}'`);const{provider:v,extension:o}=r,d=this._extHostWebview.createNewWebview(u,{},o),w=new P(u,this._proxy,_,i,d,!0);this._webviewViews.set(u,w),await v.resolveWebviewView(w,{state:g},a)}async $onDidChangeWebviewViewVisibility(u,_){this.getWebviewView(u)._setVisible(_)}async $disposeWebviewView(u){const _=this.getWebviewView(u);this._webviewViews.delete(u),_.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const _=this._webviewViews.get(u);if(!_)throw new Error("No webview found");return _}}e.ExtHostWebviewViews=D}),define(be[97],Ee([0,1,3,5,2,11,9,4,13]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class Ui{constructor(y){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=y.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,n){let f;if(typeof y=="string"){f=y;try{y=E.URI.parse(y)}catch(s){return Promise.reject(`Invalid uri - '${y}'`)}}return(0,F.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,f,n)}async asExternalUri(y,n){if((0,F.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(y,n);return E.URI.from(f)}};T.InitialState={focused:!0},T=$e([ze(0,S.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(be[212],Ee([0,1,15,5,29,13]),function(se,e,h,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends h.AbstractLogger{constructor(S,T){super();this._proxy=S.getProxy(M.MainContext.MainThreadLog),this._logFile=T.logFile.toJSON(),this.setLevel(T.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...T){this.getLevel()<=h.LogLevel.Trace&&this._proxy.$log(this._logFile,h.LogLevel.Trace,Array.from(arguments))}debug(S,...T){this.getLevel()<=h.LogLevel.Debug&&this._proxy.$log(this._logFile,h.LogLevel.Debug,Array.from(arguments))}info(S,...T){this.getLevel()<=h.LogLevel.Info&&this._proxy.$log(this._logFile,h.LogLevel.Info,Array.from(arguments))}warn(S,...T){this.getLevel()<=h.LogLevel.Warning&&this._proxy.$log(this._logFile,h.LogLevel.Warning,Array.from(arguments))}error(S,...T){this.getLevel()<=h.LogLevel.Error&&this._proxy.$log(this._logFile,h.LogLevel.Error,Array.from(arguments))}critical(S,...T){this.getLevel()<=h.LogLevel.Critical&&this._proxy.$log(this._logFile,h.LogLevel.Critical,Array.from(arguments))}flush(){}};F=$e([ze(0,A.IExtHostRpcService),ze(1,E.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(be[213],Ee([0,1,12,22,21,16,3,6,109,180,38]),function(se,e,h,M,E,A,F,C,S,T,t){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(m,k){try{return JSON.stringify(m,k)}catch(R){return"null"}}const f="$$ref$$",s={[f]:-1};class c{constructor(k,R){this.jsonString=k,this.referencedBuffers=R}}function p(m,k=null,R=!1){const L=[];return{jsonString:(R?n:JSON.stringify)(m,(B,$)=>{if(typeof $=="undefined")return s;if(typeof $=="object"){if($ instanceof M.VSBuffer){const x=L.push($)-1;return{[f]:x}}if(k)return k(B,$)}return $}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=p;function P(m,k,R){return JSON.parse(m,(L,b)=>{if(b){const B=b[f];if(typeof B=="number")return k[B];if(R&&b.$mid===1)return R.transformIncoming(b)}return b})}e.parseJsonAndRestoreBufferRefs=P;function D(m,k){return JSON.stringify(m,k)}function l(m){return m?(k,R)=>R&&R.$mid===1?m.transformOutgoing(R):R:null}var u;(function(m){m[m.LocalSide=0]="LocalSide",m[m.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(m){m[m.Responsive=0]="Responsive",m[m.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},g=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class r extends C.Disposable{constructor(k,R=null,L=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=k,this._logger=R,this._uriTransformer=L,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let b=0,B=t.ProxyIdentifier.count;b<B;b++)this._locals[b]=null,this._proxies[b]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(b=>this._receiveOneMessage(b))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(k=>{this._pendingRPCReplies[k].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(k){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(k){this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(k){this._responsiveState!==k&&(this._responsiveState=k,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(k){return this._uriTransformer?(0,S.transformIncomingURIs)(k,this._uriTransformer):k}getProxy(k){const{nid:R,sid:L}=k;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,L)),this._proxies[R]}_createProxy(k,R){let L={get:(b,B)=>(typeof B=="string"&&!b[B]&&B.charCodeAt(0)===36&&(b[B]=(...$)=>this._remoteCall(k,B,$)),B===a?R:b[B])};return new Proxy(Object.create(null),L)}set(k,R){return this._locals[k.nid]=R,R}assertRegistered(k){for(let R=0,L=k.length;R<L;R++){const b=k[R];if(!this._locals[b.nid])throw new Error(`Missing actor ${b.sid} (isMain: ${b.isMain})`)}}_receiveOneMessage(k){if(this._isDisposed)return;const R=k.byteLength,L=v.read(k,0),b=L.readUInt8(),B=L.readUInt32();switch(b){case 1:case 2:{let{rpcId:$,method:x,args:K}=d.deserializeRequestJSONArgs(L);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(R,B,$,x,K,b===2);break}case 3:case 4:{let{rpcId:$,method:x,args:K}=d.deserializeRequestMixedArgs(L);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(R,B,$,x,K,b===4);break}case 5:{this._logger&&this._logger.logIncoming(R,B,0,"ack"),this._onDidReceiveAcknowledge(B);break}case 6:{this._receiveCancel(R,B);break}case 7:{this._receiveReply(R,B,void 0);break}case 9:{let $=d.deserializeReplyOKJSON(L);this._uriTransformer&&($=(0,S.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(R,B,$);break}case 10:{const $=d.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(R,B,$);break}case 8:{let $=d.deserializeReplyOKVSBuffer(L);this._receiveReply(R,B,$);break}case 11:{let $=d.deserializeReplyErrError(L);this._uriTransformer&&($=(0,S.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(R,B,$);break}case 12:{this._receiveReplyErr(R,B,void 0);break}default:console.error("received unexpected message"),console.error(k)}}_receiveRequest(k,R,L,b,B,$){this._logger&&this._logger.logIncoming(k,R,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(L)}.${b}(`,B);const x=String(R);let K,H;if($){const ne=new E.CancellationTokenSource;B.push(ne.token),K=this._invokeHandler(L,b,B),H=()=>ne.cancel()}else K=this._invokeHandler(L,b,B),H=i;this._cancelInvokedHandlers[x]=H;const W=d.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(W.byteLength,R,1,"ack"),this._protocol.send(W),K.then(ne=>{delete this._cancelInvokedHandlers[x];const V=d.serializeReplyOK(R,ne,this._uriReplacer);this._logger&&this._logger.logOutgoing(V.byteLength,R,1,"reply:",ne),this._protocol.send(V)},ne=>{delete this._cancelInvokedHandlers[x];const V=d.serializeReplyErr(R,ne);this._logger&&this._logger.logOutgoing(V.byteLength,R,1,"replyErr:",ne),this._protocol.send(V)})}_receiveCancel(k,R){this._logger&&this._logger.logIncoming(k,R,1,"receiveCancel");const L=String(R);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(k,R,L){this._logger&&this._logger.logIncoming(k,R,0,"receiveReply:",L);const b=String(R);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const B=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b],B.resolveOk(L)}_receiveReplyErr(k,R,L){this._logger&&this._logger.logIncoming(k,R,0,"receiveReplyErr:",L);const b=String(R);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const B=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b];let $;L&&(L.$isError?($=new Error,$.name=L.name,$.message=L.message,$.stack=L.stack):$=L),B.resolveErr($)}_invokeHandler(k,R,L){try{return Promise.resolve(this._doInvokeHandler(k,R,L))}catch(b){return Promise.reject(b)}}_doInvokeHandler(k,R,L){const b=this._locals[k];if(!b)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(k));let B=b[R];if(typeof B!="function")throw new Error("Unknown method "+R+" on actor "+(0,t.getStringIdentifierForProxy)(k));return B.apply(b,L)}_remoteCall(k,R,L){if(this._isDisposed)return Promise.reject(A.canceled());let b=null;if(L.length>0&&E.CancellationToken.isCancellationToken(L[L.length-1])&&(b=L.pop()),b&&b.isCancellationRequested)return Promise.reject(A.canceled());const B=d.serializeRequestArguments(L,this._uriReplacer),$=++this._lastMessageId,x=String($),K=new T.LazyPromise;b&&b.onCancellationRequested(()=>{const W=d.serializeCancel($);this._logger&&this._logger.logOutgoing(W.byteLength,$,0,"cancel"),this._protocol.send(d.serializeCancel($))}),this._pendingRPCReplies[x]=K,this._onWillSendRequest($);const H=d.serializeRequest($,k,R,B,!!b);return this._logger&&this._logger.logOutgoing(H.byteLength,$,0,`request: ${(0,t.getStringIdentifierForProxy)(k)}.${R}(`,L),this._protocol.send(H),K}}e.RPCProtocol=r,y=g,r.UNRESPONSIVE_TIME=3*1e3;class v{constructor(k,R){this._buff=k,this._offset=R}static alloc(k,R,L){let b=new v(M.VSBuffer.alloc(L+1+4),0);return b.writeUInt8(k),b.writeUInt32(R),b}static read(k,R){return new v(k,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(k){this._buff.writeUInt8(k,this._offset),this._offset+=1}readUInt8(){const k=this._buff.readUInt8(this._offset);return this._offset+=1,k}writeUInt32(k){this._buff.writeUInt32BE(k,this._offset),this._offset+=4}readUInt32(){const k=this._buff.readUInt32BE(this._offset);return this._offset+=4,k}static sizeShortString(k){return 1+k.byteLength}writeShortString(k){this._buff.writeUInt8(k.byteLength,this._offset),this._offset+=1,this._buff.set(k,this._offset),this._offset+=k.byteLength}readShortString(){const k=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,L}static sizeLongString(k){return 4+k.byteLength}writeLongString(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readLongString(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,L}writeBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}static sizeVSBuffer(k){return 4+k.byteLength}writeVSBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readVSBuffer(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+k);return this._offset+=k,R}static sizeMixedArray(k){let R=0;R+=1;for(let L=0,b=k.length;L<b;L++){const B=k[L];switch(R+=1,B.type){case 1:R+=this.sizeLongString(B.value);break;case 2:R+=this.sizeVSBuffer(B.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(B.value);for(let $=0;$<B.buffers.length;++$)R+=this.sizeVSBuffer(B.buffers[$]);break;case 4:break}}return R}writeMixedArray(k){this._buff.writeUInt8(k.length,this._offset),this._offset+=1;for(let R=0,L=k.length;R<L;R++){const b=k[R];switch(b.type){case 1:this.writeUInt8(1),this.writeLongString(b.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(b.value);break;case 3:this.writeUInt8(3),this.writeUInt32(b.buffers.length),this.writeLongString(b.value);for(let B=0;B<b.buffers.length;++B)this.writeBuffer(b.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const k=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(k);for(let L=0;L<k;L++)switch(this.readUInt8()){case 1:R[L]=this.readLongString();break;case 2:R[L]=this.readVSBuffer();break;case 3:const B=this.readUInt32(),$=this.readLongString(),x=[];for(let K=0;K<B;++K)x.push(this.readVSBuffer());R[L]=new t.SerializableObjectWithBuffers(P($,x,null));break;case 4:R[L]=void 0;break}return R}}v.sizeUInt32=4;var o;(function(m){m[m.Simple=0]="Simple",m[m.Mixed=1]="Mixed"})(o||(o={}));class d{static _useMixedArgSerialization(k){for(let R=0,L=k.length;R<L;R++)if(k[R]instanceof M.VSBuffer||k[R]instanceof t.SerializableObjectWithBuffers||typeof k[R]=="undefined")return!0;return!1}static serializeRequestArguments(k,R){if(this._useMixedArgSerialization(k)){const L=[];for(let b=0,B=k.length;b<B;b++){const $=k[b];if($ instanceof M.VSBuffer)L[b]={type:2,value:$};else if(typeof $=="undefined")L[b]={type:4};else if($ instanceof t.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:K}=p($.value,R);L[b]={type:3,value:M.VSBuffer.fromString(x),buffers:K}}else L[b]={type:1,value:M.VSBuffer.fromString(D($,R))}}return{type:1,args:L}}return{type:0,args:D(k,R)}}static serializeRequest(k,R,L,b,B){switch(b.type){case 0:return this._requestJSONArgs(k,R,L,b.args,B);case 1:return this._requestMixedArgs(k,R,L,b.args,B)}}static _requestJSONArgs(k,R,L,b,B){const $=M.VSBuffer.fromString(L),x=M.VSBuffer.fromString(b);let K=0;K+=v.sizeUInt8(),K+=v.sizeShortString($),K+=v.sizeLongString(x);let H=v.alloc(B?2:1,k,K);return H.writeUInt8(R),H.writeShortString($),H.writeLongString(x),H.buffer}static deserializeRequestJSONArgs(k){const R=k.readUInt8(),L=k.readShortString(),b=k.readLongString();return{rpcId:R,method:L,args:JSON.parse(b)}}static _requestMixedArgs(k,R,L,b,B){const $=M.VSBuffer.fromString(L);let x=0;x+=v.sizeUInt8(),x+=v.sizeShortString($),x+=v.sizeMixedArray(b);let K=v.alloc(B?4:3,k,x);return K.writeUInt8(R),K.writeShortString($),K.writeMixedArray(b),K.buffer}static deserializeRequestMixedArgs(k){const R=k.readUInt8(),L=k.readShortString(),b=k.readMixedArray(),B=new Array(b.length);for(let $=0,x=b.length;$<x;$++){const K=b[$];typeof K=="string"?B[$]=JSON.parse(K):B[$]=K}return{rpcId:R,method:L,args:B}}static serializeAcknowledged(k){return v.alloc(5,k,0).buffer}static serializeCancel(k){return v.alloc(6,k,0).buffer}static serializeReplyOK(k,R,L){if(typeof R=="undefined")return this._serializeReplyOKEmpty(k);if(R instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(k,R);if(R instanceof t.SerializableObjectWithBuffers){const{jsonString:b,referencedBuffers:B}=p(R.value,L,!0);return this._serializeReplyOKJSONWithBuffers(k,b,B)}else return this._serializeReplyOKJSON(k,n(R,L))}static _serializeReplyOKEmpty(k){return v.alloc(7,k,0).buffer}static _serializeReplyOKVSBuffer(k,R){let L=0;L+=v.sizeVSBuffer(R);let b=v.alloc(8,k,L);return b.writeVSBuffer(R),b.buffer}static deserializeReplyOKVSBuffer(k){return k.readVSBuffer()}static _serializeReplyOKJSON(k,R){const L=M.VSBuffer.fromString(R);let b=0;b+=v.sizeLongString(L);let B=v.alloc(9,k,b);return B.writeLongString(L),B.buffer}static _serializeReplyOKJSONWithBuffers(k,R,L){const b=M.VSBuffer.fromString(R);let B=0;B+=v.sizeUInt32,B+=v.sizeLongString(b);for(const x of L)B+=v.sizeVSBuffer(x);let $=v.alloc(10,k,B);$.writeUInt32(L.length),$.writeLongString(b);for(const x of L)$.writeBuffer(x);return $.buffer}static deserializeReplyOKJSON(k){const R=k.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(k,R){const L=k.readUInt32(),b=k.readLongString(),B=[];for(let $=0;$<L;++$)B.push(k.readVSBuffer());return new t.SerializableObjectWithBuffers(P(b,B,R))}static serializeReplyErr(k,R){return R?this._serializeReplyErrEror(k,R):this._serializeReplyErrEmpty(k)}static _serializeReplyErrEror(k,R){const L=M.VSBuffer.fromString(n(A.transformErrorForSerialization(R),null));let b=0;b+=v.sizeLongString(L);let B=v.alloc(11,k,b);return B.writeLongString(L),B.buffer}static deserializeReplyErrError(k){const R=k.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(k){return v.alloc(12,k,0).buffer}}var w;(function(m){m[m.RequestJSONArgs=1]="RequestJSONArgs",m[m.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",m[m.RequestMixedArgs=3]="RequestMixedArgs",m[m.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",m[m.Acknowledged=5]="Acknowledged",m[m.Cancel=6]="Cancel",m[m.ReplyOKEmpty=7]="ReplyOKEmpty",m[m.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",m[m.ReplyOKJSON=9]="ReplyOKJSON",m[m.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",m[m.ReplyErrError=11]="ReplyErrError",m[m.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var I;(function(m){m[m.String=1]="String",m[m.VSBuffer=2]="VSBuffer",m[m.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",m[m.Undefined=4]="Undefined"})(I||(I={}))}),define(be[214],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const h=function(A){const F=C=>{self.removeEventListener("message",F);const S=C.data;Object.defineProperties(self,{postMessage:{value(T,t){S.postMessage(T,t)}},onmessage:{get(){return S.onmessage},set(T){S.onmessage=T}}}),S.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(A,F,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${h})('${F}'))`,T=new Blob([S],{type:"application/javascript"}),t=URL.createObjectURL(T),y=new MessageChannel,n=t,f={type:"_newWorker",id:n,port:y.port2,url:t,options:C};A(f,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:n};y.port1.postMessage(s),URL.revokeObjectURL(t),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(s){y.port1.onmessage=s}},onmessageerror:{get(){return y.port1.onmessageerror},set(s){y.port1.onmessageerror=s}}}),y.port1.addEventListener("messageerror",s=>{const c=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(c)}),y.port1.addEventListener("message",s=>{const c=new MessageEvent("message",{data:s.data});this.dispatchEvent(c)}),y.port1.start()}}e.NestedWorker=M}),define(be[215],Ee([0,1,4]),function(se,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService")}),define(be[216],Ee([0,1,11,17,25,2,4,63,48,176,215]),function(se,e,h,M,E,A,F,C,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let y=class $i{constructor(f,s,c,p){this.localUserHome=f,this.remoteAgentService=s,this.environmentService=c,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const P=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=P?.userHome||f})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,s){if(f.remoteAuthority)return h.Schemas.vscodeRemote;const c=(0,C.getVirtualWorkspaceScheme)(s.getWorkspace());if(c)return c;const p=s.getWorkspace().folders[0];if(p)return p.uri.scheme;const P=s.getWorkspace().configuration;return P?P.scheme:h.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?M.win32:M.posix)}async fileURI(f){let s="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const p=f.indexOf("/",2);p===-1?(s=f.substring(2),f="/"):(s=f.substring(2,p),f=f.substring(p)||"/")}return A.URI.from({scheme:h.Schemas.file,authority:s,path:f,query:"",fragment:""})}};y=$e([ze(1,t.IRemoteAgentService),ze(2,T.IWorkbenchEnvironmentService),ze(3,S.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(be[98],Ee([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(F,C){this.line=F,this.character=C}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,C){return new h(0,0)}with(F){return new h(0,0)}}e.Position=h;class M{constructor(F,C,S,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(F,C),this.end=new h(S,T)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var E;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],Ee([0,1,14,27,23,43,9,4,17,16,98,10]),function(se,e,h,M,E,A,F,C,S,T,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",f=" characters skipped \u27EB",s=(n.length+f.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var c;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function P(W){return!!W.preview}e.resultIsMatch=P;function D(W){return!!W.resource}e.isFileMatch=D;function l(W){return!!W.message}e.isProgressMessage=l;var u;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class _{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=_;class i{constructor(ne,V,J){this.ranges=V;const j=Array.isArray(V)?V:[V];if(J&&J.matchLines===1&&g(j)){ne=(0,F.getNLines)(ne,J.matchLines);let le="",ee=0,ve=0;const Re=Math.floor(J.charsPerLine/5),Fe=[];for(const Oe of j){const Ke=Math.max(Oe.startColumn-Re,0),je=Oe.startColumn+J.charsPerLine;if(Ke>ve+Re+s){const Ve=n+(Ke-ve)+f;le+=Ve+ne.slice(Ke,je),ee+=Ke-(ve+Ve.length)}else le+=ne.slice(ve,je);Fe.push(new r(0,Oe.startColumn-ee,Oe.endColumn-ee)),ve=je}this.preview={text:le,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const le=Array.isArray(V)?V[0].startLineNumber:V.startLineNumber;this.preview={text:ne,matches:(0,h.mapArrayOrNot)(V,ee=>new a(ee.startLineNumber-le,ee.startColumn,ee.endLineNumber-le,ee.endColumn))}}}}e.TextSearchMatch=i;function g(W){const ne=W[0].startLineNumber;for(const V of W)if(V.startLineNumber!==ne||V.endLineNumber!==ne)return!1;return!0}class a{constructor(ne,V,J,j){this.startLineNumber=ne,this.startColumn=V,this.endLineNumber=J,this.endColumn=j}}e.SearchRange=a;class r extends a{constructor(ne,V,J){super(ne,V,ne,J)}}e.OneLineRange=r;var v;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(v=e.SearchSortOrder||(e.SearchSortOrder={}));function o(W,ne=!0){const V=W&&W.files&&W.files.exclude,J=ne&&W&&W.search&&W.search.exclude;if(!V&&!J)return;if(!V||!J)return V||J;let j=Object.create(null);return j=E.mixin(j,E.deepClone(V)),j=E.mixin(j,E.deepClone(J),!0),j}e.getExcludes=o;function d(W,ne){return W.excludePattern&&M.match(W.excludePattern,ne)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&M.match(W.includePattern,ne)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(V=>{const J=V.folder.fsPath;if(A.isEqualOrParent(ne,J)){const j=S.relative(J,ne);return!V.includePattern||!!M.match(V.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var w;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class I extends Error{constructor(ne,V){super(ne);this.code=V}}e.SearchError=I;function m(W){const ne=W.message;if((0,T.isPromiseCanceledError)(W))return new I(ne,w.canceled);try{const V=JSON.parse(ne);return new I(V.message,V.code)}catch(V){return new I(ne,w.other)}}e.deserializeSearchError=m;function k(W){const ne={message:W.message,code:W.code};return new Error(JSON.stringify(ne))}e.serializeSearchError=k;function R(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=R;function L(W){return W.type==="success"}e.isSerializedSearchSuccess=L;function b(W){return!!W.path}e.isSerializedFileMatch=b;function B(W,ne){const V=W.searchPath?W.searchPath:W.relativePath;return(0,F.fuzzyContains)(V,ne)}e.isFilePatternMatch=B;class ${constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function x(W,ne){const V={...W||{},...ne||{}};return Object.keys(V).filter(J=>{const j=V[J];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=x;class K{constructor(ne,V){this._parsedIncludeExpression=null,this._excludeExpression={...ne.excludePattern||{},...V.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let J=ne.includePattern;V.includePattern&&(J?J={...J,...V.includePattern}:J=V.includePattern),J&&(this._parsedIncludeExpression=M.parse(J))}matchesExcludesSync(ne,V,J){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,V,J))}includedInQuerySync(ne,V,J){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,V,J)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ne,V,J))}includedInQuery(ne,V,J){const j=this._parsedExcludeExpression(ne,V,J),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ne,V,J):!0;return(0,y.isPromise)(j)?j.then(ee=>ee?!1:le()):le()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=K;function H(W){for(const ne in W)if(typeof W[ne]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,14,12,21,3,20,11,76,24,9,10,2,130,4,15,144,48,37,29,13,7,41,5]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D,l,u,_,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(k,R,L){return new T.ExtUri(b=>d(b,L)).isEqual(k,R)}function r(k,R,L){return a(k.uri,R.uri,L)?0:(0,t.compare)(k.uri.toString(),R.uri.toString())}function v(k,R,L){return k.index!==R.index?k.index<R.index?-1:1:a(k.uri,R.uri,L)?(0,t.compare)(k.name,R.name):(0,t.compare)(k.uri.toString(),R.uri.toString())}function o(k,R,L,b){const B=k.slice(0).sort((x,K)=>L(x,K,b)),$=R.slice(0).sort((x,K)=>L(x,K,b));return(0,h.delta)(B,$,(x,K)=>L(x,K,b))}function d(k,R){const L=R.getCapabilities(k.scheme);return!(L&&L&1024)}class w extends P.Workspace{constructor(R,L,b,B,$,x,K){super(R,b.map(H=>new P.WorkspaceFolder(H)),B,$,K);this._name=L,this._isUntitled=x,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(K),b.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(R,L,b,B){if(!R)return{workspace:null,added:[],removed:[]};const{id:$,name:x,folders:K,configuration:H,transient:W,isUntitled:ne}=R,V=[],J=L;L?K.forEach((ve,Re)=>{const Fe=n.URI.revive(ve.uri),Oe=w._findFolder(b||L,Fe,B);Oe?(Oe.name=ve.name,Oe.index=ve.index,V.push(Oe)):V.push({uri:Fe,name:ve.name,index:Re})}):V.push(...K.map(({uri:ve,name:Re,index:Fe})=>({uri:n.URI.revive(ve),name:Re,index:Fe}))),V.sort((ve,Re)=>ve.index<Re.index?-1:1);const j=new w($,x,V,!!W,H?n.URI.revive(H):null,!!ne,ve=>d(ve,B)),{added:le,removed:ee}=o(J?J.workspaceFolders:[],j.workspaceFolders,r,B);return{workspace:j,added:le,removed:ee}}static _findFolder(R,L,b){for(let B=0;B<R.folders.length;B++){const $=R.workspaceFolders[B];if(a($.uri,L,b))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,L){return L&&this._structure.get(R)&&(R=(0,T.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let I=class{constructor(R,L,b,B){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=B,this._extHostFileSystemInfo=b,this._requestIdProvider=new S.Counter,this._barrier=new M.Barrier,this._proxy=R.getProxy(g.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(g.MainContext.MainThreadMessageService);const $=L.workspace;this._confirmedWorkspace=$?new w($.id,$.name,[],!!$.transient,$.configuration?n.URI.revive($.configuration):null,!!$.isUntitled,x=>d(x,b)):void 0}$initializeWorkspace(R,L){this._trusted=L,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:C.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,L,b,...B){const $=[];if(Array.isArray(B)&&B.forEach(ne=>{n.URI.isUri(ne.uri)&&!$.some(V=>a(V.uri,ne.uri,this._extHostFileSystemInfo))&&$.push({uri:ne.uri,name:ne.name||(0,T.basenameOrAuthority)(ne.uri)})}),this._unconfirmedWorkspace||[L,b].some(ne=>typeof ne!="number"||ne<0)||b===0&&$.length===0)return!1;const x=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+b>x.length)return!1;const K=x.slice(0);K.splice(L,b,...$.map(ne=>({uri:ne.uri,name:ne.name||(0,T.basenameOrAuthority)(ne.uri),index:void 0})));for(let ne=0;ne<K.length;ne++){const V=K[ne];if(K.some((J,j)=>j!==ne&&a(V.uri,J.uri,this._extHostFileSystemInfo)))return!1}K.forEach((ne,V)=>ne.index=V);const{added:H,removed:W}=o(x,K,v,this._extHostFileSystemInfo);if(H.length===0&&W.length===0)return!1;if(this._proxy){const ne=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(ne,L,b,$).then(void 0,V=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,f.localize)(0,null,ne,V.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(R,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,L)}async getWorkspaceFolder2(R,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,L)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,L){let b,B="";if(typeof R=="string"?(b=n.URI.file(R),B=R):typeof R!="undefined"&&(b=R,B=R.fsPath),!b)return B;const $=this.getWorkspaceFolder(b,!0);if(!$)return B;typeof L=="undefined"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let x=(0,T.relativePath)($.uri,b);return L&&$.name&&(x=`${$.name}/${x}`),x}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:L,added:b,removed:B}=w.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:b,removed:B}))}findFiles(R,L,b,B,$=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let x;if(L===null?x=!1:L&&(typeof L=="string"?x=L:x=L.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:H}=m(R);return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(K),(0,y.withUndefinedAsNull)(H),(0,y.withUndefinedAsNull)(x),(0,y.withUndefinedAsNull)(b),$).then(W=>Array.isArray(W)?W.map(ne=>n.URI.revive(ne)):[])}async findTextInFiles(R,L,b,B,$=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const x=this._requestIdProvider.getNext(),K=typeof L.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:H,folder:W}=m(L.include),ne=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,V={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:K,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:H,excludePattern:ne},J=!1;if(this._activeSearchCallbacks[x]=j=>{if(J)return;const le=n.URI.revive(j.resource);j.results.forEach(ee=>{(0,i.resultIsMatch)(ee)?b({uri:le,preview:{text:ee.preview.text,matches:(0,h.mapArrayOrNot)(ee.preview.matches,ve=>new _.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,h.mapArrayOrNot)(ee.ranges,ve=>new _.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):b({uri:le,text:ee.text,lineNumber:ee.lineNumber})})},$.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(R,(0,y.withUndefinedAsNull)(W),V,x,$);return delete this._activeSearchCallbacks[x],j||{}}catch(j){throw delete this._activeSearchCallbacks[x],j}}$handleTextSearchResult(R,L){this._activeSearchCallbacks[L]&&this._activeSearchCallbacks[L](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};I=$e([ze(0,u.IExtHostRpcService),ze(1,l.IExtHostInitDataService),ze(2,D.IExtHostFileSystemInfo),ze(3,c.ILogService)],I),e.ExtHostWorkspace=I,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function m(k){let R,L;return k&&(typeof k=="string"?R=k:(R=k.pattern,L=k.baseFolder||n.URI.file(k.base))),{includePattern:R,folder:L}}}),define(be[32],Ee([0,1,23,3,31,5,7,147,62,10,12,4,13,15,2]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(g,a){if(a){const r=a.split(".");let v=g;for(let o=0;v&&o<r.length;o++)v=v[r[o]];return v}}function p(g){return g instanceof s.URI}function P(g){return g&&g.uri instanceof s.URI&&g.languageId&&typeof g.languageId=="string"}function D(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function l(g){return g&&g.uri instanceof s.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function u(g){if(p(g))return{resource:g};if(P(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(D(g))return{overrideIdentifier:g.languageId};if(l(g))return{resource:g.uri};if(g===null)return{resource:null}}let _=class{constructor(a,r,v){this._proxy=a.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=v,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new i(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,r){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(a,r))}};_=$e([ze(0,n.IExtHostRpcService),ze(1,E.IExtHostWorkspace),ze(2,f.ILogService)],_),e.ExtHostConfiguration=_;class i{constructor(a,r,v,o){this._onDidChangeConfiguration=new M.Emitter,this._proxy=a,this._logService=o,this._extHostWorkspace=r,this._configuration=C.Configuration.parse(v),this._configurationScopes=this._toMap(v.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,r){const v={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,v))}getConfiguration(a,r,v){const o=u(r)||{},d=this._toReadonlyValue(a?c(this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,o,v?.identifier);function w(m){if(m==null)return null;if(typeof m=="boolean")return m?1:4;switch(m){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const I={has(m){return typeof c(d,m)!="undefined"},get:(m,k)=>{this._validateConfigurationAccess(a?`${a}.${m}`:m,o,v?.identifier);let R=c(d,m);if(typeof R=="undefined")R=k;else{let L;const b=(B,$)=>{let x;const K=()=>{L=L||(0,h.deepClone)(d),x=x||c(L,$)};return(0,T.isObject)(B)?new Proxy(B,{get:(H,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return K(),()=>x;if(L)return x=x||c(L,$),x[W];const ne=H[W];return typeof W=="string"?b(ne,`${$}.${W}`):ne},set:(H,W,ne)=>(K(),x&&(x[W]=ne),!0),deleteProperty:(H,W)=>(K(),x&&delete x[W],!0),defineProperty:(H,W,ne)=>(K(),x&&Object.defineProperty(x,W,ne),!0)}):B};R=b(R,m)}return R},update:(m,k,R,L)=>{m=a?`${a}.${m}`:m;const b=w(R);return k!==void 0?this._proxy.$updateConfigurationOption(b,m,k,o,L):this._proxy.$removeConfigurationOption(b,m,o,L)},inspect:m=>{m=a?`${a}.${m}`:m;const k=(0,h.deepClone)(this._configuration.inspect(m,o,this._extHostWorkspace.workspace));if(k)return{key:m,defaultValue:k.default?.value,globalValue:k.user?.value,workspaceValue:k.workspace?.value,workspaceFolderValue:k.workspaceFolder?.value,defaultLanguageValue:k.default?.override,globalLanguageValue:k.user?.override,workspaceLanguageValue:k.workspace?.override,workspaceFolderLanguageValue:k.workspaceFolder?.override,languageIds:k.overrideIdentifiers}}};return typeof d=="object"&&(0,h.mixin)(I,d,!1),Object.freeze(I)}_toReadonlyValue(a){const r=v=>(0,T.isObject)(v)?new Proxy(v,{get:(o,d)=>r(o[d]),set:(o,d,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(o,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(o,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return r(a)}_validateConfigurationAccess(a,r,v){const o=S.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),d=v?`[${v.value}] `:"";if(o===4){typeof r?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){r?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,r){const v=new C.ConfigurationChangeEvent(a,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(o,d)=>v.affectsConfiguration(o,u(d))})}_toMap(a){return a.reduce((r,v)=>(r.set(v[0],v[1]),r),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(se,e,h,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,h):E?E.value=h:e.set(se,h),h},Ae=this&&this.__classPrivateFieldGet||function(se,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(se):M?M.value:e.get(se)};define(be[99],Ee([0,1,2,12,3,5,7,31,50,32,21,40,13,29,4,11,25,15,70,166,16]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D,l,u){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function($){function x(H){if(H!=null)return H}$.from=x;function K(H){if(H!=null)return H}$.to=K})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var g;(function($){function x(H){if(H!=null)return H}$.from=x;function K(H){if(H!=null)return H}$.to=K})(g=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function($){function x(H){if(H!=null)return H}$.from=x;function K(H){if(H!=null)return H}$.to=K})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function($){function x(W){if(W){const ne=W;return ne&&!!ne.process}else return!1}$.is=x;function K(W){if(W==null)return;const ne={process:W.process,args:W.args};return W.options&&(ne.options=a.from(W.options)),ne}$.from=K;function H(W){if(W!=null)return new F.ProcessExecution(W.process,W.args,W.options)}$.to=H})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var v;(function($){function x(H){if(H!=null)return H}$.from=x;function K(H){if(H!=null)return H}$.to=K})(v=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var o;(function($){function x(W){if(W){const ne=W;return ne&&(!!ne.commandLine||!!ne.command)}else return!1}$.is=x;function K(W){if(W==null)return;const ne={};return W.commandLine!==void 0?ne.commandLine=W.commandLine:(ne.command=W.command,ne.args=W.args),W.options&&(ne.options=v.from(W.options)),ne}$.from=K;function H(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new F.ShellExecution(W.commandLine,W.options):new F.ShellExecution(W.command,W.args?W.args:[],W.options)}$.to=H})(o=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var d;(function($){function x(W){if(W){let ne=W;return ne&&ne.customExecution==="customExecution"}else return!1}$.is=x;function K(W){return{customExecution:"customExecution"}}$.from=K;function H(W,ne){return ne.get(W)}$.to=H})(d=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function($){function x(K,H){let W;return K.scope!==void 0&&typeof K.scope!="number"?W=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===F.TaskScope.Workspace&&H&&H.workspaceFile?W=H.workspaceFile:W=l.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:W}}$.from=x})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var I;(function($){function x(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}$.from=x})(I=e.TaskGroupDTO||(e.TaskGroupDTO={}));var m;(function($){function x(W,ne){if(W==null)return[];const V=[];for(let J of W){const j=K(J,ne);j&&V.push(j)}return V}$.fromMany=x;function K(W,ne){if(W==null)return;let V;W.execution instanceof F.ProcessExecution?V=r.from(W.execution):W.execution instanceof F.ShellExecution?V=o.from(W.execution):W.execution&&W.execution instanceof F.CustomExecution&&(V=d.from(W.execution));const J=i.from(W.definition);let j;return W.scope?typeof W.scope=="number"?j=W.scope:j=W.scope.uri:j=F.TaskScope.Workspace,!J||!j?void 0:{_id:W._id,definition:J,name:W.name,source:{extensionId:ne.identifier.value,label:W.source,scope:j},execution:V,isBackground:W.isBackground,group:I.from(W.group),presentationOptions:g.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}$.from=K;async function H(W,ne,V){if(W==null)return;let J;r.is(W.execution)?J=r.to(W.execution):o.is(W.execution)?J=o.to(W.execution):d.is(W.execution)&&(J=d.to(W._id,V));const j=i.to(W.definition);let le;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?le=W.source.scope:le=await ne.resolveWorkspaceFolder(h.URI.revive(W.source.scope)):le=F.TaskScope.Workspace),!j||!le)return;const ee=new F.Task(j,le,W.name,W.source.label,J,W.problemMatchers);return W.isBackground!==void 0&&(ee.isBackground=W.isBackground),W.group!==void 0&&(ee.group=F.TaskGroup.from(W.group._id),ee.group&&W.group.isDefault&&(ee.group=new F.TaskGroup(ee.group.id,ee.group.label),W.group.isDefault&&(ee.group.isDefault=W.group.isDefault))),W.presentationOptions&&(ee.presentationOptions=g.to(W.presentationOptions)),W._id&&(ee._id=W._id),W.detail&&(ee.detail=W.detail),ee}$.to=H})(m=e.TaskDTO||(e.TaskDTO={}));var k;(function($){function x(H){return H}$.from=x;function K(H){if(!!H)return Object.assign(Object.create(null),H)}$.to=K})(k=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(x,K,H){this._id=K,this._task=H,_.set(this,void 0),Ze(this,_,x,"f")}get task(){return this._task}terminate(){Ae(this,_,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}_=new WeakMap;var L;(function($){function x(K){return{id:K._id,task:void 0}}$.from=x})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let b=class{constructor(x,K,H,W,ne,V,J,j){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=x.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=W,this._configurationService=ne,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=J,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,K,H){if(!H)return new F.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:K,provider:H,extension:x}),this._proxy.$registerTaskProvider(W,K),new F.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(x,K){this._proxy.$registerTaskSystem(x,K)}fetchTasks(x){return this._proxy.$fetchTasks(k.from(x)).then(async K=>{const H=[];for(let W of K){const ne=await m.to(W,this._workspaceProvider,this._providedCustomExecutions2);ne&&H.push(ne)}return H})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(K=>x.push(K)),x}terminateTask(x){if(!(x instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,K,H){const W=this._providedCustomExecutions2.get(x.id);if(W){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,W),this._terminalService.attachPtyToTerminal(K,await W.callback(H))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const K=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const K=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:K,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const K=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:x.exitCode})}$provideTasks(x,K){const H=this._handlers.get(x);if(!H)return Promise.reject(new Error("no handler found"));const W=[],ne=(0,M.asPromise)(()=>H.provider.provideTasks(t.CancellationToken.None)).then(V=>this.provideTasksInternal(K,W,H,V));return new Promise(V=>{ne.then(J=>{Promise.all(W).then(()=>{V(J)})})})}async $resolveTask(x,K){const H=this._handlers.get(x);if(!H)return Promise.reject(new Error("no handler found"));if(K.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${H.type}].`);const W=await m.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const ne=await H.provider.resolveTask(W,t.CancellationToken.None);if(!ne)return;this.checkDeprecation(ne,H);const V=m.from(ne,H.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(ne.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(V.execution)&&await this.addCustomExecution(V,ne,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,K,H){const W=await this._proxy.$createTaskId(x);!H&&!this._providedCustomExecutions2.has(W)&&this._notProvidedCustomExecutions.add(W),this._providedCustomExecutions2.set(W,K.execution)}async getTaskExecution(x,K){if(typeof x=="string"){const ne=this._taskExecutionPromises.get(x);if(!ne)throw new Error("Unexpected: The specified task is missing an execution");return ne}let H=this._taskExecutionPromises.get(x.id);if(H)return H;const W=new Promise(async(ne,V)=>{const J=K||await m.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);J?ne(new R(this,x.id,J)):V("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,W),W.then(ne=>(this._taskExecutions.set(x.id,ne),ne),ne=>Promise.reject(ne))}checkDeprecation(x,K){x._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let H=this._notProvidedCustomExecutions.values(),W=H.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=H.next()}};b=$e([ze(0,n.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,C.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,T.IExtHostConfiguration),ze(5,y.IExtHostTerminalService),ze(6,P.ILogService),ze(7,D.IExtHostApiDeprecationService)],b),e.ExtHostTaskBase=b;let B=class extends b{constructor(x,K,H,W,ne,V,J,j){super(x,K,H,W,ne,V,J,j);this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(x,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const H=m.from(K,x);if(H===void 0)throw new Error("Task is not valid");if(d.is(H.execution))await this.addCustomExecution(H,K,!1);else throw new u.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),K);return this._proxy.$executeTask(H).catch(ne=>{throw new Error(ne)}),W}provideTasksInternal(x,K,H,W){const ne=[];if(W)for(let V of W){this.checkDeprecation(V,H),(!V.definition||!x[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const J=m.from(V,H.extension);J&&d.is(J.execution)?(ne.push(J),K.push(this.addCustomExecution(J,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ne,extension:H.extension}}async resolveTaskInternal(x){if(d.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,K,H){}};B=$e([ze(0,n.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,C.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,T.IExtHostConfiguration),ze(5,y.IExtHostTerminalService),ze(6,P.ILogService),ze(7,D.IExtHostApiDeprecationService)],B),e.WorkerExtHostTask=B,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(be[217],Ee([0,1,14,52,27,78,20,11,17,24,9,10,2,111,134,85,48,92,216,41]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(w,I,m,k){this.configurationService=w,this.workspaceContextService=I,this.editorGroupsService=m,this.pathService=k}text(w,I,m={}){w=this.getContentPattern(w,m);const k=this.configurationService.getValue(),R=I&&I.some(b=>!this.configurationService.getValue({resource:b}).search.useRipgrep);return{...this.commonQuery(I?.map(p.toWorkspaceFolder),m),type:2,contentPattern:w,previewOptions:m.previewOptions,maxFileSize:m.maxFileSize,usePCRE2:k.search.usePCRE2||R||!1,beforeContext:m.beforeContext,afterContext:m.afterContext,userDisabledExcludesAndIgnoreFiles:m.disregardExcludeSettings&&m.disregardIgnoreFiles}}getContentPattern(w,I){const m=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const k={...w,wordSeparators:m.editor.wordSeparators};return this.isCaseSensitive(w,I)&&(k.isCaseSensitive=!0),this.isMultiline(w)&&(k.isMultiline=!0),k}file(w,I={}){return{...this.commonQuery(w,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}handleIncludeExclude(w,I){return w?(w=Array.isArray(w)?w.map(r):r(w),I?this.parseSearchPaths(w):{pattern:i(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],I={}){const m=this.handleIncludeExclude(I.includePattern,I.expandPatterns),k=this.handleIncludeExclude(I.excludePattern,I.expandPatterns),R=w.length>1,L=(m.searchPaths&&m.searchPaths.length?m.searchPaths.map($=>this.getFolderQueryForSearchPath($,I,k)):w.map($=>this.getFolderQueryForRoot($,I,k,R))).filter($=>!!$),b={_reason:I._reason,folderQueries:L,usingSearchPaths:!!(m.searchPaths&&m.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:k.pattern,includePattern:m.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const x=h.coalesce(h.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(W=>W.resource)))).filter(H=>(0,l.pathIncludedInQuery)(b,H.fsPath)),K=this.commonQueryFromFileList(x);return{...b,...K}}const B=I.extraFileResources&&I.extraFileResources.filter($=>(0,l.pathIncludedInQuery)(b,$.fsPath));return b.extraFileResources=B&&B.length?B:void 0,b}commonQueryFromFileList(w){const I=[],m=new F.ResourceMap,k={};let R=!1;return w.forEach(L=>{if(L.scheme===C.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(L)){const B=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:S.dirname(L.fsPath)});let $=m.get(B);$||(R=!0,$={folder:B,includePattern:{}},I.push($),m.set(B,$));const x=S.relative(B.fsPath,L.fsPath);(0,y.assertIsDefined)($.includePattern)[x.replace(/\\/g,"/")]=!0}else L.fsPath&&(R=!0,k[L.fsPath]=!0)}),{folderQueries:I,includePattern:k,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(w,I){if(I.isSmartCase){if(w.isRegExp){if(t.containsUppercaseCharacter(w.pattern,!0))return!0}else if(t.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,f.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const I=K=>S.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),k=(Array.isArray(w)?w:g(w)).map(K=>{const H=this.pathService.resolvedUserHome;return H?(0,A.untildify)(K,H.scheme===C.Schemas.file?H.fsPath:H.path):K}),R=M.groupBy(k,K=>I(K)?"searchPaths":"exprSegments"),L=(R.exprSegments||[]).map(K=>t.rtrim(K,"/")).map(K=>t.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),a(K))),b={},B=this.expandSearchPathPatterns(R.searchPaths||[]);B&&B.length&&(b.searchPaths=B);const $=h.flatten(L),x=i(...$);return x&&(b.pattern=x),b}getExcludesForFolder(w,I){return I.disregardExcludeSettings?void 0:(0,l.getExcludes)(w,!I.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const I=h.flatten(w.map(k=>{let{pathPortion:R,globPortion:L}=_(k);L&&(L=v(L));const b=this.expandOneSearchPath(R);return h.flatten(b.map(B=>this.resolveOneSearchPathPattern(B,L)))})),m=new Map;return I.forEach(k=>{const R=k.searchPath.toString(),L=m.get(R);L?k.pattern&&(L.pattern=L.pattern||{},L.pattern[k.pattern]=!0):m.set(R,{searchPath:k.searchPath,pattern:k.pattern?i(k.pattern):void 0})}),Array.from(m.values())}expandOneSearchPath(w){if(S.isAbsolute(w)){const I=this.workspaceContextService.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==C.Schemas.file?[{searchPath:I[0].uri.with({path:w})}]:[{searchPath:n.URI.file(S.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const I=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=r(w),w.startsWith("../")||w===".."){const k=S.posix.resolve(I.path,w);return[{searchPath:I.with({path:k})}]}const m=v(w);return[{searchPath:I,pattern:m}]}else{if(w==="./"||w===".\\")return[];{const I=w.replace(/^\.[\/\\]/,""),k=this.workspaceContextService.getWorkspace().folders.map(R=>{const L=I.match(new RegExp(`^${t.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return L?{match:L,folder:R}:null}).filter(y.isDefined);if(k.length)return k.map(R=>{const L=R.match[1];return{searchPath:R.folder.uri,pattern:L&&v(L)}});{const R=w.match(/\.[\/\\](.+)[\/\\]?/),L=R?R[1]:w,b=s.localize(0,null,L);throw new Error(b)}}}}resolveOneSearchPathPattern(w,I){const m=w.pattern&&I?`${w.pattern}/${I}`:w.pattern||I,k=[{searchPath:w.searchPath,pattern:m}];return m&&!m.endsWith("**")&&k.push({searchPath:w.searchPath,pattern:m+"/**"}),k}getFolderQueryForSearchPath(w,I,m){const k=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(w.searchPath),I,m,!1);return k?{...k,includePattern:w.pattern}:null}getFolderQueryForRoot(w,I,m,k){let R;const L=n.URI.isUri(w)?w:w.uri;if(m.searchPaths){const K=m.searchPaths.filter(H=>(0,T.isEqual)(H.searchPath,L))[0];if(K&&!K.pattern)return null;K&&(R=K.pattern)}const b=this.configurationService.getValue({resource:L}),$={...this.getExcludesForFolder(b,I)||{},...R||{}},x=n.URI.isUri(w)?(0,T.basename)(w):w.name;return{folder:L,folderName:k?x:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:b.files&&b.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!b.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!b.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!b.search.followSymlinks}}};u=$e([ze(0,c.IConfigurationService),ze(1,p.IWorkspaceContextService),ze(2,P.IEditorGroupsService),ze(3,D.IPathService)],u),e.QueryBuilder=u;function _(d){const w=d.match(/[\*\{\}\(\)\[\]\?]/);if(w){const I=w.index,m=d.substr(0,I).match(/[/|\\][^/\\]*$/);if(m){let k=d.substr(0,m.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:d.substr((m.index||0)+1)}}}return{pathPortion:d}}function i(...d){return d.length?d.reduce((w,I)=>(w[I]=!0,w),Object.create(null)):void 0}function g(d){return E.splitGlobAware(d,",").map(w=>w.trim()).filter(w=>!!w.length)}function a(d){return[`**/${d}/**`,`**/${d}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function r(d){return d.replace(/\\/g,"/")}function v(d){return r(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(d,w){d=h.distinct(d,k=>k.toString());const I=[],m=w.getWorkspace();return d&&d.forEach(k=>{let R;if(w.getWorkbenchState()===2)R=(0,T.relativePath)(m.folders[0].uri,k),R&&R!=="."&&(R="./"+R);else{const L=w.getWorkspaceFolder(k);if(L){const b=L.name;if(m.folders.filter($=>$.name===b).length===1){const $=(0,T.relativePath)(L.uri,k);$===""?R=`./${L.name}`:R=`./${L.name}/${$}`}else R=k.fsPath}}R&&I.push(R)}),I}e.resolveResourcesForSearchIncludes=o}),define(be[218],Ee([0,1,24,2,21,16,4,217,41,48]),function(se,e,h,M,E,A,F,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function y(c,p){const P=p.activationEvents;if(!P)return Promise.resolve(void 0);const D=[],l=[];for(const r of P)if(/^workspaceContains:/.test(r)){const v=r.substr("workspaceContains:".length);v.indexOf("*")>=0||v.indexOf("?")>=0||c.forceUsingSearch?l.push(v):D.push(v)}if(D.length===0&&l.length===0)return Promise.resolve(void 0);let u;const _=new Promise((r,v)=>{u=r}),i=r=>u({activationEvent:r}),g=Promise.all(D.map(r=>n(c,r,i))).then(()=>{}),a=f(c,p.identifier,l,i);return Promise.all([g,a]).then(()=>{u(void 0)}),_}e.checkActivateWorkspaceContainsExtension=y;async function n(c,p,P){for(const D of c.folders)if(await c.exists(h.joinPath(M.URI.revive(D),p))){P(`workspaceContains:${p}`);return}}async function f(c,p,P,D){if(P.length===0)return Promise.resolve(void 0);const l=new E.CancellationTokenSource,u=c.checkExists(c.folders,P,l.token),_=setTimeout(async()=>{l.cancel(),D(`workspaceContainsTimeout:${P.join(",")}`)},t);let i=!1;try{i=await u}catch(g){A.isPromiseCanceledError(g)||A.onUnexpectedError(g)}l.dispose(),clearTimeout(_),i&&D(`workspaceContains:${P.join(",")}`)}function s(c,p,P,D){const l=c.get(F.IInstantiationService),u=c.get(S.ISearchService),i=l.createInstance(C.QueryBuilder).file(p.map(g=>(0,T.toWorkspaceFolder)(M.URI.revive(g))),{_reason:"checkExists",includePattern:P,exists:!0});return u.fileSearch(i,D).then(g=>!!g.limitHit,g=>A.isPromiseCanceledError(g)?!1:Promise.reject(g))}e.checkGlobFileExists=s});var Ze=this&&this.__classPrivateFieldSet||function(se,e,h,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(se,h):E?E.value=h:e.set(se,h),h},Ae=this&&this.__classPrivateFieldGet||function(se,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!M:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(se):M?M.value:e.get(se)};define(be[33],Ee([0,1,125,17,75,24,12,6,20,2,15,5,32,179,73,31,30,177,16,26,22,153,7,86,4,29,74,13,61,65,40,3,218,69,155,11]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D,l,u,_,i,g,a,r,v,o,d,w,I,m,k,R,L,b){"use strict";var B,$,x;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let K=class Wi extends C.Disposable{constructor(V,J,j,le,ee,ve,Re,Fe,Oe,Ke){super();this._onDidChangeRemoteConnectionData=this._register(new m.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=J,this._extHostContext=j,this._initData=Re,this._extHostWorkspace=le,this._extHostConfiguration=ee,this._logService=ve,this._extHostTunnelService=Oe,this._extHostTerminalService=Ke,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=V.createChild(new d.ServiceCollection([s.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(Ve=>je.add(l.ExtensionIdentifier.toKey(Ve))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,U,Q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,D.transformErrorForSerialization(U),Q)},actualActivateExtension:async(Ve,U)=>{if(je.has(l.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,U),new f.HostExtension;const Q=this._registry.getExtensionDescription(Ve);return this._activateExtension(Q,U)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){D.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(ee=>ee.identifier).filter(ee=>this.isActivated(ee)).map(ee=>this._deactivate(ee))}catch(J){}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,J){return this._activator.activateByEvent(V,J)}_activateById(V,J){return this._activator.activateById(V,J)}activateByIdWithErrors(V,J){return this._activateById(V,J).then(()=>{const j=this._activator.getActivatedExtension(V);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}async _realPathExtensionUri(V){if(V.scheme!==b.Schemas.file)return V;const J=await this._hostUtils.realpath(V.fsPath);return T.URI.file(J)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const V=S.TernarySearchTree.forUris(J=>A.extUriBiasedIgnorePathCase.ignorePathCasing(J));for(const J of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(J)){const j=await this._realPathExtensionUri(J.extensionLocation);V.set(j,J)}return V})()),this._extensionPathIndex}_deactivate(V){let J=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return J;const j=this._activator.getActivatedExtension(V);if(!j)return J;try{typeof j.module.deactivate=="function"&&(J=Promise.resolve(j.module.deactivate()).then(void 0,le=>(this._logService.error(le),Promise.resolve(void 0))))}catch(le){this._logService.error(le)}try{(0,C.dispose)(j.subscriptions)}catch(le){this._logService.error(le)}return J}async _activateExtension(V,J){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,J).then(j=>{const le=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,J),this._logExtensionActivationTimes(V,J,"success",le),j},j=>{throw this._logExtensionActivationTimes(V,J,"failure"),j})}_logExtensionActivationTimes(V,J,j,le){const ee=H(V,J);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ee,...le||{},outcome:j})}_doActivateExtension(V,J){const j=H(V,J);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const le=this._getEntryPoint(V);if(!le)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${V.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this._logService.flush();const ee=new f.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,A.joinPath)(V.extensionLocation,le),ee),this._loadExtensionContext(V)]).then(ve=>(E.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),Wi._callActivate(this._logService,V.identifier,ve[0],ve[1],ee))).then(ve=>(E.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),ve))}_loadExtensionContext(V){const J=new _.ExtensionGlobalMemento(V,this._storage),j=new _.ExtensionMemento(V.identifier.value,!1,this._storage),le=new L.ExtensionSecrets(V,this._secretState),ee=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ve=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([J.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let Fe;return Object.freeze({globalState:J,workspaceState:j,secrets:le,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Oe){return M.join(V.extensionLocation.fsPath,Oe)},get storagePath(){return Re._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(V).fsPath},get logPath(){return M.join(Re._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return T.URI.joinPath(Re._initData.logsLocation,V.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(V)},get globalStorageUri(){return Re._storagePath.globalValue(V)},get extensionMode(){return ee},get extension(){return Fe===void 0&&(Fe=new W(Re,V.identifier,V,ve)),Fe},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(V),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(V)}})})}static _callActivate(V,J,j,le,ee){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,J,j,le,ee).then(ve=>new f.ActivatedExtension(!1,null,ee.build(),j,ve,le.subscriptions))}static _callActivateOptional(V,J,j,le,ee){if(typeof j.activate=="function")try{ee.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${J.value}`);const ve=typeof global=="object"?global:self,Re=j.activate.apply(ve,[le]);return ee.activateCallStop(),ee.activateResolveStart(),Promise.resolve(Re).then(Fe=>(ee.activateResolveStop(),Fe))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(j)}_activateOneStartupFinished(V,J){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:J}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const J of V.activationEvents)J==="onStartupFinished"&&this._activateOneStartupFinished(V,J)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,ee=>{this._logService.error(ee)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ee=>this._handleWorkspaceContainsEagerExtensions(ee.added)));const J=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(J),le=Promise.all([V,j]).then(()=>{});return Promise.race([le,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),le}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(J=>this._handleWorkspaceContainsEagerExtension(V,J))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,J){if(this.isActivated(J.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,le={folders:V.map(ve=>ve.uri),forceUsingSearch:j,exists:ve=>this._hostUtils.exists(ve.fsPath),checkExists:(ve,Re,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(ve,Re,Fe)},ee=await(0,k.checkActivateWorkspaceContainsExtension)(le,J);if(!!ee)return this._activateById(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:ee.activationEvent}).then(void 0,ve=>this._logService.error(ve))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:J}=this._initData.environment;if(!V||!J)throw new Error(h.localize(0,null));const j=await this._loadCommonJSModule(null,J,new f.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(h.localize(1,null,J.toString()));return new Promise((le,ee)=>{const ve=(Oe,Ke)=>{Oe?ee(Oe):le(typeof Ke=="number"&&Ke>0?1:0)},Re=(0,A.originalFSPath)(J),Fe=j.run(Re,ve);Fe&&Fe.then&&Fe.then(()=>{le(0)}).catch(Oe=>{ee(Oe.toString())})})}async $extensionTestsExit(V){this._logService.info(`extension host terminating: test runner requested exit with code ${V}`),this._logService.info(`exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(V,J){return this._resolvers[V]=J,(0,C.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const J=V.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const j=V.substr(0,J);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(V,J){const{authorityPrefix:j,resolver:le}=await this._activateAndGetResolver(V);if(!le)return{type:"error",error:{code:g.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(le)),E.mark(`code/extHost/willResolveAuthority/${j}`);const ee=await le.resolve(V,{resolveAttempt:J});E.mark(`code/extHost/didResolveAuthorityOK/${j}`);const ve={authority:V,host:ee.host,port:ee.port,connectionToken:ee.connectionToken},Re={extensionHostEnv:ee.extensionHostEnv,isTrusted:ee.isTrusted};return{type:"ok",value:{authority:ve,options:Re,tunnelInformation:{environmentTunnels:ee.environmentTunnels}}}}catch(ee){if(E.mark(`code/extHost/didResolveAuthorityError/${j}`),ee instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee}}async $getCanonicalURI(V,J){const{authorityPrefix:j,resolver:le}=await this._activateAndGetResolver(V);if(!le)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const ee=T.URI.revive(J);if(typeof le.getCanonicalURI=="undefined")return ee;const ve=await(0,F.asPromise)(()=>le.getCanonicalURI(ee));return ve||ee}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,J){return J===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(V,!1))}async $activate(V,J){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,J),!0):!1}async $deltaExtensions(V,J){V.forEach(le=>le.extensionLocation=T.URI.revive(le.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(J.map(async le=>{const ee=this._registry.getExtensionDescription(le);ee&&j.delete(await this._realPathExtensionUri(ee.extensionLocation))})),await Promise.all(V.map(async le=>{const ee=await this._realPathExtensionUri(le.extensionLocation);j.set(ee,le)})),this._registry.deltaExtensions(V,J),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let J=u.VSBuffer.alloc(V),j=Math.random()%256;for(let le=0;le<V;le++)J.writeUInt8(j,le);return J}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};K=$e([ze(0,a.IInstantiationService),ze(1,e.IHostUtils),ze(2,o.IExtHostRpcService),ze(3,c.IExtHostWorkspace),ze(4,n.IExtHostConfiguration),ze(5,t.ILogService),ze(6,r.IExtHostInitDataService),ze(7,v.IExtensionStoragePaths),ze(8,w.IExtHostTunnelService),ze(9,I.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function H(ne,V){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class W{constructor(V,J,j,le){B.set(this,void 0),$.set(this,void 0),x.set(this,void 0),Ze(this,B,V,"f"),Ze(this,$,J,"f"),Ze(this,x,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=le}get isActive(){return Ae(this,B,"f").isActivated(Ae(this,x,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,B,"f").getExtensionExports(Ae(this,x,"f"))}activate(){return Ae(this,B,"f").activateByIdWithErrors(Ae(this,x,"f"),{startup:!1,extensionId:Ae(this,$,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,B=new WeakMap,$=new WeakMap,x=new WeakMap}),define(be[100],Ee([0,1,17,2,3,12,5,7,163,31,33,50,168,32,164,13,4,10,91,71]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let u=class{constructor(d,w,I,m,k,R){this._workspaceService=w,this._extensionService=I,this._editorsService=m,this._configurationService=k,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=d.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(b=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,w){const I=d;if(typeof I.sourceReference=="number"&&I.sourceReference>0){let m=`debug:${encodeURIComponent(I.path||"")}`,k="?";return w&&(m+=`${k}session=${encodeURIComponent(w.id)}`,k="&"),m+=`${k}ref=${I.sourceReference}`,M.URI.parse(m)}else{if(I.path)return M.URI.file(I.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const w=[];for(const I of d.getAllExtensionDescriptions())if(I.contributes){const m=I.contributes.debuggers;if(m&&m.length>0)for(const k of m)(0,s.isDebuggerMainContribution)(k)&&w.push(k.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(w=>d.push(w)),d}addBreakpoints(d){this.startBreakpoints();const w=d.filter(k=>{const R=k.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,k),!0)});this.fireBreakpointChanges(w,[],[]);const I=[],m=new Map;for(const k of w)if(k instanceof C.SourceBreakpoint){let R=m.get(k.location.uri.toString());R||(R={type:"sourceMulti",uri:k.location.uri,lines:[]},m.set(k.location.uri.toString(),R),I.push(R)),R.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character})}else k instanceof C.FunctionBreakpoint&&I.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName});return this._debugServiceProxy.$registerBreakpoints(I)}removeBreakpoints(d){this.startBreakpoints();const w=d.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],w,[]);const I=w.filter(R=>R instanceof C.SourceBreakpoint).map(R=>R.id),m=w.filter(R=>R instanceof C.FunctionBreakpoint).map(R=>R.id),k=w.filter(R=>R instanceof C.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(I,m,k)}startDebugging(d,w,I){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,w,{parentSessionID:I.parentSession?I.parentSession.id:void 0,lifecycleManagedByParent:I.lifecycleManagedByParent,repl:I.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:I.noDebug,compact:I.compact,debugUI:I.debugUI,suppressSaveBeforeStart:I.suppressSaveBeforeStart})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,w,I){if(!w)return new C.Disposable(()=>{});const m=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:m,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,I,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,m),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(k=>k.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(d,w,I){if(!I)return new C.Disposable(()=>{});if(!this.definesDebugType(d,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:m,factory:I}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,m),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(k=>k.factory!==I),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(d,w){if(!w)return new C.Disposable(()=>{});const I=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:I,factory:w}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(m=>m.factory!==w)})}async $runInTerminal(d,w){return Promise.resolve(void 0)}async $substituteVariables(d,w){if(!this._variableResolver){const[k,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(k||[],this._editorsService,R)}let I;const m=await this.getFolder(d);return m&&(I={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(I,w)}createDebugAdapter(d,w){if(d.type==="implementation")return new r(d.implementation)}createSignService(){}async $startDASession(d,w){const I=this,m=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(m.type),m).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const R=this.convertToDto(k),L=this.createDebugAdapter(R,m);if(!L)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const b=L;return this._debugAdapters.set(d,b),this.getDebugAdapterTrackers(m).then(B=>(B&&this._debugAdaptersTrackers.set(d,B),b.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const x=$,K={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(x.arguments.value);K.body={signature:H},b.sendResponse(K)}else throw new Error("no signer")}catch(H){K.success=!1,K.message=H.message,b.sendResponse(K)}}else B&&B.onDidSendMessage&&B.onDidSendMessage($),$=(0,s.convertToVSCPaths)($,!0),I._debugServiceProxy.$acceptDAMessage(d,$)}),b.onError($=>{B&&B.onError&&B.onError($),this._debugServiceProxy.$acceptDAError(d,$.name,$.message,$.stack)}),b.onExit($=>{B&&B.onExit&&B.onExit((0,P.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,P.withNullAsUndefined)($),void 0)}),B&&B.onWillStartSession&&B.onWillStartSession(),b.startSession()))})}$sendDAMessage(d,w){w=(0,s.convertToDAPaths)(w,!1);const I=this._debugAdaptersTrackers.get(d);I&&I.onWillReceiveMessage&&I.onWillReceiveMessage(w);const m=this._debugAdapters.get(d);m&&m.sendMessage(w)}$stopDASession(d){const w=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),w&&w.onWillStopSession&&w.onWillStopSession();const I=this._debugAdapters.get(d);return this._debugAdapters.delete(d),I?I.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const w=[],I=[],m=[];if(d.added)for(const k of d.added){const R=k.id;if(R&&!this._breakpoints.has(R)){let L;if(k.type==="function")L=new C.FunctionBreakpoint(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage);else if(k.type==="data")L=new C.DataBreakpoint(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage);else{const b=M.URI.revive(k.uri);L=new C.SourceBreakpoint(new C.Location(b,new C.Position(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage)}L._id=R,this._breakpoints.set(R,L),w.push(L)}}if(d.removed)for(const k of d.removed){const R=this._breakpoints.get(k);R&&(this._breakpoints.delete(k),I.push(R))}if(d.changed){for(const k of d.changed)if(k.id){const R=this._breakpoints.get(k.id);if(R){if(R instanceof C.FunctionBreakpoint&&k.type==="function"){const L=R;L.enabled=k.enabled,L.condition=k.condition,L.hitCondition=k.hitCondition,L.logMessage=k.logMessage,L.functionName=k.functionName}else if(R instanceof C.SourceBreakpoint&&k.type==="source"){const L=R;L.enabled=k.enabled,L.condition=k.condition,L.hitCondition=k.hitCondition,L.logMessage=k.logMessage,L.location=new C.Location(M.URI.revive(k.uri),new C.Position(k.line,k.character))}m.push(R)}}}this.fireBreakpointChanges(w,I,m)}$provideDebugConfigurations(d,w,I){return(0,A.asPromise)(async()=>{const m=this.getConfigProviderByHandle(d);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.getFolder(w);return m.provideDebugConfigurations(k,I)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(d,w,I,m){return(0,A.asPromise)(async()=>{const k=this.getConfigProviderByHandle(d);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(w);return k.resolveDebugConfiguration(R,I,m)})}$resolveDebugConfigurationWithSubstitutedVariables(d,w,I,m){return(0,A.asPromise)(async()=>{const k=this.getConfigProviderByHandle(d);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(w);return k.resolveDebugConfigurationWithSubstitutedVariables(R,I,m)})}async $provideDebugAdapter(d,w){const I=this.getAdapterDescriptorFactoryByHandle(d);if(!I)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.getSession(w);return this.getAdapterDescriptor(I,m).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.convertToDto(k)})}async $acceptDebugSessionStarted(d){const w=await this.getSession(d);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(d){const w=await this.getSession(d);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,w){const I=await this.getSession(d);I&&I._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(d,w){const m={session:await this.getSession(d),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(m)}convertToDto(d){if(d instanceof C.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof C.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const w=this._adapterFactories.filter(I=>I.type===d);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(d){const w=this._adapterFactories.filter(I=>I.handle===d);if(w.length>0)return w[0].factory}getConfigProviderByHandle(d){const w=this._configProviders.filter(I=>I.handle===d);if(w.length>0)return w[0].provider}definesDebugType(d,w){if(d.contributes){const I=d.contributes.debuggers;if(I&&I.length>0){for(const m of I)if(m.label&&m.type&&m.type===w)return!0}}return!1}getDebugAdapterTrackers(d){const I=d.configuration.type,m=this._trackerFactories.filter(k=>k.type===I||k.type==="*").map(k=>(0,A.asPromise)(()=>k.factory.createDebugAdapterTracker(d)).then(R=>R,R=>null));return Promise.race([Promise.all(m).then(k=>{const R=k.filter(L=>!!L);if(R.length>0)return new a(R)}),new Promise((k,R)=>{const L=setTimeout(()=>{clearTimeout(L),R(new Error("timeout"))},1e3)})]).catch(k=>{})}async getAdapterDescriptor(d,w){const I=w.configuration.debugServer;if(typeof I=="number")return Promise.resolve(new C.DebugAdapterServer(I));if(d){const k=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>d.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,k))).then(R=>{if(R)return R})}const m=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,m))}daExecutableFromPackage(d,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,w,I){(d.length>0||w.length>0||I.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:w,changed:I}))}async getSession(d){if(d)if(typeof d=="string"){const w=this._debugSessions.get(d);if(w)return w}else{let w=this._debugSessions.get(d.id);if(!w){const I=await this.getFolder(d.folderUri),m=d.parent?this._debugSessions.get(d.parent):void 0;w=new _(this._debugServiceProxy,d.id,d.type,d.name,I,d.configuration,m),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(d){if(d){const w=M.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};u=$e([ze(0,c.IExtHostRpcService),ze(1,T.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,y.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,l.IExtHostEditorTabs)],u),e.ExtHostDebugServiceBase=u;class _{constructor(d,w,I,m,k,R,L){this._debugServiceProxy=d,this._id=w,this._type=I,this._name=m,this._workspaceFolder=k,this._configuration=R,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,w)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=_;class i{constructor(d){this.value=Object.freeze({append(w){d.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=i;class g extends n.AbstractVariableResolverService{constructor(d,w,I,m,k){function R(){if(w){const L=w.activeEditor();if(L)return L.document.uri;const b=m.tabs.filter(B=>B.isActive);if(b.length>0){const B=b[0].resource;return B&&(B.primary||B.secondary)?B.primary??B.secondary:b[0].resource}}}super({getFolderUri:L=>{const b=d.filter(B=>B.name===L);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(L,b)=>I.getConfiguration(void 0,L).get(b),getAppRoot:()=>D.cwd(),getExecPath:()=>D.env.VSCODE_EXEC_PATH,getFilePath:()=>{const L=R();if(L)return h.normalize(L.fsPath)},getWorkspaceFolderPathForFile:()=>{if(k){const L=R();if(L){const b=k.getWorkspaceFolder(L);if(b)return h.normalize(b.uri.fsPath)}}},getSelectedText:()=>{if(w){const L=w.activeEditor();if(L&&!L.selection.isEmpty)return L.document.getText(L.selection)}},getLineNumber:()=>{if(w){const L=w.activeEditor();if(L)return String(L.selection.end.line+1)}}},void 0,Promise.resolve(D.env))}}e.ExtHostVariableResolverService=g;class a{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(w=>w.onError?w.onError(d):void 0)}onExit(d,w){this.trackers.forEach(I=>I.onExit?I.onExit(d,w):void 0)}}class r extends S.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let v=class extends u{constructor(d,w,I,m,k,R){super(d,w,I,m,k,R)}createVariableResolver(d,w,I){return new g(d,w,I,this._editorTabs)}};v=$e([ze(0,c.IExtHostRpcService),ze(1,T.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,y.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,l.IExtHostEditorTabs)],v),e.WorkerExtHostDebugService=v}),define(be[219],Ee([0,1,75,2,5,32,30,26,13,29,4,33,91,15]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(l,u,_,i,g,a,r){this._apiFactory=l,this._extensionRegistry=u,this._instaService=_,this._extHostConfiguration=i,this._extHostExtensionService=g,this._initData=a,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new c(this._apiFactory,u,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(P,u,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let u of l.nodeModuleName)this._factories.set(u,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(u=>l.alternativeModuleName(u))}};s=$e([ze(2,t.IInstantiationService),ze(3,A.IExtHostConfiguration),ze(4,y.IExtHostExtensionService),ze(5,T.IExtHostInitDataService),ze(6,f.ILogService)],s),e.RequireInterceptor=s;class c{constructor(l,u,_,i,g){this._apiFactory=l,this._extensionPaths=u,this._extensionRegistry=_,this._configProvider=i,this._logService=g,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,u){const _=this._extensionPaths.findSubstr(u);if(_){let i=this._extApiImpl.get(C.ExtensionIdentifier.toKey(_.identifier));return i||(i=this._apiFactory(_,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(_.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((g,a)=>i+=`	${a} -> ${g.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(l,u){this.nodeModuleName="keytar";const{environment:_}=u,i=l.getProxy(E.MainContext.MainThreadKeytar);if(_.appRoot){let g=_.appRoot.fsPath;n.platform==="win32"&&(g=g.replace(/\\/g,"/")),g[g.length-1]==="/"&&(g=g.substr(0,g.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${g}/node_modules.asar/keytar`),this.alternativeNames.add(`${g}/node_modules/keytar`)}this._impl={getPassword:(g,a)=>i.$getPassword(g,a),setPassword:(g,a,r)=>i.$setPassword(g,a,r),deletePassword:(g,a)=>i.$deletePassword(g,a),findPassword:g=>i.$findPassword(g),findCredentials(g){return i.$findCredentials(g)}}}load(l,u){return this._impl}alternativeModuleName(l){const u=l.length;if(u<=7||!this.alternativeNames)return;const _=u-7;if((l.charAt(_)==="/"||l.charAt(_)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};p=$e([ze(0,S.IExtHostRpcService),ze(1,T.IExtHostInitDataService)],p);let P=class{constructor(l,u,_){this._extensionPaths=l,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=_.getProxy(E.MainContext.MainThreadTelemetry);const i=_.getProxy(E.MainContext.MainThreadWindow);this._impl=(g,a)=>{const r=M.URI.parse(g);return a?this.callOriginal(g,a):r.scheme==="http"||r.scheme==="https"?i.$openUri(r,g,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?i.$openUri(r,g,{}):this.callOriginal(g,a)}}load(l,u,_){const i=this._extensionPaths.findSubstr(u);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=_(l),this._impl}callOriginal(l,u){return this.sendNoForwardTelemetry(),this._original(l,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};P=$e([ze(2,S.IExtHostRpcService)],P)}),define(be[220],Ee([0,1,12,16,75,6,2,5,213,15,57,61,29,143,13,66,33,40]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class D{constructor(u,_,i,g){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new S.RPCProtocol(u,null,g),_=D._transform(_,this._rpcProtocol);const a=new y.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());a.set(n.IExtHostInitDataService,{_serviceBrand:void 0,..._}),a.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),a.set(c.IURITransformerService,new c.URITransformerService(g)),a.set(p.IHostUtils,i);const r=new f.InstantiationService(a,!0),v=r.invokeFunction(I=>I.get(P.IExtHostTerminalService));this._disposables.add(v),this._logService=r.invokeFunction(I=>I.get(T.ILogService)),E.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",_),this._extensionService=r.invokeFunction(I=>I.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const o=new WeakMap;this._extensionService.getExtensionPathIndex().then(I=>{Error.prepareStackTrace=(m,k)=>{let R="",L,b;for(const B of k)R+=`
	at ${B.toString()}`,b=B.getFileName(),!L&&b&&(L=I.findSubstr(F.URI.file(b)));return o.set(m,L),`${m.name||"Error"}: ${m.message||""}${R}`}});const d=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(I=>{const m=M.transformErrorForSerialization(I),k=o.get(I);k?d.$onExtensionRuntimeError(k.identifier,m):w.$onUnexpectedError(m)})}terminate(u){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const _=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,h.timeout)(4e3),_]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(u,_){u.extensions.forEach(g=>g.extensionLocation=F.URI.revive(_.transformIncomingURIs(g.extensionLocation))),u.environment.appRoot=F.URI.revive(_.transformIncomingURIs(u.environment.appRoot));const i=u.environment.extensionDevelopmentLocationURI;return i&&(u.environment.extensionDevelopmentLocationURI=i.map(g=>F.URI.revive(_.transformIncomingURIs(g)))),u.environment.extensionTestsLocationURI=F.URI.revive(_.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=F.URI.revive(_.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=F.URI.revive(_.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=F.URI.revive(_.transformIncomingURIs(u.logsLocation)),u.logFile=F.URI.revive(_.transformIncomingURIs(u.logFile)),u.workspace=_.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=D}),define(be[221],Ee([0,1,17,21,45,27,24,194,41]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(n,f,s){this.config=n,this.provider=f,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const f=this.config.folderQueries||[];return new Promise((s,c)=>{const p=P=>{this.resultCount++,n(P)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const D=P.toString(),l=h.basename(D);this.globalExcludePattern&&this.globalExcludePattern(D,l)||this.matchFile(p,{base:P,basename:l})}),Promise.all(f.map(P=>this.searchInFolder(P,p))).then(P=>{s({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{c(new Error((0,E.toErrorMessage)(P)))})})}async searchInFolder(n,f){const s=new M.CancellationTokenSource,c=this.getSearchOptionsForFolder(n),p=this.initDirectoryTree(),P=new S.QueryGlobTester(this.config,n),D=!P.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(s),l=C.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,s.token),_=l.elapsed(),i=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(g=>{const a=h.posix.relative(n.folder.path,g.path);if(D){const r=h.basename(g.path);this.matchFile(f,{base:n.folder,relativePath:a,basename:r});return}this.addDirectoryEntries(p,n.folder,a,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,P,f),{providerTime:_,postProcessTime:i.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(n){const f=(0,S.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),s=(0,S.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:s,includes:f,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},f,s,c){if(s===this.filePattern){const P=h.basename(this.filePattern);this.matchFile(c,{base:f,relativePath:this.filePattern,basename:P})}function p(P){const D=h.basename(P),l=h.dirname(P);let u=n[l];u||(u=n[l]=[],p(l)),u.push({base:f,relativePath:P,basename:D})}p(s)}matchDirectoryTree({rootEntries:n,pathToEntries:f},s,c){const p=this,P=this.filePattern;function D(l){const u=A.hasSiblingFn(()=>l.map(_=>_.basename));for(let _=0,i=l.length;_<i;_++){const g=l[_],{relativePath:a,basename:r}=g;if(s.matchesExcludesSync(a,r,P!==r?u:void 0))continue;const v=f[a];if(v)D(v);else{if(a===P)continue;p.matchFile(c,g)}if(p.isLimitHit)break}}D(n)}matchFile(n,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(f))}}class t{constructor(){this.sessions=new Map}fileSearch(n,f,s,c){const p=this.getSessionTokenSource(n.cacheKey),P=new T(n,f,p&&p.token);let D=0;const l=u=>{D+=u.length,s(u.map(_=>this.rawMatchToSearchItem(_)))};return this.doSearch(P,t.BATCH_SIZE,l,c).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:D,detailStats:u.stats}}))}clearCache(n){const f=this.getSessionTokenSource(n);f&&f.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,f,s,c){c.onCancellationRequested(()=>{n.cancel()});const p=D=>{D&&(P.push(D),f>0&&P.length>=f&&(s(P),P=[]))};let P=[];return n.search(p).then(D=>(P.length&&s(P),D),D=>(P.length&&s(P),Promise.reject(D)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[222],Ee([0,1,14,21,45,27,11,17,24,10,2,41]),function(se,e,h,M,E,A,F,C,S,T,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(l,u,_,i){this.query=l,this.provider=u,this.fileUtils=_,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,u){const _=this.query.folderQueries||[],i=new M.CancellationTokenSource;return u.onCancellationRequested(()=>i.cancel()),new Promise((g,a)=>{this.collector=new s(l);let r=!1;const v=(o,d)=>{if(!r&&!this.isLimitHit){const w=this.resultSize(o);p(o)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,r=!0,i.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const I=this.resultSize(o);this.resultCount+=I,(I>0||!p(o))&&this.collector.add(o,d)}};Promise.all(_.map((o,d)=>this.searchInFolder(o,w=>v(w,d),i.token))).then(o=>{i.dispose(),this.collector.flush();const d=o.some(w=>!!w&&!!w.limitHit);g({limitHit:this.isLimitHit||d,messages:(0,h.flatten)(o.map(w=>w?.message?(0,T.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},o=>{i.dispose();const d=(0,E.toErrorMessage)(o);a(new Error(d))})})}resultSize(l){return p(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,u){const _=Array.isArray(l.ranges)?l.ranges:[l.ranges],i=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:_.slice(0,u),preview:{matches:i.slice(0,u),text:l.preview.text},uri:l.uri}}async searchInFolder(l,u,_){const i=new y.QueryGlobTester(this.query,l),g=[],a={report:o=>{if(!this.validateProviderResult(o))return;const d=l.folder.scheme===F.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(o.uri))):void 0,w=S.relativePath(l.folder,o.uri);if(w){const I=i.includedInQuery(w,C.basename(w),d);(0,T.isPromise)(I)?g.push(I.then(m=>{m&&u(o)})):I&&u(o)}}},r=this.getSearchOptionsForFolder(l),v=await this.provider.provideTextSearchResults(f(this.query.contentPattern),r,a,_);return g.length&&await Promise.all(g),v}validateProviderResult(l){if(p(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const u=(0,y.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),_=(0,y.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),i={folder:t.URI.from(l.folder),excludes:_,includes:u,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function f(D){return{isCaseSensitive:D.isCaseSensitive||!1,isRegExp:D.isRegExp||!1,isWordMatch:D.isWordMatch||!1,isMultiline:D.isMultiline||!1,pattern:D.pattern}}class s{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,u=>this.sendItems(u))}add(l,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!S.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(c(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=s;function c(D){return p(D)?{preview:{matches:(0,h.mapArrayOrNot)(D.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:D.preview.text},ranges:(0,h.mapArrayOrNot)(D.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:D.text,lineNumber:D.lineNumber}}function p(D){return!!D.preview}e.extensionResultIsMatch=p;class P{constructor(l,u){this.maxBatchSize=l,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,u){!l||this.addItemToBatch(l,u)}addItems(l,u){!l||this.addItemsToBatch(l,u)}addItemToBatch(l,u){this.batch.push(l),this.batchSize+=u,this.onUpdate()}addItemsToBatch(l,u){this.batch=this.batch.concat(l),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,221,13,66,15,2,222]),function(se,e,h,M,E,A,F,C,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let y=class{constructor(c,p,P){this.extHostRpc=c,this._uriTransformer=p,this._logService=P,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,p){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const P=this._handlePool++;return this._textSearchProvider.set(P,p),this._proxy.$registerTextSearchProvider(P,this._transformScheme(c)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(c,p){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const P=this._handlePool++;return this._fileSearchProvider.set(P,p),this._proxy.$registerFileSearchProvider(P,this._transformScheme(c)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(c,p,P,D){const l=n(P),u=this._fileSearchProvider.get(c);if(u)return this._fileSearchManager.fileSearch(l,u,_=>{this._proxy.$handleFileMatch(c,p,_.map(i=>i.resource))},D);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,p,P,D){const l=this._textSearchProvider.get(c);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const u=n(P);return this.createTextSearchManager(u,l).search(i=>this._proxy.$handleTextMatch(c,p,i),D)}$enableExtensionHostSearch(){}createTextSearchManager(c,p){return new t.TextSearchManager(c,p,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};y=$e([ze(0,F.IExtHostRpcService),ze(1,C.IURITransformerService),ze(2,S.ILogService)],y),e.ExtHostSearch=y;function n(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(f),extraFileResources:s.extraFileResources&&s.extraFileResources.map(c=>T.URI.revive(c))}}e.reviveQuery=n;function f(s){return{...s,folder:T.URI.revive(s.folder)}}}),define(be[223],Ee([0,1,21,16,3,35,2,117,80,113,56,60,5,184,183,39,185,32,186,187,188,170,189,50,33,190,171,193,195,196,96,173,201,202,203,73,40,205,174,8,7,208,51,97,31,30,52,160,192,63,95,99,100,101,15,66,13,29,197,157,65,70,181,206,156,74,72,211,209,210,182,37,204,207,69,71,87,199,98,200,11,145,198,154,191]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D,l,u,_,i,g,a,r,v,o,d,w,I,m,k,R,L,b,B,$,x,K,H,W,ne,V,J,j,le,ee,ve,Re,Fe,Oe,Ke,je,Ve,U,Q,te,ae,G,oe,he,Te,Be,He,Qe,et,ot,ye,nt,q,Z,pe,We,Ye,rt,ft,dt,St,It,Tt,Xe,vt,Pe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(ie){const ue=ie.get(te.IExtHostInitDataService),me=ie.get(Z.IExtHostFileSystemInfo),fe=ie.get(et.IExtHostConsumerFileSystem),Ie=ie.get(a.IExtHostExtensionService),xe=ie.get(J.IExtHostWorkspace),Ne=ie.get(ft.IExtHostTelemetry),qe=ie.get(P.IExtHostConfiguration),it=ie.get(U.IURITransformerService),Le=ie.get(Q.IExtHostRpcService),de=ie.get(b.IExtHostStorage),ge=ie.get(Qe.IExtensionStoragePaths),X=ie.get(Ve.ILogService),z=ie.get(oe.IExtHostTunnelService),we=ie.get(he.IExtHostApiDeprecationService),ke=ie.get(V.IExtHostWindow),Je=ie.get(Ye.IExtHostSecretState),Ue=ie.get(rt.IExtHostEditorTabs);Le.set(n.ExtHostContext.ExtHostFileSystemInfo,me),Le.set(n.ExtHostContext.ExtHostLogService,X),Le.set(n.ExtHostContext.ExtHostWorkspace,xe),Le.set(n.ExtHostContext.ExtHostConfiguration,qe),Le.set(n.ExtHostContext.ExtHostExtensionService,Ie),Le.set(n.ExtHostContext.ExtHostStorage,de),Le.set(n.ExtHostContext.ExtHostTunnelService,z),Le.set(n.ExtHostContext.ExtHostWindow,ke),Le.set(n.ExtHostContext.ExtHostSecretState,Je),Le.set(n.ExtHostContext.ExtHostTelemetry,Ne),Le.set(n.ExtHostContext.ExtHostEditorTabs,Ue);const ct=Le.set(n.ExtHostContext.ExtHostDecorations,ie.get(Fe.IExtHostDecorations)),pt=Le.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ie.get(g.IExtHostDocumentsAndEditors)),lt=Le.set(n.ExtHostContext.ExtHostCommands,ie.get(c.IExtHostCommands)),gt=Le.set(n.ExtHostContext.ExtHostTerminalService,ie.get(B.IExtHostTerminalService)),ht=Le.set(n.ExtHostContext.ExtHostDebugService,ie.get(Ke.IExtHostDebugService)),_t=Le.set(n.ExtHostContext.ExtHostSearch,ie.get(je.IExtHostSearch)),wt=Le.set(n.ExtHostContext.ExtHostTask,ie.get(Oe.IExtHostTask)),Ft=Le.set(n.ExtHostContext.ExtHostOutputService,ie.get(I.IExtHostOutputService)),Vt=Le.set(n.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(Le)),Dt=Le.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Le,pt)),Mt=Le.set(n.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(Le,pt,X)),ti=Le.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new _.ExtHostDocumentSaveParticipant(X,Dt,Le.getProxy(n.MainContext.MainThreadBulkEdits))),bt=Le.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Le,lt,pt,Dt,ge)),Qt=Le.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(X,bt)),jt=Le.set(n.ExtHostContext.ExtHostNotebookEditors,new vt.ExtHostNotebookEditors(X,Le,bt)),ii=Le.set(n.ExtHostContext.ExtHostNotebookKernels,new dt.ExtHostNotebookKernels(Le,ue,bt,lt,X)),ni=Le.set(n.ExtHostContext.ExtHostNotebookRenderers,new It.ExtHostNotebookRenderers(Le,bt)),Pt=Le.set(n.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(Le,pt)),Yt=Le.set(n.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(Le.getProxy(n.MainContext.MainThreadTreeViews),lt,X)),wi=Le.set(n.ExtHostContext.ExtHostEditorInsets,new ee.ExtHostEditorInsets(Le.getProxy(n.MainContext.MainThreadEditorInsets),Pt,ue)),Wt=Le.set(n.ExtHostContext.ExtHostDiagnostics,new D.ExtHostDiagnostics(Le,X,me)),Ht=Le.set(n.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(Le,Dt,lt.converter,it)),mt=Le.set(n.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(Le,it,Dt,lt,Wt,X,we)),ri=Le.set(n.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Le,mt)),xt=Le.set(n.ExtHostContext.ExtHostFileSystemEventService,new v.ExtHostFileSystemEventService(Le,X,pt)),Bt=Le.set(n.ExtHostContext.ExtHostQuickOpen,(0,k.createExtHostQuickOpen)(Le,xe,lt)),Jt=Le.set(n.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(Le,lt,X)),bi=Le.set(n.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(Le,lt,Dt)),hi=Le.set(n.ExtHostContext.ExtHostProgress,new m.ExtHostProgress(Le.getProxy(n.MainContext.MainThreadProgress))),Ei=Le.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Le)),fi=Le.set(n.ExtHostContext.ExtHostTheming,new G.ExtHostTheming(Le)),Xt=Le.set(n.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(Le)),si=Le.set(n.ExtHostContext.ExtHostTimeline,new Be.ExtHostTimeline(Le,lt)),qt=Le.set(n.ExtHostContext.ExtHostWebviews,new ne.ExtHostWebviews(Le,{remote:ue.remote},xe,X,we)),oi=Le.set(n.ExtHostContext.ExtHostWebviewPanels,new nt.ExtHostWebviewPanels(Le,qt,xe)),_i=Le.set(n.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Le,Dt,ge,qt,oi)),yi=Le.set(n.ExtHostContext.ExtHostWebviewViews,new ot.ExtHostWebviewViews(Le,qt)),Gt=Le.set(n.ExtHostContext.ExtHostTesting,new pe.ExtHostTesting(Le,lt)),Zt=Le.set(n.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(Le));Le.set(n.ExtHostContext.ExtHostInteractive,new Se.ExtHostInteractive(Le,bt,pt,lt));const Si=(0,le.values)(n.ExtHostContext);Le.assertRegistered(Si);const Di=new q.ExtHostBulkEdits(Le,pt),ai=new s.ExtHostClipboard(Le),li=new w.ExtHostMessageService(Le,X),zt=new l.ExtHostDialogs(Le),Ot=new L.ExtHostStatusBar(Le,lt.converter);return f.ExtHostApiCommands.register(lt),function(Me,Rt,Kt){const Et=function(){let Y=!Me.isUnderDevelopment;function ce(De){Y||(X.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function De(st){if(Array.isArray(st))st.forEach(De);else if(typeof st=="string")ce(st);else{const yt=st;typeof yt.scheme=="undefined"&&ce(st),!Me.enableProposedApi&&typeof yt.exclusive=="boolean"&&(0,j.throwProposedApiError)(Me)}return st}}(),Ci={getSession(Y,ce,De){return De?.forceNewSession&&(0,j.checkProposedApiEnabled)(Me),Xt.getSession(Me,Y,ce,De)},async hasSession(Y,ce){return(0,j.checkProposedApiEnabled)(Me),!!await Xt.getSession(Me,Y,ce,{solelyCheckExistence:!0})},get onDidChangeSessions(){return Xt.onDidChangeSessions},registerAuthenticationProvider(Y,ce,De,st){return Xt.registerAuthenticationProvider(Y,ce,De,st)}},ki={registerCommand(Y,ce,De){return lt.registerCommand(!0,Y,ce,De,void 0,Me)},registerTextEditorCommand(Y,ce,De){return lt.registerCommand(!0,Y,(...st)=>{const yt=Pt.getActiveTextEditor();if(!yt){X.warn("Cannot execute "+Y+" because there is no active text editor.");return}return yt.edit(kt=>{ce.apply(De,[yt,kt,...st])}).then(kt=>{kt||X.warn("Edits from command "+Y+" were not applied.")},kt=>{X.warn("An error occurred while running command "+Y,kt)})},void 0,void 0,Me)},registerDiffInformationCommand:(Y,ce,De)=>((0,j.checkProposedApiEnabled)(Me),lt.registerCommand(!0,Y,async(...st)=>{const yt=pt.activeEditor(!0);if(!yt){X.warn("Cannot execute "+Y+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(yt.id);ce.apply(De,[kt,...st])},void 0,void 0,Me)),executeCommand(Y,...ce){return lt.executeCommand(Y,...ce)},getCommands(Y=!1){return lt.getCommands(Y)}},mi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return ai.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ne.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ne.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ce){return ke.openUri(Y,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===ue.environment.appUriScheme)return Vt.createAppUri(Y);try{return await ke.asExternalUri(Y,{allowTunneling:!!ue.remote.authority})}catch(ce){if((0,Xe.matchesScheme)(Y,Tt.Schemas.http)||(0,Xe.matchesScheme)(Y,Tt.Schemas.https))return Y;throw ce}},get remoteName(){return(0,Re.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,j.checkProposedApiEnabled)(Me),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ue.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ii={createTestController(Y,ce){return Gt.createTestController(Y,ce)},createTestObserver(){return(0,j.checkProposedApiEnabled)(Me),Gt.createTestObserver()},runTests(Y){return(0,j.checkProposedApiEnabled)(Me),Gt.runTests(Y)},get onDidChangeTestResults(){return(0,j.checkProposedApiEnabled)(Me),Gt.onResultsChanged},get testResults(){return(0,j.checkProposedApiEnabled)(Me),Gt.results}},Pi={getExtension(Y){const ce=Rt.getExtensionDescription(Y);if(ce)return new a.Extension(Ie,Me.identifier,ce,gi)},get all(){return Rt.getAllExtensionDescriptions().map(Y=>new a.Extension(Ie,Me.identifier,Y,gi))},get onDidChange(){return Rt.onDidChange}},ui={createDiagnosticCollection(Y){return Wt.createDiagnosticCollection(Me.identifier,Y)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:Y=>Wt.getDiagnostics(Y),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(Y,ce){return Ht.changeLanguage(Y.uri,ce)},match(Y,ce){return(0,t.score)(K.LanguageSelector.from(Y),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(Y,ce,De){return mt.registerCodeActionProvider(Me,Et(Y),ce,De)},registerCodeLensProvider(Y,ce){return mt.registerCodeLensProvider(Me,Et(Y),ce)},registerDefinitionProvider(Y,ce){return mt.registerDefinitionProvider(Me,Et(Y),ce)},registerDeclarationProvider(Y,ce){return mt.registerDeclarationProvider(Me,Et(Y),ce)},registerImplementationProvider(Y,ce){return mt.registerImplementationProvider(Me,Et(Y),ce)},registerTypeDefinitionProvider(Y,ce){return mt.registerTypeDefinitionProvider(Me,Et(Y),ce)},registerHoverProvider(Y,ce){return mt.registerHoverProvider(Me,Et(Y),ce,Me.identifier)},registerEvaluatableExpressionProvider(Y,ce){return mt.registerEvaluatableExpressionProvider(Me,Et(Y),ce,Me.identifier)},registerInlineValuesProvider(Y,ce){return mt.registerInlineValuesProvider(Me,Et(Y),ce,Me.identifier)},registerDocumentHighlightProvider(Y,ce){return mt.registerDocumentHighlightProvider(Me,Et(Y),ce)},registerLinkedEditingRangeProvider(Y,ce){return mt.registerLinkedEditingRangeProvider(Me,Et(Y),ce)},registerReferenceProvider(Y,ce){return mt.registerReferenceProvider(Me,Et(Y),ce)},registerRenameProvider(Y,ce){return mt.registerRenameProvider(Me,Et(Y),ce)},registerDocumentSymbolProvider(Y,ce,De){return mt.registerDocumentSymbolProvider(Me,Et(Y),ce,De)},registerWorkspaceSymbolProvider(Y){return mt.registerWorkspaceSymbolProvider(Me,Y)},registerDocumentFormattingEditProvider(Y,ce){return mt.registerDocumentFormattingEditProvider(Me,Et(Y),ce)},registerDocumentRangeFormattingEditProvider(Y,ce){return mt.registerDocumentRangeFormattingEditProvider(Me,Et(Y),ce)},registerOnTypeFormattingEditProvider(Y,ce,De,...st){return mt.registerOnTypeFormattingEditProvider(Me,Et(Y),ce,[De].concat(st))},registerDocumentSemanticTokensProvider(Y,ce,De){return mt.registerDocumentSemanticTokensProvider(Me,Et(Y),ce,De)},registerDocumentRangeSemanticTokensProvider(Y,ce,De){return mt.registerDocumentRangeSemanticTokensProvider(Me,Et(Y),ce,De)},registerSignatureHelpProvider(Y,ce,De,...st){return typeof De=="object"?mt.registerSignatureHelpProvider(Me,Et(Y),ce,De):mt.registerSignatureHelpProvider(Me,Et(Y),ce,typeof De=="undefined"?[]:[De,...st])},registerCompletionItemProvider(Y,ce,...De){return mt.registerCompletionItemProvider(Me,Et(Y),ce,De)},registerInlineCompletionItemProvider(Y,ce){return(0,j.checkProposedApiEnabled)(Me),mt.registerInlineCompletionsProvider(Me,Et(Y),ce)},registerDocumentLinkProvider(Y,ce){return mt.registerDocumentLinkProvider(Me,Et(Y),ce)},registerColorProvider(Y,ce){return mt.registerColorProvider(Me,Et(Y),ce)},registerFoldingRangeProvider(Y,ce){return mt.registerFoldingRangeProvider(Me,Et(Y),ce)},registerSelectionRangeProvider(Y,ce){return mt.registerSelectionRangeProvider(Me,Y,ce)},registerCallHierarchyProvider(Y,ce){return mt.registerCallHierarchyProvider(Me,Y,ce)},registerTypeHierarchyProvider(Y,ce){return mt.registerTypeHierarchyProvider(Me,Y,ce)},setLanguageConfiguration:(Y,ce)=>mt.setLanguageConfiguration(Me,Y,ce),getTokenInformationAtPosition(Y,ce){return(0,j.checkProposedApiEnabled)(Me),Ht.tokenAtPosition(Y,ce)},registerInlayHintsProvider(Y,ce){return(0,j.checkProposedApiEnabled)(Me),mt.registerInlayHintsProvider(Me,Y,ce)},createLanguageStatusItem(Y,ce){return(0,j.checkProposedApiEnabled)(Me),Ht.createLanguageStatusItem(Me,Y,ce)}},Ti={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(Y,ce,De){const st=await(F.URI.isUri(Y)?Promise.resolve(pi.openTextDocument(Y)):Promise.resolve(Y));return Pt.showTextDocument(st,ce,De)},createTextEditorDecorationType(Y){return Pt.createTextEditorDecorationType(Me,Y)},onDidChangeActiveTextEditor(Y,ce,De){return Pt.onDidChangeActiveTextEditor(Y,ce,De)},onDidChangeVisibleTextEditors(Y,ce,De){return Pt.onDidChangeVisibleTextEditors(Y,ce,De)},onDidChangeTextEditorSelection(Y,ce,De){return Pt.onDidChangeTextEditorSelection(Y,ce,De)},onDidChangeTextEditorOptions(Y,ce,De){return Pt.onDidChangeTextEditorOptions(Y,ce,De)},onDidChangeTextEditorVisibleRanges(Y,ce,De){return Pt.onDidChangeTextEditorVisibleRanges(Y,ce,De)},onDidChangeTextEditorViewColumn(Y,ce,De){return Pt.onDidChangeTextEditorViewColumn(Y,ce,De)},onDidCloseTerminal(Y,ce,De){return gt.onDidCloseTerminal(Y,ce,De)},onDidOpenTerminal(Y,ce,De){return gt.onDidOpenTerminal(Y,ce,De)},onDidChangeActiveTerminal(Y,ce,De){return gt.onDidChangeActiveTerminal(Y,ce,De)},onDidChangeTerminalDimensions(Y,ce,De){return(0,j.checkProposedApiEnabled)(Me),gt.onDidChangeTerminalDimensions(Y,ce,De)},onDidChangeTerminalState(Y,ce,De){return gt.onDidChangeTerminalState(Y,ce,De)},onDidWriteTerminalData(Y,ce,De){return(0,j.checkProposedApiEnabled)(Me),gt.onDidWriteTerminalData(Y,ce,De)},get state(){return ke.state},onDidChangeWindowState(Y,ce,De){return ke.onDidChangeWindowState(Y,ce,De)},showInformationMessage(Y,...ce){return li.showMessage(Me,A.default.Info,Y,ce[0],ce.slice(1))},showWarningMessage(Y,...ce){return li.showMessage(Me,A.default.Warning,Y,ce[0],ce.slice(1))},showErrorMessage(Y,...ce){return li.showMessage(Me,A.default.Error,Y,ce[0],ce.slice(1))},showQuickPick(Y,ce,De){return Bt.showQuickPick(Y,!!Me.enableProposedApi,ce,De)},showWorkspaceFolderPick(Y){return Bt.showWorkspaceFolderPick(Y)},showInputBox(Y,ce){return Bt.showInput(Y,ce)},showOpenDialog(Y){return zt.showOpenDialog(Y)},showSaveDialog(Y){return zt.showSaveDialog(Y)},createStatusBarItem(Y,ce,De){let st,yt,kt;return typeof Y=="string"?(st=Y,yt=ce,kt=De):(yt=Y,kt=ce),Ot.createStatusBarEntry(Me,st,yt,kt)},setStatusBarMessage(Y,ce){return Ot.setStatusBarMessage(Y,ce)},withScmProgress(Y){return we.report("window.withScmProgress",Me,"Use 'withProgress' instead."),hi.withProgress(Me,{location:H.ProgressLocation.SourceControl},(ce,De)=>Y({report(st){}}))},withProgress(Y,ce){return hi.withProgress(Me,Y,ce)},createOutputChannel(Y){return Ft.createOutputChannel(Y,Me)},createWebviewPanel(Y,ce,De,st){return oi.createWebviewPanel(Me,Y,ce,De,st)},createWebviewTextEditorInset(Y,ce,De,st){return(0,j.checkProposedApiEnabled)(Me),wi.createWebviewEditorInset(Y,ce,De,st,Me)},createTerminal(Y,ce,De){return typeof Y=="object"?("location"in Y&&(0,j.checkProposedApiEnabled)(Me),"pty"in Y?gt.createExtensionTerminal(Y):gt.createTerminalFromOptions(Y)):gt.createTerminal(Y,ce,De)},registerTerminalLinkProvider(Y){return gt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ce){return gt.registerProfileProvider(Me,Y,ce)},registerTreeDataProvider(Y,ce){return Yt.registerTreeDataProvider(Y,ce,Me)},createTreeView(Y,ce){return Yt.createTreeView(Y,ce,Me)},registerWebviewPanelSerializer:(Y,ce)=>oi.registerWebviewPanelSerializer(Me,Y,ce),registerCustomEditorProvider:(Y,ce,De={})=>_i.registerCustomEditorProvider(Me,Y,ce,De),registerFileDecorationProvider(Y){return ct.registerFileDecorationProvider(Y,Me.identifier)},registerUriHandler(Y){return Vt.registerUriHandler(Me.identifier,Y)},createQuickPick(){return Bt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Bt.createInputBox(Me.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(Y,ce,De){return fi.onDidChangeActiveColorTheme(Y,ce,De)},registerWebviewViewProvider(Y,ce,De){return yi.registerWebviewViewProvider(Me,Y,ce,De?.webviewOptions)},get activeNotebookEditor(){return(0,j.checkProposedApiEnabled)(Me),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ce,De){return(0,j.checkProposedApiEnabled)(Me),bt.onDidChangeActiveNotebookEditor(Y,ce,De)},get visibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Me),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Me),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ce,De){return(0,j.checkProposedApiEnabled)(Me),jt.onDidChangeNotebookEditorSelection(Y,ce,De)},onDidChangeNotebookEditorVisibleRanges(Y,ce,De){return(0,j.checkProposedApiEnabled)(Me),jt.onDidChangeNotebookEditorVisibleRanges(Y,ce,De)},showNotebookDocument(Y,ce){return(0,j.checkProposedApiEnabled)(Me),bt.showNotebookDocument(Y,ce)},registerExternalUriOpener(Y,ce,De){return(0,j.checkProposedApiEnabled)(Me),Zt.registerExternalUriOpener(Me.identifier,Y,ce,De)},get tabs(){return(0,j.checkProposedApiEnabled)(Me),Ue.tabs},get activeTab(){return(0,j.checkProposedApiEnabled)(Me),Ue.activeTab},get onDidChangeTabs(){return(0,j.checkProposedApiEnabled)(Me),Ue.onDidChangeTabs},get onDidChangeActiveTab(){return(0,j.checkProposedApiEnabled)(Me),Ue.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,j.checkProposedApiEnabled)(Me),o.InlineCompletionController.get(Y)}},pi={get rootPath(){return we.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),xe.getPath()},set rootPath(Y){throw M.readonly()},getWorkspaceFolder(Y){return xe.getWorkspaceFolder(Y)},get workspaceFolders(){return xe.getWorkspaceFolders()},get name(){return xe.name},set name(Y){throw M.readonly()},get workspaceFile(){return xe.workspaceFile},set workspaceFile(Y){throw M.readonly()},updateWorkspaceFolders:(Y,ce,...De)=>xe.updateWorkspaceFolders(Me,Y,ce||0,...De),onDidChangeWorkspaceFolders:function(Y,ce,De){return xe.onDidChangeWorkspace(Y,ce,De)},asRelativePath:(Y,ce)=>xe.getRelativePath(Y,ce),findFiles:(Y,ce,De,st)=>xe.findFiles(K.GlobPattern.from(Y),K.GlobPattern.from(ce),De,Me.identifier,st),findTextInFiles:(Y,ce,De,st)=>{let yt,kt;return typeof ce=="object"?(yt=ce,kt=De):(yt={},kt=ce,st=De),xe.findTextInFiles(Y,yt||{},kt,Me.identifier,st)},saveAll:Y=>xe.saveAll(Y),applyEdit(Y){return Di.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ce,De,st)=>xt.createFileSystemWatcher(K.GlobPattern.from(Y),ce,De,st),get textDocuments(){return Dt.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw M.readonly()},openTextDocument(Y){let ce;const De=Y;if(typeof Y=="string")ce=Promise.resolve(F.URI.file(Y));else if(F.URI.isUri(Y))ce=Promise.resolve(Y);else if(!De||typeof De=="object")ce=Dt.createDocumentData(De);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(st=>Dt.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(Y,ce,De)=>Dt.onDidAddDocument(Y,ce,De),onDidCloseTextDocument:(Y,ce,De)=>Dt.onDidRemoveDocument(Y,ce,De),onDidChangeTextDocument:(Y,ce,De)=>Dt.onDidChangeDocument(Y,ce,De),onDidSaveTextDocument:(Y,ce,De)=>Dt.onDidSaveDocument(Y,ce,De),onWillSaveTextDocument:(Y,ce,De)=>ti.getOnWillSaveTextDocumentEvent(Me)(Y,ce,De),get notebookDocuments(){return bt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ce){let De;if(F.URI.isUri(Y))De=Y,await bt.openNotebookDocument(Y);else if(typeof Y=="string")De=F.URI.revive(await bt.createNotebookDocument({viewType:Y,content:ce}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(De).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ce,De,st){return bt.registerNotebookSerializer(Me,Y,ce,De,Me.enableProposedApi?st:void 0)},registerNotebookContentProvider:(Y,ce,De,st)=>((0,j.checkProposedApiEnabled)(Me),bt.registerNotebookContentProvider(Me,Y,ce,De,Me.enableProposedApi?st:void 0)),onDidChangeConfiguration:(Y,ce,De)=>Kt.onDidChangeConfiguration(Y,ce,De),getConfiguration(Y,ce){return ce=arguments.length===1?void 0:ce,Kt.getConfiguration(Y,ce,Me)},registerTextDocumentContentProvider(Y,ce){return Mt.registerTextDocumentContentProvider(Y,ce)},registerTaskProvider:(Y,ce)=>(we.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(Me,Y,ce)),registerFileSystemProvider(Y,ce,De){return ri.registerFileSystemProvider(Me.identifier,Y,ce,De)},get fs(){return fe.value},registerFileSearchProvider:(Y,ce)=>((0,j.checkProposedApiEnabled)(Me),_t.registerFileSearchProvider(Y,ce)),registerTextSearchProvider:(Y,ce)=>((0,j.checkProposedApiEnabled)(Me),_t.registerTextSearchProvider(Y,ce)),registerRemoteAuthorityResolver:(Y,ce)=>((0,j.checkProposedApiEnabled)(Me),Ie.registerRemoteAuthorityResolver(Y,ce)),registerResourceLabelFormatter:Y=>((0,j.checkProposedApiEnabled)(Me),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ce,De)=>xt.onDidCreateFile(Y,ce,De),onDidDeleteFiles:(Y,ce,De)=>xt.onDidDeleteFile(Y,ce,De),onDidRenameFiles:(Y,ce,De)=>xt.onDidRenameFile(Y,ce,De),onWillCreateFiles:(Y,ce,De)=>xt.getOnWillCreateFileEvent(Me)(Y,ce,De),onWillDeleteFiles:(Y,ce,De)=>xt.getOnWillDeleteFileEvent(Me)(Y,ce,De),onWillRenameFiles:(Y,ce,De)=>xt.getOnWillRenameFileEvent(Me)(Y,ce,De),openTunnel:Y=>((0,j.checkProposedApiEnabled)(Me),z.openTunnel(Me,Y).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,j.checkProposedApiEnabled)(Me),z.getTunnels()},onDidChangeTunnels:(Y,ce,De)=>((0,j.checkProposedApiEnabled)(Me),z.onDidChangeTunnels(Y,ce,De)),registerPortAttributesProvider:(Y,ce)=>((0,j.checkProposedApiEnabled)(Me),z.registerPortsAttributesProvider(Y,ce)),registerTimelineProvider:(Y,ce)=>((0,j.checkProposedApiEnabled)(Me),si.registerTimelineProvider(Y,ce,Me.identifier,lt.converter)),get isTrusted(){return xe.trusted},requestWorkspaceTrust:Y=>((0,j.checkProposedApiEnabled)(Me),xe.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ce,De)=>xe.onDidGrantWorkspaceTrust(Y,ce,De)},Ai={get inputBox(){return we.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Me)},createSourceControl(Y,ce,De){return Jt.createSourceControl(Me,Y,ce,De)}},Ri={createCommentController(Y,ce){return bi.createCommentController(Me,Y,ce)}},Fi={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},onDidStartDebugSession(Y,ce,De){return ht.onDidStartDebugSession(Y,ce,De)},onDidTerminateDebugSession(Y,ce,De){return ht.onDidTerminateDebugSession(Y,ce,De)},onDidChangeActiveDebugSession(Y,ce,De){return ht.onDidChangeActiveDebugSession(Y,ce,De)},onDidReceiveDebugSessionCustomEvent(Y,ce,De){return ht.onDidReceiveDebugSessionCustomEvent(Y,ce,De)},onDidChangeBreakpoints(Y,ce,De){return ht.onDidChangeBreakpoints(Y,ce,De)},registerDebugConfigurationProvider(Y,ce,De){return ht.registerDebugConfigurationProvider(Y,ce,De||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ce){return ht.registerDebugAdapterDescriptorFactory(Me,Y,ce)},registerDebugAdapterTrackerFactory(Y,ce){return ht.registerDebugAdapterTrackerFactory(Y,ce)},startDebugging(Y,ce,De){return!De||typeof De=="object"&&"configuration"in De?ht.startDebugging(Y,ce,{parentSession:De}):ht.startDebugging(Y,ce,De||{})},stopDebugging(Y){return ht.stopDebugging(Y)},addBreakpoints(Y){return ht.addBreakpoints(Y)},removeBreakpoints(Y){return ht.removeBreakpoints(Y)},asDebugSourceUri(Y,ce){return ht.asDebugSourceUri(Y,ce)}},Mi={registerTaskProvider:(Y,ce)=>wt.registerTaskProvider(Me,Y,ce),fetchTasks:Y=>wt.fetchTasks(Y),executeTask:Y=>wt.executeTask(Me,Y),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(Y,ce,De)=>wt.onDidStartTask(Y,ce,De),onDidEndTask:(Y,ce,De)=>wt.onDidEndTask(Y,ce,De),onDidStartTaskProcess:(Y,ce,De)=>wt.onDidStartTaskProcess(Y,ce,De),onDidEndTaskProcess:(Y,ce,De)=>wt.onDidEndTaskProcess(Y,ce,De)},Li={createNotebookController(Y,ce,De,st,yt){return ii.createNotebookController(Me,Y,ce,De,st,Me.enableProposedApi?yt:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ce)=>bt.registerNotebookCellStatusBarItemProvider(Me,Y,ce),get onDidSaveNotebookDocument(){return(0,j.checkProposedApiEnabled)(Me),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,j.checkProposedApiEnabled)(Me),jt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return ni.createRendererMessaging(Me,Y)},onDidChangeNotebookDocumentMetadata(Y,ce,De){return(0,j.checkProposedApiEnabled)(Me),Qt.onDidChangeNotebookDocumentMetadata(Y,ce,De)},onDidChangeNotebookCells(Y,ce,De){return(0,j.checkProposedApiEnabled)(Me),bt.onDidChangeNotebookCells(Y,ce,De)},onDidChangeNotebookCellExecutionState(Y,ce,De){return(0,j.checkProposedApiEnabled)(Me),bt.onDidChangeNotebookCellExecutionState(Y,ce,De)},onDidChangeCellOutputs(Y,ce,De){return(0,j.checkProposedApiEnabled)(Me),bt.onDidChangeCellOutputs(Y,ce,De)},onDidChangeCellMetadata(Y,ce,De){return(0,j.checkProposedApiEnabled)(Me),bt.onDidChangeCellMetadata(Y,ce,De)},createConcatTextDocument(Y,ce){return(0,j.checkProposedApiEnabled)(Me),new He.ExtHostNotebookConcatDocument(bt,Dt,Y,ce)}};return{version:ue.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:ui,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:Ti,workspace:pi,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:T.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:St.TextSearchCompleteMessageType,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(be[224],Ee([0,1,57,96,31,95,32,39,50,40,99,100,101,73,65,70,97,72,37,69,87,71]),function(se,e,h,M,E,A,F,C,S,T,t,y,n,f,s,c,p,P,D,l,u,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService),(0,h.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,h.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,h.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,h.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,h.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,h.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,h.registerSingleton)(D.IExtHostFileSystemInfo,D.ExtHostFileSystemInfo),(0,h.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,h.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,h.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,h.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,h.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,h.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,h.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,h.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,h.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,h.registerSingleton)(u.IExtHostTelemetry,u.ExtHostTelemetry),(0,h.registerSingleton)(_.IExtHostEditorTabs,_.ExtHostEditorTabs)}),define(be[225],Ee([0,1,223,33,219,7,12,5,11]),function(se,e,h,M,E,A,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var T;(function(s){const c=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(P,...D)=>{D.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const l=D.slice(0,-1).join(","),u=D.pop().toString();return`(function anonymous(${l}) {${u}
})`}});function p(...P){return c?self.eval(c.createScript("",...P)):new Function(...P)}s.create=p})(T||(T={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(c,p){for(let P of this._alternatives){let D=P(c);if(D){c=D;break}}if(this._factories.has(c))return this._factories.get(c).load(c,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class y extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const c=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);f(c,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(h.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(c){return c.browser}async _loadCommonJSModule(c,p,P){p=p.with({path:n(p.path,".js")}),c&&performance.mark(`code/extHost/willFetchExtensionCode/${c.value}`);const D=await fetch(S.FileAccess.asBrowserUri(p).toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c.value}`),D.status!==200)throw new Error(D.statusText);const l=await D.text(),u=`${p.toString(!0)}#vscode-extension`,_=`${l}
//# sourceURL=${u}`;let i;try{i=T.create(y._ttpExtensionScripts?.createScript("module")??"module",y._ttpExtensionScripts?.createScript("exports")??"exports",y._ttpExtensionScripts?.createScript("require")??"require",y._ttpExtensionScripts?.createScript(_)??_)}catch(v){throw console.error(c?`Loading code for extension ${c.value} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${p.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}const g={},a={exports:g},r=v=>{const o=this._fakeModules.getModule(v,p);if(o===void 0)throw new Error(`Cannot load module '${v}'`);return o};try{return P.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c.value}`),i(a,g,r),a.exports!==g?a.exports:g}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c.value}`),P.codeLoadingStop()}}async $setRemoteEnvironment(c){}async _waitForDebuggerAttachment(c=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+c;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=y,y._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:s=>s});function n(s,c){return s.endsWith(c)?s:s+c}function f(s,c){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(l,u){const _=console[l];console[l]=function(){s.$logExtensionHostMessage({type:"__$console",severity:u,arguments:D(arguments)}),c&&_.apply(console,arguments)}}const P=1e5;function D(l){const u=[],_=[];if(l.length)for(let i=0;i<l.length;i++){if(typeof l[i]=="undefined")l[i]="undefined";else if(l[i]instanceof Error){const g=l[i];g.stack?l[i]=g.stack:l[i]=g.toString()}_.push(l[i])}try{const i=JSON.stringify(_,function(g,a){if(a&&typeof a=="object"){if(u.indexOf(a)!==-1)return"[Circular]";u.push(a)}return a});return i.length>P?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[226],Ee([0,1,57,15,33,74,225,212]),function(se,e,h,M,E,A,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(E.IExtHostExtensionService,F.ExtHostExtensionService),(0,h.registerSingleton)(M.ILogService,C.ExtHostLogService),(0,h.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(be[236],Ee([0,1,22,3,178,220,214,17,75,11,2,224,226]),function(se,e,h,M,E,A,F,C,S,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const f=fetch.bind(self);if(self.fetch=function(l,u){return l instanceof Request||/^file:/i.test(String(l))&&(l=T.FileAccess.asBrowserUri(t.URI.parse(String(l))).toString(!0)),f(l,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,u,_,i,g){return/^file:/i.test(u.toString())&&(u=T.FileAccess.asBrowserUri(t.URI.parse(u.toString())).toString(!0)),super.open(l,u,_??!0,i,g)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const l=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:_=>_}),u=self.Worker;Worker=function(_,i){/^file:/i.test(_.toString())&&(_=T.FileAccess.asBrowserUri(t.URI.parse(_.toString())).toString(!0));const a=`(${function(d){function w(R){return typeof R=="string"||R instanceof URL?String(R).replace(/^file:\/\//i,"vscode-file://vscode-app"):R}const I=fetch.bind(self);self.fetch=function(R,L){return R instanceof Request?I(R,L):I(w(R),L)},self.XMLHttpRequest=class extends XMLHttpRequest{open(R,L,b,B,$){return super.open(R,w(L),b??!0,B,$)}};const m=importScripts.bind(self);self.importScripts=(...R)=>{m(...R.map(w))};const k=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:R=>R}):void 0;m(k?k.createScriptURL(d):d)}.toString()}('${_}'))`;i=i||{},i.name=i.name||C.basename(_.toString());const r=new Blob([a],{type:"application/javascript"}),v=URL.createObjectURL(r);return new u(l?l.createScriptURL(v):v,i)}}else self.Worker=class extends F.NestedWorker{constructor(l,u){super(n,l,{name:C.basename(l.toString()),...u})}};const s=new class{exit(l){y()}async exists(l){return!0}async realpath(l){return l}};class c{constructor(){const u=new MessageChannel,_=new M.Emitter;let i=!1;n(u.port2,[u.port2]),u.port1.onmessage=g=>{const{data:a}=g;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const r=h.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,E.isMessageOfType)(r,2)){i=!0,P("received terminate message from renderer");return}_.fire(r)},this.protocol={onMessage:_.event,send:g=>{if(!i){const a=g.buffer.buffer.slice(g.buffer.byteOffset,g.buffer.byteOffset+g.buffer.byteLength);u.port1.postMessage(a,[a])}}}}}function p(l){return new Promise(u=>{const _=l.onMessage(i=>{_.dispose();const g=JSON.parse(i.toString());l.send((0,E.createMessageOfType)(0)),u({protocol:l,initData:g})});l.send((0,E.createMessageOfType)(1))})}let P=l=>y();function D(){const l=new c;S.mark("code/extHost/willConnectToRenderer"),p(l.protocol).then(u=>{S.mark("code/extHost/didWaitForInitData");const _=new A.ExtensionHostMain(u.protocol,u.initData,s,null);P=i=>_.terminate(i)})}e.create=D})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/34eeebdd66033633ac22efd5fab928ae37916168/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
